<?php
class TorrServer
{
	static $torrServIp = null;
	static $torrServItems = null;
	public static function getIp (){
        if (null === self::$torrServIp){
			$torrservIp = (HD::getItemStr('torrservIp', 1) != '') ? HD::getItemStr('torrservIp', 1) : false;
			if (($torrservIp == '')&&(self::getInstallTorrServer () == true)){
				$torrservIp = 'http://127.0.0.1:8090';
				HD::saveItemStr('torrservIp', $torrservIp, true);
				HD::saveItemStr('duneTorrServIp', 1, true);
			}
            self::$torrServIp = $torrservIp;
        }
        return self::$torrServIp;
    }
	public static function setTorrServIp($inputStr){
		$path_parts = parse_url($inputStr);
		if (isset($path_parts['host']))
			$torrservIp = $path_parts['host'];
		else if (isset($path_parts['path']))
			$torrservIp = $path_parts['path'];
		$ip_address = HD::get_ip_address();
		if (($torrservIp == '127.0.0.1')||($ip_address == $torrservIp)){
			if (self::getInstallTorrServer () != true)
				return array(
					'caption' => 'Error!',
					'descr' => "IP адрес TorrServer: $torrservIp указан не верно. Локальный TorrServer не найден. Необходима установка TorrServer на это устройство или указывайте IP адрес другого устройства в сети с установленным TorrServ."
				);
			$torrservIp = '127.0.0.1';
		}else if ($torrservIp == ''){
			if (self::getIp() != ''){
				if (HD::saveItemStr('torrservIp', $torrservIp, true) == true){
					self::$torrServIp = $torrservIp;
					HD::saveItemStr('duneTorrServIp', 0, true);
					return array(
						'caption' => 'Сохранено',
						'descr' =>  "Удален IP адрес TorrServer: " . self::getIp()
					);
				}else
					return array(
					'caption' => 'Error!',
					'descr' => "Сохранение не удалось"
					);
			}else
				return array(
					'caption' => 'Error!',
					'descr' => "IP адрес TorrServer не указан. Укажите IP адрес устройства с установленным TorrServ."
				);
		}
		if (isset($path_parts['port']))
			$torrservIp .= ':' . $path_parts['port'];
		else
			$torrservIp .= ':8090';
		if (isset($path_parts['scheme']))
			$torrservIp = $path_parts['scheme'] .  '://' . $torrservIp;
		else
			$torrservIp = 'http://' . $torrservIp;
		if (HD::saveItemStr('torrservIp', $torrservIp, true) == true){

			$torrservHistory = HD::getItemsArr('torrservHistory');
			$torrservHistory = array_reverse($torrservHistory);
			$torrservHistory[$torrservIp] = $torrservIp;
			$torrservHistory = array_reverse($torrservHistory);
			$torrservHistory = array_slice($torrservHistory, 0, 10);
			HD::saveItemsArr('torrservHistory', $torrservHistory);
			if (isset($path_parts['host']))
				$host = $path_parts['host'];
			else if (isset($path_parts['path']))
				$host = $path_parts['path'];
			$duneTorrServIp = 0;
			if (preg_match("/(\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3})/", $host, $m))
				if (HD::isDomainAvailible("http://$host/cgi-bin/do?cmd=status") == true)
					$duneTorrServIp = 1;
			HD::saveItemStr('duneTorrServIp', $duneTorrServIp, true);
			self::$torrServIp = $torrservIp;
			return array(
				'caption' => 'Сохранено',
				'descr' => "IP TorrServ: $torrservIp",
			);
		}else
			return array(
				'caption' => 'Error!',
				'descr' => "IP адрес TorrServer: $torrservIp cохранить не удалось",
			);
	}
	public static function getInfoRend($hash, $actions, $post_action=null){
		$comps = array();
		$stat = self::torrserverActionGet($hash);
		$y2 = 350;
		if (($stat->title != '')&&(isset($stat->name))&&($stat->title != $stat->name))
			$y2 = $y2 + 50;
		ActionFactory::add_osd_image($comps, DuneSystem::$properties['install_dir_path'] . '/icons/centr.png', 0, 0, 1920, $y2);
		$y = 50;
		ActionFactory::add_osd_text($comps, 'Name:', 100, $y, PLUGIN_FONT_NORMAL, 19, 0);
		if ($stat->title != ''){
			ActionFactory::add_osd_text($comps, $stat->title, 240, $y, PLUGIN_FONT_NORMAL, 15, 0);
			if ((isset($stat->name))&&($stat->title != $stat->name)){
				$y = $y + 50;
				ActionFactory::add_osd_text($comps, $stat->name, 240, $y, PLUGIN_FONT_NORMAL, 15, 0);
			}
		}else
			ActionFactory::add_osd_text($comps, $stat->name, 240, $y, PLUGIN_FONT_NORMAL, 15, 0);
		
		ActionFactory::add_osd_text($comps, 'Download Speed:', 100, $y + 50, PLUGIN_FONT_NORMAL, 19, 0);
		if (isset($stat->download_speed))
			ActionFactory::add_osd_text($comps, HD::get_filesize_str(intval($stat->download_speed), 1), 620, $y + 50, PLUGIN_FONT_NORMAL, 15, 0);
				
		ActionFactory::add_osd_text($comps, 'Upload Speed:', 100, $y + 100, PLUGIN_FONT_NORMAL, 19, 0);
		if (isset($stat->upload_speed))
			ActionFactory::add_osd_text($comps, HD::get_filesize_str(intval($stat->upload_speed), 1), 620, $y + 100, PLUGIN_FONT_NORMAL, 15, 0);
		
		if (isset($stat->active_peers)){
			ActionFactory::add_osd_text($comps, 'Active Peers/Total Peers:', 100, $y + 150, PLUGIN_FONT_NORMAL, 19, 0);
			ActionFactory::add_osd_text($comps, $stat->active_peers .'/'. $stat->total_peers, 620, $y + 150, PLUGIN_FONT_NORMAL, 15, 0);
		}
				
		ActionFactory::add_osd_text($comps, 'Total Size/Loaded Size:', 100, $y + 200, PLUGIN_FONT_NORMAL, 19, 0);
		if (isset($stat->loaded_size))
			ActionFactory::add_osd_text($comps, HD::readableBytes($stat->torrent_size) . '/' . HD::readableBytes($stat->loaded_size)  , 620, $y + 200, PLUGIN_FONT_NORMAL, 15, 0);
				
		return ActionFactory::update_osd($comps, ActionFactory::change_behaviour($actions, 1000, $post_action));
	}
	public static function getScreenActionMapArr ($parent_media_url){
		$actionsArr[0]['create_action'] = 'classAction';
		$actionsArr[0]['params'] = array ('indiClass' => 'TorrServer', 'action' => 'torrserverActionRem');
		$actionsArr[0]['caption'] = 'Удалить из TorrServe';
		$actionsArr[0]['key'] = GUI_EVENT_KEY_C_YELLOW;
		
		return $actionsArr;
	}
	public static function getPopUpMenuItems ($selected_media_url, $parent_media_url){
		if (!is_object($parent_media_url))
			$parent_media_url = MediaURL::decode($parent_media_url);
		if (isset($selected_media_url->movie_id)){
			$menu_items[] = array(
				'caption' => 'Очистить кеш торрента (Drop)',
				'params' => array ('indiClass' => 'TorrServer', 'action' => 'torrserverActionDrop'),
				'icon_url' => 'plugin_file://icons/s_01.png'
			);
			$menu_items[] = 'is_separator';
			$menu_items[] = array(
				'caption' => 'Удалить из TorrServe',
				'params' => array ('indiClass' => 'TorrServer', 'action' => 'torrserverActionRem'),
				'icon_url' => 'plugin_file://icons/s_0.png'
			);
			$torrServInf = HD::getItemsArr('TorrServerInf');
			if (isset($torrServInf[$selected_media_url->movie_id]))
				$menu_items[] = array(
					'caption' => 'Удалить обложку и описание',
					'params' => array ('indiClass' => 'SmartConfig', 'action' => 'addItemInfo', 'newKpId' => 'del'),
					'icon_url' => 'plugin_file://icons/s_infod.png'
				);
			else
				$menu_items[] = array(
					'caption' => 'Задать обложку и описание',
					'params' => array ('indiClass' => 'SmartConfig', 'action' => 'addItemInfo'),
					'icon_url' => 'plugin_file://icons/s_info.png'
				);
			$menu_items[] = 'is_separator';
		}
		if (isset($selected_media_url->playback_url)){
			$menu_items[] = array(
				'caption' => 'Большие файлы в начало списка',
				'params' => array ('action' => 'gbSortFolders'),
				'icon_url' => 'plugin_file://icons/s_gbSortFolders.png'
			);
			if (HD::is_android() == true){
				$menu_items[] = array(
					'caption' => 'Перейти в приложение TorrServer',
					'params' => array ('indiClass' => 'TorrServer', 'action' => 'openTorrServerApp'),
					'icon_url' => 'plugin_file://icons/s_android.png'
				);
				$menu_items[] = 'is_separator';
			}
		}
		
		if ($parent_media_url->screen_id != 'vod_torrserver')
			$menu_items[] = array(
				'caption' => 'Перейти в TorrServer',
				'params' => array ('indiClass' => 'TorrServer', 'action' => 'screenTorrServer'),
				'icon_url' => 'plugin_file://icons/s_torrserver.png'
			);
		if (self::getSlaveTorrServer () == true){
			$menu_items[] = array(
				'caption' => 'Перезапуск сервера TorrServe',
				'params' => array ('indiClass' => 'TorrServer', 'action' => 'restart'),
				'icon_url' => 'plugin_file://icons/s_restart.png'
			);
		}
		$menu_items[] = array(
			'caption' => 'Настройки TorrServer',
			'params' =>  'classSetup',
			'icon_url' => 'plugin_file://icons/s_torrserver.png'
		);
		return $menu_items;
	}
	public static function torrserverAddTorrent($path, $torrServAction, $movie){
		$tmp = explode ('.', HD::get_ip_address());
		$dontSave = false;
		if ($torrServAction == 1)
			$dontSave = true;
		if ((!preg_match("|".$tmp[0]."|", self::getIp()))&&
			(!preg_match("|magnet:\?xt=|",$path))&&
			(!preg_match("|127\.0\.0\.1|", self::getIp()))
		)
			$hash = self::torrserverActionUpload('/tmp/www/temp.torrent', $dontSave);
		else{
			
			$infoArr["title"] = $movie->name;
            $port = HD::http_local_port();
			$infoArr["poster_path"] = str_replace("http://127.0.0.1:$port/cgi-bin/plugins/Bazinga3/do?img=", '', $movie->poster_url);
			$hash = self::torrserverActionAdd($path, $infoArr, $dontSave);
		}
		return $hash;
	}
	public function addTorrServerAction($defs, $user_input){
		hd_restore_warnings();
		if (isset($user_input->delTorrServerTorrent)){
			if (!isset($user_input->hash))
				return ActionFactory::show_title_dialog('Err!');
			TorrServer::torrserverActionRem ($user_input->hash);
			return ActionFactory::show_title_dialog('Удалено');
		}
		if (isset($user_input->goTorrServerScreen)){
			if (isset($user_input->selected_media_url)){
				$selected_media_url = MediaURL::decode($user_input->selected_media_url);
				$post_action = ActionFactory::invalidate_folders(array(VodTorrServerScreen::get_media_url_str('TorrServer')));
				if (defined('PLUGIN_REPLACE_PATH_ACTION_ID') === true){
					TorrServer::actionGetTorrentList();
					$action = ActionFactory::replace_path($selected_media_url->windowCounter - 1, null, $post_action);
				}else{
					do {
						$action = ActionFactory::close_and_run($post_action);
						$media_url->windowCounter--;
					} while (1 != $media_url->windowCounter);
				}
			}else{
				do {
					$action = ActionFactory::close_and_run($post_action);
					$media_url->windowCounter--;
				} while (1 != $media_url->windowCounter);
			}
			return $action;
		}
		$params['hash'] = $user_input->hash;
		$params['counter2'] = 1;
		if (isset($user_input->counter2))
			$params['counter2'] = $user_input->counter2 + 1;	
		ControlFactory::add_label($defs, '', "Прошло : " . HD::sec_format_duration($params['counter2']));
		ControlFactory::add_vgap($defs, (-20));
		ControlFactory::add_smart_label($defs, "", '<text color="10" size="normal">Name: </text>');
		ControlFactory::add_vgap($defs, (-20));
		$jsd = self::torrserverActionGet($user_input->hash);
		if ($jsd == true){
			if ($jsd->title != '')
				$caption = $jsd->title;
			else
				$caption = $jsd->name;
			$caption = implode( ' ', str_split($caption, 23));
			ControlFactory::add_multiline_label($defs, '', $caption, 5);
			if (isset($user_input->counter)){
				$params['counter'] = $user_input->counter - 1;
				if ($user_input->counter == 0)
					$params['goTorrServerScreen'] = 1;
			}else
				$params['counter'] = 5;
		}
		$a_params['delTorrServerTorrent'] = 1;
		$a_params['hash'] = $user_input->hash;
		$a_action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $a_params);
		ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,'apply_subscription', 'Удалить', 300, $a_action);
		ControlFactory::add_vgap($defs, (-10));
		ControlFactory::add_smart_label($defs, "", '<text color="10" size="tiny">* удаляет из базы Torrserv, кнопка Return оставляет в Torrserv</text>');
		if (isset($user_input->counter)){
			ControlFactory::add_vgap($defs, (-30));
			ControlFactory::add_smart_label($defs,"", '<text color="18" size="tiny">Переход в TorrServer через: </text><text color="15" size="tiny">'.$user_input->counter.' сек. </text>');
			ControlFactory::add_vgap($defs, (-40));
			ControlFactory::add_smart_label($defs,"", '<text color="18" size="tiny">Для добавления других .torrent файлов кнопка Return пульта ДУ.</text>');
		}
		$attrs['timer'] = ActionFactory::timer(1000);
		$action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $params);
		$attrs['actions'] = array(GUI_EVENT_TIMER => ActionFactory::close_dialog_and_run($action));
		return  ActionFactory::show_dialog('Добавление', $defs, true, 1000, $attrs);
	}
	
	public function classAction ($defs, $user_input, $select_url = null){
		hd_restore_warnings();
		$caption = 'Error!';
		$msg = 'classAction: action';
		$post_action = null;
		$selected_media_url = (object)array();
		if (isset($user_input->selected_media_url))
			$selected_media_url = MediaURL::decode($user_input->selected_media_url);
		$parent_media_url = MediaURL::decode($user_input->parent_media_url);
		if ($user_input->action == 'screenTorrServer'){
			TorrServer::actionGetTorrentList();
			return ActionFactory::open_folder(VodTorrServerScreen::get_media_url_str($parent_media_url->class_name), $parent_media_url->class_name);
		}
		if ($user_input->action == 'openTorrServerApp'){
			$package = self::getTorrServerPackageName();
			if ($package != false){
				exec ("am start " . $package['name'] . "/" . $package['activity'] . " 2>&1");
				$caption = 'Выполнено';
				$msg = '';
			}else
				$msg = 'Андроид приложение TorrServer не найдено';
		}
		if ($user_input->action == 'restart'){
			if (self::getRestartSlaveTorrServer () != true)
				$msg = 'Перезапустить TorrServer не удалось';
			else{
				$caption = 'Выполнено';
				$msg = 'Перезапуск сервера TorrServer';
			}
		}
		if ($user_input->action == 'selectAndroidAction'){
			if (isset($selected_media_url->playback_url)){
				if (isset($user_input->playAll)){
					$jsd = self::torrserverActionGet($selected_media_url->movie_id);
					$arg = self::getIp() . $jsd->Playlist;
				}else
					$arg = $selected_media_url->playback_url;
				return HD::get_android_action($arg);
			}
		}
		if ($user_input->action == 'torrserverActionDrop'){
			if (isset($selected_media_url->movie_id)){
				if (isset($selected_media_url->file_info->torrentId))
					$selected_media_url_movie_id = $selected_media_url->file_info->torrentId;
				else if (isset($selected_media_url->torrentId))
					$selected_media_url_movie_id = $selected_media_url->torrentId;
				else
					$selected_media_url_movie_id = $selected_media_url->movie_id;
				self::torrserverActionDrop($selected_media_url_movie_id);
				self::actionGetTorrentList();
				$action = ActionFactory::invalidate_folders(array($user_input->parent_media_url, VodTorrServerScreen::get_media_url_str($parent_media_url->class_name)));
				return ActionFactory::show_title_dialog('Кеш очищен', $action);
			}else
				return false;
		}
		if ($user_input->action == 'torrserverActionRem'){
			if (isset($selected_media_url->movie_id)){
				if (isset($selected_media_url->file_info->torrentId))
					self::torrserverActionRem($selected_media_url->file_info->torrentId);
				else if (isset($selected_media_url->torrentId))
					self::torrserverActionRem($selected_media_url->torrentId);
				else
					self::torrserverActionRem($selected_media_url->movie_id);
				$torrServInf = HD::getItemsArr($selected_media_url->class_name . 'Inf');
				if (isset($torrServInf[$selected_media_url->movie_id])){
					unset($torrServInf[$selected_media_url->movie_id]);
					HD::saveItemsArr($selected_media_url->class_name . 'Inf', $torrServInf);
				}
				self::actionGetTorrentList();
				$action = ActionFactory::invalidate_folders(array($user_input->parent_media_url, VodTorrServerScreen::get_media_url_str($parent_media_url->class_name)));
				if ($parent_media_url->screen_id == "vod_series")
					return ActionFactory::replace_path(1, null, $action);
				return $action;
			}else
				return false;
		}
		if ($user_input->action == 'getTorrserverHashInfo'){
			$params['action'] = $user_input->action;
			$params['indiClass'] = 'TorrServer';
			if (isset($user_input->delTorrServerTorrent)){
				TorrServer::torrserverActionRem ($user_input->delTorrServerTorrent);
				return ActionFactory::show_title_dialog('Удалено');
			}
			if (isset($user_input->goToScreen)){
				if (!isset($selected_media_url->movie_id))
					return ActionFactory::invalidate_folders(array($user_input->parent_media_url));
				$mArr['movie_id'] = $selected_media_url->movie_id;
				$mArr['torrentId'] = $user_input->hash;
				$mArr['torrentClassName'] = 'TorrServer';
				$mArr['torrentSourseClassName'] = $selected_media_url->class_name;
				$mArr['poster_url'] = $selected_media_url->poster_url;
				$mArr['class_name'] = $selected_media_url->class_name;
				$mArr['torrent_id'] = $selected_media_url->torrent_id;
				$mArr['tType'] = $selected_media_url->tType;
				if (isset($selected_media_url->detailed_info))
					$mArr['detailed_info'] = $selected_media_url->detailed_info;
				if (isset($selected_media_url->description))
					$mArr['description'] = $selected_media_url->description;
				$mUrl = VodSeriesListScreen::get_media_url_str("TorrServer",$mArr);
				return ActionFactory::open_folder($mUrl, $selected_media_url->caption);
			}
			$params['hash'] = $user_input->hash;
			$params['counter'] = 1;
			if (isset($user_input->counter))
				$params['counter'] = $user_input->counter + 1;	
			ControlFactory::add_label($defs, '', "Прошло : " . HD::sec_format_duration($params['counter']));
			
			
			$jsd = TorrServer::torrserverActionGet($user_input->hash);
			if (isset($jsd->file_stats)){
				if ($jsd->title != '')
					$caption = $jsd->title;
				else
					$caption = $jsd->name;
				if (!preg_match('| |', $caption))
					$caption = implode( ' ', HD::mb_str_split($caption, 42));
				ControlFactory::add_vgap($defs, (-20));
				ControlFactory::add_smart_label($defs, "", '<text color="10" size="normal">Name: </text>');
				ControlFactory::add_vgap($defs, (-20));
				ControlFactory::add_multiline_label($defs, '', $caption, 5);
				if (isset($user_input->countdown)){
					$params['countdown'] = $user_input->countdown - 1;
					if ($user_input->countdown == 0)
						$params['goToScreen'] = 1;
				}else
					$params['countdown'] = 3;
			}
			ControlFactory::add_close_dialog_and_apply_button($defs, $this, array('action' => $user_input->action,	'indiClass' => 'TorrServer', 'delTorrServerTorrent' => $user_input->hash), $user_input->control_id, 'Удалить', 300);
			ControlFactory::add_vgap($defs, (-10));
			ControlFactory::add_smart_label($defs, "", '<text color="10" size="tiny">* удаляет из базы Torrserv, кнопка Return оставляет в Torrserv</text>');
			if (isset($user_input->countdown)){
				ControlFactory::add_vgap($defs, (-30));
				ControlFactory::add_smart_label($defs,"", '<text color="18" size="tiny">Переход в TorrServer через: </text><text color="15" size="tiny">'.$user_input->countdown.' сек. </text>');
				ControlFactory::add_vgap($defs, (-40));
				ControlFactory::add_smart_label($defs,"", '<text color="18" size="tiny">Для добавления других .torrent файлов кнопка Return пульта ДУ.</text>');
			}
			$attrs['timer'] = ActionFactory::timer(1000);
			$action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $params);
			$attrs['actions'] = array(GUI_EVENT_TIMER => ActionFactory::close_dialog_and_run($action));
			return  ActionFactory::show_dialog('Добавление в TorrServer', $defs, true, 1000, $attrs);
		}
		return ActionFactory::show_title_dialog($caption, $post_action, $msg, 0);
	}
	public function setup($defs, $user_input){
		hd_restore_warnings();
		$attrs['initial_sel_ndx'] = isset($user_input->initial_sel_ndx) ? $user_input->initial_sel_ndx : -1;
		$torrservIp = self::getIp();
		$cmd = self::getStatusTorrServer();
		$slaveTorrServer = self::getSlaveTorrServer ();
		$addTorrServInf = (HD::getItemStr('addTorrServInf', true) !='') ? HD::getItemStr('addTorrServInf', true) : 0;
		$actionTorrServ = (HD::getItemsArr('actionTorrServ', true) != array()) ? HD::getItemsArr('actionTorrServ', true) : array('play' => 0, 'enter' => 0);
		$add_params = null;
		$showOps= array('Нет','Да');
		$width = 1050;
		if ((isset($user_input->addTorrServInf))&&($user_input->selected_control_id == 'addTorrServInf')){
			HD::saveItemStr('addTorrServInf', $user_input->addTorrServInf, true);
			return null;
		}
		if ((isset($user_input->preloadTorrServ))&&($user_input->selected_control_id == 'preloadTorrServ')){
			HD::saveItemStr('preloadTorrServ', $user_input->preloadTorrServ, true);
			return null;
		}
		if ((isset($user_input->actionPlayTorrServ))&&($user_input->selected_control_id == 'actionPlayTorrServ')){
			$actionTorrServ['play'] = $user_input->actionPlayTorrServ;
			HD::saveItemsArr('actionTorrServ', $actionTorrServ, true);
			return null;
		}
		if ((isset($user_input->actionEnterTorrServ))&&($user_input->selected_control_id == 'actionEnterTorrServ')){
			$actionTorrServ['enter'] = $user_input->actionEnterTorrServ;
			HD::saveItemsArr('actionTorrServ', $actionTorrServ, true);
			return null;
		}
		if ((isset($user_input->action))&&(
		($user_input->action == 'stop')||
		($user_input->action == 'start')||
		($user_input->action == 'restart')||
		($user_input->action == 'soft_restart')
		)){
			if (isset($user_input->initial_sel_ndx))
				$add_params['initial_sel_ndx']= $user_input->initial_sel_ndx;
			$msg = ''; $caption = 'Выполнено';
			if ($user_input->action == 'stop')
				self::torrserverActionStop();
			if ($user_input->action == 'restart'){
				if (self::getRestartSlaveTorrServer () != true){
					$msg = ''; $caption = 'Перезапустить TorrServe не удалось';
				}
			}
			if ($user_input->action == 'start'){
				if (self::getStartSlaveTorrServer() != true){
					$msg = ''; $caption = 'Запустить TorrServe не удалось';
				}
			}
			$action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $add_params);
			return ActionFactory::show_title_dialog($caption,$action, $msg,0);
		}
		
		if ((isset($user_input->action))&&($user_input->action == 'saveSetupTorrserve')){
			$arr = json_decode ($user_input->jsd, true);
			$boolArr = array_flip (array('PreloadBuffer', 'RetrackersMode', 'EnableIPv6', 'ForceEncrypt', 'DisableTCP', 'DisableUTP', 'DisableUPNP', 'DisableDHT', 'DisablePEX', 'DisableUpload'));
			if ($user_input->selected_control_id == 'CacheSize')
				$user_input->CacheSize = $user_input->CacheSize * 1024 * 1024;
			if (isset($boolArr[$user_input->selected_control_id]))
				$user_input->{$user_input->selected_control_id} = (bool)$user_input->{$user_input->selected_control_id};
			if (is_numeric($user_input->{$user_input->selected_control_id}))
				$arr[$user_input->selected_control_id] =  intval($user_input->{$user_input->selected_control_id});
			else
				$arr[$user_input->selected_control_id] = $user_input->{$user_input->selected_control_id};
			if (self::torrserverActionSettingsWrite($arr) != true)
				return ActionFactory::show_title_dialog('Err!', $action, 'Сохранение не удалось', 0);
			$add_params['action'] = 'setup_torrserve';
			$add_params['initial_sel_ndx'] = $user_input->initial_sel_ndx;
			$action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $add_params);
			return ActionFactory::close_dialog_and_run($action);
		}
		if ((isset($user_input->action))&&($user_input->action == 'setup_torrserve')){
			$defs = array();
			if ($cmd == false){
				$action = UserInputHandlerRegistry::create_action($this, $user_input->control_id);
				return ActionFactory::show_title_dialog('Err!', $action, "Cервер TorrServ ($torrservIp) не запущен", $width);
			}
			$jsd = self::torrserverActionSettingsRead();
			$add_params['control_id']= $user_input->control_id;
			$add_params['action'] = 'saveSetupTorrserve';
			$add_params['jsd'] = json_encode($jsd);
			
			$add_params['initial_sel_ndx'] = 0;
			ControlFactory::add_text_field($defs,
				$this, $add_params,
				'CacheSize', 'Размер кэша',
			HD::readableBytes($jsd->CacheSize), 1, 0, 0, 0, $width - 550, true, true);
			
			ControlFactory::add_vgap($defs, -5);
			$add_params['initial_sel_ndx'] = 1;
			ControlFactory::add_text_field($defs, $this, $add_params,
				'ReaderReadAHead', 'Опережающий кэш в %',
			$jsd->ReaderReadAHead, 1, 0, 0, 0, $width - 550, true, true);
			
			ControlFactory::add_vgap($defs, -5);
			$add_params['initial_sel_ndx'] = 2;
			ControlFactory::add_text_field($defs, $this, $add_params,
			'PreloadCache', 'Буфер предзагрузки в %',
			$jsd->PreloadCache, 1, 0, 0, 0, $width - 550, true, true);
				
			ControlFactory::add_vgap($defs, -5);
			$add_params['initial_sel_ndx'] = 3;
			ControlFactory::add_combobox($defs, $this, $add_params,
			'RetrackersMode', 'Retracker mode',
			intval($jsd->RetrackersMode), array("Don't add retrackers","Add retrackers","Remove retrackers","Replace retrackers"), $width - 550, true, true);
			
			ControlFactory::add_vgap($defs, -5);
			$add_params['initial_sel_ndx'] = 4;
			ControlFactory::add_text_field($defs, $this, $add_params,
				'TorrentDisconnectTimeout', 'Torrent disconnect timeout',
			$jsd->TorrentDisconnectTimeout, 1, 0, 0, 0, $width - 550, true, true);
			
			ControlFactory::add_vgap($defs, -5);
			$add_params['initial_sel_ndx'] = 5;
			ControlFactory::add_combobox($defs, $this, $add_params,
			'EnableIPv6', 'Enable IPv6',
			intval($jsd->EnableIPv6), $showOps, $width - 550, true, true);
			
			ControlFactory::add_vgap($defs, -5);
			$add_params['initial_sel_ndx'] = 6;
			ControlFactory::add_combobox($defs, $this, $add_params,
			'ForceEncrypt', 'Force encrypt',
			intval($jsd->ForceEncrypt), $showOps, $width - 550, true, true);
			
			ControlFactory::add_vgap($defs, -5);
			$add_params['initial_sel_ndx'] = 7;
			ControlFactory::add_combobox($defs, $this, $add_params,
			'DisableTCP', 'Disable TCP',
			intval($jsd->DisableTCP), $showOps, $width - 550, true, true);
			
			ControlFactory::add_vgap($defs, -5);
			$add_params['initial_sel_ndx'] = 8;
			ControlFactory::add_combobox($defs, $this, $add_params,
			'DisableUTP', 'Disable UTP',
			intval($jsd->DisableUTP), $showOps, $width - 550, true, true);
			
			ControlFactory::add_vgap($defs, -5);
			$add_params['initial_sel_ndx'] = 9;
			ControlFactory::add_combobox($defs, $this, $add_params,
			'DisableUPNP', 'Disable UPNP',
			intval($jsd->DisableUPNP), $showOps, $width - 550, true, true);
			
			ControlFactory::add_vgap($defs, -5);
			$add_params['initial_sel_ndx'] = 10;
			ControlFactory::add_combobox($defs, $this, $add_params,
			'DisableDHT', 'Disable DHT',
			intval($jsd->DisableDHT), $showOps, $width - 550, true, true);
			
			ControlFactory::add_vgap($defs, -5);
			$add_params['initial_sel_ndx'] = 11;
			ControlFactory::add_combobox($defs, $this, $add_params,
			'DisablePEX', 'Disable PEX',
			intval($jsd->DisablePEX), $showOps, $width - 550, true, true);
			
			ControlFactory::add_vgap($defs, -5);
			$add_params['initial_sel_ndx'] = 12;
			ControlFactory::add_combobox($defs, $this, $add_params,
			'DisableUpload', 'Disable upload',
			intval($jsd->DisableUpload), $showOps, $width - 550, true, true);
			
			ControlFactory::add_vgap($defs, -5);
			$add_params['initial_sel_ndx'] = 13;
			ControlFactory::add_text_field($defs, $this, $add_params,
				'DownloadRateLimit', 'Download rate limit',
			$jsd->DownloadRateLimit, 1, 0, 0, 0, $width - 550, true, true);
			
			ControlFactory::add_vgap($defs, -5);
			$add_params['initial_sel_ndx'] = 14;
			ControlFactory::add_text_field($defs, $this, $add_params,
				'UploadRateLimit', 'Upload rate limit',
			$jsd->UploadRateLimit, 1, 0, 0, 0, $width - 550, true, true);
			
			ControlFactory::add_vgap($defs, -5);
			$add_params['initial_sel_ndx'] = 15;
			ControlFactory::add_text_field($defs, $this, $add_params,
				'ConnectionsLimit', 'Connections limit',
			$jsd->ConnectionsLimit, 1, 0, 0, 0, $width - 550, true, true);
			
			ControlFactory::add_vgap($defs, -5);
			$add_params['initial_sel_ndx'] = 16;
			ControlFactory::add_text_field($defs, $this, $add_params,
				'DhtConnectionLimit', 'Dht connection limit',
			$jsd->DhtConnectionLimit, 1, 0, 0, 0, $width - 550, true, true);
			
			ControlFactory::add_vgap($defs, -5);
			$add_params['initial_sel_ndx'] = 17;
			ControlFactory::add_text_field($defs, $this, $add_params,
				'PeersListenPort', 'Peers listen por',
			$jsd->PeersListenPort, 1, 0, 0, 0, $width - 550, true, true);
			
			ControlFactory::add_vgap($defs, 55);
			$attrs['initial_sel_ndx'] = isset($user_input->initial_sel_ndx) ? $user_input->initial_sel_ndx : -1;
			return ActionFactory::show_dialog('Настройки сервера TorrServ: ' . $cmd, $defs, true, $width, $attrs);
		}
		
		if ((isset($user_input->action))&&($user_input->action == 'torrservSearch')){
			$torrservIp_ops = HD::isServerAvailable(null, '8090');
			if (count($torrservIp_ops) > 0){
				ControlFactory::add_vgap($defs, -10);
				ControlFactory::add_smart_label($defs, "", 
						'<text size="small">Найдено: '. count($torrservIp_ops) .'</text>'
					);
				ControlFactory::add_vgap($defs, -10);
				$add_params['control_id']= $user_input->control_id;
				$torrservIp_ops[''] = "Выберите";
				ControlFactory::add_combobox($defs, $this, $add_params,
					'torrservIp', '',
					'', $torrservIp_ops, $width - 100, true, false
				);
				ControlFactory::add_vgap($defs, -10);
				ControlFactory::add_smart_label($defs, "", 
						'<text size="small">*Выберите нужный из списка если их несколько</text>'
					);
			}else{
				ControlFactory::add_multiline_label($defs, '', 'Запущенных TorrServer в локальной сети не найденно, запустите TorrServer на каком либо устройстве если же запущенный TorrServer имеет не стандартный порт укажите "IP адрес:порт" вручную. ', 5);
				$gui_params['button_caption_centered'] = 1;
				$action = UserInputHandlerRegistry::create_action($this, $user_input->control_id);
				ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,'_do', 'Ok', 300, $action, $gui_params);
			}
			return ActionFactory::show_dialog('Запущенные TorrServer в локальной сети', $defs, true, $width, $attrs);
		}
		
		if ((isset($user_input->torrservIp))&&(isset($user_input->action_type))){
			if ((isset($user_input->torrservHistoryIp))&&($user_input->torrservHistoryIp != 'na'))
				$user_input->torrservIp = $user_input->torrservHistoryIp;
			if ($user_input->torrservIp == 'Укажите IP адрес (:порт - необязательно)')
				$user_input->torrservIp = '';
			$sArr = self::setTorrServIp ($user_input->torrservIp);
			if ($sArr['caption'] == 'Error!'){
				$actions = UserInputHandlerRegistry::create_action($this, $user_input->control_id);
				return ActionFactory::show_title_dialog($sArr['caption'], $actions, $sArr['descr'], $width);
			}
			$action = UserInputHandlerRegistry::create_action($this, $user_input->control_id);
			if ($user_input->action_type == 'confirm')
				return ActionFactory::close_dialog_and_run($action);
			else
				return $action;
		}
		if ($torrservIp == ''){
			$torrservIp = 'Укажите IP адрес (:порт - необязательно)';
			if (self::getInstallTorrServer () == true){
				$ipDescr = 'Найден локальный TorrServ нажмите Enter в адресной строке или у';
				$torrservIp = 'http://127.0.0.1:8090';
			}else if (HD::get_platform_kind() == '87xx'){
				$ipDescr = 'Что бы использовать локальный TorrServ установите плагин TorrServe или у';
			}else if (HD::get_platform_kind() == 'android')
				$ipDescr = 'Что бы использовать локальный TorrServ установите андроидное приложение TorrServ или у';
			else
				$ipDescr = 'У';
			$ipDescr .= "кажите IP адрес устройства с TorrServ:";
		}else
			$ipDescr = "IP адрес TorrServ:";
		
		ControlFactory::add_vgap($defs, -10);
		ControlFactory::add_multiline_label($defs, '', $ipDescr, 5);
		ControlFactory::add_vgap($defs, -10);
		$add_params['control_id']= $user_input->control_id;
		ControlFactory::add_text_field(
			$defs, $this, $add_params,
			'torrservIp', '',
			$torrservIp, 0, 0, 0, 0, $width - 100, 1, 0
		);
		$torrservHistory = HD::getItemsArr('torrservHistory');
		if (count($torrservHistory) > 0){
			$torrservHistoryOps['na'] = 'Ранее использованные TorrServe';
			foreach ($torrservHistory as $k => $v)
				$torrservHistoryOps[$k] = $k;
			$add_params['control_id']= $user_input->control_id;
			ControlFactory::add_combobox($defs, $this, $add_params,
				'torrservHistoryIp',
				'',
				'na', $torrservHistoryOps,  $width - 100, true, false
			);
		}
		$add_params_search['action']= 'torrservSearch';
		ControlFactory::add_button_close(&$defs, $this, $add_params_search, $user_input->control_id, '', 'Найти запущенные TorrServ', $width - 100);
		if ($torrservIp != 'Укажите IP адрес (:порт - необязательно)'){
			$tt ='';
			if ($slaveTorrServer == true)
				$tt = '<icon width="48" height="48">'.DuneSystem::$properties['install_dir_path'].'/icons/s_dune_logo.png</icon><icon width="20" height="48">'.DuneSystem::$properties['install_dir_path'].'/icons/pixel.png</icon>';
			if ($cmd == true){
				
				ControlFactory::add_smart_label($defs, 
					"", 
					$tt . '<text color="10" size="normal">TorrServe: '.$cmd . ' </text><icon width="115" height="25">'.DuneSystem::$properties['install_dir_path'].'/icons/online.png</icon>' 
				);
				if (!preg_match("|matrix|i", $cmd)){
					ControlFactory::add_multiline_label($defs, '', 'Необходимо установить TorrServer MatriX', 2);
					return ActionFactory::show_dialog('Версия TorrServer устарела', $defs, true, $width, $attrs);
				}
				ControlFactory::add_vgap($defs, -10);
				$add_params['action']= 'setup_torrserve';
				ControlFactory::add_button_close(&$defs, $this, $add_params, $user_input->control_id, '', 'TorrServe Settings', $width - 100);
				$add_params['action']= 'stop';
				ControlFactory::add_button_close(&$defs, $this, $add_params, $user_input->control_id, '', 'Остановить TorrServe', $width - 100);
				if ($slaveTorrServer == true){
					$params['initial_sel_ndx']= 4;
					$params['action']= 'restart';
					ControlFactory::add_button_close(&$defs, $this, $params, $user_input->control_id, '', 'Перезапустить TorrServe', $width - 100);
				}
				if (DuneSystem::$properties['plugin_name'] != 'torrent_center'){
					ControlFactory::add_vgap($defs, -10);
					ControlFactory::add_multiline_label($defs, '', "Добавлять обложку и описание в TorrServ?", 2);
					ControlFactory::add_vgap($defs, -10);
					
					ControlFactory::add_combobox($defs, $this, $add_params,
					'addTorrServInf', '',
					$addTorrServInf, $showOps, $width - 100, true, false);
					
					ControlFactory::add_vgap($defs, -10);
					ControlFactory::add_multiline_label($defs, '', "Добавление торрентов по кнопке ENTER", 2);
					ControlFactory::add_vgap($defs, -10);
					$actionTorrServOps[0] = 'добавить и проиграть';
					$actionTorrServOps[1] = 'проиграть';
					$actionTorrServOps[2] = 'только добавить';
					$actionTorrServOps[3] = 'Выбрать';
					ControlFactory::add_combobox($defs, $this, $add_params,
					'actionEnterTorrServ', '',
					$actionTorrServ['enter'], $actionTorrServOps, $width - 100, true, false);
					ControlFactory::add_vgap($defs, -10);
					ControlFactory::add_multiline_label($defs, '', "Добавление торрентов по кнопке PLAY", 2);
					ControlFactory::add_vgap($defs, -10);
					ControlFactory::add_combobox($defs, $this, $add_params,
					'actionPlayTorrServ', '',
					$actionTorrServ['play'], $actionTorrServOps, $width - 100, true, false);
				}
				ControlFactory::add_vgap($defs, -10);
				ControlFactory::add_multiline_label($defs, '', "Прелоад перед запуском воспроизведения:", 2);
				ControlFactory::add_vgap($defs, -10);
				$preloadTorrServ = (HD::getItemStr('preloadTorrServ', true) !='') ? HD::getItemStr('preloadTorrServ', true) : 1;
				ControlFactory::add_combobox($defs, $this, $add_params,
				'preloadTorrServ', '',
				$preloadTorrServ, $showOps, $width - 100, true, false);
			}else{
				ControlFactory::add_smart_label($defs, 
					"", 
					$tt . '<text color="8" size="normal">TorrServer </text><icon width="115" height="25">'.DuneSystem::$properties['install_dir_path'].'/icons/offline.png</icon>'
				);
				if ($slaveTorrServer == true){
					$add_params['action']= 'start';
					ControlFactory::add_button_close(&$defs, $this, $add_params, $user_input->control_id, '', 'Запустить TorrServe', $width - 100);
				}
			}
			if ($torrservIp = 'http://127.0.0.1:8090')
				ControlFactory::add_smart_label($defs, "", 
					'<text size="tiny">*127.0.0.1 локальный TorrServer установленный на этом плеере</text>'
				);
		}
		return ActionFactory::show_dialog('Настройки TorrServer', $defs, true, $width, $attrs);
	}
	
	public static function getSlaveTorrServer (){
		$duneTorrServIp = (HD::getItemStr('duneTorrServIp',true) !='') ? HD::getItemStr('duneTorrServIp', true) : 0;
		if (($duneTorrServIp == 1)||(self::getLocalTorrServer() == true))
			return true;
		return false;
	}
	public static function getLocalTorrServer (){
		if (self::getIp() != 'http://127.0.0.1:8090')
			return false;
		return self::getInstallTorrServer ();
	}
	public static function getInstallTorrServer (){
		$platform = HD::get_platform_kind();
		if ($platform == 'apk'){
			if (preg_match('|"ru.yourok.torrserve"|', file_get_contents('/tmp/applications/app_data.json')))
                return "apk_apk";
			if (preg_match('|TorrServe|', file_get_contents('/tmp/run/installed_plugins.xml')))
				return "apk_plugin";
        } else if ($platform == 'android'){
			$file_exists = shell_exec ('/system/dunehd/dunehd_service do [ -f "/data/data/ru.yourok.torrserve/files/torrserver" ] && echo 2');
			if ($file_exists == 2)
				return $platform;
		}else if ($platform == '87xx')
			if (preg_match('|TorrServe|', file_get_contents('/tmp/run/installed_plugins.xml')))
				return $platform;
		return false;
	}
	public static function getStatusTorrServer (){
		$torrServIp = self::getIp();
		if ($torrServIp != ''){
			$cmd = HD::isDomainAvailible("$torrServIp/echo");
			if($cmd == true)
				return $cmd;
		}
		return false;
	}
	public static function getOnlineStatusServer (){
		$torrServIp = self::getIp();
hd_print("EEE torrServIp: $torrServIp");
		if ($torrServIp != ''){
			if (HD::isServerAvailable($torrServIp) == true)
				return true;
			if (self::getSlaveTorrServer() == true)
				return self::getStartSlaveTorrServer();
		}
		return false;
	}
	public static function checkTorrServerKill(){
		if (self::getInstallTorrServer() == true){
			if (self::getStatusTorrServer() == true){
				return self::torrserverActionStop();
			}
		}
	}
	public static function getStartSlaveTorrServer (){
		$path_parts = parse_url(self::getIp());
		if ((PeerflixServer::getLocalPeerflixServer() == true)&&
		(TorrServer::getLocalTorrServer() == true)){
			if (HD::get_platform_kind() == '87xx'){
				//HD::check_transmission_kill();
				PeerflixServer::checkPeerflixServerKill();
				echo '---';
			}
		}
		$context = stream_context_create(
			array(
				'http' => array(
					'timeout' => 1,
					'method' => "GET"
				)
			)
		);
		$pluginArr[] = DuneSystem::$properties['plugin_name'];
		$pluginArr[] = "Bazinga";
		foreach ($pluginArr as $plugin){
			hd_silence_warnings();
			$response = file_get_contents($path_parts['scheme'] .  '://' . $path_parts['host'] . "/cgi-bin/plugins/$plugin/torrserve");
			hd_restore_warnings();
			if ($response == true){
				sleep (2);
				if (preg_match('|started|', $response)){
					hd_print('Bazinga start');
					return true;
				}
				$jsd = json_decode($response);
				if (json_last_error() === JSON_ERROR_NONE){
					hd_print($jsd->msg);
					return $jsd->status;
				}
			}
		}
		return false;
    }
	public static function getRestartSlaveTorrServer (){
		if (self::torrserverActionStop() == '')
			if (self::getStartSlaveTorrServer() == true){
				sleep (2);
				return true;
			}
		return false;
	}
	public static function torrserverActionUpload($first_arg, $dontSave=null){
		$arr['file'] = '@' . $first_arg;
		if ($dontSave == false)
			$arr['save'] = true;
		$jsd = json_decode(HD::http_post_document(self::getIp() . '/torrent/upload', $arr));
		if (($jsd == false)||(!isset($jsd->hash)))
			return false;
		return $jsd->hash;
	}
	public static function torrserverActionSettingsWrite($arr){
		$arr["action"]="set";
		$arr["sets"]= $arr;
		$context = stream_context_create(
			array(
				'http' => array(
					'method' => 'POST',
					'header' => "Content-Type: application/octet-stream\r\n",
					'content'=> json_encode($arr)
				)
			)
		);
		$response =  file_get_contents(self::getIp() . '/settings', 0, $context);
		return true;
	}
	public static function torrserverActionSettingsRead(){
		$context = stream_context_create(
			array(
				'http' => array(
					'method' => 'POST',
					'header' => "Content-Type: application/octet-stream\r\n",
					'content'=> '{"action":"get"}'
				)
			)
		);
		$response = file_get_contents(self::getIp() . '/settings',0,$context);
		if ($response == true){
			$jsd = json_decode($response);
			if (json_last_error() === JSON_ERROR_NONE)
				return $jsd;
		}
		return false;
	}
	public static function actionGetTorrentList(){
		// $str = HD::do_cmd('run', 'action=torrentTorrServList torrServIp=' . self::getIp());
		$cmdAsyncExec = DuneSystem::$properties['install_dir_path'] . '/www/cgi-bin/php-cgi -f ' .  DuneSystem::$properties['install_dir_path'] . "/www/cgi-bin/run.php action=torrentTorrServList torrServIp=" . self::getIp ();
		$str = HD::asyncExec($cmdAsyncExec);
		if (!empty($str)){
			if ($str == '[]')
				return true;
			return json_decode ($str);
		}
		return false;
	}
	public static function torrserverActionDrop($hash){
		$arr["action"]="drop";
		$arr["hash"]= $hash;
hd_print("EEE torrserverActionDrop(), content: ".print_r($arr,1));
		$context = stream_context_create(
			array(
				'http' => array(
					'method' => 'POST',
					'header' => "Content-Type: application/octet-stream\r\n",
					'content'=> json_encode($arr)
				)
			)
		);
		$jsd = json_decode(file_get_contents(self::getIp() . '/torrents', 0, $context));
		return true;
	}
	public static function torrserverActionRem($hash){
		
		$arr["action"]="rem";
		$arr["hash"]= $hash;
hd_print("EEE torrserverActionRem(), content: ".print_r($arr,1));
		$context = stream_context_create(
			array(
				'http' => array(
					'method' => 'POST',
					'header' => "Content-Type: application/octet-stream\r\n",
					'content'=> json_encode($arr)
				)
			)
		);
		$jsd = json_decode(file_get_contents(self::getIp() . '/torrents', 0, $context));
		return true;
	}
	public static function torrserverActionAdd($first_arg, $infoArr = null, $dontSave = null){
		$addTorrServInf = (HD::getItemStr('addTorrServInf', true) !='') ? HD::getItemStr('addTorrServInf', true) : 0;
		$content["action"] = "add";
		$content["link"] = $first_arg;
		if (($infoArr==true)&&($addTorrServInf == 1)){
			$content["title"] = $infoArr["title"];
			$content["poster"] = $infoArr["poster_path"];
		}
		$content["save_to_db"] = true;
		if ($dontSave==true)
			$content["save_to_db"] = false;
hd_print("EEE torrserverActionAdd(), content: ".print_r($content,1));
		$context = stream_context_create(
			array(
				'http' => array(
					'method' => 'POST',
					'header' => "Content-Type: application/octet-stream\r\n",
					'content'=> json_encode($content)
				)
			)
		);
		$jsd = json_decode(file_get_contents(self::getIp() . '/torrents', 0, $context));
		if (isset($jsd->hash))
				return $jsd->hash;
		return false;
	}
	public static function torrserverActionGet($hash){
hd_print("EEE torrserverActionGet(hash=$hash)");
		$arr["action"] = "get";
		$arr["hash"] = $hash;
		$context = stream_context_create(
			array(
				'http' => array(
					'timeout' => 1,
					'method' => 'POST',
					'header' => "Content-Type: application/octet-stream\r\n",
					'content'=> json_encode ($arr)
				)
			)
		);
		hd_silence_warnings();
		$str = file_get_contents(self::getIp() . '/torrents', 0, $context);
		hd_restore_warnings();
		if ($str == true){
			$str = preg_replace('/("\w+"):\s*?(\d+),/', '\\1:"\\2",', $str);
			$str = preg_replace('/("length"):\s*?(\d+)/', '\\1:"\\2"', $str);
			return json_decode ($str);
		}
		return false;
	}
	public static function torrserverActionViewed($first_arg){
		$context = stream_context_create(
			array(
				'http' => array(
					'timeout' => 1,
					'method' => 'POST',
					'header' => "Content-Type: application/octet-stream\r\n",
					'content'=> '{"action":"list", "hash":"'.$first_arg.'"}'
				)
			)
		);
		hd_silence_warnings();
		$response = file_get_contents(self::getIp() . '/viewed', 0, $context);
		hd_restore_warnings();
		if ($response == true){
			$str = preg_replace('/("\w+"):\s*?(\d+)/', '\\1:"\\2"', $response);
			return json_decode ($str);
		}
		return false;
	}
	public static function torrserverActionStop(){
		hd_silence_warnings();
		file_get_contents(self::getIp() . '/shutdown');
		hd_restore_warnings();
		sleep (2);
		return self::getStatusTorrServer();
	}
	public static function torrserverActionPreload($first_arg){
		exec('wget --quiet -O - "'. str_replace('&play', '&preload', $first_arg) .'" > /dev/null &');
		return true;
	}
	public static function torrserverActionKill(){
		if (self::getLocalTorrServer() == true){
			if (HD::get_platform_kind() == '87xx'){
				$cmd = shell_exec ("pidof TorrServe");
				if ($cmd == true){
                    $port = HD::http_local_port();
					$q = file_get_contents("http://127.0.0.1:$port/cgi-bin/plugins/TorrServe/service_api?cmd=torrserve_stop");
					hd_print ("kill: torrserve => $q");
					$cmd = shell_exec ("pidof TorrServe");
					if ($cmd == true)
						return false;
					else
						return true;
				}else
					return true;
			}
			return true;
		}
		return true;
	}
	public static function load_movie($movie_id, $mUrl, $getMovieInfo){
		if (isset(self::$torrServItems[$movie_id]))
			return self::$torrServItems[$movie_id];
		else if (isset($mUrl->data))
			return (array)json_decode(urldecode($mUrl->data));
		else
			return false;
	}
	public static function getTorrServerPackageName(){
		$package = false;
		$jsd = json_decode(file_get_contents('/tmp/applications/app_data.json'));
		foreach ($jsd->applications as $v){
			if (preg_match('|torrserve|', $v->package_name)){
				$package['name'] = $v->package_name;
				$package['activity'] = $v->activity;
				break;
			}
		}
		return $package;
	}
	public static function set_movie($movie_id, $obj){
		self::$torrServItems[$movie_id] = (array)json_decode(urldecode($obj));
	}
	public static function get_series_list($media_url, $movie){
		if (isset($media_url->torrentId))
			$hash = $media_url->torrentId;
		else if (isset($media_url->file_info->torrentId))
			$hash = $media_url->file_info->torrentId;
		else
			$hash = $media_url->movie_id;
		if (isset($media_url->torrentId)){
			$jsd = self::torrserverActionGet($hash);
			if ($jsd == false)
				return 'addTorrent';
		}else
			$jsd = self::torrserverActionGet($hash);
		if ($jsd == true){
			if (!isset($jsd->file_stats)){
				$i = 0;
				do{
					$i++;
					usleep(500000);
					$jsd = self::torrserverActionGet($hash);
				} while (($i < 20)&&(!isset($jsd->file_stats)));
			}
			$jsdViewed = self::torrserverActionViewed($hash);
			foreach ($jsdViewed as $v)
				$viewed[$v->file_index] = 1;
			$items = array();
			foreach ($jsd->file_stats as $key => $vel){
				$pathinfo = pathinfo($vel->path);
				if (((isset($pathinfo['extension']))&&(!preg_match("/mp3|wav|og(?:g|a)|flac|dts|ac3|rm|aac|wma|mka|ape|mpeg|ra?m|avi|mp(?:g|e|4)|mov|divx|asf|qt|wmv|m\dv|rv|vob|asx|ogm|mkv|m2ts|ts/i",$pathinfo['extension'])))||(!isset($pathinfo['extension'])))
					continue;
				$title = pathinfo($vel->path, PATHINFO_BASENAME);
				$items[$vel->path]['title'] = $title;
				$items[$vel->path]['id'] = md5 ($title);//to be continue
				$items[$vel->path]['title'] = $title;
				if (isset($vel->length))
					$items[$vel->path]['file_info']['size'] = HD::readableBytes($vel->length);
				$items[$vel->path]['playback_url'] = self::getIp() . '/stream/' . str_replace(' ', '%20', $title) . '?link=' . $hash . '&index=' . $vel->id . '&play';
				$items[$vel->path]['is_stream_url'] = true;
				$items[$vel->path]['file_info']['poster_url'] = $movie->poster_url;
				$items[$vel->path]['file_info']['class_name'] = $media_url->class_name;
				$items[$vel->path]['file_info']['details_box_width'] = true;
				if (isset($media_url->detailed_info))
					$items[$vel->path]['file_info']['detailed_info'] = $media_url->detailed_info;
				if (isset($viewed[$vel->id]))
					$items[$vel->path]['file_info']['stiker_img'] = 'plugin_file://icons/ss_eye.png';
				if (isset($selected_media_url->tType))
					$items[$vel->path]['file_info']['tType'] = $selected_media_url->tType;
				if (isset( $media_url->torrentId))
					$items[$vel->path]['file_info']['torrentId'] = $media_url->torrentId;
				else
					$items[$vel->path]['file_info']['torrentId'] = $media_url->movie_id;
				$items[$vel->path]['file_info']['torrentClassName'] = 'TorrServer';
			}
			ksort($items);
			return $items;
		}else return array();
	}
	public function meinMenuOpenFolderDialog(&$user_input, &$plugin_cookies){
		hd_restore_warnings();
		if (isset($user_input->openTorrServerApp)){
			sleep (2);
			$package = self::getTorrServerPackageName();
			if ($package != false){
				exec ("am start " . $package['name'] . "/" . $package['activity'] . " 2>&1");
				return null;
			}else
				return ActionFactory::show_title_dialog( 'Андроид приложение TorrServer не найдено');
		}
		if (isset($user_input->dontAsk))
			$plugin_cookies->torrServerAsk = 1;
		if (isset($user_input->install)){
			$add_params['openTorrServerApp'] = true;
			$post_action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $add_params);
			$jsd = json_decode(HD::http_get_document('https://api.github.com/repos/YouROK/TorrServe/releases/latest'));
			if (isset($jsd->assets[0]->browser_download_url))
				return ActionFactory::download_and_install_apk('TorrServe MatriX', 'ru.yourok.torrserve', array($jsd->assets[0]->browser_download_url), false, $post_action);
			else
				return ActionFactory::show_title_dialog('Установка не удалась!');
		}
		$torrServerAsk = isset($plugin_cookies->torrServerAsk) ? $plugin_cookies->torrServerAsk : 0;
		if ($torrServerAsk === 0){
			$title = 'Установить андроид приложение TorrServer?';
			$add_params['install'] = true;
			$yes_action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $add_params);
					
			$add_params1['dontAsk'] = true;
			$yes_action1 = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $add_params1);
			$msgs1[] = "Позднее TorrServer можно уcтановить через настройки плагина или из apk файла";
			$no_action = ActionFactory::show_yes_no_dialog('Больше не спрашивать?', $yes_action1, true, $msgs1, false, 950);
					
			$msgs[] = "TorrServer необходим для просмотра торрентов онлайн";
			$msgs[] = "После установки андроидного приложения TorrServer необходимо необходимо установить сервер в настройках андроидного приложения TorrServer";
			return ActionFactory::show_yes_no_dialog($title, $yes_action, true, $msgs, $no_action, 950);
		}
		$action = UserInputHandlerRegistry::create_action($this, 'classSetupTorrServer');
hd_print("EEE tni 1");
		return ActionFactory::show_title_dialog('TorrServer не запущен', $action, self::getIp(), 0);
	}
}
?>
