<?php
class Transmission
{
	static $transmissionIp = null;
	static $transmissionRPC = null;
	static $transmissionItems = null;
	static $torrent = null;
	public static $sessionInfo;
	public static function getIp(){
        if (null === self::$transmissionIp){
			$transmissionIp = (HD::getItemStr('transmissionIp', 1) != '') ? HD::getItemStr('transmissionIp', 1) : false;
			if (($transmissionIp == '')&&(self::getInstallTransmission() == true)){
				$transmissionIp = 'http://127.0.0.1:9091';
				HD::saveItemStr('transmissionIp', $transmissionIp, true);
				HD::saveItemStr('duneTransmissionIp', 1, true);
			}
            self::$transmissionIp = $transmissionIp;
        }
        return self::$transmissionIp;
	}
	public static function getSlaveTransmissionApp($host){
		if (HD::isDomainAvailible("http://$host/cgi-bin/plugins/LTU_install/service_api?cmd=transmission_status") == true)
			return 'LTU_install';
		else if (HD::isDomainAvailible("http://$host/cgi-bin/plugins/Transmission/service_api?cmd=transmission_status") == true)
			return 'Transmission';
		else if (HD::isDomainAvailible("http://$host/cgi-bin/plugins/Entware/service_api?cmd=transmission_status") == true)
			return 'Entware';
		else if ((HD::is_android() == true)&&($host == '127.0.0.1')){
			$file_exists = shell_exec ('/system/dunehd/dunehd_service do [ -f "/data/user/0/com.ap.transmission.btc/Config/settings.json" ] && echo 2');
				if ($file_exists == 2)
					return 'transmission.btc';
		}
		return false;
	}
	public function actionStartStopTransmission($defs, $user_input){
		hd_restore_warnings();
		if (!isset($user_input->action))
			$user_input->action = $params['action'] = 'start';
		else
			$params['action'] = $user_input->action;
		if ((isset($user_input->action))&&($user_input->action == 'stop'))
			$caption = 'Остановка';
		else
			$caption = 'Запуск';
		$params['counter'] = 1;
		if(isset($user_input->unlock))
			$params['unlock'] = true;
		if (isset($user_input->counter))
			$params['counter'] = $user_input->counter + 1;
		if (!isset($user_input->transmissionActionPerformed)){
			$transmissionIp = self::getIp();
			$path_parts = parse_url($transmissionIp);
			if ((self::getLocalTransmission() == true)&&
			(TorrServer::getLocalTorrServer() == true)&&
			(PeerflixServer::getLocalPeerflixServer() == true)
			){
				if (HD::get_platform_kind() == '87xx'){
					PeerflixServer::checkPeerflixServerKill();
					TorrServer::checkTorrServerKill();
					echo '---';
				}
			}
			$transmissionApp = self::getSlaveTransmissionApp($path_parts['host']);
			if ($transmissionApp == 'transmission.btc'){
				exec ("am start com.ap.transmission.btc/com.ap.transmission.btc.activities.MainActivity 2>&1");
				sleep (10);
				$action = UserInputHandlerRegistry::create_action($this, $user_input->control_id);
				return ActionFactory::show_title_dialog('Приложение Transmission BTC запущено!',$action);
			}else if ($transmissionApp == true){
				$cmdAsyncExec = 'wget -O - "http://'.$path_parts['host'].'/cgi-bin/plugins/'.self::getSlaveTransmissionApp($path_parts['host']).'/service_api?cmd=transmission_' . $user_input->action . '"';
				$result = HD::asyncExec($cmdAsyncExec);
			}else
				return ActionFactory::show_title_dialog('Err!', null, 'Запустить/остановить Transmission не удалось!');
			
		}else
			$result = true;
		if ($result == true){
			$a = false;
			if ($user_input->action == 'start')
				$a = true;
			if (self::getOnlineStatusServer() == $a){
				HD::asyncExec('proc_close');
				$params = null;
				$params['counter'] = $user_input->counter + 1;
				$action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $params);
			}else{
				$params['peerflixActionPerformed'] = 1;
				$action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $params);
			}
		}else
			$action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $params);
		ControlFactory::add_smart_label($defs, '', '<text size="small">Прошло: '.HD::sec_format_duration($params['counter'])." сек. </text>");
		$attrs['timer'] = ActionFactory::timer(1000);
		$attrs['actions'] = array(GUI_EVENT_TIMER => ActionFactory::close_dialog_and_run($action));
		return  ActionFactory::show_dialog($caption . ' Transmission', $defs, true, 0, $attrs);
	}
	public static function setTransmissionIp($inputStr){
		$path_parts = parse_url($inputStr);
		if (isset($path_parts['host']))
			$transmissionIp = $path_parts['host'];
		else if (isset($path_parts['path']))
			$transmissionIp = $path_parts['path'];
		if (self::$transmissionRPC != false)
			self::$transmissionRPC = false;
		$ip_address = HD::get_ip_address();
		if (($transmissionIp == '127.0.0.1')||($ip_address == $transmissionIp)){
			if (self::getInstallTransmission() != true)
				return array(
					'caption' => 'Error!',
					'descr' => "IP адрес Transmission: $transmissionIp указан не верно. Локальный Transmission не найден. Необходима установка Transmission на это устройство или указывайте IP адрес другого устройства в сети с установленным Transmission"
				);
			$transmissionIp = '127.0.0.1';
		}else if ($transmissionIp == ''){
			if (self::getIp() != ''){
				if (HD::saveItemStr('transmissionIp', $transmissionIp, true) == true){
					self::$transmissionIp = $transmissionIp;
					HD::saveItemStr('duneTransmissionIp', 0, true);
					return array(
						'caption' => 'Сохранено',
						'descr' =>  "Удален IP адрес Transmission: " . self::getIp()
					);
				}else
					return array(
					'caption' => 'Error!',
					'descr' => "Сохранение не удалось"
					);
			}else
				return array(
					'caption' => 'Error!',
					'descr' => "IP адрес Transmission не указан. Укажите IP адрес устройства с установленным Transmission"
				);
		}
		if (isset($path_parts['port']))
			$transmissionIp .= ':' . $path_parts['port'];
		else
			$transmissionIp .= ':9091';
		if (isset($path_parts['scheme']))
			$transmissionIp = $path_parts['scheme'] .  '://' . $transmissionIp;
		else
			$transmissionIp = 'http://' . $transmissionIp;
		if (HD::saveItemStr('transmissionIp', $transmissionIp, true) == true){
			$transmissionHistory = HD::getItemsArr('transmissionHistory');
			$transmissionHistory = array_reverse($transmissionHistory);
			$transmissionHistory[$transmissionIp] = $transmissionIp;
			$transmissionHistory = array_reverse($transmissionHistory);
			$transmissionHistory = array_slice($transmissionHistory, 0, 10);
			HD::saveItemsArr('transmissionHistory', $transmissionHistory);
			if (isset($path_parts['host']))
				$host = $path_parts['host'];
			else if (isset($path_parts['path']))
				$host = $path_parts['path'];
			self::$transmissionIp = $transmissionIp;
			$duneTransmissionIp = 0;
			if (preg_match("/(\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3})/", $host, $m)){
				$url = "http://$host/cgi-bin/do?cmd=status";
				if (HD::isDomainAvailible($url) == true){
					$duneTransmissionIp = 1;
					$inf = file_get_contents($url);
					if (preg_match('|android_app_active|', $inf))
						$duneTransmissionIp = 2;
				}
			}
			HD::saveItemStr('duneTransmissionIp', $duneTransmissionIp, true);
			return array(
				'caption' => 'Сохранено',
				'descr' => "IP Transmission: $transmissionIp",
			);
		}else
			return array(
				'caption' => 'Error!',
				'descr' => "IP адрес Transmission: $transmissionIp cохранить не удалось",
			);
	}
	public static function getOnlineStatusServer(){
		$transmissionIp = self::getIp();
		if ($transmissionIp != ''){
			$cmd = HD::isDomainAvailible($transmissionIp);
			if($cmd == true)
				return $cmd;
		}
		return false;
	}
	public static function getSlaveTransmission(){
		$duneTransmissionIp = (HD::getItemStr('duneTransmissionIp',true) !='') ? HD::getItemStr('duneTransmissionIp', true) : 0;
		if ($duneTransmissionIp == 2)
			return false;
		if (($duneTransmissionIp == 1)||(self::getLocalTransmission() == true))
			return true;
		return false;
	}
	public static function getLocalTransmission(){
		if (self::getIp() != 'http://127.0.0.1:9091')
			return false;
		return self::getInstallTransmission();
	}
	public static function getInstallTransmission(){
		if (HD::is_android() == true){
			$file_exists = shell_exec ('/system/dunehd/dunehd_service do [ -f "/data/user/0/com.ap.transmission.btc/Config/settings.json" ] && echo 2');
				if ($file_exists == 2)
					return '/data/user/0/com.ap.transmission.btc/Config/settings.json';
		}
		else if (file_exists(str_replace(DuneSystem::$properties['plugin_name'], 'Transmission', DuneSystem::$properties['install_dir_path']) . '/bin/etc/default/settings.json'))
			return str_replace(DuneSystem::$properties['plugin_name'], 'Transmission', DuneSystem::$properties['install_dir_path']) . '/bin/etc/default/settings.json';
		else if (file_exists('/opt/etc/transmission/settings.json'))
			return '/opt/etc/transmission/settings.json';
		else if (file_exists('/transmission/.config/settings.json'))
			return '/transmission/.config/settings.json';
		return false;
	}
	public function setup($defs, $user_input){
		
		hd_restore_warnings();
		$attrs['initial_sel_ndx'] = isset($user_input->initial_sel_ndx) ? $user_input->initial_sel_ndx : -1;
		$transmissionIp = self::getIp();
		$cmd = self::getOnlineStatusServer();
		$slaveTransmission = self::getSlaveTransmission();
		Transmission::actionGetSessionInfo();
		$add_params = null;
		$width = 1050;
		if ((isset($user_input->action))&&(('start' == $user_input->action)||('stop' == $user_input->action)
		)){
			hd_silence_warnings();
			return self::actionStartStopTransmission($defs, $user_input);
		}
		if ((isset($user_input->action))&&($user_input->action == 'test')){
			echo '===========================================================';
			echo 'Transmission IP: ' . self::getIp();
			$transmissionAccount = (HD::getItemsArr('transmissionAccount', true) != array()) ? HD::getItemsArr('transmissionAccount', true) : array('login' => 'Введите логин', 'pass' => 'Введите пароль');
			
			self::transmissionRpcAction();
			if (self::$transmissionRPC == false)
				echo 'Transmission self::$transmissionRPC: false';
			else{
				echo 'Transmission self::$transmissionRPC: true';
				$s = json_encode (self::$transmissionRPC->sstats());
				echo 'Transmission self::$transmissionRPC:' . $s ;
			}
			$transmissionAccount = (HD::getItemsArr('transmissionAccount', true) != array()) ? HD::getItemsArr('transmissionAccount', true) : array('login' => '', 'pass' => '');
			$cmd = 'action=sstats transmissionIp=' . self::getIp();
			if (($transmissionAccount['login'] != '')&&($transmissionAccount['pass'] != ''))
				$cmd .= " login=". urlencode($transmissionAccount['login']) ." pass=" . urlencode($transmissionAccount['pass']);
			$result = HD::do_cmd('transmissionActions', $cmd);
			$result = HD::do_cmd('transmissionActions', $cmd);
			if ($result == true)
				echo('Transmission HD::do_cmd:' . $result);
			else{
				echo 'Transmission HD::do_cmd: false';
				echo "exec_result_sstats-->" . HD::getItemTmpStr('exec_result_sstats') . "<--";
			}
			
			$cmdAsyncExec = DuneSystem::$properties['install_dir_path'] . '/www/cgi-bin/php-cgi -f ' .  DuneSystem::$properties['install_dir_path'] . "/www/cgi-bin/transmissionActions.php action=get transmissionIp=" . self::getIp();
			
			if (($transmissionAccount['login'] != '')&&($transmissionAccount['pass'] != ''))
				$cmdAsyncExec .= " login=". urlencode($transmissionAccount['login']) ." pass=" . urlencode($transmissionAccount['pass']);
			$i = 0;
			do {
				$str = HD::asyncExec($cmdAsyncExec);
				$i++;
				echo 'Transmission $cmdAsyncExec: count - ' . $i;
				sleep (1);
			} while (($i < 10)&&(empty($str)));
			echo 'Transmission $cmdAsyncExec: str - ' . $str;
			echo "exec_result_get-->" . HD::getItemTmpStr('exec_result_get') . "<--";
			echo "error-proc_open.txt-->" . HD::getItemTmpStr('error-proc_open.txt') . "<--";
			echo '===========================================================';
			return ActionFactory::show_title_dialog('ok!', null, 'test', 850);
		}
		if ((isset($user_input->action))&&($user_input->action == 'reboot')){
			if (isset($user_input->do_reboot))
				return ActionFactory::restart();
			$msg = 'Перезагрузить плеер сейчас?';
			ControlFactory::add_multiline_label($defs, '', $msg, 8);
			$add_params['do_reboot'] = true;
			$add_params['action']= 'reboot';
			$reboot = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $add_params);
			ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,'_reboot', 'Да', 250, $reboot);
			ControlFactory::add_close_dialog_button($defs, 'Нет', 250);
			return  ActionFactory::show_dialog('Необходима перезагрузка плеера',$defs, true,1000,$attrs);
		}
		if ((isset($user_input->action))&&($user_input->action == 'delay')){
			HD::saveItemStr('delay_ms', $user_input->delay_ms, true);
			$add_params['initial_sel_ndx'] = $user_input->initial_sel_ndx;
			$add_params['action']= 'reboot';
			$action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $add_params);
			return ActionFactory::close_dialog_and_run($action);
		}
		if ((isset($user_input->action))&&($user_input->action == 'setup')){
			$add_params['control_id']= $user_input->control_id;
			$add_params['action'] = 'setup';
			if (isset($user_input->subAction)){
				$add_params['initial_sel_ndx'] = $user_input->initial_sel_ndx;
				Transmission::transmissionRpcAction();
				if (isset($user_input->str)){
					$argument[strval($user_input->subAction)] = $user_input->{$user_input->subAction};
					if ($user_input->{$user_input->subAction} == 'false')
						$add_params['initial_sel_ndx'] = $user_input->initial_sel_ndx - 1;
				}else{
					if (($user_input->{$user_input->subAction} != 0)&&($user_input->{$user_input->subAction} != ""))
						$argument[strval($user_input->subAction)] = intval($user_input->{$user_input->subAction});
					else{
						$action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $add_params);
						$action = ActionFactory::close_dialog_and_run($action);
						return ActionFactory::show_title_dialog('Err!', $action, 'Сохранение значения не удалось. Значение не может быть пустым или равным нулю.', 850);
					}
				}
				if (isset($argument))
					$result = Transmission::$transmissionRPC->sset($argument);
				$action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $add_params);
				if ((!isset($result))||($result->result != 'success'))
					return ActionFactory::show_title_dialog('Err!', $action, 'Сохранение значения не удалось.', 850);
				else
					return ActionFactory::close_dialog_and_run($action);
			}
			$subActionArr[] = array(
				'subAction' => 'peer-limit-global',
				'caption' => 'Глобальный лимит пиров',
				'sessionInfo' => 'peer_limit_global'
			);
			$subActionArr[] = array(
				'subAction' => 'peer-limit-per-torrent',
				'caption' => 'Лимит пиров торрента',
				'sessionInfo' => 'peer_limit_per_torrent'
			);
			$ops['true'] = 'Да';
			$ops['false'] = 'Нет';
			$initial_value = 'false';
			if (isset(Transmission::$sessionInfo['speed_limit_down_enabled'])){
				$subActionArr[] = array(
					'subAction' => 'speed-limit-down',
					'caption' => 'Скорость загрузки КБ/с',
					'sessionInfo' => 'speed_limit_down'
				);
				$initial_value = 'true';
			}
			$subActionArr[] = array(
				'subAction' => 'speed-limit-down-enabled',
				'caption' => 'Лимит скорости загрузки',
				'str' => true,
				'initial_value' => $initial_value,
				'ops' => $ops
			);
			$initial_value = 'false';
			if (isset(Transmission::$sessionInfo['speed_limit_up_enabled'])){
				$subActionArr[] = array(
					'subAction' => 'speed-limit-up',
					'caption' => 'Скорость отдачи КБ/с',
					'sessionInfo' => 'speed_limit_up'
				);
				$initial_value = 'true';
			}
			$subActionArr[] = array(
				'subAction' => 'speed-limit-up-enabled',
				'caption' => 'Лимит скорости отдачи',
				'initial_value' => $initial_value,
				'str' => true,
				'ops' => $ops
			);
			$subActionArr[] = array(
				'subAction' => 'alt-speed-down',
				'caption' => 'Альтернативная скорость загрузки КБ/с',
				'sessionInfo' => 'alt_speed_down'
			);
			
			$subActionArr[] = array(
				'subAction' => 'alt-speed-up',
				'caption' => 'Альтернативная скорость отдачи КБ/с',
				'sessionInfo' => 'alt_speed_up'
			);
			$initial_value = 'false';
			if (isset(Transmission::$sessionInfo['seedRatioLimited'])){
				$subActionArr[] = array(
					'subAction' => 'seedRatioLimit',
					'caption' => 'Коэффициент отдачи (ratio)',
					'sessionInfo' => 'seedRatioLimit'
				);
				$initial_value = 'true';
			}
			$subActionArr[] = array(
				'subAction' => 'seedRatioLimited',
				'caption' => 'Коэффициент отдачи (ratio)',
				'initial_value' => $initial_value,
				'str' => true,
				'ops' => $ops
			);
			$initial_value = 'false';
			if (isset(Transmission::$sessionInfo['download_queue_enabled'])){
				$subActionArr[] = array(
					'subAction' => 'download-queue-size',
					'caption' => 'Размер очереди загрузки',
					'sessionInfo' => 'download_queue_size'
				);
				$initial_value = 'true';
			}
			$subActionArr[] = array(
				'subAction' => 'download-queue-enabled',
				'caption' => 'Очередь загрузки',
				'initial_value' => $initial_value,
				'str' => true,
				'ops' => $ops
			);
			$initial_value = 'false';
			if (isset(Transmission::$sessionInfo['seed_queue_enabled'])){
				$subActionArr[] = array(
					'subAction' => 'seed-queue-size',
					'caption' => 'Размер очереди отдачи',
					'sessionInfo' => 'seed_queue_size'
				);
				$initial_value = 'true';
			}
			$subActionArr[] = array(
				'subAction' => 'seed-queue-enabled',
				'caption' => 'Очередь отдачи',
				'initial_value' => $initial_value,
				'str' => true,
				'ops' => $ops
			);
			foreach ($subActionArr as $k => $v){
				ControlFactory::add_vgap($defs, -10);
				$add_params['subAction'] = $v['subAction'];
				$add_params['initial_sel_ndx'] = $k;
				if (isset($v['ops'])){
					if (isset($v['str']))
						$add_params['str'] = 1;
					ControlFactory::add_combobox($defs, $this, $add_params,
						$v['subAction'], $v['caption'],
						$v['initial_value'], $v['ops'], 400, true, false
					);
				}else{
					if (isset($add_params['str']))
						unset($add_params['str']);
					ControlFactory::add_text_field(
						$defs, $this, $add_params,
						$v['subAction'], $v['caption'],
						Transmission::$sessionInfo[$v['sessionInfo']], 1, 0, 0, 0, 400, 1, 0
					);
				}
			}
			return ActionFactory::show_dialog('Transmission ' . self::getIp(), $defs, true, $width, $attrs);
		}
		if ((isset($user_input->action))&&($user_input->action == 'transmissionLogin')){
			$transmissionAccount = (HD::getItemsArr('transmissionAccount', true) != array()) ? HD::getItemsArr('transmissionAccount', true) : array('login' => 'Введите логин', 'pass' => 'Введите пароль');
			if ($transmissionAccount['login'] == '')
				$transmissionAccount['login'] = 'Введите логин';
			if ($transmissionAccount['pass'] == '')
				$transmissionAccount['pass'] = 'Введите пароль';
			if (isset($user_input->transmissionLogin)){
				$transmissionAccount['login'] = $user_input->transmissionLogin;
				$transmissionAccount['pass'] = $user_input->transmissionPass;
				HD::saveItemsArr('transmissionAccount', $transmissionAccount, true);
				$action = UserInputHandlerRegistry::create_action($this, $user_input->control_id);
				return ActionFactory::show_title_dialog('Логин и пароль Transmission', $action, ' Сохранены!');
			} 
			ControlFactory::add_text_field(
				$defs, $this, $add_params,
				'transmissionLogin', '',
				$transmissionAccount['login'], 0, 0, 0, 0, $width - 100, 0, 0
			);
			$q=1;
			if ($transmissionAccount['pass'] == 'Введите пароль')
				$q=0;
			ControlFactory::add_text_field(
				$defs, $this, $add_params,
				'transmissionPass', '',
				$transmissionAccount['pass'], 0, $q, 0, 0, $width - 100, 0, 0
			);
			$add_params['action']= 'transmissionLogin';
			ControlFactory::add_close_dialog_and_apply_button($defs, $this, $add_params, $user_input->control_id, 'Применить', 450);
			return ActionFactory::show_dialog('Логин и пароль Transmission', $defs, true, $width, $attrs);
		}
		if ((isset($user_input->action))&&($user_input->action == 'transmissionSearch')){
			$transmissionIp_ops = HD::isServerAvailable(null, '9091');
			if (count($transmissionIp_ops) > 0){
				ControlFactory::add_vgap($defs, -10);
				ControlFactory::add_smart_label($defs, "", 
						'<text size="small">Найдено: '. count($transmissionIp_ops) .'</text>'
					);
				ControlFactory::add_vgap($defs, -10);
				$add_params['control_id']= $user_input->control_id;
				$transmissionIp_ops[''] = "Выберите";
				ControlFactory::add_combobox($defs, $this, $add_params,
					'transmissionIp', '',
					'', $transmissionIp_ops, $width - 100, true, false
				);
				ControlFactory::add_vgap($defs, -10);
				ControlFactory::add_smart_label($defs, "", 
						'<text size="small">*Выберите нужный из списка если их несколько</text>'
					);
			}else{
				ControlFactory::add_multiline_label($defs, '', 'Запущенных Transmission в локальной сети не найденно, запустите Transmission на каком либо устройстве если же запущенный Transmission имеет не стандартный порт укажите "IP адрес:порт" вручную. ', 5);
				$gui_params['button_caption_centered'] = 1;
				$action = UserInputHandlerRegistry::create_action($this, $user_input->control_id);
				ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,'_do', 'Ok', 300, $action, $gui_params);
			}
			return ActionFactory::show_dialog('Запущенные Transmission в локальной сети', $defs, true, $width, $attrs);
		}
		
		if ((isset($user_input->transmissionIp))&&(isset($user_input->action_type))){
			if ((isset($user_input->transmissionHistoryIp))&&($user_input->transmissionHistoryIp != 'na'))
				$user_input->transmissionIp = $user_input->transmissionHistoryIp;
			if ($user_input->transmissionIp == 'Укажите IP адрес (:порт - необязательно)')
				$user_input->transmissionIp = '';
			$sArr = self::setTransmissionIp ($user_input->transmissionIp);
			if ($sArr['caption'] == 'Error!'){
				$actions = UserInputHandlerRegistry::create_action($this, $user_input->control_id);
				return ActionFactory::show_title_dialog($sArr['caption'], $actions, $sArr['descr'], $width);
			}
			$action = UserInputHandlerRegistry::create_action($this, $user_input->control_id);
			if ($user_input->action_type == 'confirm'){
				return ActionFactory::close_dialog_and_run($action);
			}else
				return $action;
		}
		if ($transmissionIp == ''){
			$transmissionIp = 'Укажите IP адрес (:порт - необязательно)';
			if (self::getInstallTransmission() == true){
				$ipDescr = 'Найден локальный Transmission нажмите Enter в адресной строке или у';
				$transmissionIp = 'http://127.0.0.1:9091';
			}else
				$ipDescr = 'Что бы использовать локальный Transmission установите Transmission или у';
			$ipDescr .= "кажите IP адрес устройства с Transmission:";
		}else
			$ipDescr = "IP адрес Transmission:";
		
		ControlFactory::add_vgap($defs, -10);
		ControlFactory::add_multiline_label($defs, '', $ipDescr, 5);
		ControlFactory::add_vgap($defs, -10);
		$add_params['control_id']= $user_input->control_id;
		ControlFactory::add_text_field(
			$defs, $this, $add_params,
			'transmissionIp', '',
			$transmissionIp, 0, 0, 0, 0, $width - 100, 1, 0
		);
		$transmissionHistory = HD::getItemsArr('transmissionHistory');
		if (count($transmissionHistory) > 0){
			$transmissionHistoryOps['na'] = 'Ранее использованные Transmission';
			foreach ($transmissionHistory as $k => $v)
				$transmissionHistoryOps[$k] = $k;
			$add_params['control_id']= $user_input->control_id;
			ControlFactory::add_vgap($defs, -10);
			ControlFactory::add_combobox($defs, $this, $add_params,
				'transmissionHistoryIp',
				'',
				'na', $transmissionHistoryOps,  $width - 100, true, false
			);
		}
		ControlFactory::add_vgap($defs, -10);
		$add_params_login['action']= 'transmissionLogin';
		ControlFactory::add_button_close(&$defs, $this, $add_params_login, $user_input->control_id, '', 'Логин и пароль Transmission', $width - 100);
		ControlFactory::add_vgap($defs, -10);
		ControlFactory::add_smart_label($defs, "", '<text size="tiny">*Логин и пароль Transmission задавать при необходимости</text>');
		ControlFactory::add_vgap($defs, -25);
		$add_params_search['action']= 'transmissionSearch';
		ControlFactory::add_button_close(&$defs, $this, $add_params_search, $user_input->control_id, '', 'Найти запущенные Transmission', $width - 100);
		if ($transmissionIp != 'Укажите IP адрес (:порт - необязательно)'){
			$tt ='';
			if ($slaveTransmission == true)
				$tt = '<icon width="48" height="48">'.DuneSystem::$properties['install_dir_path'].'/icons/s_dune_logo.png</icon><icon width="20" height="48">'.DuneSystem::$properties['install_dir_path'].'/icons/pixel.png</icon>';
			$duneTransmissionIp = (HD::getItemStr('duneTransmissionIp',true) !='') ? HD::getItemStr('duneTransmissionIp', true) : 0;
			if ($duneTransmissionIp == 2)
				$tt = '<icon width="48" height="48">'.DuneSystem::$properties['install_dir_path'].'/icons/s_android.png</icon><icon width="20" height="48">'.DuneSystem::$properties['install_dir_path'].'/icons/pixel.png</icon>';
			if ($cmd == true){
				ControlFactory::add_smart_label($defs, 
					"", 
					$tt . '<text color="10" size="normal">Transmission </text><icon width="115" height="25">'.DuneSystem::$properties['install_dir_path'].'/icons/online.png</icon>' 
				);
				$add_params['action']= 'setup';
				ControlFactory::add_button_close(&$defs, $this, $add_params, $user_input->control_id, '', 'Настройки Transmission Daemon', $width - 100);
				if ($slaveTransmission == true){
					$add_params['action']= 'stop';
					ControlFactory::add_button_close(&$defs, $this, $add_params, $user_input->control_id, '', 'Остановить Transmission', $width - 100);
				}
				if($user_input->parent_media_url == 'main_menu'){
					$add_params['action']= 'test';
					ControlFactory::add_button_close(&$defs, $this, $add_params, $user_input->control_id, '', 'Тест подключения', $width - 100);
					// ControlFactory::add_multiline_label($defs, '', 'Частота обновления списка торрентов и файлов', 5);
					// $delay_ms = (HD::getItemStr('delay_ms', true) !='') ? HD::getItemStr('delay_ms', true) : 1000;
					// $delay_ms_ops[1000] = '1 сек';
					// $delay_ms_ops[1500] = '1,5 сек (не рекомендуется)';
					// $delay_ms_ops[2000] = '2 сек (не рекомендуется)';
					// $delay_ms_ops[2500] = '2,5 сек (не рекомендуется)';
					// $delay_ms_ops[3000] = '3 сек (не рекомендуется)';
					// $add_params['action']= 'delay';
					// $add_params['initial_sel_ndx'] = 6;
					// ControlFactory::add_combobox($defs, $this, $add_params,
						// 'delay_ms', '',
						// $delay_ms, $delay_ms_ops, $width - 100, true, false
					// );
				}
			}else{
				ControlFactory::add_smart_label($defs, 
					"", 
					$tt . '<text color="8" size="normal">Transmission </text><icon width="115" height="25">'.DuneSystem::$properties['install_dir_path'].'/icons/offline.png</icon>'
				);
				if ($slaveTransmission == true){
					$add_params['action']= 'start';
					ControlFactory::add_button_close(&$defs, $this, $add_params, $user_input->control_id, '', 'Запустить Transmission', $width - 100);
				}
			}
			if ($transmissionIp == 'http://127.0.0.1:9091')
				ControlFactory::add_smart_label($defs, "", 
					'<text size="tiny">*127.0.0.1 локальный Transmission установленный на этом плеере</text>'
				);
		}
		return ActionFactory::show_dialog('Настройки Transmission', $defs, true, $width, $attrs);
	}
	public static function getPopUpMenuItems ($selected_media_url, $parent_media_url, $select_url = null){
		
		if (isset($selected_media_url->movie_id)){
			$s = "";
			if ($select_url==true){
				foreach ($select_url as $v){
					$media_url = MediaURL::decode($v);
					if (isset($media_url->movie_id))
						$idArr[] = $media_url->movie_id;
					$c = count ($idArr);
					$s = " (выделенно $c)";
				}
			}else
				$idArr[] = $selected_media_url->movie_id;
			$jIdArr = json_encode($idArr);
			$menu_items[] = array(
				'caption' => 'Удалить торрент' . $s,
				'params' => array ('action' => 'transmissionActionRem', 'ids' => $jIdArr),
				'icon_url' => 'plugin_file://icons/s_delete.png'
			);
			$menu_items[] = array(
				'caption' => 'Удалить торрент и файлы' . $s,
				'params' => array ('action' => 'transmissionActionRem', 'ids' => $jIdArr, 'delete_local_data' => true),
				'icon_url' => 'plugin_file://icons/s_delete.png'
			);
			$menu_items[] = 'is_separator';
			$menu_items[] = array(
					'caption' => 'Остановить торрент' . $s,
					'params' => array ('action' => 'transmissionActionStartStop', 'rpcAction' => 'stop', 'ids' => $jIdArr),
					'icon_url' => 'plugin_file://icons/s_stop.png'
				);
			$menu_items[] = array(
					'caption' => 'Остановить все торренты',
					'params' => array ('action' => 'transmissionActionStartStop', 'rpcAction' => 'stop', 'ids' => 'all'),
					'icon_url' => 'plugin_file://icons/s_stop.png'
				);
			$menu_items[] = 'is_separator';
			$menu_items[] = array(
				'caption' => 'Запустить торрент' . $s,
				'params' => array ('action' => 'transmissionActionStartStop', 'rpcAction' => 'start', 'ids' => $jIdArr),
				'icon_url' => 'plugin_file://icons/s_start.png'
				);
			$menu_items[] = array(
					'caption' => 'Запустить принудительно' . $s,
					'params' => array ('action' => 'transmissionActionStartStop', 'rpcAction' => 'start_now', 'ids' => $jIdArr),
					'icon_url' => 'plugin_file://icons/s_start_now.png'
				);
			$menu_items[] = array(
				'caption' => 'Запустить все торренты',
				'params' => array ('action' => 'transmissionActionStartStop', 'rpcAction' => 'start', 'ids' => 'all'),
				'icon_url' => 'plugin_file://icons/s_start.png'
				);
			$menu_items[] = 'is_separator';
			$menu_items[] = array(
					'caption' => 'Проверить торрент' . $s,
					'params' => array ('action' => 'transmissionRpcActionExec', 'rpcAction' => 'verify', 'ids' => $jIdArr),
					'icon_url' => 'plugin_file://icons/s_verify.png'
				);
			$menu_items[] = 'is_separator';
			$menu_items[] = array(
					'caption' => 'Анонсировать ' . $s,
					'params' => array ('action' => 'transmissionRpcActionExec', 'rpcAction' => 'reannounce', 'ids' => $jIdArr),
					'icon_url' => 'plugin_file://icons/s_reannounce.png'
				);
			$menu_items[] = 'is_separator';
			
		}
		if (isset($selected_media_url->id)){
			$s = '';
			if ($select_url==true){
				foreach ($select_url as $v){
					$media_url = MediaURL::decode($v);
					if (isset($media_url->id))
						$idArr[] = $media_url->id;
					$s = ' (выделенно '.count ($idArr).')';
				}
			}
			if ($selected_media_url->data->wanted == 1){
				$caption = 'Остановить закачку этого файла' . $s;
				$icon_url = 'plugin_file://icons/s_stop.png';
			}else{
				$caption = 'Запустить закачку этого файла' . $s;
				$icon_url = 'plugin_file://icons/s_start.png';
			}
			$menu_items[] = array(
				'caption' => $caption,
				'params' => array ('action' => 'transmissionActionFileStartStop'),
				'icon_url' => $icon_url
			);
			$menu_items[] = 'is_separator';
			$menu_items[] = array(
				'caption' => 'Остановить закачку всех файлов',
				'params' => array ('action' => 'transmissionActionFileStartStop', 'setAction' => 'files-unwanted', 'ids' => 'all'),
				'icon_url' => 'plugin_file://icons/s_stop.png'
			);
			$menu_items[] = array(
				'caption' => 'Запустить закачку всех файлов',
				'params' => array ('action' => 'transmissionActionFileStartStop', 'setAction' => 'files-wanted', 'ids' => 'all'),
				'icon_url' => 'plugin_file://icons/s_start.png'
			);
			$menu_items[] = 'is_separator';
			$jIdArr2 = json_encode(array($selected_media_url->data->movie_id));
			$menu_items[] = array(
				'caption' => 'Удалить торрент',
				'params' => array ('action' => 'transmissionActionRem', 'ids' => $jIdArr2),
				'icon_url' => 'plugin_file://icons/s_delete.png'
			);
			$menu_items[] = array(
				'caption' => 'Удалить торрент и файлы',
				'params' => array ('action' => 'transmissionActionRem', 'ids' => $jIdArr2, 'delete_local_data' => true),
				'icon_url' => 'plugin_file://icons/s_delete.png'
			);
			$menu_items[] = 'is_separator';
			$menu_items[] = array(
				'caption' => 'Высокий приоритет' . $s,
				'params' => array ('action' => 'transmissionActionPriority', 'setAction' => 'priority-high'),
				'icon_url' => 'plugin_file://icons/s_file2.png'
			);
			$menu_items[] = array(
				'caption' => 'Нормальный приоритет' . $s,
				'params' => array ('action' => 'transmissionActionPriority', 'setAction' => 'priority-normal'),
				'icon_url' => 'plugin_file://icons/s_file4.png'
			);
			$menu_items[] = array(
				'caption' => 'Низкий приоритет' . $s,
				'params' => array ('action' => 'transmissionActionPriority', 'setAction' => 'priority-low'),
				'icon_url' => 'plugin_file://icons/s_file3.png'
			);
			$menu_items[] = 'is_separator';
			$menu_items[] = array(
				'caption' => 'Высокий приоритет для всех файлов',
				'params' => array ('action' => 'transmissionActionPriority', 'setAction' => 'priority-high', 'ids' => 'all'),
				'icon_url' => 'plugin_file://icons/s_file2.png'
			);
			$menu_items[] = array(
				'caption' => 'Нормальный приоритет для всех файлов',
				'params' => array ('action' => 'transmissionActionPriority', 'setAction' => 'priority-normal', 'ids' => 'all'),
				'icon_url' => 'plugin_file://icons/s_file4.png'
			);
			$menu_items[] = array(
				'caption' => 'Низкий приоритет для всех файлов',
				'params' => array ('action' => 'transmissionActionPriority', 'setAction' => 'priority-low', 'ids' => 'all'),
				'icon_url' => 'plugin_file://icons/s_file3.png'
			);
		}
		if (isset($selected_media_url->playback_url)){
			
			$menu_items[] = array(
				'caption' => 'Большие файлы в начало списка',
				'params' => array ('action' => 'gbSortFolders'),
				'icon_url' => 'plugin_file://icons/s_gbSortFolders.png'
			);
		}
		$menu_items[] = 'is_separator';
		$path_parts1 = null;
		if (TransmissionUPnP::getIp() != '')
			$path_parts1['host'] = parse_url(TransmissionUPnP::getIp());
		$path_parts2 = parse_url(self::getIp());
		
		if ($path_parts1['host'] == $path_parts2['host'])
			$menu_items[] = array(
				'caption' => 'Перейти в Transmission BTC UPnP',
				'params' => array ('action' => 'screenTransmissionUPnP'),
				'icon_url' => 'plugin_file://icons/s_transmissionupnp.png'
			);
		
		$menu_items[] = array(
			'caption' => 'Настройки Transmission',
			'params' =>  'classSetup',
			'icon_url' => 'plugin_file://icons/s_transmission.png'
		);
		if (isset($selected_media_url->movie_id)){
			$menu_items[] = 'is_separator';
			$menu_items[] = array(
				'caption' => 'Информация о закачке (Info)',
				'params' =>  'info',
				'icon_url' => 'plugin_file://icons/s_info.png'
			);
		}
		if (VodTransmissionScreen::$sort == 0){
			if (isset($selected_media_url->movie_id)){
				if ($select_url==true){
					foreach ($select_url as $v){
						$media_url = MediaURL::decode($v);
						if (isset($media_url->movie_id))
							$idArr[] = $media_url->movie_id;
						$s = ' (выделенно '.count ($idArr).')';
					}
				}else
					$idArr[] = $selected_media_url->movie_id;
				$idArr2[] = $selected_media_url->movie_id;
				$jIdArr = json_encode($idArr);
				$jIdArr2 = json_encode($idArr2);
				$menu_items[] = 'is_separator';
				$menu_items[] = array(
					'caption' => 'Сдвинуть в начало',
					'params' => array ('action' => 'transmissionActionQueue', 'rpcAction' => 'queue_move_top', 'ids' => $jIdArr2),
					'icon_url' => 'plugin_file://icons/s_queue_move_top.png'
				);
				$menu_items[] = array(
					'caption' => 'Сдвинуть вверх' . $s,
					'params' => array ('action' => 'transmissionActionQueue', 'rpcAction' => 'queue_move_up', 'ids' => $jIdArr),
					'icon_url' => 'plugin_file://icons/s_queue_move_up.png'
				);
				$menu_items[] = 'is_separator';
				$menu_items[] = array(
					'caption' => 'Сдвинуть вниз' . $s,
					'params' => array ('action' => 'transmissionActionQueue', 'rpcAction' => 'queue_move_down', 'ids' => $jIdArr),
					'icon_url' => 'plugin_file://icons/s_queue_move_down.png'
				);
				$menu_items[] = array(
					'caption' => 'Сдвинуть в конец',
					'params' => array ('action' => 'transmissionActionQueue', 'rpcAction' => 'queue_move_bottom', 'ids' => $jIdArr2),
					'icon_url' => 'plugin_file://icons/s_queue_move_bottom.png'
				);
			}
		}
		return $menu_items;
	}
	public static function getStats(){
		$cmd = 'action=sstats transmissionIp=' . self::getIp();
		if (($transmissionAccount['login'] != '')&&($transmissionAccount['pass'] != ''))
			$cmd .= " login=". urlencode($transmissionAccount['login']) ." pass=" . urlencode($transmissionAccount['pass']);
		$result = HD::do_cmd('transmissionActions', $cmd);
		if ($result == true)
			return json_decode($result);
		return false;
	}
	public static function getStatusString ($intstatus){
		self::transmissionRpcAction();
		return self::$transmissionRPC->getStatusString($intstatus);
	}
	
	public function transmissionActionAddTorrent($user_input){
		hd_restore_warnings();
		if (!isset($user_input->counter))
			HD::asyncExec('proc_close');
		$add_params = null;
		if (isset($user_input->action))
			$add_params['action'] = $user_input->action;
		if (isset($user_input->indiClass))
			$add_params['indiClass'] = $user_input->indiClass;
		$selected_media_url = MediaURL::decode($user_input->selected_media_url);
		if ((!isset($selected_media_url->tType ))||($selected_media_url->tType == 'torrent'))
			$torrent_location = 'http://'.HD::get_ip_address().'/temp.torrent';
		if (isset($user_input->torrentPath))
			$add_params['torrentPath'] = $torrent_location = $user_input->torrentPath;
		$cmdAsyncExec = DuneSystem::$properties['install_dir_path'] . '/www/cgi-bin/php-cgi -f ' .  DuneSystem::$properties['install_dir_path'] . "/www/cgi-bin/transmissionActions.php action=add_file torrent_location=\"$torrent_location\" transmissionIp=" . self::getIp();
		if (isset($user_input->filesUnwantedArr)){
			$add_params['filesUnwantedArr'] = $user_input->filesUnwantedArr;
			$filesUnwantedArr = json_decode($user_input->filesUnwantedArr, true);
			if (count($filesUnwantedArr) > 0)
				$cmdAsyncExec .= " extra_options=". urlencode($user_input->filesUnwantedArr);
		}
		if (isset($user_input->paused)){
			$cmdAsyncExec .= " paused=1";
			$add_params['paused'] = $user_input->paused;
		}
		$transmissionAccount = (HD::getItemsArr('transmissionAccount', true) != array()) ? HD::getItemsArr('transmissionAccount', true) : array('login' => '', 'pass' => '');
		if (($transmissionAccount['login'] != '')&&($transmissionAccount['pass'] != ''))
			$cmdAsyncExec .= " login=". urlencode($transmissionAccount['login']) ." pass=" . urlencode($transmissionAccount['pass']);
		$result = HD::asyncExec($cmdAsyncExec);
		if ($result != ''){
			$result = json_decode ($result);
			if (isset($result->arguments->torrent_added->hashString)){
				$add_params['torrent_added'] = $result->arguments->torrent_added->hashString;
				$add_params['torrent_added_name'] = $result->arguments->torrent_added->name;
				$add_params['torrent_id'] = $result->arguments->torrent_added->id;
			}else
				return ActionFactory::show_title_dialog("Добавление не удалось", null, $result->result);
		}
		$counter = 1;
		if (isset($user_input->counter))
			$counter = $user_input->counter + 1;
		$add_params['counter'] = $counter;
		$action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $add_params);
		$attrs['timer'] = ActionFactory::timer(1000);
		$attrs['actions'] = array(GUI_EVENT_TIMER => ActionFactory::close_dialog_and_run($action));
		ControlFactory::add_label($defs, '', "Прошло : " . HD::sec_format_duration($counter));
		return  ActionFactory::show_dialog('Добавление торрента', $defs, true, 0, $attrs);
	}
	
	public function transmissionActionGetTorrentInfo($user_input){
		hd_restore_warnings();
		$filesUnwantedArr = array();
		if (isset($user_input->filesUnwantedArr)){
			$filesUnwantedArr = json_decode($user_input->filesUnwantedArr, true);
		}
		$content = array_values(array_flip (self::$torrent->content()));
		if (count($content) == 0)
			return ActionFactory::show_title_dialog('Err!', null, "Этот файл не является торрент файлом. Возможно произошла ошибка при загрузке торрент файла.", 800);
		if (isset($user_input->filesUnwanted)){
			if ($user_input->filesUnwanted == 'files_unwanted')
				$filesUnwantedArr[$user_input->files_id] = $user_input->files_id;
			if ($user_input->filesUnwanted == 'files_wanted')
				if (isset($filesUnwantedArr[$user_input->files_id]))
					unset($filesUnwantedArr[$user_input->files_id]);
			if ($user_input->filesUnwanted == 'all'){
				if (count($filesUnwantedArr) == 0){
					foreach ($content as $k => $v)
						$filesUnwantedArr[$k + 1] = $k;
				}else
					$filesUnwantedArr = array();
			}
			if ($user_input->filesUnwanted == 'reverse'){
				if (isset($user_input->reverse))
					unset($user_input->reverse);
				else
					$user_input->reverse = $add_params['reverse'] = 1;
			}
		}
					
		$attrs['initial_sel_ndx'] = isset($user_input->initial_sel_ndx) ? $user_input->initial_sel_ndx : -1;
		$width = 1350;
		$add_params['filesUnwantedArr'] = json_encode($filesUnwantedArr);
		$name = self::$torrent->name();
		ControlFactory::add_vgap($defs, (-15));
		ControlFactory::add_smart_label($defs, 
			"", 
			'<icon width="30" height="30">gui_skin://special_icons/controls_button_red.aai</icon><text color="15" size="small"> Не загружаюся все  </text>
			<icon width="30" height="30">gui_skin://special_icons/controls_button_green.aai</icon><text color="15" size="small"> Перевернуть список</text>'
		);
		ControlFactory::add_smart_label($defs, 
			"", 
			'<icon width="40" height="40">'.DuneSystem::$properties['install_dir_path'].'/icons/s_torrent.png</icon><text color="14" size="normal"> '.$name.'</text>'
		);
		if ($user_input->handler_id == 'file_list'){
			ControlFactory::add_close_dialog_and_apply_button($defs, $this, $add_params, 'addTransmissionTorrent', 'Загрузить торрент', 450);
			$add_params['paused'] = true;
			ControlFactory::add_close_dialog_and_apply_button($defs, $this, $add_params, 'addTransmissionTorrent', 'Добавить торрент', 450);
		}else{
			$add_params['action'] = 'addTransmissionTorrent';
			$add_params['indiClass'] = 'Transmission';
			ControlFactory::add_close_dialog_and_apply_button($defs, $this, $add_params, 'classAction', 'Загрузить торрент', 450);
			$add_params['paused'] = true;
			ControlFactory::add_close_dialog_and_apply_button($defs, $this, $add_params, 'classAction', 'Добавить торрент', 450);
		}
		if (isset($user_input->reverse)){
			$content = array_reverse($content, true);
			$add_params['reverse'] = 1;
		}
		$i = 1;
		foreach ($content as $k => $v){
			$path_parts = pathinfo($v);
			if (isset($filesUnwantedArr[$k + 1])){
				$add_params['filesUnwanted'] = 'files_wanted';
				$caption = 'Не загружается';
				$color = 17;
			}else{
				$add_params['filesUnwanted'] = 'files_unwanted';
				$caption = 'Загружается';
				$color = 15;
			}
			$add_params['files_id'] = $k + 1;
			ControlFactory::add_smart_label($defs, 
				"", 
				'<gap width="300"/><text color="'.$color.'" size="small"> '.$path_parts['basename'].'</text>'
			);
			$add_params['initial_sel_ndx'] = $i + 1;
			ControlFactory::add_vgap($defs, (-70));
			ControlFactory::add_close_dialog_and_apply_button($defs, $this, $add_params, $user_input->control_id, $caption, 350);
			$i++;
		}
		$add_params['initial_sel_ndx'] = -1;
		$add_params['filesUnwanted'] = 'all';
		$action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $add_params);
		$attrs['actions'][GUI_EVENT_KEY_A_RED]	= ActionFactory::close_dialog_and_run($action);
		$add_params['filesUnwanted'] = 'reverse';
		$action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $add_params);
		$attrs['actions'][GUI_EVENT_KEY_B_GREEN] = ActionFactory::close_dialog_and_run($action);
		return ActionFactory::show_dialog('Добавить торрент в Transmission', $defs, true, $width, $attrs);
	}
	
	public static function transmissionActionSaveTorrentFile($filepath=null, $torrentFileStr=null){
		if ($filepath==true)
			$torrentFileStr = file_get_contents ($filepath);
		
		if (file_put_contents ('/tmp/www/temp.torrent', $torrentFileStr) !== false){
			self::$torrent = new Torrent('/tmp/www/temp.torrent');
			if ('temp.torrent' != self::$torrent->name())
				return array("status" => true);
			else
				return array("status" =>  false, "msg"=>"Сохраненный файл не является торрент файлом. Возможно произошла ошибка при загрузке торрент файла.");
		}else
			return array("status" => false, "msg" => "Сохранение не удалось");
	}
	
	public static function transmissionRpcAction (){
		if (self::$transmissionRPC == false){
			$transmissionAccount = (HD::getItemsArr('transmissionAccount', true) != array()) ? HD::getItemsArr('transmissionAccount', true) : array('login' => '', 'pass' => '');
			$login=$pass=null;
			if ($transmissionAccount['login'] != '')
				$login=$transmissionAccount['login'];
			if ($transmissionAccount['pass'] != '')
				$pass=$transmissionAccount['pass'];
			self::$transmissionRPC = new TransmissionRPC(self::getIp() . "/transmission/rpc", $login, $pass);
		}
	}
	
	public function classAction ($defs, $user_input, $select_url = null){
	
		hd_restore_warnings();
		$caption = 'Error!';
		$msg = 'classAction: action';
		$post_action = null;
		$selected_media_url = (object)array();
		$parent_media_url = MediaURL::decode($user_input->parent_media_url);
		if ($user_input->action == 'addTransmissionTorrent'){
			$selected_media_url = MediaURL::decode($user_input->selected_media_url);
			if (isset($user_input->goToScreen)){
				if (!isset($selected_media_url->movie_id))
					return ActionFactory::invalidate_folders(array($user_input->parent_media_url));
				$arr['movie_id'] = $user_input->torrent_id;
				$arr['data']['caption'] = $selected_media_url->caption;
				$arr['data']['poster_url'] =  $selected_media_url->poster_url;
				$arr['data']['description'] = $selected_media_url->description;
				$arr['data']['hashString'] = $user_input->hash;
				$arr['data']['key'] = $user_input->torrent_id;
				$mUrl = VodTransmissionScreen::get_media_url_str('Transmission', $arr);
				return ActionFactory::open_folder($mUrl, $selected_media_url->caption);	
			}
			if (isset($user_input->torrent_added)){
				ControlFactory::add_multiline_label($defs, '', $user_input->torrent_added_name, 15);
				$add_params['goToScreen'] = 1;
				$add_params['action'] = $user_input->action;
				$add_params['indiClass'] = 'Transmission';
				$add_params['hash'] = $user_input->torrent_added;
				$add_params['torrent_id'] = $user_input->torrent_id;
				ControlFactory::add_close_dialog_and_apply_button($defs, $this, $add_params, $user_input->control_id, 'В Transmission', 450);
				ControlFactory::add_close_dialog_button($defs,'Ok', 450);
				return  ActionFactory::show_dialog('.torrent добавлен', $defs, true, 1000);
			}
			hd_silence_warnings();
			return Transmission::transmissionActionAddTorrent($user_input);
		}
		if ($user_input->control_id == 'classAction')
			unset ($user_input->control_id);
		if ($user_input->action == 'setupTransmission'){
			$defs = array();
			hd_silence_warnings();
			return Transmission::setupTransmission($defs, $user_input);
		}
		if ($user_input->action == 'sort'){
			$sort = (HD::getItemStr('sort', true) !='') ? HD::getItemStr('sort', true) : 0;
			$sort = $sort + 1;
			if ($sort == 3)
				$sort = 0;
			HD::saveItemStr('sort', $sort, true);
			$action = ActionFactory::invalidate_folders(array($user_input->parent_media_url));
			$actions = $this->get_action_map($parent_media_url);
			return  ActionFactory::change_behaviour($actions, 1000, $action);
		}
		if ($user_input->action == 'transmissionActionRem'){
			$selected_media_url = MediaURL::decode($user_input->selected_media_url);
			if (isset($user_input->ids)){
				$delete_local_data = 0;
				if (isset($user_input->delete_local_data))
					$delete_local_data = 1;
				$cmdAsyncExec = DuneSystem::$properties['install_dir_path'] . '/www/cgi-bin/php-cgi -f ' .  DuneSystem::$properties['install_dir_path'] . "/www/cgi-bin/transmissionActions.php action=remove ids=".$user_input->ids." delete_local_data=".$delete_local_data." transmissionIp=" . self::getIp();
				$transmissionAccount = (HD::getItemsArr('transmissionAccount', true) != array()) ? HD::getItemsArr('transmissionAccount', true) : array('login' => '', 'pass' => '');
				if (($transmissionAccount['login'] != '')&&($transmissionAccount['pass'] != ''))
					$cmdAsyncExec .= " login=". urlencode($transmissionAccount['login']) ." pass=" . urlencode($transmissionAccount['pass']);
				$str = HD::asyncExec($cmdAsyncExec);
				if ($str != ''){
					Transmission::actionGetTorrentList();
					if (isset($parent_media_url->movie_id)){
						$action = ActionFactory::invalidate_folders(array($user_input->parent_media_url));
						return ActionFactory::replace_path(1, null, $action);
					}
					return ActionFactory::show_title_dialog('Удалено', null, 'Результат удаления может отобразится не сразу', 650);
				}else{
					if (isset($user_input->counter))
						$counter = $user_input->counter + 1;
					else
						$counter = 1;
					$params['counter'] = $counter;
					$params['action'] = 'transmissionActionRem';
					$params['ids'] = $user_input->ids;
					if (isset($user_input->delete_local_data))
						$params['delete_local_data'] = $user_input->delete_local_data;
					$action = UserInputHandlerRegistry::create_action($this, 'classAction', $params);
					$attrs['timer'] = ActionFactory::timer(1000);
					$attrs['actions'] = array(GUI_EVENT_TIMER => ActionFactory::close_dialog_and_run($action));
					ControlFactory::add_label($defs, '', "Прошло : " . HD::sec_format_duration($params['counter']));
					return  ActionFactory::show_dialog('Удаление', $defs, true, 0, $attrs);
				}
			}else
				return ActionFactory::show_title_dialog('Err!');
		}
		if ($user_input->action == 'transmissionRpcActionExec'){
			$selected_media_url = MediaURL::decode($user_input->selected_media_url);
			if (isset($user_input->ids)){
				self::transmissionRpcAction();
				foreach (json_decode ($user_input->ids) as $v)
					$ids[] = intval($v);
				
				$rpcAction = $user_input->rpcAction;
				$result = self::$transmissionRPC->$rpcAction($ids);
				if ($result->result == 'success'){
					$msg = ''; $w = 0;
					if ($user_input->rpcAction != 'reannounce'){
						$msg = 'Результат выполнения может отобразится не сразу';
						$w = 650;
					}
					return ActionFactory::show_title_dialog('Выполнено', null, $msg, $w);
				}
				return ActionFactory::show_title_dialog('Err!', $post_action=null, 'Выполнение не удалось', 0);
			}
		}
		if ($user_input->action == 'transmissionActionPriority'){
			$s = '';
			$selected_media_url = MediaURL::decode($user_input->selected_media_url);
			
			if (isset($selected_media_url->data->movie_id))
				$ids[] = intval($selected_media_url->data->movie_id);
			if (isset($user_input->setAction)){
				if (isset($user_input->ids)){
					if ($user_input->ids == 'all')
						foreach ($this->torrentItemsArr as $v)
							$arguments[$user_input->setAction][] = intval($v);
					else
						foreach (json_decode ($user_input->ids) as $v)
							$arguments[$user_input->setAction][] = intval($v);
				}else if ($select_url==true){
					foreach ($select_url as $v){
						$media_url = MediaURL::decode($v);
						if (isset($media_url->id)){
							$arguments[$user_input->setAction][] = intval($media_url->id);
						}
					}
				}else
					$arguments[$user_input->setAction][] = intval($selected_media_url->id);

				self::transmissionRpcAction();
				$result = self::$transmissionRPC->set($ids, $arguments);
				if ($result->result == 'success')
					return ActionFactory::show_title_dialog('Выполнено', null, 'Результат выполнения может отобразится не сразу', 650);
				return ActionFactory::show_title_dialog('Err!', $post_action=null, 'Выполнение не удалось', 0);
			}

			if (isset($selected_media_url->id)){
				if ($select_url==true){
					foreach ($select_url as $v){
						$media_url = MediaURL::decode($v);
						if (isset($media_url->id))
							$idArr[] = $media_url->id;
						$s = ' (выделенно '.count ($idArr).')';
					}
				}else
					$idArr[] = $selected_media_url->id;
				$jIdArr = json_encode($idArr);
				$menu_items[] = array(
					'caption' => 'Высокий приоритет' . $s,
					'params' => array ('action' => $user_input->action, 'setAction' => 'priority-high', 'ids' => $jIdArr),
					'icon_url' => 'plugin_file://icons/s_file2.png'
				);
				$menu_items[] = array(
					'caption' => 'Нормальный приоритет' . $s,
					'params' => array ('action' => $user_input->action, 'setAction' => 'priority-normal', 'ids' => $jIdArr),
					'icon_url' => 'plugin_file://icons/s_file4.png'
				);
				$menu_items[] = array(
					'caption' => 'Низкий приоритет' . $s,
					'params' => array ('action' => $user_input->action, 'setAction' => 'priority-low', 'ids' => $jIdArr),
					'icon_url' => 'plugin_file://icons/s_file3.png'
				);
				$menu_items[] = 'is_separator';
				foreach ($menu_items as $v){
					if ($v == 'is_separator')
						$m_i [] =  array(
						GuiMenuItemDef::is_separator => true,);
					else
						$m_i[] = array(
							GuiMenuItemDef::caption => $v['caption'],
							GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'classAction', $v['params']),
							GuiMenuItemDef::icon_url => $v['icon_url'],
						);
				}
				$m_i[] = array(
					GuiMenuItemDef::caption => 'Выделить (Select)',
					GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'select'),
					GuiMenuItemDef::icon_url => 'plugin_file://icons/s_select.png',
				);
				$m_i[] = array(
					GuiMenuItemDef::caption => 'Снять выделение (Clear)',
					GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'unselect'),
					GuiMenuItemDef::icon_url => 'plugin_file://icons/s_unselect.png',
				);
				return ActionFactory::show_popup_menu($m_i);
			}else
				return ActionFactory::show_title_dialog('Err!');
		}
		if ($user_input->action == 'transmissionActionFileStartStop'){
			$s = '';
			$selected_media_url = MediaURL::decode($user_input->selected_media_url);
			
			if (isset($selected_media_url->data->movie_id))
				$ids[] = intval($selected_media_url->data->movie_id);
				
			if ($select_url==true){
				foreach ($select_url as $v){
					$media_url = MediaURL::decode($v);
					if (isset($media_url->id)){
						if ($media_url->data->wanted == 1)
							$cmd = 'files-unwanted';
						else
							$cmd = 'files-wanted';
						$arguments[$cmd][] = intval($media_url->id);
					}
				}
			}else if ((isset($user_input->ids))&&($user_input->ids == 'all')){
				$cmd = $user_input->setAction;
				foreach ($this->torrentItemsArr as $v)
					$arguments[$cmd][] = intval($v);
				
			}else{
				if ($selected_media_url->data->wanted == 1)
					$cmd = 'files-unwanted';
				else
					$cmd = 'files-wanted';
				$arguments[$cmd][] = intval($selected_media_url->id);
			}
			self::transmissionRpcAction();
			$result = self::$transmissionRPC->set($ids, $arguments);
			if ($result->result == 'success')
				return ActionFactory::show_title_dialog('Выполнено', null, 'Результат выполнения может отобразится не сразу', 650);
			return ActionFactory::show_title_dialog('Err!', $post_action=null, 'Выполнение не удалось', 0);
			
		}
		if ($user_input->action == 'transmissionActionStartStop'){
			$s = '';
			$selected_media_url = MediaURL::decode($user_input->selected_media_url);
			if (isset($user_input->ids)){
				self::transmissionRpcAction();
				if ($user_input->ids == 'all'){
					foreach ($this->torrentArr as $v)
						$ids[] = intval($v);
				}else
					foreach (json_decode ($user_input->ids) as $v)
						$ids[] = intval($v);
				
				$rpcAction = $user_input->rpcAction;
				$result = self::$transmissionRPC->$rpcAction($ids);
				if ($result->result == 'success')
					return ActionFactory::show_title_dialog('Выполнено', null, 'Результат выполнения может отобразится не сразу', 650);
				return ActionFactory::show_title_dialog('Err!', $post_action=null, 'Выполнение не удалось', 0);
			}
			if (isset($selected_media_url->movie_id)){
				if ($select_url==true){
					foreach ($select_url as $v){
						$media_url = MediaURL::decode($v);
						if (isset($media_url->movie_id))
							$idArr[] = $media_url->movie_id;
						$s = ' (выделенно '.count ($idArr).')';
					}
				}else
					$idArr[] = $selected_media_url->movie_id;
				$jIdArr = json_encode($idArr);
				$menu_items[] = array(
					'caption' => 'Остановить торрент' . $s,
					'params' => array ('action' => $user_input->action, 'rpcAction' => 'stop', 'ids' => $jIdArr),
					'icon_url' => 'plugin_file://icons/s_stop.png'
				);
				$menu_items[] = array(
					'caption' => 'Остановить все торренты',
					'params' => array ('action' => $user_input->action, 'rpcAction' => 'stop', 'ids' => 'all'),
					'icon_url' => 'plugin_file://icons/s_stop.png'
				);
				$menu_items[] = 'is_separator';
				if (isset(self::$sessionInfo['version'])){
					$caption = 'Использовать альтернативные скорости';
					$rpcAction = 'true';
					$icon_url = 'plugin_file://icons/s_tortuga.png';
					if (isset(self::$sessionInfo['alt_speed_enabled'])){
						$caption = 'Не использовать альтернативные скорости';
						$rpcAction = 'false';
						$icon_url = 'plugin_file://icons/s_tortugas.png';
					}
					$menu_items[] = array(
						'caption' => $caption,
						'params' => array ('action' => 'transmissionAltSpeedEnabled', 'rpcAction' => $rpcAction),
						'icon_url' => $icon_url
					);
					$menu_items[] = 'is_separator';
				}
				$menu_items[] = array(
					'caption' => 'Запустить торрент' . $s,
					'params' => array ('action' => $user_input->action, 'rpcAction' => 'start', 'ids' => $jIdArr),
					'icon_url' => 'plugin_file://icons/s_start.png'
				);
				$menu_items[] = array(
					'caption' => 'Запустить все торренты',
					'params' => array ('action' => $user_input->action, 'rpcAction' => 'start', 'ids' => 'all'),
					'icon_url' => 'plugin_file://icons/s_start.png'
				);
				$menu_items[] = 'is_separator';
				
				foreach ($menu_items as $v){
					if ($v == 'is_separator')
						$m_i [] =  array(
						GuiMenuItemDef::is_separator => true,);
					else
						$m_i[] = array(
							GuiMenuItemDef::caption => $v['caption'],
							GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'classAction', $v['params']),
							GuiMenuItemDef::icon_url => $v['icon_url'],
						);
				}
				$m_i[] = array(
					GuiMenuItemDef::caption => 'Выделить (Select)',
					GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'select'),
					GuiMenuItemDef::icon_url => 'plugin_file://icons/s_select.png',
				);
				$m_i[] = array(
					GuiMenuItemDef::caption => 'Снять выделение (Clear)',
					GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'unselect'),
					GuiMenuItemDef::icon_url => 'plugin_file://icons/s_unselect.png',
				);
				return ActionFactory::show_popup_menu($m_i);
			}else
				return ActionFactory::show_title_dialog('Err!');
		}
		if ($user_input->action == 'transmissionAltSpeedEnabled'){
			self::transmissionRpcAction();
			$arguments['alt-speed-enabled'] = $user_input->rpcAction;
			$result = self::$transmissionRPC->sset($arguments);
			if ($result->result == 'success'){
				if (isset(self::$sessionInfo['alt_speed_enabled']))
					unset (self::$sessionInfo['alt_speed_enabled']);
				else
					self::$sessionInfo['alt_speed_enabled'] = 1;
				Transmission::actionGetSessionInfo();
				return ActionFactory::show_title_dialog('Выполнено', null, 'Результат выполнения может отобразится не сразу', 650);
			}
			return ActionFactory::show_title_dialog('Err!', $post_action=null, 'Выполнение не удалось', 0);
		}
		if ($user_input->action == 'transmissionActionQueue'){
			$s = ''; $post_action=null;
			$selected_media_url = MediaURL::decode($user_input->selected_media_url);
			if (isset($user_input->ids)){
				self::transmissionRpcAction();
				foreach (json_decode ($user_input->ids) as $v)
						$ids[] = intval($v);
				$rpcAction = $user_input->rpcAction;
				$result = self::$transmissionRPC->$rpcAction($ids);
				if ($result->result == 'success')
					return ActionFactory::show_title_dialog('Выполнено', null, 'Результат выполнения может отобразится не сразу', 650);
				return ActionFactory::show_title_dialog('Err!', $post_action=null, 'Выполнение не удалось', 0);
			}
			
		}
		if ($user_input->action == 'screenTransmissionUPnP')
			return ActionFactory::open_folder(VodSeriesListScreen::get_media_url_str('TransmissionUPnP'), 'Transmission UPnP');
		
		return ActionFactory::show_title_dialog($caption, $post_action, $msg, 0);
	}
	public static function load_movie($movie_id, $mUrl, $getMovieInfo){
		if (isset(self::$transmissionItems[$movie_id]))
			return self::$transmissionItems[$movie_id];
		else
			return false;
	}
	public static function set_movie($movie_id, $obj){
		self::$transmissionItems[$movie_id] = (array)$obj;
	}
	public static function actionGetSessionInfo(){
		$cmd = 'action=sget transmissionIp=' . self::getIp();
		$transmissionAccount = (HD::getItemsArr('transmissionAccount', true) != array()) ? HD::getItemsArr('transmissionAccount', true) : array('login' => '', 'pass' => '');
		if (($transmissionAccount['login'] != '')&&($transmissionAccount['pass'] != ''))
			$cmd .= " login=". urlencode($transmissionAccount['login']) ." pass=" . urlencode($transmissionAccount['pass']);
		$result = HD::do_cmd('transmissionActions', $cmd);
		if ($result == true){
			$jsd = json_decode($result,true);
			if (isset($jsd['arguments']))
				self::$sessionInfo = $jsd['arguments'];
		}
		return false;
	}
	public static function actionGetTorrentList(){
		$cmdAsyncExec = DuneSystem::$properties['install_dir_path'] . '/www/cgi-bin/php-cgi -f ' .  DuneSystem::$properties['install_dir_path'] . "/www/cgi-bin/transmissionActions.php action=get transmissionIp=" . self::getIp();
		$transmissionAccount = (HD::getItemsArr('transmissionAccount', true) != array()) ? HD::getItemsArr('transmissionAccount', true) : array('login' => '', 'pass' => '');
		if (($transmissionAccount['login'] != '')&&($transmissionAccount['pass'] != ''))
			$cmdAsyncExec .= " login=". urlencode($transmissionAccount['login']) ." pass=" . urlencode($transmissionAccount['pass']);
		$str = HD::asyncExec($cmdAsyncExec);
		if (!empty($str)){
			if ($str == '[]')
				return true;
			return json_decode ($str);
		}
		return false;
	}
	public static function actionGetTorrentFileList($transmissionId){
		$cmdAsyncExec = DuneSystem::$properties['install_dir_path'] . '/www/cgi-bin/php-cgi -f ' .  DuneSystem::$properties['install_dir_path'] . "/www/cgi-bin/transmissionActions.php action=getFile transmissionId=$transmissionId transmissionIp=" . self::getIp();
		$transmissionAccount = (HD::getItemsArr('transmissionAccount', true) != array()) ? HD::getItemsArr('transmissionAccount', true) : array('login' => '', 'pass' => '');
		if (($transmissionAccount['login'] != '')&&($transmissionAccount['pass'] != ''))
			$cmdAsyncExec .= " login=". urlencode($transmissionAccount['login']) ." pass=" . urlencode($transmissionAccount['pass']);
		$str = HD::asyncExec($cmdAsyncExec);
		if (!empty($str)){
			if ($str == '[]')
				return true;
			return json_decode ($str);
		}
		return false;
	}
	public static function transmissionAddTorrent($torrentFile, $tType){
		if ($tType == 'magnet')
			return array("status" => true);
		if ($torrentFile == 'http://'.HD::get_ip_address().'/temp.torrent'){
			self::$torrent = new Torrent('/tmp/www/temp.torrent');
			if ('temp.torrent' == self::$torrent->name())
				return array("status" =>  false, "msg"=>"Сохраненный файл не является торрент файлом. Возможно произошла ошибка при загрузке торрент файла.");
		}
		return array("status" => true);
	}
}
?>
