<?
if (!class_exists('DuneSystem')){
	if (preg_match('|plugins/(.*?)/lib|', __DIR__, $matches)){
		$tmp_path = '/tmp/plugins/'.$matches[1];
		$plugin_name = $matches[1];
		$install_dir = str_replace('/lib/wox', '',  __DIR__);
		if (file_exists('/persistfs/plugins_data'))
			$data_dir = "/persistfs/plugins_data/$plugin_name";
		else
			$data_dir = "/flashdata/plugins_data/$plugin_name";
        $port = HD::http_local_port();
		$www_url = "http://127.0.0.1:$port/plugins/$plugin_name/";
		$cgi_url = "http://127.0.0.1:$port/cgi-bin/plugins/$plugin_name/";
	}

	function hd_print($str){
		echo $str;
	}
	class DuneSystem{
		public static $properties = array ();
	};
	DuneSystem::$properties['plugin_name']      = $plugin_name;
	DuneSystem::$properties['install_dir_path'] = $install_dir;
	DuneSystem::$properties['tmp_dir_path']     = $tmp_path;
	DuneSystem::$properties['plugin_www_url']   = $www_url;
	DuneSystem::$properties['plugin_cgi_url']   = $cgi_url;
	DuneSystem::$properties['data_dir_path']    = $data_dir;
}
class HDReactor_Class {
	static $cName = 'HDReactor';
	static $className = 'HDReactor_Class';
	static $DomainName = null;
	static $proxyArr = null;
	static $proxyArrMd5 = null;
	static $proxy = null;
	public static function getDomainName(){
		if (null === self::$DomainName)
			self::$DomainName = (HD::getItemStr(self::$cName . 'DomainName') != '') ? HD::getItemStr(self::$cName . 'DomainName') : 'https://hdreactor.club';
		return self::$DomainName;
	}
	public static function getMainMenuInfo(){
		return array (
			'name' => self::$cName,
			'descr' => '||'.self::$cName.'|каталог и источник торрентов с сайта '.self::$cName.'.|Если сайт не доступен используйте прокси или VPN, а так же официальные зеркала (сайты с похожим дизайном и названием могут не являтся зеркалом)'
		);
	}
	public static function get_media_url_str($k, $arr=null){
		if ($arr == true)
			return SmartVodCategoryListScreen::get_media_url_str($k, $arr);
		return SmartVodCategoryListScreen::get_media_url_str($k);
	}
	public static function getSearchMediaUrlStr($k, $arr=null){
		return SmartVodListScreen::get_media_url_str($k, $arr);
	}
	public static function getPopUpMenuItems ($selected_media_url, $parent_media_url){
		$menu_items = array();
		if ($parent_media_url == 'main_menu'){
			$menu_items[] = array(
				'caption' => 'Задать зеркало ' . self::$cName,
				'params' => array ('action' => 'mirror'),
				'icon_url' => SmartConfig::getPluginIco('s_' . self::$className)
			);
			$menu_items[] = array(
				'caption' => 'Прокси для ' . self::$cName,
				'params' => array ('action' => 'proxy'),
				'icon_url' => SmartConfig::getPluginIco('s_proxy')
			);
			$menu_items[] = 'is_separator';
		}
		$parent_media_url = MediaURL::decode($parent_media_url);
		if ($parent_media_url->screen_id == 'vod_torrentlist'){
			
			$menu_items[] = array(
				'caption' => 'Изменить действие для торрентов',
				'params' => array ('action' => 'torrentActionSetup'),
				'icon_url' => SmartConfig::getPluginIco('s_torrent')
			);
			$menu_items[] = array(
				'caption' => 'Выбрать действие торрента',
				'conID' => 'add_actions',
				'params' => array ('torrentAction' => 1),
				'icon_url' => SmartConfig::getPluginIco('s_list')
			);
			$menu_items[] = 'is_separator';
			$menu_items[] = array(
				'caption' => 'Настройки TorrServer',
				'conID' => 'classSetupTorrServer',
				'params' =>  null,
				'icon_url' => SmartConfig::getPluginIco('s_torrserver')
			);
			$menu_items[] = array(
				'caption' => 'Настройки PeerflixServer',
				'conID' => 'classSetupPeerflixServer',
				'params' =>  null,
				'icon_url' => SmartConfig::getPluginIco('s_peerflixserver')
			);
			$menu_items[] = array(
				'caption' => 'Настройки Transmission',
				'conID' => 'classSetupTransmission',
				'params' =>  null,
				'icon_url' => SmartConfig::getPluginIco('s_transmission')
			);
			$menu_items[] = array(
				'caption' => 'Настройки Transmission UPnP',
				'conID' => 'classSetupTransmissionUPnP',
				'params' =>  null,
				'icon_url' => SmartConfig::getPluginIco('s_transmissionupnp')
			);
			$menu_items[] = 'is_separator';
		}
		if ((isset($parent_media_url->screen_id))&&($parent_media_url->screen_id != 'vod_series')){
			$menu_items[] = array(
				'caption' => 'Добавить в Главное меню',
				'params' => array ('action' => 'addToMainMenu'),
				'icon_url' => SmartConfig::getPluginIco('s_home')
			);
		}
		return $menu_items;
	}
	public static function getScreenActionMapArr($media_url){
		$actionsArr = array();
		return $actionsArr;
	}
	public static function getVodCategories($media_url){
		static $categories = null;
		if (is_null($categories)){
			$categories['categories'][] = array('id'=> 'search', 'class' => 'SmartSearchScreen', 'caption' => 'Поиск');
			$categories['categories'][] = array('id'=> '/', 'class' => 'SmartVodListScreen', 'caption' => 'Все');
			$categories['categories'][] = array('id'=> '/tags/', 'class' => 'SmartVodCategoryListScreen', 'caption' => 'Все теги');
			$categories['categories'][] = array('id'=> '/1/', 'class' => 'SmartVodListScreen', 'caption' => 'Кино HD');
			$categories['categories'][] = array('id'=> '/6/', 'class' => 'SmartVodListScreen', 'caption' => 'Сериалы HD');
			$categories['categories'][] = array('id'=> '/7/', 'class' => 'SmartVodListScreen', 'caption' => 'Мульты HD');
			$categories['categories'][] = array('id'=> '/4/', 'class' => 'SmartVodListScreen', 'caption' => 'Music HD');
			$categories['categories'][] = array('id'=> '/sport-hd/', 'class' => 'SmartVodListScreen', 'caption' => 'Спорт HD');
			$categories['categories'][] = array('id'=> '/4k_uhd/', 'class' => 'SmartVodListScreen', 'caption' => '4K(UHD)');
			$categories['categories'][] = array('id'=> '/tags/3D/', 'class' => 'SmartVodListScreen', 'caption' => '3D');
		}
		if (isset($media_url->categoryId)){
			if (!isset($categories['subCategories'][$media_url->categoryId])){
				$doc = iconv('windows-1251', 'UTF-8', self::http_get_document(self::getDomainName() . $media_url->categoryId));
				if (preg_match_all('|id="st_\d*?" value="(.*?)"|ms', $doc, $matches))
					foreach($matches [1] as $v)
						$categories['subCategories'][$media_url->categoryId][] = array('id'=> '/tags/'.$v.'/', 'class' => 'SmartVodListScreen', 'caption' => HD::str_remove_tag($v));
				$c=explode('<div class="tl">',$doc);
				if (preg_match_all('|<a href="'.self::getDomainName().'(.*?)" class="clouds.*?публикаций:(.*?)">(.*?)</a>|ms', $c[1], $matches))
					foreach($matches [1] as $k => $v)
						$categories['subCategories'][$media_url->categoryId][] = array('id'=> $v, 'class' => 'SmartVodListScreen', 'caption' => $matches[3][$k] .' ('.trim($matches[2][$k]).')');
			}
			return $categories['subCategories'][$media_url->categoryId];
		}
		return $categories['categories'];
	}
	public static function getShortMovieRange ($media_url, &$m_feed){
		if ($m_feed === 'end')
			return $items;
		$doc = iconv('windows-1251', 'UTF-8', self::http_get_document(self::getDomainName() . $media_url->categoryId . 'page/' . ($m_feed + 1) . '/'));
		++$m_feed;
		if (preg_match('|">1<\/a> <span class="nav_ext">\.\.\.|', $doc))
			$m_feed = 'end';
		return self::parseSitePage($doc);
	}
	public static function getSearchShortMovieRange ($keyword, &$m_feed){
		if (is_object($keyword))
			$keyword = $keyword->searchStr;
		if ($m_feed === 'end')
			return array();
		$post_data = "do=search&subaction=search&search_start=". ($m_feed + 1) ."&full_search=1&result_from=1&story=".urlencode (iconv('UTF-8', 'windows-1251', $keyword))."&titleonly=3&searchuser=&replyless=0&replylimit=0&searchdate=0&beforeafter=after&sortby=date&resorder=desc&showposts=0&catlist%5B%5D=0";
		$opts[CURLOPT_COOKIEJAR] = self::cookie();
		$opts[CURLOPT_COOKIEFILE] = self::cookie();
		$opts[CURLOPT_POST] = true;
		$opts[CURLOPT_POSTFIELDS] = $post_data;
		$doc = iconv('windows-1251', 'UTF-8', self::http_get_document(self::getDomainName() . '/index.php?do=search', $opts));

		++$m_feed;
		if (preg_match('|">1<\/a> <span class="nav_ext">\.\.\.|', $doc))
			$m_feed = 'end';
		return self::parseSitePage($doc);
	}
	public static function parseSitePage($doc){
		$items = array();
		if (preg_match_all('|movie-item">.*?href="(.+?)".*?src="(.+?)".*?alt="(.+?)".*?movie-item__btn|ms', $doc, $matches)){
			foreach ($matches[1] as $k => $v){
				if (preg_match("|\/tags\/|",$v)){
					if (preg_match('|<span>\d+?-\d+?-\d+?.*?</span>.*?href="(.+?)"|ms', $matches[0][$k], $match))
						$v = $match[1];
				}
				$path_parts = parse_url(self::getDomainName());
				if (preg_match("|".$path_parts['host']."|",$v)){
					$tmp = explode($path_parts['host'], $v);
					$v = $tmp[1];
				}
				$caption = HD::str_remove_tag($matches[3][$k]);
				$img = self::http_get_img ($matches[2][$k]);

				$short_movie = new ShortMovie(
					strval(trim($v)),
					strval($caption),
					strval($img)
				);
				$info = '||' . $caption;
				if (preg_match('|movie-item__meta.*?">(.+?)</span>|ms', $matches[0][$k], $match))
					$info .= '|' . HD::str_remove_tag($match[1]);
				if (preg_match('|<span>(\d+?-\d+?-\d+?.*?)</span>|', $matches[0][$k], $match))
					$info .= '|' . HD::str_remove_tag($match[1]);
				if (preg_match('|class="tegi".*?">(.+?)</div|ms', $matches[0][$k], $match))
					$info .= '|' . HD::str_remove_tag(str_replace("</a>", ",", $match[1]));
				if (preg_match('|item__text.*?">(.+?)</div|ms', $matches[0][$k], $match)){
					$ds = HD::str_remove_tag($match[1]);
					if ($ds != '')
						$info .= '|' . $ds;
				}
				$short_movie->info = $info;
				array_push ($items, $short_movie);
			}
		}
		// if (preg_match_all('|<div class="tl">(.*?)</h1>.*?<br.*?<a href="(.*?)"|ms', $doc, $matches))
			// foreach ($matches[2] as $k => $v){
				// $date = '';
				// $img = SmartConfig::getPluginIco('');
				// if (preg_match('|<img src="(.*?)"|ms', $matches[0][$k], $match))
					// $img = HD::str_remove_tag($match[1]);
				// if (preg_match('|</h1>(.*?)<br|ms', $matches[0][$k], $match))
					// $date = HD::str_remove_tag($match[1]);
				// $caption = HD::str_remove_tag($matches[1][$k]);
				// $short_movie = new ShortMovie(
					// strval(trim($v)),
					// strval($caption),
					// strval($img)
				// );
				// $info = '||' . $caption;
				// $info .= '|' . $date;
				// $short_movie->info = $info;
				// array_push ($items, $short_movie);
		// }
		return $items;
	}
	public static function load_movie($movie_id, $mUrl, $getMovieInfo){
		$arr = array();
		$arr['caption'] = $arr['class_info']['catalog_info']['caption'] = $mUrl->caption;
		$arr['poster_url'] = $arr['class_info']['catalog_info']['poster_url'] = $mUrl->poster_url;
		if (isset($mUrl->caption_original))
			$arr['caption_original'] = $arr['class_info']['catalog_info']['caption_original'] = $mUrl->caption_original;
		if (isset($mUrl->year))
			$arr ['year'] = $arr['class_info']['catalog_info']['year'] = $mUrl->year;
		if (!preg_match("|^http|",$movie_id))
			$url = self::getDomainName() . $movie_id;
		else
			$url = preg_replace('#((http.*)://.+?\/)#i', self::getDomainName() . "/", $movie_id);
		$opts[CURLOPT_COOKIEJAR] = self::cookie();
		$opts[CURLOPT_COOKIEFILE] = self::cookie();
		$doc = iconv('windows-1251', 'UTF-8', self::http_get_document($url, $opts));
		if (preg_match('|<h1.*?">(.*?)</|ms', $doc, $match))
			$capt = $arr ['caption'] = HD::str_remove_tag($match[1]);
		if (preg_match('|description" content="(.*?)"|ms', $doc, $matches))
			$arr ['description'] = HD::str_remove_tag($matches[1]);
		
		if (preg_match('|<img src="(.*?)"|ms', $matches[1], $match))
			$arr ['poster_url'] = HD::str_remove_tag($match[1]);
		if (preg_match('|kinopoisk.ru/film/(\d*)|ms', $doc, $match))
			$arr['class_info']['dbIDs']['kpID'] = $match[1];
		else if (preg_match('|kinopoisk.ru/rating/(\d*?)\.|ms', $doc, $match))
			$arr['class_info']['dbIDs']['kpID'] = $match[1];
		else{
			$kpIDs = HD::getItemsArr('kpIDs');
			if (isset($kpIDs[$movie_id]))
				$arr['class_info']['dbIDs']['kpID'] = $kpIDs[$movie_id];
		}
		if (preg_match('|imdb.com/title/tt(\d*?)/|ms', $doc, $match))
			$arr['class_info']['dbIDs']['imdbID'] = 'tt' . $match[1];
		if (!isset($arr['class_info']['dbIDs']['kpID'])){
			$arr['class_info']['goToScreen'] = 'SmartVodTorrentsScreen';
			$arr['class_info']['noTrailers'] = true;
		}else
			$arr = SmartConfig::getMovieInfoArr($getMovieInfo, $movie_id, $mUrl, $arr);
		if ($capt == $arr['caption'])
			$arr['class_info']['goToScreen'] = 'SmartVodTorrentsScreen';
		// if (preg_match('|spoiler">(.*?)</span>|ms', $matches[1], $match))
			// if (preg_match_all('|<img src="(.*?)"|ms', $match[1], $match))
				// $arr ['background_urls'] = $match[1];
		
		if (preg_match('|distribute_m">(.*?)<|ms', $doc, $match))
			$seed = HD::str_remove_tag($match[1]);
		if (preg_match('|swing_m">(.*?)<|ms', $doc, $match))
			$leech = HD::str_remove_tag($match[1]);
		if (preg_match('|азмер:</b>(.*?)<|ms', $doc, $match)){
			$match[1] = str_replace("|", "", $match[1]);
			$size = HD::str_remove_tag($match[1]);
		}
		if (preg_match('|активность:</b>(.*?)<|ms', $doc, $match))
			$s_date = HD::str_remove_tag($match[1]);
		if (preg_match('|Загрузил:(.*?)</div>|ms', $doc, $match)){
			$match[1] = str_replace("|", "", $match[1]);
			$add_date = HD::str_remove_tag($match[1]);
		}
		if (preg_match('|torrent">.*?<a href="(.*?)"|ms', $doc, $match)){
			if (preg_match('|info_d1">(.*?)<|ms', $doc, $matches)){
				$torrentId = $match[1];
				$arr['class_info']['torrent'][self::$className][$torrentId]['caption'] = $capt;
				$arr['class_info']['torrent'][self::$className][$torrentId]['type'] = 'torrent';
				$arr['class_info']['torrent'][self::$className][$torrentId]['S'] = $seed;
				$arr['class_info']['torrent'][self::$className][$torrentId]['L'] = $leech;
				$arr['class_info']['torrent'][self::$className][$torrentId]['size'] = $size;
				$arr['class_info']['torrent'][self::$className][$torrentId] ['add_date'] = $add_date;
				$arr['class_info']['torrent'][self::$className][$torrentId] ['up_date'] = $s_date;
			}
			if (preg_match('|<a href="(magnet:.*?)"|ms', $doc, $m)){
				$torrentId = $m[1];
				$arr['class_info']['torrent'][self::$className][$torrentId]['caption'] = $capt;
				$arr['class_info']['torrent'][self::$className][$torrentId]['type'] = 'magnet';
				$arr['class_info']['torrent'][self::$className][$torrentId]['S'] = $seed;
				$arr['class_info']['torrent'][self::$className][$torrentId]['L'] = $leech;
				$arr['class_info']['torrent'][self::$className][$torrentId]['size'] = $size;
				$arr['class_info']['torrent'][self::$className][$torrentId] ['add_date'] = $add_date;
				$arr['class_info']['torrent'][self::$className][$torrentId] ['up_date'] = $s_date;
			}
		}
		return $arr;
	}
	public static function getShortTorrentRange ($movie, $media_url, &$m_feed){
		$items = array();
		if ($m_feed === 'end')
			return $items;
		if (isset($movie->class_info['torrent'][self::$className])){
			foreach ($movie->class_info['torrent'][self::$className] as $k => $v){
				$caption = $v['caption'];
				$short_movie = new ShortMovie(
					strval(trim($k)),
					strval($caption),
					strval($movie->poster_url)
				);
				$short_movie->icon_path = SmartConfig::getPluginIco('s_' . $v['type']);
				$short_movie->tType = $v['type'];
				$info = '||' . $caption . '|'. self::$cName;
				$short_movie->details_box_width = true;
				$info .= '||Размер|' . $v['size'];
				$info .= '||Seed:|' . $v ['S'];
				$info .= '||Leech:|' . $v['L'];
				$short_movie->info = $info;
				$short_movie->extra_item = $v['size'];
				array_push ($items, $short_movie);
			}
			$m_feed = 'end';
			return $items;
		}
		$keyword = $movie->name;
		$itemsObj = self::getSearchShortMovieRange ($keyword, $m_feed);
		$ico = SmartConfig::getPluginIco('s_torrent');
		foreach($itemsObj as $v){
			$v->icon_path = $ico;
			$v->tType = 'torrent';
			$items[] = $v;
		}
		return $items;
	}
	public static function getVodSourceInfo($v){
		$ico = SmartConfig::getPluginIco(self::$className);
		$sources['caption'] = self::$cName;
		$sources['detailed_info'] = '||'.self::$cName.'|Торрент файлы найденные на '.self::$cName.' по названию. Так как поиск производится по названию возможны неточности.';
		$sources['icon_path'] = $ico;
		$sources['detailed_icon_path'] = $ico;
		$sources['goTo'] = 'SmartVodTorrentsScreen';
		$sources['class_name'] = $v;
		$sources['type'] = SmartConfig::getPluginIco('torrentSource');
		return $sources;
	}
	public static function getTorrentFile($torrent_id, $dloadPath=null){
		if (preg_match("/\.html/",$torrent_id)){
			if (!preg_match("|^http|",$torrent_id))
				$torrent_id = self::getDomainName() . $torrent_id;
			$opts[CURLOPT_COOKIEJAR] = self::cookie();
			$opts[CURLOPT_COOKIEFILE] = self::cookie();
			$doc = iconv('windows-1251', 'UTF-8', self::http_get_document($torrent_id, $opts));
			if (preg_match('|torrent">.*?<a href="(.*?)"|ms', $doc, $match))
				$torrent_id = $match[1];
			else if (preg_match('|<a href="(magnet:.*?)"|ms', $doc, $match))
				$torrent_id = $match[1];
			else
				return array("status" => false,"descr" => "Возможно произошла ошибка при загрузке торрент файла");
		}
		if (preg_match("|magnet:\?xt=|",$torrent_id)){
			$torrentFile["status"] = true;
			$torrentFile["path"] = $torrent_id;
			return $torrentFile;
		}
		if (!preg_match("|^http|",$torrent_id))
			$torrent_id = self::getDomainName()  . $torrent_id;
		$opts[CURLOPT_REFERER] = $torrent_id;
		$doc = self::http_get_document($torrent_id, $opts);
		return SmartConfig::checkTorrent($dloadPath, $doc);
	}
	public static function cookie(){
		return DuneSystem::$properties['tmp_dir_path'] . "/" . self::$cName . "Cookie";
	}
	public static function http_get_img ($url){
		if (preg_match("|https|",$url))
			return DuneSystem::$properties['plugin_cgi_url'] . "do?img=" .  $url;	
		return $url;
	}
	public static function http_get_document ($url, $opts=null){
		if (is_null(self::$proxy)){
			self::$proxy = false;
			$sitesProxy = HD::getItemsArr('sitesProxy');
			if (isset($sitesProxy[self::$cName])){
				$proxySettings = (HD::getItemsArr('proxySettings') != array()) ? HD::getItemsArr('proxySettings') : array();
				if (isset($proxySettings['proxy'])){
					self::$proxy['proxy'] = $proxySettings['proxy'];
					if ((isset($proxySettings['proxyType']))&&($proxySettings['proxyType'] == 'SOCKS5'))
						self::$proxy['proxyType'] = $proxySettings['proxyType'];
					if (isset($proxySettings['proxyAccount']))
						self::$proxy['proxyAccount'] = $proxySettings['proxyAccount'];
				}
			}
		}
		if (self::$proxy == true){
			$opts[CURLOPT_PROXY] = self::$proxy['proxy'];
			if (isset(self::$proxy['proxyType']))
				$opts[CURLOPT_PROXYTYPE] = CURLPROXY_SOCKS5;
			if (isset(self::$proxy['proxyAccount']))
				$opts[CURLOPT_PROXYUSERPWD] = self::$proxy['proxyAccount'];
		}
		return HD::http_get_document($url, $opts);
	}
}
