<?
class Jackett_Class {
	static $cName = 'Jackett';
	static $className = 'Jackett_Class';
	static $DomainName = null;
	static $altDomainName = null;
	public static function getDomainName(){
		if (null === self::$DomainName)
			self::$DomainName = (HD::getItemStr(self::$cName . 'DomainName') != '') ? HD::getItemStr(self::$cName . 'DomainName') : 'https://torlook.info';
		return self::$DomainName;
	}
	public static function getMainMenuInfo(){
		return false;
	}
	public static function getScreenActionMapArr($media_url){
		$actionsArr = array();
		if((isset($media_url->screen_id))&&($media_url->screen_id == 'vod_torrentlist')){
			$actionsArr[0]['create_action'] = 'classAction';
			$actionsArr[0]['params'] = array ('indiClass' => self::$className,'action' => 'sort');
			$actionsArr[0]['caption'] = 'Сортировки';
			$actionsArr[0]['key'] = GUI_EVENT_KEY_C_YELLOW;
		}
		return $actionsArr;
	}
	public static function getPopUpMenuItems ($selected_media_url, $parent_media_url){
		$menu_items = array();
		$parent_media_url = MediaURL::decode($parent_media_url);
		if ($parent_media_url->screen_id == 'vod_source_list'){
			$menu_items[] = array(
				'caption' => 'Задать API Key ' . self::$cName,
				'params' =>  array ('indiClass' => self::$className, 'action' => 'apiKey'),
				'icon_url' => SmartConfig::getPluginIco('s_' . self::$className)
			);
			$menu_items[] = array(
				'caption' => 'IP адресс ' . self::$cName,
				'params' =>  array ('indiClass' => self::$className, 'action' => 'ipAdress'),
				'icon_url' => SmartConfig::getPluginIco('s_proxy')
			);
			$menu_items[] = 'is_separator';
		}
		if ($parent_media_url->screen_id == 'vod_torrentlist'){
			
			$menu_items[] = array(
				'caption' => 'Изменить действие для торрентов',
				'params' => array ('action' => 'torrentActionSetup'),
				'icon_url' => SmartConfig::getPluginIco('s_torrent')
			);
			$menu_items[] = array(
				'caption' => 'Выбрать действие торрента',
				'conID' => 'add_actions',
				'params' => array ('torrentAction' => 1),
				'icon_url' => SmartConfig::getPluginIco('s_list')
			);
			$menu_items[] = 'is_separator';
			$menu_items[] = array(
				'caption' => 'Настройки TorrServer',
				'conID' => 'classSetupTorrServer',
				'params' =>  null,
				'icon_url' => SmartConfig::getPluginIco('s_torrserver')
			);
			$menu_items[] = array(
				'caption' => 'Настройки PeerflixServer',
				'conID' => 'classSetupPeerflixServer',
				'params' =>  null,
				'icon_url' => SmartConfig::getPluginIco('s_peerflixserver')
			);
			$menu_items[] = array(
				'caption' => 'Настройки Transmission',
				'conID' => 'classSetupTransmission',
				'params' =>  null,
				'icon_url' => SmartConfig::getPluginIco('s_transmission')
			);
			$menu_items[] = array(
				'caption' => 'Настройки Transmission UPnP',
				'conID' => 'classSetupTransmissionUPnP',
				'params' =>  null,
				'icon_url' => SmartConfig::getPluginIco('s_transmissionupnp')
			);
			$menu_items[] = 'is_separator';
		}
		if ((isset($parent_media_url->screen_id))&&($parent_media_url->screen_id != 'vod_series')){
			$menu_items[] = array(
				'caption' => 'Добавить в Главное меню',
				'params' => array ('action' => 'addToMainMenu'),
				'icon_url' => SmartConfig::getPluginIco('s_home')
			);
		}
		return $menu_items;
	}
	public static function getVodSourceInfo($v){
		$ico = SmartConfig::getPluginIco(self::$className);
		$sources['caption'] = self::$cName;
		$sources['detailed_info'] = '||'.self::$cName.'|Магнет ссылки и торренты найденные на '.self::$cName.' по названию. Так как поиск производится по названию возможны неточности.';
		$sources['icon_path'] = $ico;
		$sources['detailed_icon_path'] = $ico;
		$sources['goTo'] = 'SmartVodTorrentsScreen';
		$sources['class_name'] = $v;
		$sources['type'] = SmartConfig::getPluginIco('torrentSource');
		return $sources;
	}
	public static function getShortTorrentRange ($movie, $media_url, &$m_feed){
		$items = array();
		if ($m_feed === 'end')
			return $items;
		$icon_path = SmartConfig::getPluginIco('s_magnet');
		$sorting = (HD::getItemsArr(self::$className . '_sorting') != array()) ? HD::getItemsArr(self::$className . '_sorting') : array('vod_torrentlist' => 0);	
		$keyword = $movie->name;
		if ($movie->name != $movie->name_original)
			$keyword = $movie->name_original;
		$jackettApiToken = (HD::getItemStr('jackettApiToken') != '') ? HD::getItemStr('jackettApiToken') : '';
		$jackettIpAdr = (HD::getItemStr('jackettIpAdr') != '') ? HD::getItemStr('jackettIpAdr') : '';
		$data = file_get_contents ($jackettIpAdr . "/api/v2.0/indexers/all/results?apikey=$jackettApiToken&Query=" . urlencode(trim($keyword)));
		$data =  preg_replace('/("\w+"):\s*?(\d+),/', '\\1:"\\2",', $data);
		$data_json = json_decode ($data);
		if (isset($data_json->Results)){
			$icon_path_magnet = SmartConfig::getPluginIco('s_magnet');
			$icon_path_torrent = SmartConfig::getPluginIco('s_torrent');
			foreach ($data_json->Results as $k => $v){
				$size_bytes[$k] = $v->Size;
				$seeds_count[$k]= $v->Seeders;
				$sizeReadable = HD::readableBytes($v->Size);
				$name = $v->Title;
				if ($v->Link != ''){
					$torrent = $v->Link;
					$icon_path = $icon_path_torrent;
					$tType = 'torrent';
				}else if ($v->MagnetUri != ''){
					$torrent = $v->MagnetUri;
					$icon_path = $icon_path_magnet;
					$tType = 'magnet';
				}
				$short_movie = new ShortMovie(
					strval($torrent),
					strval($name),
					strval($movie->poster_url)
				);
				$info = "||$name";
				$info .= "||Tracker: $v->Tracker";
				$info .= "||PublishDate: " . date ('d.m.Y H:i', (strtotime($v->PublishDate)));
				$short_movie->extra_item = "$sizeReadable|S:$v->Seeders|L:$v->Peers";
				$info .= "||$sizeReadable S:$v->Seeders L:$v->Peers";
				$short_movie->info = $info;
				$short_movie->tType = $tType;
				$short_movie->icon_path = $icon_path;
				$short_movie->details_box_width = true;
				$result[$k] = $short_movie;
			}
			natsort($size_bytes);
			$size_bytes = array_keys (array_reverse ($size_bytes, true));
			if (count($result) > 0){
				if ($sorting['vod_torrentlist'] == 0)
					$sort = $result;
				else if ($sorting['vod_torrentlist'] == 2){
					arsort($seeds_count);
					$seeds_count = array_keys ($seeds_count);
					foreach ($seeds_count as $k => $v)
						$sort[$k] = $result[$v];
				}else if ($sorting['vod_torrentlist'] == 1){
					foreach ($size_bytes as $k => $v)
						$sort[$k] = $result[$v];
				}
				$items = array_values ($sort);
			}
			$m_feed = 'end';
		}
		return $items;
	}
	public function classAction ($defs, $user_input, $select_url = null){
		hd_restore_warnings();
		$post_action = null;
		$caption = 'Error!';
		$msg = 'classAction: action';
		$width = 1050;
		$parent_media_url = MediaURL::decode($user_input->parent_media_url);
		if ($user_input->action == 'ipAdress'){
			$add_params['control_id']= $user_input->control_id;
			$add_params['action'] = $user_input->action;
			$add_params['indiClass'] = self::$className;
			$jackettIpAdr = (HD::getItemStr('jackettIpAdr') != '') ? HD::getItemStr('jackettIpAdr') : '';
			if (isset($user_input->newIpAdr)){
				if ((!preg_match("|http|", $user_input->newIpAdr))&&($user_input->newIpAdr != ''))
					$user_input->newIpAdr = 'http://' . $user_input->newIpAdr;
				if ((!preg_match("|\:\d|", $user_input->newIpAdr))&&
				(!preg_match("|^(\\d{1,3})\\.(\\d{1,3})\\.(\\d{1,3})\\.(\\d{1,3})$|", $user_input->newIpAdr))&&
				($user_input->newIpAdr != ''))
					$user_input->newIpAdr = $user_input->newIpAdr . ':9117';
				echo $user_input->newIpAdr;
				$user_input->newIpAdr = preg_replace("|\/$|", '', $user_input->newIpAdr);
				HD::saveItemStr('jackettIpAdr', $user_input->newIpAdr);
				if ($user_input->newIpAdr == '')
					$user_input->newIpAdr = 'значение удалено.';
				return ActionFactory::show_title_dialog('Сохранено!', null, "IP:\n" . $user_input->newIpAdr, $width - 350);
			}
			ControlFactory::add_multiline_label($defs,'' ,"Указывайте IP " . self::$cName , 5);
			ControlFactory::add_text_field($defs, $this, null,
                    'newIpAdr',
                    '',
                    $jackettIpAdr, 0, 0, 0, 1, $width - 100, false, false
            );
			ControlFactory::add_close_dialog_and_apply_button($defs, $this, $add_params, $user_input->control_id, 'Применить', 450);
			return ActionFactory::show_dialog('IP адресс ' . self::$cName, $defs, true, $width);
		}
		if ($user_input->action == 'apiKey'){
			$add_params['control_id']= $user_input->control_id;
			$add_params['action'] = $user_input->action;
			$add_params['indiClass'] = self::$className;
			$jackettApiToken = (HD::getItemStr('jackettApiToken') != '') ? HD::getItemStr('jackettApiToken') : '';
			if (isset($user_input->newApiToken)){
				if (HD::saveItemStr('jackettApiToken', $user_input->newApiToken) == false)
					return ActionFactory::show_title_dialog("Сохранение не удалось");
				return ActionFactory::show_title_dialog("Сохранено");
			}
			ControlFactory::add_multiline_label($defs,'' ,"Укажите свой API токен Jackett", 5);
			ControlFactory::add_text_field($defs, $this, null,
                    'newApiToken',
                    '',
                    $jackettApiToken, 0, 0, 0, 1, $width - 100, false, false
            );
			$add_params['action']= $user_input->action;
			ControlFactory::add_close_dialog_and_apply_button($defs, $this, $add_params, $user_input->control_id, 'Применить', 450);
			return ActionFactory::show_dialog("API токен Jackett", $defs, true, $width);
		}
		if ($user_input->action == 'sort'){
			$sorting = (HD::getItemsArr(self::$className . '_sorting') != array()) ? HD::getItemsArr(self::$className . '_sorting') : array('vod_torrentlist' => 0);	
			$add_params['control_id']= $user_input->control_id;
			$add_params['action'] = $user_input->action;
			$add_params['indiClass'] = self::$className;
			if ((isset($user_input->selected_control_id))&&(isset($user_input->action_type))){
				if (isset($user_input->initial_sel_ndx))
					$add_params['initial_sel_ndx'] = $user_input->initial_sel_ndx;
				$sorting['vod_torrentlist'] = $user_input->sorting;
				if (HD::saveItemsArr(self::$className . '_sorting', $sorting) == false)
					return ActionFactory::show_title_dialog("Сохранение не удалось");
				$action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $add_params);
				$action = ActionFactory::close_dialog_and_run($action);
				return ActionFactory::invalidate_folders(array($user_input->parent_media_url), $action);
			}
			$add_params['initial_sel_ndx'] = 0;
			
			$sorting_ops[0]	= 'Выдача';
			$sorting_ops[1]	= 'Размер';
			$sorting_ops[2]	= 'Раздающие';
			$sort = $sorting['vod_torrentlist'];
			ControlFactory::add_combobox($defs, $this, $add_params,
				'sorting', '',
				$sort, $sorting_ops, 800, true, false
			);
			$attrs['initial_sel_ndx'] = isset($user_input->initial_sel_ndx) ? $user_input->initial_sel_ndx : -1;
			return ActionFactory::show_dialog("Cортировка:", $defs, true, 0, $attrs);
		}
		if (isset($user_input->selected_media_url))
			$selected_media_url = MediaURL::decode($user_input->selected_media_url);
		else{
			$msg = 'classAction: selected_media_url';
			return ActionFactory::show_title_dialog($caption, $post_action, $msg, 0);
		}
		$class_name = $selected_media_url->class_name;
		$parent_media_url = MediaURL::decode($user_input->parent_media_url);
		
		return ActionFactory::show_title_dialog($caption, $post_action, $msg, 0);
	}
	
	public static function getTorrentFile($torrent_id, $dloadPath=null){
		$torrentFile["status"] = true;
		$torrentFile["path"] = $torrent_id;
		return $torrentFile;
	}
	public static function checkApproach(){
		$result = false;
		$jackettApiToken = (HD::getItemStr('jackettApiToken') != '') ? HD::getItemStr('jackettApiToken') : '';
		$jackettIpAdr = (HD::getItemStr('jackettIpAdr') != '') ? HD::getItemStr('jackettIpAdr') : '';
		if(($jackettApiToken == '')&&($jackettIpAdr == '')){
			$result['title'] = 'Не Указан IP адресс и API key Jackett';
			$result['action'] = 'popup_menu';
			$result['msg'] = 'Укажите IP адресс и API key Jackett';
		}else if ($jackettApiToken == ''){
			$result['title'] = 'Не Указан API key Jackett';
			$result['msg'] =  'Укажите API key Jackett';
			$result['params'] =  array ('indiClass' => self::$className, 'action' => 'apiKey');
		}else if ($jackettIpAdr == ''){
			$result['title'] = 'Не Указан IP адресс Jackett';
			$result['msg'] =  'Укажите IP адресс Jackett';
			$result['params'] =  array ('indiClass' => self::$className, 'action' => 'ipAdress');
		}
		return $result;
	}
}