<?
class Youtube_Class {
	static $cName = 'YouTube Трейлеры';
	static $className = 'Youtube_Class';
	public static function getMainMenuInfo(){
		return array (
			'name' => self::$cName,
			'descr' => '||'.self::$cName.'|трейлеры через поиск Youtube| совпадения не точны - могут отображатся любые трейлеры (компьютерные игры, приложения и другое)'
		);
	}
	public static function get_media_url_str($k, $arr=null){
		if ($arr == true)
			return SmartVodCategoryListScreen::get_media_url_str($k, $arr);
		return SmartVodCategoryListScreen::get_media_url_str($k);
	}
	public static function getSearchMediaUrlStr($k, $arr=null){
		return SmartVodRectangleListScreen::get_media_url_str($k, $arr);
	}
	public static function getPopUpMenuItems ($selected_media_url, $parent_media_url){
		$menu_items = array();
		$parent_media_url = MediaURL::decode($parent_media_url);
		if ((isset($parent_media_url->screen_id))&&($parent_media_url->screen_id != 'vod_series')){
			$menu_items[] = array(
				'caption' => 'Добавить в Главное меню',
				'params' => array ('action' => 'addToMainMenu'),
				'icon_url' => SmartConfig::getPluginIco('s_home')
			);
		}
		return $menu_items;
	}
	public static function getVodCategories($media_url){
		static $categories = null;
		$category = null;
		if (isset($media_url->categoryId))
			$category = $media_url->categoryId;
		
		if (is_null($categories)){
			$categories['categories'][] = array('id'=> 'search', 'class' => 'SmartSearchScreen', 'caption' => 'Поиск');
			$categories['categories'][] = array('id'=> 'ru_trailers', 'class' => 'SmartVodCategoryListScreen', 'caption' => 'Трейлеры', 'description' => 'Поиск трейлеров на русском языке');
			$categories['categories'][] = array('id'=> 'eng_trailers', 'class' => 'SmartVodCategoryListScreen', 'caption' => 'Trailers Eng', 'description' => 'Поиск трейлеров на английском языке');
			$search = 'трейлер';
			$categories['subCategories']['ru_trailers'][] = array(
				'id'=> '/search?part=snippet&q='.urlencode($search).'&type=video,channel,playlist&maxResults=50&relevanceLanguage=ru', 
				'class' => 'SmartVodRectangleListScreen', 
				'caption' => 'Все Трейлеры'
			);
			for ($i = date('Y') + 2; $i> 1950; $i--)
				$categories['subCategories']['ru_trailers'][] = array(
				'id'=> '/search?part=snippet&q='.urlencode($search . ' ' . $i).'&type=video,channel,playlist&maxResults=50&relevanceLanguage=ru', 
				'class' => 'SmartVodRectangleListScreen', 
				'caption' => "Трейлеры $i"
			);
			$search = 'trailer';
			$categories['subCategories']['eng_trailers'][] = array(
				'id'=> '/search?part=snippet&q='.urlencode($search).'&type=video,channel,playlist&maxResults=50&relevanceLanguage=en', 
				'class' => 'SmartVodRectangleListScreen', 
				'caption' => 'All Trailers'
			);
			for ($i = date('Y') + 2; $i> 1950; $i--)
				$categories['subCategories']['eng_trailers'][] = array(
				'id'=> '/search?part=snippet&q='.urlencode($search . ' ' . $i).'&type=video,channel,playlist&maxResults=50&relevanceLanguage=en', 
				'class' => 'SmartVodRectangleListScreen', 
				'caption' => "Trailers $i"
			);
		}
		if ($category == true)
			return $categories['subCategories'][$category];
		return $categories['categories'];
	}
	public static function getScreenActionMapArr($media_url){
		$actionsArr = array();
		if((isset($media_url->screen_id))&&($media_url->screen_id == 'vod_rectanglelist')){
			$actionsArr[0]['create_action'] = 'classAction';
			$actionsArr[0]['params'] = array ('indiClass' => self::$className,'action' => 'sort');
			$actionsArr[0]['caption'] = 'Сортировки';
			$actionsArr[0]['key'] = GUI_EVENT_KEY_C_YELLOW;
		}
		return $actionsArr;
	}
	public function classAction ($defs, $user_input, $select_url = null){
		hd_restore_warnings();
		$post_action = null;
		$caption = 'Error!';
		$msg = 'classAction: action';
		$width = 1050;
		if (isset($user_input->selected_media_url))
			$selected_media_url = MediaURL::decode($user_input->selected_media_url);
		else{
			$msg = 'classAction: selected_media_url';
			return ActionFactory::show_title_dialog($caption, $post_action, $msg, 0);
		}
		$class_name = $selected_media_url->class_name;
		$parent_media_url = MediaURL::decode($user_input->parent_media_url);
		if ($user_input->action == 'sort'){
			$add_params['control_id']= $user_input->control_id;
			$add_params['action'] = $user_input->action;
			$add_params['indiClass'] = self::$className;
			if ((isset($user_input->selected_control_id))&&(isset($user_input->action_type))){
				$add_params['initial_sel_ndx'] = $user_input->initial_sel_ndx;
				if ($user_input->selected_control_id == 'sorting')
					if (HD::saveItemStr(self::$className . '_sorting', $user_input->sorting) == false)
						return ActionFactory::show_title_dialog("Сохранение не удалось");
				
				$action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $add_params);
				$action = ActionFactory::close_dialog_and_run($action);
				return ActionFactory::invalidate_folders(array($user_input->parent_media_url), $action);
			}

			$sorting = (HD::getItemStr(self::$className . '_sorting') != '') ? HD::getItemStr(self::$className . '_sorting') : '&order=date';
			$sorting_ops['&order=date']			= 'по дате (по умолчанию)';
			$sorting_ops['&order=rating']		= 'по рейтингу';
			$sorting_ops['&order=relevance']	= 'по ревалентности';
			$sorting_ops['&order=title']		= 'по названию';
			$sorting_ops['&order=videoCount']	= 'по количеству видео';
			$sorting_ops['&order=viewCount']	= 'по количеству просмотров';
			ControlFactory::add_combobox($defs, $this, $add_params,
				'sorting', '',
				$sorting, $sorting_ops, 600, true, false
			);
			$attrs['initial_sel_ndx'] = isset($user_input->initial_sel_ndx) ? $user_input->initial_sel_ndx : -1;
			return ActionFactory::show_dialog("Cортировка:", $defs, true, 0, $attrs);
		}
		return ActionFactory::show_title_dialog($caption, $post_action, $msg, 0);
	}
	public static function getSearchShortMovieRange ($keyword, &$m_feed){
		if (is_object($keyword))
			$keyword = $keyword->searchStr;
		$arr['categoryId'] =  '/search?part=snippet&q='.urlencode($keyword).'&type=video,channel,playlist&maxResults=50&relevanceLanguage=ru';
		$obj = (object) $arr;
		return self::getShortMovieRange ($obj, &$m_feed);
	}
	public static function getShortMovieRange ($media_url, &$m_feed){
		$items = array();
		if ($m_feed === 'end')
			return $items;
		
		$sorting = (HD::getItemStr(self::$className . '_sorting') != '') ? HD::getItemStr(self::$className . '_sorting') : '&order=date';
		if (isset($media_url->categoryId))
			$url = 'https://www.googleapis.com/youtube/v3' . $media_url->categoryId . $sorting . '&key=' . Trailers::getApiKey();
		else
			$url = 'https://www.googleapis.com/youtube/v3/search?part=snippet&q='.urlencode($media_url->hash_patrs->name).'&type=video,channel,playlist&maxResults=50&relevanceLanguage=ru' . $sorting . '&key=' . Trailers::getApiKey();
		if ($m_feed != '0')
			$url .= "&pageToken=" . $m_feed;
		$jsd = json_decode (HD::http_get_document($url));
		if (isset($jsd->nextPageToken))
			$m_feed = $jsd->nextPageToken;
		else
			$m_feed = 'end';
		if (isset($jsd->error->message)){
			hd_print ("-->Msg:" . $jsd->error->message);
			return array();
		}
		if (count($jsd->items)== 0)
			return array();
		foreach ($jsd->items as $v){
			$info = '';
			if (isset($v->id->videoId))
				$id = $v->id->videoId;
			else if (isset($v->id->channelId))
				$id = $v->id->channelId;
			else if (isset($v->id->playlistId))
				$id = $v->id->playlistId;
			else if (isset($v->snippet->resourceId->videoId))
				$id = $v->snippet->resourceId->videoId;
			else if (isset($v->snippet->resourceId->channelId))
				$id = $v->snippet->resourceId->channelId;
			else if (isset($v->contentDetails->upload->videoId))
				$id = $v->contentDetails->upload->videoId;
			else if (isset($v->contentDetails->bulletin->resourceId->videoId))
				$id = $v->contentDetails->bulletin->resourceId->videoId;
			else
				$id = $v->id;			
			if (isset($v->snippet->thumbnails->medium->url))
				$img = str_replace("https", "http", $v->snippet->thumbnails->medium->url);
			
			if (isset($v->snippet->localized->title))
				$name = HD::str_remove_tag($v->snippet->localized->title);
			else
				$name = HD::str_remove_tag($v->snippet->title);
			if (isset($v->id->kind))
				$kind = $v->id->kind;
			else if (isset($v->snippet->resourceId->kind))
				$kind = $v->snippet->resourceId->kind;
			else if (isset($v->kind))
				$kind = $v->kind;
			if ($kind == "youtube#channel"){
				$mId = '/search?part=snippet&channelId='.$id.'&type=video&maxResults=50';
			}else if ($kind == 'youtube#playlist'){
				$mId = '/playlistItems?part=snippet&maxResults=50&playlistId='.$id;
			}else if (($kind == 'youtube#video')||($kind == 'youtube#playlistItem')||($kind == 'youtube#activity')){
				$mId = $id;
			}
			$short_movie = new ShortMovie(
				strval($mId),
				strval($name),
				strval($img)
			);
			$short_movie->shape = 'rectangle';
			$short_movie->goToScreen = 'SmartVodRectangleListScreen';
			if ($kind == "youtube#channel")
				$short_movie->shape = 'tetragon';
			else if (($kind == 'youtube#video')||($kind == 'youtube#playlistItem')||($kind == 'youtube#activity'))
				$short_movie->goToScreen = 'VodSeriesListScreen';
			$info .= '||' . str_replace("|", "", $name);
			
			$date = new DateTime($v->snippet->publishedAt);
			$pr = '['. str_replace("youtube#", "", $kind) . '] ';
			if (isset($v->snippet->type))
				$pr = '['. $v->snippet->type . '] ';
			if ((isset($v->snippet->liveBroadcastContent))&&($v->snippet->liveBroadcastContent == "live"))
				$pr .= "[live] ";
			$info .= '|' .$pr. $date->format('d.m.Y');
			if ($kind != "youtube#channel")
				$info .= '||' . $v->snippet->channelTitle;
			if (isset($v->snippet->localized->description))
				$short_movie->description = HD::str_remove_tag($v->snippet->localized->description);
			else
				$short_movie->description = HD::str_remove_tag($v->snippet->description);
			$info .= '|' . $short_movie->description;
			$short_movie->info = $info;
			array_push ($items, $short_movie);
		}
		return $items;
	}
	public static function load_movie($movie_id, $mUrl, $getMovieInfo){
		$arr = array();
		$arr['caption'] = $mUrl->caption;
		$arr['description'] = $mUrl->description;
		$arr['poster_url'] = $mUrl->poster_url;
		
		$arr['setSeriesList'] = true;
		$arr['id'] = $movie_id;
		$arr['title'] = $mUrl->caption;
		$arr['playback_url'] = 'http://www.youtube.com/watch?v=' . $movie_id;
		$arr['is_stream_url'] = false;
		$arr['file_info']['poster_url'] = $mUrl->poster_url;//self::http_get_img ($jsd->items[0]->snippet->thumbnails->medium->url);
		$arr['file_info']['class_name'] = HD::str_remove_tag($mUrl->class_name);
		$arr['file_info']['description'] = HD::str_remove_tag($mUrl->description);
		$arr['file_info']['detailed_info'] = HD::str_remove_tag($mUrl->description);
		$arr['file_info']['icon_path'] = 'plugin_file://icons/s_youtube.png';
		$arr['file_info']['parent_media_url'] = 'noupd';
		return $arr;
	}
	public static function getVodSourceInfo($v){
		$ico = SmartConfig::getPluginIco('youtubeVideo');
		$sources['caption'] = 'YouTube Video';
		$sources['detailed_info'] = '||YouTube Video|Видео найденные на YouTube по названию. Поиск на Youtube производится по названию возможны неточности.';
		$sources['icon_path'] = $ico;
		$sources['detailed_icon_path'] = $ico;
		$sources['goTo'] = 'SmartVodRectangleListScreen';
		$sources['class_name'] = $v;
		$sources['type'] = SmartConfig::getPluginIco('onlineSource');
		$sources['iconId'] = 'youtubeVideo';
		return $sources;
	}
	public static function get_series_list($media_url, $movie){
		$items[$media_url->movie_id]['id'] = md5 ($media_url->movie_id);
		$items[$media_url->movie_id]['title'] = HD::str_remove_tag($movie->name);
		$items[$media_url->movie_id]['playback_url'] = 'http://www.youtube.com/watch?v='.$media_url->movie_id;
		$items[$media_url->movie_id]['is_stream_url'] = false;
				
		$items[$media_url->movie_id]['file_info']['poster_url'] = $media_url->poster_url;//self::http_get_img ($jsd->items[0]->snippet->thumbnails->medium->url);
		$items[$media_url->movie_id]['file_info']['class_name'] = $media_url->class_name;
		$items[$media_url->movie_id]['file_info']['description'] = HD::str_remove_tag($media_url->description);
		$items[$media_url->movie_id]['file_info']['detailed_info'] = HD::str_remove_tag($media_url->description);
		$items[$media_url->movie_id]['file_info']['icon_path'] = 'plugin_file://icons/s_youtube.png';
		return $items;
	}
}
?>