<?
class Zona_Class {
	static $cName = 'Zona';
	static $className = 'Zona_Class';
	static $genreNames = false;
	static $proxyArr = null;
	static $proxyArrMd5 = null;
	static $proxy = null;
	public static function get_media_url_str($k, $arr=null){
		if ($arr == true)
			return SmartVodCategoryListScreen::get_media_url_str($k, $arr);
		return SmartVodCategoryListScreen::get_media_url_str($k);
	}
	public static function getMainMenuInfo(){
		$arr[] = array (
			'name' => 'Фильмы',
			'descr' => '||Фильмы|с каталога приложения Zona',
			'ico' => SmartConfig::getPluginIco('zonaFilm'),
			'mUrl' => self::get_media_url_str(self::$className, array('sectionId'=> 'film', 'iconId'=> 'zonaFilm', 'caption' => 'Фильмы'))
		);
		$arr[] = array (
			'name' => 'Сериалы',
			'descr' => '||Сериалы|с каталога приложения Zona',
			'ico' => SmartConfig::getPluginIco('zonaSerial'),
			'mUrl' => self::get_media_url_str(self::$className, array('sectionId'=> 'serial', 'iconId'=> 'zonaSerial', 'caption' => 'Сериалы'))
		);
		$arr[] = array (
			'name' => 'Телепередачи',
			'descr' => '||Телепередачи|с каталога приложения Zona',
			'ico' => SmartConfig::getPluginIco('zonaTvshow'),
			'mUrl' => self::get_media_url_str(self::$className, array('sectionId'=> 'tvshow', 'iconId'=> 'zonaTvshow', 'caption' => 'Телепередачи'))
		);
		return $arr;
	}
	public static function getScreenActionMapArr($media_url){
		$actionsArr = array();
		if ((isset($media_url->screen_id))&&(($media_url->screen_id == 'vod_list')||
		($media_url->screen_id == 'vod_torrentlist'))){
			$actionsArr[0]['create_action'] = 'classAction';
			$actionsArr[0]['params'] = array ('indiClass' => self::$className,'action' => 'sort');
			$actionsArr[0]['caption'] = 'Сортировки';
			$actionsArr[0]['key'] = GUI_EVENT_KEY_C_YELLOW;
		}
		return $actionsArr;
	}
	public static function getPopUpMenuItems ($selected_media_url, $parent_media_url){
		$menu_items = array();
		
		if ($parent_media_url == 'main_menu'){
			$menu_items[] = array(
				'caption' => 'Прокси для ' . self::$cName,
				'params' => array ('action' => 'proxy'),
				'icon_url' => SmartConfig::getPluginIco('s_proxy')
			);
			$menu_items[] = 'is_separator';
		}
		$parent_media_url = MediaURL::decode($parent_media_url);
		if ($parent_media_url->screen_id == 'vod_torrentlist'){
			
			$menu_items[] = array(
				'caption' => 'Изменить действие для торрентов',
				'params' => array ('action' => 'torrentActionSetup'),
				'icon_url' => SmartConfig::getPluginIco('s_torrent')
			);
			$menu_items[] = array(
				'caption' => 'Выбрать действие торрента',
				'conID' => 'add_actions',
				'params' => array ('torrentAction' => 1),
				'icon_url' => SmartConfig::getPluginIco('s_list')
			);
			$menu_items[] = 'is_separator';
			$menu_items[] = array(
				'caption' => 'Настройки TorrServer',
				'conID' => 'classSetupTorrServer',
				'params' =>  null,
				'icon_url' => SmartConfig::getPluginIco('s_torrserver')
			);
			$menu_items[] = array(
				'caption' => 'Настройки PeerflixServer',
				'conID' => 'classSetupPeerflixServer',
				'params' =>  null,
				'icon_url' => SmartConfig::getPluginIco('s_peerflixserver')
			);
			$menu_items[] = array(
				'caption' => 'Настройки Transmission',
				'conID' => 'classSetupTransmission',
				'params' =>  null,
				'icon_url' => SmartConfig::getPluginIco('s_transmission')
			);
			$menu_items[] = array(
				'caption' => 'Настройки Transmission UPnP',
				'conID' => 'classSetupTransmissionUPnP',
				'params' =>  null,
				'icon_url' => SmartConfig::getPluginIco('s_transmissionupnp')
			);
			$menu_items[] = 'is_separator';
		}
		if ((isset($parent_media_url->screen_id))&&($parent_media_url->screen_id != 'vod_series')){
			$menu_items[] = array(
				'caption' => 'Добавить в Главное меню',
				'params' => array ('action' => 'addToMainMenu'),
				'icon_url' => SmartConfig::getPluginIco('s_home')
			);
		}
		return $menu_items;
	}
	public static function getVodCategories($media_url){
		$opts [CURLOPT_USERAGENT] = "Java/1.8.0_171";
		static $categories = null;
		$category = null;
		if ($media_url->sectionId == 'tvshow'){
			if (!isset($categories['categories'][$media_url->sectionId])){
				$jsd = json_decode(self::http_get_document("http://zsolr3.zonasearch.com/solr/genre_tv/select/?q=*:*&version=2.2&wt=json&fl=id,name,ord,adult,fictional,custom&start=0&rows=2147483647&zona=1.0.8.2" ,$opts));
				
				$categories['categories'][$media_url->sectionId][] = array('sectionId' => $media_url->sectionId, 'id'=> 'AND%28genreId%3A%2812+OR+25+OR+26+OR+28+OR+27%29%29', 'class' => 'SmartVodListScreen', 'caption' => 'Все', 'description' => 'Все с каталога Zona');
				foreach ($jsd->response->docs as $v)
					$arr[$v->ord] = $v;
				ksort($arr);
				foreach ($arr as $v)
					$categories['categories'][$media_url->sectionId][] = array('sectionId' => $media_url->sectionId, 'id'=> 'AND%28genreId%3A%28'.$v->id.'%29%29', 'class' => 'SmartVodListScreen', 'caption' => HD::get_upper($v->name), 'description' => 'Категории сериалов с каталога Zona');
			}
		}else{
			if (!isset($categories['categories'][$media_url->sectionId])){
				$catalog_film['Все'] = 'all';
				$categories['categories'][$media_url->sectionId][] = array('sectionId' => $media_url->sectionId, 'id'=> 'all', 'class' => 'SmartVodListScreen', 'caption' => 'Все', 'description' => 'Все с каталога Zona');
				$catalog_film['Года'] = 'year_navigator';
				$categories['categories'][$media_url->sectionId][] = array('sectionId' => $media_url->sectionId, 'id'=> 'year', 'class' => 'SmartVodCategoryListScreen', 'caption' => 'Года', 'description' => 'Года с каталога Zona');
				$catalog_film['Страны'] = 'country_navigator';
				$categories['categories'][$media_url->sectionId][] = array('sectionId' => $media_url->sectionId, 'id'=> 'country', 'class' => 'SmartVodCategoryListScreen', 'caption' => 'Страны', 'description' => 'Страны с каталога Zona');
				$jsd = json_decode(self::http_get_document("http://zsolr3.zonasearch.com/solr/genre2/select/?q=*:*&version=2.2&wt=json&fl=id,name,ord,adult,fictional,custom&start=0&rows=2147483647&zona=1.0.8.2" ,$opts));
				foreach ($jsd->response->docs as $v){
					if (($v->adult == true)||($v->custom == true))
						continue;
					$arr[$v->ord] = $v;
				}
				ksort($arr);
				foreach ($arr as $v){
					$categories['categories'][$media_url->sectionId][] = array('sectionId' => $media_url->sectionId, 'id'=> 'AND%28genreId%3A%28'.$v->id.'%29%29', 'class' => 'SmartVodListScreen', 'caption' => HD::get_upper($v->name), 'description' => 'Категории с каталога Zona');
					self::$genreNames[$v->id] = HD::get_upper($v->name);
				}
			}
		}
		if (isset($media_url->categoryId)){
			if (($media_url->categoryId == 'year')&&(!isset($categories['categories']['year'])))
				for ($i = date('Y') + 1; $i > (1919); $i--)
					$categories['categories']['year'][] = array('sectionId' => $media_url->sectionId, 'id'=> "AND%28release_date%3A%5B$i-01-01T00%3A00%3A00.000Z+TO+$i-12-31T23%3A59%3A59.999Z%5D%29", 'class' => 'SmartVodListScreen', 'caption' => $i, 'description' => 'Категория с каталога Zona');
			if (($media_url->categoryId == 'country')&&(!isset($categories['categories']['country']))){
				$jsd =json_decode (self::http_get_document('http://zsolr3.zonasearch.com/solr/country/select/?q=*:*&version=2.2&wt=json&fl=id,name&start=0&rows=2147483647'));
				foreach ($jsd->response->docs as $v)
					$categories['categories']['country'][] = array('sectionId' => $media_url->sectionId, 'id'=> "AND%28country_id%3A%28".$v->id."%29%29", 'class' => 'SmartVodListScreen', 'caption' => HD::get_upper($v->name), 'description' => 'Категория с каталога Zona');
			}
			return $categories['categories'][$media_url->categoryId];
		}
		return $categories['categories'][$media_url->sectionId];
	}
	public static function getGenreName($id) {
		if (self::$genreNames == false){
			$opts [CURLOPT_USERAGENT] = "Java/1.8.0_171";
			$jsd = json_decode(self::http_get_document("http://zsolr3.zonasearch.com/solr/genre2/select/?q=*:*&version=2.2&wt=json&fl=id,name,ord,adult,fictional,custom&start=0&rows=2147483647&zona=1.0.8.2" ,$opts));
			foreach ($jsd->response->docs as $v)
				self::$genreNames[$v->id] = HD::get_upper($v->name);				
		}
		return self::$genreNames[$id];
	}
	public static function getShortMovieRange ($media_url, &$m_feed){
		$items = array();
		if ($m_feed === 'end')
			return $items;
		$sorting = (HD::getItemsArr(self::$className . '_sorting') != array()) ? HD::getItemsArr(self::$className . '_sorting') :  array('vod_torrentlist' => '0', 'sort' => 'year');
		$s = 'false';
		if (($media_url->sectionId == 'serial')||($media_url->sectionId == 'tvshow'))
			$s = 'true';
		if ($media_url->categoryId == 'all')
			$media_url->categoryId = '';
		$url = "http://zsolr3.zonasearch.com/solr/movie/select/?q=(NOT%28abuse%3Azona%29AND%28adult%3Afalse%29AND%28tor_count%3A%5B1+TO+2147483647%5D%29AND%28indexed%3A%5B1+TO+7%5D%29AND%28serial%3A$s%29" . $media_url->categoryId . ")&version=2.2&wt=json&sort=". $sorting['sort'] . "%20desc,release_date%20desc,id%20desc&fl=id,year,playable,trailer,quality,audio_quality,type3d,serial,languages_imdb,rating,genre,runtime,episodes,tor_count,serial_end_year,serial_ended,abuse,release_date_int,release_date_rus,indexed,geo_rules,partner_entity_id,partner_type,name_rus,name_ukr,name_eng,name_original&start=" . ($m_feed * 60) . "&rows=60";
		$opts [CURLOPT_USERAGENT] = "Java/1.8.0_171";
		$jsd = json_decode(self::http_get_document($url, $opts));
		if ((($m_feed+1) * 60 )> $jsd->response->numFound)
			$m_feed = 'end';
		++$m_feed;
		foreach ($jsd->response->docs as $v){
			$id = $v->id;
			$caption = $caption_original = $v->name_rus;
			if ($v->name_original != ''){
				$caption_original = $v->name_original;
				if ($v->name_rus == '')
					$caption = $v->name_original;
			}
			$short_movie = new ShortMovie(
				strval($id),
				strval($caption),
				strval(DuneSystem::$properties['plugin_cgi_url'] . "do?img=http://img2.zonapic.com/images/film_240/".substr($id, 0, -3)."/$id.jpg")
			);
			$info = '||' . $caption;
			$info .= '|' . $caption_original;
			$info .= '|| ' . $v->year;
			if ((isset($v->release_date_int))&&(preg_match("|(\d\d\d\d)-(\d\d)-(\d\d)|ms", $v->release_date_int, $matches)))
				$info .= '|Дата выхода: ' . $matches[3].'.' .$matches[2].'.'.$matches[1];
			else if ((isset($v->release_date_rus))&&(preg_match("|(\d\d\d\d)-(\d\d)-(\d\d)|ms", $v->release_date_rus, $matches)))
				$info .= '|Дата выхода: ' . $matches[3].'.' .$matches[2].'.'.$matches[1];
			if (isset($v->genre)){
				$category = '';
				foreach (json_decode($v->genre) as $g)
					$category .= self::getGenreName($g->i) . '; ';
				$info .= '|' . $category;
			}
						
			if (($v->quality == 15)&&($v->trailer == 1))
				$info .= "||Только трейлер";
			else if (($v->quality + $v->audio_quality) < 7)
				$info .= '||Высокое качество';
			else if (($v->quality + $v->audio_quality) > 20)
				$info .= '||Низкое качество';
			else if (($v->quality + $v->audio_quality) > 6)
				$info .= '||Среднее качество';
			if (preg_match('|-|', $v->rating))
				$info .= '|Rating: ' . (10 + round ($v->rating,2));
			else
				$info .= '|Rating: ' . round ($v->rating,2);
			if ((isset($v->serial_ended))&&($v->serial_ended == 1)){
				$info .= '||Сериал завершен|'.$v->serial_end_year;
			}
			
			if ((isset($v->episodes))&&(preg_match_all('|S(.+?)E(\d+)|ms', $v->episodes, $match)))
				$info .= '||Сезонов: '. (int)end($match[1]) . '|Всего эпизодов:'.count($match[1]);
			$short_movie->info = $info;
			$short_movie->newClassName = 'Kinopoisk_Class';
			array_push ($items, $short_movie);
		}
		return $items;
	}
	public function classAction ($defs, $user_input, $select_url = null){
		hd_restore_warnings();
		$post_action = null;
		$caption = 'Error!';
		$msg = 'classAction: action';
		$width = 1050;
		$parent_media_url = MediaURL::decode($user_input->parent_media_url);
		if ($user_input->action == 'sort'){
			$sorting = (HD::getItemsArr(self::$className . '_sorting') != array()) ? HD::getItemsArr(self::$className . '_sorting') :  array('vod_torrentlist' => '0', 'sort' => 'year');
			$add_params['control_id']= $user_input->control_id;
			$add_params['action'] = $user_input->action;
			$add_params['indiClass'] = self::$className;
			if ((isset($user_input->selected_control_id))&&(isset($user_input->action_type))){
				if (isset($user_input->initial_sel_ndx))
					$add_params['initial_sel_ndx'] = $user_input->initial_sel_ndx;
				if ($parent_media_url->screen_id == 'vod_torrentlist')
					$sorting['vod_torrentlist'] = $user_input->sorting;
				else
					$sorting['sort'] = $user_input->sorting;
				if (HD::saveItemsArr(self::$className . '_sorting', $sorting) == false)
					return ActionFactory::show_title_dialog("Сохранение не удалось");
				$action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $add_params);
				$action = ActionFactory::close_dialog_and_run($action);
				return ActionFactory::invalidate_folders(array($user_input->parent_media_url), $action);
			}
			$add_params['initial_sel_ndx'] = 0;
			if ($parent_media_url->screen_id == 'vod_torrentlist'){
				$sorting = $sorting['vod_torrentlist'];
				$sorting_ops[0]	= 'Выдача';
				$sorting_ops[1]	= 'Размер';
				$sorting_ops[2]	= 'Раздающие';
				$sorting = $sorting['vod_torrentlist'];
			}else{
				$sorting_ops['popularity']	= 'Популярные';
				$sorting_ops['rating']		= 'Рейтинговые';
				$sorting_ops['year']		= 'Новые';
				$sorting = $sorting['sort'];
			}
			
			ControlFactory::add_combobox($defs, $this, $add_params,
				'sorting', '',
				$sorting, $sorting_ops, 800, true, false
			);
			$attrs['initial_sel_ndx'] = isset($user_input->initial_sel_ndx) ? $user_input->initial_sel_ndx : -1;
			return ActionFactory::show_dialog("Cортировка:", $defs, true, 0, $attrs);
		}
		if (isset($user_input->selected_media_url))
			$selected_media_url = MediaURL::decode($user_input->selected_media_url);
		else{
			$msg = 'classAction: selected_media_url';
			return ActionFactory::show_title_dialog($caption, $post_action, $msg, 0);
		}
		$class_name = $selected_media_url->class_name;
		$parent_media_url = MediaURL::decode($user_input->parent_media_url);
		
		return ActionFactory::show_title_dialog($caption, $post_action, $msg, 0);
	}
	public static function getVodSourceInfo($v){
		$ico = SmartConfig::getPluginIco(self::$className);
		$sources['caption'] = 'Магнет ссылки';
		$sources['detailed_info'] = '||'.self::$cName.'|Магнит линки найденные на '.self::$cName.'.';
		$sources['icon_path'] = $ico;
		$sources['detailed_icon_path'] = $ico;
		$sources['goTo'] = 'SmartVodTorrentsScreen';
		$sources['class_name'] = $v;
		$sources['type'] = SmartConfig::getPluginIco('torrentSource');
		return $sources;
	}
	public static function getShortTorrentRange ($movie, $media_url, &$m_feed){
		$items = array();
		$sorting = (HD::getItemsArr(self::$className . '_sorting') != array()) ? HD::getItemsArr(self::$className . '_sorting') :  array('vod_torrentlist' => '0', 'sort' => 'year');
		if ($m_feed === 'end')
			return $items;
		if (!isset($movie->class_info['dbIDs']['kpID'])){
			return array();
		}else
			$id = $movie->class_info['dbIDs']['kpID'];
		$icon_path = SmartConfig::getPluginIco('s_magnet');
		static $get_info = array();
		if (isset($get_info[$id])){
			 $seeds_count = $get_info[$id]['seeds_count'];
			 $size_bytes = $get_info[$id]['size_bytes'];
			 $result = $get_info[$id]['result'];
		}else{
			$result = $get_info = array();
			$opts [CURLOPT_USERAGENT] = "Java/1.8.0_171";
			$doc = self::http_get_document("http://zsolr3.zonasearch.com/solr/torrent/select/?q=((kinopoisk_id:$id)AND(deleted:false))AND(indexed%3A[1+TO+7])&fl=id,kinopoisk_id,broadcast_id,translate_info,files,episodes,episodesInfo,episodes_map_auto,languages,language,languages_mod,languages_parser,subtitles,subtitles_mod,subtitles_parser,private,hash,torrent_download_link,seeds,peers,size_bytes,type3d,quality_id,audio_quality_id,trailer,resolution,video_info,loading_time_sum,loading_success_count,loading_fail_count&version=2.2&start=0&rows=2147483647&wt=json" ,$opts);
			$jsd = json_decode(preg_replace('/("size_bytes"):(\d+)/', '\\1:"\\2"', $doc));
			foreach ($jsd->response->docs as $k => $v){
				$size_bytes[$k] = $v->size_bytes;
				$seeds_count[$k]=$v->seeds;
				$sizeReadable = HD::readableBytes($v->size_bytes);
				if ((isset($v->files))&&($v->files != ''))
					$info = $name = preg_replace("/S\d+E\d+\./i", '', key(json_decode($v->files, 1)));
				if ((isset($v->resolution))&&($v->resolution != ''))
					$name = "[$v->resolution] " . $name;
				$short_movie = new ShortMovie(
					strval($v->torrent_download_link),
					strval($name),
					strval(Kinopoisk_Class::http_get_img("http://st.kp.yandex.net/images/film_iphone/iphone360_$id.jpg"))
				);
				if ((isset($v->resolution))&&($v->resolution != ''))
					$info .= "|$v->resolution";
				$short_movie->extra_item = "$sizeReadable|S:$v->seeds|L:$v->peers";
				$info .= "||$sizeReadable S:$v->seeds L:$v->peers";
				if ((isset($v->episodes_map_auto))&&($v->episodes_map_auto != '{}')){
					$file = json_decode($v->episodes_map_auto, 1);
					ksort($file);
					$strt = key($file);
					end($file);
					$end = key($file);
					$info .= "|$strt - $end";
				}
				if ((isset($v->languages_parser))&&($v->languages_parser != ''))
					$info .= '||Языки: ' . str_replace(" ", ", ", $v->languages_parser);
				if ((isset($v->subtitles_parser))&&($v->subtitles_parser != ''))
					$info .= '||Cубтитры: ' . str_replace(" ", ", ", $v->subtitles_parser);
				if ((isset($v->translate_info))&&($v->translate_info != ''))
					$info .= '||' . $v->translate_info;
				$info .= '||Найдено магнетов: ' . $jsd->response->numFound;
				$short_movie->info = $info;
				$short_movie->tType = 'magnet';
				$short_movie->icon_path = $icon_path;
				$short_movie->details_box_width = true;
				$result[$k] = $short_movie;
			}
			natsort($size_bytes);
			$size_bytes = array_keys (array_reverse ($size_bytes, true));
			$get_info[$id]['seeds_count'] = $seeds_count;
			$get_info[$id]['size_bytes'] = $size_bytes;
			$get_info[$id]['result'] = $result;
		}
		if (count($result) > 0){
			if ($sorting['vod_torrentlist'] == 0)
				$sort = $result;
			else if ($sorting['vod_torrentlist'] == 2){
				arsort($seeds_count);
				$seeds_count = array_keys ($seeds_count);
				foreach ($seeds_count as $k => $v)
					$sort[$k] = $result[$v];
			}else if ($sorting['vod_torrentlist'] == 1){
				foreach ($size_bytes as $k => $v)
					$sort[$k] = $result[$v];
			}
			$items = array_values ($sort);
		}
		$m_feed = 'end';
		return $items;
	}
	public static function getTorrentFile($torrent_id, $dloadPath=null){
		$torrentFile["status"] = true;
		$torrentFile["path"] = $torrent_id;
		return $torrentFile;
	}
	public static function http_get_document ($url, $opts=null){
		if (is_null(self::$proxy)){
			self::$proxy = false;
			$sitesProxy = HD::getItemsArr('sitesProxy');
			if (isset($sitesProxy[self::$cName])){
				$proxySettings = (HD::getItemsArr('proxySettings') != array()) ? HD::getItemsArr('proxySettings') : array();
				if (isset($proxySettings['proxy'])){
					self::$proxy['proxy'] = $proxySettings['proxy'];
					if ((isset($proxySettings['proxyType']))&&($proxySettings['proxyType'] == 'SOCKS5'))
						self::$proxy['proxyType'] = $proxySettings['proxyType'];
					if (isset($proxySettings['proxyAccount']))
						self::$proxy['proxyAccount'] = $proxySettings['proxyAccount'];
				}
			}
		}
		if (self::$proxy == true){
			$opts[CURLOPT_PROXY] = self::$proxy['proxy'];
			if (isset(self::$proxy['proxyType']))
				$opts[CURLOPT_PROXYTYPE] = CURLPROXY_SOCKS5;
			if (isset(self::$proxy['proxyAccount']))
				$opts[CURLOPT_PROXYUSERPWD] = self::$proxy['proxyAccount'];
		}
		return HD::http_get_document($url, $opts);
	}
}
?>