<?
if (!class_exists('DuneSystem')){
	if (preg_match('|plugins/(.*?)/lib|', __DIR__, $matches)){
		$tmp_path = '/tmp/plugins/'.$matches[1];
		$plugin_name = $matches[1];
		$install_dir = str_replace('/lib/wox', '',  __DIR__);
		if (file_exists('/persistfs/plugins_data'))
			$data_dir = "/persistfs/plugins_data/$plugin_name";
		else
			$data_dir = "/flashdata/plugins_data/$plugin_name";
        $port = HD::http_local_port();
		$www_url = "http://127.0.0.1:$port/plugins/$plugin_name/";
		$cgi_url = "http://127.0.0.1:$port/cgi-bin/plugins/$plugin_name/";
	}

	function hd_print($str){
		echo $str;
	}
	class DuneSystem{
		public static $properties = array ();
	};
	DuneSystem::$properties['plugin_name']      = $plugin_name;
	DuneSystem::$properties['install_dir_path'] = $install_dir;
	DuneSystem::$properties['tmp_dir_path']     = $tmp_path;
	DuneSystem::$properties['plugin_www_url']   = $www_url;
	DuneSystem::$properties['plugin_cgi_url']   = $cgi_url;
	DuneSystem::$properties['data_dir_path']    = $data_dir;
}

class m3uVOD_Class {
	static $linkArr = array();
	static $cName = 'm3uVOD';
	static $className = 'm3uVOD_Class';
	public static function getMainMenuInfo(){
		return array (
			'name' => self::$cName,
			'descr' => '||'.self::$cName.'|фильмы импортированные с m3u/m3u8 плейлистов'
		);
	}
	public static function get_media_url_str($k, $arr=null){
		if ($arr == true)
			return SmartVodCategoryListScreen::get_media_url_str($k, $arr);
		return SmartVodCategoryListScreen::get_media_url_str($k);
	}
	public static function getSearchMediaUrlStr($k, $arr = null){
		return SmartVodSimpleListScreen::get_media_url_str($k, $arr);
	}
	public static function getVodSourceInfo($v){
		$ico = SmartConfig::getPluginIco($v);
		$arr['caption'] = self::$cName;
		$arr['icon_path'] = $ico;
		$arr['detailed_icon_path'] = $ico;
		$arr['class_name'] = $v;
		$arr['detailed_info'] = '||' . self::$cName . '|видео с '.self::$cName.' плейлистов. Поиск видео производится по названию возможны неточности.';
		$arr['type'] = SmartConfig::getPluginIco('onlineSource');
		return $arr;
	}
	public static function getPopUpMenuItems ($selected_media_url, $parent_media_url){
		$menu_items = array();
		if ($parent_media_url != 'main_menu')
			$parent_media_url = MediaURL::decode($parent_media_url);
		if((isset($parent_media_url->screen_id))&&($parent_media_url->screen_id == 'vod_simplelist')){
			$menu_items[] = array(
				'caption' => 'Просм./Не просм.',
				'params' => array('action' => 'viewed', 'indiClass' => self::$className),
				'icon_url' => SmartConfig::getPluginIco('ss_eye')
			);
			if (HD::is_android() == true){
				$menu_items[] = array(
					'caption' => 'Играть Файл через Android',
					'conID' => 'playDirectly',
					'params' => array('is_android' => true),
					'icon_url' => SmartConfig::getPluginIco('s_android')
				);
			}
		}
		if (($parent_media_url == 'main_menu')||
		((isset($parent_media_url->screen_id))&&($parent_media_url->screen_id == 'vod_category_list'))){
			$m3uDataDirPath = smbtree::get_folder_info('m3uDataDirPath');
			if (($m3uDataDirPath != '')&&(file_exists($m3uDataDirPath))){
				if ($parent_media_url != 'main_menu')
					$menu_items[] = array(
						'caption' => 'Обновить плейлисты',
						'params' => array('action' => 'updateM3uVod', 'indiClass' => self::$className),
						'icon_url' => SmartConfig::getPluginIco('s_roundarr')
					);
				$menu_items[] = array(
					'caption' => 'm3u VOD Плейлисты',
					'params' => array('action' => 'addM3uVod', 'indiClass' => self::$className),
					'icon_url' => SmartConfig::getPluginIco('s_unselect')
				);
			}else
				$menu_items[] = array(
					'caption' => 'Расположение папки данных',
					'params' => array('action' => 'addM3uDataDirPath', 'indiClass' => self::$className),
					'icon_url' => SmartConfig::getPluginIco('s_home')
				);
		}
		return $menu_items;
	}
	public static function getScreenActionMapArr($media_url){
		$actionsArr = array();
		if (($media_url == 'main_menu')||
		((isset($media_url->screen_id))&&($media_url->screen_id == 'vod_category_list'))){
			$actionsArr[0]['create_action'] = 'classAction';
			$actionsArr[0]['params'] = array('action' => 'addM3uDataDirPath', 'indiClass' => self::$className);
			$actionsArr[0]['caption'] = 'Расположение данных';
			$actionsArr[0]['key'] = GUI_EVENT_KEY_C_YELLOW;
			
			$actionsArr[1]['create_action'] = 'classAction';
			$actionsArr[1]['params'] = array('action' => 'addM3uVod', 'indiClass' => self::$className);
			$actionsArr[1]['caption'] = 'Плейлисты';
			$actionsArr[1]['key'] = GUI_EVENT_KEY_B_GREEN;
			
			$actionsArr[2]['create_action'] = 'classAction';
			$actionsArr[2]['params'] = array('action' => 'updateM3uVod', 'indiClass' => self::$className);
			$actionsArr[2]['caption'] = 'Обновить';
			$actionsArr[2]['key'] = GUI_EVENT_KEY_D_BLUE;
		}
		if(isset($media_url->searchStr)){
			$actionsArr[0]['create_action'] = 'classAction';
			$actionsArr[0]['params'] = array ('indiClass' => self::$className,'action' => 'sort');
			$actionsArr[0]['caption'] = 'Сортировки';
			$actionsArr[0]['key'] = GUI_EVENT_KEY_C_YELLOW;
		}
		return $actionsArr;
	}
	public static function byLineLoadM3u($m3uFile, $fileName, $m3uDataDirPath){
		$text = fopen($m3uFile, "rb");
		$arrAll = $arrGroup = array();
		if ($text) {
			$i=0;
			while (($buffer = fgets($text)) !== false){
				$i++;
				if (preg_match('/\#EXTM3U/i', $buffer))
					continue;
				if (preg_match('/group-title="(.*?)"/i', $buffer, $result))
					$arrGroup[$result[1]][$i] = $i;
				if (preg_match('/\#EXTINF.*,(.*?)$/i', $buffer, $match)){
					$arrAll[$match[1]] = $i; 
				}
			}
		}
		fclose($text);
		file_put_contents($m3uDataDirPath . '/' . $fileName .'Group.json', json_encode($arrGroup));
		file_put_contents($m3uDataDirPath . '/' . $fileName .'All.json', json_encode($arrAll));
		return $arrGroup;
	}
	public static function loadM3uVod(){
		$m3uDataDirPath = smbtree::get_folder_info('m3uDataDirPath');
		if (($m3uDataDirPath != '')||(file_exists($m3uDataDirPath))){
			$m3uVodUrlsArr = HD::getItemsArr('m3uVodUrlsArr');
			if (count($m3uVodUrlsArr) > 0){
				foreach ($m3uVodUrlsArr as $k => $v){
					$md5Elder = false;
					$m3uFile = $m3uDataDirPath . '/' . $v . '.m3u';
					$hashFile = $m3uDataDirPath . '/' . $v . '.hash';
					$doc = HD::http_get_document($k);
					$md5Doc = md5($doc);
					if (file_exists($hashFile))
						$md5Elder = file_get_contents ($hashFile);
					if ($md5Doc != $md5Elder){
						file_put_contents ($m3uFile, $doc);
						file_put_contents ($hashFile, $md5Doc);
						$arr = self::byLineLoadM3u($m3uFile, $v, $m3uDataDirPath);
					}else
						$arr = (array)json_decode(file_get_contents ($m3uDataDirPath . '/' . $v .'Group.json'));
					$arr = array_flip (array_keys($arr));
					ksort($arr);
					$arrGroup[$k] =$arr;
				}
			}
			$m3uFiles = glob('{'.$m3uDataDirPath.'/*.[mM]3[uU]*}', GLOB_BRACE);
			if (count($m3uFiles) > 0){
				$m3uVodUrlsArr = array_flip ($m3uVodUrlsArr);
				foreach ($m3uFiles as $m3uFile){
					$md5Elder = false;
					$fileName = pathinfo($m3uFile, PATHINFO_FILENAME);
					$hashFile = $m3uDataDirPath . '/' . $fileName . '.hash';
					if (!isset($m3uVodUrlsArr[$fileName])){
						$md5File = md5_file($m3uFile);
						if (file_exists($hashFile))
							$md5Elder = file_get_contents ($hashFile);
						if ($md5File != $md5Elder){
							file_put_contents ($hashFile, $md5File);
							$arr = self::byLineLoadM3u($m3uFile, $fileName, $m3uDataDirPath);
						}else{
							if (file_exists($m3uDataDirPath . '/' . $fileName .'Group.json'))
								$arr = (array)json_decode(file_get_contents ($m3uDataDirPath . '/' . $fileName .'Group.json'));
							else{
								$arr = self::byLineLoadM3u($m3uFile, $fileName, $m3uDataDirPath);
								$arr = (array)json_decode(file_get_contents ($m3uDataDirPath . '/' . $fileName .'Group.json'));
							}
						}
						$arr = array_flip (array_keys($arr));
						ksort($arr);
						$arrGroup[$m3uFile] =$arr;
					}
				}
			}
		}else
			return array();
		return $arrGroup;
	}
	public static function getVodCategories($media_url){
		$category = null;
		if (isset($media_url->categoryId))
			$category = $media_url->categoryId;
		
		$m3uDataDirPath = smbtree::get_folder_info('m3uDataDirPath');
		if (($m3uDataDirPath == '')||(!file_exists($m3uDataDirPath)))
			$categories['categories'][] = array('id'=> 'addM3uDataDirPath', 'class' => 'SmartVodCategoryListScreen', 'caption' => 'Выбрать расположение', 'icon_path' => 'openfolder', 'description' => 'Выберите расположение папки данных импортированных из плейлистов');
		else{
			$cmdAsyncExec = DuneSystem::$properties['install_dir_path'] . '/www/cgi-bin/php-cgi -f ' .  DuneSystem::$properties['install_dir_path'] . "/www/cgi-bin/classActions.php action=loadM3uVod class_name=" . self::$className;
hd_print("cmdAsyncExec: $cmdAsyncExec\n");
			// echo "\nhttp://".HD::get_ip_address()."/cgi-bin/plugins/".DuneSystem::$properties['plugin_name']."/classActions?action=loadM3uVod&class_name=" . self::$className;
			$str = HD::asyncExec($cmdAsyncExec);
			if (!empty($str)){
				if ($str != '[]'){
					$categories['categories'][] = array('id'=> 'search', 'class' => 'SmartSearchScreen', 'caption' => "Поиск", 'description' => 'Поиск по всем плейлистам');
					$catArr = json_decode($str, true);
					foreach ($catArr as $k => $v){
						$fileName = pathinfo($k, PATHINFO_FILENAME);
						$categories['categories'][] = array('id'=> 'all', 'playlist' => $k, 'class' => 'SmartVodSimpleListScreen', 'caption' => "Все [$fileName]", 'description' => "Все итемы из плейлиста $fileName");
						foreach ($v as $key => $vel)
							$categories['categories'][] = array('id'=> $key, 'playlist' => $k, 'class' => 'SmartVodSimpleListScreen', 'caption' => "$key [$fileName]", 'description' => "Категория $key из плейлиста $fileName");
					}
				}else
					$categories['categories'][] = array('id'=> 'nill', 'class' => 'SmartVodCategoryListScreen', 'caption' => 'Ничего не найдено');
			}else{
				$categories['categories'][] = array('id'=> 'noll', 'class' => 'SmartVodCategoryListScreen', 'caption' => 'Обработка m3u VOD плейлиста' . str_repeat(".", rand(1, 5)), 'description' => "Это может занять какоето время в зависимости от размеров плейлистов");
				return $categories['categories'];
			}
		}
		return $categories['categories'];
	}
	public function classAction ($defs, $user_input, $select_url = null){
		hd_restore_warnings();
		$post_action = null;
		$caption = 'Error!';
		$msg = 'classAction: action';
		$width = 1050;
		if ($user_input->action == 'viewed'){
			if (!isset($user_input->selected_media_url))
                return null;
			$selected_media_url = MediaURL::decode($user_input->selected_media_url);
			$viewedItemsArr = HD::getItemsArr('viewedItemsArr');
			if (isset($viewedItemsArr[$selected_media_url->movie_id]))
				unset ($viewedItemsArr[$selected_media_url->movie_id]);
			else
				$viewedItemsArr[$selected_media_url->movie_id] = 'viewed';
			HD::saveItemsArr('viewedItemsArr', $viewedItemsArr);
			return ActionFactory::show_title_dialog("Внимание", null, 'Изменения применятся после повторного входа в каталог.', 550);
		}
		if ($user_input->action == 'sort'){
			$sorting = (HD::getItemsArr(self::$className . '_sorting') != array()) ? HD::getItemsArr(self::$className . '_sorting') : array('searchSort' => 0);
			$add_params['control_id']= $user_input->control_id;
			$add_params['action'] = $user_input->action;
			$add_params['indiClass'] = self::$className;
			if ((isset($user_input->selected_control_id))&&(isset($user_input->action_type))){
				if (isset($user_input->initial_sel_ndx))
					$add_params['initial_sel_ndx'] = $user_input->initial_sel_ndx;
				$sorting['searchSort'] = $user_input->sorting;
				if (HD::saveItemsArr(self::$className . '_sorting', $sorting) == false)
					return ActionFactory::show_title_dialog("Сохранение не удалось");
				$action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $add_params);
				$action = ActionFactory::close_dialog_and_run($action);
				return ActionFactory::invalidate_folders(array($user_input->parent_media_url), $action);
			}
			$add_params['initial_sel_ndx'] = 0;
			$sorting_ops = array(
				0 => 'По умолчанию',
				1 => 'По алфавиту'
			);
			$sorting = $sorting['searchSort'];
			ControlFactory::add_combobox($defs, $this, $add_params,
				'sorting', '',
				$sorting, $sorting_ops, 800, true, false
			);
			$attrs['initial_sel_ndx'] = isset($user_input->initial_sel_ndx) ? $user_input->initial_sel_ndx : -1;
			return ActionFactory::show_dialog("Cортировка:", $defs, true, 0, $attrs);
		}
		if (isset($user_input->selected_media_url))
			$selected_media_url = MediaURL::decode($user_input->selected_media_url);
		else{
			$msg = 'classAction: selected_media_url';
			return ActionFactory::show_title_dialog($caption, $post_action, $msg, 0);
		}
		$class_name = $selected_media_url->class_name;
		$parent_media_url = MediaURL::decode($user_input->parent_media_url);
		
		if ($user_input->action == 'addM3uVod'){
			$add_params['action'] = $user_input->action;
			$add_params['indiClass'] = self::$className;
			$m3uVodUrlsArr = HD::getItemsArr('m3uVodUrlsArr');
			$m3uDataDirPath = smbtree::get_folder_info('m3uDataDirPath');
			
			if ((isset($user_input->action_type))&&(isset($user_input->selected_control_id))){
				if (isset($user_input->initial_sel_ndx))
					$add_params['initial_sel_ndx'] = $user_input->initial_sel_ndx;
				if ($user_input->selected_control_id == 'm3uVodUrl'){
					if (preg_match('|^http|i', $user_input->m3uVodUrl)){//if (preg_match('/^(http|https)://([A-Z0-9][A-Z0-9_-]*(?:.[A-Z0-9][A-Z0-9_-]*)+):?(d+)?/?/i', $user_input->m3uVodUrl)){
						$m3uVodUrlsArr[$user_input->m3uVodUrl] = sprintf('%u',crc32($user_input->m3uVodUrl));//pathinfo($user_input->m3uVodUrl, PATHINFO_FILENAME);
						HD::saveItemsArr('m3uVodUrlsArr', $m3uVodUrlsArr);
					}else
						return ActionFactory::show_title_dialog('Не Сохранено!', null, 'Адрес плейлиста указан не верно.', 400);
					$post_action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $add_params);
					$post_action = ActionFactory::close_dialog_and_run($post_action);
					if ($parent_media_url->screen_id == 'main_menu')
						return ActionFactory::show_title_dialog('Сохранено', $post_action);
					else{
						self::loadM3uVod();
						HD::asyncExec('proc_close');
						$post_action = ActionFactory::invalidate_folders(array($user_input->parent_media_url), $post_action);
						return ActionFactory::show_title_dialog('Сохранено', $post_action);
					}
				}
				if ($user_input->selected_control_id == 'delSelectM3u'){
					if ($user_input->delSelectM3u != ''){
						$fileName = pathinfo($user_input->delSelectM3u, PATHINFO_FILENAME);
						if (isset($m3uVodUrlsArr[$user_input->delSelectM3u])){
							unset($m3uVodUrlsArr[$user_input->delSelectM3u]);
							HD::saveItemsArr('m3uVodUrlsArr', $m3uVodUrlsArr);
							$m3uWorkingFiles[] = $m3uDataDirPath . '/' . $fileName . '.m3u';
						}else
							$m3uWorkingFiles[] = $user_input->delSelectM3u;
						$m3uWorkingFiles[] = $m3uDataDirPath . '/' . $fileName . 'Group.json';
						$m3uWorkingFiles[] = $m3uDataDirPath . '/' . $fileName . '.hash';
						foreach ($m3uWorkingFiles as $v)
							if ((file_exists($v))&&(unlink($v) == false))
								return ActionFactory::show_title_dialog('Не Удалено!', null, "Не удалось удалить файл:\n" . $v, 800);
						$post_action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $add_params);
						$post_action = ActionFactory::close_dialog_and_run($post_action);
						if ($parent_media_url->screen_id == 'main_menu')
							return ActionFactory::show_title_dialog('Удалено', $post_action);
						else{
							self::loadM3uVod();
							HD::asyncExec('proc_close');
							$post_action = ActionFactory::invalidate_folders(array($user_input->parent_media_url), $post_action);
							return ActionFactory::show_title_dialog('Удалено', $post_action);
						}
					}else{
						$post_action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $add_params);
						return ActionFactory::close_dialog_and_run($post_action);
					}
						
				}
				if ($user_input->selected_control_id == 'addM3uDataDirPath'){
					$post_action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, array('action' => 'addM3uDataDirPath', 'indiClass' => self::$className));
					return ActionFactory::close_dialog_and_run($post_action);
				}
			}
			
			ControlFactory::add_multiline_label($defs, '', 'Папка хранения данных:', 3);
			
			$caption = 'Указать расположение папки хранения данных';
			if (($m3uDataDirPath != '')&&(file_exists($m3uDataDirPath))){
				$caption = 'Изменить расположение папки хранения данных';
				ControlFactory::add_vgap($defs, -35);
				ControlFactory::add_smart_label($defs, "", '<text color="23">'.$m3uDataDirPath.'</text>');
			}
			$add_params['initial_sel_ndx'] = 0;
			$add_params['control_id']= $user_input->control_id;
			ControlFactory::add_button(&$defs, $this, $add_params, 
				'addM3uDataDirPath', 
				'', 
				$caption, $width - 100, array('button_caption_centered' => false)
			);
			if (($m3uDataDirPath != '')&&(file_exists($m3uDataDirPath))){
				ControlFactory::add_multiline_label($defs, '', 'Плейлисты', 3);
				$add_params['initial_sel_ndx'] = $add_params['initial_sel_ndx'] + 1;
				ControlFactory::add_button(&$defs, $this, $add_params, 
				'addM3uDataDirPath', 
				'', 
				'Выберите локальный m3u/m3u8 плейлист*', $width - 100, array('button_caption_centered' => false));
				$add_params['initial_sel_ndx'] = $add_params['initial_sel_ndx'] + 1;
				ControlFactory::add_text_field($defs, $this, $add_params,
					'm3uVodUrl',
					'',
					'Укажите http/https адрес плейлиста**', 0, 0, 0, 1, $width - 100, 0, 1
				);
				$files = glob('{'.$m3uDataDirPath.'/*.[mM]3[uU]*}', GLOB_BRACE);
				if ((count($m3uVodUrlsArr)>0)||(count($files)>0)){
					ControlFactory::add_multiline_label($defs, '', 'Добавленные плейлисты:', 3);
					$add_params['initial_sel_ndx'] = $add_params['initial_sel_ndx'] + 1;
					$m3uVodUrlsArrOps[''] = 'Выберите плейлист что бы удалить его';
					foreach ($m3uVodUrlsArr as $k => $v)
						$m3uVodUrlsArrOps[$k] = HD::strimwidthCenter($k);
					
					if (count($files) > 0){
						$m3uVodUrlsArr = array_flip ($m3uVodUrlsArr);
						foreach ($files as $file){
							if (!isset($m3uVodUrlsArr[pathinfo($file, PATHINFO_FILENAME)])){
								$m3uVodUrlsArrOps[$file] = HD::strimwidthCenter($file);
							}
						}
					}
					ControlFactory::add_combobox($defs, $this, $add_params,
						'delSelectM3u', '',
						'', $m3uVodUrlsArrOps, $width - 100, true, false
					);
				}
				ControlFactory::add_smart_label($defs, "", '<text color="23" size="small">*Добавление локальных плейлистов это обычное копирование</text>');
				ControlFactory::add_vgap($defs, -35);
				ControlFactory::add_smart_label($defs, "", '<text color="23" size="small">в выбранную папку данных m3u VOD плейлистов</text>');
				ControlFactory::add_vgap($defs, -25);
				ControlFactory::add_smart_label($defs, "", '<text color="23" size="small">**Добавляйте только адреса самообновляемых плейлистов</text>');
				ControlFactory::add_vgap($defs, -35);
				ControlFactory::add_smart_label($defs, "", '<text color="23" size="small">которые загружаются по прямым ссылкам.</text>');
			}else
				ControlFactory::add_multiline_label($defs, '', 'Папка хранения данных не выбрана или удалена, выберите расположение папки хранения данных', 3);
			$attrs['initial_sel_ndx'] = isset($user_input->initial_sel_ndx) ? $user_input->initial_sel_ndx : -1;
			return ActionFactory::show_dialog("Добавление m3u/m3u8 VOD плейлистов", $defs, true, $width, $attrs);
		}
		if ($user_input->action == 'updateM3uVod'){
			self::loadM3uVod();
			HD::asyncExec('proc_close');
			$action = ActionFactory::show_title_dialog("Обновлено");
			return ActionFactory::invalidate_folders(array($user_input->parent_media_url), $action);
		}
		if ($user_input->action == 'addM3uDataDirPath'){
			$media_url = MediaURL::encode(
				array(
					'screen_id'     => 'file_list',
					'save_data'		=> 'm3uDataDirPath'
				)
			);
			return ActionFactory::open_folder($media_url,'Расположение данных:');
		}
		return ActionFactory::show_title_dialog($caption, $post_action, $msg, 0);
	}
	public static function getSearchShortMovieRange ($keyword, &$m_feed, $mfd = null){
		static $searchDataArr = array();
		$items = array();
		if (is_object($keyword))
			$keyword = $keyword->searchStr;
		if (($m_feed === 'end')||(mb_strlen($keyword,'UTF-8') < 3))
			return $items;
		$keyword = preg_replace ("/[^a-zA-ZА-Яа-я0-9\s]/iu", "", $keyword);
		$sorting = (HD::getItemsArr(self::$className . '_sorting') != array()) ? HD::getItemsArr(self::$className . '_sorting') : array('searchSort' => 0);
		self::loadM3uVod();
		$m3uDataDirPath = smbtree::get_folder_info('m3uDataDirPath');
		if (!isset($searchDataArr[$keyword])){
			$searchDataArr = array();
			if (($m3uDataDirPath != '')||(file_exists($m3uDataDirPath))){
				$m3uVodUrlsArr = HD::getItemsArr('m3uVodUrlsArr');
				if (count($m3uVodUrlsArr) > 0){
					foreach ($m3uVodUrlsArr as $k => $v){
						$allJson = $m3uDataDirPath . '/' . $v . 'All.json';
						$m3uFile = $m3uDataDirPath . '/' . $v . '.m3u';
						if ((file_exists($allJson))&&(file_exists($m3uFile))){
							$jsonsAll[$allJson]['fileName'] = pathinfo($k, PATHINFO_FILENAME);
							$jsonsAll[$allJson]['m3uFile'] = $m3uFile;
						}
					}
				}
				$m3uFiles = glob('{'.$m3uDataDirPath.'/*.[mM]3[uU]*}', GLOB_BRACE);
				if (count($m3uFiles) > 0){
					foreach ($m3uFiles as $m3uFile){
						$fileName = pathinfo($m3uFile, PATHINFO_FILENAME);
						$allJson = $m3uDataDirPath . '/' . $fileName . 'All.json';
						if ((file_exists($allJson))&&(!isset($jsonsAll[$allJson]))){
							$jsonsAll[$allJson]['fileName'] = $fileName;
							$jsonsAll[$allJson]['m3uFile'] = $m3uFile;
						}
					}
				}
			}
			if ((isset($jsonsAll))&&(count($jsonsAll) > 0)){
				$searchArr = array();
				foreach ($jsonsAll as $json => $infArr){
					$jsd = json_decode(file_get_contents($json));
					foreach ($jsd as $k => $v){
						$k = preg_replace ("/[^a-zA-ZА-Яа-я0-9\s]/iu", "", $k);
						if (preg_match("/". mb_strtolower($keyword, 'UTF-8') . "/i", mb_strtolower($k, 'UTF-8'), $m)){
							$searchDataArr[$keyword][trim($k) . '&playlist=' . $infArr['m3uFile']]['id'] = $v;
							$searchDataArr[$keyword][trim($k) . '&playlist=' . $infArr['m3uFile']]['fileName'] = $infArr['fileName'];
							$searchDataArr[$keyword][trim($k) . '&playlist=' . $infArr['m3uFile']]['m3uFile'] = $infArr['m3uFile'];
							$searchDataArr[$keyword][trim($k) . '&playlist=' . $infArr['m3uFile']]['name'] = $k;
						}
					}
				}
			}else
				$searchDataArr[$keyword] = array();
		}
		if ($mfd == true)
			return $searchDataArr;
		if ($sorting['searchSort'] == 1)
			ksort ($searchDataArr[$keyword]);
		if ((isset($searchDataArr[$keyword]))&&(count($searchDataArr[$keyword]) > 0)){
			$output = array_slice($searchDataArr[$keyword], ($m_feed * 10), 10);
			$viewedItemsArr = HD::getItemsArr('viewedItemsArr');
			foreach ($output as $v){
				$stream = new FileReader($v['m3uFile']);
				$stream->SetOffset($v['id'] - 1);
				$result = $stream->Read(2);
				if (count($result) > 0){
					foreach ($result as $line){
						if (preg_match('/.*,(?P<name>.*?)$/i', $line, $match)){
							$desc = array($v['fileName']);
							$name = trim($match['name']);
							if (preg_match('/(?<=video-title=")(?P<vtitle>.*?)(?=")/i', $line, $match))
								$desc[] = $match['vtitle'] . ' ';
							if (preg_match('/(?<=group-title=")(?P<groupTitle>.*?)(?=")/i', $line, $match))
								$desc[] =  $match['groupTitle'];
							if (preg_match('/(?<=video-desc=")(?P<desc>.*?)(?=")/i', $line, $match))
								$desc[] =  $match['desc'];
							
							$icon_path = $img = SmartConfig::getPluginIco('movie');
							if (preg_match('/(?<=tvg-logo=")(?P<tvgLogo>.*?)"/i', $line, $match))
								$img = self::http_get_img ($match['tvgLogo']);
						}else{
							$id = md5($name);
							$short_movie = new ShortMovie(
								strval($id),
								strval($name),
								strval($img)
							);
							$info = '||' . str_replace("|", "", $name);
							$short_movie->goToScreen = 'VodSeriesListScreen';
							if ($desc != ''){
								$short_movie->description = HD::str_remove_tag(implode (' ', $desc));
								$info .= '|' . implode ('|', $desc);
							}
							if ($icon_path != $img){
								$short_movie->icon_path = $icon_path;
								$short_movie->details_box_width = true;
							}
							if (isset($viewedItemsArr[$id])){
								if ($viewedItemsArr[$id] == 'viewed')
									$tt = '[ПРОСМ] ';
								else
									$tt = '[' . HD::sec_format_duration($viewedItemsArr[$id]['p']) . '/' . HD::sec_format_duration($viewedItemsArr[$id]['d']) . '] ';
								if ($viewedItemsArr[$id]['d'] > 0)
									$prsnt =  round(($viewedItemsArr[$id]['p']/$viewedItemsArr[$id]['d'])* 100);
								else
									$prsnt = 0;
								$info = "||Просмотренно: $prsnt %|$tt";
								$short_movie->extra_item = $tt;
							}
							$short_movie->info = $info;
							$short_movie->link = trim($line);
							array_push ($items, $short_movie);
						}
					}
				}
			}
			if (count($items) > 0)
				$m_feed++;
			else
				$m_feed = 'end';
		}else
			$m_feed = 'end';
		return $items;
	}
	public static function getShortMovieRange ($media_url, &$m_feed){
		static $dataArr = array();
		$items = array();
		if ($m_feed === 'end')
			return $items;
		$viewedIco = SmartConfig::getPluginIco('viewed');
		$m3uDataDirPath = smbtree::get_folder_info('m3uDataDirPath');
		$plName = pathinfo($media_url->playlist, PATHINFO_FILENAME);
		if (preg_match('|^http|i', $media_url->playlist)){
			$fileName = sprintf('%u',crc32($media_url->playlist));
			$media_url->playlist = $m3uDataDirPath . '/' . $fileName . '.m3u';
		}else
			$fileName = $fileName = pathinfo($media_url->playlist, PATHINFO_FILENAME);
		$viewedItemsArr = HD::getItemsArr('viewedItemsArr');
		if ($media_url->categoryId != 'all'){
			if (!isset($dataArr[$fileName][$media_url->categoryId])){
				$dataArr = array();
				$arr = json_decode(file_get_contents ($m3uDataDirPath . '/' . $fileName . 'Group.json'), true);
				$dataArr[$fileName][$media_url->categoryId] = $arr[$media_url->categoryId];
				unset ($arr);
			}
			$output = array_slice($dataArr[$fileName][$media_url->categoryId], ($m_feed * 10), 10);
			foreach ($output as $v){
				$stream = new FileReader($media_url->playlist);
				$stream->SetOffset($v - 1);
				$result = $stream->Read(2);
				if (count($result) > 0){
					foreach ($result as $line){
						if (preg_match('/.*,(?P<name>.*?)$/i', $line, $match)){
							$desc = array($plName);
							$name = trim($match['name']);
							if (preg_match('/(?<=video-title=")(?P<vtitle>.*?)(?=")/i', $line, $match))
								$desc[] = $match['vtitle'] . ' ';
							if (preg_match('/(?<=group-title=")(?P<groupTitle>.*?)(?=")/i', $line, $match))
								$desc[] =  $match['groupTitle'];
							if (preg_match('/(?<=video-desc=")(?P<desc>.*?)(?=")/i', $line, $match))
								$desc[] =  $match['desc'];
							
							$icon_path = $img = SmartConfig::getPluginIco('movie');
							if (preg_match('/(?<=tvg-logo=")(?P<tvgLogo>.*?)"/i', $line, $match))
								$img = self::http_get_img ($match['tvgLogo']);
						}else{
							$id = md5($name);
							$short_movie = new ShortMovie(
								strval($id),
								strval($name),
								strval($img)
							);
							$info = '||' . str_replace("|", "", $name);
							$short_movie->goToScreen = 'VodSeriesListScreen';
							if ($desc != ''){
								$short_movie->description = HD::str_remove_tag(implode (' ', $desc));
								$info .= '|' . implode ('|', $desc);
							}
							if ($icon_path != $img){
								$short_movie->icon_path = $icon_path;
								$short_movie->details_box_width = true;
							}
							
							$short_movie->link = trim($line);
							if (isset($viewedItemsArr[$id])){
								if ($viewedItemsArr[$id] == 'viewed')
									$tt = '[ПРОСМ] ';
								else
									$tt = '[' . HD::sec_format_duration($viewedItemsArr[$id]['p']) . '/' . HD::sec_format_duration($viewedItemsArr[$id]['d']) . '] ';
								if ($viewedItemsArr[$id]['d'] > 0)
									$prsnt =  round(($viewedItemsArr[$id]['p']/$viewedItemsArr[$id]['d'])* 100);
								else
									$prsnt = 0;
								$info = "||Просмотренно: $prsnt %|$tt";
								$short_movie->extra_item = $tt;
							}
							$short_movie->info = $info;
							array_push ($items, $short_movie);
						}
					}
				}
			}
			if (count($items) > 0)
				$m_feed++;
			else
				$m_feed = 'end';
		}else if (file_exists($media_url->playlist)){
			$stream = new FileReader($media_url->playlist);
			$stream->SetOffset(($m_feed * 100) + 1);
			$result = $stream->Read(100);
			if (count($result) > 0){
				foreach ($result as $line){
					if (preg_match('/.*,(?P<name>.*?)$/i', $line, $match)){
						$desc = array($plName);
						$name = trim($match['name']);
						if (preg_match('/(?<=video-title=")(?P<vtitle>.*?)(?=")/i', $line, $match))
							$desc[] = $match['vtitle'] . ' ';
						if (preg_match('/(?<=group-title=")(?P<groupTitle>.*?)(?=")/i', $line, $match))
							$desc[] =  $match['groupTitle'];
						if (preg_match('/(?<=video-desc=")(?P<desc>.*?)(?=")/i', $line, $match))
							$desc[] =  $match['desc'];
						
						$icon_path = $img = SmartConfig::getPluginIco('movie');
						if (preg_match('/(?<=tvg-logo=")(?P<tvgLogo>.*?)"/i', $line, $match))
							$img = self::http_get_img ($match['tvgLogo']);
					}else if (preg_replace ("/[^a-zA-ZА-Яа-я0-9\s]/iu", "", $line) != ''){
						$id = md5($name);
						$short_movie = new ShortMovie(
							strval($id),
							strval($name),
							strval($img)
						);
						$info = '||' . str_replace("|", "", $name);
						$short_movie->goToScreen = 'VodSeriesListScreen';
						if ($desc != ''){
							$short_movie->description = HD::str_remove_tag(implode (' ', $desc));
							$info .= '|' . implode ('|', $desc);
						}
						if ($icon_path != $img){
							$short_movie->icon_path = $icon_path;
							$short_movie->details_box_width = true;
						}
						if (isset($viewedItemsArr[$id])){
							if ($viewedItemsArr[$id] == 'viewed')
								$tt = '[ПРОСМ] ';
							else
								$tt = '[' . HD::sec_format_duration($viewedItemsArr[$id]['p']) . '/' . HD::sec_format_duration($viewedItemsArr[$id]['d']) . '] ';
							if ($viewedItemsArr[$id]['d'] > 0)
								$prsnt =  round(($viewedItemsArr[$id]['p']/$viewedItemsArr[$id]['d'])* 100);
							else
								$prsnt = 0;
							$info = "||Просмотренно: $prsnt %|$tt";
							$short_movie->extra_item = $tt;
							$short_movie->icon_path = $viewedIco;
							$short_movie->color_str = 3;
						}
						$short_movie->info = $info;
						$short_movie->link = trim($line);
						array_push ($items, $short_movie);
					}
				}
				$m_feed++;
			}else
				$m_feed = 'end';
		}else
			hd_print ('file not found:' . $media_url->playlist);
		return $items;
	}
	public static function getSeasons($media_url){
		$arr = (array)self::$linkArr;
		if (isset($arr[$media_url->hash_patrs->name])){
			foreach ($arr[$media_url->hash_patrs->name] as $v){
				if ($media_url->link == $v->m3uFile){
					if ((preg_match("|езон\s*(\d+)|i", $v->name, $m))||
					(preg_match("|(\d+).+?езон|i", $v->name, $m))){
						$uArr[$m[1]]['caption'] = 'Сезон '. $m[1];
						$uArr[$m[1]]['link'] = $v->m3uFile;
						$uArr[$m[1]]['detailed_info'] = '||' . 'Сезон '. $m[1] . $media_url->detailed_info;
						$uArr[$m[1]]['class_name'] = $media_url->class_name;
						$uArr[$m[1]]['poster_url'] = $media_url->poster_url;
						$uArr[$m[1]]['season'] = $m[1];
						$uArr[$m[1]]['goTo'] = 'VodSeriesListScreen';
					}else{
						$uArr[1]['caption'] = 'Сезон 1';
						$uArr[1]['link'] = $v->m3uFile;
						$uArr[1]['detailed_info'] = '||' . 'Сезон 1' . $media_url->detailed_info;
						$uArr[1]['class_name'] = $media_url->class_name;
						$uArr[1]['poster_url'] = $media_url->poster_url;
						$uArr[1]['season'] = $m[1];
						$uArr[1]['goTo'] = 'VodSeriesListScreen';
					}
				}
			}
		}else{
			echo 'err:672';
		}
		ksort ($uArr);
		return $uArr;
	}
	public static function get_series_list($media_url, $movie){
		secondTry:
		$arr = (array)self::$linkArr;
		if (isset($arr[$media_url->hash_patrs->name])){
			foreach ($arr[$media_url->hash_patrs->name] as $v){
				if (is_array($v))
					$v = (object)$v;
				if ($media_url->link == $v->m3uFile){
					if (isset($media_url->hash_patrs->season)){
						if ((preg_match("|езон\s*".$media_url->hash_patrs->season."|i", $v->name))||
						(preg_match("|".$media_url->hash_patrs->season.".+?езон|i", $v->name))){
							$stream = new FileReader($v->m3uFile);
							$stream->SetOffset($v->id - 1);
							$result = $stream->Read(2);
							if (count($result) > 0)
								foreach ($result as $line){
									if (preg_match('/.*,(?P<name>.*?)$/i', $line, $match)){
										$name = trim($match['name']);
									}
									if (!preg_match('/.*,(?P<name>.*?)$/i', $line, $match))
										$items[$name]['playback_url'] = trim($line);
								}
							$tvshow_se = VideoInfo::tvshow_se_parse($name);
							if (isset($tvshow_se['S']))
								$media_url->hash_patrs->season = $tvshow_se['S'];
							if (isset($tvshow_se['E']))
								$media_url->hash_patrs->episode = $tvshow_se['E'];
							else
								$media_url->hash_patrs->episode = $name;
							$hash_patrs = $media_url->caption;
							if (isset($media_url->hash_patrs))
								$hash_patrs = implode("", (array)$media_url->hash_patrs);
							$items[$name]['id'] = md5 ($hash_patrs);
							$items[$name]['title'] = $name;
							$items[$name]['is_stream_url'] = false;if (preg_match('~^storage_name|^storage_label|^storage_uuid|^main_storage|^smb|^nfs~i', $line))
								$arr['is_stream_url'] = true;
							$items[$name]['file_info']['poster_url'] = $media_url->poster_url;
							$items[$name]['file_info']['details_box_width'] = true;
							$items[$name]['file_info']['class_name'] = $media_url->class_name;
							$items[$name]['file_info']['detailed_info'] = $media_url->detailed_info;
							if (isset($media_url->description))
								$items[$name]['file_info']['description'] = $media_url->description;
						}
					}else{
						foreach ($arr[$media_url->hash_patrs->name] as $v){
							if ($media_url->link == $v->m3uFile){
							
							$stream = new FileReader($v->m3uFile);
							$stream->SetOffset($v->id - 1);
							$result = $stream->Read(2);
							if (count($result) > 0)
								foreach ($result as $line){
									if (preg_match('/.*,(?P<name>.*?)$/i', $line, $match)){
										$name = trim($match['name']);
									}
									if (!preg_match('/.*,(?P<name>.*?)$/i', $line, $match))
										$items[$name]['playback_url'] = trim($line);
								}
							$media_url->hash_patrs->episode = $name;
							$hash_patrs = $media_url->caption;
							if (isset($media_url->hash_patrs))
								$hash_patrs = implode("", (array)$media_url->hash_patrs);
							$items[$name]['id'] = md5 ($hash_patrs);
							$items[$name]['title'] = $name;
							$items[$name]['is_stream_url'] = false;						
							if (preg_match('~^storage_name|^storage_label|^storage_uuid|^main_storage|^smb|^nfs~i', $line))
								$arr['is_stream_url'] = true;
							$items[$name]['file_info']['poster_url'] = $media_url->poster_url;
							$items[$name]['file_info']['details_box_width'] = true;
							$items[$name]['file_info']['class_name'] = $media_url->class_name;
							$items[$name]['file_info']['detailed_info'] = $media_url->detailed_info;
							if (isset($media_url->description))
								$items[$name]['file_info']['description'] = $media_url->description;
							}
						}
					}
				}
			}
		}else if (!isset($st)){
			$m_feed = 0;
			self::$linkArr = self::getSearchShortMovieRange ($media_url->hash_patrs->name, $m_feed, true);
			$st = true;
			goto secondTry;
		}
		return $items;
	}
	public static function getIframe($params){
		$iframeInfo = array();
		$keyword = preg_replace ("/[^a-zA-ZА-Яа-я0-9\s]/iu","",$params['caption']);
		$m_feed = 0;
		$arr = self::getSearchShortMovieRange ($keyword, $m_feed, true);
		$poster_url = '';
		if (isset($arr[$keyword]))
			foreach ($arr[$keyword] as $v){
				$iframeInfo['urls'][$v['fileName']]['link'] = $v['m3uFile'];
				$iframeInfo['urls'][$v['fileName']]['caption'] = $v['fileName'];
				$iframeInfo['urls'][$v['fileName']]['poster_url'] = $poster_url;
				$iframeInfo['urls'][$v['fileName']]['goTo'] = 'VodSeriesListScreen';
				if (preg_match("|езон |i", $v['name']))
					$iframeInfo['urls'][$v['fileName']]['goTo'] = 'VodSeasonListScreen';
			}
		$iframeInfo['linkArr'] = $arr;
		$iframeInfo['className'] = self::$className;
		$m_feed = 0;
		if ((isset($iframeInfo['urls']))&&(count($iframeInfo['urls']) > 0))
			return $iframeInfo;
		return array("status" => 'null');
	}
	public static function load_movie($movie_id, $mUrl, $getMovieInfo){
		$arr = array();
		$arr['caption'] = $mUrl->caption;
		$arr['description'] = $mUrl->description;
		$arr['poster_url'] = $mUrl->poster_url;
		
		$arr['setSeriesList'] = true;
		$arr['id'] = $movie_id;
		$arr['title'] = $mUrl->caption;
		$arr['playback_url'] = $mUrl->link;
		$arr['is_stream_url'] = false;
		if (preg_match('~^storage_name|^storage_label|^storage_uuid|^main_storage|^smb|^nfs~i', $mUrl->link))
			$arr['is_stream_url'] = true;
		$arr['file_info']['poster_url'] = self::http_get_img ($mUrl->poster_url);//self::http_get_img ($jsd->items[0]->snippet->thumbnails->medium->url);
		$arr['file_info']['class_name'] = HD::str_remove_tag($mUrl->class_name);
		$arr['file_info']['description'] = HD::str_remove_tag($mUrl->description);
		$arr['file_info']['detailed_info'] = HD::str_remove_tag($mUrl->description);
		$arr['file_info']['icon_path'] = SmartConfig::getPluginIco('movie');
		$arr['file_info']['parent_media_url'] = 'noupd';
		return $arr;
	}
	public static function http_get_img ($url){
		if (!preg_match('|plugin_file\:|', $url))
			$url = DuneSystem::$properties['plugin_cgi_url'] . "do?img=" . $url;
		return $url;
	}
}
?>
