<?php
error_reporting (E_ALL);
require_once "do_config.php";
require_once str_replace('/www/cgi-bin', '', __DIR__) . "/lib/wow/TransmissionRPC.class.php";
if (preg_match('|plugins/(.*?)/www|', __DIR__, $matches))
	$tmp_path = '/tmp/plugins/'.$matches[1].'/exec_result';
$action = '';
if (isset($_REQUEST["action"]))
	$action = $_REQUEST["action"];
if (isset($_REQUEST["transmissionIp"])){
	$login=$pass=null;
	if (isset($_REQUEST["login"]))
		$login = urldecode($_REQUEST["login"]);
	if (isset($_REQUEST["pass"]))
		$pass = urldecode($_REQUEST["pass"]);
	$rpc = new TransmissionRPC($_REQUEST["transmissionIp"] . "/transmission/rpc", $login, $pass);
	if (($action == 'get')||($action == 'getFile')){
		$ids = array();
		$fields = array(
			"activityDate","addedDate","corruptEver", "doneDate","downloadDir","downloadedEver","errorString","eta",
			"hashString","id","isFinished", "isStalled", "name", "peersConnected", "peersGettingFromUs",
			"peersSendingToUs","percentDone", "priorities","queuePosition","rateDownload", "rateUpload",
			"recheckProgress","secondsDownloading","secondsSeeding","sizeWhenDone","status", "uploadedEver",
			"uploadRatio"
		);
		if (isset($_REQUEST["transmissionId"])){
			$ids[] = intval($_REQUEST["transmissionId"]);
			$fields[] = "files";
			$fields[] = "fileStats";
		}
		if (isset($_REQUEST["fields"]))
			$fields = json_decode ($_REQUEST["fields"], true);
		$result = $rpc->get($ids, $fields);
		$str = json_encode ($result);
	}else if ($action == 'remove'){
		if (isset($_REQUEST["ids"])){
			foreach (json_decode ($_REQUEST["ids"]) as $v)
				$ids[] = intval($v);
			$delete_local_data = false;
			if ($_REQUEST["delete_local_data"] == 1)
				$delete_local_data = true;
			$result = $rpc->remove ($ids, $delete_local_data);
			$str = json_encode ($result);
		}
	}else if ($action == 'add_file'){
		if (isset($_REQUEST["extra_options"])){
			$extraOptionsArr = json_decode(urldecode($_REQUEST["extra_options"]), true);
			foreach ($extraOptionsArr as $v)
				$extra_options["files-unwanted"][] = intval($v - 1);
			if (isset($_REQUEST["paused"]))
				$extra_options["paused"] = 'true';
			$result = $rpc->add_file ($_REQUEST["torrent_location"], false, $extra_options);
		}else if (isset($_REQUEST["paused"])){
			$extra_options["paused"] = 'true';
			$result = $rpc->add_file ($_REQUEST["torrent_location"], false, $extra_options);
		}else
			$result = $rpc->add_file ($_REQUEST["torrent_location"]);
		$str = json_encode ($result);
	}else if ($action == 'sget'){
		$result = $rpc->sget();
		$str = json_encode ($result);
	}else if ($action == 'sstats'){
		$result = $rpc->sstats();
		$str = json_encode ($result);
	}else if ($action == 'setPriorityHigh'){
		$ids[] = intval($_REQUEST["torrent_id"]);
		$arguments['priority-high'][] = intval($_REQUEST["file_id"]);
		$arguments['priority-high'][] = intval($_REQUEST["file_id"] + 1);
		$result = $rpc->set($ids, $arguments);
		$str = json_encode ($result);
	}
	file_put_contents ($tmp_path ."_" .$action, $str);
	echo '';
}
//"activityDate","addedDate","bandwidthPriority","comment","corruptEver","creator","dateCreated","desiredAvailable","doneDate","downloadDir","downloadedEver","downloadLimit","downloadLimited","editDate","error","errorString","eta","etaIdle","files","fileStats","hashString","haveUnchecked","haveValid","honorsSessionLimits","id","isFinished","isPrivate","isStalled","labels","leftUntilDone","magnetLink","manualAnnounceTime","maxConnectedPeers","metadataPercentComplete","name","peer-limit","peers","peersConnected","peersFrom","peersGettingFromUs","peersSendingToUs","percentDone","pieces","pieceCount","pieceSize","priorities","queuePosition","rateDownload (B/s)","rateUpload (B/s)","recheckProgress","secondsDownloading","secondsSeeding","seedIdleLimit","seedIdleMode","seedRatioLimit","seedRatioMode","sizeWhenDone","startDate","status","trackers","trackerStats","totalSize","torrentFile","uploadedEver","uploadLimit","uploadLimited","uploadRatio","wanted","webseeds","webseedsSendingToUs"
?>