<?php
class SmartConfig{
	static $idx = 0;
	static $processedSources = array();
	static $keyArr = array(
		GUI_EVENT_KEY_0,
		GUI_EVENT_KEY_1,
		GUI_EVENT_KEY_2,
		GUI_EVENT_KEY_3,
		GUI_EVENT_KEY_4,
		GUI_EVENT_KEY_5,
		GUI_EVENT_KEY_6,
		GUI_EVENT_KEY_7,
		GUI_EVENT_KEY_8,
		GUI_EVENT_KEY_9
	);
	static $newFavItems = array();
	
	public static function getPluginIco($icoName) {
		if (file_exists(HD::get_data_path() . "/icons/$icoName.png"))
			$link = HD::get_data_path() . "/icons/$icoName.png";
		else if (file_exists(DuneSystem::$properties['install_dir_path'] . "/icons/$icoName.png"))
			$link = "plugin_file://icons/$icoName.png";
		else if (preg_match("|_bg|", $icoName)){
			if (file_exists(HD::get_data_path() . "/icons/$icoName.jpg"))
				$link = HD::get_data_path() . "/icons/$icoName.jpg";
			else
				$link = 'gui_skin://images/bg.jpg';
		}else if (preg_match("|userFav_|",$icoName)){
			$link = 'plugin_file://icons/userFavFolder.png';
		}else
			$link = 'plugin_file://icons/folder.png';
		return $link;
	}
	public static function getQualityIco($name) {
		$icoName = HD::strSanitizing($name);
		if (file_exists(HD::get_data_path() . "/icons/quality/$icoName.png"))
			return HD::get_data_path() . "/icons/quality/$icoName.png";
		else if (file_exists(DuneSystem::$properties['install_dir_path'] . "/icons/quality/$icoName.png"))
			return "plugin_file://icons/quality/$icoName.png";
		hd_print ("=>$icoName<=>$name<=");
		return false;
	}
	public function reboot($user_input){
		hd_restore_warnings();
		if ((isset($user_input->action))&&($user_input->action === 'do_reboot'))
			return ActionFactory::restart();
		$defs = array();
		if (isset($user_input->msg))
			$msg = $user_input->msg;
		else
			$msg = 'Перезагрузить плеер сейчас?';
		ControlFactory::add_multiline_label($defs, '', $msg, 8);
		$add_params['action'] = 'do_reboot';
		$reboot = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $add_params);
		ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,'_reboot', 'Да', 250, $reboot);
		ControlFactory::add_close_dialog_button($defs, 'Нет', 250);
		return ActionFactory::show_dialog('Необходима перезагрузка плеера', $defs, true, 800);
	}
	
	public static function getVodSources($class_name, $movie=null, $media_url=null){
		
		static $lastId = null;
		static $sources = null;
		
		if ($class_name == 'sourcesIsNull'){
			$sources = null;
			self::$idx = 0;
			$lastId = null;
			self::$processedSources = array();
			HD::asyncExec('proc_close');
			return true;
		}
		if ($lastId != $movie->id){
			self::$idx = 0;
			$lastId = $movie->id;
			self::$processedSources = array();
			HD::asyncExec('proc_close');
			if (VodSourceListScreen::$needRefresh != false){
				self::$processedSources[1000]['slist'] = 'slist';
				self::$processedSources[1000]['caption'] = 'Получение списка источников и проверка логинов на сайты';
				return self::$processedSources;
			}
		}
		
		if (is_null($sources)){
			$s = self::getAllVodSources($media_url);
			$nbrSources = HD::getItemsArr('nbrSources');
			$fCat = array();
			foreach ($s as $k => $v){
				if (isset($nbrSources[$k]))
					$n = $nbrSources[$k];
				else
					$n = count ($fCat) - 1000;
				$fCat[$k] = $n;
				$sources[$n] = $v;
			}
			$diff1 = array_diff_key($fCat,$nbrSources);
			$diff2 = array_diff_key($nbrSources,$fCat);

			if ((!empty($diff1))||(!empty($diff2))){
				$fCat = array_flip($fCat);
				ksort($fCat);
				$fCat = array_values ($fCat);
				$nbrSources = array_flip($fCat);
				HD::saveItemsArr('nbrSources', $nbrSources);
			}
			ksort($sources);
			$sources = array_values ($sources);
		}
		$hideSources = HD::getItemsArr('hideSources', true);
		$sourseTypeSkip = (HD::getItemStr('sourseTypeSkip', true) != '') ? HD::getItemStr('sourseTypeSkip', true) : 0;
		if (self::$idx < count ($sources)){
			VodSourceListScreen::$needRefresh = true;
			do {
				if (isset($hideSources[$sources[self::$idx]['class_name']])){
					self::$idx++;
					continue;
				}
				if ($sourseTypeSkip != 0){
					if ((($sourseTypeSkip == 1)&&(!preg_match("|onlineSource|",$sources[self::$idx]['type'])))
						||(($sourseTypeSkip == 2)&&(preg_match("|onlineSource|",$sources[self::$idx]['type'])))){
						self::$idx++;
						continue;
					}
				}
				if (isset($sources[self::$idx]['goTo'])){
					if (($sources[self::$idx]['goTo'] == 'SmartVodRectangleListScreen')||
					($sources[self::$idx]['goTo'] == 'SmartVodTorrentsScreen')){
						if (preg_match('|(.*?)\n|', $movie->name_original, $m))
							$movie->name_original = $m[1];
						$hash_patrs['name'] = $movie->name;
						if ($sources[self::$idx]['goTo'] == 'SmartVodTorrentsScreen'){
							$sources[self::$idx]['pstr'] = true;
							$sources[self::$idx]['detailed_icon_path'] = $movie->poster_url;
						}
						if (isset($movie->name_original)){
							if (preg_match('|(.*?)\n|', $movie->name_original, $m))
								$hash_patrs['caption_original'] = $m[1];
							else if (!preg_match('|$Перевод:|', $movie->name_original))
								$hash_patrs['caption_original'] = $movie->name_original;
						}
						$year = '';
						if (preg_match('|(\d{4})|', $movie->country, $m)){
							$hash_patrs['year'] = $m[1];
							$tmp = explode (',', $movie->country);
							$year = '|' .  end($tmp);
						}else{
							$hash_patrs['year'] = $movie->year;
							$year = '|' . $movie->year;
						}
						$sources[self::$idx]['hash_patrs'] = $hash_patrs;
					}
					if (isset($sources[self::$idx]['variable'])){
						if (isset($media_url->links->className)){
							if ($sources[self::$idx]['class_name'] == $media_url->links->className)
								self::$processedSources[] = $sources[self::$idx];
						}
					}else
						self::$processedSources[] = $sources[self::$idx];
					self::$idx++;
					if (isset(self::$processedSources[1000]))
						unset(self::$processedSources[1000]);
					continue;
				}else if (!isset($sources[self::$idx]['goTo'])){
					if ($class_name == $sources[self::$idx]['class_name']){
						if (isset($movie->video_urls[$class_name])){
							foreach ($movie->video_urls[$class_name]['movie'] as $k => $v){
								echo 'getVodSources';//to be continue self::$processedSources[] =
							}
							self::$idx++;
							continue;
						}
						$params['movie_id'] = $movie->id;
					}
					$params['caption'] = $movie->name;
					if (isset($movie->name_original))
						$params['caption_original'] = $movie->name_original;
					if (isset($movie->year))
						$params['year'] = $movie->year;
					if (isset($movie->country))
						$params['country'] = $movie->country;
					if (isset($movie->class_info['linksArr']))
						$params['linksArr'] = $movie->class_info['linksArr'];
					if ((isset($movie->class_info['dbIDs']['myShowsID']))||
					((isset($movie->is_serial))&&($movie->is_serial == true)))
						$params['is_serial'] = true;
					if (isset($movie->class_info['dbIDs']['kpID']))
						$params['kpID'] = $movie->class_info['dbIDs']['kpID'];
					$cmdAsyncExec = DuneSystem::$properties['install_dir_path'] . '/www/cgi-bin/php-cgi -f ' .  DuneSystem::$properties['install_dir_path'] . "/www/cgi-bin/classActions.php action=getIframe class_name=" . $sources[self::$idx]['class_name'] ." params=" . urlencode(json_encode($params));
hd_print("EEE cmdAsyncExec: ".$cmdAsyncExec."\n");
					// echo "\nhttp://".HD::get_ip_address()."/cgi-bin/plugins/".DuneSystem::$properties['plugin_name']."/classActions?action=getIframe&class_name={$sources[self::$idx]['class_name']}&params=" . urlencode(json_encode($params));
					$str = HD::asyncExec($cmdAsyncExec);
					if (!empty($str)){
						if ($str != '[]'){
							$jsd = json_decode($str);
							if ((isset($jsd->urls))&&($jsd->urls != false)){
								foreach ($jsd->urls as $k => $v){
									$arr = array();
									if (isset($jsd->infoArr)){
										if (isset($jsd->infoArr->description))
											$arr['description'] = $jsd->infoArr->description;
										$poster_url = $jsd->infoArr->poster_url;
										$hash_patrs['name'] = $jsd->infoArr->caption;
										if (isset($jsd->infoArr->caption_original)){
											if (preg_match('|(.*?)\n|', $jsd->infoArr->caption_original, $m))
												$hash_patrs['caption_original'] = $m[1];
											else
												$hash_patrs['caption_original'] = $jsd->infoArr->caption_original;
										}
										$year = '';
										if (isset($jsd->infoArr->year)){
											$hash_patrs['year'] = $jsd->infoArr->year;
											$year = '|' . $jsd->infoArr->year;
										}
										$caption = $jsd->infoArr->caption;
										if ($k != $sources[self::$idx]['class_name']::$cName)
											$caption = "[$k] " . $jsd->infoArr->caption;
										else
											$k = '';
										$detailed_info = '||' . $jsd->infoArr->caption;
										if (isset($jsd->infoArr->caption_original))
											$detailed_info .= '|' . $jsd->infoArr->caption_original;
										$detailed_info .= $year .'||' . $sources[self::$idx]['class_name']::$cName . '|' . $k;
										if (isset($jsd->infoArr->detailed_info))
											$detailed_info .= '|' . $jsd->infoArr->detailed_info;
									}else{
										$poster_url = $movie->poster_url;
										if (preg_match('|(.*?)\n|', $movie->name_original, $m))
											$movie->name_original = $m[1];
										$hash_patrs['name'] = $movie->name;
										if (isset($movie->name_original)){
											if (preg_match('|(.*?)\n|', $movie->name_original, $m))
												$hash_patrs['caption_original'] = $m[1];
											else if (!preg_match('|$Перевод:|', $movie->name_original))
												$hash_patrs['caption_original'] = $movie->name_original;
										}
										$year = '';
										if (preg_match('|(\d{4})|', $movie->country, $m)){
											$hash_patrs['year'] = $m[1];
											$tmp = explode (',', $movie->country);
											$year = '|' .  end($tmp);
										}else{
											$hash_patrs['year'] = $movie->year;
											$year = '|' . $movie->year;
										}
										$caption = $movie->name;
										if ($k != $sources[self::$idx]['class_name']::$cName)
											$caption = "[$k] " . $movie->name;
										else
											$k = '';
										$detailed_info = '||' . $movie->name . '|' . $movie->name_original . $year .'||' . $sources[self::$idx]['class_name']::$cName . '|' . $k;
									}
									$arr['caption'] = $caption;
									$arr['icon_path'] =  $sources[self::$idx]['icon_path'];
									$arr['detailed_icon_path'] = $poster_url;
									$arr['detailed_info'] = $detailed_info;
									$arr['class_name'] = $sources[self::$idx]['class_name'];
									$arr['goTo'] = $v->goTo;
									$arr['link'] = $v->link;
									$arr['hash_patrs'] = $hash_patrs;
									$arr['type'] =  $sources[self::$idx]['type'];
									$arr['left_bottom'] =  $sources[self::$idx]['class_name']::$cName;
									self::$processedSources[] = $arr;
								}
								if (isset($jsd->linkArr)){
									self::$processedSources['linkArr'] = $jsd->linkArr;
									self::$processedSources['className'] = $jsd->className;
								}
								if (isset(self::$processedSources[1000]))
									unset(self::$processedSources[1000]);
							}
						}else
							unset(self::$processedSources[1000]);
						HD::asyncExec('proc_close');
						self::$idx++;
						return self::$processedSources;
					}else{
						self::$processedSources[1000] = $sources[self::$idx];
						self::$processedSources[1000]['inWork'] = 'inWork';
						self::$processedSources[1000]['caption'] = $sources[self::$idx]['caption'] . ' получение ссылок';
						return self::$processedSources;
					}
				}
				
			} while (self::$idx < count ($sources));
		}else{
			if (isset(self::$processedSources[1000]))
				unset(self::$processedSources[1000]);
			self::$processedSources[1000]['completed'] = 'completed';
			self::$processedSources[1000]['caption'] = 'Поиск источников завершен';
			VodSourceListScreen::$needRefresh = false;
		}
		return self::$processedSources;
	}
	
	public static function getAllVodSources($media_url){
		static $sources = null;
		if (is_null($sources)){
			$wox = self::getWox();
			$ico = SmartConfig::getPluginIco('Youtube_Class');
			$online = SmartConfig::getPluginIco('onlineSource');
			$sources['Trailers']['caption'] = 'Трейлеры';
			$sources['Trailers']['detailed_info'] = '||Трейлеры|трейлеры c Кинопоиска и Youtube. Поиск трейлеров на Youtube производится по названию возможны неточности.';
			$sources['Trailers']['icon_path'] = $ico;
			$sources['Trailers']['detailed_icon_path'] = $ico;
			$sources['Trailers']['goTo'] = 'VodSeriesListScreen';
			$sources['Trailers']['class_name'] = 'Trailers';
			$sources['Trailers']['type'] = $online;
						
			foreach($wox as $v){
				$source = $v::getVodSourceInfo($v);
				if ($source != false)
					$sources[$v] = $source;
			}
		}
		return $sources;
	}
	
	public static function getWox(){
		static $php_files = null;
		if (is_null($php_files))
			foreach (glob('{'.DuneSystem::$properties['install_dir_path'].'/lib/wox/*.php}', GLOB_BRACE) as $file)
				$php_files[] = basename($file, ".php");
		return $php_files;
	}
	
	public function rightButtonAction ($movie, $user_input, $left_button_caption){
		$w = 750;
		$parent_media_url = MediaURL::decode($user_input->parent_media_url);
		
		$rightButtonActionArr['Избранное']['control_id'] = 'classAction';
		$rightButtonActionArr['Избранное']['control_id'] = 'classAction';
		$rightButtonActionArr['Избранное']['add_params']['action'] = 'addToFav';
		if (isset($movie->class_info['dbIDs']['myShowsID']))
			$rightButtonActionArr['Избранное']['add_params']['myShowsID'] = $movie->class_info['dbIDs']['myShowsID'];
		else if ((isset($movie->class_info['dbIDs']['kpID']))&&((isset($movie->is_serial))&&($movie->is_serial == true)))
			$rightButtonActionArr['Избранное']['add_params']['kpID'] = $movie->class_info['dbIDs']['kpID'];	
		$class_name = $parent_media_url->class_name;
		if ($left_button_caption == 'Просмотр'){
			$rightButtonActionArr['Открыть Источники']['control_id'] = 'classAction';
			$rightButtonActionArr['Открыть Источники']['add_params']['action'] = 'openSource';
		}
		if ((isset($movie->is_serial))&&(isset($movie->class_info['dbIDs']['kpID']))){
			$rightButtonActionArr['Сезоны и эпизоды']['control_id'] = 'classAction';
			$rightButtonActionArr['Сезоны и эпизоды']['add_params']['action'] = 'kpEpisodesInfo';
			$rightButtonActionArr['Сезоны и эпизоды']['add_params']['kpID'] = $movie->class_info['dbIDs']['kpID'];
			$rightButtonActionArr['Избранное']['add_params']['kpID'] = $movie->class_info['dbIDs']['kpID'];
		}
		
		$rightButtonActionArr['Поиск']['control_id'] = 'classAction';
		$rightButtonActionArr['Поиск']['add_params']['action'] = 'search';
		if ($class_name != 'myShows_Class'){
			$myShowsIds = HD::getItemsArr('myShowsIds');
			if (isset($myShowsIds[$parent_media_url->movie_id])){
				$rightButtonActionArr['Удалить myShowsID ['.$myShowsIds[$parent_media_url->movie_id].']']['control_id'] = 'classAction';
				$rightButtonActionArr['Удалить myShowsID ['.$myShowsIds[$parent_media_url->movie_id].']']['add_params']['action'] = 'setMyShowId';
				$rightButtonActionArr['Удалить myShowsID ['.$myShowsIds[$parent_media_url->movie_id].']']['add_params']['delMyShowId'] = $parent_media_url->movie_id;
				$rightButtonActionArr['Избранное']['add_params']['myShowsID'] = $myShowsIds[$parent_media_url->movie_id];
			}else{
				// if (isset($movie->is_serial)){
					$rightButtonActionArr['Задать/исправить myShowsID']['control_id'] = 'classAction';
					$rightButtonActionArr['Задать/исправить myShowsID']['add_params']['action'] = 'setMyShowId';
					if (isset($movie->name))
						$rightButtonActionArr['Задать/исправить myShowsID']['add_params']['caption'] = $movie->name;
					if (isset($movie->name_original))
						$rightButtonActionArr['Задать/исправить myShowsID']['add_params']['caption_original'] = $movie->name_original;
				// }
			}
		}
		if ((isset($movie->class_info['dbIDs']['myShowsID']))&&(isset($user_input->mShowsA))){
			$jsd = VideoInfo::get_profile_shows_myshows ($user_input->mShowsA);
			foreach ($jsd as $v)
				$arr[$v->show->id] = $v->watchStatus;
			if (isset($arr[$movie->class_info['dbIDs']['myShowsID']])){
				$named_array = myShows_Class::getMyShowsNamedArr(true);
				$watchStatus = $arr[$movie->class_info['dbIDs']['myShowsID']];
				$caption = 'myShows: ' . $named_array [$watchStatus];
				$rightButtonActionArr[$caption]['add_params']['myShowStatus'] = $watchStatus;
			}else{
				$caption = 'Добавить в myShows';
				$rightButtonActionArr[$caption]['add_params']['myShowStatusNew'] = 'watching';
			}
			$rightButtonActionArr[$caption]['control_id'] = 'classAction';
			$rightButtonActionArr[$caption]['add_params']['action'] = 'setMyShowStatus';
			$rightButtonActionArr[$caption]['add_params']['mShowsA'] = $user_input->mShowsA;
			$rightButtonActionArr[$caption]['add_params']['myShowsID'] = $movie->class_info['dbIDs']['myShowsID'];
			$rightButtonActionArr['Избранное']['add_params']['myShowsID'] = $movie->class_info['dbIDs']['myShowsID'];
		}
		
		if ($class_name != 'Kinopoisk_Class'){
			$kpIDs = HD::getItemsArr('kpIDs');
			if (isset($kpIDs[$parent_media_url->movie_id])){
				$rightButtonActionArr['Удалить Id Кинопоиска ['.$kpIDs[$parent_media_url->movie_id].']']['control_id'] = 'classAction';
				$rightButtonActionArr['Удалить Id Кинопоиска ['.$kpIDs[$parent_media_url->movie_id].']']['add_params']['action'] = 'searchKpId';
				$rightButtonActionArr['Удалить Id Кинопоиска ['.$kpIDs[$parent_media_url->movie_id].']']['add_params']['delSearchKpId'] = $parent_media_url->movie_id;
				$rightButtonActionArr['Избранное']['add_params']['kpID'] = $kpIDs[$parent_media_url->movie_id];
			}else{
				$rightButtonActionArr['Задать/исправить Id Кинопоиска']['control_id'] = 'classAction';
				$rightButtonActionArr['Задать/исправить Id Кинопоиска']['add_params']['action'] = 'searchKpId';
				if (isset($movie->name))
					$rightButtonActionArr['Задать/исправить Id Кинопоиска']['add_params']['caption'] = $movie->name;
				if (isset($movie->name_original))
					$rightButtonActionArr['Задать/исправить Id Кинопоиска']['add_params']['caption_original'] = $movie->name_original;
			}
		}
		if(isset($movie->class_info['dbIDs']['kpID'])){
			$rightButtonActionArr['Актеры и режиссеры']['control_id'] = 'classAction';
			$rightButtonActionArr['Актеры и режиссеры']['add_params']['action'] = 'kpActorsAndDirectors';
			$rightButtonActionArr['Актеры и режиссеры']['add_params']['kpID'] = $movie->class_info['dbIDs']['kpID'];
			
			$rightButtonActionArr['Похожие фильмы']['control_id'] = 'classAction';
			$rightButtonActionArr['Похожие фильмы']['add_params']['action'] = 'kpSimilarSequelsPrequelsRelatedFilms';
			$rightButtonActionArr['Похожие фильмы']['add_params']['operationID'] = 'kp_similar_films';
			$rightButtonActionArr['Похожие фильмы']['add_params']['caption'] = 'Похожие фильмы';
			$rightButtonActionArr['Похожие фильмы']['add_params']['kpID'] = $movie->class_info['dbIDs']['kpID'];
			
			$rightButtonActionArr['Сиквелы и приквелы']['control_id'] = 'classAction';
			$rightButtonActionArr['Сиквелы и приквелы']['add_params']['action'] = 'kpSimilarSequelsPrequelsRelatedFilms';
			$rightButtonActionArr['Сиквелы и приквелы']['add_params']['operationID'] = 'kp_sequels_and_prequels_films';
			$rightButtonActionArr['Сиквелы и приквелы']['add_params']['caption'] = 'Сиквелы и приквелы';
			$rightButtonActionArr['Сиквелы и приквелы']['add_params']['kpID'] = $movie->class_info['dbIDs']['kpID'];
			
			$rightButtonActionArr['Связанные фильмы']['control_id'] = 'classAction';
			$rightButtonActionArr['Связанные фильмы']['add_params']['action'] = 'kpSimilarSequelsPrequelsRelatedFilms';
			$rightButtonActionArr['Связанные фильмы']['add_params']['operationID'] = 'kp_related_films';
			$rightButtonActionArr['Связанные фильмы']['add_params']['caption'] = 'Связанные фильмы';
			$rightButtonActionArr['Связанные фильмы']['add_params']['kpID'] = $movie->class_info['dbIDs']['kpID'];
			
			$rightButtonActionArr['Отзывы Кинопоиск']['control_id'] = 'classAction';
			$rightButtonActionArr['Отзывы Кинопоиск']['add_params']['indiClass'] = 'Kinopoisk_Class';
			$rightButtonActionArr['Отзывы Кинопоиск']['add_params']['action'] = 'reviews';
			$rightButtonActionArr['Отзывы Кинопоиск']['add_params']['kpID'] = $movie->class_info['dbIDs']['kpID'];
		}
		
		if (file_exists(HD::get_data_path() . "/icons/" . $parent_media_url->screen_id . "_bg.jpg")){
			$rightButtonActionArr['Удалить бекграунд']['control_id'] = 'classAction';
			$rightButtonActionArr['Удалить бекграунд']['add_params']['action'] = 'background_actions';
			$rightButtonActionArr['Удалить бекграунд']['add_params']['del'] = true;
		}else{
			$rightButtonActionArr['Задать бекграунд']['control_id'] = 'classAction';
			$rightButtonActionArr['Задать бекграунд']['add_params']['action'] = 'background_actions';
		}
		$pluginCachePath = HD::get_data_path() . "/pluginCache/";
		$infoCachePath = $pluginCachePath . md5($parent_media_url->movie_id . $parent_media_url->class_name) . '.srz';
		if (file_exists($infoCachePath)){
			$rightButtonActionArr['Обновление кеша карточки фильма']['control_id'] = 'classAction';
			$rightButtonActionArr['Обновление кеша карточки фильма']['add_params']['action'] = 'pluginInfoCacheDel';
			$rightButtonActionArr['Обновление кеша карточки фильма']['add_params']['infoCachePath'] = $infoCachePath;
		}
		foreach ($rightButtonActionArr as $k => $v){
			$add_params = null;
			extract($rightButtonActionArr[$k]);
			ControlFactory::add_close_dialog_and_apply_button($defs, $this, $add_params, $v['control_id'], $k, $w);
			ControlFactory::add_vgap($defs, (-10));
		}
		return ActionFactory::show_dialog('Действия', $defs, true);
	}
	
	public function userTorrentAction($user_input, $movie){
		hd_restore_warnings();
		if (!isset($user_input->selected_media_url))
            $user_input->selected_media_url = $user_input->parent_media_url;
		
		if ($user_input->selected_media_url == 'notrt')
			return ActionFactory::show_title_dialog("ok!", null, '');
		if (!isset($user_input->event_key))
			$user_input->event_key = 'enter';
		if (isset($user_input->torrServAction)){
			$selected_media_url = MediaURL::decode($user_input->selected_media_url);
			$class_name = $selected_media_url->class_name;
			if (isset($selected_media_url->goToSelfScreen))
				return ActionFactory::open_folder();
			if (isset($selected_media_url->torrentSourseClassName))
				$class_name = $selected_media_url->torrentSourseClassName;
			$torrentFile = $class_name::getTorrentFile($selected_media_url->torrent_id);
			if ($torrentFile["status"] == true){
				HD::asyncExec('proc_close');
				VodTorrServerScreen::$counter = 0;
				TorrServer::actionGetTorrentList();
				$hash = TorrServer::torrserverAddTorrent($torrentFile["path"], $user_input->torrServAction, $movie);
				if ($hash == true){
					if ($user_input->torrServAction == 2)
						return ActionFactory::show_title_dialog("Добавлен", null, $selected_media_url->caption);
					else
						return UserInputHandlerRegistry::create_action($this, 'classAction', array ('action' => 'getTorrserverHashInfo', 'hash' => $hash, 'indiClass' => 'TorrServer'));
				}else
					return ActionFactory::show_title_dialog("Добавление не удалось", null, 'Возможно используется не торрент файл');
			}else
				return ActionFactory::show_title_dialog("Eror!", null, $torrentFile["descr"]);
		}
		
		$defs = array();
		$torrentAction = (HD::getItemStr('torrentAction', true) != '') ? HD::getItemStr('torrentAction', true) : 0;
		$parent_media_url = MediaURL::decode($user_input->parent_media_url);
		if (isset($parent_media_url->torrentClassName)){
			$actionArr = array('TorrServer' => 2, 'PeerflixServer' => 3, 'TransmissionUPnP' => 5);
			if (isset($actionArr[$parent_media_url->torrentClassName]))
				$torrentAction = $actionArr[$parent_media_url->torrentClassName];
		}
		if ($torrentAction == 0){
			return  UserInputHandlerRegistry::create_action($this, 'classAction', 
			array ('action' => 'torrentActionSetup', 'event_key' => $user_input->event_key));
		}else{
			$selected_media_url = MediaURL::decode($user_input->selected_media_url);
			if (isset($user_input->torrentAction))
				$torrentAction = $user_input->torrentAction;
			if ($torrentAction == 2){
				if (TorrServer::getOnlineStatusServer() == true){
					if (isset($user_input->event_key)){
						$actionTorrServ = (HD::getItemsArr('actionTorrServ', true) !=array()) ? HD::getItemsArr('actionTorrServ', true) : array('play' => 0, 'enter' => 0);
						if ($actionTorrServ[$user_input->event_key] == 3){
							ControlFactory::add_button_close(&$defs, $this, array ('torrServAction' => 0), $user_input->control_id, '', 'Добавить и проиграть', 500);
							ControlFactory::add_button_close(&$defs, $this, array ('torrServAction' => 1), $user_input->control_id, '', 'Проиграть', 500);
							ControlFactory::add_button_close(&$defs, $this, array ('torrServAction' => 2), $user_input->control_id, '', 'Только добавить', 500);
							return ActionFactory::show_dialog('TorrServ', $defs, true, 600);					
						}else
							return UserInputHandlerRegistry::create_action($this, $user_input->control_id, array ('torrServAction' => $actionTorrServ[$user_input->event_key]));
					}
				}else{
					$action = UserInputHandlerRegistry::create_action($this, 'classSetupTorrServer');
hd_print("EEE tni 3");
					return ActionFactory::show_title_dialog('TorrServer не запущен', $action, TorrServer::getIp(), 0);
				}
			}
			if ($torrentAction == 3){
				if (PeerflixServer::getOnlineStatusServer() == true){
					$selected_media_url = MediaURL::decode($user_input->selected_media_url);
					$class_name = $selected_media_url->class_name;
					if (isset($selected_media_url->torrentSourseClassName))
						$class_name = $selected_media_url->torrentSourseClassName;
					$torrentFile = $class_name::getTorrentFile($selected_media_url->torrent_id);
					if ($torrentFile["status"] == true){
						HD::asyncExec('proc_close');
						VodPeerflixServerScreen::$counter = 0;
						PeerflixServer::actionGetTorrentList();
						$hash =PeerflixServer::peerflixServerAddTorrent($torrentFile["path"], $movie);
						if ($hash == true)
							return UserInputHandlerRegistry::create_action($this, 'classAction', array ('action' => 'getPeerflixServerHashInfo', 'hash' => $hash, 'indiClass' => 'PeerflixServer'));
						else
							return ActionFactory::show_title_dialog("Добавление не удалось", null, 'Возможно используется не торрент файл');
					}else
						return ActionFactory::show_title_dialog("Eror!", null, $torrentFile["descr"]);
				}else if (PeerflixServer::getSlavePeerflixServer() == true){
					hd_silence_warnings();
					return PeerflixServer::startPeerflixServer($defs, $user_input);
				}
				$action = UserInputHandlerRegistry::create_action($this, 'classSetupPeerflixServer');
				return ActionFactory::show_title_dialog('Peerflix-Server не запущен', $action, PeerflixServer::getIp(), 0);
			}
			if ($torrentAction == 4){
				if (Transmission::getOnlineStatusServer() == true){
					$selected_media_url = MediaURL::decode($user_input->selected_media_url);
					$class_name = $selected_media_url->class_name;
					if (isset($selected_media_url->torrentSourseClassName))
						$class_name = $selected_media_url->torrentSourseClassName;
					$torrentFile = $class_name::getTorrentFile($selected_media_url->torrent_id);
					if ($torrentFile["status"] == true){
						HD::asyncExec('proc_close');
						VodTransmissionScreen::$counter = 0;
						Transmission::actionGetTorrentList();
						Transmission::actionGetSessionInfo();
						$response = Transmission::transmissionAddTorrent($torrentFile["path"], $selected_media_url->tType, $movie);
						if ($response["status"] == true){
							if ($selected_media_url->tType == 'torrent'){
								hd_silence_warnings();
								return Transmission::transmissionActionGetTorrentInfo($user_input);
							}else{
								$add_params['action'] = 'addTransmissionTorrent';
								$add_params['indiClass'] = 'Transmission';
								$add_params['torrentPath'] = $torrentFile["path"];
								return  UserInputHandlerRegistry::create_action($this, 'classAction', $add_params);
							}
						}else
							return ActionFactory::show_title_dialog("Добавление не удалось", null, $response["msg"]);
					}else
						return ActionFactory::show_title_dialog("Eror!", null, $torrentFile["descr"]);
				}else if (Transmission::getSlaveTransmission() == true){
					hd_silence_warnings();
					return Transmission::actionStartStopTransmission($defs, $user_input);
				}
				$action = UserInputHandlerRegistry::create_action($this, 'classSetupTransmission');
				return ActionFactory::show_title_dialog('Transmission не запущен', $action, Transmission::getIp(), 0);
			}
			if ($torrentAction == 5){
				if (TransmissionUPnP::getOnlineStatusServer() == true){
					$selected_media_url = MediaURL::decode($user_input->selected_media_url);
					$class_name = $selected_media_url->class_name;
					if (isset($selected_media_url->torrentSourseClassName))
						$class_name = $selected_media_url->torrentSourseClassName;
					$torrentFile = $class_name::getTorrentFile($selected_media_url->torrent_id);
					if ($torrentFile["status"] == true){
						HD::asyncExec('proc_close');
						VodTransmissionUPnPScreen::$counter = 0;
						TransmissionUPnP::actionGetTorrentList();
						TransmissionUPnP::actionGetSessionInfo();
						$response = TransmissionUPnP::transmissionUPnPAddTorrent($torrentFile["path"], $selected_media_url->tType, $movie);
						if ($response["status"] == true){
							if ($selected_media_url->tType == 'torrent'){
								hd_silence_warnings();
								return TransmissionUPnP::transmissionActionGetTorrentInfo($user_input);
							}else{
								$add_params['action'] = 'addTransmissionUPnPTorrent';
								$add_params['indiClass'] = 'TransmissionUPnP';
								$add_params['torrentPath'] = $torrentFile;
								return  UserInputHandlerRegistry::create_action($this, 'classAction', $add_params);
							}
						}else
							return ActionFactory::show_title_dialog("Добавление не удалось", null, $response["msg"]);
					}else
						return ActionFactory::show_title_dialog("Eror!", null, $torrentFile["descr"]);
				}else if (TransmissionUPnP::getInstallTransmissionUPnP() == true){
					hd_silence_warnings();
					return TransmissionUPnP::startTransmissionUPnP($defs, $user_input);
				}
				$action = UserInputHandlerRegistry::create_action($this, 'classSetupTransmissionUPnP');
				return ActionFactory::show_title_dialog('Transmission BTC UPnP не запущен', $action, TransmissionUPnP::getIp(), 0);
			}
			if ($torrentAction == 7){
				$selected_media_url = MediaURL::decode($user_input->selected_media_url);
					$class_name = $selected_media_url->class_name;
					if (isset($selected_media_url->torrentSourseClassName))
						$class_name = $selected_media_url->torrentSourseClassName;
					$torrentFile = $class_name::getTorrentFile($selected_media_url->torrent_id);
					if ($torrentFile["status"] == true)
						return HD::get_android_action($torrentFile["path"], 'torrent');
					else
						return ActionFactory::show_title_dialog("Eror!", null, $torrentFile["descr"]);
			}
			if ($torrentAction == 6){
				if ($selected_media_url->tType != "torrent")
					$torrentAction = 1;
				else{
					$dloadTorrentDirPath = smbtree::get_folder_info('dloadTorrentDirPath');
					if (($dloadTorrentDirPath == '')||(!file_exists($dloadTorrentDirPath))){
						if (!file_exists($dloadTorrentDirPath)){
							ControlFactory::add_vgap($defs, -10);
							ControlFactory::add_smart_label($defs, "", '<text color="15" size="small">Папка для сохранения торрент файлов не найдена,</text>');
							ControlFactory::add_vgap($defs, -30);
							ControlFactory::add_smart_label($defs, "", '<text color="15" size="small">возможно перемещена или удалена.</text>');
						}else{
							ControlFactory::add_vgap($defs, -10);
							ControlFactory::add_smart_label($defs, "", '<text color="15" size="small">Папка для сохранения торрент файлов не выбрана</text>');
						}
						ControlFactory::add_vgap($defs, -30);
						ControlFactory::add_smart_label($defs, "", '<text color="15" size="small">Выберите папку в которую будут сохранятся торренты.</text>');
						ControlFactory::add_vgap($defs, -30);
						ControlFactory::add_smart_label($defs, "", '<text color="23" size="tiny">Изменить место сохранения можно через popup menu на торрент файле</text>');
						ControlFactory::add_vgap($defs, -50);
						ControlFactory::add_smart_label($defs, "", '<text color="23" size="tiny">или magnet ссылке -> Действия для торрент файлов.</text>');
						ControlFactory::add_close_dialog_and_apply_button($defs, $this, array ('action' => 'dloadTorrentDirPath'), 'classAction', 'ОК', 350);
						return ActionFactory::show_dialog('Папка для сохранения торентов', $defs, true, 870);
					}else{
						$class_name = $selected_media_url->class_name;
						$name = str_replace(array('*','|','\\',':','"','<','>','?','/',' '), "_", $selected_media_url->caption) . ".torrent";
						$torrentFile = $class_name::getTorrentFile($selected_media_url->torrent_id, $dloadTorrentDirPath . '/' . $name);
						if ($torrentFile["status"] == true){
							ControlFactory::add_vgap($defs, -10);
							ControlFactory::add_smart_label($defs, "", '<text color="15" size="small">'.$dloadTorrentDirPath.'</text>');
							ControlFactory::add_vgap($defs, -30);
							ControlFactory::add_smart_label($defs, "", '<text color="15" size="small">'.$name.'torrent</text>');
							ControlFactory::add_close_dialog_button($defs, 'ОК', 400);
							ControlFactory::add_close_dialog_and_apply_button($defs, $this, array ('action' => 'openDloadTorrentDir'), 'classAction', 'Открыть папку', 400);
							return ActionFactory::show_dialog('Сохранено', $defs, true, 870);
						}else
							return ActionFactory::show_title_dialog("Eror!", null, $torrentFile["descr"]);
					}
				}
			}
			if ($torrentAction == 1){
				$add_params['event_key']='enter';
				$add_params['torrentAction']= 2;
				ControlFactory::add_close_dialog_and_apply_button($defs, $this, $add_params, $user_input->control_id, 'Онлайн через TorrServer', 850);
				$add_params['torrentAction']= 3;
				ControlFactory::add_close_dialog_and_apply_button($defs, $this, $add_params, $user_input->control_id, 'Онлайн через Peerflix-Server', 850);
				$add_params['torrentAction']= 4;
				ControlFactory::add_close_dialog_and_apply_button($defs, $this, $add_params, $user_input->control_id, 'Качать через Transmission', 850);
				$add_params['torrentAction']= 5;
				ControlFactory::add_close_dialog_and_apply_button($defs, $this, $add_params, $user_input->control_id, 'Качать через Transmission BTC', 850);
				$add_params['torrentAction']= 6;
				if ($selected_media_url->tType == "torrent")
					ControlFactory::add_close_dialog_and_apply_button($defs, $this, $add_params, $user_input->control_id, 'Сохранить торрент файл', 850);
				if (HD::is_android() == true){
					$add_params['torrentAction']= 7;
					ControlFactory::add_close_dialog_and_apply_button($defs, $this, $add_params, $user_input->control_id, 'Открыть через Android приложение', 850);
				}
				return ActionFactory::show_dialog('Действия', $defs, true, 850);
			}
			return ActionFactory::show_title_dialog("test");
		}
	}
	public static function saveSearchHistori($mUrl){
		$searchHistori = HD::getItemsArr('searchHistori');
		$searchHistori_flip = array_flip($searchHistori);
		if (isset($searchHistori_flip[$mUrl]))
			unset($searchHistori[$searchHistori_flip[$mUrl]]);
		array_unshift($searchHistori, $mUrl);
		$searchHistori = array_slice($searchHistori, 0, 100);
		HD::saveItemsArr('searchHistori', $searchHistori);
	}
	public function classAction ($defs, $user_input, $select_url = null){
		hd_restore_warnings();
		$post_action = null;
		$caption = 'Error!';
		$msg = 'classAction: action1';
		$width = 1050;
		$parent_media_url = MediaURL::decode($user_input->parent_media_url);
		$class_name = $parent_media_url->class_name;
		if ($user_input->action == 'pluginInfoCacheDel'){
			unlink ($user_input->infoCachePath);
			$add_params['inv'] = $parent_media_url->searchKpId->parent_mUrl;
			return UserInputHandlerRegistry::create_action($this, 'ifx', $add_params);
		}
		if ($user_input->action == 'setMyShowStatus'){
			$named_array = myShows_Class::getMyShowsNamedArr();
			if (isset($user_input->myShowStatusNew)){
				$jsd = VideoInfo::manageSetShowStatus_myshows ($user_input->myShowsID, $user_input->myShowStatusNew, $user_input->mShowsA);
				if ($jsd == 1)
					$title = 'Статус "'.$named_array[$user_input->myShowStatusNew].'" задан!';
				else
					$title = 'Ошибка myShows';
				if (isset($user_input->close_dialog)){
					$actions =  ActionFactory::show_title_dialog($title, null, "", 800);
					return ActionFactory::close_dialog_and_run($actions);
				}else
					return ActionFactory::show_title_dialog($title, null, "", 800);
			}
			$add_params['control_id']= $user_input->control_id;
			$add_params['action'] = $user_input->action;
			$add_params['close_dialog'] = true;
			$add_params['myShowsID'] = $user_input->myShowsID;
			$add_params['mShowsA'] = $user_input->mShowsA;
			ControlFactory::add_combobox($defs, $this, $add_params,
				'myShowStatusNew', '',
				$user_input->myShowStatus, $named_array, 800, true, false
			);
			ControlFactory::add_vgap($defs, 50);
			return  ActionFactory::show_dialog("Статус сериала myShow",	$defs, true, 850);
		}
		if ($user_input->action == 'setMyShowId'){
			echo '--------------' . $user_input->addId;
			$add_params['action'] = $user_input->action;
			if (isset($user_input->delMyShowId)){
				$myShowsIds = HD::getItemsArr('myShowsIds');
				unset($myShowsIds[$user_input->delMyShowId]);
				HD::saveItemsArr('myShowsIds', $myShowsIds);
				return ActionFactory::invalidate_folders(array($user_input->parent_media_url));
			}
			if (isset($user_input->addId)){
				if ($user_input->addId == true){
					if (is_numeric($user_input->addId)){
						$myShowsIds = HD::getItemsArr('myShowsIds');
						$myShowsIds[$parent_media_url->setMyShowId->movie_id] = $user_input->addId;
						HD::saveItemsArr('myShowsIds', $myShowsIds);
						$add_params['inv'] = $parent_media_url->setMyShowId->parent_mUrl;
						$post_action = UserInputHandlerRegistry::create_action($this, 'ifx', $add_params);
						return ActionFactory::close_and_run($post_action);
					}else{
						$post_action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $add_params);
						return ActionFactory::show_title_dialog('myShows ID указан не верно', $post_action, 'Введите числовое значение Kinopoisk ID', 500);
					}
				}else{
					ControlFactory::add_text_field($defs, $this, false,
						'addId',
						'',
						'Задайте myShows ID.', 1, 0, 0, 1, 550, 0, false
					);
					
					ControlFactory::add_close_dialog_and_apply_button($defs, $this, $add_params, $user_input->control_id, 'Применить', 350);
					return  ActionFactory::show_dialog("Задать myShows ID", $defs, true,0, $attrs);
				}
			}
			
			if (isset($user_input->doNewSearch)){
				$arr['setMyShowId']['movie_id'] = $parent_media_url->setMyShowId->movie_id;
				$arr['setMyShowId']['caption'] = $parent_media_url->setMyShowId->caption;
				if (isset($parent_media_url->setMyShowId->caption_original))
					$arr['setMyShowId']['caption_original'] = $parent_media_url->setMyShowId->caption_original;
				$arr['setMyShowId']['parent_mUrl'] = $parent_media_url->setMyShowId->parent_mUrl;
				$arr['setMyShowId']['searchStr'] = $user_input->doNewSearch;
				$mUrl = SmartVodRectangleListScreen::get_media_url_str('myShows_Class', $arr);
				$post_action = ActionFactory::open_folder($mUrl, "Задать/исправить ID myShows");
				return ActionFactory::close_and_run($post_action);
			}
			
			if (isset($user_input->searchStr)){
				$searchSettings = (HD::getItemsArr('searchSettings') != array()) ? HD::getItemsArr('searchSettings') : array('useOsk' => 1, 'searchСhoice' => 1, 'kpSearchMetod' => 0);
				if (isset($parent_media_url->setMyShowId->caption_original))
					$searchStr = $parent_media_url->setMyShowId->caption_original;
				else
					$searchStr = $parent_media_url->setMyShowId->caption;
				if (($searchSettings['useOsk'] == 2)&&(!isset($user_input->openStandartSearch))) {
					$advKeys = new AdvKeyboard($parent_media_url, $plugin_cookies, $this, $user_input->control_id, array('action' => $user_input->action));
					$advKeys->str = $searchStr;
					$advKeys->strRed = '';
					$advKeys->suggSite = 'kp';
					return $advKeys->startup_kbrd();
				}
				ControlFactory::add_text_field($defs, $this, $add_params,
					'doNewSearch', '',
					$searchStr, 0, 0, $searchSettings['useOsk'], 1, 1230, 0, 1
				);
				if (($searchSettings['useOsk'] == 1)||(isset($user_input->openStandartSearch)))
				ControlFactory::add_vgap($defs, 500);
				return ActionFactory::show_dialog("Искать ID myShows", $defs, true, 1330);
			}
			
			if (isset($user_input->caption)){
				$arr['setMyShowId']['movie_id'] = $parent_media_url->movie_id;
				$arr['setMyShowId']['caption'] = $user_input->caption;
				if (isset($user_input->caption_original)){
					if (preg_match('|(.*?)\n|', $user_input->caption_original, $m))
						$arr['setMyShowId']['caption_original'] = $m[1];
					else
						$arr['setMyShowId']['caption_original'] = $user_input->caption_original;
				}
				$arr['setMyShowId']['parent_mUrl'] = $user_input->parent_media_url;
				$mUrl = SmartVodRectangleListScreen::get_media_url_str('myShows_Class', $arr);
				return ActionFactory::open_folder($mUrl, "Задать/исправить Id Кинопоиска");
			}
		}
		if ($user_input->action == 'searchKpId'){
			$add_params['action'] = $user_input->action;
			if (isset($user_input->delSearchKpId)){
				$kpIDs = HD::getItemsArr('kpIDs');
				unset($kpIDs[$user_input->delSearchKpId]);
				HD::saveItemsArr('kpIDs', $kpIDs);
				return ActionFactory::invalidate_folders(array($user_input->parent_media_url));
			}
			if (isset($user_input->addId)){
				if ($user_input->addId == true){
					if (is_numeric($user_input->addId)){
						$kpIDs = HD::getItemsArr('kpIDs');
						$kpIDs[$parent_media_url->searchKpId->movie_id] = $user_input->addId;
						HD::saveItemsArr('kpIDs', $kpIDs);
						$add_params['inv'] = $parent_media_url->searchKpId->parent_mUrl;
						$post_action = UserInputHandlerRegistry::create_action($this, 'ifx', $add_params);
						return ActionFactory::close_and_run($post_action);
					}else{
						$post_action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $add_params);
						return ActionFactory::show_title_dialog('Kinopoisk ID указан не верно', $post_action, 'Введите числовое значение Kinopoisk ID', 500);
					}
				}else{
					ControlFactory::add_text_field($defs, $this, false,
						'addId',
						'',
						'Задайте Kinopoisk Id.', 1, 0, 0, 1, 550, 0, false
					);
					
					ControlFactory::add_close_dialog_and_apply_button($defs, $this, $add_params, $user_input->control_id, 'Применить', 350);
					return  ActionFactory::show_dialog("Задать Kinopoisk ID", $defs, true,0, $attrs);
				}
			}
			
			if (isset($user_input->doNewSearch)){
				$arr['searchKpId']['movie_id'] = $parent_media_url->searchKpId->movie_id;
				$arr['searchKpId']['caption'] = $parent_media_url->searchKpId->caption;
				if (isset($parent_media_url->searchKpId->caption_original))
					$arr['searchKpId']['caption_original'] = $parent_media_url->searchKpId->caption_original;
				$arr['searchKpId']['parent_mUrl'] = $parent_media_url->searchKpId->parent_mUrl;
				$arr['searchKpId']['searchStr'] = $user_input->doNewSearch;
				$mUrl = SmartVodListScreen::get_media_url_str('Kinopoisk_Class', $arr);
				$post_action = ActionFactory::open_folder($mUrl, "Задать/исправить Id Кинопоиска");
				return ActionFactory::close_and_run($post_action);
			}
			
			if (isset($user_input->searchStr)){
				$searchSettings = (HD::getItemsArr('searchSettings') != array()) ? HD::getItemsArr('searchSettings') : array('useOsk' => 1, 'searchСhoice' => 1, 'kpSearchMetod' => 0);
				if (isset($parent_media_url->searchKpId->caption_original))
					$searchStr = $parent_media_url->searchKpId->caption_original;
				else
					$searchStr = $parent_media_url->searchKpId->caption;
				if (($searchSettings['useOsk'] == 2)&&(!isset($user_input->openStandartSearch))) {
					$advKeys = new AdvKeyboard($parent_media_url, $plugin_cookies, $this, $user_input->control_id, array('action' => $user_input->action));
					$advKeys->str = $searchStr;
					$advKeys->strRed = '';
					$advKeys->suggSite = 'kp';
					return $advKeys->startup_kbrd();
				}
				$add_params['control_id']= $user_input->control_id;
				$add_params['action'] = $user_input->action;
				ControlFactory::add_text_field($defs, $this, $add_params,
					'doNewSearch', '',
					$searchStr, 0, 0, $searchSettings['useOsk'], 1, 1230, 0, 1
				);
				if (($searchSettings['useOsk'] == 1)||(isset($user_input->openStandartSearch)))
				ControlFactory::add_vgap($defs, 500);
				return ActionFactory::show_dialog("Искать Id Кинопоиска", $defs, true, 1330);
			}
			if (isset($user_input->caption)){
				$arr['searchKpId']['movie_id'] = $parent_media_url->movie_id;
				$arr['searchKpId']['caption'] = $user_input->caption;
				if (isset($user_input->caption_original)){
					if (preg_match('|(.*?)\n|', $user_input->caption_original, $m))
						$arr['searchKpId']['caption_original'] = $m[1];
					else
						$arr['searchKpId']['caption_original'] = $user_input->caption_original;
				}
				$arr['searchKpId']['parent_mUrl'] = $user_input->parent_media_url;
				$mUrl = SmartVodListScreen::get_media_url_str('Kinopoisk_Class', $arr);
				return ActionFactory::open_folder($mUrl, "Задать/исправить Id Кинопоиска");
			}
		}
		if (isset($user_input->selected_media_url))
			$selected_media_url = MediaURL::decode($user_input->selected_media_url);
		else{
			$msg = 'classAction: selected_media_url';
			return ActionFactory::show_title_dialog($caption, $post_action, $msg, 0);
		}
		$class_name = $selected_media_url->class_name;
		
		if ($user_input->action == 'search'){
			if (isset($user_input->open_item)){
				$class_name = 'Kinopoisk_Class';
				$mUrl = $class_name::getSearchMediaUrlStr($class_name, array('searchStr' => $user_input->doNewSearch));
				self::saveSearchHistori($mUrl);
				$mArr['movie_id'] = $user_input->open_item;
				$mUrl = VodMovieScreen::get_media_url_str($class_name, $mArr);
				$action = ActionFactory::open_folder($mUrl, $user_input->doNewSearch);
				return ActionFactory::invalidate_folders(array($user_input->parent_media_url), $action);
			}
			if (isset($user_input->open_people)){
				$class_name = 'Kinopoisk_Class';
				$mUrl = $class_name::getSearchMediaUrlStr($class_name, array('searchStr' => $user_input->doNewSearch, 'searchType' => 'people'));
				self::saveSearchHistori($mUrl);
				$mArr['categoryId'] = 'KPPeople' . $user_input->open_people;
				$mUrl = SmartVodListScreen::get_media_url_str($class_name, $mArr);
				$action = ActionFactory::open_folder($mUrl, $user_input->doNewSearch);
				return ActionFactory::invalidate_folders(array($user_input->parent_media_url), $action);
			}
			if (isset($selected_media_url->searchStr)){
				if ((isset($user_input->search_actions))&&($user_input->search_actions == 'open')){
					$mUrl = $user_input->selected_media_url;
					$searchSettings = (HD::getItemsArr('searchSettings') != array()) ? HD::getItemsArr('searchSettings') : array('useOsk' => 1, 'searchСhoice' => 1, 'kpSearchMetod' => 0);
					if ($searchSettings['searchСhoice'] == 1){
						$buttons = self::getWox();
						array_unshift($buttons, $class_name);
						$buttons = array_flip($buttons);
						$add_params['closedKeyboard'] = true;
						$add_params['control_id']= $user_input->control_id;
						$add_params['action'] = $user_input->action;
						foreach ($buttons as $button => $k){
							if (method_exists($button,'getSearchMediaUrlStr')){
								$add_params['openSearch'] = $button;
								$add_params['doNewSearch'] = $selected_media_url->searchStr;
								ControlFactory::add_close_dialog_and_apply_button($defs, $this, $add_params, $user_input->control_id, str_replace(" Трейлеры", "", $button::$cName), 850);
								ControlFactory::add_vgap($defs, (-10));
							}
						}
						return ActionFactory::show_dialog('Искать в', $defs, true);
					}
					self::saveSearchHistori($mUrl);
					$action = ActionFactory::open_folder($mUrl, $class_name::$cName . ': ' . $selected_media_url->searchStr);
					return ActionFactory::invalidate_folders(array($user_input->parent_media_url), $action);
				}
			}
			$add_params['control_id']= $user_input->control_id;
			$add_params['action'] = $user_input->action;
			if (isset($user_input->searchType))
				$add_params['searchType'] = $user_input->searchType;
			$searchSettings = (HD::getItemsArr('searchSettings') != array()) ? HD::getItemsArr('searchSettings') : array('useOsk' => 1, 'searchСhoice' => 1, 'kpSearchMetod' => 0);
			$searchTextArr = (HD::getItemsArr('searchTextArr') != array()) ? HD::getItemsArr('searchTextArr') : array();
			if ((isset($user_input->selected_control_id))&&(isset($user_input->action_type))){
				if ($user_input->selected_control_id == 'doNewSearch'){
					if (!isset($user_input->closedKeyboard)){
						$add_params['closedKeyboard'] = true;
						$action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $add_params);
						return ActionFactory::close_dialog_and_run($action);
					}
				}
			}
			if (isset($user_input->closedKeyboard)){
				if ((!isset($user_input->searchType))||($user_input->searchType == ''))
					$user_input->searchType = 'film';
				$searchTextArr[$user_input->searchType] = $user_input->doNewSearch;
				HD::saveItemsArr('searchTextArr', $searchTextArr);
				if ($user_input->selected_control_id == 'doNewSearch'){
					$add_params['closedKeyboard'] = true;
					$class_name = $selected_media_url->class_name;
					if ((isset($user_input->searchType))&&($user_input->searchType == 'people')){
						$mUrl = $class_name::getSearchMediaUrlStr($class_name, array('searchStr' => $user_input->doNewSearch, 'searchType' => 'people'));
						self::saveSearchHistori($mUrl);
						$action = ActionFactory::open_folder($mUrl, $class_name::$cName . ' люди: ' . $user_input->doNewSearch);
					}else if ($searchSettings['searchСhoice'] == 1){
						$buttons = self::getWox();
						array_unshift($buttons, $class_name);
						$buttons = array_flip($buttons);
						foreach ($buttons as $button => $k){
							if (method_exists($button,'getSearchMediaUrlStr')){
								$add_params['openSearch'] = $button;
								$add_params['doNewSearch'] = $user_input->doNewSearch;
								ControlFactory::add_close_dialog_and_apply_button($defs, $this, $add_params, $user_input->control_id, str_replace(" Трейлеры", "", $button::$cName), 850);
								ControlFactory::add_vgap($defs, (-10));
							}
						}
						return ActionFactory::show_dialog('Искать в', $defs, true);
					}else{
						$mUrl = $class_name::getSearchMediaUrlStr($class_name, array('searchStr' => $user_input->doNewSearch));
						self::saveSearchHistori($mUrl);
						$action = ActionFactory::open_folder($mUrl, str_replace(" Трейлеры", "", $class_name::$cName) . ': ' . $user_input->doNewSearch);
					}
				}
				if (isset($user_input->openSearch)){
					$class_name = $user_input->openSearch;
					$mUrl = $class_name::getSearchMediaUrlStr($class_name, array('searchStr' => $user_input->doNewSearch));
					self::saveSearchHistori($mUrl);
					$action = ActionFactory::open_folder($mUrl, str_replace(" Трейлеры", "", $class_name::$cName) . ': ' . $user_input->doNewSearch);
				}
				return ActionFactory::invalidate_folders(array($user_input->parent_media_url), $action);
			}
			if (isset($user_input->duneVoiceSearch)){
				$file_exists = shell_exec ('/system/dunehd/dunehd_service do [ -f "/data/data/com.example.dunevoice/files/our_file.txt" ] && echo 2');
				if ($file_exists == 2){
					$add_params['doNewSearch'] = shell_exec ('/system/dunehd/dunehd_service do cat /data/data/com.example.dunevoice/files/our_file.txt');
					$add_params['closedKeyboard'] = true;
					$add_params['selected_control_id'] = 'doNewSearch';
					$action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $add_params);
				}else{
					if (isset($user_input->counter))
						$add_params['counter'] = 1 + $user_input->counter;
					else
						$add_params['counter'] = 1;
					
					if ($add_params['counter'] == 40)
						$action = null;
					else{
						$add_params['duneVoiceSearch'] = true;
						$action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $add_params);
					}
				}
				ControlFactory::add_label($defs, '', "Прошло: " . HD::sec_format_duration($params['counter']));
				$attrs['timer'] = ActionFactory::timer(1000);
				$attrs['actions'] = array(GUI_EVENT_TIMER => ActionFactory::close_dialog_and_run($action));
				return  ActionFactory::show_dialog('Поиск', $defs, true, 0, $attrs);
			}
			
			$searchText = '';
			$add_params['searchType'] = 'film';
			$sfx = 'фильмов и сериалов';
			if ((isset($selected_media_url->searchType))&&($selected_media_url->searchType == 'people')){
				$add_params['searchType'] = $selected_media_url->searchType;
				$sfx = 'актеров, режиссеров или сценаристов';
			}
			if ((isset($selected_media_url->voice))&&(file_exists('/data/data/com.example.dunevoice'))){
				$file_exists = shell_exec ('/system/dunehd/dunehd_service do [ -f "/data/data/com.example.dunevoice/files/our_file.txt" ] && echo 2');
				if ($file_exists == 2)
					echo shell_exec ('/system/dunehd/dunehd_service do rm -rf /data/data/com.example.dunevoice/files/our_file.txt');
				shell_exec ('am start com.example.dunevoice -a android.intent.category.DEFAULT');
				$add_params['duneVoiceSearch'] = true;
				return UserInputHandlerRegistry::create_action($this, $user_input->control_id, $add_params);
			}
			if (isset($selected_media_url->searchStr))
				$searchText = $selected_media_url->searchStr;
			else if ((isset($selected_media_url->caption))&&(isset($selected_media_url->movie_id))){
				$searchText = $selected_media_url->caption;
				if (isset($selected_media_url->hash_patrs->name))
					$searchText = $selected_media_url->hash_patrs->name;
			}else if (isset($searchTextArr[$add_params['searchType']]))
				$searchText = $searchTextArr[$add_params['searchType']];
			$regex = '(.*)( — Рус| - Рус| - Первый тре| - Официальный| – Рус| — Официальный| \| Офиц| — Тре| - Трейлер | \(Трейлер| – Тизер| - первый| \| Русский| - второй| - Official T| Trailer | Final Trailer| Teaser | Official Trailer)';
			$regex2 = '(.*)( \(Рус| \| Трейлер| - трейлер| Трейлер| Русский трейлер| Дублированный| – Третий трейлер| \| Movieclips|Officail Trailer| Трейлер)';
			if (preg_match("/$regex/i",$searchText, $matches))
				$searchText = $matches[1];
			if (preg_match("/$regex2/i",$searchText, $matches))
				$searchText = $matches[1];
			if (($searchSettings['useOsk'] == 2)&&(!isset($user_input->openStandartSearch))) {
				$advKeys = new AdvKeyboard($parent_media_url, $plugin_cookies, $this, $user_input->control_id, array('action' => $user_input->action));
				$advKeys->str = '';
				$advKeys->strRed = $searchText;
				if ($add_params['searchType'] ==  'people')
					$advKeys->suggCountry =  'people';
				$advKeys->suggSite = 'kp';
				return $advKeys->startup_kbrd();
			}
			ControlFactory::add_text_field($defs, $this, $add_params,
				'doNewSearch', '',
				$searchText, 0, 0, $searchSettings['useOsk'], 1, 1230, 0, 1
			);
			if (($searchSettings['useOsk'] == 1)||(isset($user_input->openStandartSearch)))
				ControlFactory::add_vgap($defs, 500);
			return ActionFactory::show_dialog("Поиск $sfx", $defs, true, 1330);
		}
		
		if ($user_input->action == 'kpSimilarSequelsPrequelsRelatedFilms'){
			$mArr['categoryId'] = $parent_media_url->movie_id;
			$mArr['kpSimilarSequelsPrequelsRelatedFilms'] = $user_input->operationID;
			$mArr['kpID'] = $user_input->kpID;
			$mUrl = SmartVodListScreen::get_media_url_str('Kinopoisk_Class', $mArr);
			return ActionFactory::open_folder($mUrl, $user_input->caption);
		}
		if ($user_input->action == 'kpActorsAndDirectors'){
			$mArr['categoryId'] = $parent_media_url->movie_id;
			$mArr['kpActorsAndDirectors'] = $user_input->kpID;
			$mUrl = SmartVodListScreen::get_media_url_str('Kinopoisk_Class', $mArr);
			return ActionFactory::open_folder($mUrl, 'Актеры и режиссеры');
		}
		if ($user_input->action == 'kpEpisodesInfo'){
			static $arr = array();
			if (!isset($arr[$user_input->kpID])){
				$arr = array();
				$doc = HD::http_get_document("http://webcache.googleusercontent.com/search?q=cache:https://www.kinopoisk.ru/film/{$user_input->kpID}/episodes/");
				$doc = html_entity_decode($doc, ENT_QUOTES,'UTF-8');
				if (preg_match('|<b>Годы:</b>(.*?)</tr>|ms', $doc, $matches))
					$arr[$user_input->kpID]['years'] =  'Годы: ' . str_replace(" ", ", ", HD::str_remove_tag($matches[1]));
				if (preg_match('|<b>Время:</b>(.*?)</tr>|ms', $doc, $matches))
					$arr[$user_input->kpID]['time'] =  'Время: ' .  HD::str_remove_tag($matches[1]);
				if (preg_match_all('|<a name="s.*?">(.+?)</td>(.*?)</table>|ms', $doc, $m)){
					foreach ($m[1] as $key => $vel){
						if (preg_match_all("|<tr>(.*?)</tr>|ms", $m[2][$key], $matches)){
							$info = '';
							foreach ($matches[1] as $k => $v){
								if (preg_match("/moviename-big/",$v))
									$arr[$user_input->kpID]['episodes'][HD::str_remove_tag(str_replace(array ("<br>",'</h1>' )," ",$vel))][] = HD::str_remove_tag(str_replace(array ("<br>",'</h1>' ),"||", $v)) . "\n";
							}
						}
					}
				}
			}
			$add_params['action'] = $user_input->action;
			$attrs = null;
			if(!isset($arr[$user_input->kpID]['episodes']))
				ControlFactory::add_multiline_label($defs, '', 'Ничего не найдено.', 2);
			else if(isset($user_input->season)){
				foreach ($arr[$user_input->kpID]['episodes'][$user_input->season] as $v){
					$tmp = explode("||", $v);
					ControlFactory::add_smart_label($defs, "", '<text color="23" size="small">'. trim($tmp[2]).'</text><text color="15" size="small"> - '.$tmp[0].'</text>');
					ControlFactory::add_vgap($defs, -30);
					ControlFactory::add_smart_label($defs, "", '<text color="15" size="tiny"> - '.$tmp[1].'</text>');
					ControlFactory::add_vgap($defs, -25);
				}
				$add_params['kpID'] = $user_input->kpID;
				ControlFactory::add_close_dialog_button($defs, 'Ok', 250);
				$action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $add_params);
				$attrs['actions'][GUI_EVENT_KEY_RETURN]	= ActionFactory::close_dialog_and_run($action);
				return ActionFactory::show_dialog('Сезон: ' . $user_input->season, $defs, true, 900, $attrs);
			}else{
				ControlFactory::add_multiline_label($defs, '', $arr[$user_input->kpID]['years'], 2);
				ControlFactory::add_multiline_label($defs, '', $arr[$user_input->kpID]['time'], 2);
				foreach ($arr[$user_input->kpID]['episodes'] as $k => $v){
					$add_params['season'] = $k;
					$add_params['kpID'] = $user_input->kpID;
					ControlFactory::add_close_dialog_and_apply_button($defs, $this, $add_params, $user_input->control_id, $k, 850);
				}
			}
			return ActionFactory::show_dialog('Сезоны', $defs, true, 900);
		}
		if ($user_input->action == 'addItemInfo'){
			$add_params['control_id']= $user_input->control_id;
			$add_params['action'] = $user_input->action;
			$add_params['indiClass'] = 'SmartConfig';
			$kpId = '';
			if (isset($user_input->newKpId)){
				if ((is_numeric($user_input->newKpId))||($user_input->newKpId == 'del')){
					$selected_media_url = MediaURL::decode($user_input->selected_media_url);
					$inf = HD::getItemsArr($selected_media_url->class_name .'Inf');
					if ($user_input->newKpId != 'del'){
						$arr = Kinopoisk_Class::simpleKpIdInfo($user_input->newKpId);
						$infoArr["title"] = $arr['caption'];
						if (isset($arr['caption_original']))
							$infoArr["original_title"] = $arr['caption_original'];
						$infoArr["poster_path"] = $arr['poster_url'];
						$infoArr["overview"] = $arr['description'];
						$infoArr["year"] = $arr['year'];
						if (isset($movie->class_info['dbIDs']))
							$infoArr["dbIDs"]['kpID'] = $user_input->newKpId;
						$infoStr = json_encode($infoArr);
						$inf[$selected_media_url->movie_id] = $infoStr;
					}else
						unset($inf[$selected_media_url->movie_id]);
					HD::saveItemsArr($selected_media_url->class_name .'Inf', $inf);
					$action = ActionFactory::invalidate_folders(array($user_input->parent_media_url));
					$action = ActionFactory::show_title_dialog('Добавленно!', $action);
					return ActionFactory::close_and_run($action);
				}
				$kpId = 'KP id не верный!';
			}
			ControlFactory::add_text_field($defs, $this, $add_params,
				'newKpId', '',
				$kpId, 1, 0, 0, 1, 350, 0, 1);
			// ControlFactory::add_vgap($defs, 500);
			// ControlFactory::add_smart_label($defs, "", '<text color="23" size="small">*обложка и описание подгрудаются по ID Кинопоиска</text>');
			return ActionFactory::show_dialog("Введите ID Кинопоиска", $defs, true);
		}
		if ($user_input->action == 'openDloadTorrentDir'){
			if (file_exists(DuneSystem::$properties['data_dir_path'] .'/dloadTorrentDirPath')) {
				$dirSettings = unserialize(file_get_contents(DuneSystem::$properties['data_dir_path'] .'/dloadTorrentDirPath'));
				$path = smbtree::get_folder_info ('dloadTorrentDirPath');
				if (preg_match('|^/tmp/mnt/storage/|', $path))
					$path = preg_replace('|^/tmp/mnt/storage/|', 'storage_name://', $path);
				else if ((preg_match('|^/tmp/mnt/smb/|', $path))&&($dirSettings['user']==true)&&($dirSettings['password']==true))
					$path = 'smb://'. $dirSettings['user'] .':'. $dirSettings['password'] .'@'. preg_replace("|^\/tmp\/mnt\/smb\/\d|", str_replace('//', '',key ($dirSettings)), $path);
				else if (preg_match('|^/tmp/mnt/smb/|', $path))
					$path = 'smb:' . preg_replace("|^\/tmp\/mnt\/smb\/\d|", key ($dirSettings), $path);
				else if ((preg_match('|^/tmp/mnt/network/|', $path))&&($dirSettings['nfs_protocol']==true)){
					if ($dirSettings['nfs_protocol']=='tcp')
						$path = 'nfs-tcp://' . preg_replace("|^\/tmp\/mnt\/network\/\d|", key ($dirSettings).':/', $path);
					else
						$path = 'nfs-udp://' . preg_replace("|^\/tmp\/mnt\/network\/\d|", key ($dirSettings).':/', $path);
				}
				return ActionFactory::launch_media_url('embedded_app://{name=file_browser}{url='.$path.'}{caption=File Browser}');
			}else{
				$dloadTorrentDirPath = smbtree::get_folder_info('dloadTorrentDirPath');
				if (($dloadTorrentDirPath == '')||(!file_exists($dloadTorrentDirPath))){
					if (!file_exists($dloadTorrentDirPath)){
						ControlFactory::add_vgap($defs, -10);
						ControlFactory::add_smart_label($defs, "", '<text color="15" size="small">Папка для сохранения торрент файлов не найдена,</text>');
						ControlFactory::add_vgap($defs, -30);
						ControlFactory::add_smart_label($defs, "", '<text color="15" size="small">возможно перемещена или удалена.</text>');
					}else{
						ControlFactory::add_vgap($defs, -10);
						ControlFactory::add_smart_label($defs, "", '<text color="15" size="small">Папка для сохранения торрент файлов не выбрана</text>');
					}
					ControlFactory::add_vgap($defs, -30);
					ControlFactory::add_smart_label($defs, "", '<text color="15" size="small">Выберите папку в которую будут сохранятся торренты.</text>');
					ControlFactory::add_vgap($defs, -30);
					ControlFactory::add_smart_label($defs, "", '<text color="23" size="tiny">Изменить место сохранения можно через popup menu на торрент файле</text>');
					ControlFactory::add_vgap($defs, -50);
					ControlFactory::add_smart_label($defs, "", '<text color="23" size="tiny">или magnet ссылке -> Действия для торрент файлов.</text>');
					ControlFactory::add_close_dialog_and_apply_button($defs, $this, array ('action' => 'dloadTorrentDirPath'), 'classAction', 'ОК', 350);
					return ActionFactory::show_dialog('Папка для сохранения торентов', $defs, true, 870);
				}
			}
		}
		if ($user_input->action == 'dloadTorrentDirPath'){
			$media_url = MediaURL::encode(
				array(
					'screen_id'     => 'file_list',
					'save_data'		=> 'dloadTorrentDirPath'
				)
			);
			return ActionFactory::open_folder($media_url, 'Сохранять торрент файлы в');
		}
		if ($user_input->action == 'torrentActionSetup'){
			$torrentAction = (HD::getItemStr('torrentAction', true) != '') ? HD::getItemStr('torrentAction', true) : 0;
			$add_params['control_id']= $user_input->control_id;
			$add_params['action'] = $user_input->action;
			if (isset($user_input->event_key))
				$add_params['event_key']= $user_input->event_key;
			if ((isset($user_input->selected_control_id))&&(isset($user_input->action_type))){
				$add_params['initial_sel_ndx'] = $user_input->initial_sel_ndx;
				if (isset($user_input->event_key))
					$add_params['control_id'] = 'add_actions';
				if ($user_input->selected_control_id == 'torrentAction')
					if (HD::saveItemStr('torrentAction', $user_input->torrentAction, true) == false)
						return ActionFactory::show_title_dialog("Сохранение не удалось");
				
				$action = UserInputHandlerRegistry::create_action($this, $add_params['control_id'], $add_params);
				$action = ActionFactory::close_dialog_and_run($action);
				return ActionFactory::invalidate_folders(array($user_input->parent_media_url), $action);
				
			}
			$torrentActionOps[0] = 'Не выбрано';
			$torrentActionOps[1] = 'Выбирать действие каждый раз';
			$torrentActionOps[2] = 'Онлайн через TorrServer';
			$torrentActionOps[3] = 'Онлайн через Peerflix-Server';
			$torrentActionOps[4] = 'Качать через Transmission';
			$torrentActionOps[5] = 'Качать через Transmission BTC*';
			$torrentActionOps[6] = 'Сохранить торрент файл**';
			if (HD::is_android() == true)
				$torrentActionOps[7] = 'Открыть через Android приложение';
			$add_params['initial_sel_ndx'] = 0;
			ControlFactory::add_multiline_label($defs, '', 'Выберите действие по умолчанию для открытия torrent файлов и magnet ссылок', 8);
			$add_params['initial_sel_ndx'] = $add_params['initial_sel_ndx'] + 1;
			ControlFactory::add_combobox($defs, $this, $add_params,
				'torrentAction',
				'',
				$torrentAction, $torrentActionOps,  800, true, false
			);
			if ($torrentAction == 6){
				ControlFactory::add_smart_label($defs, "", '<text color="15" size="small">Папка в которую будут сохранятся торренты:</text>');
				ControlFactory::add_vgap($defs, -10);
				ControlFactory::add_button_close(&$defs, $this, array ('action' => 'dloadTorrentDirPath'), 'classAction', '', 'Изменить расположение', 800);
			}
			ControlFactory::add_vgap($defs, -10);
			ControlFactory::add_smart_label($defs, "", '<text color="23" size="small">*Transmission BTC может быть установлен на</text>');
			ControlFactory::add_vgap($defs, -30);
			ControlFactory::add_smart_label($defs, "", '<text color="23" size="small">любом адроид устройстве</text>');
			ControlFactory::add_vgap($defs, -30);
			ControlFactory::add_smart_label($defs, "", '<text color="23" size="small">**Сохраняются только торрент файлы, не magnet ссылки</text>');
			ControlFactory::add_vgap($defs, -30);
			ControlFactory::add_smart_label($defs, "", '<text color="15" size="small">Изменить действие по умолчанию можно через нажатие</text>');
			ControlFactory::add_vgap($defs, -30);
			ControlFactory::add_smart_label($defs, "", '<text color="15" size="small">кнопки popup menu на торрент файле или magnet ссылке</text>');
			$attrs['initial_sel_ndx'] = isset($user_input->initial_sel_ndx) ? $user_input->initial_sel_ndx : -1;
			return ActionFactory::show_dialog('Действие по умолчанию', $defs, true, 920);
		}
		if ($user_input->action == 'histSetup'){
			$add_params['control_id']= $user_input->control_id;
			$add_params['action'] = $user_input->action;
			$pluginCachePath = HD::get_data_path() . "/pluginCache/";
			if ((isset($user_input->selected_control_id))&&(isset($user_input->action_type))){
				$params['initial_sel_ndx'] = $user_input->initial_sel_ndx;
				$params['action'] = $user_input->action;
				if ($user_input->selected_control_id == 'posterCasheHist'){
					if (HD::saveItemStr('posterCasheHist', $user_input->posterCasheHist) == false)
						return ActionFactory::show_title_dialog("Сохранение не удалось");
					if (($user_input->posterCasheHist != 1)&&(file_exists($pluginCachePath)))
						HD::delDir($pluginCachePath);
				}
				$action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $params);
				$action = ActionFactory::close_dialog_and_run($action);
				return ActionFactory::invalidate_folders(array($user_input->parent_media_url), $action);
				
			}
			ControlFactory::add_multiline_label($defs, '', 'Кешировать постеры и описание в папку DATA:', 8);
			$posterCasheHist = (HD::getItemStr('posterCasheHist') != '') ? HD::getItemStr('posterCasheHist') : 0;
			$add_params['initial_sel_ndx'] = $add_params['initial_sel_ndx'] + 1;
			ControlFactory::add_combobox($defs, $this, $add_params,
				'posterCasheHist',
				'',
				$posterCasheHist, array('Нет', 'Да'),  600, true, false
			);
			ControlFactory::add_vgap($defs, -10);
			if ((HD::get_data_path() == DuneSystem::$properties['data_dir_path'])||
			(preg_match('|^/tmp/mnt/storage/|', HD::get_data_path()))||
			(preg_match('|^/D/|', HD::get_data_path()))
			){
				ControlFactory::add_smart_label($defs, "", '<text color="15" size="small">Свободное место: ' . HD::get_storage_size(HD::get_data_path()) . '</text>');
				ControlFactory::add_vgap($defs, -20);
			}
			ControlFactory::add_smart_label($defs, "", '<text color="15" size="tiny">*Отключение кеша удаляет кеш</text>');
			$attrs['initial_sel_ndx'] = isset($user_input->initial_sel_ndx) ? $user_input->initial_sel_ndx : -1;
			return ActionFactory::show_dialog('Дополнительные настройки', $defs, true, 700, $attrs);
		}
		if ($user_input->action == 'favSetup'){
			$add_params['control_id']= $user_input->control_id;
			$add_params['action'] = $user_input->action;
			$pluginCachePath = HD::get_data_path() . "/pluginCache/";
			if ((isset($user_input->selected_control_id))&&(isset($user_input->action_type))){
				$params['initial_sel_ndx'] = $user_input->initial_sel_ndx;
				$params['action'] = $user_input->action;
				if ($user_input->selected_control_id == 'openSaveFolder')
					if (HD::saveItemStr('openSaveFolder', $user_input->openSaveFolder) == false)
						return ActionFactory::show_title_dialog("Сохранение не удалось");
				if ($user_input->selected_control_id == 'upViewed')
					if (HD::saveItemStr('upViewed', $user_input->upViewed) == false)
						return ActionFactory::show_title_dialog("Сохранение не удалось");
				if ($user_input->selected_control_id == 'upNew')
					if (HD::saveItemStr('upNew', $user_input->upNew) == false)
						return ActionFactory::show_title_dialog("Сохранение не удалось");
				if ($user_input->selected_control_id == 'posterCashe'){
					if (HD::saveItemStr('posterCashe', $user_input->posterCashe) == false)
						return ActionFactory::show_title_dialog("Сохранение не удалось");
					if (($user_input->posterCashe != 1)&&(file_exists($pluginCachePath)))
						HD::delDir($pluginCachePath);
				}
				$action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $params);
				$action = ActionFactory::close_dialog_and_run($action);
				return ActionFactory::invalidate_folders(array($user_input->parent_media_url), $action);
				
			}
			ControlFactory::add_multiline_label($defs, '', 'Открывать сохраненные папки минуя карточку фильма:', 8);
			$openSaveFolder = (HD::getItemStr('openSaveFolder') != '') ? HD::getItemStr('openSaveFolder') : 1;
			$add_params['initial_sel_ndx'] = 0;
			ControlFactory::add_combobox($defs, $this, $add_params,
				'openSaveFolder',
				'',
				$openSaveFolder, array('Нет', 'Да'),  600, true, false
			);
			ControlFactory::add_multiline_label($defs, '', 'Поднимать просмотренные в начало списка:', 8);
			$upViewed = (HD::getItemStr('upViewed') != '') ? HD::getItemStr('upViewed') : 1;
			$add_params['initial_sel_ndx'] = $add_params['initial_sel_ndx'] + 1;
			ControlFactory::add_combobox($defs, $this, $add_params,
				'upViewed',
				'',
				$upViewed, array('Нет', 'Да'),  600, true, false
			);
			ControlFactory::add_multiline_label($defs, '', 'Поднимать новые в начало списка:', 8);
			$upNew = (HD::getItemStr('upNew') != '') ? HD::getItemStr('upNew') : 1;
			$add_params['initial_sel_ndx'] = $add_params['initial_sel_ndx'] + 1;
			ControlFactory::add_combobox($defs, $this, $add_params,
				'upNew',
				'',
				$upNew, array('Нет', 'Да'),  600, true, false
			);
			ControlFactory::add_multiline_label($defs, '', 'Кешировать постеры и описание в папку DATA:', 8);
			$posterCashe = (HD::getItemStr('posterCashe') != '') ? HD::getItemStr('posterCashe') : 0;
			$add_params['initial_sel_ndx'] = $add_params['initial_sel_ndx'] + 1;
			ControlFactory::add_combobox($defs, $this, $add_params,
				'posterCashe',
				'',
				$posterCashe, array('Нет', 'Да'),  600, true, false
			);
			ControlFactory::add_vgap($defs, -10);
			if ((HD::get_data_path() == DuneSystem::$properties['data_dir_path'])||
			(preg_match('|^/tmp/mnt/storage/|', HD::get_data_path()))||
			(preg_match('|^/D/|', HD::get_data_path()))
			){
				ControlFactory::add_smart_label($defs, "", '<text color="15" size="small">Свободное место: ' . HD::get_storage_size(DuneSystem::$properties['data_dir_path']) . '</text>');
				ControlFactory::add_vgap($defs, -20);
			}
			ControlFactory::add_smart_label($defs, "", '<text color="15" size="tiny">*Отключение кеша удаляет кеш</text>');
			$attrs['initial_sel_ndx'] = isset($user_input->initial_sel_ndx) ? $user_input->initial_sel_ndx : -1;
			return ActionFactory::show_dialog('Дополнительные настройки', $defs, true, 700, $attrs);
		}
		if ($user_input->action == 'addUserFav'){
			$add_params['control_id']= $user_input->control_id;
			$add_params['action'] = $user_input->action;
			if (isset($user_input->delUserFav)){
				$selected_media_url = MediaURL::decode($user_input->selected_media_url);
				$userFavList = HD::getItemsArr('userFavList');
				unset($userFavList[$selected_media_url->class_name]);
				HD::saveItemsArr('userFavList', $userFavList);
				SmartMainMenuScreen::$invalMainMenu = true;
				$action = ActionFactory::invalidate_folders(array('main_menu'));
				return ActionFactory::show_title_dialog('Удалено!', $action);
			}
			if (isset($user_input->newUserFav)){
				$userFavList = HD::getItemsArr('userFavList');
				$userFavList['userFav_' . sprintf("%u", crc32($user_input->newUserFav))] = $user_input->newUserFav;
				HD::saveItemsArr('userFavList', $userFavList);
				SmartMainMenuScreen::$invalMainMenu = true;
				$action = ActionFactory::invalidate_folders(array('main_menu'));
				$action = ActionFactory::show_title_dialog('Добавленно!', $action);
				return ActionFactory::close_and_run($action);
			}
			ControlFactory::add_text_field($defs, $this, $add_params,
				'newUserFav',
				'',
				'', 0, 0, 1, 1, 1250, 0, 1);
			ControlFactory::add_vgap($defs, 500);
			ControlFactory::add_smart_label($defs, "", '<text color="23" size="small">*удаление избранного popup menu в главном меню плагина</text>');
			return ActionFactory::show_dialog("Введите название Избранного", $defs, true);
        }
		if ($user_input->action == 'openSource'){
			$mArr['movie_id'] = $parent_media_url->movie_id;
			$mUrl = VodSourceListScreen::get_media_url_str($class_name, $mArr);
			return ActionFactory::open_folder($mUrl, 'Источники');
		}
		if ($user_input->action == 'aditionalSettings'){
			$add_params['control_id']= $user_input->control_id;
			$add_params['action'] = $user_input->action;
			
			if ((isset($user_input->selected_control_id))&&(isset($user_input->action_type))){
				if (isset($user_input->initial_sel_ndx))
					$params['initial_sel_ndx'] = $user_input->initial_sel_ndx;
				$params['action'] = $user_input->action;
				if ($user_input->selected_control_id == 'filmix_quality')
					if (HD::saveItemStr('filmix_quality', $user_input->filmix_quality, true) == false)
						return ActionFactory::show_title_dialog("Сохранение не удалось");
				if ($user_input->selected_control_id == 'video_quality')
					if (HD::saveItemStr('video_quality', $user_input->video_quality, true) == false)
						return ActionFactory::show_title_dialog("Сохранение не удалось");
				if ($user_input->selected_control_id == 'android_action')
					if (HD::saveItemStr('android_action', $user_input->android_action, true) == false)
						return ActionFactory::show_title_dialog("Сохранение не удалось");
				if ($user_input->selected_control_id == 'downViewed'){
					if (HD::saveItemStr('downViewed', $user_input->downViewed) == false)
						return ActionFactory::show_title_dialog("Сохранение не удалось");
					$action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $params);
					$action = ActionFactory::close_dialog_and_run($action);
					return ActionFactory::invalidate_folders(array($user_input->parent_media_url), $action);
				}
				if ($user_input->selected_control_id == 'framesEpisode'){
					if (HD::saveItemStr('framesEpisode', $user_input->framesEpisode) == false)
						return ActionFactory::show_title_dialog("Сохранение не удалось");
					$action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $params);
					$action = ActionFactory::close_dialog_and_run($action);
					$action = ActionFactory::invalidate_folders(array($user_input->parent_media_url), $action);
					return ActionFactory::show_title_dialog("Сохранено", $action, 'Настройки применится при открытии других списков серий, текущий список закеширован', 800);
				}
				$action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $params);
				return ActionFactory::close_dialog_and_run($action);
			}
			$w1 = 400; $color = 15;
			$vquality[1] = '360';
			$vquality[2] = '480';
			$vquality[3] = '720';
			$vquality[4] = '1080';
			$ini_arr = parse_ini_file('/tmp/run/versions.txt');
			if ((preg_match('|87\d\d|', $ini_arr['platform_kind']))||(HD::is_android() == true)){
				$vquality[5] = '1440p';
				$vquality[6] = '2160p (max.)';
			}
			$add_params['initial_sel_ndx'] = 0;
			if ($parent_media_url->class_name == 'Filmix_Class'){
				$filmix_quality = (HD::getItemStr('filmix_quality', true) != '') ? HD::getItemStr('filmix_quality', true) : 1;
				ControlFactory::add_combobox($defs, $this, $add_params,
					'filmix_quality', '',
					$filmix_quality, $vquality, $w1, true, false
				);
				ControlFactory::add_smart_label($defs,"", '<gap width="' . ($w1 + 20) . '"/><text dy="-69" color="'.$color.'">качество видео Filmix*</text>');
				ControlFactory::add_vgap($defs, -80);
				ControlFactory::add_smart_label($defs, "", '<text color="23" size="small">*качество 720 доступно после логина</text>');
				ControlFactory::add_vgap($defs, 55);
			}else{
				$video_quality = (HD::getItemStr('video_quality', true) != '') ? HD::getItemStr('video_quality', true) : 1;
				ControlFactory::add_combobox($defs, $this, $add_params,
					'video_quality', '',
					$video_quality, $vquality, $w1, true, false
				);
				ControlFactory::add_smart_label($defs,"", '<gap width="' . ($w1 + 20) . '"/><text dy="-69" color="'.$color.'">качество видео*</text>');
				ControlFactory::add_vgap($defs, -80);
				ControlFactory::add_smart_label($defs, "", '<text color="23" size="small">*глобально для всех источников, кроме Filmix и торрентов</text>');
				ControlFactory::add_vgap($defs, 55);
			}
			if (HD::is_android() == true){
				$android_action = (HD::getItemStr('android_action', true) != '') ? HD::getItemStr('android_action', true) : 0;
				ControlFactory::add_vgap($defs, -75);
				$add_params['initial_sel_ndx'] = $add_params['initial_sel_ndx'] + 1;
				ControlFactory::add_combobox($defs, $this, $add_params,
					'android_action',
					'',
					$android_action, array('Нет', 'Да все', 'Только HLS v4'),  $w1, true, false
				);
				ControlFactory::add_smart_label($defs,"", '<gap width="' . ($w1 + 20) . '"/><text dy="-69" color="'.$color.'">использовать Android плеера</text>');
			}
			$downViewed = (HD::getItemStr('downViewed') != '') ? HD::getItemStr('downViewed') : 0;
			ControlFactory::add_vgap($defs, -75);
			$add_params['initial_sel_ndx'] = $add_params['initial_sel_ndx'] + 1;
			ControlFactory::add_combobox($defs, $this, $add_params,
				'downViewed', '',
				$downViewed, array('Да', 'Нет'),  $w1, true, false
			);
			ControlFactory::add_smart_label($defs,"", '<gap width="' . ($w1 + 20) . '"/><text dy="-69" color="'.$color.'">опускать просмотренные вниз</text>');
			$framesEpisode = (HD::getItemStr('framesEpisode') != '') ? HD::getItemStr('framesEpisode') : 1;
			ControlFactory::add_vgap($defs, -75);
			$add_params['initial_sel_ndx'] = $add_params['initial_sel_ndx'] + 1;
			ControlFactory::add_combobox($defs, $this, $add_params,
				'framesEpisode',
				'',
				$framesEpisode, array('Нет', 'Да', 'Кадры Нет'),  $w1, true, false
			);
			ControlFactory::add_smart_label($defs,"", '<gap width="' . ($w1 + 20) . '"/><text dy="-69" color="'.$color.'">кадры эпизодов и недостающие</text>');
			ControlFactory::add_vgap($defs, -75);
			$attrs['initial_sel_ndx'] = isset($user_input->initial_sel_ndx) ? $user_input->initial_sel_ndx : -1;
			return ActionFactory::show_dialog('Дополнительные настройки', $defs, true, 1100, $attrs);
		}
		if ($user_input->action == 'moveToFav'){
			if (!isset($user_input->selected_media_url))
                return null;
			$add_params['action'] = $user_input->action;
			$userFavList = HD::getItemsArr('userFavList');
			if (isset($user_input->selectFav)){
				$caption = $caption2 = 'Избранное';
				if (isset($userFavList[$user_input->selectFav]))
					$caption = $userFavList[$user_input->selectFav];
				if (isset($userFavList[$parent_media_url->class_name]))
					$caption2 = $userFavList[$parent_media_url->class_name];
			}
			if (isset($user_input->invalFav)){
				if ($user_input->invalFav == true){
					$favorites = HD::getItemsArr($parent_media_url->class_name);
					if (isset($favorites[$user_input->selected_media_url]))
						unset ($favorites[$user_input->selected_media_url]);
					if (HD::saveItemsArr($parent_media_url->class_name, $favorites) == false)
						$captionFav = "Удаление из $caption2 не удалось";
				}
				return ActionFactory::invalidate_folders(array(
				VodFavoritesScreen::get_media_url_str($user_input->selectFav,  array('caption' => $caption)),
				VodFavoritesScreen::get_media_url_str($parent_media_url->class_name,  array('caption' => $caption2))
				));
			}
			if (isset($user_input->selectFav)){
				$favorites = HD::getItemsArr($user_input->selectFav);
				if (isset($favorites[$user_input->selected_media_url]))
					unset ($favorites[$user_input->selected_media_url]);
				
				$flipFavorites = array_flip ($favorites);
				if ($selected_media_url->class_name == 'myShows_Class'){
					if (isset($selected_media_url->movie_id)){
						$jsds = VideoInfo::get_info_by_myshows_id ($selected_media_url->movie_id);
						if ($jsds->kinopoiskId != ''){
							$smu = json_decode($user_input->selected_media_url);
							$smu->poster_url = Kinopoisk_Class::http_get_img("http://st.kp.yandex.net/images/film_iphone/iphone360_".$jsds->kinopoiskId.".jpg");
							if (isset($smu->shape))
								unset($smu->shape);
							$smu->kpID = $jsds->kinopoiskId;
							$user_input->selected_media_url =  json_encode($smu);
						}
					}
				}
				array_unshift ($flipFavorites, $user_input->selected_media_url);
				$favorites = array_flip ($flipFavorites);
				if (HD::saveItemsArr($user_input->selectFav, $favorites) == false)
					$captionFav = "Добавление в $caption не удалось";
				$captionFav = 'Добавленно в ' . $caption;
				ControlFactory::add_multiline_label($defs, '', "Удалить из $caption2?", 8);
				$add_params['selectFav'] = $user_input->selectFav;
				$add_params['invalFav'] = true;
				ControlFactory::add_close_dialog_and_apply_button($defs, $this, $add_params, $user_input->control_id, 'Да', 550);
				$add_params['invalFav'] = false;
				ControlFactory::add_close_dialog_and_apply_button($defs, $this, $add_params, $user_input->control_id, 'Нет', 550);
				return ActionFactory::show_dialog($captionFav, $defs, true);
			}
			
			if ($parent_media_url->class_name != 'favorites'){
				$add_params['selectFav'] = 'favorites';
				$action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $add_params);
				ControlFactory::add_custom_close_dialog_and_apply_buffon($defs, null, 'Избранное', 550, $action);
			}
			foreach ($userFavList as $k => $v){
				if ($parent_media_url->class_name != $k){
					$add_params['selectFav'] = $k;
					$action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $add_params);
					ControlFactory::add_custom_close_dialog_and_apply_buffon($defs, null, $v, 550, $action);
				}
			}
			return ActionFactory::show_dialog('Переместить в', $defs, true);
		}
		if ($user_input->action == 'addToFav'){
			if (!isset($user_input->selected_media_url))
                return null;
			if (isset($selected_media_url->torrent_id))
				$user_input->selected_media_url = $user_input->parent_media_url;
			$add_params['action'] = $user_input->action;
			$userFavList = HD::getItemsArr('userFavList');
			$favorites = HD::getItemsArr('favorites');
			if (isset($user_input->favAction)){
				$caption = 'Избранное';
				if ($user_input->selectFav != 'favorites'){
					$favorites = HD::getItemsArr($user_input->selectFav);
					$caption = $userFavList[$user_input->selectFav];
				}
				if (isset($favorites[$user_input->selected_media_url])){
					HD::pluginCacheDel($user_input->selected_media_url);
					unset ($favorites[$user_input->selected_media_url]);
					$captionFav = 'Удаленно из ' . $caption;
				}else if ((isset($user_input->del_media_url))&&(isset($favorites[$user_input->del_media_url]))){
					HD::pluginCacheDel($user_input->del_media_url);
					unset ($favorites[$user_input->del_media_url]);
					$captionFav = 'Удаленно из ' . $caption;
				}else{
					$flipFavorites = array_flip ($favorites);
					myShows_Class::addToFavAndMyShows($user_input->selectFav, $selected_media_url, $user_input);
					if ($selected_media_url->class_name == 'myShows_Class'){
						if (isset($selected_media_url->movie_id)){
							$jsds = VideoInfo::get_info_by_myshows_id ($selected_media_url->movie_id);
							if ($jsds->kinopoiskId != ''){
								$smu = json_decode($user_input->selected_media_url);
								$smu->poster_url = Kinopoisk_Class::http_get_img("http://st.kp.yandex.net/images/film_iphone/iphone360_".$jsds->kinopoiskId.".jpg");
								if (isset($smu->shape))
									unset($smu->shape);
								$smu->kpID = $jsds->kinopoiskId;
								$user_input->selected_media_url =  json_encode($smu);
							}
						}
					}
					array_unshift ($flipFavorites, $user_input->selected_media_url);
					$favorites = array_flip ($flipFavorites);
					$captionFav = 'Добавленно в ' . $caption;
				}
				$post_action = ActionFactory::invalidate_folders(array(VodFavoritesScreen::get_media_url_str($user_input->selectFav,  array('caption' => $caption))));
				if (HD::saveItemsArr($user_input->selectFav, $favorites) == false)
					$captionFav = "Добавление в $caption не удалось";
				if ($user_input->favAction != 'delete2')
					return ActionFactory::show_title_dialog($captionFav, $post_action, $selected_media_url->caption, 800);
				return $post_action;
			}
			if (count($userFavList) > 0){
				if (isset($user_input->myShowsID))
					$add_params['myShowsID'] = $user_input->myShowsID;
				if (isset($user_input->kpID))
					$add_params['kpID'] = $user_input->kpID;
				if (isset($favorites[$user_input->selected_media_url])){
					$add_params['favAction'] = 'delete';
					$caption = 'Удалить из';
				}else{
					$add_params['favAction'] = 'addTo';
					$caption = 'Добавить в';
				}
				$add_params['selectFav'] = 'favorites';
				$action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $add_params);
				ControlFactory::add_custom_close_dialog_and_apply_buffon($defs, null, $caption . ': Избранное', 750, $action);
				foreach ($userFavList as $k => $v){
					$favList = HD::getItemsArr($k);
					if (isset($favList[$user_input->selected_media_url])){
						$add_params['favAction'] ='delete';
						$caption = 'Удалить из';
					}else{
						$add_params['favAction'] = 'addTo';
						$caption = 'Добавить в';
					}
					$add_params['selectFav'] = $k;
					$action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $add_params);
					ControlFactory::add_custom_close_dialog_and_apply_buffon($defs, null, $caption . ': ' . $v, 750, $action);
				}
				return ActionFactory::show_dialog('Избранное', $defs, true);
			}
			if (isset($favorites[$user_input->selected_media_url])){
				$add_params['favAction'] ='delete';
				$add_params['selectFav'] = 'favorites';
				ControlFactory::add_multiline_label($defs, '', "Итем уже находится в избранном.\nУдалить из Избранного?", 8);
				$action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $add_params);
				ControlFactory::add_close_dialog_and_apply_button($defs, $this, $add_params, $user_input->control_id, 'Удалить', 250);
				ControlFactory::add_close_dialog_button($defs,'Отмена', 250);
				return ActionFactory::show_dialog('Удаление', $defs, true, 750);
			}else{
				$flipFavorites = array_flip ($favorites);
				myShows_Class::addToFavAndMyShows('favorites', $selected_media_url, $user_input);
				if ($selected_media_url->class_name == 'myShows_Class'){
					if (isset($selected_media_url->movie_id)){
						$jsds = VideoInfo::get_info_by_myshows_id ($selected_media_url->movie_id);
						if ($jsds->kinopoiskId != ''){
							$smu = json_decode($user_input->selected_media_url);
							$smu->poster_url = Kinopoisk_Class::http_get_img("http://st.kp.yandex.net/images/film_iphone/iphone360_".$jsds->kinopoiskId.".jpg");
							if (isset($smu->shape))
								unset($smu->shape);
							$smu->kpID = $jsds->kinopoiskId;
							$user_input->selected_media_url =  json_encode($smu);
						}
					}
				}
				array_unshift ($flipFavorites, $user_input->selected_media_url);
				$favorites = array_flip ($flipFavorites);
				$caption = 'Добавленно в Избранное';
			}
			if (HD::saveItemsArr('favorites', $favorites) == false)
				$caption = 'Добавление в Избранное не удалось';
			$post_action = ActionFactory::invalidate_folders(array(VodFavoritesScreen::get_media_url_str('favorites',  array('caption' => 'Избранное'))));
			return ActionFactory::show_title_dialog($caption, $post_action, $selected_media_url->caption, 800);
		}
		
		if ($user_input->action == 'reboot'){
			if (isset($user_input->do_reboot))
				return ActionFactory::restart();
			$defs = array();
			if (isset($user_input->msg))
				$msg = $user_input->msg;
			else
				$msg = 'Перезагрузить плеер сейчас?';
			ControlFactory::add_multiline_label($defs, '', $msg, 8);
			$add_params['indiClass'] = 'SmartConfig';
			$add_params['action'] = $user_input->action;
			$add_params['do_reboot'] = true;
			$reboot = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $add_params);
			ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,'_reboot', 'Да', 250, $reboot);
			ControlFactory::add_close_dialog_button($defs, 'Нет', 250);
			return ActionFactory::show_dialog('Необходима перезагрузка плеера', $defs, true, 800);
		}
		
		if ($user_input->action == 'background_actions'){
			if (isset($user_input->del)){
				$parent_media_url = MediaURL::decode($user_input->parent_media_url);
				if (!unlink(HD::get_data_path() . "/icons/" . $parent_media_url->screen_id . "_bg.jpg"))
					return ActionFactory::show_title_dialog('Удаление не удалось!', null, HD::get_data_path() . "/icons/" . $parent_media_url->screen_id . "_bg.jpg");
				$add_params['action'] = 'reboot';
				$add_params['indiClass'] = 'SmartConfig';
				return UserInputHandlerRegistry::create_action($this, $user_input->control_id, $add_params);
			}
			$media_url = MediaURL::encode (
				array(
					'screen_id'     => 'file_list',
					'save_file'		=> array(
						'parent' => $user_input->parent_media_url,
						'action' => 'plugin_ico',
						'arg' => $parent_media_url->screen_id . '_bg',
						'extension' => 'jpg',
						'reboot' => true
					),
				)
			);
			return ActionFactory::open_folder($media_url,'Задать бекграунд');
		}
		
		if ($user_input->action == 'addToMainMenu'){
			$mainMenuItems = HD::getItemsArr('mainMenuItems');
			if (isset($user_input->del))
				unset($mainMenuItems[$user_input->selected_media_url]);
			else{
				$mainMenuItems[$user_input->selected_media_url] = $selected_media_url->caption;
				$caption = 'Добавлено в главное меню.';
			}
			if (HD::saveItemsArr('mainMenuItems', $mainMenuItems) != true)
				$caption = 'Добавление не удалось';
			SmartMainMenuScreen::invalMainMenu();
			$post_action = ActionFactory::invalidate_folders(array('main_menu'));
			if (isset($user_input->del))
				return $post_action;
			return ActionFactory::show_title_dialog($caption, $post_action, $selected_media_url->caption, 900);
		}
		
		if ($user_input->action == 'eneyIn'){
			$ul = base64_decode('0JLQstC10LTQuNGC0LUg0LvQvtCz0LjQvQ');
			$up = base64_decode('0JLQstC10LTQuNGC0LUg0L/QsNGA0L7Qu9GM');
			$add_params['action']= $user_input->action;
			$eney = HD::getItemsArr('eney');
			if (isset($user_input->eney)){
				if ($user_input->ul == ''){
					if (isset($eney[$class_name::$cName])){
						if (file_exists($class_name::cookie()))
							unlink($class_name::cookie());
						unset($eney[$class_name::$cName]);
						HD::saveItemsArr('eney', $eney);
						$caption = base64_decode('0JvQvtCz0LjQvSDQuCDQv9Cw0YDQvtC70Ywg0YPQtNCw0LvQtdC90LXQvdGLIQ');
						$post_action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $add_params);
						return ActionFactory::show_title_dialog($caption, $post_action, '', 0);
					}
				}
				if (($user_input->ul == '')||($user_input->up == '')||($ul == $user_input->ul)||($up == $user_input->up)){
					$caption = base64_decode('0KHQvtGF0YDQsNC90LXQvdC40LUg0L3QtSDRg9C00LDQu9C+0YHRjCE');
					$msg = base64_decode('0KPQutCw0LbQuNGC0LUg0L/RgNCw0LLQuNC70YzQvdC+INC70L7Qs9C40L0g0Lgg0L/QsNGA0L7Qu9GMLg');
					$post_action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $add_params);
					return ActionFactory::show_title_dialog($caption, $post_action, $msg, 0);
				}
				$eneyIn = $class_name::testEneyIn ($user_input->ul, $user_input->up);
				if ($eneyIn == true){
					if (is_array($eneyIn)){
						$add_params['ul'] = $user_input->ul;
						$add_params['up'] = $user_input->up;
						if (isset($eneyIn['msg'])){
							$post_action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $add_params);
							return ActionFactory::show_title_dialog(base64_decode($eneyIn['caption']), $post_action, base64_decode($eneyIn['msg']), $width);
						}
						if (isset($eneyIn['capthca'])){
							//todo m.b
						}
					}
					$eney[$class_name::$cName][0] = HD::eney($user_input->ul);
					$eney[$class_name::$cName][1] = HD::eney($user_input->up);
					HD::saveItemsArr('eney', $eney);
					$caption = base64_decode('0JvQvtCz0LjQvSDQuCDQv9Cw0YDQvtC70Ywg0YHQvtGF0YDQsNC90LXQvdGLIQ');
					return ActionFactory::show_title_dialog($caption, $post_action, '', 0);
				}else{
					$caption = base64_decode('0JDQstGC0L7RgNC40LfQsNGG0LjRjyDQvdC1INGD0LTQsNC70LDRgdGMIQ');
					$msg = base64_decode('0J/RgNC+0LLQtdGA0YzRgtC1INC/0YDQsNCy0LjQu9GM0L3QvtGB0YLRjCDQstCy0L7QtNCwINC70L7Qs9C40L3QsCDQuCDQv9Cw0YDQvtC70Y8uINCf0YDQuCDQstGL0LrQu9Cw0LTRi9Cy0LDQvdC40LggbG9nINGE0LDQudC70LAg0L/RgNC+0LLQtdGA0YzRgtC1INC90LXRgiDQu9C4INGC0LDQvCDQstCw0YjQuNGFINC70LjRh9C90YvRhSDQtNCw0L3QvdGL0YUh');
					$add_params['ul'] = $user_input->ul;
					$add_params['up'] = $user_input->up;
					$post_action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $add_params);
					return ActionFactory::show_title_dialog($caption, $post_action, $msg, $width);
				}
			}
			
			$ps = 0;
			if (isset($eney[$class_name::$cName])){
				$ul = HD::eney('l', $eney[$class_name::$cName][0]);
				$up = HD::eney('p', $eney[$class_name::$cName][1]);
				$ps = 1;
			}else if (isset($user_input->ul)) {
				$ul = $user_input->ul;
				$up = $user_input->up;
			}
			ControlFactory::add_text_field($defs, $this, null,
				'ul',
				'',
				$ul, 0, 0, 0, 1, 950, 0, false
            );
			ControlFactory::add_text_field($defs, $this, null,
				'up',
				'',
				$up, 0, $ps, 0, 1, 950, 0, false
            );
			$add_params['eney']= 'eney';
			ControlFactory::add_close_dialog_and_apply_button($defs, $this, $add_params, $user_input->control_id, 'Применить', 450);
			return ActionFactory::show_dialog(base64_decode("0JvQvtCz0LjQvSDQvdCwINGB0LDQudGCIA") . $class_name::$cName, $defs, true, $width);
		}
		
		if ($user_input->action == 'mirror'){
			$add_params['action']= $user_input->action;
			if (isset($user_input->newDomen)){
				if ((!preg_match("|http|", $user_input->newDomen))&&($user_input->newDomen != ''))
					$user_input->newDomen = 'http://' . $user_input->newDomen;
				$user_input->newDomen = preg_replace("|\/$|", '', $user_input->newDomen);
				if ((preg_match('|^(http[s]?\:\/\/)?((\w+)\.)?(([\w-]+)?)(\.[\w-]+){1,2}$|', $user_input->newDomen))
					||($user_input->newDomen == ''))
					HD::saveItemStr($class_name::$cName . 'DomainName', $user_input->newDomen);
				else{
					$action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $add_params);
					return ActionFactory::show_title_dialog('Не Сохранено!', $action, $user_input->newDomen . ' не доменное имя.', $width - 350);
				}
				$class_name::$DomainName = null;
				if (method_exists($class_name,'cookie')){
					if (file_exists($class_name::cookie()))
						unlink($class_name::cookie());
				}
				if ($user_input->newDomen == '')
					$user_input->newDomen = 'значение по умолчанию.';
				return ActionFactory::show_title_dialog('Сохранено!', null, "Доменное имя зеркала:\n" . $user_input->newDomen, $width - 350);
			}
			ControlFactory::add_multiline_label($defs,'' ,"Указывайте доменное имя зеркала " . $class_name::$cName . " но не сайтов клонов. Они возможно работать не будут. Точно указывайте тип сайта https или http - это важно.", 5);
			ControlFactory::add_text_field($defs, $this, null,
                    'newDomen',
                    '',
                    $class_name::getDomainName(), 0, 0, 0, 1, $width - 100, false, false
            );
			ControlFactory::add_close_dialog_and_apply_button($defs, $this, $add_params, $user_input->control_id, 'Применить', 450);
			return ActionFactory::show_dialog("Доменное имя зеркала " . $class_name::$cName, $defs, true, $width);
		}
		
		if ($user_input->action == 'apiToken'){
			$kpUnOffToken = (HD::getItemStr('kpUnOffToken') != '') ? HD::getItemStr('kpUnOffToken') : '';
			if (isset($user_input->newApiToken)){
				if (HD::saveItemStr('kpUnOffToken', $user_input->newApiToken) == false)
					return ActionFactory::show_title_dialog("Сохранение не удалось");
				return ActionFactory::show_title_dialog("Сохранено");
			}
			ControlFactory::add_multiline_label($defs,'' ,"Укажите свой API токен сервиса kinopoiskapiunofficial.tech", 5);
			ControlFactory::add_text_field($defs, $this, null,
                    'newApiToken',
                    '',
                    $kpUnOffToken, 0, 0, 0, 1, $width - 100, false, false
            );
			$add_params['action']= $user_input->action;
			ControlFactory::add_close_dialog_and_apply_button($defs, $this, $add_params, $user_input->control_id, 'Применить', 450);
			return ActionFactory::show_dialog("API токен сервиса kinopoiskapiunofficial.tech", $defs, true, $width);
		}
		
		if ($user_input->action == 'proxy'){
			if ($class_name == 'search')
				$class_name = 'Kinopoisk_Class';
			$add_params['action']= $user_input->action;
			$sitesProxy = HD::getItemsArr('sitesProxy');
			if (isset($user_input->sitesProxyOnOff)){
				if (isset($sitesProxy[$class_name::$cName]))
					unset($sitesProxy[$class_name::$cName]);
				else
					$sitesProxy[$class_name::$cName] = 1;
				HD::saveItemsArr('sitesProxy', $sitesProxy);
				return UserInputHandlerRegistry::create_action($this, $user_input->control_id, $add_params);
			}
			if (isset($user_input->openProxyFile)){
				$class_name::$proxyArr = false;
				HD::saveItemsArr('proxyListFilePath', array());
				$media_url = MediaURL::encode(
                    array(
                        'screen_id'     => 'file_list',
						'save_file'		=> array(	
						'parent'		=> $user_input->parent_media_url,
						'action'		=> 'saveFilePath',
						'arg'			=> 'proxyListFilePath',
						'extension'		=> 'txt'
						),
                    )
				);
				return ActionFactory::open_folder($media_url,'%tr%t202');
			}
			
			if (isset($user_input->saveProxy)){
				$proxySettings['proxy'] = $user_input->proxy;
				if ((isset($user_input->proxyType))&&($user_input->proxyType == 'SOCKS5'))
					$proxySettings['proxyType'] = $user_input->proxyType;
				else
					$proxySettings['proxyType'] = $user_input->proxyType = 'HTTP';
				if (isset($user_input->proxyAccount))
					$proxySettings['proxyAccount'] = $user_input->proxyAccount;
				if (isset($user_input->kpProxyType))
					$proxySettings['kpProxyType'] = $user_input->kpProxyType;
				if (HD::saveItemsArr('proxySettings', $proxySettings) == false)
					return ActionFactory::show_title_dialog("Сохранение не удалось");
				$proxySettingsHistory = HD::getItemsArr('proxySettingsHistory');
				$proxySettingsHistory = array_reverse($proxySettingsHistory);
				$proxySettingsHistory[$user_input->proxy . ' [' . $user_input->proxyType . ']'] = $proxySettings;
				$proxySettingsHistory = array_reverse($proxySettingsHistory);
				$proxySettingsHistory = array_slice($proxySettingsHistory, 0, 10);
				if (HD::saveItemsArr('proxySettingsHistory', $proxySettingsHistory) == false)
					return ActionFactory::show_title_dialog("Сохранение не удалось");
				$sitesProxy = HD::getItemsArr('sitesProxy');
				$sitesProxy[$class_name::$cName] = 1;
				if (HD::saveItemsArr('proxySettingsHistory', $proxySettingsHistory) == false)
					return ActionFactory::show_title_dialog("Сохранение не удалось");
				if ($class_name == 'Kinopoisk_Class')
					$class_name::$kpAccess = 'noCheck';
				$class_name::$proxy = $proxySettings;
				$action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $add_params);
				return ActionFactory::show_title_dialog('Сохранено!',$action);
			}
			if (isset($user_input->testProxy)){
				$action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $add_params);
				if ($user_input->proxy == ''){
					HD::saveItemsArr('proxySettings', array());
					return ActionFactory::show_title_dialog('Настройка прокси сброшена!',$action);
				}
				if ($user_input->proxy == 'IP прокси сервера:порт')
					return ActionFactory::show_title_dialog('Прокси не указан!',$action);
				$opts[CURLOPT_PROXY] = $user_input->proxy;
				if ((isset($user_input->proxyType))&&($user_input->proxyType == 'SOCKS5'))
					$opts[CURLOPT_PROXYTYPE] = CURLPROXY_SOCKS5;
				else
					$user_input->proxyType = 'HTTP';
				if ((isset($user_input->proxyAccount))&&($user_input->proxyAccount != '')&&($user_input->proxyAccount != 'Логин:Пароль (задавать при необходимости)'))
					$opts[CURLOPT_PROXYUSERPWD] = $user_input->proxyAccount;
				$opts[CURLOPT_HEADER] = true;
				$opts[CURLOPT_NOBODY] = true;
				$opts['getHttpCode'] = 1;
				$httpCodeArr = HD::http_get_document($class_name::getDomainName(), $opts);
				if ($httpCodeArr['httpCode'] == 200)
					ControlFactory::add_smart_label($defs, '', '<text color="18" size="small">Тест proxy: </text><text color="15" size="small">' . $user_input->proxy . '</text><text color="18" size="small"> [ok]</text>');
				else{
					ControlFactory::add_vgap($defs, -20);
					ControlFactory::add_smart_label($defs, '', '<text color="21">Подключение не удалось</text>');
					ControlFactory::add_vgap($defs, -20);
					unset ($httpCodeArr['httpCode']);
					foreach ($httpCodeArr as $k => $v){
						ControlFactory::add_smart_label($defs, "", '<text color="21" size="tiny">'.$k.' </text><text color="15" size="tiny">'.$v.'</text>');
						ControlFactory::add_vgap($defs, -30);
					}
				}
				
				ControlFactory::add_smart_label($defs, '', '<text color="14" size="small">Proxy: </text><text color="15" size="small">' . $user_input->proxy . '</text>');
				ControlFactory::add_vgap($defs, -20);
				ControlFactory::add_smart_label($defs, '', '<text color="14" size="small">Тип прокси: </text><text color="15" size="small">' . $user_input->proxyType . '</text>');
				ControlFactory::add_vgap($defs, -20);
				if ((isset($user_input->proxyAccount))&&(($user_input->proxyAccount != '')||($user_input->proxyAccount != 'Логин:Пароль (задавать при необходимости)'))){
					ControlFactory::add_smart_label($defs, '', '<text color="14" size="small">Логин Пароль: </text><text color="15" size="small">' . $user_input->proxyAccount . '</text>');
					ControlFactory::add_vgap($defs, -20);
				}
				ControlFactory::add_smart_label($defs, "", '<text color="15" size="small">*Проверьте правильность указания типа прокси.</text>');
				ControlFactory::add_vgap($defs, -20);
				ControlFactory::add_smart_label($defs, "", '<text color="15" size="small">**Если вы уверенны в роботоспособности прокси - сохранить,</text>');
				ControlFactory::add_vgap($defs, -30);
				ControlFactory::add_smart_label($defs, "", '<text color="15" size="small">возможно не правильное определение</text>');

				$add_params['proxy'] = $user_input->proxy;
				if ((isset($user_input->proxyType))&&($user_input->proxyType == 'SOCKS5'))
					$add_params['proxyType'] = $user_input->proxyType;
				if ((isset($user_input->proxyAccount))&&(($user_input->proxyAccount != '')&&($user_input->proxyAccount != 'Логин:Пароль (задавать при необходимости)')))
					$add_params['proxyAccount'] = $user_input->proxyAccount;
				if (isset($user_input->kpProxyType))
					$add_params['kpProxyType'] = $user_input->kpProxyType;
				$add_params['saveProxy'] = true;
				ControlFactory::add_close_dialog_and_apply_button($defs, $this, $add_params, $user_input->control_id, 'Сохранить', 450);
				unset($add_params['saveProxy']);
				if (isset($user_input->initial_sel_ndx)){
					$add_params['openProxyList'] = $user_input->openProxyList;
					$add_params['initial_sel_ndx'] = $user_input->initial_sel_ndx;
					$add_params['nextPageToken'] = $user_input->nextPageToken;
				}
				ControlFactory::add_close_dialog_and_apply_button($defs, $this, $add_params, $user_input->control_id, 'Отмена', 450);
				return ActionFactory::show_dialog("Тест прокси для " . $class_name::$cName, $defs, true, $width);
			}
			if (isset($user_input->openProxyList)){
				$add_params['openProxyList'] = $user_input->openProxyList;
				$pageToken = 0;
				if (isset($user_input->nextPageToken))
					$pageToken = $user_input->nextPageToken;
				$badProxy = HD::getItemsArr('badProxy');
				if ($class_name::$proxyArr == false){
					$class_name::$proxyArr = file($user_input->openProxyList, FILE_IGNORE_NEW_LINES | FILE_SKIP_EMPTY_LINES);
					$class_name::$proxyArrMd5 = md5(implode ('',$class_name::$proxyArr));
					if ((current($class_name::$proxyArr)) != $class_name::$proxyArrMd5){
						HD::saveItemsArr('badProxy', array());
						$badProxy = HD::getItemsArr('badProxy');
					}
				}
				$i = $pageToken * 10;
				do{
					$add_params['initial_sel_ndx'] = $i - ($pageToken * 10);
					$prefix = ($i + 1) . '. ';
					if ((isset($user_input->initial_sel_ndx))&&($add_params['initial_sel_ndx'] == $user_input->initial_sel_ndx)){
						$prefix = '[x] ';
						$badProxy[$class_name::$proxyArr[$i]] = $class_name::$proxyArrMd5;
						HD::saveItemsArr('badProxy', $badProxy);
					}else if (isset($badProxy[$class_name::$proxyArr[$i]]))
						$prefix = '[x] ';
					$add_params['nextPageToken'] = $pageToken;
					$add_params['proxy'] = $class_name::$proxyArr[$i];
					$add_params['testProxy'] = true;
					$gui_params['button_caption_centered'] = false;
					ControlFactory::add_close_dialog_and_apply_button($defs, $this, $add_params, $user_input->control_id,  $prefix. $class_name::$proxyArr[$i], $width - 50, $gui_params);

					$i++;
				}while (($i < (($pageToken * 10) + 10))&&(isset($class_name::$proxyArr[$i + 1])));
				
				unset($add_params['proxy'], $add_params['testProxy'], $add_params['initial_sel_ndx']);
				
				if ((($pageToken + 1) * 10) < (count($class_name::$proxyArr))){
					$add_params['nextPageToken'] = $pageToken + 1;
					ControlFactory::add_close_dialog_and_apply_button($defs, $this, $add_params, $user_input->control_id, 'Далее', 450);
				}
				if ($pageToken != 0){
					$add_params['nextPageToken'] = $pageToken - 1;
					ControlFactory::add_close_dialog_and_apply_button($defs, $this, $add_params, $user_input->control_id, 'Назад', 450);
				}
					
				$attrs['initial_sel_ndx'] = isset($user_input->initial_sel_ndx) ? $user_input->initial_sel_ndx : -1;
				$all = round((count($class_name::$proxyArr)) / 10);
				if (((count($class_name::$proxyArr)) % 10) > 0)
					$all++;
				$params['action'] = $user_input->action;
				$action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $params);
				$attrs['actions'][GUI_EVENT_KEY_RETURN]	= ActionFactory::close_dialog_and_run($action);
				return  ActionFactory::show_dialog("Proxy страница " . ($pageToken + 1) ." из " . $all, $defs, true, $width, $attrs);
			}
			if (isset($user_input->proxyHistory)){
				$proxySettingsHistory = HD::getItemsArr('proxySettingsHistory');
				$add_params['proxy'] = $proxySettingsHistory[$user_input->proxyHistory]['proxy'];
				$add_params['proxyType'] = $proxySettingsHistory[$user_input->proxyHistory]['proxyType'];
				if (isset($proxySettingsHistory[$user_input->proxyHistory]['proxyAccount']))
					$add_params['proxyAccount'] = $proxySettingsHistory[$user_input->proxyHistory]['proxyAccount'];
				$add_params['testProxy'] = true;
				$action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $add_params);
				return ActionFactory::close_dialog_and_run($action);
			}
			$proxySettings = (HD::getItemsArr('proxySettings') != array()) ? HD::getItemsArr('proxySettings') : array('proxy' => '', 'proxyType' => 'HTTP', 'proxyAccount' => 'Логин:Пароль (задавать при необходимости)');
			if ($proxySettings['proxy'] == ''){
				ControlFactory::add_vgap($defs, -10);
				ControlFactory::add_label($defs, '', 'Прокси для ' . $class_name::$cName . ' не включен');
				ControlFactory::add_vgap($defs, -20);
				ControlFactory::add_smart_label($defs, "", 
					'<text size="tiny">*что бы включить прокси укажите IP адрес и порт прокси сервера</text>'
				);
				$caption = false;
			}else if (isset($sitesProxy[$class_name::$cName])){
				ControlFactory::add_vgap($defs, -10);
				ControlFactory::add_label($defs, '', 'Прокси для ' . $class_name::$cName . ' включен');
				ControlFactory::add_vgap($defs, -30);
				ControlFactory::add_smart_label($defs, "", 
					'<text size="tiny">*прокси работает только для каталога (источники через прокси не работают)</text>'
				);
				ControlFactory::add_vgap($defs, -30);
				$caption = 'Выключить';
			}else{
				ControlFactory::add_vgap($defs, -10);
				ControlFactory::add_label($defs, '', 'Прокси для ' . $class_name::$cName . ' не включен');
				ControlFactory::add_vgap($defs, 9);
				$caption = 'Включить';
			}
			if ($caption == true){
				$params3['action'] = $user_input->action;
				$params3['sitesProxyOnOff'] = true;
				ControlFactory::add_close_dialog_and_apply_button($defs, $this, $params3, $user_input->control_id, $caption, 450);	
			}
			if (isset($user_input->addProxy))
				$proxy = $user_input->addProxy;
			else if ($proxySettings['proxy'] == '')
				$proxy = 'IP прокси сервера:порт';
			else{
				$proxy = $proxySettings['proxy'];
				ControlFactory::add_label($defs, '', 'IP прокси сервера:порт');
			}
			ControlFactory::add_text_field($defs, $this, null,
				'proxy',
				'',
				$proxy, 0, 0, 0, 1, $width - 100, 0, false
			);
			$proxyType_ops['HTTP'] = 'Тип прокси: HTTP';
			$proxyType_ops['SOCKS5'] = 'Тип прокси: SOCKS5';
			
			if (isset($user_input->addProxyType))
				$proxySettings['proxyType'] = $user_input->addProxyType;
			else if (!isset($proxySettings['proxyType']))
				$proxySettings['proxyType'] = 'HTTP';
			ControlFactory::add_combobox($defs, $this, null,
				'proxyType',
				'',
				$proxySettings['proxyType'], $proxyType_ops,  $width - 100, true
			);
			if ((!isset($proxySettings['proxyAccount']))||($proxySettings['proxyAccount'] == ''))
				$proxySettings['proxyAccount'] = 'Логин:Пароль (задавать при необходимости)';
			ControlFactory::add_text_field($defs, $this, null,
				'proxyAccount',
				'',
				$proxySettings['proxyAccount'], 0, 0, 0, 1, $width - 100, 0, false
            );
			ControlFactory::add_vgap($defs, -20);
			ControlFactory::add_smart_label($defs, "", 
				'<text size="tiny">**прокси используется для всех сайтов с включенной функцией "Использовать прокси"</text>'
			);
			if ($class_name == 'Kinopoisk_Class'){
				ControlFactory::add_vgap($defs, -40);
				if (!isset($proxySettings['kpProxyType']))
					$proxySettings['kpProxyType'] = 2;
				ControlFactory::add_label($defs, '', 'Использовать прокси для:');
				ControlFactory::add_vgap($defs, -10);
				$kpProxyType_ops[1] = 'карточка';
				$kpProxyType_ops[2] = 'карточка и постеры';
				ControlFactory::add_combobox($defs, $this, null,
					'kpProxyType',
					'',
					$proxySettings['kpProxyType'], $kpProxyType_ops,  $width - 100, true
				);
			}else
				ControlFactory::add_vgap($defs, -10);
			$add_params['testProxy']= true;
			ControlFactory::add_close_dialog_and_apply_button($defs, $this, $add_params, $user_input->control_id, 'Применить', 450);
			$proxySettingsHistory = HD::getItemsArr('proxySettingsHistory');
			if (count($proxySettingsHistory) > 0){
				$proxyHistoryOps[0] = 'История proxy';
				foreach ($proxySettingsHistory as $k => $v)
					$proxyHistoryOps[$k] = $k;
				$add_params['action'] = 'proxy';
				$add_params['control_id']= $user_input->control_id;
				unset ($add_params['testProxy']);
				ControlFactory::add_combobox($defs, $this, $add_params,
					'proxyHistory',
					'',
					0, $proxyHistoryOps,  $width - 100, true, false
				);
			}
			ControlFactory::add_label($defs, '', 'Cписок прокси из текстового файла');
			$proxyListFilePath = smbtree::get_folder_info ('proxyListFilePath');

			if ($proxyListFilePath == true){
				ControlFactory::add_vgap($defs, -30);
				ControlFactory::add_smart_label($defs, "", '<text color="17" size="small">'.$proxyListFilePath.'</text>');
				$params2['action'] = $user_input->action;
				$params2['openProxyList'] = $proxyListFilePath;
				ControlFactory::add_close_dialog_and_apply_button($defs, $this, $params2, $user_input->control_id, 'Показать', 450);
			}
			$params['action'] = $user_input->action;
			$params['openProxyFile']= true;
			ControlFactory::add_close_dialog_and_apply_button($defs, $this, $params, $user_input->control_id, 'Выбрать файл', 450);
			
			return ActionFactory::show_dialog("Использовать прокси для " . $class_name::$cName, $defs, true, $width);
		}
		return ActionFactory::show_title_dialog($caption, $post_action, $msg, 0);
	}
	public static function getMovieInfoArr($getMovieInfo, $movie_id, $mUrl, $arr){
		if (!isset($arr['caption_original']))
			$arr['caption_original'] = $arr['caption'];
		if ($getMovieInfo == 'min'){
			// if (!isset($arr['class_info']['dbIDs']['kpID'])){
				// $year = '';
				// if ((isset($arr['year']))&&(preg_match("#^(\d{4})#",$arr['year'], $mch)))
					// $year = $mch[1];
				// else if ((isset($arr['country']))&&(preg_match("#(\d{4})#",$arr ['country'], $mch)))
					// $year = $mch[1];
				// $kpID = Kinopoisk_Class::searchKpId ($arr['caption'], $arr['caption_original'], $year);
					// if ($kpID == true)
						// $arr['class_info']['dbIDs']['kpID'] = $kpID;
			// }
			if (isset($arr['class_info']['dbIDs']['kpID'])){
				$kpInfo = Kinopoisk_Class::simpleKpIdInfo($arr['class_info']['dbIDs']['kpID']);
				foreach ($kpInfo as $k => $v)
					$arr[$k] = $v;
			}
		}else{
			$kpIDs = HD::getItemsArr('kpIDs');
			if (isset($kpIDs[$movie_id]))
				$arr['class_info']['dbIDs']['kpID'] = $kpIDs[$movie_id];
			if ((isset($mUrl->kpID))&&(!isset($arr['class_info']['dbIDs']['kpID'])))
				$arr['class_info']['dbIDs']['kpID'] = $mUrl->kpID;
			if (!isset($arr['class_info']['dbIDs']['kpID'])){
				$year = '';
				if ((isset($arr['year']))&&(preg_match("#^(\d{4})#",$arr['year'], $mch)))
					$year = $mch[1];
				else if ((isset($arr['country']))&&(preg_match("#(\d{4})#",$arr ['country'], $mch)))
					$year = $mch[1];
				$kpID = Kinopoisk_Class::searchKpId ($arr['caption'], $arr['caption_original'], $year);
				if ($kpID == true)
					$arr['class_info']['dbIDs']['kpID'] = $kpID;
			}
			if (!isset($arr['class_info']['dbIDs']['kpID']))
				return $arr;
			$jsd = Kinopoisk_Class::get_id_info($arr['class_info']['dbIDs']['kpID']);
			if ($jsd == true){
				// if ((isset($jsd->nameRU))&&($jsd->nameRU != ''))
					// $arr['caption_original'] = $arr['caption'] = $jsd->nameRU;
				// else if ((isset($jsd->nameEN))&&($jsd->nameEN != ''))
					// $arr['caption_original'] = $arr['caption'] = $jsd->nameEN;
				// if ((isset($jsd->nameEN))&&($jsd->nameEN != ''))
					// $arr['caption_original'] = $jsd->nameEN;
				if (isset($jsd->description))
					$arr['description'] = $jsd->description;
				if (!preg_match("|".DuneSystem::$properties['plugin_name']."|", $arr['poster_url']))
					$arr['poster_url'] = Kinopoisk_Class::http_get_img("http://st.kp.yandex.net/images/film_iphone/iphone360_".$arr['class_info']['dbIDs']['kpID'].".jpg&rPath=" . $arr['poster_url']);
				else
					$arr['poster_url'] = Kinopoisk_Class::http_get_img("http://st.kp.yandex.net/images/film_iphone/iphone360_".$arr['class_info']['dbIDs']['kpID'].".jpg");
				$arr['country'] = $jsd->country;
				if (preg_match("|-|",$jsd->year))
					$arr['country'] .= ', '.$jsd->year;
				else
					$arr['year'] = $jsd->year;
				if (isset ($jsd->genre))
					$arr['genres'] = $jsd->genre;
				if (isset ($jsd->ratingData->ratingIMDb))
					$arr['rate_imdb'] = $jsd->ratingData->ratingIMDb;
				if (isset ($jsd->ratingData->rating))
					$arr ['rate_kinopoisk'] = $jsd->ratingData->rating;
				if (isset ($jsd->filmLength)){
					$length = $jsd->filmLength;
					if (preg_match("/(\d*):(\d\d)/i", $length, $tmp))
						$length = ($tmp[1]*60+$tmp[2]);
					$arr ['length'] = $length;
				}
				if (isset ($jsd->creators[0])){
					foreach ($jsd->creators[0] as $v){
						if ((isset ($v->nameEN))&&($v->nameEN != ''))
							$name_r[] = $v->nameRU .' ('.$v->nameEN.')';
						else
							$name_r[] = $v->nameRU;
						if (count($name_r) > 1)
							$arr['director'] = implode(', ', $name_r);
						else
							$arr['director'] = $name_r[0];
					}
				}
				if (isset ($jsd->creators[1])){
					$name_r = array();
					foreach ($jsd->creators[1] as $v){
						if ((isset ($v->nameEN))&&($v->nameEN != ''))
							$name_r[] = $v->nameRU .' ('.$v->nameEN.')';
						else
							$name_r[] = $v->nameRU;
						if (count($name_r) > 1)
							$arr['actors'] = implode(', ', $name_r);
						else
							$arr['actors'] = $name_r[0];
					}
				}
				if (isset ($jsd->creators[2])){
					$name_r = array();
					foreach ($jsd->creators[2] as $v){
						if ((isset ($v->nameEN))&&($v->nameEN != ''))
							$name_r[] = $v->nameRU .' ('.$v->nameEN.')';
						else
							$name_r[] = $v->nameRU;
						if (count($name_r) > 1)
							$arr ['details']['Продюсеры:'] = implode(', ', $name_r);
						else
							$arr ['details']['Продюсеры:'] = $name_r[0];
					}
				}
				if (isset ($jsd->gallery)){
					foreach ($jsd->gallery as $key => $vel){
						if ($key=='poster')
							continue;
						foreach ($vel as $v){
							if (!preg_match("|^http|",$v->image))
								$v->image = "http://st.kp.yandex.net/images/". $v->image;
							$arr ['background_urls'][] = Kinopoisk_Class::http_get_img($v->image);
						}
					}
				}
				if (isset ($jsd->slogan))
					$arr ['details']["Слоган:"] = wordwrap($jsd->slogan, 75, "\n");
				
				if (isset ($jsd->budgetData->budget))
					$arr ['budget'] = str_replace(array ('$', ' '),"", $jsd->budgetData->budget);
				if (isset($jsd->videoURL)){
					foreach ($jsd->videoURL as $k => $v){
						$arr['class_info']['trailers'][$v] = array(
							'name' => "Kinopoisk $k",
							'url' => $v
						);
					}
				}
				if ($getMovieInfo == 'max'){
					if ((isset($jsd->type))&&($jsd->type == 'KPSerial')){
						$arr['is_serial']= 1;
						$myShowsIds = HD::getItemsArr('myShowsIds');
						if (isset($myShowsIds[$movie_id]))
							$myShowsID = $myShowsIds[$movie_id];
						else if (isset($arr['class_info']['dbIDs']['myShowsID']))
							$myShowsID = $arr['class_info']['dbIDs']['myShowsID'];
						else{
							if ((isset($arr['caption_original']))&&($arr['caption_original'] != '')){
								if (preg_match('|(.*?)\n|', trim($arr['caption_original']), $m))
									$arr['caption_original'] = $m[1];
								$myshows = VideoInfo::search_myshows_info($arr['caption_original'], $arr['class_info']['dbIDs']['kpID']);
							}else if ((isset($jsd->nameEN))&&($jsd->nameEN != ''))
								$myshows = VideoInfo::search_myshows_info($jsd->nameEN, $arr['class_info']['dbIDs']['kpID']);
							else
								$myshows = VideoInfo::search_myshows_info($arr['caption'], $arr['class_info']['dbIDs']['kpID']);
							if (isset($myshows->id))
								$myShowsID = $myshows->id;
						}
						if ((isset($myShowsID))&&($myShowsID != $movie_id)){
							$rate_details = array();
							if (isset($arr ['rate_details']))
								$rate_details = $arr ['rate_details'];
							unset($arr ['rate_details']);
							$arr['class_info']['dbIDs']['myShowsID'] = $myShowsID;
							if ($myshows == true)
								$jsd = $myshows;
							else
								$jsd = VideoInfo::get_info_by_myshows_id ($myShowsID);
							if ($jsd->rating != '')
								$arr ['rate_details']['MyShows:']=  round($jsd->rating, 1);
							$arr ['rate_details']['Сезонов:'] = $jsd->totalSeasons;
							if ( $jsd->status != ''){
								if ( $jsd->status == 'TBD/On The Bubble'){
									$arr ['rate_details']['Статус:']= ' ';
									$arr ['rate_details']['   '] = 'Пауза';
								}else if ($jsd->status == 'Returning Series'){
									$arr ['rate_details']['Статус:']= ' ';
									$arr ['rate_details']['   '] = 'Продолжается';
								}else if ($jsd->status == 'Canceled/Ended'){
									$arr ['rate_details']['Статус:'] = ' ';
									$arr ['rate_details']['   '] = 'Завершен';
								}else if ($jsd->status == 'New Series'){
									$arr ['rate_details']['Статус:']= ' ';
									$arr ['rate_details']['   '] = 'Новый!';
								}else{
									$arr ['rate_details']['Статус:']= ' ';
									$arr ['rate_details']['   ']=  $jsd->status;
								}
							}
							if ($jsd->totalSeasons != '')
								$arr ['rate_details']['Сезонов:']=  $jsd->totalSeasons;
							if ($jsd->started != ''){
								$arr ['rate_details']['Started:']=  ' ';
								$arr ['rate_details']['  ']=  $jsd->started;
							}
							if ($jsd->ended != ''){
								$arr ['rate_details']['Ended:']= ' ';
								$arr ['rate_details'][' ']=  $jsd->ended;
							}
							if ($jsd->imdbUrl != ''){
								if (preg_match('|tt(\d+)\/|', $jsd->imdbUrl, $m))
									$arr['class_info']['dbIDs']['imdbID'] = 'tt' . $m[1];
							}else if ($jsd->imdbId != '')
								$arr['class_info']['dbIDs']['imdbID'] = 'tt' . $jsd->imdbId;
							if ($jsd->tvrageId != '')
								$arr['class_info']['dbIDs']['tvrageID'] = $jsd->tvrageId;
							foreach ($rate_details as $key => $vel)
								$arr ['rate_details'][$key] = $vel;
						}
					}
					if (!isset($arr['background_urls'])){
						if (preg_match("#^(\d{4})#",$arr ['year'], $mch))
							$year = $mch[1];
						else if (preg_match("#(\d{4})#",$arr ['country'], $mch))
							$year = $mch[1];
						$themoviedbIdArr = VideoInfo::search_themoviedbId ($arr['caption_original'], $year, true);
						$arr['class_info']['dbIDs']['themoviedbId'] = $themoviedbIdArr['themoviedbId'];
						foreach(TheMovieDatabase_Class::getImagesFromThemoviedb ($arr['class_info']['dbIDs']['themoviedbId'], $themoviedbIdArr['media_type']) as $k => $v){
							if ($k == 'class_info'){
								foreach ($v as $key => $vel)
									$arr['class_info'][$key] = $vel;
							}else if ($k != 'poster_url')
								$arr[$k] = $v;
						}
					}
				}
				if (isset($jsd->seriesInfo)){
					$arr ['rate_details']['Сезонов:'] = $jsd->seriesInfo->totalSeasons;
					$arr ['rate_details']['Эпизодов:'] = $jsd->seriesInfo->totalEpisodes;
				}
			}
		}
		if (isset($arr['class_info']['dbIDs']['kpID']))
			$arr ['rate_details']['kpID:'] = $arr['class_info']['dbIDs']['kpID'];
		return $arr;
	}
	
	public static function getFavSeries($class_name, $reset=null){
		if ($reset== true){
			if ($class_name = 'a11'){
				self::$newFavItems = array();
				return true;
			}else if (isset(self::$newFavItems[$class_name]))
				unset (self::$newFavItems[$class_name]);
		}	
		if (!isset(self::$newFavItems[$class_name])){
			$cmdAsyncExec = DuneSystem::$properties['install_dir_path'] . '/www/cgi-bin/php-cgi -f ' .  DuneSystem::$properties['install_dir_path'] . "/www/cgi-bin/classActions.php action=getNewFavItems class_name=$class_name";
			// echo "\nhttp://".HD::get_ip_address()."/cgi-bin/plugins/".DuneSystem::$properties['plugin_name']."/classActions?action=getNewFavItems&class_name=$class_name";
			$str = HD::asyncExec($cmdAsyncExec);
			if (!empty($str)){
				if ($str != '[]'){
					HD::asyncExec('proc_close');
					self::$newFavItems[$class_name] = json_decode($str, true);
					return self::$newFavItems[$class_name];
				}else
					return true;
			}else return false;
		}else return self::$newFavItems[$class_name];
	}
	
	public static function checkTorrent($dloadPath, $doc){
		$fileList = false;
		if (($dloadPath==true)&&($dloadPath == 'fileList')){
			$fileList = true; $dloadPath = false;
		}
		if ($dloadPath==true){
			if (file_put_contents ($dloadPath, $doc) === false)
				return array("status" => false, "descr" => "Сохранение файла не удалось, возможно доступ только для чтения");
			return array("status" => true, "descr" => "Торрент файл сохранен", "path" => $dloadPath );
		}else{
            $port = HD::http_local_port();
			$dloadPath = 'http://'.HD::get_ip_address().":$port/temp.torrent";
			if (file_put_contents ('/tmp/www/temp.torrent', $doc) === false)
				return array("status" => false, "descr" => "Сохранение файла temp.torrent не удалось, возможно доступ только для чтения");
		}
		$torrent = new Torrent('/tmp/www/temp.torrent');
		if (count($torrent->content()) == 0)
			return array("status" => false,"descr" => "Этот файл не является торрент файлом. Возможно произошла ошибка при загрузке торрент файла");
		if ($fileList == true){
			$filesInTorrentArr = array();
			$content = array_values(array_flip ($torrent->content()));
			foreach ($content as $k => $v){
				$pathinfo = pathinfo($v);
				if (((isset($pathinfo['extension']))&&(!preg_match("/mp3|wav|og(?:g|a)|flac|dts|ac3|rm|aac|wma|mka|ape|mpeg|ra?m|avi|mp(?:g|e|4)|mov|divx|asf|qt|wmv|m\dv|rv|vob|asx|ogm|mkv|m2ts|ts/i",$pathinfo['extension'])))||(!isset($pathinfo['extension'])))
					continue;
				$title = pathinfo($v, PATHINFO_BASENAME);
				$filesInTorrentArr[md5($title)] = $title;
			}
			return $filesInTorrentArr;
		}
		$torrentFile["status"] = true;
		$torrentFile["path"] = $dloadPath;
		return $torrentFile;
	}
	
}

?>
