<?php

//Notice. As is. It is free. q2100 forum.hdtv.ru
class AdvKeyboard implements UserInputHandler {	
	const ID = 'adv_text_keyboard';
	const enc = 'UTF-8';
	protected $scrBuff = array(
		0 => '',1 => '',2 => '',3 => '',4 => '',5 => '',
		6 => '',7 => '',8 => '',9 => '',10 => '',11 => '',
		100 => '',101 => '',102 => '',103 => '',104 => '',
		300 => '',301 => '',302 => '',303 => '',304 => '', 
		305 => '',
	);
	protected $defs = array();
	protected $kLayout = array();
	public $curKbrdLayout = 0;
	public $lang = "english";
	private $shift = false;
	protected $selRow = 0;
	protected $selCol = 0;
	public $cursPos = 0;
	public $str = "";
	public $suggestions = array();
	public $suggCountry;
	public $suggLang;
	public $suggSite;
	public $parentHandler;
	public $postActionCtrlId = '';
	public $plugin_cookies;
	public $media_url;
	public $btnOkText = "";
	public $btnCancelText = "";
	public $kbrdConfText = "";
	public $openConfText = "";
	public $userKbrds = array(
		0 => 'english',
		1 => '-',
		2 => '-'
	);
	public $existingKbrds = array();
	public $firstRun = true;
	public $confOpened = false;
	
	public function __construct(&$media_url, &$plugin_cookies, $handler, $postActionCtrlId, $add_params=array()){
		$this->media_url = $media_url;
		$this->plugin_cookies = $plugin_cookies;
		$this->parentHandler = $handler;
		$this->postActionCtrlId = $postActionCtrlId;
		$this->add_params = $add_params;
		UserInputHandlerRegistry::get_instance()->register_handler($this);
    }
	
	public function __destruct(){
		//hd_print("AdvKeyboard destruction");
    }
	
	public function get_handler_id(){
		return self::ID;
	}

///////////////////////////////

	   public function get_action_map($media_url, &$plugin_cookies){
        $actions = array();
		$actions[GUI_EVENT_KEY_CLEAR] = UserInputHandlerRegistry::create_action($this, 'clear_left');
		$actions[GUI_EVENT_KEY_A_RED]	= UserInputHandlerRegistry::create_action($this, 'clear_all');
		$actions[GUI_EVENT_KEY_B_GREEN] = UserInputHandlerRegistry::create_action($this, 'alt_onoff');
		$actions[GUI_EVENT_KEY_C_YELLOW] = UserInputHandlerRegistry::create_action($this, 'shift_onoff');
		$actions[GUI_EVENT_KEY_D_BLUE] = UserInputHandlerRegistry::create_action($this, 'change_keyboard');
		$actions[GUI_EVENT_KEY_AUDIO] = UserInputHandlerRegistry::create_action($this, 'change_keyboard');
		$actions[GUI_EVENT_KEY_TOP_MENU] = UserInputHandlerRegistry::create_action($this, 'openStandartSearch');
		$actions[GUI_EVENT_KEY_POPUP_MENU] = UserInputHandlerRegistry::create_action($this, 'openStandartSearch');
		$actions[GUI_EVENT_KEY_P_PLUS] = UserInputHandlerRegistry::create_action($this, 'p_plus');
		$actions[GUI_EVENT_KEY_P_MINUS] = UserInputHandlerRegistry::create_action($this, 'p_minus');
		$actions[GUI_EVENT_KEY_ENTER] = UserInputHandlerRegistry::create_action($this, 'selection_enter');
		$actions[GUI_EVENT_KEY_PLAY] = UserInputHandlerRegistry::create_action($this, 'do_search');
		$actions[GUI_EVENT_KEY_UP] = UserInputHandlerRegistry::create_action($this, 'selection_up');
		$actions[GUI_EVENT_KEY_DOWN] = UserInputHandlerRegistry::create_action($this, 'selection_down');
		$actions[GUI_EVENT_KEY_LEFT] = UserInputHandlerRegistry::create_action($this, 'selection_left');
		$actions[GUI_EVENT_KEY_RIGHT] = UserInputHandlerRegistry::create_action($this, 'selection_right');
		$actions[GUI_EVENT_KEY_SELECT] = UserInputHandlerRegistry::create_action($this, 'space');
		$actions[GUI_EVENT_KEY_SETUP] = UserInputHandlerRegistry::create_action($this, 'config_lang');
		$actions[GUI_EVENT_TIMER] = UserInputHandlerRegistry::create_action($this, 'timed_startup');

		$add_params['num_key'] = 0;
		$actions[GUI_EVENT_KEY_0] = UserInputHandlerRegistry::create_action($this, 'add_num', $add_params);
		$add_params['num_key'] = 1;
		$actions[GUI_EVENT_KEY_1] = UserInputHandlerRegistry::create_action($this, 'add_num', $add_params);
		$add_params['num_key'] = 2;
		$actions[GUI_EVENT_KEY_2] = UserInputHandlerRegistry::create_action($this, 'add_num', $add_params);
		$add_params['num_key'] = 3;
		$actions[GUI_EVENT_KEY_3] = UserInputHandlerRegistry::create_action($this, 'add_num', $add_params);
		$add_params['num_key'] = 4;
		$actions[GUI_EVENT_KEY_4] = UserInputHandlerRegistry::create_action($this, 'add_num', $add_params);
		$add_params['num_key'] = 5;
		$actions[GUI_EVENT_KEY_5] = UserInputHandlerRegistry::create_action($this, 'add_num', $add_params);
		$add_params['num_key'] = 6;
		$actions[GUI_EVENT_KEY_6] = UserInputHandlerRegistry::create_action($this, 'add_num', $add_params);
		$add_params['num_key'] = 7;
		$actions[GUI_EVENT_KEY_7] = UserInputHandlerRegistry::create_action($this, 'add_num', $add_params);
		$add_params['num_key'] = 8;
		$actions[GUI_EVENT_KEY_8] = UserInputHandlerRegistry::create_action($this, 'add_num', $add_params);
		$add_params['num_key'] = 9;
		$actions[GUI_EVENT_KEY_9] = UserInputHandlerRegistry::create_action($this, 'add_num', $add_params);
        return $actions;
    }
	
	public function handle_user_input(&$user_input, &$plugin_cookies){
		
		if ($user_input->control_id == 'p_minus'){
			if ($this->selRow < 5)
				$this->selRow = 5;
			else if ($this->selRow == 5){
				$this->selRow = 6;
				if ($this->scrBuff[6] =='')
					$this->selRow = 0;
			}else if ($this->selRow < 11)
				$this->selRow = 0;
			else if ($this->selRow > 11)
				$this->selRow = 0;
			return $this->screen_render();
		}
		if ($user_input->control_id == 'p_plus'){
			if ($this->selRow < 5)
				$this->selRow = 6;
			else if ($this->selRow == 5)
				$this->selRow = 0;
			else if ($this->selRow < 11)
				$this->selRow = 5;
			else if ($this->selRow > 11){
				$this->selRow = 6;
				if ($this->scrBuff[6] =='')
					$this->selRow = 5;
			}
			return $this->screen_render();
		}
		if ($user_input->control_id == 'selection_up'){
			$this->adjust_selection_up();
			return $this->screen_render();
		}
		
		if ($user_input->control_id == 'selection_down'){
			$this->adjust_selection_down();
			return $this->screen_render();
		}
		
		if ($user_input->control_id == 'selection_left'){
			$this->adjust_selection_left();
			return $this->screen_render();
		}
		
		if ($user_input->control_id == 'selection_right'){
			$this->adjust_selection_right();
			return $this->screen_render();
		}
		if ($user_input->control_id == 'space'){
			$this->str = AdvKeyboard::mb_insert_str($this->str, ' ', $this->cursPos);
			++$this->cursPos;
			return $this->screen_render();
		}
		if ($user_input->control_id == 'selection_enter'){
			return $this->selection_enter();
		}
		if ($user_input->control_id == 'clear_left'){
			return $this->selection_clear_left();
		}
		if ($user_input->control_id == 'clear_all'){
			if ($this->cursPos != 0)
				return $this->selection_clear_all();
			else
				return $this->add_str_strRed();
		}
		if ($user_input->control_id == 'search_str'){
			return $this->section_search_str();
		}
		if ($user_input->control_id == 'change_keyboard'){
			return $this->change_keyboard();
		}
		if ($user_input->control_id == 'alt_onoff'){
			$kLayout = $this->kLayout;
			$kbrdPage = $this->curKbrdLayout;
			if (($kbrdPage + 5) < count($kLayout))
				$this->curKbrdLayout += 5;
			else 
				$this->curKbrdLayout = 0;
			$this->adjust_selection_down();
			$this->adjust_selection_up();
			return $this->screen_render();
		}
		if ($user_input->control_id == 'shift_onoff'){
			$this->shift = !$this->shift;
			return $this->screen_render();
		}
		if ($user_input->control_id == 'do_search'){
			if (($this->selRow > 5)&&($this->selRow < 12)){
				$add_params = $this->add_params;
				$add_params['closedKeyboard'] = true;
				if (isset($this->suggestions[$this->selRow - 6]['title'])){
					$this->str = $this->suggestions[$this->selRow - 6];
					if ($this->suggestions[$this->selRow - 6]['type'] == 'film')
						$add_params['open_item'] = $this->suggestions[$this->selRow - 6]['id'];
					else
						$add_params['open_people'] = $this->suggestions[$this->selRow - 6]['id'];
				}
				$add_params['doNewSearch'] = $this->suggestions[$this->selRow - 6]['title'];
				$add_params['selected_control_id'] = 'doNewSearch';
				if ($this->suggCountry ==  'people')
					$add_params['searchType'] = 'people';
				$do_search = UserInputHandlerRegistry::create_action($this->parentHandler, $this->postActionCtrlId, $add_params);
				return ActionFactory::close_dialog_and_run($do_search);

			}
			$add_params = $this->add_params;
			$add_params['doNewSearch'] = $this->str;
			$add_params['closedKeyboard'] = true;
			$add_params['selected_control_id'] = 'doNewSearch';
			if ($this->suggCountry ==  'people')
				$add_params['searchType'] = 'people';
			$do_search = UserInputHandlerRegistry::create_action($this->parentHandler, $this->postActionCtrlId, $add_params);
			return ActionFactory::close_dialog_and_run($do_search);
		}
		if ($user_input->control_id == 'openStandartSearch'){
			$add_params = $this->add_params;
			$add_params['searchStr'] = $this->str;
			$add_params['openStandartSearch'] = 1; 
			$add_params['search_actions'] = 'keyboard';
			$do_search = UserInputHandlerRegistry::create_action($this->parentHandler, $this->postActionCtrlId, $add_params);
			return ActionFactory::close_dialog_and_run($do_search);
		}
		if ($user_input->control_id == 'add_num'){
			$this->str = AdvKeyboard::mb_insert_str($this->str, $user_input->num_key, $this->cursPos);
			++$this->cursPos;
			return $this->screen_render();
		}
			
		if ($user_input->control_id == 'config_lang'){
			if (isset($user_input->initial_sel_ndx))
				return $this->selection_config_lang($user_input->initial_sel_ndx);
			return $this->selection_config_lang();
		}
		
		if ($user_input->control_id == 'set_lang_0'){
			$this->userKbrds[0] = $user_input->set_lang_0;
			HD::saveItemsArr('adv_kbrd_lang', $this->userKbrds);
			return null;
		} 
		
		if ($user_input->control_id == 'set_lang_1'){
			$this->userKbrds[1] = $user_input->set_lang_1;
			HD::saveItemsArr('adv_kbrd_lang', $this->userKbrds);
			return null;
		} 
		
		if ($user_input->control_id == 'set_lang_2'){
			$this->userKbrds[2] = $user_input->set_lang_2;
			HD::saveItemsArr('adv_kbrd_lang', $this->userKbrds);
			return null;
		}
		
		if ($user_input->control_id == 'timed_startup'){
			return $this->timed_startup_logic();	
		}
		
		if ($user_input->control_id == 'close_dialog'){
			if ((isset($user_input->close_config_dialog_kbrd_q21))&&($user_input->close_config_dialog_kbrd_q21))
				return $this->close_config_dialog();
			else if (isset($user_input->restart_kbrd))
				return $this->restart_kbrd();
			else 
				return ActionFactory::close_dialog();
		}
		
		if ($user_input->control_id == 'screen_render_after_config'){
			$this->load_config();
			return $this->change_keyboard(0);
		}
		
		if ($user_input->control_id == 'fixSkin'){
			if (file_exists('/tmp/dune_skin_dir.txt'))
				$skin_path = trim(str_replace('skin_dir =', '', file_get_contents('/tmp/dune_skin_dir.txt'))) . '/';
			else
				throw new Exception(get_class($this).': Can not determine the path to the active skin.');
			$custom_skin_path = file_exists('/persistfs')? '/persistfs/dune_skin/' : '/flashdata/dune_skin/';
			if (!file_exists($custom_skin_path))
				mkdir ($custom_skin_path);
			if (file_exists($custom_skin_path)){
				foreach (glob($custom_skin_path . '*') as $file) {
					if (is_link($file)) {
						unlink($file);
					} else if (is_dir($file)) {
						shell_exec('rm -rf ' . $file . '/*');
						rmdir($file);
					} else unlink($file);
				}
			}else{
				throw new Exception(get_class($this).': Can not create custom skin.');
				return false;
			}
			foreach (glob($skin_path . '*') as $file) {
				hd_print($file);
				if ($file == $skin_path . 'images') {
					mkdir($custom_skin_path . 'images');
					foreach (glob($skin_path . 'images/*') as $images_file) {
						hd_print('    ' . $images_file);
						if ($images_file == $skin_path . 'images/bg.jpg') {
							copy($images_file, $custom_skin_path . 'images/' . basename($images_file));
						} else symlink($images_file, $custom_skin_path . 'images/' . basename($images_file));
					}
				} else if ($file == $skin_path . 'dune_skin_config.xml')
					file_put_contents($custom_skin_path . basename($file), preg_replace('|<text_colors>.*?</text_colors>|ms','',file_get_contents($file)));
				else
					symlink($file, $custom_skin_path . basename($file));
			}
			if (file_exists('/config/settings.properties')) {
				$system_settings_runtime = parse_ini_file('/config/settings.properties', 0, INI_SCANNER_RAW);
				$system_settings_runtime['gui_skin'] = 'custom';
				$output = '';
				foreach($system_settings_runtime as $k => $v) {
					$output .= "$k = $v" . PHP_EOL;
				}
				file_put_contents('/config/settings.properties', $output);
			}
			if (defined('CHANGE_SETTINGS_ACTION_ID'))
				return array(
					 GuiAction::handler_string_id => CHANGE_SETTINGS_ACTION_ID,
					 GuiAction::data => array(
						ChangeSettingsActionData::restart_gui => true,
						ChangeSettingsActionData::post_action => null));

			if (defined('RESTART_ACTION_ID'))
				return array(
				     GuiAction::handler_string_id => RESTART_ACTION_ID,
				     GuiAction::data => array(
				        RestartActionData::reboot => false));
			exec('killall shell');
		}
		
		if (isset($user_input->argColor)){
			$control_id = $user_input->control_id;
			$adv_kbrd_colors = HD::getItemsArr('adv_kbrd_colors');
			$adv_kbrd_colors[$user_input->argColor] = $user_input->{$control_id};
			HD::saveItemsArr('adv_kbrd_colors', $adv_kbrd_colors);
			$this->load_config();
			$params['initial_sel_ndx'] = $user_input->initial_sel_ndx;
			$do_actions = UserInputHandlerRegistry::create_action($this, 'config_lang',$params);
			return ActionFactory::close_dialog_and_run($do_actions);
		}
		hd_print("kbrd: no suitable control_id({$user_input->control_id}) action found");
	}
	
	public function screen_render(){
		$this->highlight_selected();
		$this->defs = array();
		$this->add_screen_labels();
		return $this->screen_refresh();
	}
	
	public function screen_refresh(){
		return ActionFactory::reset_controls($this->defs);
	}

	public function timed_startup_logic(){
		$this->load_config();
		if ($this->firstRun) {
			hd_print("assuming advanced keyboard first run");
			$this->firstRun = false;
			return $this->selection_config_lang();
		} else
			return $this->change_keyboard(0);
	}
	
	public function restart_kbrd(){
		$add_params['search_actions'] = 'open';
		$post_action =  UserInputHandlerRegistry::create_action($this->parentHandler, 'search',$add_params);
		return ActionFactory::close_dialog_and_run($post_action);
	}
	
	public function close_config_dialog(){
		$this->confOpened = false;
		$post_action = UserInputHandlerRegistry::create_action($this, 'screen_render_after_config');
		return ActionFactory::close_dialog_and_run($post_action);
	}
	
	private function selection_config_lang($initial_sel_ndx=-1){
		$defs = array();
		$exKbrdsAndNone = $this->existingKbrds;
		$exKbrdsAndNone['-'] = '    ---    ';
		$gi = HD::getItemsArr('adv_kbrd_lang');
		if (is_array($gi))
			$this->userKbrds = $gi + $this->userKbrds;
		ControlFactory::add_vgap($defs, -10);
		ControlFactory::add_combobox(
			$defs,
			$this,
			NULL,
			'set_lang_0',
			'1:',
			$this->userKbrds[0], $this->existingKbrds, 1050, false, true
		);
		ControlFactory::add_vgap($defs, -9);
		ControlFactory::add_combobox(
			$defs,
			$this,
			NULL,
			'set_lang_1',
			'2:',
			$this->userKbrds[1], $exKbrdsAndNone, 1050, false, true
		);
		ControlFactory::add_vgap($defs, -9);
		ControlFactory::add_combobox(
			$defs,
			$this,
			NULL,
			'set_lang_2',
			'3:',
			$this->userKbrds[2], $exKbrdsAndNone, 1050, false, true
		);
		$t1 = '';
		for ($i = 1; $i<24; $i++){
			$color_ops[$i] = $i;
			$t1 .= '<text color="'.$i.'" size="small">'.$i.'|</text>';
		}
		$ini_array = parse_ini_file("/config/settings.properties");
		if ($ini_array['gui_skin'] == 'alt:Silver'){
			ControlFactory::add_multiline_label($defs, '', $this->needFixSkin, 8);
			$add_action = UserInputHandlerRegistry::create_action($this, 'fixSkin');
			ControlFactory::add_custom_close_dialog_and_apply_buffon($defs, '_del', $this->fixSkin, 350, $add_action);
		}else{
			$defArr['defColor']['tr'] = $this->trDefColor;
			$defArr['defColor']['tr2'] =  '<gap width="140"/>
				<icon width="18" height="49">gui_skin://cut_images/textfield_'.$this->textFieldDe0.'selected/textfield_'.$this->textFieldDe0.'selected_left.aai</icon>
				<icon width="835" height="49">gui_skin://cut_images/textfield_'.$this->textFieldDe0.'selected/textfield_'.$this->textFieldDe0.'selected_center.aai</icon>
				<icon width="18" height="49">gui_skin://cut_images/textfield_'.$this->textFieldDe0.'selected/textfield_'.$this->textFieldDe0.'selected_right.aai</icon>
			';
			$defArr['selColor']['tr'] = $this->trSelColor;
			$defArr['selColor']['tr2'] =  '<gap width="140"/>
				<icon width="18" height="49">gui_skin://cut_images/textfield_'.$this->textFieldDe1.'selected/textfield_'.$this->textFieldDe1.'selected_left.aai</icon>
				<icon width="835" height="49">gui_skin://cut_images/textfield_'.$this->textFieldDe1.'selected/textfield_'.$this->textFieldDe1.'selected_center.aai</icon>
				<icon width="18" height="49">gui_skin://cut_images/textfield_'.$this->textFieldDe1.'selected/textfield_'.$this->textFieldDe1.'selected_right.aai</icon>
			';
			$defArr['searchColor']['tr'] = $this->trSearchColor;
			$defArr['searchColor']['tr2'] = '<gap width="140"/>
				<icon width="18" height="49">gui_skin://cut_images/textfield_selected/textfield_selected_left.aai</icon>
				<icon width="835" height="49">gui_skin://cut_images/textfield_selected/textfield_selected_center.aai</icon>
				<icon width="18" height="49">gui_skin://cut_images/textfield_selected/textfield_selected_right.aai</icon>
			';
			$defArr['suggColor']['tr'] = $this->trSuggColor;
			$defArr['suggSelColor']['tr'] = $this->trSuggSelColor;
			$defArr['cursColor']['tr'] = $this->trCursColor;
			$defArr['cursColor']['tr2'] = '<gap width="140"/>
				<icon width="18" height="49">gui_skin://cut_images/textfield_selected/textfield_selected_left.aai</icon>
				<icon width="835" height="49">gui_skin://cut_images/textfield_selected/textfield_selected_center.aai</icon>
				<icon width="18" height="49">gui_skin://cut_images/textfield_selected/textfield_selected_right.aai</icon>
			';
			$defArr['textFieldDe0']['tr'] = $this->trTextFieldDe0;
			$defArr['textFieldDe0']['tr2'] =  '<gap width="140"/>
				<icon width="18" height="49">gui_skin://cut_images/textfield_'.$this->textFieldDe0.'selected/textfield_'.$this->textFieldDe0.'selected_left.aai</icon>
				<icon width="835" height="49">gui_skin://cut_images/textfield_'.$this->textFieldDe0.'selected/textfield_'.$this->textFieldDe0.'selected_center.aai</icon>
				<icon width="18" height="49">gui_skin://cut_images/textfield_'.$this->textFieldDe0.'selected/textfield_'.$this->textFieldDe0.'selected_right.aai</icon>
			';
			$defArr['textFieldDe1']['tr'] = $this->trTextFieldDe1;
			$defArr['textFieldDe1']['tr2'] =  '<gap width="140"/>
				<icon width="18" height="49">gui_skin://cut_images/textfield_'.$this->textFieldDe1.'selected/textfield_'.$this->textFieldDe1.'selected_left.aai</icon>
				<icon width="835" height="49">gui_skin://cut_images/textfield_'.$this->textFieldDe1.'selected/textfield_'.$this->textFieldDe1.'selected_center.aai</icon>
				<icon width="18" height="49">gui_skin://cut_images/textfield_'.$this->textFieldDe1.'selected/textfield_'.$this->textFieldDe1.'selected_right.aai</icon>
			';
			$defArr['textFieldDe2']['tr'] = $this->trTextFieldDe2;
			$defArr['textFieldDe2']['tr2'] =  '<gap width="140"/>
				<icon width="18" height="49">gui_skin://cut_images/textfield_'.$this->textFieldDe2.'selected/textfield_'.$this->textFieldDe2.'selected_left.aai</icon>
				<icon width="835" height="49">gui_skin://cut_images/textfield_'.$this->textFieldDe2.'selected/textfield_'.$this->textFieldDe2.'selected_center.aai</icon>
				<icon width="18" height="49">gui_skin://cut_images/textfield_'.$this->textFieldDe2.'selected/textfield_'.$this->textFieldDe2.'selected_right.aai</icon>
			';
			$defArr['textFieldDe3']['tr'] = $this->trTextFieldDe3;
			$defArr['textFieldDe3']['tr2'] =  '<gap width="140"/>
				<icon width="18" height="49">gui_skin://cut_images/textfield_'.$this->textFieldDe3.'selected/textfield_'.$this->textFieldDe3.'selected_left.aai</icon>
				<icon width="835" height="49">gui_skin://cut_images/textfield_'.$this->textFieldDe3.'selected/textfield_'.$this->textFieldDe3.'selected_center.aai</icon>
				<icon width="18" height="49">gui_skin://cut_images/textfield_'.$this->textFieldDe3.'selected/textfield_'.$this->textFieldDe3.'selected_right.aai</icon>
			';
			$defArr['textFieldDe4']['tr'] = $this->trTextFieldDe4;
			$defArr['textFieldDe4']['tr2'] =  '<gap width="140"/>
				<icon width="18" height="49">gui_skin://cut_images/textfield_'.$this->textFieldDe4.'selected/textfield_'.$this->textFieldDe4.'selected_left.aai</icon>
				<icon width="835" height="49">gui_skin://cut_images/textfield_'.$this->textFieldDe4.'selected/textfield_'.$this->textFieldDe4.'selected_center.aai</icon>
				<icon width="18" height="49">gui_skin://cut_images/textfield_'.$this->textFieldDe4.'selected/textfield_'.$this->textFieldDe4.'selected_right.aai</icon>
			';
			$defArr['textFieldDe5']['tr'] = $this->trTextFieldDe5;
			$defArr['textFieldDe5']['tr2'] =  '<gap width="140"/>
				<icon width="18" height="49">gui_skin://cut_images/textfield_'.$this->textFieldDe5.'selected/textfield_'.$this->textFieldDe5.'selected_left.aai</icon>
				<icon width="835" height="49">gui_skin://cut_images/textfield_'.$this->textFieldDe5.'selected/textfield_'.$this->textFieldDe5.'selected_center.aai</icon>
				<icon width="18" height="49">gui_skin://cut_images/textfield_'.$this->textFieldDe5.'selected/textfield_'.$this->textFieldDe5.'selected_right.aai</icon>
			';
			$defArr['textFieldDe0']['tsColor'] = 'defColor';
			$defArr['textFieldDe1']['tsColor'] = 'selColor';
			$defArr['textFieldDe2']['tsColor'] = 'searchColor';
			$defArr['textFieldDe3']['tsColor'] = 'selColor';
			$defArr['textFieldDe4']['tsColor'] = 'suggColor';
			$defArr['textFieldDe5']['tsColor'] = 'suggSelColor';
			$i = 3;
			$adv_kbrd_colors = HD::getItemsArr('adv_kbrd_colors');
			ControlFactory::add_vgap($defs, -9);
			foreach ($defArr as $k => $v){
				$color = isset($adv_kbrd_colors[$k]) ? $adv_kbrd_colors[$k] : $this->{$k};
				$params['argColor'] = $k;
				$params['initial_sel_ndx'] = $i;
				if (preg_match('|textFieldDe|', $k))
					$color_ops = array ('de' => 'v1', '' => 'v2', 'ed' => 'v3');
				ControlFactory::add_combobox($defs, $this, $params,
					$k, '', $color, $color_ops,0, true, false
				);
				if (isset($v['tr2'])){
					ControlFactory::add_vgap($defs, -70);
					ControlFactory::add_smart_label($defs, "", $v['tr2']);
				}
				if (preg_match('|textFieldDe|', $k)){
					$tsColor = $v['tsColor'];
					ControlFactory::add_smart_label($defs,"", '<gap width="150"/><text dy="-69" color="'.$this->{$tsColor}.'">'.$v['tr'].'</text>');
				}else
					ControlFactory::add_smart_label($defs,"", '<gap width="150"/><text dy="-69" color="'.$this->{$k}.'">'.$v['tr'].'</text>');
				ControlFactory::add_vgap($defs, -78);
				$i++;
			}
		}
		$this->confOpened = true;
		$add_params = array('close_config_dialog_kbrd_q21' => $this->confOpened);
		$actions[GUI_EVENT_KEY_RETURN] = UserInputHandlerRegistry::create_action($this, 'close_dialog', $add_params);
		$attrs['actions'] = $actions;
		$attrs['dialog_params'] = array('frame_style' => DIALOG_FRAME_STYLE_GLASS);
		$attrs['initial_sel_ndx'] = isset($initial_sel_ndx) ? $initial_sel_ndx : -1;
		return ActionFactory::show_dialog($this->kbrdConfText, $defs, false, 1100, $attrs);
	}

	private function adjust_selection_up(){
	adjUP:
		--$this->selRow;
		if ($this->selRow < 0)
			$this->selRow = 11;
		else if (trim(strip_tags($this->scrBuff[$this->selRow])) === "")
			goto adjUP;
		
		$this->adjust_selection_left(false);
		if ($this->selRow > 4)	
			$this->adjust_selection_right(false);
	}
	
	private function adjust_selection_down(){
		do {
			++$this->selRow;
			if ($this->selRow > 11)
				$this->selRow = 0;
		} while (trim(strip_tags($this->scrBuff[$this->selRow])) === "");
		if ($this->selRow > 4)
			$this->adjust_selection_right(false);
		$this->adjust_selection_left(false);
	}
	
	private function adjust_selection_left($noskip = true){
		if ($this->selRow < 5){
			$arr = $this->scrBuff[$this->selRow+200];
			$maxPos = key(array_slice($arr, -1, 1, true));
			do {
				if (($noskip == true)||(!isset($this->scrBuff[$this->selRow+200][$this->selCol])))
					--$this->selCol;
				if ($this->selCol < 0)
					$this->selCol = $maxPos;
				if ($this->selCol > $maxPos)
					$this->selCol = $maxPos;
			} while (!isset($this->scrBuff[$this->selRow+200][$this->selCol]));
		}else if (($this->selRow === 5) && ($noskip)){
			if ($this->cursPos > 0)
				--$this->cursPos;
			else
				$this->cursPos = mb_strlen($this->str, self::enc);
		}else
			$this->selCol = 0;
	}

	private function adjust_selection_right($noskip = true){
		if ($this->selRow < 5) {
			$arr = $this->scrBuff[$this->selRow+200];
			$maxPos = key(array_slice($arr, -1, 1, true));
			do {
				if (($noskip == true)||(!isset($this->scrBuff[$this->selRow+200][$this->selCol])))
					++$this->selCol;
				if ($this->selCol > $maxPos){
					if ($noskip == true)
						$this->selCol = 0;
					else
						$this->selCol = $maxPos;
				}
			} while (!isset($this->scrBuff[$this->selRow+200][$this->selCol]));
		} else if (($this->selRow === 5) && ($noskip)){
			if ($this->cursPos == mb_strlen($this->str, self::enc))
				$this->cursPos = 0;
			else if ($this->cursPos < mb_strlen($this->str, self::enc))
				++$this->cursPos;
		}else if ($this->selRow === 11){
			++$this->selCol;
			if ($this->selCol > 1)
				$this->selCol = 0;
		}else{ //rows 6-10
			$this->selCol = 0;
		}
	}

	private function selection_enter(){
		$selRow = $this->selRow;
		$selCol = $this->selCol;
		$kbrdPage = $this->curKbrdLayout;
		$kLayout = $this->kLayout;
		if ($selRow < 5) {
			if (isset($this->scrBuff[$selRow+200])){
				$selKey = $this->scrBuff[$selRow+200][$selCol];
				if (mb_strlen($selKey, self::enc) == 1){
					$keyText = ($this->shift) ? mb_strtoupper($selKey, self::enc): mb_strtolower($selKey, self::enc);
					$this->str = AdvKeyboard::mb_insert_str($this->str, $keyText, $this->cursPos);
					$this->cursPos += mb_strlen($keyText, self::enc);
					if((mb_strlen($this->str, self::enc)) > 2)
						$this->suggestions = AdvKeyboard::get_suggestions($this->str, $this->suggCountry, $this->suggLang, $this->suggSite);
					return $this->screen_render();
				}else return $this->keyCommand($selKey);
			}else hd_print('Err!:map');
		} else if ($selRow === 5){
			if ($this->str === "")
				return null;
			$add_params = $this->add_params;
			$add_params['doNewSearch'] = $this->str;
			$add_params['closedKeyboard'] = true;
			$add_params['selected_control_id'] = 'doNewSearch';
			if ($this->suggCountry ==  'people')
				$add_params['searchType'] = 'people';
			$do_search = UserInputHandlerRegistry::create_action($this->parentHandler, $this->postActionCtrlId, $add_params);
			return ActionFactory::close_dialog_and_run($do_search);
		}else{
			if (isset($this->suggestions[$selRow - 6])){
				if ($this->suggestions[$this->selRow - 6]['type'] == "person"){
					$add_params = $this->add_params;
					$add_params['open_people'] = $this->suggestions[$this->selRow - 6]['id'];
					$add_params['doNewSearch'] = $this->suggestions[$this->selRow - 6]['title'];
					$add_params['closedKeyboard'] = true;
					$add_params['selected_control_id'] = 'doNewSearch';
					if ($this->suggCountry ==  'people')
						$add_params['searchType'] = 'people';
					$do_search = UserInputHandlerRegistry::create_action($this->parentHandler, $this->postActionCtrlId, $add_params);
					return ActionFactory::close_dialog_and_run($do_search);
				}
				
				$this->str = $this->suggestions[$selRow - 6]['title'];
				$this->cursPos = mb_strlen($this->str, self::enc);
				$this->selRow = 5;
				$this->selCol = 0;
				return $this->screen_render();
			}
		}
		hd_print("key type ({$keyType}) not recognized");
		return null;
	}
	private function section_search_str(){
		$this->selRow = 5;
		$this->selCol = 0;
		return $this->screen_render();
	}
	private function add_str_strRed(){
		$this->str = $this->strRed;
		if((mb_strlen($this->str, self::enc)) > 2)
			$this->suggestions = AdvKeyboard::get_suggestions($this->str, $this->suggCountry, $this->suggLang, $this->suggSite);
		$this->cursPos = mb_strlen($this->str, self::enc);
		return $this->screen_render();
	}
	private function selection_clear_all(){
		$this->cursPos = 0;
		$this->str = '';
		return $this->screen_render();
	}
	private function selection_clear_left(){
		if ($this->cursPos === 0){
			if ($this->selRow == 5)
				return null;
			else{
				$this->cursPos = mb_strlen($this->str, self::enc);
				$this->str = AdvKeyboard::mb_delete_chr($this->str, --$this->cursPos);
				if((mb_strlen($this->str, self::enc)) > 2)
					$this->suggestions = AdvKeyboard::get_suggestions($this->str, $this->suggCountry, $this->suggLang, $this->suggSite);
			}
		}else{
			$this->str = AdvKeyboard::mb_delete_chr($this->str, --$this->cursPos);
			if((mb_strlen($this->str, self::enc)) > 2)
				$this->suggestions = AdvKeyboard::get_suggestions($this->str, $this->suggCountry, $this->suggLang, $this->suggSite);
		}
		return $this->screen_render();
	}

	public function get_kbrds_list(){
		$kbrdsList = array();
		$langNames = self::known_languages();
		foreach(new DirectoryIterator(DuneSystem::$properties['install_dir_path']."/adv_keyboards/") as $file)
			if ($file->isFile() && ($file->getExtension() === 'txt')) {
				$langFileName = $file->getFilename();
				$pos = mb_strpos($langFileName, "adv_keyboard_", 0, self::enc);
				if ($pos !== false) {
					$lang = mb_substr($langFileName, $pos + mb_strlen("adv_keyboard_", self::enc), -4, self::enc);
					$posCustom = mb_strpos($lang, "_", 0, self::enc);
					if ($posCustom === false) {
						$langCasual = $lang;
						$langCustom = "";
					} else {
						$strWidth = mb_strlen($lang, self::enc);
						$langCustom = mb_substr($lang, $posCustom + 1, $strWidth, self::enc);
						$langCasual = mb_substr($lang, 0, $posCustom, self::enc);
					}
				}
				if (isset($langNames[$langCasual]))
					$kbrdsList[$lang] = ($posCustom === false) ? $langNames[$langCasual] : "{$langNames[$langCasual]} ({$langCustom})";
				else
					$kbrdsList[$lang] = $lang;
				
			};
		asort($kbrdsList);
		return $kbrdsList;
	}

	private function change_keyboard($j = -1) {
		static $i = 0;
		if ($j !== -1)
			$i = $j - 1;
		do {
			($i < 2) ? ++$i : $i = 0;
		} while (trim($this->userKbrds[$i]) === '-');
		$this->load_keyboard($this->userKbrds[$i]);
		return $this->screen_render();
	}

	public function load_keyboard($lang){		
		$filePath = DuneSystem::$properties['install_dir_path']."/adv_keyboards/adv_keyboard_{$lang}.txt";
		$result = true;
		if (file_exists($filePath)) {
			$this->kLayout = file($filePath, FILE_IGNORE_NEW_LINES | FILE_SKIP_EMPTY_LINES);
		} else {
			$result = false;
			hd_print("Warning: Advanced Keyboard file not found! Trying default one...");
			$filePath = DuneSystem::$properties['install_dir_path']."/adv_keyboards/adv_keyboard_english.txt";
			$this->kLayout = file($filePath, FILE_IGNORE_NEW_LINES | FILE_SKIP_EMPTY_LINES);
		}
		if ($this->kLayout === false) {
			$result = false;
			hd_print("ERROR: Fails to load any Advanced Keyboard files!");
			$this->kLayout = array(
				0 => "CLICK_HERE ({$lang})",
				1 => "ksssssssssssssssssssssssssssss",
				2 => "e-----------------------------",
				3 => "ERR: [keyboard file not found]",
				4 => "csssssssssssssssssssssssssssss",
				5 => "------------------------------"
			);
		}
		$this->shift = false;
		$this->curKbrdLayout = 0;
		return $result;
	}
	
	private function keyCommand($selKey){
		$selRow = $this->selRow;
		$selCol = $this->selCol;
		$kbrdPage = $this->curKbrdLayout;
		$kLayout = $this->kLayout;
		if ($selKey == 'BackSpace')
			return $this->selection_clear_left();
		if (($selKey == 'Shift')||($selKey == 'SHIFT')){
			$this->shift = !$this->shift;
			return $this->screen_render();
		}
		if (preg_match('|^Alt|', $selKey)){
			if (($kbrdPage + 5) < count($kLayout))
				$this->curKbrdLayout += 5;
			else 
				$this->curKbrdLayout = 0;
			$this->adjust_selection_down();
			$this->adjust_selection_up();
			return $this->screen_render();
		}
		if (preg_match('|__|', $selKey)){
			$this->str = AdvKeyboard::mb_insert_str($this->str, ' ', $this->cursPos);
			++$this->cursPos;
			return $this->screen_render();
		}
		if (preg_match('|\&.+;|', $selKey)){
			$this->str = AdvKeyboard::mb_insert_str($this->str, htmlspecialchars_decode($selKey), $this->cursPos);
			++$this->cursPos;
			return $this->screen_render();
		}
		if ($selKey == 'Enter'){
			$add_params = $this->add_params;
			$add_params['doNewSearch'] = $this->str;
			$add_params['closedKeyboard'] = true;
			$add_params['selected_control_id'] = 'doNewSearch';
			if ($this->suggCountry ==  'people')
				$add_params['searchType'] = 'people';
			$do_search = UserInputHandlerRegistry::create_action($this->parentHandler, $this->postActionCtrlId, $add_params);
			return ActionFactory::close_dialog_and_run($do_search);
		}
		if ($selKey == 'Conf')
			return $this->selection_config_lang();
		if (($selRow == 0)&&($selCol == 0))
			return $this->change_keyboard();
		hd_print("command key ({$selKey}) not recognized");
		return null;
	}

	public static function mb_insert_str($str, $insStr, $insPos, $encoding = self::enc){
		$strWidth = mb_strlen($str, $encoding);
		$strStart = mb_substr($str, 0, $insPos, $encoding);
		$strEnd = mb_substr($str, $insPos, $strWidth - $insPos, $encoding);
		return "{$strStart}{$insStr}{$strEnd}";
	}
	
	public static function mb_delete_chr($str, $delPos, $number = 1, $encoding = self::enc){
		$strWidth = mb_strlen($str, $encoding);
		$strStart = mb_substr($str, 0, $delPos, $encoding);
		$strEnd = mb_substr($str, $delPos + $number, $strWidth - $delPos - $number, $encoding);
		return "{$strStart}{$strEnd}";
	}
	
	public static function get_suggestions($query, $cr = 'ru', $hl = 'ru', $ds = 'yt'){
		if ($query == '')
			return array();
		if ($ds == 'yt'){
			$query = rawurlencode($query);
			$doc = HD::http_get_document("http://suggestqueries.google.com/complete/search?client=toolbar&hl={$hl}&gl={$cr}&ds={$ds}&q={$query}");
			$a = explode('<suggestion data="', $doc);
			foreach($a as $value)
				$sugg[] = mb_strstr($value, '"/>', true, self::enc);
			$sugg = array_slice($sugg, 1);
		}
		if ($ds == 'kp'){
			$jsd = Kinopoisk_Class::suggestKpSearch($query, $cr);
			if ($cr == 'people')
				$jsd = $jsd->searchPeople;
			else
				$jsd = $jsd->searchFilms;
			foreach ($jsd as $v){
				if ($cr == 'people'){
					$sugg[] = array(
						'id' => $v->id,
						'type' => "person",
						'title' => $v->nameRU,
						'originalTitle' => $v->nameEN,
						'year' => isset($v->year) ? $v->year : ''
					);
				}else{
					$sugg[] = array(
						'id' => $v->id,
						'type' => 'film',
						'title' => $v->nameRU,
						'originalTitle' => $v->nameEN,
						'year' => isset($v->year) ? $v->year : '',
						'rating' => $v->rating
					);
				}
				
			}
		}
		return $sugg;
	}
	
	public function add_screen_labels(){
		$kbrdPage = $this->curKbrdLayout;
		$kLayout = $this->kLayout;
		$vSpace = -16; 
		ControlFactory::add_smart_label($this->defs, "", $this->scrBuff[100]);
		ControlFactory::add_vgap($this->defs, -70);
		ControlFactory::add_smart_label($this->defs, "", $this->scrBuff[0]);
		
		ControlFactory::add_vgap($this->defs, -15);
		ControlFactory::add_smart_label($this->defs, "", $this->scrBuff[101]);
		ControlFactory::add_vgap($this->defs, -70);
		ControlFactory::add_smart_label($this->defs, "", $this->scrBuff[1]);
		
		ControlFactory::add_vgap($this->defs, -15);
		ControlFactory::add_smart_label($this->defs, "", $this->scrBuff[102]);
		ControlFactory::add_vgap($this->defs, -70);
		ControlFactory::add_smart_label($this->defs, "", $this->scrBuff[2]);
		
		ControlFactory::add_vgap($this->defs, -15);
		ControlFactory::add_smart_label($this->defs, "", $this->scrBuff[103]);
		ControlFactory::add_vgap($this->defs, -70);
		ControlFactory::add_smart_label($this->defs, "", $this->scrBuff[3]);
		
		
		ControlFactory::add_vgap($this->defs, -15);
		ControlFactory::add_smart_label($this->defs, "", $this->scrBuff[104]);
		ControlFactory::add_vgap($this->defs, -70);
		ControlFactory::add_smart_label($this->defs, "", $this->scrBuff[4]);
		if ($this->selRow == 5)
			$textfield = $this->textFieldDe3;
		else if (isset($this->textFieldDe2))
			$textfield = $this->textFieldDe2;
		else
			$textfield = '';
		ControlFactory::add_smart_label($this->defs,"", '<gap width="10"/><icon>gui_skin://cut_images/textfield_'.$textfield.'selected/textfield_'.$textfield.'selected_left.aai</icon><icon width="1330" height="58">gui_skin://cut_images/textfield_'.$textfield.'selected/textfield_'.$textfield.'selected_center.aai</icon><icon>gui_skin://cut_images/textfield_'.$textfield.'selected/textfield_'.$textfield.'selected_right.aai</icon>');
		ControlFactory::add_vgap($this->defs, -65);
		ControlFactory::add_smart_label($this->defs, "", $this->scrBuff[5]);

		ControlFactory::add_smart_label($this->defs, "", $this->scrBuff[300]);
		ControlFactory::add_vgap($this->defs, -70);
		ControlFactory::add_smart_label($this->defs,"", $this->scrBuff[6]);		
		ControlFactory::add_vgap($this->defs, $vSpace);
		
		ControlFactory::add_smart_label($this->defs, "", $this->scrBuff[301]);
		ControlFactory::add_vgap($this->defs, -70);
		ControlFactory::add_smart_label($this->defs,"", $this->scrBuff[7]);
		ControlFactory::add_vgap($this->defs, $vSpace);
		
		ControlFactory::add_smart_label($this->defs, "", $this->scrBuff[302]);
		ControlFactory::add_vgap($this->defs, -70);
		ControlFactory::add_smart_label($this->defs,"", $this->scrBuff[8]);
		ControlFactory::add_vgap($this->defs, $vSpace);
		
		ControlFactory::add_smart_label($this->defs, "", $this->scrBuff[303]);
		ControlFactory::add_vgap($this->defs, -70);
		ControlFactory::add_smart_label($this->defs,"", $this->scrBuff[9]);
		ControlFactory::add_vgap($this->defs, $vSpace);
		
		ControlFactory::add_smart_label($this->defs, "", $this->scrBuff[304]);
		ControlFactory::add_vgap($this->defs, -70);
		ControlFactory::add_smart_label($this->defs,"", $this->scrBuff[10]);
		ControlFactory::add_vgap($this->defs, $vSpace);
		
		ControlFactory::add_smart_label($this->defs, "", $this->scrBuff[305]);
		ControlFactory::add_vgap($this->defs, -70);
		ControlFactory::add_smart_label($this->defs,"", $this->scrBuff[11]);

		$atlHelp = "";
		if ((isset($this->atlHelp))&&($this->atlHelp == true))
			$atlHelp = "<icon>gui_skin://special_icons/controls_button_green.aai</icon><text dy=\"7\" size=\"small\">- {$this->altOnOff} </text>";

		ControlFactory::add_vgap($this->defs, -15);
		if ($this->cursPos != 0)
			$aRed = $this->clearSearchStr;
		else
			$aRed = $this->restoreSearchStr;
		ControlFactory::add_smart_label($this->defs,"", "
		<icon>gui_skin://special_icons/controls_button_red.aai</icon><text dy=\"7\" size=\"small\">- $aRed </text>
		$atlHelp
		<icon>gui_skin://special_icons/controls_button_yellow.aai</icon><text dy=\"7\" size=\"small\">- {$this->shiftOnOff} </text>
		<icon>gui_skin://special_icons/controls_button_blue.aai</icon><text dy=\"7\" size=\"small\">- {$this->changeKbrdLay}</text>
		");
		ControlFactory::add_vgap($this->defs, -25);
		ControlFactory::add_smart_label($this->defs,"", "
		<icon>" . DuneSystem::$properties['install_dir_path'] . "/icons/keysetup.png</icon><text dy=\"7\" size=\"small\">- {$this->kbrdConfText} </text>
		<icon>gui_skin://special_icons/controls_button_clear.aai</icon><text dy=\"7\" size=\"small\">- BackSpace</text>
		<icon>gui_skin://special_icons/controls_button_top_menu.aai</icon><text dy=\"7\" size=\"small\">- {$this->oldSearchKeyb} </text>
		");
		ControlFactory::add_vgap($this->defs, -25);
		ControlFactory::add_smart_label($this->defs,"", "
		<icon>gui_skin://special_icons/controls_button_p_plus.aai</icon><icon>gui_skin://special_icons/controls_button_p_minus.aai</icon><text dy=\"7\" size=\"small\">- {$this->fastMov} </text>
		<icon width=\"48\" height=\"48\" >gui_skin://osd_icons/play.aai</icon><text dy=\"7\" size=\"small\"> - {$this->btnOkText} </text>
		<icon>gui_skin://special_icons/controls_button_select.aai</icon><text dy=\"7\" size=\"small\">- {$this->kbrdSpaceText} </text>
		");
	}
	
	public function highlight_selected(){	
		//color blindness safe colors
		$defColor = $this->defColor;
		$selColor = $this->selColor;
		$searchColor = $this->searchColor;
		$suggColor = $this->suggColor;
		$suggSelColor = $this->suggSelColor;
		$cursColor = $this->cursColor;
		//use short names
		$suggestions = $this->suggestions;
		
		$selRow = $this->selRow;
		$selCol = $this->selCol;
		$kbrdPage = $this->curKbrdLayout;
		$kLayout = $this->kLayout;
		$strTmp = "";
		$this->atlHelp = null;
		for ($i = 0; $i < 5; ++$i) {
			$line=$kLayout[$kbrdPage + $i];
			if (preg_match_all("~(.*?)\|(\d.*?)\|~", $line, $matches)){
				$txt = $txt2 = ""; $offset = 0; $keyMap = $this->scrBuff[$i+200] = array();
				foreach ($matches[1] as $k => $str){
					$x2=explode(',',$matches[2][$k]);
					$gapWidth0 =$x2[0];
					$widthCenter =$x2[1];
					if ((isset($x2[3]))&&($x2[3] != ''))
						$txt2 .= '<gap width="'.$x2[3].'"/>';
					$str = trim($matches[1][$k]);
					if (preg_match("|\[_|", $str))
						$str = str_replace(array('[',']'), '_', $str);
					
					if (isset($this->minSpace))
						$gapWidth0 = $gapWidth0 - $this->minSpace;
					if ($str == 'Shift'){
						$str = ($this->shift) ? mb_strtoupper($str, self::enc): $str;
						if ($this->shift)
							$this->minSpace = 26;
					}else if (isset($this->minSpace))
						unset($this->minSpace);
					if ((isset($x2[2]))&&($x2[2] != ''))
						$offset = $offset + $x2[2];
					$keyMap[$k + $offset] = $str;
					if (($i == $selRow)&&($k + $offset == $selCol)){
						$textColor= $selColor;
						$textfield = $this->textFieldDe1;
					}else{
						$textColor= $defColor;
						$textfield = $this->textFieldDe0;
					}
					if (preg_match('|Alt|', $line))
						$this->atlHelp = true;
					$txt .= '<gap width="'.$gapWidth0.'"/><text color="'.$textColor.'">'.$str.'</text>';
					$txt2 .= '
						<icon width="18" height="49">gui_skin://cut_images/textfield_'.$textfield.'selected/textfield_'.$textfield.'selected_left.aai</icon>
						<icon width="'.$widthCenter.'" height="49">gui_skin://cut_images/textfield_'.$textfield.'selected/textfield_'.$textfield.'selected_center.aai</icon>
						<icon width="18" height="49">gui_skin://cut_images/textfield_'.$textfield.'selected/textfield_'.$textfield.'selected_right.aai</icon>
						<gap width="1"/>
						';
				}
			}else hd_print('Err!:map');
			$this->scrBuff[$i] = $txt;
			$this->scrBuff[$i+100] = $txt2;
			$this->scrBuff[$i+200] = $keyMap;
		}
		if ($selRow === 5)
			$curs = "</text><text color=\"{$cursColor}\">|</text><text color=\"{$selColor}\">";
		else
			$curs = "</text><text color=\"{$cursColor}\">|</text><text color=\"{$searchColor}\">";
		
		$this->scrBuff[5] = AdvKeyboard::mb_insert_str($this->str, $curs, $this->cursPos);

		if ($selRow === 5)
			$this->scrBuff[5] = "<gap width=\"30\"/><text color=\"{$selColor}\">{$this->scrBuff[5]}</text>";
		else
			$this->scrBuff[5] = "<gap width=\"30\"/><text color=\"{$searchColor}\">{$this->scrBuff[5]}</text>";
		for ($i = 0; $i < 6; ++$i) {
			$strTmp = $txt2 = '';
			if (!isset($suggestions->captcha)){
				if (isset($suggestions[$i]['title'])) {
					$text = HD::str_remove_tag($suggestions[$i]['title']);
					if ($selRow === ($i + 6)){
						$text_color = $suggSelColor;
						$textfield = $this->textFieldDe5;
					}else{
						$text_color = $suggColor;
						$textfield = $this->textFieldDe4;
					}
					$text2name = $text2 = '';
					$textLen = mb_strlen($text, self::enc);
					if ($textLen > 42)
						$text = mb_strimwidth($text, 0, 42, "...", self::enc);
					if (($textLen < 30)&&($suggestions[$i]['originalTitle'] != ''))
						$text2name = HD::str_remove_tag($suggestions[$i]['originalTitle']);
					if ((isset($suggestions[$i]['year']))&&($suggestions[$i]['year'] != '')){
						if ($text2name != '')
							$text2name .= ', ';
						$text2name .= HD::str_remove_tag($suggestions[$i]['year']);
					}
					$text2 .= "<gap width=\"10\"/><text color=\"7\">(" . $text2name . ')</text>';
					if ((isset($suggestions[$i]['rating']))&&($suggestions[$i]['rating'] != 0))
						$text2 .= "<gap width=\"10\"/><icon dy=\"5\" width=\"40\" height=\"40\">" . DuneSystem::$properties['install_dir_path'] . "/icons/s_kinopoisk.png</icon><gap width=\"10\"/><text color=\"7\">" . HD::str_remove_tag($suggestions[$i]['rating']) . '</text>';
					
					$ico = 'searchHistorivideo';
					if ($suggestions[$i]['type'] == "person")
						$ico = 'searchHistoripeople';
					$strTmp = "<gap width=\"45\"/><icon dy=\"5\" width=\"40\" height=\"40\">" . DuneSystem::$properties['install_dir_path'] . "/icons/$ico.png</icon><gap width=\"10\"/><text color=\"$text_color\">$text</text>$text2";
					if ($textfield != 'ed')
					$txt2 = '<gap width="35"/><icon width="18" height="49">gui_skin://cut_images/textfield_'.$textfield.'selected/textfield_'.$textfield.'selected_left.aai</icon>
							<icon width="1300" height="49">gui_skin://cut_images/textfield_'.$textfield.'selected/textfield_'.$textfield.'selected_center.aai</icon>
							<icon width="18" height="49">gui_skin://cut_images/textfield_'.$textfield.'selected/textfield_'.$textfield.'selected_right.aai</icon>
							<gap width="1"/>
							';
				}
			}
			$this->scrBuff[$i + 6] = $strTmp;
			$this->scrBuff[$i+300] = $txt2;
		}
	}
	
	public function startup_kbrd(){
		$curLocale = self::get_STB_locale();
		if (($curLocale=='russian')||(!file_exists(DuneSystem::$properties['install_dir_path'] . '/translations'))){
			$this->btnOkText = 'Поиск';
			$this->btnCancelText = 'Отмена';
			$this->kbrdConfText = 'Настройки клавиатуры';
			$this->kbrdSpaceText = 'Пробел';
			$this->openConfText = 'открывает это окно';
			$this->clearSearchStr = 'Очистить поиск';
			$this->restoreSearchStr = 'Восстановить поиск';
			$this->altOnOff = 'Альт.';
			$this->changeKbrdLay = 'Изменить раскладку';
			$this->shiftOnOff = 'Строчные/ПРОПИСНЫЕ';
			$this->oldSearchKeyb = 'Cтарая клавиатура';
			$this->fastMov = 'Быстрый переход';
			$this->trDefColor = 'Цвет кнопки';
			$this->trSelColor = 'Цвет выделения';
			$this->trSearchColor = 'Цвет строки поиска';
			$this->trSuggColor = 'Цвет быстрого поиска';
			$this->trSuggSelColor = 'Выделенный быстрый поиск';
			$this->trCursColor = 'Цвет курсора |';
			$this->trTextFieldDe0 = 'Вид кнопки';
			$this->trTextFieldDe1 = 'Вид выделенной кнопки';
			$this->trTextFieldDe2 = 'Вид строки поиска';
			$this->trTextFieldDe3 = 'Вид выделенной строки поиска';
			$this->trTextFieldDe4 = 'Вид строки быстрого поиска';
			$this->trTextFieldDe5 = 'Вид выделенного быстрого поиска';
			$this->needFixSkin = 'Для отображения всех цветов палитры необходимо исправить Silver Skin. Тема Silver будет установлена пользовательской и плеер будет перегружен.';
			$this->fixSkin = 'Исправить Silver Skin';
			$caption = 'Поиск';
		}else if ($curLocale=='ukrainian'){
			$this->btnOkText = 'Пошук';
			$this->btnCancelText = 'Скасувати';
			$this->kbrdConfText = 'Налаштування клавіатури';
			$this->kbrdSpaceText = 'Пробіл';
			$this->openConfText = 'відкриває це вікно';
			$this->clearSearchStr = 'Очистити пошук';
			$this->restoreSearchStr = 'Відновити пошук';
			$this->altOnOff = 'Альт.';
			$this->changeKbrdLay = 'Змінити мову';
			$this->shiftOnOff = 'Рядкові/ПРОПИСНІ';
			$this->oldSearchKeyb = 'Cтара клавіатура';
			$this->fastMov = 'Швидкий перехід';
			$this->trDefColor = 'Колір кнопки';
			$this->trSelColor = 'Колір виділення';
			$this->trSearchColor = 'Колір рядка пошуку';
			$this->trSuggColor = 'Колір швидкого пошуку';
			$this->trSuggSelColor = 'Виділений швидкий пошук';
			$this->trCursColor = 'Колір курсора |';
			$this->trTextFieldDe0 = 'Вигляд кнопки';
			$this->trTextFieldDe1 = 'Вигляд виділеної кнопки';
			$this->trTextFieldDe2 = 'Вигляд рядка пошуку';
			$this->trTextFieldDe3 = 'Вигляд виділенного рядка пошуку';
			$this->trTextFieldDe4 = 'Вигляд рядка швидкого пошуку';
			$this->trTextFieldDe5 = 'Вигляд виділенного швидкого пошуку';
			$this->needFixSkin = 'Для отображения всех цветов палитры необходимо исправить Silver Skin. Тема Silver будет установлена пользовательской и плеер будет перегружен.';
			$this->fixSkin = 'Исправить Silver Skin';
			$caption = 'Пошук';
		}else{
			$this->btnOkText = 'Search';
			$this->btnCancelText = 'Cancel';
			$this->kbrdConfText = "Keyboard Setup";
			$this->kbrdSpaceText = 'Space';
			$this->openConfText = 'opens this window';
			$this->clearSearchStr = 'Clear Search';
			$this->restoreSearchStr = 'Restore search';
			$this->altOnOff = 'Alt';
			$this->changeKbrdLay = 'Сhange Keyboard Layout';
			$this->shiftOnOff = 'Shift ON/off';
			$this->oldSearchKeyb = 'Go To Old Keyboard';
			$this->fastMov = 'Fast Switch';
			$this->trDefColor = 'Button Color';
			$this->trSelColor = 'Highlight Color';
			$this->trSearchColor = 'Search Bar Color';
			$this->trSuggColor = 'Quick Search Color';
			$this->trSuggSelColor = 'Selected Quick Search';
			$this->trCursColor = 'Cursor Color |';
			$this->trTextFieldDe0 = 'Button View';
			$this->trTextFieldDe1 = 'View Selected Button';
			$this->trTextFieldDe2 = 'Type Of Search String';
			$this->trTextFieldDe3 = 'View Selected Search String';
			$this->trTextFieldDe4 = 'Quick Search Bar Type';
			$this->trTextFieldDe5 = 'Type Of Highlighted Quick Search';
			$this->needFixSkin = 'Для отображения всех цветов палитры необходимо исправить Silver Skin. Тема Silver будет установлена пользовательской и плеер будет перегружен.';
			$this->fixSkin = 'Исправить Silver Skin';
			$caption = 'Search';
		}
		$this->cursPos = mb_strlen($this->str, self::enc);
		$this->existingKbrds = $this->get_kbrds_list();
		$gi = HD::getItemsArr('adv_kbrd_lang');
		if ((is_array($gi)) && ($gi !== array())) {
			$this->userKbrds = $gi + $this->userKbrds;
			$this->firstRun = false;
		}else{
			hd_print("no saved language settings");
			HD::saveItemsArr('adv_kbrd_lang', $this->userKbrds);
			$this->firstRun = true;
		}
		$this->add_screen_labels();
		$attrs['actions'] = $this->get_action_map($this->media_url, $this->plugin_cookies);
		$attrs['timer'] = ActionFactory::timer(1);
		$adv_kbrd_colors = HD::getItemsArr('adv_kbrd_colors');
		return ActionFactory::show_dialog($caption, $this->defs, true, 1500, $attrs);
	}
	public function load_config(){
		$adv_kbrd_colors = HD::getItemsArr('adv_kbrd_colors');
		$this->defColor = isset($adv_kbrd_colors['defColor']) ? $adv_kbrd_colors['defColor'] : 15;
		$this->selColor = isset($adv_kbrd_colors['selColor']) ? $adv_kbrd_colors['selColor'] : 18;
		$this->searchColor = isset($adv_kbrd_colors['searchColor']) ? $adv_kbrd_colors['searchColor'] : 15;
		$this->suggColor = isset($adv_kbrd_colors['suggColor']) ? $adv_kbrd_colors['suggColor'] : 15;
		$this->suggSelColor = isset($adv_kbrd_colors['suggSelColor']) ? $adv_kbrd_colors['suggSelColor'] : 18;
		$this->cursColor = isset($adv_kbrd_colors['cursColor']) ? $adv_kbrd_colors['cursColor'] : 15;
		$this->textFieldDe0 = isset($adv_kbrd_colors['textFieldDe0']) ? $adv_kbrd_colors['textFieldDe0'] : 'de';
		$this->textFieldDe1 = isset($adv_kbrd_colors['textFieldDe1']) ? $adv_kbrd_colors['textFieldDe1'] : '';
		$this->textFieldDe2 = isset($adv_kbrd_colors['textFieldDe2']) ? $adv_kbrd_colors['textFieldDe2'] : 'de';
		$this->textFieldDe3 = isset($adv_kbrd_colors['textFieldDe3']) ? $adv_kbrd_colors['textFieldDe3'] : '';
		$this->textFieldDe4 = isset($adv_kbrd_colors['textFieldDe4']) ? $adv_kbrd_colors['textFieldDe4'] : 'de';
		$this->textFieldDe5 = isset($adv_kbrd_colors['textFieldDe5']) ? $adv_kbrd_colors['textFieldDe5'] : '';
	}
	public static function get_STB_locale(){
		$propertiesFile = realpath("/config/settings.properties");
		if ($propertiesFile) {
			$handle = fopen($propertiesFile, "r");
			if ($handle) {
				while (($buffer = fgets($handle)) !== false) {
					$pos = strpos($buffer, "interface_language = "); //robust but fast comparison
					if ($pos !== false) {
						$result = trim(substr($buffer, $pos + strlen("interface_language = ")));
						fclose($handle);
						return $result;
					}
				}
				if (!feof($handle))
					hd_print("Get current player locale failed.");
				fclose($handle);
			}
		}
		hd_print("interface_language setting not found. Default STB locale = english");
		return "english";
	}
	
	public static function known_languages(){
		//all known translations
		return array(
			'arabic' => 'العربية',
			'bulgarian' => 'Български',
			'chinese_simplified' => '简体中文',
			'chinese_traditional' => '繁體中文',
			'czech' => 'Čeština',
			'danish' => 'Dansk',
			'dutch' => 'Nederlands',
			'english' => 'English',
			'estonian' => 'Eesti',
			'french' => 'Français',
			'german' => 'Deutsch',
			'greek' => 'Ελληνικά',
			'hebrew' => 'עברית',
			'hungarian' => 'Magyar',
			'italian' => 'Italiano',
			'japanese' => '日本語',
			'korean' => '한국어',
			'polish' => 'Polski',
			'romanian' => 'Română',
			'russian' => 'Русский',
			'slovak' => 'Slovenčina',
			'spanish' => 'Español',
			'swedish' => 'Svenska',
			'turkish' => 'Türkçe',
			'ukrainian' => 'Українська',
			'vietnamese' => 'Tiếng Việt'
		);
	}
}


?>
