<?php

interface GlobalActionsProvider
{
    function add_actions(&$action_map);
}

class GlobalActionMap
{
    private static $providers = array();

    public static function register_provider(GlobalActionsProvider $provider)
    {
        self::$providers[] = $provider;
    }

    public static function add_actions(&$action_map)
    {
        foreach (self::$providers as $p)
            $p->add_actions($action_map);
    }
}

?>
