<?php

class Sticker
{
    private function __construct()
    { }

    public static function sticker($items, $above_selection=false){
		if (!$items)
			return null;
		return array(
			'items' => $items,
			'above_selection' => $above_selection
		);
    }

	public static function item($geom, $comp){
        return array(
			'geom' => $geom, 
			'comp' => $comp
		);
    }

    public static function geom($x, $y, $halign='right', $valign='top')
    {
        return array(
			'x' => $x, 
			'y' => $y,
            'halign' => $halign, 
			'valign' => $valign
		);
    }

    public static function icon($url){
        return array(
			'items' => array(
				array(
				'type' => 'icon', 
				'url' => $url
				)
			)
		);
    }

    public static function text($text, $color=null)
    {
        $arr = array(
			'type' => 'text', 
			'text' => $text, 
			'color' => $color
		);
        if (isset($color))
            $arr['color'] = $color;
        return array('items' => array($arr));
    }
	
}

?>
