<?php

class L
{
    static $MAIN_SCALE = 1.18;
    static $PAGE_SIZE = 9;

    ////////////////////////////////////////////////////////////////////////////////////////////////
    // Linear dimensions. Ratio-dependent.

    static $WIDTH = 1920;
    static $HEIGHT = 1080;

    // Font sizes.

    static $LARGE_TEXT_SIZE = 60;
    static $BIG_TEXT_SIZE = 48;
    static $TEXT_SIZE = 36;
    static $SMALL_TEXT_SIZE = 30;
    static $LIST_TEXT_SIZE = 42;

    static $TEXT_TOP = 2;
    static $TEXT_BOTTOM = 10;
    static $LIST_TEXT_TOP = 2;
    static $LIST_TEXT_BOTTOM = 11;
    static $LARGE_TEXT_TOP = 3;
    static $LARGE_TEXT_BOTTOM = 16;

    static $TITLE_TEXT_SIZE;

    static $SMALL_TEXT_ALIGN = -4;
    static $TEXT_ALIGN = -5;
    static $BIG_TEXT_ALIGN = -7;
    static $LARGE_TEXT_ALIGN = -9;

    static $TITLE_TEXT_ALIGN;

    static $TEXT_LINE_SPACING = 13;
    static $LIST_TEXT_LINE_SPACING = 15;
    static $BIG_TEXT_LINE_SPACING = 17;

    static $TEXT_BOTTOM_EXTENT = 8;

    // Misc

    static $PAR_VGAP_BIG = 20;
    static $PAR_VGAP_SMALL = 10;

    static $PANEL_LINE_HEIGHT = 90;

    static $SCREEN_RIGHT = 75;
    static $SCREEN_LEFT = 75;

    static $ICON_SIZE = 40;

    static $PANEL_TOP_OFFSET = 150;
    static $PANEL_BOTTOM_OFFSET = 120;

    static $VOD_PANEL_TOP = 60;
    static $VOD_PANEL_BOTTOM = 60;

    static $HINTS_BOTTOM_OFFSET = 90;
    static $HINTS_HGAP = 80;
    static $HINTS_SMALL_HGAP = 40;

    static $PANEL_HEIGHT;
    static $VOD_PANEL_HEIGHT;
    static $PANEL_H_PADDING = 20;
    static $PANEL_H_GAP = 40;
    static $PANEL_TAIL_WIDTH = 20;

    static $PANEL_DEFAULT_WIDTH;

    static $PANEL_SEL_Y_OFFSET = 10;

    static $SEL_FRAME_DEFAULT_HEIGHT;
    static $SEL_FRAME_DEFAULT_WIDTH = 500;

    static $SEL_BORDER = 7;

    static $PLAY_OSD_TOP_PADDING = 18;
    static $PLAY_OSD_BOTTOM_PADDING = 18;

    static $INFO_HEIGHT = 350;
    static $INFO_TV_ICON_WIDTH = 126;
    static $INFO_TV_ICON_HEIGHT = 72;
    static $INFO_VOD_ICON_WIDTH = 303;
    static $INFO_VOD_ICON_HEIGHT = 431;
    static $INFO_VOD_ICON_RIGHT = 40;
    static $INFO_V_PADDING = 20;
    static $INFO_H_PADDING = 140;
    static $INFO_PROGRESS_H = 24;

    static $ADVANCED_INFO_TOP = 40;
    static $STATUS_TOP = 80;
    static $STATUS_ICON_WIDTH = 64;
    static $STATUS_ICON_HEIGHT = 64;

    static $DEFAULT_LEFT = 144;

    static $CONTROL_LABEL_Y_TOP = 30;

    static $TITLE_WIDTH;
    static $TITLE_LEFT = 150;

    static $WIDGET_RIGHT;
    static $WIDGET_HGAP = 40;
    static $WIDGET_INNER_HGAP = 10;
    static $WIDGET_WIDTH;

    static $TITLE_FULL_WIDTH;

    static $LIST_SPECIAL_TEXT_LEFT = 20;

    static $VOD_GRID_PANEL_WIDTH;
    static $VOD_GRID_POSTER_WIDTH = 220;
    static $VOD_GRID_POSTER_HEIGHT = 330;
    static $VOD_GRID_NUMBER_TEXT_SIZE = 24;
    static $VOD_GRID_ITEM_V_PADDING = 20;
    static $VOD_GRID_ITEM_H_PADDING = 20;
    static $VOD_GRID_NUMBER_TEXT_TOP = 10;
    static $VOD_GRID_NUMBER_TEXT_LEFT = 10;
    static $VOD_GRID_SEL_WIDTH_EXTENT = -3;
    static $VOD_GRID_BOTTOM_SHADOW_SIZE = 90;
    static $VOD_GRID_SEL_EXTENT = 10;

    static $VOD_LIST_SEL_POSTER_WIDTH = 107;
    static $VOD_LIST_SEL_POSTER_HEIGHT = 160;
    static $VOD_LIST_POSTER_WIDTH = 97;
    static $VOD_LIST_POSTER_HEIGHT = 145;

    static $VOD_LIST_TEXT_SPACING = 8;
    static $VOD_LIST_TEXT_INDENT = 20;
    static $VOD_LIST_ICON_RIGHT = 40;
    static $VOD_LIST_ICON_X_OFFSET = 10;
    static $VOD_LIST_ICON_V_PADDING = 9;
    static $VOD_LIST_SEL_HEIGHT_EXTENT = 15;

    static $VOD_LIST_SEP_TOP = 18;
    static $VOD_LIST_SEP_BOTTOM = 24;
    static $VOD_LIST_SEP_TITLE_LEFT = 200;

    static $VOD_SEARCH_SEL_POSTER_WIDTH = 80;
    static $VOD_SEARCH_SEL_POSTER_HEIGHT = 121;
    static $VOD_SEARCH_POSTER_WIDTH = 73;
    static $VOD_SEARCH_POSTER_HEIGHT = 110;

    static $VOD_SHORT_INFO_PANEL_WIDTH;

    static $VOD_CATEGORIES_PANEL_WIDTH;

    static $VOD_BACK_ARROW_SIZE = 50;
    static $VOD_BACK_ARROW_LEFT;
    static $VOD_BACK_ARROW_LEFT2;
    static $VOD_BACK_ARROW_TOP = 60;

    static $VOD_POSTER_LEFT;
    static $VOD_POSTER_BOTTOM = 30;
    static $VOD_POSTER_WIDTH = 303;
    static $VOD_POSTER_HEIGHT = 431;

    static $VOD_BUTTON_HEIGHT = 50;
    static $VOD_BUTTON_TEXT_LEFT = 10;

    static $VOD_PEOPLE_PANELS_WIDTH;
    static $VOD_PEOPLE_PANEL_WIDTH;
    static $VOD_PERSON_INFO_PANEL_WIDTH;

    static $VOD_INFO_TEXT_INDENT = 10;
    static $VOD_INFO_POSTER_BOTTOM = 10;
    static $VOD_INFO_RATING_ICON_RIGHT = 8;

    static $VOD_SCROLL_SIZE = 350;

    static $VOD_OBJECT_COL_HGAP = 40;
    static $VOD_OBJECT_PAR_DY = 10;
    static $VOD_MOVIE_DESCRIPTION_VGAP = 12;
    static $VOD_DESCRIPTION_HR_TOP = 27;
    static $VOD_DESCRIPTION_HR_BOTTOM = 12;
    static $VOD_PERSON_PAR_VGAP = 15;

    static $VOD_LOCK_WIDTH = 37;
    static $VOD_LOCK_HEIGHT = 37;
    static $VOD_LOCK_RIGHT = 13;
    static $VOD_LOCK_TOP = 13;

    static $VOD_SEARCH_ICON_WIDTH = 50;
    static $VOD_SEARCH_ICON_HEIGHT = 75;
    static $VOD_SEARCH_ICON_SEL_WIDTH = 60;
    static $VOD_SEARCH_ICON_SEL_HEIGHT = 90;

    static $FILE_MAPPING_HR_TITLE_LEFT = 300;

    static $TITLE_Y;

    static $BUTTON_ICON_WIDTH = 48;
    static $BUTTON_ICON_HEIGHT = 48;

    static $IMDB_WIDTH = 45;
    static $IMDB_HEIGHT = 45;

    static $INCLUDED_ICON_WIDTH = 28;
    static $INCLUDED_ICON_HEIGHT = 32;

    static $COLOR_BUTTON_WIDTH = 52;
    static $COLOR_BUTTON_HEIGHT = 50;

    static $TEXT_HGAP = 20;
    static $IMDB_ICON_TEXT_DY = 11;
    static $COLOR_ICON_TEXT_DY = 8;
    static $COLOR_ICON_SMALL_TEXT_DY = 6;
    static $TEXT_ICON_HGAP = 5;
    static $SCROLLBAR_H_OFFSET = 15;

    ////////////////////////////////////////////////////////////////////////////////////////////////
    // Colors.
    //static $BG_COLOR = 0xE0000000;
    static $BG_COLOR = 0xC0000000;
    //static $PANEL_BG_COLOR = 0x80404040;
    static $PANEL_BG_COLOR = 0xD0000000;
    static $PANEL_BG_DARK_COLOR = 0xD0000000;
    //static $SEL_BG_COLOR = 0xD0404040;
    static $SEL_BG_COLOR = 0x80404040;
    static $SEL_RECT_COLOR = 0xD0346EBF;
    static $TEXT_COLOR_R = 0xAF;
    static $TEXT_COLOR_G = 0xAF;
    static $TEXT_COLOR_B = 0xA0;
    static $TEXT_COLOR;
    static $DIMMED_TEXT_COLOR_R = 0x80;
    static $DIMMED_TEXT_COLOR_G = 0x80;
    static $DIMMED_TEXT_COLOR_B = 0x80;
    static $DIMMED_TEXT_COLOR;
    static $ERROR_TEXT_COLOR = 0xFFA00000;
    static $SEL_TEXT_COLOR = 0xFFFFFFE0;
    static $MSG_DATE_TEXT_COLOR = 0xFFC06018;
    static $TIMELINE_COLOR = 0xD0205090;
    static $WIDGET_TIME_COLOR;

    static function static_init()
    {
        self::$TITLE_TEXT_SIZE = self::$LARGE_TEXT_SIZE;
        self::$TITLE_TEXT_ALIGN = self::$LARGE_TEXT_ALIGN;
        self::$PANEL_HEIGHT = self::$HEIGHT - self::$PANEL_TOP_OFFSET - self::$PANEL_BOTTOM_OFFSET;
        self::$VOD_PANEL_HEIGHT = self::$HEIGHT - self::$VOD_PANEL_TOP - self::$PANEL_BOTTOM_OFFSET;
        self::$PANEL_DEFAULT_WIDTH = (self::$WIDTH - self::$PANEL_TAIL_WIDTH - self::$PANEL_H_GAP * 2) / 2;
        self::$SEL_FRAME_DEFAULT_HEIGHT = self::$PANEL_LINE_HEIGHT - self::$PANEL_SEL_Y_OFFSET * 2;
        self::$TITLE_WIDTH = self::$WIDTH * 2 / 3 - 20;
        self::$WIDGET_RIGHT = self::$SCREEN_RIGHT;
        self::$WIDGET_WIDTH = self::$WIDTH - self::$TITLE_WIDTH - self::$TITLE_LEFT - self::$WIDGET_RIGHT - self::$WIDGET_HGAP;
        self::$TITLE_FULL_WIDTH = self::$WIDTH - self::$TITLE_LEFT - self::$WIDGET_RIGHT;
        self::$VOD_GRID_PANEL_WIDTH = self::$PANEL_DEFAULT_WIDTH + 200;
        self::$VOD_SHORT_INFO_PANEL_WIDTH = self::$PANEL_DEFAULT_WIDTH - self::$PANEL_H_GAP - 200;
        self::$VOD_CATEGORIES_PANEL_WIDTH = self::$PANEL_DEFAULT_WIDTH - 200;
        self::$VOD_BACK_ARROW_LEFT = self::$SCREEN_LEFT;
        self::$VOD_BACK_ARROW_LEFT2 = self::$VOD_BACK_ARROW_LEFT + 10;
        self::$VOD_POSTER_LEFT = self::$SCREEN_LEFT;
        self::$VOD_PEOPLE_PANELS_WIDTH = self::$WIDTH - self::$VOD_POSTER_LEFT - self::$SCREEN_RIGHT -
        self::$VOD_POSTER_WIDTH - self::$PANEL_H_GAP;
        self::$VOD_PERSON_INFO_PANEL_WIDTH = self::$VOD_POSTER_WIDTH;
        self::$VOD_PEOPLE_PANEL_WIDTH = self::$VOD_PEOPLE_PANELS_WIDTH -  self::$VOD_PERSON_INFO_PANEL_WIDTH - self::$PANEL_H_GAP;
        self::$TITLE_Y = self::$VOD_BACK_ARROW_TOP + (self::$VOD_BACK_ARROW_SIZE - self::$TITLE_TEXT_SIZE) / 2;
        self::$TEXT_COLOR = 0xFF000000 + self::$TEXT_COLOR_R * 0x10000 + self::$TEXT_COLOR_G * 0x100 + self::$TEXT_COLOR_B;
        self::$DIMMED_TEXT_COLOR = 0xFF000000 + self::$DIMMED_TEXT_COLOR_R * 0x10000 + self::$DIMMED_TEXT_COLOR_G * 0x100 + self::$DIMMED_TEXT_COLOR_B;
        self::$WIDGET_TIME_COLOR = self::$SEL_TEXT_COLOR;
    }
}

?>
