<?php
class TransmissionUPnP
{
	static $transmissionUPnPIp = null;
	static $transmissionUPnPItems = null;
	static $transmissionBtcIp = null;
	static $transmissionRPC = null;
	static $torrentItemsArr = array();
	static $torrent = null;
	public static $sessionInfo;
	public static function getIp(){
        if (null === self::$transmissionUPnPIp){
			$transmissionUPnPIp = (HD::getItemStr('transmissionUPnPIp', 1) != '') ? HD::getItemStr('transmissionUPnPIp', 1) : false;
			if (($transmissionUPnPIp == '')&&(self::getInstallTransmissionUPnP() == true)){
				$transmissionUPnPIp = 'http://127.0.0.1:9092';
				HD::saveItemStr('transmissionUPnPIp', $transmissionUPnPIp, true);
				HD::saveItemStr('duneTransmissionUPnPIp', 1, true);
			}
            self::$transmissionUPnPIp = $transmissionUPnPIp;
        }
        return self::$transmissionUPnPIp;
	}
	public static function getTransmissionBtcIp($set='w'){
		if ($set != 'w'){
			if ((($set == '')||($set == 0))||(preg_match('|\D+|', $set)))
				$set = 9091;
			HD::saveItemStr('transmissionPort', $set, true);
			if (self::getIp() != ''){
				$path_parts = parse_url(self::getIp());
				self::$transmissionBtcIp = $path_parts['scheme'] .  '://' .$path_parts['host'] .':'. $set;
			}
		}
        if (null === self::$transmissionBtcIp){
			$transmissionPort = (HD::getItemStr('transmissionPort', 1) != '') ? HD::getItemStr('transmissionPort', 1) : 9091;
            if (self::getIp() != ''){
				$path_parts = parse_url(self::getIp());
				self::$transmissionBtcIp = $path_parts['scheme'] .  '://' . $path_parts['host'] .':'. $transmissionPort;
			}
        }
        return self::$transmissionBtcIp;
	}
	public static function startTransmissionUPnP(){
		exec ("am start com.ap.transmission.btc/com.ap.transmission.btc.activities.MainActivity 2>&1");
		sleep (10);
		return true;
    }
	public static function setTransmissionUPnPIp($inputStr){
		$path_parts = parse_url($inputStr);
		if (isset($path_parts['host']))
			$transmissionUPnPIp = $path_parts['host'];
		else if (isset($path_parts['path']))
			$transmissionUPnPIp = $path_parts['path'];
		$ip_address = HD::get_ip_address();
		if (($transmissionUPnPIp == '127.0.0.1')||($ip_address == $transmissionUPnPIp)){
			if (self::getInstallTransmissionUPnP() != true)
				return array(
					'caption' => 'Error!',
					'descr' => "IP адрес Transmission BTC: $transmissionUPnPIp указан не верно. Локальный Transmission BTC не найден. Необходима установка Transmission BTC на это устройство или указывайте IP адрес другого устройства в сети с установленным Transmission BTC."
				);
			$transmissionUPnPIp = '127.0.0.1';
		}else if ($transmissionUPnPIp == ''){
			if (self::getIp() != ''){
				if (HD::saveItemStr('transmissionUPnPIp', $transmissionUPnPIp, true) == true){
					self::$transmissionUPnPIp = $transmissionUPnPIp;
					HD::saveItemStr('duneTransmissionUPnPIp', 0, true);
					return array(
						'caption' => 'Сохранено',
						'descr' =>  "Удален IP адрес Transmission BTC: " . self::getIp()
					);
				}else
					return array(
					'caption' => 'Error!',
					'descr' => "Сохранение не удалось"
					);
			}else
				return array(
					'caption' => 'Error!',
					'descr' => "IP адрес Transmission BTC не указан. Укажите IP адрес устройства с установленным Transmission BTC."
				);
		}
		if (isset($path_parts['port']))
			$transmissionUPnPIp .= ':' . $path_parts['port'];
		else
			$transmissionUPnPIp .= ':9092';
		if (isset($path_parts['scheme']))
			$transmissionUPnPIp = $path_parts['scheme'] .  '://' . $transmissionUPnPIp;
		else
			$transmissionUPnPIp = 'http://' . $transmissionUPnPIp;
		if (HD::saveItemStr('transmissionUPnPIp', $transmissionUPnPIp, true) == true){
			$transmissionUPnPHistory = HD::getItemsArr('transmissionUPnPHistory');
			$transmissionUPnPHistory = array_reverse($transmissionUPnPHistory);
			$transmissionUPnPHistory[$transmissionUPnPIp] = $transmissionUPnPIp;
			$transmissionUPnPHistory = array_reverse($transmissionUPnPHistory);
			$transmissionUPnPHistory = array_slice($transmissionUPnPHistory, 0, 10);
			HD::saveItemsArr('transmissionUPnPHistory', $transmissionUPnPHistory);
			if (isset($path_parts['host']))
				$host = $path_parts['host'];
			else if (isset($path_parts['path']))
				$host = $path_parts['path'];
			self::$transmissionUPnPIp = $transmissionUPnPIp;
			return array(
				'caption' => 'Сохранено',
				'descr' => "IP Transmission BTC: $transmissionUPnPIp",
			);
		}else
			return array(
				'caption' => 'Error!',
				'descr' => "IP адрес Transmission BTC: $transmissionUPnPIp cохранить не удалось",
			);
	}
	public static function getOnlineStatusServer(){
		$transmissionUPnPIp = self::getIp();
		if ($transmissionUPnPIp != ''){
			$cmd = HD::isDomainAvailible($transmissionUPnPIp . '/playlist');
			if($cmd == true)
				return $cmd;
		}
		return false;
	}
	public static function getInstallTransmissionUPnP(){
		$platform = HD::get_platform_kind();
		if ($platform == 'android'){
			$file_exists = shell_exec ('/system/dunehd/dunehd_service do [ -f "/data/user/0/com.ap.transmission.btc/Config/settings.json" ] && echo 2');
				if ($file_exists == 2)
					return true;
		}
		return false;
	}
	public function transmissionActionGetTorrentInfo($user_input){
		hd_restore_warnings();
		$filesUnwantedArr = array();
		if (isset($user_input->filesUnwantedArr)){
			$filesUnwantedArr = json_decode($user_input->filesUnwantedArr, true);
		}
		$content = array_values(array_flip (self::$torrent->content()));
		if (count($content) == 0)
			return ActionFactory::show_title_dialog('Err!', null, "Этот файл не является торрент файлом. Возможно произошла ошибка при загрузке торрент файла.", 800);
		if (isset($user_input->filesUnwanted)){
			if ($user_input->filesUnwanted == 'files_unwanted')
				$filesUnwantedArr[$user_input->files_id] = $user_input->files_id;
			if ($user_input->filesUnwanted == 'files_wanted')
				if (isset($filesUnwantedArr[$user_input->files_id]))
					unset($filesUnwantedArr[$user_input->files_id]);
			if ($user_input->filesUnwanted == 'all'){
				if (count($filesUnwantedArr) == 0){
					foreach ($content as $k => $v)
						$filesUnwantedArr[$k + 1] = $k;
				}else
					$filesUnwantedArr = array();
			}
			if ($user_input->filesUnwanted == 'reverse'){
				if (isset($user_input->reverse))
					unset($user_input->reverse);
				else
					$user_input->reverse = $add_params['reverse'] = 1;
			}
		}
					
		$attrs['initial_sel_ndx'] = isset($user_input->initial_sel_ndx) ? $user_input->initial_sel_ndx : -1;
		$width = 1350;
		$add_params['filesUnwantedArr'] = json_encode($filesUnwantedArr);
		$name = self::$torrent->name();
		ControlFactory::add_vgap($defs, (-15));
		ControlFactory::add_smart_label($defs, 
			"", 
			'<icon width="30" height="30">gui_skin://special_icons/controls_button_red.aai</icon><text color="15" size="small"> Не загружаюся все  </text>
			<icon width="30" height="30">gui_skin://special_icons/controls_button_green.aai</icon><text color="15" size="small"> Перевернуть список</text>'
		);
		ControlFactory::add_smart_label($defs, 
			"", 
			'<icon width="40" height="40">'.DuneSystem::$properties['install_dir_path'].'/icons/s_torrent.png</icon><text color="14" size="normal"> '.$name.'</text>'
		);
		if ($user_input->handler_id == 'file_list'){
			ControlFactory::add_close_dialog_and_apply_button($defs, $this, $add_params, 'addTransmissionUPnPTorrent', 'Загрузить торрент', 450);
			$add_params['paused'] = true;
			ControlFactory::add_close_dialog_and_apply_button($defs, $this, $add_params, 'addTransmissionUPnPTorrent', 'Добавить торрент', 450);
		}else{
			$add_params['action'] = 'addTransmissionUPnPTorrent';
			$add_params['indiClass'] = 'TransmissionUPnP';
			ControlFactory::add_close_dialog_and_apply_button($defs, $this, $add_params, 'classAction', 'Загрузить торрент', 450);
			$add_params['paused'] = true;
			ControlFactory::add_close_dialog_and_apply_button($defs, $this, $add_params, 'classAction', 'Добавить торрент', 450);
		}
		if (isset($user_input->reverse)){
			$content = array_reverse($content, true);
			$add_params['reverse'] = 1;
		}
		$i = 1;
		foreach ($content as $k => $v){
			$path_parts = pathinfo($v);
			if (isset($filesUnwantedArr[$k + 1])){
				$add_params['filesUnwanted'] = 'files_wanted';
				$caption = 'Не загружается';
				$color = 17;
			}else{
				$add_params['filesUnwanted'] = 'files_unwanted';
				$caption = 'Загружается';
				$color = 15;
			}
			$add_params['files_id'] = $k + 1;
			ControlFactory::add_smart_label($defs, 
				"", 
				'<gap width="300"/><text color="'.$color.'" size="small"> '.$path_parts['basename'].'</text>'
			);
			$add_params['initial_sel_ndx'] = $i + 1;
			ControlFactory::add_vgap($defs, (-70));
			ControlFactory::add_close_dialog_and_apply_button($defs, $this, $add_params, $user_input->control_id, $caption, 350);
			$i++;
		}
		$add_params['initial_sel_ndx'] = -1;
		$add_params['filesUnwanted'] = 'all';
		$action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $add_params);
		$attrs['actions'][GUI_EVENT_KEY_A_RED]	= ActionFactory::close_dialog_and_run($action);
		$add_params['filesUnwanted'] = 'reverse';
		$action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $add_params);
		$attrs['actions'][GUI_EVENT_KEY_B_GREEN] = ActionFactory::close_dialog_and_run($action);
		return ActionFactory::show_dialog('Добавить торрент в Transmission', $defs, true, $width, $attrs);
	}
	public function transmissionActionAddTorrent($user_input){
		hd_restore_warnings();
		if (!isset($user_input->counter))
			HD::asyncExec('proc_close');
		$add_params = null;
		if (isset($user_input->action))
			$add_params['action'] = $user_input->action;
		if (isset($user_input->indiClass))
			$add_params['indiClass'] = $user_input->indiClass;
		$selected_media_url = MediaURL::decode($user_input->selected_media_url);
		if ((!isset($selected_media_url->tType ))||($selected_media_url->tType == 'torrent'))
			$torrent_location = 'http://'.HD::get_ip_address().'/temp.torrent';
		if (isset($user_input->torrentPath))
			$add_params['torrentPath'] = $torrent_location = $user_input->torrentPath;
		$cmdAsyncExec = DuneSystem::$properties['install_dir_path'] . '/www/cgi-bin/php-cgi -f ' .  DuneSystem::$properties['install_dir_path'] . "/www/cgi-bin/transmissionActions.php action=add_file torrent_location=\"$torrent_location\" transmissionIp=" . self::getTransmissionBtcIp();
		if (isset($user_input->filesUnwantedArr)){
			$add_params['filesUnwantedArr'] = $user_input->filesUnwantedArr;
			$filesUnwantedArr = json_decode($user_input->filesUnwantedArr, true);
			if (count($filesUnwantedArr) > 0)
				$cmdAsyncExec .= " extra_options=". urlencode($user_input->filesUnwantedArr);
		}
		if (isset($user_input->paused)){
			$cmdAsyncExec .= " paused=1";
			$add_params['paused'] = $user_input->paused;
		}
		// $transmissionAccount = (HD::getItemsArr('transmissionAccount', true) != array()) ? HD::getItemsArr('transmissionAccount', true) : array('login' => '', 'pass' => '');
		// if (($transmissionAccount['login'] != '')&&($transmissionAccount['pass'] != ''))
			// $cmdAsyncExec .= " login=". $transmissionAccount['login'] ." pass=" . $transmissionAccount['pass'];
		$result = HD::asyncExec($cmdAsyncExec);
		if ($result != ''){
			$result = json_decode ($result);
			if (isset($result->arguments->torrent_added->hashString)){
				$add_params['torrent_added'] = $result->arguments->torrent_added->hashString;
				$add_params['torrent_id'] = $result->arguments->torrent_added->id;
				$add_params['torrent_added_name'] = $result->arguments->torrent_added->name;
			}else
				return ActionFactory::show_title_dialog("Добавление не удалось", null, $result->result);
		}
		$counter = 1;
		if (isset($user_input->counter))
			$counter = $user_input->counter + 1;
		$add_params['counter'] = $counter;
		$action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $add_params);
		$attrs['timer'] = ActionFactory::timer(1000);
		$attrs['actions'] = array(GUI_EVENT_TIMER => ActionFactory::close_dialog_and_run($action));
		ControlFactory::add_label($defs, '', "Прошло : " . HD::sec_format_duration($counter));
		return  ActionFactory::show_dialog('Добавление торрента', $defs, true, 0, $attrs);
	}
	
	public static function transmissionUPnPAddTorrent($torrentFile, $tType){
		if ($tType == 'magnet')
			return array("status" => true);
		if ($torrentFile == 'http://'.HD::get_ip_address().'/temp.torrent'){
			self::$torrent = new Torrent('/tmp/www/temp.torrent');
			if ('temp.torrent' == self::$torrent->name())
				return array("status" =>  false, "msg"=>"Сохраненный файл не является торрент файлом. Возможно произошла ошибка при загрузке торрент файла.");
		}
		return array("status" => true);
	}
	
	public static function transmissionActionSaveTorrentFile($filepath=null, $torrentFileStr=null){
		if ($filepath==true)
			$torrentFileStr = file_get_contents ($filepath);
		
		if (file_put_contents ('/tmp/www/temp.torrent', $torrentFileStr) !== false){
			self::$torrent = new Torrent('/tmp/www/temp.torrent');
			if ('temp.torrent' != self::$torrent->name())
				return array("status" => true);
			else
				return array("status" =>  false, "msg"=>"Сохраненный файл не является торрент файлом. Возможно произошла ошибка при загрузке торрент файла.");
		}else
			return array("status" => false, "msg" => "Сохранение не удалось");
	}
	public function setup($defs, $user_input){
		hd_restore_warnings();
		$attrs['initial_sel_ndx'] = isset($user_input->initial_sel_ndx) ? $user_input->initial_sel_ndx : -1;
		$transmissionUPnPIp = self::getIp();
		$cmd = self::getOnlineStatusServer();
		$slaveTransmissionUPnP = self::getInstallTransmissionUPnP();
		self::actionGetSessionInfo();
		$add_params = null;
		if (isset($user_input->class_name))
			$add_params['class_name'] = $user_input->class_name;
		$width = 1050;
		if ((isset($user_input->action))&&($user_input->action == 'setup')){
			$add_params['control_id']= $user_input->control_id;
			$add_params['action'] = 'setup';
			if (isset($user_input->subAction)){
				$add_params['initial_sel_ndx'] = $user_input->initial_sel_ndx;
				TransmissionUPnP::transmissionRpcAction();
				if (isset($user_input->str)){
					$argument[strval($user_input->subAction)] = $user_input->{$user_input->subAction};
					if ($user_input->{$user_input->subAction} == 'false')
						$add_params['initial_sel_ndx'] = $user_input->initial_sel_ndx - 1;
				}else{
					if (($user_input->{$user_input->subAction} != 0)&&($user_input->{$user_input->subAction} != ""))
						$argument[strval($user_input->subAction)] = intval($user_input->{$user_input->subAction});
					else{
						$action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $add_params);
						$action = ActionFactory::close_dialog_and_run($action);
						return ActionFactory::show_title_dialog('Err!', $action, 'Сохранение значения не удалось. Значение не может быть пустым или равным нулю.', 850);
					}
				}
				if (isset($argument))
					$result = TransmissionUPnP::$transmissionRPC->sset($argument);
				$action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $add_params);
				if ((!isset($result))||($result->result != 'success'))
					return ActionFactory::show_title_dialog('Err!', $action, 'Сохранение значения не удалось.', 850);
				else
					return ActionFactory::close_dialog_and_run($action);
			}
			$subActionArr[] = array(
				'subAction' => 'peer-limit-global',
				'caption' => 'Глобальный лимит пиров',
				'sessionInfo' => 'peer_limit_global'
			);
			$subActionArr[] = array(
				'subAction' => 'peer-limit-per-torrent',
				'caption' => 'Лимит пиров торрента',
				'sessionInfo' => 'peer_limit_per_torrent'
			);
			$ops['true'] = 'Да';
			$ops['false'] = 'Нет';
			$initial_value = 'false';
			if (isset(self::$sessionInfo['speed_limit_down_enabled'])){
				$subActionArr[] = array(
					'subAction' => 'speed-limit-down',
					'caption' => 'Скорость загрузки КБ/с',
					'sessionInfo' => 'speed_limit_down'
				);
				$initial_value = 'true';
			}
			$subActionArr[] = array(
				'subAction' => 'speed-limit-down-enabled',
				'caption' => 'Лимит скорости загрузки',
				'str' => true,
				'initial_value' => $initial_value,
				'ops' => $ops
			);
			$initial_value = 'false';
			if (isset(self::$sessionInfo['speed_limit_up_enabled'])){
				$subActionArr[] = array(
					'subAction' => 'speed-limit-up',
					'caption' => 'Скорость отдачи КБ/с',
					'sessionInfo' => 'speed_limit_up'
				);
				$initial_value = 'true';
			}
			$subActionArr[] = array(
				'subAction' => 'speed-limit-up-enabled',
				'caption' => 'Лимит скорости отдачи',
				'initial_value' => $initial_value,
				'str' => true,
				'ops' => $ops
			);
			$subActionArr[] = array(
				'subAction' => 'alt-speed-down',
				'caption' => 'Альтернативная скорость загрузки КБ/с',
				'sessionInfo' => 'alt_speed_down'
			);
			
			$subActionArr[] = array(
				'subAction' => 'alt-speed-up',
				'caption' => 'Альтернативная скорость отдачи КБ/с',
				'sessionInfo' => 'alt_speed_up'
			);
			$initial_value = 'false';
			if (isset(self::$sessionInfo['seedRatioLimited'])){
				$subActionArr[] = array(
					'subAction' => 'seedRatioLimit',
					'caption' => 'Коэффициент отдачи (ratio)',
					'sessionInfo' => 'seedRatioLimit'
				);
				$initial_value = 'true';
			}
			$subActionArr[] = array(
				'subAction' => 'seedRatioLimited',
				'caption' => 'Коэффициент отдачи (ratio)',
				'initial_value' => $initial_value,
				'str' => true,
				'ops' => $ops
			);
			$initial_value = 'false';
			if (isset(self::$sessionInfo['download_queue_enabled'])){
				$subActionArr[] = array(
					'subAction' => 'download-queue-size',
					'caption' => 'Размер очереди загрузки',
					'sessionInfo' => 'download_queue_size'
				);
				$initial_value = 'true';
			}
			$subActionArr[] = array(
				'subAction' => 'download-queue-enabled',
				'caption' => 'Очередь загрузки',
				'initial_value' => $initial_value,
				'str' => true,
				'ops' => $ops
			);
			$initial_value = 'false';
			if (isset(self::$sessionInfo['seed_queue_enabled'])){
				$subActionArr[] = array(
					'subAction' => 'seed-queue-size',
					'caption' => 'Размер очереди отдачи',
					'sessionInfo' => 'seed_queue_size'
				);
				$initial_value = 'true';
			}
			$subActionArr[] = array(
				'subAction' => 'seed-queue-enabled',
				'caption' => 'Очередь отдачи',
				'initial_value' => $initial_value,
				'str' => true,
				'ops' => $ops
			);
			foreach ($subActionArr as $k => $v){
				ControlFactory::add_vgap($defs, -10);
				$add_params['subAction'] = $v['subAction'];
				$add_params['initial_sel_ndx'] = $k;
				if (isset($v['ops'])){
					if (isset($v['str']))
						$add_params['str'] = 1;
					ControlFactory::add_combobox($defs, $this, $add_params,
						$v['subAction'], $v['caption'],
						$v['initial_value'], $v['ops'], 400, true, false
					);
				}else{
					if (isset($add_params['str']))
						unset($add_params['str']);
					ControlFactory::add_text_field(
						$defs, $this, $add_params,
						$v['subAction'], $v['caption'],
						self::$sessionInfo[$v['sessionInfo']], 1, 0, 0, 0, 400, 1, 0
					);
				}
			}
			return ActionFactory::show_dialog('Transmission ' . self::getTransmissionBtcIp(), $defs, true, $width, $attrs);
		}
		if ((isset($user_input->action))&&($user_input->action == 'transmissionUPnPSearch')){
			$transmissionUPnPIp_ops = HD::isServerAvailable(null, '9092');
			if (count($transmissionUPnPIp_ops) > 0){
				ControlFactory::add_vgap($defs, -10);
				ControlFactory::add_smart_label($defs, "", 
						'<text size="small">Найдено: '. count($transmissionUPnPIp_ops) .'</text>'
					);
				ControlFactory::add_vgap($defs, -10);
				$add_params['control_id']= $user_input->control_id;
				$transmissionUPnPIp_ops[''] = "Выберите";
				ControlFactory::add_combobox($defs, $this, $add_params,
					'transmissionUPnPIp', '',
					'', $transmissionUPnPIp_ops, $width - 100, true, false
				);
				ControlFactory::add_vgap($defs, -10);
				ControlFactory::add_smart_label($defs, "", 
						'<text size="small">*Выберите нужный из списка если их несколько</text>'
					);
			}else{
				ControlFactory::add_multiline_label($defs, '', 'Запущенных Transmission BTC UPnP в локальной сети не найденно, запустите Transmission BTC UPnP на каком либо устройстве если же запущенный Transmission BTC UPnP имеет не стандартный порт укажите "IP адрес:порт" вручную. ', 5);
				$gui_params['button_caption_centered'] = 1;
				$action = UserInputHandlerRegistry::create_action($this, $user_input->control_id);
				ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,'_do', 'Ok', 300, $action, $gui_params);
			}
			return ActionFactory::show_dialog('Запущенные Transmission BTC UPnP в локальной сети', $defs, true, $width, $attrs);
		}
		if ((isset($user_input->transmissionUPnPIp))&&(isset($user_input->action_type))){
			if ((isset($user_input->transmissionUPnPHistoryIp))&&($user_input->transmissionUPnPHistoryIp != 'na'))
				$user_input->transmissionUPnPIp = $user_input->transmissionUPnPHistoryIp;
			if ($user_input->transmissionUPnPIp == 'Укажите IP адрес (:порт - необязательно)')
				$user_input->transmissionUPnPIp = '';
			$sArr = self::setTransmissionUPnPIp ($user_input->transmissionUPnPIp);
			$action = UserInputHandlerRegistry::create_action($this, $user_input->control_id);
			if ($user_input->action_type == 'confirm')
				return ActionFactory::close_dialog_and_run($action);
			else
				return $action;
		}
		if ((isset($user_input->selected_control_id))&&($user_input->selected_control_id == 'transmissionPort')){
			self::getTransmissionBtcIp($user_input->transmissionPort);
			if (isset($user_input->initial_sel_ndx))
				$add_params['initial_sel_ndx']= $user_input->initial_sel_ndx;
			$action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $add_params);
			if ($user_input->action_type == 'confirm')
				return ActionFactory::close_dialog_and_run($action);
			else
				return $action;
		}
		
		if ($transmissionUPnPIp == ''){
			$transmissionUPnPIp = 'Укажите IP адрес (:порт - необязательно)';
			if (self::getInstallTransmissionUPnP() == true){
				$ipDescr = 'Найден локальный Transmission BTC UPnP нажмите Enter в адресной строке или у';
				$transmissionUPnPIp = 'http://127.0.0.1:9092';
			}else if (HD::get_platform_kind() == 'android')
				$ipDescr = 'Что бы использовать локальный Transmission BTC UPnP установите андроидное приложение Transmission BTC или у';
			else
				$ipDescr = 'У';
			$ipDescr .= "кажите IP адрес устройства с Transmission BTC:";
		}else
			$ipDescr = "IP адрес Transmission BTC UPnP:";
		
		ControlFactory::add_vgap($defs, -10);
		ControlFactory::add_multiline_label($defs, '', $ipDescr, 5);
		ControlFactory::add_vgap($defs, -10);
		$add_params['control_id']= $user_input->control_id;
		ControlFactory::add_text_field(
			$defs, $this, $add_params,
			'transmissionUPnPIp', '',
			$transmissionUPnPIp, 0, 0, 0, 0, $width - 100, 1, 0
		);
		$transmissionUPnPHistory = HD::getItemsArr('transmissionUPnPHistory');
		if (count($transmissionUPnPHistory) > 0){
			$transmissionUPnPHistoryOps['na'] = 'Ранее использованные Transmission BTC UPnP';
			foreach ($transmissionUPnPHistory as $k => $v)
				$transmissionUPnPHistoryOps[$k] = $k;
			$add_params['control_id']= $user_input->control_id;
			ControlFactory::add_vgap($defs, -10);
			ControlFactory::add_combobox($defs, $this, $add_params,
				'transmissionUPnPHistoryIp',
				'',
				'na', $transmissionUPnPHistoryOps,  $width - 100, true, false
			);
		}
		$add_params_search['action']= 'transmissionUPnPSearch';
		ControlFactory::add_button_close(&$defs, $this, $add_params_search, $user_input->control_id, '', 'Найти запущенные Transmission BTC UPnP', $width - 100);
		if ($transmissionUPnPIp != 'Укажите IP адрес (:порт - необязательно)'){
			$tt = '<icon width="48" height="48">'.DuneSystem::$properties['install_dir_path'].'/icons/s_android.png</icon><icon width="20" height="48">'.DuneSystem::$properties['install_dir_path'].'/icons/pixel.png</icon>';
			if ($slaveTransmissionUPnP == true)
				$tt = '<icon width="48" height="48">'.DuneSystem::$properties['install_dir_path'].'/icons/s_dune_logo.png</icon><icon width="20" height="48">'.DuneSystem::$properties['install_dir_path'].'/icons/pixel.png</icon>';
			if ($cmd == true){
				ControlFactory::add_smart_label($defs, 
					"", 
					$tt . '<text color="10" size="normal">Transmission BTC UPnP </text><icon width="115" height="25">'.DuneSystem::$properties['install_dir_path'].'/icons/online.png</icon>' 
				);
				$add_params['action']= 'setup';
				ControlFactory::add_button_close(&$defs, $this, $add_params, $user_input->control_id, '', 'Настройки Transmission Daemon', $width - 100);
			}else{
				ControlFactory::add_smart_label($defs, 
					"", 
					$tt . '<text color="8" size="normal">Transmission BTC UPnP </text><icon width="115" height="25">'.DuneSystem::$properties['install_dir_path'].'/icons/offline.png</icon>'
				);
				if ($slaveTransmissionUPnP == true){
					$add_params['action']= 'start';
					ControlFactory::add_button_close(&$defs, $this, $add_params, $user_input->control_id, '', 'Запустить Transmission BTC UPnP', $width - 100);
				}
			}
			if ($transmissionUPnPIp == 'http://127.0.0.1:9092')
				ControlFactory::add_smart_label($defs, "", 
					'<text size="tiny">*127.0.0.1 локальный Transmission BTC UPnP установленный на этом плеере</text>'
				);
		}
		$ipDescr = "Укажите RPC порт Transmission BTC:";
		ControlFactory::add_vgap($defs, -10);
		ControlFactory::add_multiline_label($defs, '', $ipDescr, 5);
		ControlFactory::add_vgap($defs, -10);
		$transmissionPort = (HD::getItemStr('transmissionPort', 1) != '') ? HD::getItemStr('transmissionPort', 1) : 9091;
		$add_params['initial_sel_ndx'] = 4;
		ControlFactory::add_text_field(
			$defs, $this, $add_params,
			'transmissionPort', '',
			$transmissionPort, 1, 0, 0, 0, $width - 100, 1, 0
		);
		ControlFactory::add_smart_label($defs, "", 
			'<text size="tiny">*Указывать другой порт если в настройках Transmission BTC изменялся RPC порт</text>'
		);
		return ActionFactory::show_dialog('Настройки Transmission BTC UPnP', $defs, true, $width, $attrs);
	}
	public static function getPopUpMenuItems ($selected_media_url, $parent_media_url, $select_url = null){
		if (!is_object($parent_media_url))
			$parent_media_url = MediaURL::decode($parent_media_url);
		if (!isset($selected_media_url->playback_url)){
			$s = "";
			if ($select_url==true){
				foreach ($select_url as $v){
					$media_url = MediaURL::decode($v);
					if (isset($media_url->data->id))
						$idArr[] = $media_url->data->id;
					$c = count ($idArr);
					$s = " (выделенно $c)";
				}
			}else
				$idArr[] = $selected_media_url->data->id;
			$jIdArr = json_encode($idArr);
			$menu_items[] = array(
				'caption' => 'Удалить торрент' . $s,
				'params' => array ('action' => 'transmissionActionRem', 'ids' => $jIdArr),
				'icon_url' => 'plugin_file://icons/s_delete.png'
			);
			$menu_items[] = array(
				'caption' => 'Удалить торрент и файлы' . $s,
				'params' => array ('action' => 'transmissionActionRem', 'ids' => $jIdArr, 'delete_local_data' => true),
				'icon_url' => 'plugin_file://icons/s_delete.png'
			);
			$menu_items[] = 'is_separator';
			$menu_items[] = array(
					'caption' => 'Остановить торрент' . $s,
					'params' => array ('action' => 'transmissionActionStartStop', 'rpcAction' => 'stop', 'ids' => $jIdArr),
					'icon_url' => 'plugin_file://icons/s_stop.png'
				);
			$menu_items[] = array(
					'caption' => 'Остановить все торренты',
					'params' => array ('action' => 'transmissionActionStartStop', 'rpcAction' => 'stop', 'ids' => 'all'),
					'icon_url' => 'plugin_file://icons/s_stop.png'
				);
			$menu_items[] = 'is_separator';
			$menu_items[] = array(
				'caption' => 'Запустить торрент' . $s,
				'params' => array ('action' => 'transmissionActionStartStop', 'rpcAction' => 'start', 'ids' => $jIdArr),
				'icon_url' => 'plugin_file://icons/s_start.png'
				);
			$menu_items[] = array(
					'caption' => 'Запустить принудительно' . $s,
					'params' => array ('action' => 'transmissionActionStartStop', 'rpcAction' => 'start_now', 'ids' => $jIdArr),
					'icon_url' => 'plugin_file://icons/s_start_now.png'
				);
			$menu_items[] = array(
				'caption' => 'Запустить все торренты',
				'params' => array ('action' => 'transmissionActionStartStop', 'rpcAction' => 'start', 'ids' => 'all'),
				'icon_url' => 'plugin_file://icons/s_start.png'
				);
			$menu_items[] = 'is_separator';
			if ($select_url==true){
				foreach ($select_url as $v){
					$media_url = MediaURL::decode($v);
					if (isset($media_url->data->id))
						$idArr[] = $media_url->data->id;
					$s = ' (выделенно '.count ($idArr).')';
				}
			}else
				$idArr[] = $selected_media_url->data->id;
			$idArr2[] = $selected_media_url->data->id;
			$jIdArr = json_encode($idArr);
			$jIdArr2 = json_encode($idArr2);
			$menu_items[] = array(
				'caption' => 'Сдвинуть в начало',
				'params' => array ('action' => 'transmissionActionQueue', 'rpcAction' => 'queue_move_top', 'ids' => $jIdArr2),
				'icon_url' => 'plugin_file://icons/s_queue_move_top.png'
			);
			$menu_items[] = array(
				'caption' => 'Сдвинуть вверх' . $s,
				'params' => array ('action' => 'transmissionActionQueue', 'rpcAction' => 'queue_move_up', 'ids' => $jIdArr),
				'icon_url' => 'plugin_file://icons/s_queue_move_up.png'
			);
			$menu_items[] = 'is_separator';
			$menu_items[] = array(
				'caption' => 'Сдвинуть вниз' . $s,
				'params' => array ('action' => 'transmissionActionQueue', 'rpcAction' => 'queue_move_down', 'ids' => $jIdArr),
				'icon_url' => 'plugin_file://icons/s_queue_move_down.png'
			);
			$menu_items[] = array(
				'caption' => 'Сдвинуть в конец',
				'params' => array ('action' => 'transmissionActionQueue', 'rpcAction' => 'queue_move_bottom', 'ids' => $jIdArr2),
				'icon_url' => 'plugin_file://icons/s_queue_move_bottom.png'
			);
			$menu_items[] = array(
				'caption' => 'Проверить торрент' . $s,
				'params' => array ('action' => 'transmissionRpcActionExec', 'rpcAction' => 'verify', 'ids' => $jIdArr),
				'icon_url' => 'plugin_file://icons/s_verify.png'
			);
			$menu_items[] = 'is_separator';
			$menu_items[] = array(
					'caption' => 'Анонсировать ' . $s,
					'params' => array ('action' => 'transmissionRpcActionExec', 'rpcAction' => 'reannounce', 'ids' => $jIdArr),
					'icon_url' => 'plugin_file://icons/s_reannounce.png'
				);
			$menu_items[] = 'is_separator';
			
		}
		if (isset($selected_media_url->playback_url)){
			
			$menu_items[] = array(
				'caption' => 'Большие файлы в начало списка',
				'params' => array ('action' => 'gbSortFolders'),
				'icon_url' => 'plugin_file://icons/s_gbSortFolders.png'
			);
			$s = '';
			if ($select_url==true){
				foreach ($select_url as $v){
					$media_url = MediaURL::decode($v);
					if (isset($media_url->file_info->file_id))
						$idArr[] = $media_url->file_info->file_id;
					$s = ' (выделенно '.count ($idArr).')';
				}
			}
			if ($selected_media_url->file_info->wanted == 1){
				$caption = 'Остановить закачку этого файла' . $s;
				$icon_url = 'plugin_file://icons/s_stop.png';
			}else{
				$caption = 'Запустить закачку этого файла' . $s;
				$icon_url = 'plugin_file://icons/s_start.png';
			}
			$menu_items[] = array(
				'caption' => $caption,
				'params' => array ('action' => 'transmissionActionFileStartStop'),
				'icon_url' => $icon_url
			);
			$menu_items[] = 'is_separator';
			$menu_items[] = array(
				'caption' => 'Остановить закачку всех файлов',
				'params' => array ('action' => 'transmissionActionFileStartStop', 'setAction' => 'files-unwanted', 'ids' => 'all'),
				'icon_url' => 'plugin_file://icons/s_stop.png'
			);
			$menu_items[] = array(
				'caption' => 'Запустить закачку всех файлов',
				'params' => array ('action' => 'transmissionActionFileStartStop', 'setAction' => 'files-wanted', 'ids' => 'all'),
				'icon_url' => 'plugin_file://icons/s_start.png'
			);
			$menu_items[] = 'is_separator';
			$menu_items[] = array(
				'caption' => 'Высокий приоритет' . $s,
				'params' => array ('action' => 'transmissionActionPriority', 'setAction' => 'priority-high'),
				'icon_url' => 'plugin_file://icons/s_file2.png'
			);
			$menu_items[] = array(
				'caption' => 'Нормальный приоритет' . $s,
				'params' => array ('action' => 'transmissionActionPriority', 'setAction' => 'priority-normal'),
				'icon_url' => 'plugin_file://icons/s_file4.png'
			);
			$menu_items[] = array(
				'caption' => 'Низкий приоритет' . $s,
				'params' => array ('action' => 'transmissionActionPriority', 'setAction' => 'priority-low'),
				'icon_url' => 'plugin_file://icons/s_file3.png'
			);
			$menu_items[] = 'is_separator';
			$menu_items[] = array(
				'caption' => 'Высокий приоритет для всех файлов',
				'params' => array ('action' => 'transmissionActionPriority', 'setAction' => 'priority-high', 'ids' => 'all'),
				'icon_url' => 'plugin_file://icons/s_file2.png'
			);
			$menu_items[] = array(
				'caption' => 'Нормальный приоритет для всех файлов',
				'params' => array ('action' => 'transmissionActionPriority', 'setAction' => 'priority-normal', 'ids' => 'all'),
				'icon_url' => 'plugin_file://icons/s_file4.png'
			);
			$menu_items[] = array(
				'caption' => 'Низкий приоритет для всех файлов',
				'params' => array ('action' => 'transmissionActionPriority', 'setAction' => 'priority-low', 'ids' => 'all'),
				'icon_url' => 'plugin_file://icons/s_file3.png'
			);
		}
		$menu_items[] = 'is_separator';
		if ($parent_media_url->screen_id != 'vod_transmissionupnp')
			$menu_items[] = array(
				'caption' => 'Перейти в Transmission BTC UPnP',
				'params' => array ('action' => 'screenTransmissionUPnP'),
				'icon_url' => 'plugin_file://icons/s_transmissionupnp.png'
			);
		
		$menu_items[] = array(
			'caption' => 'Настройки Transmission BTC UPnP',
			'params' =>  'classSetup',
			'icon_url' => 'plugin_file://icons/s_transmissionupnp.png'
		);

		return $menu_items;
	}
	public static function transmissionRpcAction (){
		if (self::$transmissionRPC == false){
			$login=$pass=null;
			// $transmissionAccount = (HD::getItemsArr('transmissionAccount', true) != array()) ? HD::getItemsArr('transmissionAccount', true) : array('login' => '', 'pass' => '');
			// if ($transmissionAccount['login'] != '')
				// $login=$transmissionAccount['login'];
			// if ($transmissionAccount['pass'] != '')
				// $pass=$transmissionAccount['pass'];
			self::$transmissionRPC = new TransmissionRPC(self::getTransmissionBtcIp() . "/transmission/rpc", $login, $pass);
		}
	}
	public static function getStats(){
		$result = HD::do_cmd('transmissionActions', 'action=sstats transmissionIp=' . self::getTransmissionBtcIp());
		if ($result == true)
			return json_decode($result);
		return false;
	}
	public static function setTransmissionActionPriority($torrent_id, $file_id){
		$result = HD::do_cmd('transmissionActions', "action=setPriorityHigh torrent_id=$torrent_id file_id=$file_id transmissionIp=" . self::getTransmissionBtcIp());
		if ($result == true)
			return json_decode($result);
		return false;
	}
	public static function getStatusString ($intstatus){
		self::transmissionRpcAction();
		return self::$transmissionRPC->getStatusString($intstatus);
	}
	public static function actionGetSessionInfo(){
		$result = HD::do_cmd('transmissionActions', 'action=sget transmissionIp=' . self::getTransmissionBtcIp());
		if ($result == true){
			$jsd = json_decode($result,true);
			if (isset($jsd['arguments']))
				self::$sessionInfo = $jsd['arguments'];
		}
		return false;
	}
	public function classAction ($defs, $user_input, $select_url = null){
		hd_restore_warnings();
		$caption = 'Error!';
		$msg = 'classAction: action';
		$post_action = null;
		$selected_media_url = (object)array();
		$parent_media_url = MediaURL::decode($user_input->parent_media_url);
		if ($user_input->action == 'addTransmissionUPnPTorrent'){
			$selected_media_url = MediaURL::decode($user_input->selected_media_url);
			if (isset($user_input->goToScreen)){
				if (!isset($selected_media_url->movie_id))
					return ActionFactory::invalidate_folders(array($user_input->parent_media_url));
				$mArr['movie_id'] = $selected_media_url->movie_id;
				$mArr['torrentId'] = $user_input->hash;
				$mArr['torrentClassName'] = 'TransmissionUPnP';
				$mArr['torrentSourseClassName'] = $selected_media_url->class_name;
				$mArr['class_name'] = $selected_media_url->class_name;
				$mArr['torrent_id'] = $selected_media_url->torrent_id;
				$mArr['tType'] = $selected_media_url->tType;
				$mArr['data']['id'] =  $selected_media_url->torrent_id;
				if (isset($selected_media_url->detailed_info))
					$mArr['detailed_info'] = $selected_media_url->detailed_info;
				if (isset($selected_media_url->description))
					$mArr['description'] = $selected_media_url->description;
				$mUrl = VodSeriesListScreen::get_media_url_str("TransmissionUPnP",$mArr);
				return ActionFactory::open_folder($mUrl, $selected_media_url->caption);	
			}
			if (isset($user_input->torrent_added)){
				ControlFactory::add_multiline_label($defs, '', $user_input->torrent_added_name, 15);
				$add_params['goToScreen'] = 1;
				$add_params['action'] = $user_input->action;
				$add_params['indiClass'] = 'TransmissionUPnP';
				$add_params['hash'] = $user_input->torrent_id;
				ControlFactory::add_close_dialog_and_apply_button($defs, $this, $add_params, $user_input->control_id, 'Ok', 450);
				ControlFactory::add_close_dialog_button($defs,'Добавить еще торрент', 450);
				return  ActionFactory::show_dialog('.torrent добавлен', $defs, true, 1000);
			}
			hd_silence_warnings();
			return TransmissionUPnP::transmissionActionAddTorrent($user_input);
		}
		if ($user_input->action == 'transmissionActionQueue'){
			$s = ''; $post_action=null;
			$selected_media_url = MediaURL::decode($user_input->selected_media_url);
			if (isset($user_input->ids)){
				self::transmissionRpcAction();
				foreach (json_decode ($user_input->ids) as $v)
						$ids[] = intval($v);
				$rpcAction = $user_input->rpcAction;
				$result = self::$transmissionRPC->$rpcAction($ids);
				if ($result->result == 'success')
					return ActionFactory::show_title_dialog('Выполнено', null, 'Результат выполнения может отобразится не сразу', 650);
				return ActionFactory::show_title_dialog('Err!', $post_action=null, 'Выполнение не удалось', 0);
			}
		}
		if ($user_input->action == 'actionReturn'){
			$i=0;
			HD::asyncExec('proc_close');
			do {
				$str = self::actionGetTorrentList();
				$i++;
				usleep(50000);
			} while (($i < 100)&&($str==false));
			return ActionFactory::close_and_run();
		}
		if ($user_input->action == 'transmissionAltSpeedEnabled'){
			self::transmissionRpcAction();
			$arguments['alt-speed-enabled'] = $user_input->rpcAction;
			$result = self::$transmissionRPC->sset($arguments);
			if ($result->result == 'success'){
				if (isset(self::$sessionInfo['alt_speed_enabled']))
					unset (self::$sessionInfo['alt_speed_enabled']);
				else
					self::$sessionInfo['alt_speed_enabled'] = 1;
				self::actionGetSessionInfo();
				return ActionFactory::show_title_dialog('Выполнено', null, 'Результат выполнения может отобразится не сразу', 650);
			}
			return ActionFactory::show_title_dialog('Err!', $post_action=null, 'Выполнение не удалось', 0);
		}
		if ($user_input->action == 'transmissionActionPriority'){
			$s = '';
			$selected_media_url = MediaURL::decode($user_input->selected_media_url);
			if (isset($selected_media_url->file_info->torrent_id))
				$ids[] = intval($selected_media_url->file_info->torrent_id);
			if (isset($user_input->setAction)){
				if (isset($user_input->ids)){
					if ($user_input->ids == 'all')
						foreach (self::$torrentItemsArr as $v)
							$arguments[$user_input->setAction][] = intval($v);
					else
						foreach (json_decode ($user_input->ids) as $v)
							$arguments[$user_input->setAction][] = intval($v);
				}else if ($select_url==true){
					foreach ($select_url as $v){
						$media_url = MediaURL::decode($v);
						if (isset($media_url->file_info->file_id)){
							$arguments[$user_input->setAction][] = intval($media_url->file_info->file_id);
						}
					}
				}else
					$arguments[$user_input->setAction][] = intval($selected_media_url->file_info->file_id);

				self::transmissionRpcAction();
				$result = self::$transmissionRPC->set($ids, $arguments);
				if ($result->result == 'success')
					return ActionFactory::show_title_dialog('Выполнено', null, 'Результат выполнения может отобразится не сразу', 650);
				return ActionFactory::show_title_dialog('Err!', $post_action=null, 'Выполнение не удалось', 0);
			}

			if (isset($selected_media_url->id)){
				if ($select_url==true){
					foreach ($select_url as $v){
						$media_url = MediaURL::decode($v);
						if (isset($media_url->id))
							$idArr[] = $media_url->id;
						$s = ' (выделенно '.count ($idArr).')';
					}
				}else
					$idArr[] = $selected_media_url->id;
				$jIdArr = json_encode($idArr);
				$menu_items[] = array(
					'caption' => 'Высокий приоритет' . $s,
					'params' => array ('action' => $user_input->action, 'setAction' => 'priority-high', 'ids' => $jIdArr),
					'icon_url' => 'plugin_file://icons/s_file2.png'
				);
				$menu_items[] = array(
					'caption' => 'Нормальный приоритет' . $s,
					'params' => array ('action' => $user_input->action, 'setAction' => 'priority-normal', 'ids' => $jIdArr),
					'icon_url' => 'plugin_file://icons/s_file4.png'
				);
				$menu_items[] = array(
					'caption' => 'Низкий приоритет' . $s,
					'params' => array ('action' => $user_input->action, 'setAction' => 'priority-low', 'ids' => $jIdArr),
					'icon_url' => 'plugin_file://icons/s_file3.png'
				);
				$menu_items[] = 'is_separator';
				foreach ($menu_items as $v){
					if ($v == 'is_separator')
						$m_i [] =  array(
						GuiMenuItemDef::is_separator => true,);
					else
						$m_i[] = array(
							GuiMenuItemDef::caption => $v['caption'],
							GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'classAction', $v['params']),
							GuiMenuItemDef::icon_url => $v['icon_url'],
						);
				}
				$m_i[] = array(
					GuiMenuItemDef::caption => 'Выделить (Select)',
					GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'select'),
					GuiMenuItemDef::icon_url => 'plugin_file://icons/s_select.png',
				);
				$m_i[] = array(
					GuiMenuItemDef::caption => 'Снять выделение (Clear)',
					GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'unselect'),
					GuiMenuItemDef::icon_url => 'plugin_file://icons/s_unselect.png',
				);
				return ActionFactory::show_popup_menu($m_i);
			}else
				return ActionFactory::show_title_dialog('Err!');
		}
		if ($user_input->action == 'transmissionActionFileStartStop'){
			$s = '';
			$selected_media_url = MediaURL::decode($user_input->selected_media_url);
			
			if (isset($selected_media_url->file_info->torrent_id))
				$ids[] = intval($selected_media_url->file_info->torrent_id);
				
			if ($select_url==true){
				foreach ($select_url as $v){
					$media_url = MediaURL::decode($v);
					if (isset($media_url->file_info->file_id)){
						if ($media_url->file_info->wanted == 1)
							$cmd = 'files-unwanted';
						else
							$cmd = 'files-wanted';
						$arguments[$cmd][] = intval($media_url->file_info->file_id);
					}
				}
			}else if ((isset($user_input->ids))&&($user_input->ids == 'all')){
				$cmd = $user_input->setAction;
				foreach (self::$torrentItemsArr as $v)
					$arguments[$cmd][] = intval($v);
			}else{
				if ($selected_media_url->file_info->wanted == 1)
					$cmd = 'files-unwanted';
				else
					$cmd = 'files-wanted';
				$arguments[$cmd][] = intval($selected_media_url->file_info->file_id);
			}
			self::transmissionRpcAction();
			$result = self::$transmissionRPC->set($ids, $arguments);
			if ($result->result == 'success')
				return ActionFactory::show_title_dialog('Выполнено', null, 'Результат выполнения может отобразится не сразу', 650);
			return ActionFactory::show_title_dialog('Err!', $post_action=null, 'Выполнение не удалось', 0);
			
		}
		if ($user_input->action == 'transmissionActionStartStop'){
			$s = '';
			$selected_media_url = MediaURL::decode($user_input->selected_media_url);
			if (isset($user_input->ids)){
				self::transmissionRpcAction();
				if ($user_input->ids == 'all'){
					foreach ($this->torrentArr as $v)
						$ids[] = intval($v);
				}else
					foreach (json_decode ($user_input->ids) as $v)
						$ids[] = intval($v);
				
				$rpcAction = $user_input->rpcAction;
				$result = self::$transmissionRPC->$rpcAction($ids);
				if ($result->result == 'success')
					return ActionFactory::show_title_dialog('Выполнено', null, 'Результат выполнения может отобразится не сразу', 650);
				return ActionFactory::show_title_dialog('Err!', $post_action=null, 'Выполнение не удалось', 0);
			}
			if (isset($selected_media_url->movie_id)){
				if ($select_url==true){
					foreach ($select_url as $v){
						$media_url = MediaURL::decode($v);
						if (isset($media_url->data->id))
							$idArr[] = $media_url->data->id;
						$s = ' (выделенно '.count ($idArr).')';
					}
				}else
					$idArr[] = $selected_media_url->data->id;
				$jIdArr = json_encode($idArr);
				$menu_items[] = array(
					'caption' => 'Остановить торрент' . $s,
					'params' => array ('action' => $user_input->action, 'rpcAction' => 'stop', 'ids' => $jIdArr),
					'icon_url' => 'plugin_file://icons/s_stop.png'
				);
				$menu_items[] = array(
					'caption' => 'Остановить все торренты',
					'params' => array ('action' => $user_input->action, 'rpcAction' => 'stop', 'ids' => 'all'),
					'icon_url' => 'plugin_file://icons/s_stop.png'
				);
				$menu_items[] = 'is_separator';
				if (isset(self::$sessionInfo['version'])){
					$caption = 'Использовать альтернативные скорости';
					$rpcAction = 'true';
					$icon_url = 'plugin_file://icons/s_tortuga.png';
					if (isset(self::$sessionInfo['alt_speed_enabled'])){
						$caption = 'Не использовать альтернативные скорости';
						$rpcAction = 'false';
						$icon_url = 'plugin_file://icons/s_tortugas.png';
					}
					$menu_items[] = array(
						'caption' => $caption,
						'params' => array ('action' => 'transmissionAltSpeedEnabled', 'rpcAction' => $rpcAction),
						'icon_url' => $icon_url
					);
					$menu_items[] = 'is_separator';
				}
				$menu_items[] = array(
					'caption' => 'Запустить торрент' . $s,
					'params' => array ('action' => $user_input->action, 'rpcAction' => 'start', 'ids' => $jIdArr),
					'icon_url' => 'plugin_file://icons/s_start.png'
				);
				$menu_items[] = array(
					'caption' => 'Запустить все торренты',
					'params' => array ('action' => $user_input->action, 'rpcAction' => 'start', 'ids' => 'all'),
					'icon_url' => 'plugin_file://icons/s_start.png'
				);
				$menu_items[] = 'is_separator';
				
				foreach ($menu_items as $v){
					if ($v == 'is_separator')
						$m_i [] =  array(
						GuiMenuItemDef::is_separator => true,);
					else
						$m_i[] = array(
							GuiMenuItemDef::caption => $v['caption'],
							GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'classAction', $v['params']),
							GuiMenuItemDef::icon_url => $v['icon_url'],
						);
				}
				$m_i[] = array(
					GuiMenuItemDef::caption => 'Выделить (Select)',
					GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'select'),
					GuiMenuItemDef::icon_url => 'plugin_file://icons/s_select.png',
				);
				$m_i[] = array(
					GuiMenuItemDef::caption => 'Снять выделение (Clear)',
					GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'unselect'),
					GuiMenuItemDef::icon_url => 'plugin_file://icons/s_unselect.png',
				);
				return ActionFactory::show_popup_menu($m_i);
			}else
				return ActionFactory::show_title_dialog('Err!');
		}
		if ($user_input->action == 'transmissionActionRemove'){
			$s = "";
			$selected_media_url = MediaURL::decode($user_input->selected_media_url);
			if ($select_url==true){
				foreach ($select_url as $v){
					$media_url = MediaURL::decode($v);
					if (isset($media_url->data->id))
						$idArr[] = $media_url->data->id;
					$c = count ($idArr);
					$s = " (выделенно $c)";
				}
			}else if (isset($selected_media_url->data->id))
				$idArr[] = $selected_media_url->data->id;
			else if (isset($selected_media_url->file_info->torrent_id))
				$idArr[] = $selected_media_url->file_info->torrent_id;
				
			$jIdArr = json_encode($idArr);
			$menu_items[] = array(
				'caption' => 'Удалить торрент' . $s,
				'params' => array ('action' => 'transmissionActionRem', 'ids' => $jIdArr),
				'icon_url' => 'plugin_file://icons/s_delete.png'
			);
			$menu_items[] = array(
				'caption' => 'Удалить торрент и файлы' . $s,
				'params' => array ('action' => 'transmissionActionRem', 'ids' => $jIdArr, 'delete_local_data' => true),
				'icon_url' => 'plugin_file://icons/s_delete.png'
			);
			$menu_items[] = 'is_separator';
			foreach ($menu_items as $v){
				if ($v == 'is_separator')
					$m_i [] =  array(
					GuiMenuItemDef::is_separator => true,);
				else
					$m_i[] = array(
						GuiMenuItemDef::caption => $v['caption'],
						GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'classAction', $v['params']),
						GuiMenuItemDef::icon_url => $v['icon_url'],
					);
			}
			$m_i[] = array(
				GuiMenuItemDef::caption => 'Выделить (Select)',
				GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'select'),
				GuiMenuItemDef::icon_url => 'plugin_file://icons/s_select.png',
			);
			$m_i[] = array(
				GuiMenuItemDef::caption => 'Снять выделение (Clear)',
				GuiMenuItemDef::action => UserInputHandlerRegistry::create_action($this, 'unselect'),
				GuiMenuItemDef::icon_url => 'plugin_file://icons/s_unselect.png',
			);
			return ActionFactory::show_popup_menu($m_i);
		}
		
		if ($user_input->action == 'transmissionActionRem'){
			$selected_media_url = MediaURL::decode($user_input->selected_media_url);
			if (isset($user_input->ids)){
				$delete_local_data = 0;
				if (isset($user_input->delete_local_data))
					$delete_local_data = 1;
				$cmdAsyncExec = DuneSystem::$properties['install_dir_path'] . '/www/cgi-bin/php-cgi -f ' .  DuneSystem::$properties['install_dir_path'] . "/www/cgi-bin/transmissionActions.php action=remove ids=".$user_input->ids." delete_local_data=".$delete_local_data." transmissionIp=" . self::getTransmissionBtcIp();
				// $transmissionAccount = (HD::getItemsArr('transmissionAccount', true) != array()) ? HD::getItemsArr('transmissionAccount', true) : array('login' => '', 'pass' => '');
				// if (($transmissionAccount['login'] != '')&&($transmissionAccount['pass'] != ''))
					// $cmdAsyncExec .= " action=get login=". $transmissionAccount['login'] ." pass=" . $transmissionAccount['pass'];
				$str = HD::asyncExec($cmdAsyncExec);
				if ($str != ''){
					self::actionGetTorrentList();
					if ($parent_media_url->screen_id == "vod_series")
						return ActionFactory::replace_path(1, null, $action);
					return ActionFactory::show_title_dialog('Удалено', null, 'Результат удаления может отобразится не сразу', 650);
				}else{
					if (isset($user_input->counter))
						$counter = $user_input->counter + 1;
					else
						$counter = 1;
					$params['counter'] = $counter;
					$params['action'] = 'transmissionActionRem';
					$params['ids'] = $user_input->ids;
					if (isset($user_input->delete_local_data))
						$params['delete_local_data'] = $user_input->delete_local_data;
					$action = UserInputHandlerRegistry::create_action($this, 'classAction', $params);
					$attrs['timer'] = ActionFactory::timer(1000);
					$attrs['actions'] = array(GUI_EVENT_TIMER => ActionFactory::close_dialog_and_run($action));
					ControlFactory::add_label($defs, '', "Прошло : " . HD::sec_format_duration($params['counter']));
					return  ActionFactory::show_dialog('Удаление', $defs, true, 0, $attrs);
				}
			}else
				return ActionFactory::show_title_dialog('Err!');
		}
		if ($user_input->action == 'screenTransmissionUPnP'){
			TransmissionUPnP::actionGetTorrentList();
			return ActionFactory::open_folder(VodTransmissionUPnPScreen::get_media_url_str($parent_media_url->class_name), 'Transmission BTC UPnP');
		}
		return ActionFactory::show_title_dialog($caption, $post_action, $msg, 0);
	}
	public static function load_movie($movie_id, $mUrl, $getMovieInfo){
		if (isset(self::$transmissionUPnPItems[$movie_id]))
			return self::$transmissionUPnPItems[$movie_id];
		else
			return false;
	}
	public static function set_movie($movie_id, $obj){
		self::$transmissionUPnPItems[$movie_id] = (array)$obj;
	}
	
	public static function get_series_list($media_url, $movie){
		if (isset($media_url->torrentId)){
			$torrentObj = TransmissionUPnP::actionGetTorrentFileList($media_url->torrentId);
			if ($torrentObj == false)
				return 'addTorrent';
		}else
			$torrentObj = TransmissionUPnP::actionGetTorrentFileList($media_url->data->id);
		if ($torrentObj == true){
			self::$torrentItemsArr = $items = array();
			if (!isset($torrentObj->arguments->torrents[0]->files))
				return $items;
			foreach ($torrentObj->arguments->torrents[0]->files as $id => $file){
				$path_parts = pathinfo($file->name);
				$title = $path_parts['basename'];
				if (((isset($path_parts['extension']))&&(!preg_match("/mp3|wav|og(?:g|a)|flac|dts|ac3|rm|aac|wma|mka|ape|mpeg|ra?m|avi|mp(?:g|e|4)|mov|divx|asf|qt|wmv|m\dv|rv|vob|asx|ogm|mkv|m2ts|ts/i",$path_parts['extension'])))||(!isset($path_parts['extension'])))
					continue;
				self::$torrentItemsArr[] = $id;
				$size = HD::readableBytes($file->length);
				$detailed_info = '';
				$detailed_info .= '||Загружено: ';
				$percent = 0;
				if (isset($file->bytesCompleted))
					$percent = round((floatval($file->bytesCompleted) / floatval($file->length) ) * 100);
					$detailed_info .=  $percent . '%';
				if (isset($file->bytesCompleted))
					$detailed_info .= '|' . HD::readableBytes($file->bytesCompleted);
				if (isset($file->length))
					$detailed_info .= '|из ' . $size;
				$items[$title]['id'] = md5 ($title);
				$items[$title]['title'] = $title;
				$items[$title]['playback_url'] = self::getIp() . "/torrent/".$media_url->movie_id."/$id." . $path_parts['extension'];
				$items[$title]['is_stream_url'] = true;
				$items[$title]['file_info']['poster_url'] = $movie->poster_url;
				$items[$title]['file_info']['class_name'] = $media_url->class_name;
				$items[$title]['file_info']['size'] = $size;
				$items[$title]['file_info']['file_id'] = $id;
				$items[$title]['file_info']['torrent_id'] = $torrentObj->arguments->torrents[0]->id;
				$items[$title]['file_info']['details_box_width'] = true;
				$icon_path = 'plugin_file://icons/ss_file4.png';
				foreach($torrentObj->arguments->torrents[0]->priorities as $idx => $vdx)
					$priorities[$idx] = $vdx;
				if (isset($priorities[$id])){
					if ($priorities[$id] == 1){
						$icon_path = 'plugin_file://icons/ss_file2.png';
						$detailed_info .= '||Приоритет:|высокий';
						$items[$title]['file_info']['priorities'] = 'h';
					}
					if ($priorities[$id] == -1){
						$icon_path = 'plugin_file://icons/ss_file3.png';
						$detailed_info .= '||Приоритет:|низкий';
						$items[$title]['file_info']['priorities'] = 'l';
					}
				}else{
					$icon_path = 'plugin_file://icons/ss_file4.png';
					$detailed_info .= '||Приоритет:|нормальный';
					$items[$title]['file_info']['priorities'] = 'm';
				}
				
				if (!isset($torrentObj->arguments->torrents[0]->fileStats[$id]->wanted)){
					$items[$title]['file_info']['wanted'] = 0;
					$icon_path = 'plugin_file://icons/ss_file1.png';
					$detailed_info .= '|не загружать';
				}else
					$items[$title]['file_info']['wanted'] = 1;
				if ($percent == 100)
					$icon_path = 'plugin_file://icons/ss_file.png';
				$items[$title]['file_info']['percent'] = $percent;	
				$items[$title]['file_info']['stiker_img'] = $icon_path;		
				$items[$title]['file_info']['detailed_info'] = $detailed_info;
			}
			ksort($items);
			return $items;
		}else return array();
	}
	public static function actionGetTorrentList(){
		$cmdAsyncExec = DuneSystem::$properties['install_dir_path'] . '/www/cgi-bin/php-cgi -f ' .  DuneSystem::$properties['install_dir_path'] . "/www/cgi-bin/transmissionActions.php action=get transmissionIp=" . self::getTransmissionBtcIp();
		$str = HD::asyncExec($cmdAsyncExec);
		if (!empty($str)){
			if ($str == '[]')
				return true;
			return json_decode ($str);
		}
		return false;
	}
	public static function actionGetTorrentFileList($transmissionId){
		$cmdAsyncExec = DuneSystem::$properties['install_dir_path'] . '/www/cgi-bin/php-cgi -f ' .  DuneSystem::$properties['install_dir_path'] . "/www/cgi-bin/transmissionActions.php action=getFile transmissionId=$transmissionId transmissionIp=" . self::getTransmissionBtcIp();
		$transmissionAccount = (HD::getItemsArr('transmissionAccount', true) != array()) ? HD::getItemsArr('transmissionAccount', true) : array('login' => '', 'pass' => '');
		if (($transmissionAccount['login'] != '')&&($transmissionAccount['pass'] != ''))
			$cmdAsyncExec .= " login=". urlencode($transmissionAccount['login']) ." pass=" . urlencode($transmissionAccount['pass']);
		$str = HD::asyncExec($cmdAsyncExec);
		if (!empty($str)){
			if ($str == '[]')
				return true;
			return json_decode ($str);
		}
		return false;
	}
	public static function getScreenActionMapArr ($parent_media_url){
		$actionsArr[0]['create_action'] = 'classAction';
		$actionsArr[0]['params'] = array ('action' => 'transmissionActionRemove');
		$actionsArr[0]['caption'] = 'Удалить';
		$actionsArr[0]['key'] = GUI_EVENT_KEY_D_BLUE;
		$actionsArr[0]['create_action'] = 'classAction';
		$actionsArr[0]['params'] = array ('action' => 'actionReturn', 'indiClass' => 'TransmissionUPnP');
		$actionsArr[0]['key'] = GUI_EVENT_KEY_RETURN;
		return $actionsArr;
	}
	public static function getTransmissionBTCPackageName(){
		$package = false;
		$jsd = json_decode(file_get_contents('/tmp/applications/app_data.json'));
		foreach ($jsd->applications as $v){
			if (preg_match('|transmission\.btc|', $v->package_name)){
				$package['name'] = $v->package_name;
				$package['activity'] = $v->activity;
				break;
			}
		}
		return $package;
	}
	public function meinMenuOpenFolderDialog(&$user_input, &$plugin_cookies){
		hd_restore_warnings();
		if (isset($user_input->openTransmissionBTCApp)){
			sleep (2);
			$package = self::getTransmissionBTCPackageName();
			if ($package != false){
				exec ("am start " . $package['name'] . "/" . $package['activity'] . " 2>&1");
				return null;
			}else
				return ActionFactory::show_title_dialog( 'Андроид приложение TransmissionBTC не найдено');
		}
		if (isset($user_input->dontAsk))
			$plugin_cookies->transmissionBTCAsk = 1;
		if (isset($user_input->install)){
			$add_params['openTransmissionBTCApp'] = true;
			$post_action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $add_params);
			$jsd = json_decode(HD::http_get_document('https://api.github.com/repos/AndreyPavlenko/transmissionbtc/releases/latest'));
			$download_url = false;
			if (isset($jsd->assets)){
				foreach ($jsd->assets as $v){
					if (preg_match('|armeabi|', $v->browser_download_url)){
						$download_url = $v->browser_download_url;
						break;
					}
				}
			}
			if ($download_url == true)
				return ActionFactory::download_and_install_apk('Transmission BTC', 'com.ap.transmission.btc', array($download_url), false, $post_action);
			else
				return ActionFactory::show_title_dialog('Установка не удалась!');
		}
		$transmissionBTCAsk = isset($plugin_cookies->transmissionBTCAsk) ? $plugin_cookies->transmissionBTCAsk : 0;
		if ($transmissionBTCAsk === 0){
			$title = 'Установить андроид приложение TransmissionBTC?';
			$add_params['install'] = true;
			$yes_action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $add_params);
					
			$add_params1['dontAsk'] = true;
			$yes_action1 = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $add_params1);
			$msgs1[] = "Позднее TransmissionBTC можно уcтановить через настройки плагина или из apk файла";
			$no_action = ActionFactory::show_yes_no_dialog('Больше не спрашивать?', $yes_action1, true, $msgs1, false, 980);
					
			$msgs[] = "TransmissionBTC необходим для закачки торрентов";
			$msgs[] = "После установки андроидного приложения TransmissionBTC необходимо настроить папки для зигрузки в настройках андроидного приложения TransmissionBTC и запустить его";
			return ActionFactory::show_yes_no_dialog($title, $yes_action, true, $msgs, $no_action, 980);
		}
		$action = UserInputHandlerRegistry::create_action($this, 'classSetupTransmissionUPnP');
		return ActionFactory::show_title_dialog('Transmission BTC не запущен', $action, self::getIp(), 0);
	}
}
?>