<?
class Compilations_Class {
	static $cName = 'Подборки';
	static $className = 'Compilations_Class';
	public static function get_media_url_str($k, $arr=null){
		if ($arr == true)
			return SmartVodCategoryListScreen::get_media_url_str($k, $arr);
		return SmartVodCategoryListScreen::get_media_url_str($k);
	}
	public static function getMainMenuInfo(){
		return array (
			'name' => self::$cName,
			'descr' => '||'.self::$cName.'|подборки фильмов'
		);
	}
	public static function getPopUpMenuItems ($selected_media_url, $parent_media_url){
		$menu_items = array();
		$parent_media_url = MediaURL::decode($parent_media_url);
		if ((isset($parent_media_url->screen_id))&&($parent_media_url->screen_id != 'vod_series')){
			$menu_items[] = array(
				'caption' => 'Добавить в Главное меню',
				'params' => array ('action' => 'addToMainMenu'),
				'icon_url' => SmartConfig::getPluginIco('s_home')
			);
		}
		return $menu_items;
	}
	public static function getVodCategories($media_url){
		$categories['categories'][] = array('id'=> 'ivi', 'class' => 'SmartVodRectangleListScreen', 'caption' => 'Подборки IVI', 'description' => 'карточка видео подбирается по названию - возможны не точности. Для исправления используйте Задать/испрвить id кинопоиска.');
		$categories['categories'][] = array('id'=> 'okko', 'class' => 'SmartVodRectangleListScreen', 'caption' => 'Подборки OKKO', 'description' => 'карточка видео подбирается по названию - возможны не точности. Для исправления используйте Задать/испрвить id кинопоиска.');
		return $categories['categories'];
	}
	public static function getScreenActionMapArr($media_url){
		$actionsArr = array();
		if (isset($media_url->searchStr))
			return $actionsArr;
		return $actionsArr;
	}
	public function classAction ($defs, $user_input, $select_url = null){
		hd_restore_warnings();
		$post_action = null;
		$caption = 'Error!';
		$msg = 'classAction: action';
		$width = 1050;
		if (isset($user_input->selected_media_url))
			$selected_media_url = MediaURL::decode($user_input->selected_media_url);
		$class_name = $selected_media_url->class_name;
		$parent_media_url = MediaURL::decode($user_input->parent_media_url);
		return ActionFactory::show_title_dialog($caption, $post_action, $msg, 0);
	}
	public static function parseOkkoCompilationsPage($jsd){
		$items = array();
		foreach ($jsd as $v){
			$v = $v->element;
			$caption = $v->name;
			if ($v->originalName != '')
				$caption_original = $v->originalName;
			$short_movie = new ShortMovie(
				strval($v->alias),
				strval($caption),
				strval(self::http_get_img($v->basicCovers->items[0]->url . '?width=300&scale=1&quality=80&mediaType=jpeg'))
			);
			$short_movie->info = '||' . $caption . '|' . $v->type;
			$short_movie->goToScreen = 'SmartVodListScreen';
			$short_movie->argument = "okko";
			array_push ($items, $short_movie);
		}
		return $items;
	}
	public static function parseIviCompilationsPage($jsd){
		$items = array();
		foreach ($jsd as $v){
			if (isset($v->title))
				$caption = $v->title;
			if ($v->title_eng != '')
				$caption_original = $v->title_eng;
			if (isset($v->images[0]->path))
				$img = $v->images[0]->path;
			$short_movie = new ShortMovie(
				strval($v->id),
				strval($caption),
				strval(self::http_get_img($img))
			);
			$short_movie->info = '||' . $caption . '|' . $v->object_type;
			$short_movie->goToScreen = 'SmartVodListScreen';
			$short_movie->argument = "ivi";
			array_push ($items, $short_movie);
		}
		return $items;
	}
	public static function parseOkkoCompilation2Page($jsd){
		$items = array();
		foreach ($jsd as $v){
			
			$v = $v->element;
			$caption = $v->name;
			if ($v->originalName != '')
				$caption_original = $v->originalName;
			$img = $v->basicCovers->items[0]->url;
			foreach($v->basicCovers->items as $v1)
				if ($v1->imageType == 'PORTRAIT')
					$img = $v1->url;
			
			$short_movie = new ShortMovie(
				strval($v->alias),
				strval($caption),
				strval(self::http_get_img($img . '?width=300&scale=1&quality=80&mediaType=jpeg'))
			);
			$short_movie->info = '||' . $caption . '|' . $caption_original .'|' . $v->type;
			$short_movie->caption = $caption;
			$short_movie->caption_original = $caption_original;
			$short_movie->argument = "okko";
			array_push ($items, $short_movie);
		}
		return $items;
	}
	public static function parseIviCompilation2Page($jsd){
		$items = array();
		foreach ($jsd as $v){
			$caption = $v->title;
			$caption_original = $v->orig_title;
			$short_movie = new ShortMovie(
				strval($v->id),
				strval($caption),
				strval(self::http_get_img($v->poster_originals[0]->path . '/300x456/'))
			);
			$rating = 'n/a';
			if (isset($v->rating->ready->main))
				$rating = $v->rating->ready->main;
			
			$short_movie->info = '||' . $caption . 
			'|' . $caption_original . 
			'||' . $v->year . 
			'|IVI Rating: ' . $v->ivi_rating_10 . 
			'|Rating: ' . $rating;
			$short_movie->caption = $caption;
			$short_movie->caption_original = $caption_original;
			$short_movie->year = $v->year;
			array_push ($items, $short_movie);
		}
		return $items;
	}
	public static function getShortMovieRange ($media_url, &$m_feed){
		if ($m_feed === 'end')
			return array();
		if ($media_url->categoryId == "okko"){
			$url = "https://ctx.playfamily.ru/screenapi/v1/noauth/collection/web/1?elementAlias=collections_web&elementType=COLLECTION&limit=20&offset=".($m_feed * 20 )."&withInnerCollections=true&includeProductsForUpsale=false&filter=%7B%22sortType%22%3A%22RANK%22%2C%22sortOrder%22%3A%22ASC%22%2C%22useSvodFilter%22%3Afalse%2C%22genres%22%3A%5B%5D%2C%22yearsRange%22%3Anull%2C%22rating%22%3Anull%7D";
			$jsd = json_decode (HD::http_get_document($url));
			if (!isset($jsd->element->collectionItems->items)){
				$m_feed = 'end';
				return array();
			}else
				++$m_feed;
			return self::parseOkkoCompilationsPage($jsd->element->collectionItems->items);
		}
		if ($media_url->categoryId == "ivi"){
			$url = "https://api.ivi.ru/mobileapi/collections/v5/?app_version=870&from=".($m_feed * 20 )."&tags_exclude=goodmovies&to=" . ((($m_feed +1) * 20 ) - 1);
			$jsd = json_decode (HD::http_get_document($url));
			if (!isset($jsd->result)){
				$m_feed = 'end';
				return array();
			}else
				++$m_feed;
			return self::parseIviCompilationsPage($jsd->result);
		}
		if ((isset($media_url->argument))&&($media_url->argument == 'ivi')){
			$url = "https://api.ivi.ru/mobileapi/collection/catalog/v5/?id=".$media_url->categoryId."&withpreorderable=true&fake=false&from=0&to=19&sort=priority_in_collection&fields=id%2Civi_pseudo_release_date%2Corig_title%2Ctitle%2Cfake%2Cpreorderable%2Cavailable_in_countries%2Chru%2Cposter_originals%2Crating%2Ccontent_paid_types%2Ccompilation_hru%2Ckind%2Cadditional_data%2Crestrict%2Chd_available%2Chd_available_all%2C3d_available%2C3d_available_all%2Cuhd_available%2Cuhd_available_all%2Chdr10_available%2Chdr10_available_all%2Cdv_available%2Cdv_available_all%2Cfullhd_available%2Cfullhd_available_all%2Chdr10plus_available%2Chdr10plus_available_all%2Chas_5_1%2Cshields%2Cseasons_count%2Cseasons_content_total%2Cseasons%2Cepisodes%2Cseasons_description%2Civi_rating_10_count%2Cseasons_extra_info%2Ccount%2Cgenres%2Cyears%2Civi_rating_10%2Crating%2Ccountry%2Cduration_minutes%2Cyear&app_version=870";
			$jsd = json_decode (HD::http_get_document($url));
			$m_feed = 'end';
			return self::parseIviCompilation2Page($jsd->result);
		}
		if ((isset($media_url->argument))&&($media_url->argument == 'okko')){
			$url = "https://ctx.playfamily.ru/screenapi/v1/noauth/collection/web/1?elementAlias=".$media_url->categoryId."&elementType=COLLECTION&limit=20&offset=".($m_feed * 20 )."&withInnerCollections=true&includeProductsForUpsale=false&filter=%7B%22sortType%22%3A%22RANK%22%2C%22sortOrder%22%3A%22ASC%22%2C%22useSvodFilter%22%3Afalse%2C%22genres%22%3A%5B%5D%2C%22yearsRange%22%3Anull%2C%22rating%22%3Anull%7D";
			$jsd = json_decode (HD::http_get_document($url));
			if (count($jsd->element->collectionItems->items) != 20)
				$m_feed = 'end';
			else
				++$m_feed;
			return self::parseOkkoCompilation2Page($jsd->element->collectionItems->items);
		}
		return null;
	}
	public static function load_movie($movie_id, $mUrl, $getMovieInfo){
		if (isset($mUrl->argument)){
			$url = "https://ctx.playfamily.ru/screenapi/v1/noauth/moviecard/web/1?elementAlias=$movie_id&elementType=MOVIE";
			$jsd = json_decode (HD::http_get_document($url));
			$mUrl->year = date('Y', strtotime($jsd->element->extraAttributes->release_date_imdb));
			$arr['class_info']['dbIDs']['imdbID'] = $jsd->element->extraAttributes->imdb_id;
		}
		$arr['class_info']['catalog_info']['caption'] = $mUrl->caption;
		$arr['class_info']['catalog_info']['poster_url'] = $mUrl->poster_url;
		if (isset($mUrl->caption_original))
			$arr['class_info']['catalog_info']['caption_original'] = $mUrl->caption_original;
		if (isset($mUrl->year))
			$arr['class_info']['catalog_info']['year'] = $mUrl->year;
		
		$kpID = Kinopoisk_Class::searchKpId ($mUrl->caption, $mUrl->caption_original, $mUrl->year, $movie_id);
		if ($kpID == true){
			$arr['class_info']['dbIDs']['kpID'] = $kpID;
			$jsd = Kinopoisk_Class::get_id_info($kpID);
			if ($jsd->nameRU != '')
				$arr['caption_original'] = $arr['caption'] = $jsd->nameRU;
			else if ($jsd->nameEN != '')
				$arr['caption_original'] = $arr['caption'] = $jsd->nameEN;
			if ($jsd->nameEN != '')
				$arr['caption_original'] = $jsd->nameEN;
			$arr['description'] = $jsd->description;
			$arr['poster_url'] = Kinopoisk_Class::http_get_img("http://st.kp.yandex.net/images/film_iphone/iphone360_$kpID.jpg&rPath=". $mUrl->poster_url);
			$arr['country'] = $jsd->country;
			if (preg_match("|-|",$jsd->year))
				$arr['country'] .= ', '.$jsd->year;
			else
				$arr['year'] = $jsd->year;
			if (isset ($jsd->genre))
				$arr['genres'] = $jsd->genre;
			if (isset ($jsd->ratingData->ratingIMDb))
				$arr['rate_imdb'] = $jsd->ratingData->ratingIMDb;
			if (isset ($jsd->ratingData->rating))
				$arr ['rate_kinopoisk'] = $jsd->ratingData->rating;
			if (isset ($jsd->filmLength)){
				$length = $jsd->filmLength;
				if (preg_match("/(\d*):(\d\d)/i", $length, $tmp))
					$length = ($tmp[1]*60+$tmp[2]);
				$arr ['length'] = $length;
			}
			if (isset ($jsd->creators[0])){
				foreach ($jsd->creators[0] as $v){
					if ((isset ($v->nameEN))&&($v->nameEN != ''))
						$name_r[] = $v->nameRU .' ('.$v->nameEN.')';
					else
						$name_r[] = $v->nameRU;
					if (count($name_r) > 1)
						$arr['director'] = implode(', ', $name_r);
					else
						$arr['director'] = $name_r[0];
				}
			}
			if (isset ($jsd->creators[1])){
				$name_r = array();
				foreach ($jsd->creators[1] as $v){
					if ((isset ($v->nameEN))&&($v->nameEN != ''))
						$name_r[] = $v->nameRU .' ('.$v->nameEN.')';
					else
						$name_r[] = $v->nameRU;
					if (count($name_r) > 1)
						$arr['actors'] = implode(', ', $name_r);
					else
						$arr['actors'] = $name_r[0];
				}
			}
			if (isset ($jsd->creators[2])){
				$name_r = array();
				foreach ($jsd->creators[2] as $v){
					if ((isset ($v->nameEN))&&($v->nameEN != ''))
						$name_r[] = $v->nameRU .' ('.$v->nameEN.')';
					else
						$name_r[] = $v->nameRU;
					if (count($name_r) > 1)
						$arr ['details']['Продюсеры:'] = implode(', ', $name_r);
					else
						$arr ['details']['Продюсеры:'] = $name_r[0];
				}
			}
			if (isset ($jsd->gallery)){
				foreach ($jsd->gallery as $key => $vel){
					if ($key=='poster')
						continue;
					foreach ($vel as $v)
						$arr ['background_urls'][] = "http://st.kp.yandex.net/images/". $v->image;
				}
			}
			if (isset ($jsd->slogan))
				$arr ['details']["Слоган:"] = wordwrap($jsd->slogan, 75, "\n");
			
			if (isset ($jsd->budgetData->budget))
				$arr ['budget'] = str_replace(array ('$', ' '),"", $jsd->budgetData->budget);
			if (isset($jsd->videoURL)){
				foreach ($jsd->videoURL as $k => $v){
					$arr['class_info']['trailers'][$v] = array(
						'name' => "Kinopoisk $k",
						'url' => $v
					);
				}
			}
			if ($getMovieInfo == 'max'){
				if ((isset($jsd->type))&&($jsd->type == 'KPSerial')){
					$arr['is_serial']= 1;
					$jsd = VideoInfo::search_myshows_info($arr['caption_original'], $movie_id);
					if (isset($jsd->id)){
						$arr['class_info']['dbIDs']['myShowsID'] = $jsd->id;
						if ($jsd->rating != '')
							$arr ['rate_details']['MyShows:']=  $jsd->rating;	
						$arr ['rate_details']['Сезонов:'] = $jsd->totalSeasons;
						if ( $jsd->status != ''){
							if ( $jsd->status == 'TBD/On The Bubble'){
								$arr ['rate_details']['Статус:']= ' ';
								$arr ['rate_details']['   '] = 'Пауза';
							}else if ($jsd->status == 'Returning Series'){
								$arr ['rate_details']['Статус:']= ' ';
								$arr ['rate_details']['   '] = 'Продолжается';
							}else if ($jsd->status == 'Canceled/Ended'){
								$arr ['rate_details']['Статус:'] = ' ';
								$arr ['rate_details']['   '] = 'Завершен';
							}else if ($jsd->status == 'New Series'){
								$arr ['rate_details']['Статус:']= ' ';
								$arr ['rate_details']['   '] = 'Новый!';
							}else{
								$arr ['rate_details']['Статус:']= ' ';
								$arr ['rate_details']['   ']=  $jsd->status;
							}
						}
						if ($jsd->totalSeasons != '')
							$arr ['rate_details']['Сезонов:']=  $jsd->totalSeasons;
						if ($jsd->started != ''){
							$arr ['rate_details']['Started:']=  ' ';
							$arr ['rate_details']['  ']=  $jsd->started;
						}
						if ($jsd->ended != ''){
							$arr ['rate_details']['Ended:']= ' ';
							$arr ['rate_details'][' ']=  $jsd->ended;
						}
						if ($jsd->imdbId != '')
							$arr['class_info']['dbIDs']['imdbID'] = $jsd->imdbId;
						if ($jsd->tvrageId != '')
							$arr['class_info']['dbIDs']['tvrageID'] = $jsd->tvrageId;			
					}
				}
				$media_type = 'movie';
				if (isset($mUrl->media_type))
					$media_type = $mUrl->media_type;
				if (!isset($arr['background_urls'])){
					$themoviedbIdArr = VideoInfo::search_themoviedbId ($arr['caption_original'], $arr['year'], true);
					$arr['class_info']['dbIDs']['themoviedbId'] = $themoviedbIdArr['themoviedbId'];
					foreach(TheMovieDatabase_Class::getImagesFromThemoviedb ($arr['class_info']['dbIDs']['themoviedbId'], $media_type) as $k => $v)
						$arr[$k] = $v;
				}
			}
			if (isset($jsd->seriesInfo)){
				$arr ['rate_details']['Сезонов:'] = $jsd->seriesInfo->totalSeasons;
				$arr ['rate_details']['Эпизодов:'] = $jsd->seriesInfo->totalEpisodes;
			}
			if (isset($arr['class_info']['dbIDs']['kpID']))
				$arr ['rate_details']['KPid:'] = $arr['class_info']['dbIDs']['kpID'];
		}else{
			$arr['caption'] = $mUrl->caption;
			$arr['poster_url'] = $mUrl->poster_url;
			if (isset($mUrl->caption_original))
				$arr['caption_original'] = $mUrl->caption_original;
			if (isset($mUrl->year))
				$arr['year'] = $mUrl->year;
			$media_type = 'movie';
			if (isset($mUrl->media_type))
				$media_type = $mUrl->media_type;
			$themoviedbIdArr = VideoInfo::search_themoviedbId ($arr['caption_original'], $arr['year'], true);
			$arr['class_info']['dbIDs']['themoviedbId'] = $themoviedbIdArr['themoviedbId'];
			foreach(TheMovieDatabase_Class::getImagesFromThemoviedb ($arr['class_info']['dbIDs']['themoviedbId'], $media_type) as $k => $v)
				$arr[$k] = $v;
		}
		return $arr;
	}
	public static function getVodSourceInfo($v){
		return false;
	}
	public static function http_get_img ($url){
		return $url;
		// return DuneSystem::$properties['plugin_cgi_url'] . "do?img=" . $url;
	}
}
?>