<?
if (!class_exists('DuneSystem')){
	if (preg_match('|plugins/(.*?)/lib|', __DIR__, $matches)){
		$tmp_path = '/tmp/plugins/'.$matches[1];
		$plugin_name = $matches[1];
		$install_dir = str_replace('/lib/wox', '',  __DIR__);
		if (file_exists('/persistfs/plugins_data'))
			$data_dir = "/persistfs/plugins_data/$plugin_name";
		else
			$data_dir = "/flashdata/plugins_data/$plugin_name";
        $port = HD::http_local_port();
		$www_url = "http://127.0.0.1:$port/plugins/$plugin_name/";
		$cgi_url = "http://127.0.0.1:$port/cgi-bin/plugins/$plugin_name/";
	}

	function hd_print($str){
		echo $str;
	}
	class DuneSystem{
		public static $properties = array ();
	};
	DuneSystem::$properties['plugin_name']      = $plugin_name;
	DuneSystem::$properties['install_dir_path'] = $install_dir;
	DuneSystem::$properties['tmp_dir_path']     = $tmp_path;
	DuneSystem::$properties['plugin_www_url']   = $www_url;
	DuneSystem::$properties['plugin_cgi_url']   = $cgi_url;
	DuneSystem::$properties['data_dir_path']    = $data_dir;
}
class FastTorrent_Class {
	static $cName = 'Fast-Torrent';
	static $className = 'FastTorrent_Class';
	static $DomainName = null;
	static $proxyArr = null;
	static $proxyArrMd5 = null;
	static $proxy = null;
	public static function getDomainName(){
		if (null === self::$DomainName)
			self::$DomainName = (HD::getItemStr(self::$cName . 'DomainName') != '') ? HD::getItemStr(self::$cName . 'DomainName') : 'http://fast-torrent.ru';
		return self::$DomainName;
	}
	public static function getMainMenuInfo(){
		return array (
			'name' => self::$cName,
			'descr' => '||'.self::$cName.'|каталог и источник торрентов с сайта '.self::$cName.'.|Если сайт не доступен используйте прокси или VPN, а так же официальные зеркала (сайты с похожим дизайном и названием могут не являтся зеркалом)'
		);
	}
	public static function get_media_url_str($k, $arr=null){
		if ($arr == true)
			return SmartVodCategoryListScreen::get_media_url_str($k, $arr);
		return SmartVodCategoryListScreen::get_media_url_str($k);
	}
	public static function getSearchMediaUrlStr($k, $arr=null){
		return SmartVodListScreen::get_media_url_str($k, $arr);
	}
	public static function getPopUpMenuItems ($selected_media_url, $parent_media_url){
		$menu_items = array();
		if ($parent_media_url == 'main_menu'){
			$menu_items[] = array(
				'caption' => 'Задать зеркало ' . self::$cName,
				'params' => array ('action' => 'mirror'),
				'icon_url' => SmartConfig::getPluginIco('s_' . self::$className)
			);
			$menu_items[] = array(
				'caption' => 'Прокси для ' . self::$cName,
				'params' => array ('action' => 'proxy'),
				'icon_url' => SmartConfig::getPluginIco('s_proxy')
			);
			$menu_items[] = 'is_separator';
		}
		$parent_media_url = MediaURL::decode($parent_media_url);
		if ($parent_media_url->screen_id == 'vod_torrentlist'){
			
			$menu_items[] = array(
				'caption' => 'Изменить действие для торрентов',
				'params' => array ('action' => 'torrentActionSetup'),
				'icon_url' => SmartConfig::getPluginIco('s_torrent')
			);
			$menu_items[] = array(
				'caption' => 'Выбрать действие торрента',
				'conID' => 'add_actions',
				'params' => array ('torrentAction' => 1),
				'icon_url' => SmartConfig::getPluginIco('s_list')
			);
			$menu_items[] = 'is_separator';
			$menu_items[] = array(
				'caption' => 'Настройки TorrServer',
				'conID' => 'classSetupTorrServer',
				'params' =>  null,
				'icon_url' => SmartConfig::getPluginIco('s_torrserver')
			);
			$menu_items[] = array(
				'caption' => 'Настройки PeerflixServer',
				'conID' => 'classSetupPeerflixServer',
				'params' =>  null,
				'icon_url' => SmartConfig::getPluginIco('s_peerflixserver')
			);
			$menu_items[] = array(
				'caption' => 'Настройки Transmission',
				'conID' => 'classSetupTransmission',
				'params' =>  null,
				'icon_url' => SmartConfig::getPluginIco('s_transmission')
			);
			$menu_items[] = array(
				'caption' => 'Настройки Transmission UPnP',
				'conID' => 'classSetupTransmissionUPnP',
				'params' =>  null,
				'icon_url' => SmartConfig::getPluginIco('s_transmissionupnp')
			);
			$menu_items[] = 'is_separator';
		}
		if ((isset($parent_media_url->screen_id))&&($parent_media_url->screen_id != 'vod_series')){
			$menu_items[] = array(
				'caption' => 'Добавить в Главное меню',
				'params' => array ('action' => 'addToMainMenu'),
				'icon_url' => SmartConfig::getPluginIco('s_home')
			);
		}
		return $menu_items;
	}
	public static function getScreenActionMapArr($media_url){
		$actionsArr = array();
		if((isset($media_url->screen_id))&&($media_url->screen_id != 'vod_category_list')){
			$actionsArr[0]['create_action'] = 'classAction';
			$actionsArr[0]['params'] = array ('indiClass' => self::$className,'action' => 'sort');
			$actionsArr[0]['caption'] = 'Сортировки';
			$actionsArr[0]['key'] = GUI_EVENT_KEY_C_YELLOW;
		}
		return $actionsArr;
	}
	public static function getVodCategories($media_url){
		static $categories = null;
		if (is_null($categories)){
			$categories['categories'][] = array('id'=> 'search', 'class' => 'SmartSearchScreen', 'caption' => 'Поиск');
			$categories['categories'][] = array('id'=> '/new/all/', 'class' => 'SmartVodListScreen', 'caption' => 'Все');
			$categories['categories'][] = array('id'=> '/new-torrent/', 'class' => 'SmartVodCategoryListScreen', 'caption' => 'Фильмы');
			$categories['categories'][] = array('id'=> '/last-tv-torrent/', 'class' => 'SmartVodCategoryListScreen', 'caption' => 'Сериалы');
			$categories['categories'][] = array('id'=> '/last-multfilm-torrent/', 'class' => 'SmartVodCategoryListScreen', 'caption' => 'Анимация');
			$categories['categories'][] = array('id'=> '/new/documentary/', 'class' => 'SmartVodCategoryListScreen', 'caption' => 'ТВ');
			$categories['categories'][] = array('id'=> '/new/music/', 'class' => 'SmartVodCategoryListScreen', 'caption' => 'Музыка');
		}
		if (isset($media_url->categoryId)){
			if (!isset($categories['subCategories'][$media_url->categoryId])){
				$doc = self::http_get_document(self::getDomainName() . $media_url->categoryId);
				if(preg_match("|nav-menu'>(.*?)<div class='no-mobile'|ms", $doc, $matches)){
					if (preg_match_all("|<a href='(.*?)'.*?</a>|", str_replace('"', "'", $matches[1]), $matches)){
						foreach ($matches[0] as $k => $v){
							if((!preg_match("/onclick|tags/", $v))&&($matches[1][$k] != $media_url->categoryId)){
								if ('' == $matches[1][$k])
									$categories['subCategories'][$media_url->categoryId][] = array('id'=> $media_url->categoryId, 'class' => 'SmartVodListScreen', 'caption' => HD::str_remove_tag($v));
								else
									$categories['subCategories'][$media_url->categoryId][] = array('id'=> $matches[1][$k], 'class' => 'SmartVodListScreen', 'caption' => HD::str_remove_tag($v));							}
						}
					}
				}
				if(preg_match("|<table><tr>(.*?)</table>|ms", $doc, $matches)){
					if (preg_match_all("|<a href='(.*?)'.*?</a>|", str_replace('"', "'", $matches[1]), $matches)){
						foreach ($matches[0] as $k => $v)
							$categories['subCategories'][$media_url->categoryId][] = array('id'=> $matches[1][$k], 'class' => 'SmartVodListScreen', 'caption' => HD::str_remove_tag($v));
					}
				}
			}
			return $categories['subCategories'][$media_url->categoryId];
		}
		return $categories['categories'];
	}
	public static function getShortMovieRange ($media_url, &$m_feed){
		$items = array();
		if ($m_feed === 'end')
			return $items;
		$sorting = (HD::getItemsArr(self::$className . '_sorting') != array()) ? HD::getItemsArr(self::$className . '_sorting') :  array('vod_torrentlist' => '0', 'sort' => 0);
		if ($media_url->categoryId == '/new/all/'){
			$otps[CURLOPT_POST] = true;
			$otps[CURLOPT_POSTFIELDS] = "sort=".$sorting['sort']."&search_pages=15&filter_action=";
			$doc = self::http_get_document(self::getDomainName() . '/all/all/all/' . ($m_feed+1) . ".html", $otps);
		}else
			$doc = self::http_get_document(self::getDomainName() . $media_url->categoryId . ($m_feed+1) . ".html?sort=" . $sorting['sort']);
		if ((preg_match("|<li class='page_next float_right'><em></em></li>|ms", $doc))||
		(!preg_match("|page_next float_right|ms", $doc)))
			$m_feed = 'end';
		else
			++$m_feed;
		return self::parseSitePage($doc);
	}
	public static function parseSitePage($doc){
		$items = array();
		if (preg_match_all('|<div itemscope itemtype=".*?>(.*?)</div></div></div>|ms', $doc, $matches)){
			foreach ($matches[1] as $k => $v){
				if(preg_match('|href="(.*?)"|ms', $v, $match))
					$id = trim($match[1]);
				if(preg_match('|alt="(.*?)"|ms', $v, $match))
					$caption = $caption_original = HD::str_remove_tag($match[1]);
				if(preg_match('|alternativeHeadline">(.*?)<|ms', $v, $match))
					$caption_original = $match[1];
				if(preg_match('|image" content="(.*?)"|ms', $v, $match))
					$poster_url = self::http_get_img ($match[1]);
				$short_movie = new ShortMovie(
					strval(trim($id)),
					strval($caption),
					strval($poster_url)
				);
				$info = '||' . $caption;
				$info .= '|' . $caption_original;
				if (preg_match('|name">.*?\((\d+?)\).*?</|ms', $v, $match))
					$short_movie->year = HD::str_remove_tag($match[1]);
				if(preg_match("|(Дата выхода фильма:.*?)<|", $v, $match))
					$info .= '||' . HD::str_remove_tag(str_replace(' фильма', '', $match[1]));
				if(preg_match('|qa-icon qa-(.*?)use_tooltip|ms', $v, $match)){
					$info .= '||' . trim($match[1]);
					$short_movie->right_top_img = $short_movie->left_bottom_img = false;
					$right_top_img = SmartConfig::getQualityIco(trim($match[1]));
					$short_movie->right_top_img = $right_top_img;
				}
				if(preg_match("|<div class='film-genre'>(.*?)</div|ms", $v, $match))
					$info .= '||' . HD::str_remove_tag($match[1]);
				if(preg_match("|В ролях</strong>:(.*?)</div|ms", $v, $match))
					$info .= '||' . HD::str_remove_tag($match[1]);
				if(preg_match('|film-announce">(.*?)</div|ms', $v, $match))
					$info .= '||' . HD::str_remove_tag($match[1]);
				$short_movie->info = $info;
				array_push ($items, $short_movie);
			}
		}
		return $items;
	}
	public static function getSearchShortMovieRange ($keyword, &$m_feed){
		if (is_object($keyword))
			$keyword = $keyword->searchStr;
		$items = array();
		 if ($m_feed === 'end')
			return $items;
		++$m_feed;
	
		$date1 = 1895;
		$date2 = date("Y") + 2;
		$keyword = urlencode ($keyword);
		$opts [CURLOPT_POST] = true;
		$opts [CURLOPT_POSTFIELDS] = "search_page=$m_feed&search_pages=15&keyword=$keyword&captcha_0=&captcha_1=&captcha_2=&up_celebrity=0&type%5B%5D=1&type%5B%5D=4&type%5B%5D=14899&type%5B%5D=14902&type%5B%5D=14903&countries_mode=1&tag_mode=1&genre_mode=1&award_mode=1&from_date=$date1&to_date=$date2&from_rating=1&to_rating=10&sort=14&search_pages_set=15";
		$doc = self::http_get_document(self::getDomainName() . "/search/$keyword/15/$m_feed.html", $opts);
		if (preg_match('|"num_pages": (\d*),|ms', $doc, $m))
			if ($m_feed == $m[1])
				$m_feed = 'end';
		return self::parseSitePage($doc);
	}
	public function classAction ($defs, $user_input, $select_url = null){
		hd_restore_warnings();
		$post_action = null;
		$caption = 'Error!';
		$msg = 'classAction: action';
		$width = 1050;
		$parent_media_url = MediaURL::decode($user_input->parent_media_url);
		if ($user_input->action == 'sort'){
			$sorting = (HD::getItemsArr(self::$className . '_sorting') != array()) ? HD::getItemsArr(self::$className . '_sorting') :  array('vod_torrentlist' => '0', 'sort' => 0);
			$add_params['control_id']= $user_input->control_id;
			$add_params['action'] = $user_input->action;
			$add_params['indiClass'] = self::$className;
			if ((isset($user_input->selected_control_id))&&(isset($user_input->action_type))){
				if (isset($user_input->initial_sel_ndx))
					$add_params['initial_sel_ndx'] = $user_input->initial_sel_ndx;
					if ($parent_media_url->screen_id == 'vod_torrentlist')
						$sorting['vod_torrentlist'] = $user_input->sorting;
					else
						$sorting['sort'] = $user_input->sorting;
				if (HD::saveItemsArr(self::$className . '_sorting', $sorting) == false)
					return ActionFactory::show_title_dialog("Сохранение не удалось");
				$action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $add_params);
				$action = ActionFactory::close_dialog_and_run($action);
				return ActionFactory::invalidate_folders(array($user_input->parent_media_url), $action);
			}
			$add_params['initial_sel_ndx'] = 0;
			if ($parent_media_url->screen_id == 'vod_torrentlist'){
				$sorting = $sorting['vod_torrentlist'];
				$sorting_ops[0]	= 'Выдача';
				$sorting_ops[1]	= 'Размер';
			}else{
				$sorting = $sorting['sort'];
				$sorting_ops[6]	= 'Новые';
				$sorting_ops[7]	= 'Старые';
				$sorting_ops[8]	= 'Лучшие';
				$sorting_ops[2]	= 'Популярные';
				$sorting_ops[13]= 'Самые рекомендуемые';
				$sorting_ops[0]	= 'Новые торренты';
				$sorting_ops[1]	= 'Ранние торренты';
				$sorting_ops[3]	= 'Непопулярные';
				$sorting_ops[4]	= 'Название ( А - Я )';
				$sorting_ops[5]	= 'Название ( Я - А )';
				$sorting_ops[14]= 'Новые на ДВД';
				$sorting_ops[15]= 'Ранние на ДВД';
				$sorting_ops[9]	= 'Худшие по рейтингу';
				$sorting_ops[10]= 'Лучшие по качеству';
				$sorting_ops[11]= 'Худшие по качеству';
				$sorting_ops[12]= 'Новые фильмы на сайте';
				$sorting_ops[20]= 'Обсуждаемые';
			}
			ControlFactory::add_combobox($defs, $this, $add_params,
				'sorting', '',
				$sorting, $sorting_ops, 800, true, false
			);
			$attrs['initial_sel_ndx'] = isset($user_input->initial_sel_ndx) ? $user_input->initial_sel_ndx : -1;
			return ActionFactory::show_dialog("Cортировка:", $defs, true, 0, $attrs);
		}
		if (isset($user_input->selected_media_url))
			$selected_media_url = MediaURL::decode($user_input->selected_media_url);
		else{
			$msg = 'classAction: selected_media_url';
			return ActionFactory::show_title_dialog($caption, $post_action, $msg, 0);
		}
		$class_name = $selected_media_url->class_name;
		$parent_media_url = MediaURL::decode($user_input->parent_media_url);
		
		return ActionFactory::show_title_dialog($caption, $post_action, $msg, 0);
	}
	public static function load_movie($movie_id, $mUrl, $getMovieInfo){
		$arr = array();
		$arr['caption'] = $arr['class_info']['catalog_info']['caption'] = $mUrl->caption;
		$arr['poster_url'] = $arr['class_info']['catalog_info']['poster_url'] = $mUrl->poster_url;
		if (isset($mUrl->caption_original))
			$arr['caption_original'] = $arr['class_info']['catalog_info']['caption_original'] = $mUrl->caption_original;
		if (isset($mUrl->year))
			$arr ['year'] = $arr['class_info']['catalog_info']['year'] = $mUrl->year;
		if (!preg_match("|^http|",$movie_id))
			$url = self::getDomainName() . $movie_id;
		else
			$url = preg_replace('#((http.*)://.+?\/)#i', self::getDomainName() . "/", $movie_id);
		$doc = self::http_get_document($url);
		if (preg_match("|film_name'>(.*?)<|ms", $doc, $match))
			$arr['caption_original'] =  $arr ['caption'] = HD::str_remove_tag($match[1]);
		if (preg_match("|name_orig'>(.*?)</|ms", $doc, $match))
			$arr['caption_original'] = HD::str_remove_tag($match[1]);
		if (preg_match("|film_name'>.*?\((\d+?)\).*?</|ms", $doc, $match))
			$arr ['year'] = HD::str_remove_tag($match[1]);
		if (preg_match("|description\" class='justify'>(.*?)</div|ms", $doc, $match))
			$arr['description'] = HD::str_remove_tag($match[1]);
		if (preg_match("|>Жанр.*?\:(.*?)</p>|ms", $doc, $match))
			$arr['genres'] = HD::str_remove_tag($match[1]);
		if (preg_match_all("|<em class=\"cn-icon.*?title='(.*?)'>|ms", $doc, $match))
			$arr['country'] = implode(', ', $match[1]);
		else if (preg_match('|Стили</strong>:(.*?)</p>|ms', $doc, $match))
			$arr ['country'] = HD::str_remove_tag($match[1]);
		if(preg_match('|kinopoisk_id.*?=(.*?);|ms', $doc, $match)){
			$kpId = trim ($match[1]);
			if ($kpId != 0)
				$arr['class_info']['dbIDs']['kpID'] = $kpId;
		}else{
			$kpIDs = HD::getItemsArr('kpIDs');
			if (isset($kpIDs[$movie_id]))
				$arr['class_info']['dbIDs']['kpID'] = $kpIDs[$movie_id];
		}
		if (preg_match("|должительность.*?\:(.*?)</p>|ms", $doc, $match)){
			if (preg_match('|(\d*):(\d*):(\d*)|', trim($match[1]), $m))
				$arr ['length'] = ($m[1]*60) + $m[2];
			if (preg_match('|(\d*):(\d*)|', trim($match[1]), $m))
				$arr ['length'] = ($m[1]*60) + $m[2];
		}
		if (preg_match("|'image_src' href='(.*?)'|ms", $doc, $match))
			$arr ['poster_url'] = $match[1];
		if (preg_match('|Режиссер</strong>:(.*?)</p>|ms', $doc, $match))
			$arr ['director'] = HD::str_remove_tag($match[1]);
		if (preg_match('|В ролях</strong>:(.*?)</p>|ms', $doc, $match))
			$arr ['actors'] = HD::str_remove_tag($match[1]);
		if (preg_match_all ('|<a class=\'slideshow\' href="(.*?)"|ms', $doc, $matches))
			foreach ($matches[1] as $k => $v)
				$arr ['background_urls'][] = $v;
		if (preg_match_all ("|<a class='slideshow\d*?' href='(.*?)'|ms", $doc, $matches))
			foreach ($matches[1] as $k => $v)
				$arr ['background_urls'][] = $v;
		if (preg_match('|в Мире\)</strong>:(.*?)<|ms', $doc, $match))
			$arr ['details']['Дата выхода:'] = HD::str_remove_tag($match[1]);
		if (!isset($arr['class_info']['dbIDs']['kpID']))
			$arr['class_info']['goToScreen'] = 'SmartVodTorrentsScreen';
		else
			$arr = SmartConfig::getMovieInfoArr($getMovieInfo, $movie_id, $mUrl, $arr);
		$arr['class_info'][self::$className]['searchTorrentUrl'] = str_replace('.html', '/torrents.html', $movie_id);
		return $arr;
	}
	public static function getVodSourceInfo($v){
		$ico = SmartConfig::getPluginIco(self::$className);
		$sources['caption'] = self::$cName;
		$sources['detailed_info'] = '||'.self::$cName.'|Торрент файлы найденные на '.self::$cName.' по названию. Так как поиск производится по названию возможны неточности.';
		$sources['icon_path'] = $ico;
		$sources['detailed_icon_path'] = $ico;
		$sources['goTo'] = 'SmartVodTorrentsScreen';
		$sources['class_name'] = $v;
		$sources['type'] = SmartConfig::getPluginIco('torrentSource');
		return $sources;
	}
	public static function getShortTorrentRange ($movie, $media_url, &$m_feed){
		$items = array();
		if ($m_feed === 'end')
			return $items;
		$m_feed = 'end';
		$sorting = (HD::getItemsArr(self::$className . '_sorting') != array()) ? HD::getItemsArr(self::$className . '_sorting') :  array('vod_torrentlist' => '0', 'sort' => 0);
		$icon_path = SmartConfig::getPluginIco('s_torrent');
		if (!isset($movie->class_info[self::$className]['searchTorrentUrl'])){
			$m_feed = 0;
			
			$keyword = $movie->name;
			$year = $movie->year  != '' ? $movie->year : false;
			$obj = self::getSearchShortMovieRange ($keyword, $m_feed);
			foreach($obj as $k => $v){
				if (HD::strSanitizing($v->name) == HD::strSanitizing($movie->name)){
					$stack[$k] = str_replace('.html', '/torrents.html',$v->id);
					if (($year == true)&&(isset($v->year)))
						if ($year == $v->year){
							$searchTorrentUrl = str_replace('.html', '/torrents.html', $v->id);
							break;
						}
				}
			}
			if (!isset($searchTorrentUrl)){
				if (isset($arrKeys))
					$searchTorrentUrl = array_shift($stack);
				else if (count($obj) > 0){
					$v = array_shift($obj);
					$searchTorrentUrl = str_replace('.html', '/torrents.html',$v->id);
				}
			}
			if (!isset($searchTorrentUrl))
				return $items;
		}else
			$searchTorrentUrl = $movie->class_info[self::$className]['searchTorrentUrl'];
		
		if (!preg_match("|^http|",$searchTorrentUrl))
			$searchTorrentUrl = self::getDomainName() . $searchTorrentUrl;
		$doc = self::http_get_document($searchTorrentUrl);
		if (preg_match_all("|<div class='c1'>(.*?)</center>|ms", $doc, $matches)){
			foreach ($matches[0] as $k => $v){
				$info ='';
				$v = str_replace('|', '*', $v);
				if(preg_match("|<div class='torrent.*?download-event'>(.*?)</a>|ms", $v, $match))
					$result[$k]['name']= HD::str_remove_tag(str_replace('</b>', ' ', $match[1]));
				if(preg_match('|<a href="(/download.*?)"|ms', $v, $match))
					$result[$k]['link']= $match[1];
				if(preg_match('|icon qa-(.*?)\s|ms', $v, $match))
					$info.= $match[1];
				if(preg_match("|class='c3'>(.*?)<|ms", $v, $match)){
					$info.= '|' . $match[1];
					$result[$k]['size']= $size = HD::str_remove_tag($match[1]);
					if (preg_match('|МБ|', $size))
						$size = $size / 1000;
					$sSk[$k] = $size;
				}
				if(preg_match("|class='c4'>(.*?)<|ms", $v, $match))
					$info.= '|Дата добавления: ' . $match[1];
				if(preg_match("|<div class='margin'>(.*?)</center>|ms", $v, $match))
					$info.= '|' . HD::str_remove_tag(str_replace(array('<span>', '<br/>'), array(' ', '|'),$match[1]));
				$result[$k]['info']= $info;					
			}
		}
		if (preg_match_all("|<div class='c12'>(.*?)</div>\s*?</div>\s*?</div>|ms", $doc, $matches)){
			foreach ($matches[0] as $k => $v){
				$info ='';
				$v = str_replace('|', '*', $v);
				if(preg_match("|Файл</span>:(.*?)</a>|ms", $v, $match))
					$result[$k+1000]['name']= HD::str_remove_tag(str_replace('</b>', ' ', $match[1]));
				if(preg_match('|<a href="(/download.*?)"|ms', $v, $match))
					$result[$k+1000]['link']= $match[1];
				if(preg_match("|Аудио</span>:(.*?)<|ms", $v, $match))
					$info.= $match[1];
				$sSk[$k+1000] = 0;
				$result[$k+1000]['info']= $info;					
			}
		}
		if (isset($result)){
			if (($sorting['vod_torrentlist'] == 1)&&(count($sSk) > 1)){
				natsort($sSk);
				$sSk = array_keys (array_reverse ($sSk, true));
				foreach ($sSk as $k => $v)
					$sort[$k] = $result[$v];
				$result = $sort;
			}
			foreach ($result as $v){
				$short_movie = new ShortMovie(
					strval($v['link']),
					strval($v['name']),
					strval($movie->poster_url)
				);
				$short_movie->tType = 'torrent';
				$short_movie->icon_path = $icon_path;
				$info = '||' . $v['name'] . '|'. self::$cName . "||" . $v['size'];
				$short_movie->extra_item = $v['size'];
				$info .= $v['info'];
				$short_movie->info = $info;
				$short_movie->details_box_width = true;
				array_push ($items, $short_movie);
			}
		}
		return $items;
	}
	public static function getTorrentFile($torrent_id, $dloadPath=null){
		$url = $torrent_id;
		if (!preg_match("|^http|", $torrent_id))
			$url = self::getDomainName() . $torrent_id;
		$doc = self::http_get_document($url);
		return SmartConfig::checkTorrent($dloadPath, $doc);
	}
	public static function http_get_img ($url){
		if (preg_match("|https|",$url))
			return DuneSystem::$properties['plugin_cgi_url'] . "do?img=" .  $url;	
		return $url;
	}
	public static function http_get_document ($url, $opts=null){
		if (is_null(self::$proxy)){
			self::$proxy = false;
			$sitesProxy = HD::getItemsArr('sitesProxy');
			if (isset($sitesProxy[self::$cName])){
				$proxySettings = (HD::getItemsArr('proxySettings') != array()) ? HD::getItemsArr('proxySettings') : array();
				if (isset($proxySettings['proxy'])){
					self::$proxy['proxy'] = $proxySettings['proxy'];
					if ((isset($proxySettings['proxyType']))&&($proxySettings['proxyType'] == 'SOCKS5'))
						self::$proxy['proxyType'] = $proxySettings['proxyType'];
					if (isset($proxySettings['proxyAccount']))
						self::$proxy['proxyAccount'] = $proxySettings['proxyAccount'];
				}
			}
		}
		if (self::$proxy == true){
			$opts[CURLOPT_PROXY] = self::$proxy['proxy'];
			if (isset(self::$proxy['proxyType']))
				$opts[CURLOPT_PROXYTYPE] = CURLPROXY_SOCKS5;
			if (isset(self::$proxy['proxyAccount']))
				$opts[CURLOPT_PROXYUSERPWD] = self::$proxy['proxyAccount'];
		}
		return HD::http_get_document($url, $opts);
	}
}
?>
