<?php
if (!class_exists('DuneSystem')){
	if (preg_match('|plugins/(.*?)/lib|', __DIR__, $matches)){
		$tmp_path = '/tmp/plugins/'.$matches[1];
		$plugin_name = $matches[1];
		$install_dir = str_replace('/lib/wox', '',  __DIR__);
		if (file_exists('/persistfs/plugins_data'))
			$data_dir = "/persistfs/plugins_data/$plugin_name";
		else
			$data_dir = "/flashdata/plugins_data/$plugin_name";
        $port = HD::http_local_port();
		$www_url = "http://127.0.0.1:$port/plugins/$plugin_name/";
		$cgi_url = "http://127.0.0.1:$port/cgi-bin/plugins/$plugin_name/";
	}

	function hd_print($str){
		echo $str;
	}
	class DuneSystem{
		public static $properties = array ();
	};
	DuneSystem::$properties['plugin_name']      = $plugin_name;
	DuneSystem::$properties['install_dir_path'] = $install_dir;
	DuneSystem::$properties['tmp_dir_path']     = $tmp_path;
	DuneSystem::$properties['plugin_www_url']   = $www_url;
	DuneSystem::$properties['plugin_cgi_url']   = $cgi_url;
	DuneSystem::$properties['data_dir_path']    = $data_dir;
}



class Filmix_Class {
	static $cName = 'Filmix';
	static $className = 'Filmix_Class';
	static $DomainName = null;
	static $proxyArr = null;
	static $proxyArrMd5 = null;
	static $proxy = null;
	static $logIn = 'noCheck';
	public static function getDomainName(){
		if (null === self::$DomainName)
			self::$DomainName = (HD::getItemStr(self::$cName . 'DomainName') != '') ? HD::getItemStr(self::$cName . 'DomainName') : 'https://filmix.ac';
		return self::$DomainName;
	}
	public static function cookie(){
		return DuneSystem::$properties['tmp_dir_path'] . "/" . self::$cName . "Cookie";
	}
	public static function getMainMenuInfo(){
		
		return array (
			'name' => self::$cName,
			'descr' => '||'.self::$cName.'|каталог и источник видео с сайта '.self::$cName.'.||Для просмотра 720 видео необходим логин на сайт - PopUp Menu>>Авторизация. Для 1080 и выше необходим "PRO+ аккаунт"||Работа "PRO+ аккаунт" в этом плагине не гарантируется и зависит от используемых заркал.||При спользовании прокси видео не работает.|Если сайт не доступен необходим VPN, а так же официальные зеркала (сайты с похожим дизайном и названием могут не являтся зеркалом).'
		);
	}
	public static function get_media_url_str($k, $arr=null){
		if ($arr == true)
			return SmartVodCategoryListScreen::get_media_url_str($k, $arr);
		return SmartVodCategoryListScreen::get_media_url_str($k);
	}
	public static function getSearchMediaUrlStr($k, $arr=null){
		return SmartVodListScreen::get_media_url_str($k, $arr);
	}
	public function meinMenuOpenFolderDialog($user_input){
		if (self::checkLogIn() == 'false'){
			$alertOff = (HD::getItemStr(self::$cName . 'AlertOff') != '') ? HD::getItemStr(self::$cName . 'AlertOff') : false;
			$add_params['action'] = $user_input->action;
			if ((!isset($user_input->closed_dialog))&&($alertOff == false)){
				$add_params['closed_dialog']= true;
				ControlFactory::add_multiline_label($defs, '', "Для полноценного использования источника ".self::$cName." необходима авторизация (POPUP MENU на каталоге), без авторизации не доступно 720р видео!",5);		
				ControlFactory::add_close_dialog_and_apply_button($defs, $this, array ('action' => 'eneyIn'), 'classAction', base64_decode('0JDQstGC0L7RgNC40LfQsNGG0LjRjyDQvdCwIA') . self::$cName, 600);
				ControlFactory::add_close_dialog_and_apply_button($defs, $this, $add_params, $user_input->control_id, 'Продолжить без авторизации', 600);
				$add_params['alertOff']= true;
				ControlFactory::add_close_dialog_and_apply_button($defs, $this, $add_params, $user_input->control_id, 'Больше не показывать', 600);
				return  ActionFactory::show_dialog('Внимание!',$defs, true,900,$attrs);
			}
			if (isset($user_input->alertOff))
				if (HD::saveItemStr(self::$cName . 'AlertOff', 1) == false)
					return ActionFactory::show_title_dialog("Сохранение не удалось");
		}
		return ActionFactory::open_folder();
	}
	public static function checkLogIn(){
		if (self::$logIn == 'noCheck'){
			$eney = HD::getItemsArr('eney');
			if (isset($eney[self::$cName])){
				$ul = HD::eney('l', $eney[self::$cName][0]);
				$up = HD::eney('p', $eney[self::$cName][1]);
				if (file_exists(self::cookie())){
					$doc = HD::http_get_document(self::getDomainName());
					if (preg_match('|dle_user_name|', $doc))
						self::$logIn = 'true';
				}
				if (self::$logIn == 'noCheck'){
					$cgr = self::testEneyIn();
					if ($cgr == false)
						self::$logIn = 'false';
					else
						self::$logIn = 'true';
				}
			}else
				self::$logIn = 'false';
		}
		return self::$logIn;
	}
	public static function testEneyIn($ul = null, $up = null){
		if ($ul == false){
			$eney = HD::getItemsArr('eney');
			if (isset($eney[self::$cName])){
				$ul = HD::eney('l', $eney[self::$cName][0]);
				$up = HD::eney('p', $eney[self::$cName][1]);
			}else
				return false;
		}
		if (file_exists(self::cookie()))
			unlink(self::cookie());
		$opts [CURLOPT_COOKIEJAR]	= self::cookie();
		$header[] = "cookie: x-a-key=sinatra;";
		$opts [CURLOPT_HTTPHEADER] = $header;
		$opts [CURLOPT_POST] = true;
		$opts [CURLOPT_POSTFIELDS] = "login_name=$ul&login_password=$up&login=submit";
		$doc = self::http_get_document(self::getDomainName(), $opts);
		if (!preg_match("|<form action=|", $doc)){
			self::$logIn = 'true';
			return true;
		}else{
			self::$logIn = 'false';
			echo $doc;
			if (file_exists(self::cookie()))
				unlink(self::cookie());
			return false;
		}
	}
	public static function getPopUpMenuItems ($selected_media_url, $parent_media_url){
		$menu_items = array();
		if ($parent_media_url == 'main_menu'){
			
			$menu_items[] = array(
				'caption' => base64_decode('0JDQstGC0L7RgNC40LfQsNGG0LjRjyDQvdCwIA') . self::$cName,
				'params' => array ('action' => 'eneyIn'),
				'icon_url' => SmartConfig::getPluginIco('s_user')
			);
			$menu_items[] = array(
				'caption' => 'Задать зеркало ' . self::$cName,
				'params' => array ('action' => 'mirror'),
				'icon_url' => SmartConfig::getPluginIco('s_' . self::$className)
			);
			$menu_items[] = array(
				'caption' => 'Прокси для ' . self::$cName,
				'params' => array ('action' => 'proxy'),
				'icon_url' => SmartConfig::getPluginIco('s_proxy')
			);
			$menu_items[] = 'is_separator';
		}
		$parent_media_url = MediaURL::decode($parent_media_url);
		if ((isset($parent_media_url->screen_id))&&($parent_media_url->screen_id != 'vod_series')){
			$menu_items[] = array(
				'caption' => 'Добавить в Главное меню',
				'params' => array ('action' => 'addToMainMenu'),
				'icon_url' => SmartConfig::getPluginIco('s_home')
			);
		}
		return $menu_items;
	}
	
	public function classAction ($defs, $user_input, $select_url = null){
		hd_restore_warnings();
		$post_action = null;
		$caption = 'Error!';
		$msg = 'classAction: action';
		$width = 1050;
		if (isset($user_input->selected_media_url))
			$selected_media_url = MediaURL::decode($user_input->selected_media_url);
		else{
			$msg = 'classAction: selected_media_url';
			return ActionFactory::show_title_dialog($caption, $post_action, $msg, 0);
		}
		$class_name = $selected_media_url->class_name;
		$parent_media_url = MediaURL::decode($user_input->parent_media_url);
		if ($user_input->action == 'randomGenres'){
			static $country_jsd = null;
			static $genre_jsd = null;
			$add_params['indiClass']= $class_name;
			$add_params['control_id']= $user_input->control_id;
			$add_params['action'] = $user_input->action;
			if (isset($user_input->reset))
				if (HD::saveItemsArr(self::$cName . 'RandomMovies', array()) == false)
					return ActionFactory::show_title_dialog("Сохранение не удалось");
			$randomMovies = (HD::getItemsArr(self::$cName . 'RandomMovies') != array()) ? HD::getItemsArr(self::$cName . 'RandomMovies') : array();
			$random_max_years = isset($randomMovies['max_years']) ? $randomMovies['max_years'] : date('Y');
			$random_min_years = isset($randomMovies['min_years']) ? $randomMovies['min_years'] : '1920';
			$random_genre = isset($randomMovies['random_genre']) ? $randomMovies['random_genre'] : array();
			$random_country = isset($randomMovies['random_country']) ? $randomMovies['random_country'] : array();
			if ($country_jsd == false){
				$opts [CURLOPT_POSTFIELDS] = "scope=random_movie&type=countries";
				$country_jsd = json_decode(iconv('windows-1251', 'UTF-8', self::http_get_document(self::getDomainName() . '/engine/ajax/get_filter.php', $opts)));
			}
			if ($genre_jsd == false){
				$opts [CURLOPT_POSTFIELDS] = "scope=random_movie&type=categories";
				$genre_jsd = json_decode(iconv('windows-1251', 'UTF-8', self::http_get_document(self::getDomainName() . '/engine/ajax/get_filter.php', $opts)));
			}
			
			if ((isset($user_input->selected_control_id))&&(isset($user_input->action_type))){
				$params['indiClass']= $class_name;
				$params['initial_sel_ndx'] = $user_input->initial_sel_ndx;
				$params['action'] = $user_input->action;
				if ($user_input->selected_control_id == 'random_country'){
					$flipRandomCountry = array_flip ($random_country);
					if ($user_input->random_country == ''){
						unset($randomMovies['random_country']);
					}else if ($user_input->random_country == 'all'){
						$random_country = array();
						foreach ($country_jsd as $k => $v)
							$random_country[] = str_replace('f', '', $k);
						$randomMovies['random_country'] = $random_country;
					}else if (isset($flipRandomCountry[$user_input->random_country])){
						unset ($flipRandomCountry[$user_input->random_country]);
						$randomMovies['random_country'] = array_flip ($flipRandomCountry);
					}else{
						$random_country[] = $user_input->random_country;
						$randomMovies['random_country'] = $random_country;
					}
				}
				if ($user_input->selected_control_id == 'random_genre'){
					$flipRandomgenre = array_flip ($random_genre);
					if ($user_input->random_genre == ''){
						unset($randomMovies['random_genre']);
					}else if ($user_input->random_genre == 'all'){
						$random_genre = array();
						foreach ($genre_jsd as $k => $v)
							$random_genre[] = str_replace('f', '', $k);
						$randomMovies['random_genre'] = $random_genre;
					}else if (isset($flipRandomgenre[$user_input->random_genre])){
						unset ($flipRandomgenre[$user_input->random_genre]);
						$randomMovies['random_genre'] = array_flip ($flipRandomgenre);
					}else{
						$random_genre[] = $user_input->random_genre;
						$randomMovies['random_genre'] = $random_genre;
					}
				}
				if ($user_input->selected_control_id == 'random_max_years'){
					$randomMovies['max_years'] = $user_input->random_max_years;
					if ($user_input->random_max_years < $random_min_years)
						$randomMovies['min_years'] = $user_input->random_max_years;
				}
				if ($user_input->selected_control_id == 'random_min_years'){
					$randomMovies['min_years'] = $user_input->random_min_years;
					if ($user_input->random_min_years > $random_max_years)
						$randomMovies['max_years'] = $user_input->random_min_years;
				}
				if (HD::saveItemsArr(self::$cName . 'RandomMovies', $randomMovies) == false)
					return ActionFactory::show_title_dialog("Сохранение не удалось");
				$action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $params);
				return ActionFactory::close_dialog_and_run($action);
			}
			
			
			for ($i = 1920; $i< $random_max_years+1; $i++)
				$min_ops[$i] = $i;
			for ($i = $random_min_years; $i< date('Y')+1; $i++)
				$max_ops[$i] = $i;
			ControlFactory::add_label($defs, "Период:", "$random_min_years - $random_max_years года");
			
			$add_params['initial_sel_ndx'] = 0;
			ControlFactory::add_combobox($defs, $this, $add_params,
			'random_min_years', 'Начало периода:',
			$random_min_years, $min_ops, 100, true, false);
			
			$add_params['initial_sel_ndx'] = $add_params['initial_sel_ndx'] + 1;
			ControlFactory::add_combobox($defs, $this, $add_params,
			'random_max_years', 'Конец периода:',
			$random_max_years, $max_ops, 100, true, false);
			
			$c2 = ''; $arr = array();
			$arr[''] = 'Все жанры';
			$arr['all'] = 'Выбрать все жанры';
			foreach ($genre_jsd as $k => $v)
				$arr[str_replace('f', '', $k)] = $v;
			if ($random_genre == array())
				$c = 'Все жанры';
			else{
				$c = '';
				foreach ($random_genre as $v){
					$c .=  $arr[$v] . '; ';
					$arr[$v] = $arr[$v] . '*';
					$c2 = $v;
				}
				
			}
			ControlFactory::add_multiline_label($defs, 'Выбранные жанры:', $c, 3);
			$add_params['initial_sel_ndx'] = $add_params['initial_sel_ndx'] + 1;
			ControlFactory::add_combobox($defs, $this, $add_params,
			'random_genre', 'Жанры:',
			$c2, $arr, 800, true, false);
			
			$c2 = ''; $arr = array();
			$arr[''] = 'Все страны';
			$arr['all'] = 'Выбрать все страны';
			foreach ($country_jsd as $k => $v)
				$arr[str_replace('f', '', $k)] = $v;
			if ($random_country == array())
				$c = 'Все страны';
			else{
				$c = '';
				foreach ($random_country as $v){
					$c .=  $arr[$v] . '; ';
					$arr[$v] = $arr[$v] . '*';
					$c2 = $v;
				}
			}
			ControlFactory::add_multiline_label($defs, 'Выбранные страны:', $c, 3);
			$add_params['initial_sel_ndx'] = $add_params['initial_sel_ndx'] + 1;
			ControlFactory::add_combobox($defs, $this, $add_params,
				'random_country', 'Страны:',
				$c2, $arr, 800, true, false
			);
			ControlFactory::add_vgap($defs, (-10));
			ControlFactory::add_smart_label($defs, "", '<text color="23" size="tiny">* повторный выбор категории удаляет ее из списка</text>');
			ControlFactory::add_vgap($defs, (-45));
			ControlFactory::add_smart_label($defs, "", '<icon width="142" height="50">gui_skin://special_icons/controls_button_clear.aai</icon><text color="23"> - сброс сортировок</text>');
			$attrs['initial_sel_ndx'] = isset($user_input->initial_sel_ndx) ? $user_input->initial_sel_ndx : -1;
			$action = UserInputHandlerRegistry::create_action($this, 'invalidate');
			$attrs['actions'][GUI_EVENT_KEY_RETURN]	= ActionFactory::close_dialog_and_run($action);
			$add_params['reset'] = true;
			$action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $add_params);
			$attrs['actions'][GUI_EVENT_KEY_CLEAR]	= ActionFactory::close_dialog_and_run($action);
			return ActionFactory::show_dialog("Выберите жанры, страны и период", $defs,	true, 1200, $attrs);
		}
		return ActionFactory::show_title_dialog($caption, $post_action, $msg, 0);
	}
	
	public static function getVodCategories($media_url){
		static $categories = null;
		$category = null;
		if (isset($media_url->categoryId))
			$category = $media_url->categoryId;
		if (is_null($categories)){
			$categories['categories'][] = array('id'=> 'search', 'class' => 'SmartSearchScreen', 'caption' => 'Поиск');
			$categories['categories'][] = array('id'=> '/', 'class' => 'SmartVodListScreen', 'caption' => 'Все');
			$doc = iconv('windows-1251', 'UTF-8', self::http_get_document(self::getDomainName()));
			self::checkLogIn();
			if (preg_match('|menu-items">(.*?)</nav>|ms', $doc, $m)){
				if (preg_match_all ('|class="title">(.*?)<i.*?</div>\s*?</div>|ms', $m[1], $match)){

					foreach ($match[0] as $k => $v){
						$categories['categories'][] = array('id'=> "catalog_$k", 'class' => 'SmartVodCategoryListScreen', 'caption' => HD::get_upper(HD::str_remove_tag($match[1][$k])));
						if (HD::str_remove_tag($match[1][$k]) == 'мультфильмы')
							$categories['categories'][] = array('id'=> '/multserialy/', 'class' => 'SmartVodListScreen', 'caption' => 'Мультсериалы');
						if (preg_match_all ('|href="(.*?)".*?>(.*?)</a>|ms',  $v, $matches)){
							foreach($matches[1] as $key => $vel){
								if (preg_match("/premiere|random/",$vel))
									continue;
								$categories['subCategories']["catalog_$k"][] = array('id'=> str_replace(array(self::getDomainName(), '/playlists/filmy'), array('','/playlists/films'), $vel), 'class' => 'SmartVodListScreen', 'caption' => HD::str_remove_tag($matches[2][$key]));
							}
						}
					}
				}
			}
		}
		if ($category==true)
			return $categories['subCategories'][$category];
		return $categories['categories'];
	}
	public static function getRandomMovies($media_url){
		$items = array();
		$randomMovies = (HD::getItemsArr(self::$cName . 'RandomMovies') != array()) ? HD::getItemsArr(self::$cName . 'RandomMovies') : array();
		$max_years = isset($randomMovies['max_years']) ? $randomMovies['max_years'] : date('Y');
		$min_years = isset($randomMovies['min_years']) ? $randomMovies['min_years'] : '1920';
		$random_genre = isset($randomMovies['random_genre']) ? $randomMovies['random_genre'] : false;
		$random_country = isset($randomMovies['random_country']) ? $randomMovies['random_country'] : false;
		$c =  $g = '';
		if ($random_genre == true){
			if (count($random_genre) > 1)
				$g = '-g'. implode(';', $random_genre);
			else
				$g = '-g'. array_shift($random_genre);
		}
		if ($random_country == true){
			if (count($random_country) > 1)
				$c = '-c'. implode(';'. $random_country);
			else
				$c = '-c'. array_shift($random_country);
		}
		$arg = '';
		if (preg_match('|serial|',$media_url->categoryId))
			$arg = '-m7';
		if (preg_match('|mult|',$media_url->categoryId))
			$arg = '-m14';
		$opts[CURLOPT_REFERER] = self::getDomainName() . '/' . $media_url->categoryId;
		$opts [CURLOPT_POST] = true;
		$opts [CURLOPT_POSTFIELDS] = "filter=y$min_years%3B". $max_years . $c . $g . $arg;
		$doc = iconv('windows-1251', 'UTF-8', self::http_get_document(self::getDomainName() . '/engine/ajax/random_movie.php', $opts));
		if (preg_match_all ('|short".*?itemprop="url" href="(.*?)".*?</article|ms', $doc, $match)){
			foreach ($match[0] as $k => $v){
				if (preg_match('|src="(.*?)"|ms', $v, $m)){
					if ($m[1] == self::getDomainName() . '/templates/Filmix/media/img/none.png')
						$poster_url = 'plugin_file://icons/s_filmix.png';
					else
						$poster_url = self::http_get_img ($m[1]);
				}
				if (preg_match('|name" content="(.*?)"|ms', $v, $m))
					$caption = HD::str_remove_tag($m[1]);
				$path_parts = parse_url(self::getDomainName());
				if (preg_match("|".$path_parts['host']."|",$match[1][$k])){
					$tmp = explode($path_parts['host'], $match[1][$k]);
					$match[1][$k] = $tmp[1];
				}
				$short_movie = new ShortMovie(
					strval($match[1][$k]),
					strval($caption),
					strval($poster_url)
				);
				$info = '||' . $caption;
				if (preg_match('|class="origin-name.*?>(.*?)<|ms', $v, $m)){
					$caption_original = HD::str_remove_tag($m[1]);
					if ($caption_original != ''){
						$short_movie->caption_original = $caption_original;
						$info .= '|' . $caption_original;
					}else
						$info .= '|' . $caption;
				}
				if (preg_match('|class="count\s.*?>(.*?)</|ms', $v, $m))
					$info .= '||Рейтинг: ' . HD::str_remove_tag($m[1]);
				if (preg_match('|Жанр.*?>(.*?)</div|ms', $v, $m))
					$info .= '||' . HD::str_remove_tag($m[1]);
				$quality = '';
				if (preg_match('|quality">(.*?)<|ms', $v, $m)){
					$short_movie->extra_item = $quality = HD::str_remove_tag($m[1]);
					if (preg_match('|(.*)\s(\d*)|', $quality, $m)){
						$short_movie->right_top_img = $short_movie->left_bottom_img = false;
						$right_top_img = SmartConfig::getQualityIco($m[1]);
						$left_bottom_img = SmartConfig::getQualityIco($m[2]);
						if ($right_top_img == true)
							$short_movie->right_top_img = $right_top_img;
						if ($left_bottom_img == true)
							$short_movie->left_bottom_img = $left_bottom_img;
					}else{
						$right_top_img = SmartConfig::getQualityIco($quality);
						if ($right_top_img != false)
							$short_movie->right_top_img = $right_top_img;
					}
				}
				if (preg_match('|Год.*?>(.*?)</div|ms', $v, $m)){
					$short_movie->year = $year = HD::str_remove_tag($m[1]);
					$info .= "||$year $quality";
				}
				else if ($quality != '')
					$info .= '||' . $quality;
				if (preg_match('|status-1" title="(.*?)"|ms', $v, $m))
					$info .= '||Статус: Продолжается';
				if (preg_match('|class="video-in">(.*?)</|ms', $v, $m))
					$info .= '||' . HD::str_remove_tag($m[1]);
				if (preg_match('|Перевод.*?>(.*?)</div|ms', $v, $m))
					$info .= '||' . HD::str_remove_tag($m[1]);
				if (preg_match('|ежиссер.*?>(.*?)</div|ms', $v, $m)){
					$director = HD::str_remove_tag($m[1]);
					if ($director != '{director}')
						$info .= '||Режиссер: ' . $director;
				}
				if (preg_match('|ролях.*?>(.*?)</div|ms', $v, $m))
					$info .= '||В ролях: ' . HD::str_remove_tag($m[1]);
				if (preg_match('|description">(.*?)<|ms', $v, $m))
					$info .= '||' . HD::str_remove_tag($m[1]);
				$short_movie->info = $info;
				
				array_push ($items, $short_movie);
			}
		}
		return $items;
	}
	public static function getShortMovieRange ($media_url, &$m_feed){
		$items = array();
		if ($m_feed === 'end')
			return $items;
		$media_url->categoryId = str_replace('//', '/', $media_url->categoryId);
		$url = self::getDomainName() . $media_url->categoryId;
		if ($m_feed > 0){
			if (mb_substr($url, -1) != '/')
				$url .= '/';
			$url .= 'pages/' . ($m_feed + 1) . '/';
		}
		$doc = iconv('windows-1251', 'UTF-8', self::http_get_document($url));
		if (!preg_match('|<span>\d*?</span>|', $doc))
			$m_feed = 'end';
		else
			++$m_feed;
		
		if (preg_match_all ('|<article.*?href="(.*?)".*?</article|ms', $doc, $match)){
			foreach ($match[0] as $k => $v){
				if (preg_match('|src="(.*?)"|ms', $v, $m)){
					if (preg_match('|none.png$|', $m[1]))
						$poster_url = 'plugin_file://icons/poster_none.png';
					else
						$poster_url = self::http_get_img ($m[1]);
				}
				if (preg_match('|name">(.*?)</h2|ms', $v, $m))
					$caption = HD::str_remove_tag($m[1]);
				$path_parts = parse_url(self::getDomainName());
				if (preg_match("|".$path_parts['host']."|",$match[1][$k])){
					$tmp = explode($path_parts['host'], $match[1][$k]);
					$match[1][$k] = $tmp[1];
				}
				$short_movie = new ShortMovie(
					strval($match[1][$k]),
					strval($caption),
					strval($poster_url)
				);
				$info = '||' . $caption;
				if (preg_match('|alternativeHeadline">(.*?)</|ms', $v, $m)){
					$caption_original = HD::str_remove_tag($m[1]);
					if ($caption_original != ''){
						$short_movie->caption_original = $caption_original;
						$info .= '|' . $caption_original;
					}else
						$info .= '|' . $caption;
				}
				if (preg_match('|video-in">(.*?)</|ms', $v, $m))
					$info .= '||' . HD::str_remove_tag($m[1]);
				if (preg_match('|class="item">(.*?)</div|ms', $v, $m))
					$info .= '||' . str_replace(array("\r","\n"), '|', HD::str_remove_tag($m[1]));
				$quality = '';
				if (preg_match('|quality">(.*?)<|ms', $v, $m)){
					$short_movie->extra_item = $quality = HD::str_remove_tag($m[1]);
					if (preg_match('|(.*)\s(\d*)|', $quality, $m)){
						$short_movie->right_top_img = $short_movie->left_bottom_img = false;
						$right_top_img = SmartConfig::getQualityIco($m[1]);
						$left_bottom_img = SmartConfig::getQualityIco($m[2]);
						if ($right_top_img == true)
							$short_movie->right_top_img = $right_top_img;
						if ($left_bottom_img == true)
							$short_movie->left_bottom_img = $left_bottom_img;
					}else{
						$right_top_img = SmartConfig::getQualityIco($quality);
						if ($right_top_img != false)
							$short_movie->right_top_img = $right_top_img;
					}
				}
				if (preg_match('|grid-item">(.*?)</|ms', $v, $m)){
					$short_movie->year = $year = HD::str_remove_tag($m[1]);
					$info .= "||$year $quality";
				}
				else if ($quality != '')
					$info .= '||' . $quality;
				$short_movie->info = $info;
				
				array_push ($items, $short_movie);
			}
			return $items;
		}
		if (preg_match_all ('|class="film">.*?href="(.*?)".*?</a>|ms', $doc, $match)){
			foreach ($match[0] as $k => $v){
				if (preg_match('|src="(.*?)"|ms', $v, $m)){
					if ($m[1] == self::getDomainName() . '/templates/Filmix/media/img/none.png')
						$poster_url = 'plugin_file://icons/s_filmix.png';
					else
						$poster_url = self::http_get_img ($m[1]);
				}
				if (preg_match('|"film-name">(.*?)<|ms', $v, $m))
					$caption = HD::str_remove_tag($m[1]);
				$path_parts = parse_url(self::getDomainName());
				if (preg_match("|".$path_parts['host']."|",$match[1][$k])){
					$tmp = explode($path_parts['host'], $match[1][$k]);
					$match[1][$k] = $tmp[1];
				}
				$short_movie = new ShortMovie(
					strval($match[1][$k]),
					strval($caption),
					strval($poster_url)
				);
				$info = '||' . $caption . '|' . self::$cName;
				$short_movie->info = $info;
				
				array_push ($items, $short_movie);
			}
			return $items;
		}
		if (preg_match_all ('|class="short">.*?href="(.*?)".*?</article>|ms', $doc, $match)){
			foreach ($match[0] as $k => $v){
				if (preg_match('|src="(.*?)"|ms', $v, $m)){
					if (preg_match('|none.png$|', $m[1]))
						$poster_url = 'plugin_file://icons/poster_none.png';
					else
						$poster_url = self::http_get_img ($m[1]);
				}
				if (preg_match('|<h3 class="name">(.*?)</h3>|ms', $v, $m))
					$caption = HD::str_remove_tag($m[1]);
				$path_parts = parse_url(self::getDomainName());
				if (preg_match("|".$path_parts['host']."|",$match[1][$k])){
					$tmp = explode($path_parts['host'], $match[1][$k]);
					$match[1][$k] = $tmp[1];
				}
				$extra_item = false;
				if (preg_match('|class="count">(.*?)</div|ms', $v, $m)){
					$extra_item = HD::str_remove_tag($m[1]);
					if ($extra_item == '0 видео')
						continue;
				}
				$short_movie = new ShortMovie(
					strval($match[1][$k]),
					strval($caption),
					strval($poster_url)
				);
				$info = '||' . $caption;
				if (preg_match('|class="description">(.*?)</div|ms', $v, $m))
					$info .= '|' . HD::str_remove_tag($m[1]);
				if ($extra_item == true){
					$short_movie->left_top = $short_movie->extra_item = $extra_item;
					$short_movie->left_top_img = 'plugin_file://icons/bt.png';
					$info .= '|' . $extra_item;
				}
				if (preg_match('|class="rating".+?>(.*?)</span>|ms', $v, $m))
					$info .= '||' . HD::str_remove_tag($m[1]);
				if (preg_match('|class="date">(.*?)</div|ms', $v, $m))
					$info .= '|' . HD::str_remove_tag($m[1]);
				$short_movie->info = $info;
				$short_movie->goToScreen = 'SmartVodListScreen';
				array_push ($items, $short_movie);
			}
			return $items;
		}
		return $items;
	}
	
	public static function getSearchShortMovieRange ($keyword, &$m_feed){
		if (is_object($keyword))
			$keyword = $keyword->searchStr;
		$items = array();
		if ($m_feed === 'end')
			return $items;
		$keyword = urlencode($keyword);
		$opts [CURLOPT_POST] = true;
		$opts [CURLOPT_POSTFIELDS] = "scf=fx&story=$keyword&search_start=$m_feed&do=search&subaction=search&years_ot=1902&years_do=". (date('Y') + 1) . "&kpi_ot=1&kpi_do=10&imdb_ot=1&imdb_do=10&sort_name=&undefined=asc&sort_date=&sort_favorite=";
		$header[] = "X-Requested-With: XMLHttpRequest";
		$header[] = "Referer: " . self::getDomainName() . '/search/' . $keyword;
		$header[] = "Origin: " . self::getDomainName();
		$header[] = "Cookie: FILMIXNET=" . substr(md5(rand (0,1000)), 0, 26) . ";";
		$opts[CURLOPT_HTTPHEADER] = $header;
		$doc =  HD::http_get_document(self::getDomainName() . '/engine/ajax/sphinx_search.php', $opts);
		if (!preg_match('|class="navigation|', $doc))
			$m_feed = 'end';
		else if (preg_match('|</span> <span>\d*</span> <\!|', $doc))
			$m_feed = 'end';
		else
			++$m_feed;
		if (preg_match_all ('|short".*?itemprop="url" href="(.*?)".*?</article|ms', $doc, $match)){
			foreach ($match[0] as $k => $v){
				if (preg_match('|src="(.*?)"|ms', $v, $m)){
					if ($m[1] == self::getDomainName() . '/templates/Filmix/media/img/none.png')
						$poster_url = 'plugin_file://icons/s_filmix.png';
					else
						$poster_url = self::http_get_img ($m[1]);
				}
				if (preg_match('|" title="(.*?)"|ms', $v, $m))
					$caption = HD::str_remove_tag($m[1]);
				$path_parts = parse_url(self::getDomainName());
				if (preg_match("|".$path_parts['host']."|",$match[1][$k])){
					$tmp = explode($path_parts['host'], $match[1][$k]);
					$match[1][$k] = $tmp[1];
				}
				if (class_exists('ShortMovie')){
					$short_movie = new ShortMovie(
						strval($match[1][$k]),
						strval($caption),
						strval($poster_url)
					);
				}
				$info = '||' . $caption;
				if (preg_match('|class="origin-name.*?>(.*?)<|ms', $v, $m)){
					$caption_original = HD::str_remove_tag($m[1]);
					if ($caption_original != ''){
						if (class_exists('ShortMovie'))
							$short_movie->caption_original = $caption_original;
						$info .= '|' . $caption_original;
					}else
						$info .= '|' . $caption;
				}
				if (preg_match('|class="count\s.*?>(.*?)</|ms', $v, $m))
					$info .= '||Рейтинг: ' . HD::str_remove_tag($m[1]);
				if (preg_match('|Жанр.*?>(.*?)</div|ms', $v, $m))
					$info .= '||' . HD::str_remove_tag($m[1]);
				$quality = '';
				
				if (preg_match('|quality">(.*?)<|ms', $v, $m)){
					$quality = HD::str_remove_tag($m[1]);
					if (class_exists('ShortMovie')){
						$short_movie->extra_item = $quality;
						if (preg_match('|(.*)\s(\d*)|', $quality, $m)){
							$short_movie->right_top_img = $short_movie->left_bottom_img = false;
							$right_top_img = SmartConfig::getQualityIco($m[1]);
							$left_bottom_img = SmartConfig::getQualityIco($m[2]);
							if ($right_top_img == true)
								$short_movie->right_top_img = $right_top_img;
							if ($left_bottom_img == true)
								$short_movie->left_bottom_img = $left_bottom_img;
						}else{
							$right_top_img = SmartConfig::getQualityIco($quality);
							if ($right_top_img != false)
								$short_movie->right_top_img = $right_top_img;
						}
					}
				}
				if (preg_match('|Год.*?>(.*?)</div|ms', $v, $m)){
					$year = HD::str_remove_tag($m[1]);
					if (class_exists('ShortMovie'))
						$short_movie->year = $year;
					$info .= "||$year $quality";
				}
				else if ($quality != '')
					$info .= '||' . $quality;
				if (preg_match('|status-1" title="(.*?)"|ms', $v, $m))
					$info .= '||Статус: Продолжается';
				if (preg_match('|class="video-in">(.*?)</|ms', $v, $m))
					$info .= '||' . HD::str_remove_tag($m[1]);
				if (preg_match('|Перевод.*?>(.*?)</div|ms', $v, $m))
					$info .= '||' . HD::str_remove_tag($m[1]);
				if (preg_match('|ежиссер.*?>(.*?)</div|ms', $v, $m))
					$info .= '||Режиссер: ' . HD::str_remove_tag($m[1]);
				if (preg_match('|ролях.*?>(.*?)</div|ms', $v, $m))
					$info .= '||В ролях: ' . HD::str_remove_tag($m[1]);
				if (preg_match('|description">(.*?)<|ms', $v, $m)){
					$description = HD::str_remove_tag($m[1]);
					$info .= '||' . $description;
				}
				if (class_exists('ShortMovie')){
					$short_movie->info = $info;
					array_push ($items, $short_movie);
				}else{
					$arr['filmixId'] = strval($match[1][$k]);
					$arr['infoArr']['caption'] = $caption;
					$arr['infoArr']['poster_url'] = $poster_url;
					if (isset($description))
						$arr['infoArr']['description'] = $description;
					if (isset($year))
						$arr['infoArr']['year'] = $year;
					if (isset($caption_original))
						$arr['infoArr']['caption_original'] = $caption_original;
					// $arr['infoArr']['detailed_info'] = $info;
					array_push ($items, $arr);
				}
			}
		}
		
		return $items;
	}
	
	public static function load_movie($movie_id, $mUrl, $getMovieInfo){
		$arr = array();
		$arr['caption'] = $arr['class_info']['catalog_info']['caption'] = $mUrl->caption;
		$arr['poster_url'] = $arr['class_info']['catalog_info']['poster_url'] = $mUrl->poster_url;
		if (isset($mUrl->caption_original))
			$arr['caption_original'] = $arr['class_info']['catalog_info']['caption_original'] = $mUrl->caption_original;
		if (isset($mUrl->year))
			$arr ['year'] = $arr['class_info']['catalog_info']['year'] = $mUrl->year;
		if (!preg_match("|^http|",$movie_id))
			$url = self::getDomainName() . $movie_id;
		else
			$url = preg_replace('#((http.*)://.+?\/)#i', self::getDomainName() . "/", $movie_id);
		$opts [CURLOPT_USERAGENT]    = "Mozilla/5.0 (Windows NT 6.1; Trident/7.0; rv:11.0) like Gecko";
		$doc = iconv('windows-1251', 'UTF-8', self::http_get_document($url, $opts));
		if (preg_match('|name" itemprop="name">(.*?)</|ms', $doc, $match))
			$arr['caption_original'] = $arr['caption'] = HD::str_remove_tag($match[1]);
		if (preg_match('|alternativeHeadline">(.*?)</|ms', $doc, $match))
			$arr['caption_original'] = HD::str_remove_tag($match[1]);
		if (preg_match('|full-story">(.*?)</div>|ms', $doc, $match))
			$arr['description'] = HD::str_remove_tag($match[1]);
		if (preg_match('|image" content="(.*?)"|ms', $doc, $match))
			$arr['poster_url'] = self::http_get_img($match[1]);
		if (preg_match('|Режиссер:(.*?)</div>|ms', $doc, $match))
			$arr['director'] = HD::str_remove_tag($match[1]);
		if (preg_match('|В ролях:(.*?)</div>|ms', $doc, $match))
			$arr['actors'] = HD::str_remove_tag($match[1]);
		if (preg_match('|Жанр:(.*?)</div>|ms', $doc, $match))
			$arr['genres'] = HD::str_remove_tag($match[1]);
		if (preg_match('|Страна:(.*?)</div>|ms', $doc, $match))
			$arr ['country'] = HD::str_remove_tag($match[1]);
		if (preg_match('|Год:(.*?)</div>|ms', $doc, $match)){
			$year = HD::str_remove_tag($match[1]);
			if (preg_match('|\d{4}$|', $year))
				$arr ['year'] = $year;
			else{
				$arr ['country'] .= ', ' . $year;
				$arr ['year'] = $year;
			}
		}
		if (preg_match('|class="ico">В эфире|', $doc))
			$arr ['rate_details']['S:'] = 'Продолжается';
		if (preg_match('|ratePos">(.*?)</|ms', $doc, $m)){
				$ratePos = '+' . HD::str_remove_tag($m[1]);
			if (preg_match('|rateNeg">(.*?)</|ms', $doc, $m))
				$rateNeg = '-' .HD::str_remove_tag($m[1]);
			$arr ['rate_details'][$ratePos] = $rateNeg;
		}
		if (preg_match('|class="quality">(.*?)</div>|ms', $doc, $match)){
			$quality = HD::str_remove_tag($match[1]);
			if (preg_match('|(.*)\s(\d*)|', $quality, $m)){
				$arr ['rate_details']['Q:'] = $m[1];
				$arr ['rate_details']['R:'] = $m[2];
			}else
				$arr ['rate_details']['Q:'] = $quality;
		}
		if (preg_match('|Сценарист:(.*?)</div>|ms', $doc, $match))
			$arr ['scenario'] = HD::str_remove_tag($match[1]);
		if (preg_match('|Перевод:(.*?)</div>|ms', $doc, $match))
			$arr ['details']['Перевод::'] = HD::str_remove_tag($match[1]);
		if (preg_match('|Слоган:(.*?)</div>|ms', $doc, $match))
			$arr ['details']['Слоган:'] = HD::str_remove_tag($match[1]);
		if (preg_match('|Показ Мир:(.*?)</div>|ms', $doc, $match))
			$arr ['details']['Показ Мир:'] = HD::str_remove_tag($match[1]);
		if (preg_match('|class="kinopoisk.*?>(.*?)</div>|ms', $doc, $match))
			$arr ['rate_kinopoisk'] = HD::str_remove_tag($match[1]);
		if (preg_match('|class="imdb.*?>(.*?)</div>|ms', $doc, $match))
			$arr ['rate_imdb'] = HD::str_remove_tag($match[1]);
		if (preg_match('|Время:(.*?) м|ms', $doc, $match))
			$arr ['length'] = HD::str_remove_tag($match[1]);
		$kpIDs = HD::getItemsArr('kpIDs');
		if (isset($kpIDs[$movie_id]))
			$arr['class_info']['dbIDs']['kpID'] = $kpIDs[$movie_id];
		if (preg_match('|frames-list">(.*?)</ul>|ms', $doc, $match)){
			if (preg_match_all ('|<a href="(.*?)"|ms', $match[1], $matches))
				foreach ($matches[1] as $k => $v)
					$arr ['background_urls'][] = self::http_get_img ($v);
		}
		if ($getMovieInfo != 'min')
			$arr = SmartConfig::getMovieInfoArr($getMovieInfo, $movie_id, $mUrl, $arr);
		return $arr;
	}
	public static function getIframe($params){
		$iframeInfo = array();
		if ((isset($params['caption_original']))&&(preg_match('|(.*?)\n|', $params['caption_original'], $m)))
			$params['caption_original'] = $m[1];
		if ((isset($params['country']))&&(preg_match('|(\d{4})|', $params['country'], $m))){
			$params['year'] = $m[1];
			unset($params['country']);
		}
		if (isset($params['movie_id']))
			$filmixId =  $params['movie_id'];
		if ((!isset($filmixId))&&(HD::strSanitizing($params['caption_original']) != HD::strSanitizing($params['caption']))){
			$year = 'null';
			if (isset($params['year']))
				$year = $params['year'];
			if (isset($params['caption_original'])){
				$keyword = $params['caption_original'];
				$m_feed= 0;
				$arr = self::getSearchShortMovieRange ($keyword, $m_feed);
				foreach ($arr as $k => $v){
					if ((isset($v['infoArr']['caption_original']))&&(HD::strSanitizing($keyword) == HD::strSanitizing($v['infoArr']['caption_original']))){
						if ((isset($v['infoArr']['year']))&&(preg_match('|(\d{4})|', $v['infoArr']['year'], $m))){
							if (trim($m[1]) == trim($year)){
								extract ($v);
								$iframeInfo['infoArr'] = $infoArr;
								break;
							}
						}
					}
				}
			}
		}
		if (!isset($filmixId)){
			$year = 'null';
			if (isset($params['year']))
				$year = $params['year'];
			$keyword = $params['caption'];
			$m_feed= 0;
			$arr = self::getSearchShortMovieRange ($keyword, $m_feed);
			foreach ($arr as $k => $v){
				if ((isset($v['infoArr']['caption']))&&(HD::strSanitizing($keyword) == HD::strSanitizing($v['infoArr']['caption']))){
					if ((isset($v['infoArr']['year']))&&(preg_match('|(\d{4})|', $v['infoArr']['year'], $m))){
						if (trim($m[1]) == trim($year)){
							extract ($v);
							$iframeInfo['infoArr'] = $infoArr;
							break;
						}
					}
				}
			}
			if (!isset($filmixId)){
				if (count($arr) > 0){
					extract ($arr[0]);
					$iframeInfo['infoArr'] = $infoArr;
				}
			}
		}
		if (isset($filmixId)){
			$iframe = FilmixNext::getIframe (self::getDomainName() . $filmixId, 'video_id');
			foreach ($iframe as $k => $v){
				if (preg_match("|EpisodId_|", $v))
					$iframeInfo['urls'][$k]['goTo'] = 'VodSeriesListScreen';
				else
					$iframeInfo['urls'][$k]['goTo'] = 'VodSeasonListScreen';
				$iframeInfo['urls'][$k]['link'] = $v;
			}
		}else{
			echo "\n".self::$cName.":search failed";
			return array("status"=>false);
		}
		return $iframeInfo;
	}
	public static function getSeasons($media_url){
		if (preg_match("|filmixId_|", $media_url->link))
			$urls = FilmixNext::getIframe ($media_url->link, 'video_id');
		else if (preg_match("|filmix|", $media_url->link))
			$urls = FilmixNext::getIframe ($media_url->link, 'translation');
		foreach ($urls as $k => $v){
			$uArr[$k]['caption'] = $k;
			$uArr[$k]['link'] = $v;
			$uArr[$k]['detailed_info'] = '||' . $k . $media_url->detailed_info;
			$uArr[$k]['class_name'] = $media_url->class_name;
			$uArr[$k]['poster_url'] = $media_url->poster_url;
			$uArr[$k]['goTo'] = 'VodSeasonListScreen';
			if (preg_match("|SeasonId|",$v)){
				$uArr[$k]['season'] = $k;
				$uArr[$k]['goTo'] = 'VodSeriesListScreen';
			}
		}
		return $uArr;
	}
	public static function get_series_list($media_url, $movie){
		$items = array();
		if (preg_match('|EpisodId_|', $media_url->link)){
			$qltyMax = false;
			if (preg_match('|(.+?)\sQ:(\d+)|', $media_url->caption, $m))
				$qltyMax = $m[2];
			$hash_patrs = $media_url->caption;
			if (isset($media_url->hash_patrs)){
				$hash_patrs = implode("", (array)$media_url->hash_patrs);
			}
			$items[$media_url->caption]['id'] = md5 ($hash_patrs);
			$items[$media_url->caption]['title'] = $media_url->caption;
			$items[$media_url->caption]['playback_url'] = $media_url->link;
			$items[$media_url->caption]['is_stream_url'] = false;
			$items[$media_url->caption]['file_info']['poster_url'] = $media_url->poster_url;
			$items[$media_url->caption]['file_info']['details_box_width'] = true;
			$items[$media_url->caption]['file_info']['class_name'] = $media_url->class_name;
			if (isset($media_url->description))
				$items[$media_url->caption]['file_info']['description'] = $media_url->description;
			$items[$media_url->caption]['file_info']['detailed_info'] = $media_url->detailed_info;
			if ($qltyMax == true)
				$items[$media_url->caption]['file_info']['qltyMax'] = $qltyMax;
			return $items;
		}
		$episodes = FilmixNext::getIframe ($media_url->link, 'season');
		if ($episodes == true){
			foreach ($episodes as $key => $vel){
				$qltyMax = false;
				if (preg_match('|(.+?)\sQ:(\d+?)$|', $key, $m)){
					$key = $m[1];
					$qltyMax = $m[2];
				}
				$tvshow_se = VideoInfo::tvshow_se_parse($key);
				if (isset($tvshow_se['S']))
					$media_url->hash_patrs->season = $tvshow_se['S'];
				if (isset($tvshow_se['E']))
					$media_url->hash_patrs->episode = $tvshow_se['E'];
				else
					$media_url->hash_patrs->episode = $key;
				$hash_patrs = implode("", (array)$media_url->hash_patrs);
				$items[$key]['id'] = md5 ($hash_patrs);
				$items[$key]['title'] = $key;
				$items[$key]['playback_url'] = $vel;
				$items[$key]['is_stream_url'] = false;
				$items[$key]['file_info']['poster_url'] = $media_url->poster_url;
				$items[$key]['file_info']['details_box_width'] = true;
				$items[$key]['file_info']['class_name'] = $media_url->class_name;
				$items[$key]['file_info']['detailed_info'] = $media_url->detailed_info;
				if (isset($media_url->description))
					$items[$key]['file_info']['description'] = $media_url->description;
				if ($qltyMax == true)
					$items[$key]['file_info']['qltyMax'] = $qltyMax;
			}
		}
		return $items;
	}
	public static function getVodSourceInfo($v){
		self::checkLogIn();
		$ico = SmartConfig::getPluginIco($v);
		$arr['caption'] = self::$cName;
		$arr['icon_path'] = $ico;
		$arr['detailed_icon_path'] = $ico;
		$arr['class_name'] = $v;
		$arr['detailed_info'] = '||' . self::$cName . '|видео с сайта '.self::$cName.'. Поиск видео на сайте '.self::$cName.' производится по названию возможны неточности.';
		$arr['type'] = SmartConfig::getPluginIco('onlineSource');
		return $arr;
	}
	
	public static function getScreenActionMapArr($media_url){
		$actionsArr = array();
		return $actionsArr;
	}
	public static function http_get_img ($url){
		if (self::$proxy == true){
			$path_parts = parse_url(self::getDomainName());
			if (!preg_match("|^http|",$url))
				return DuneSystem::$properties['plugin_cgi_url'] . "do?img=" . self::getDomainName() . $url . "&proxy=" . self::$cName;
			if (preg_match("|".$path_parts['host']."|",$url))
				return DuneSystem::$properties['plugin_cgi_url'] . "do?img=" . $url . "&proxy=" . self::$cName;
		}
		if (!preg_match("|^http|",$url))
			return DuneSystem::$properties['plugin_cgi_url'] . "do?img=" . self::getDomainName() . $url;
		return DuneSystem::$properties['plugin_cgi_url'] . "do?img=" . $url;
	}
	
	public static function http_get_document ($url, $opts=null){
		if (!isset($opts[CURLOPT_COOKIEJAR])){
			$cgr = true;
			if (!file_exists(self::cookie()))
				$cgr = self::testEneyIn();
			if ($cgr == true)
				$opts[CURLOPT_COOKIEJAR] = $opts[CURLOPT_COOKIEFILE] = self::cookie();
		}
		if (is_null(self::$proxy)){
			self::$proxy = false;
			$sitesProxy = HD::getItemsArr('sitesProxy');
			if (isset($sitesProxy[self::$cName])){
				$proxySettings = (HD::getItemsArr('proxySettings') != array()) ? HD::getItemsArr('proxySettings') : array();
				if (isset($proxySettings['proxy'])){
					self::$proxy['proxy'] = $proxySettings['proxy'];
					if ((isset($proxySettings['proxyType']))&&($proxySettings['proxyType'] == 'SOCKS5'))
						self::$proxy['proxyType'] = $proxySettings['proxyType'];
					if (isset($proxySettings['proxyAccount']))
						self::$proxy['proxyAccount'] = $proxySettings['proxyAccount'];
				}
			}
		}
		if (self::$proxy == true){
			$opts[CURLOPT_PROXY] = self::$proxy['proxy'];
			if (isset(self::$proxy['proxyType']))
				$opts[CURLOPT_PROXYTYPE] = CURLPROXY_SOCKS5;
			if (isset(self::$proxy['proxyAccount']))
				$opts[CURLOPT_PROXYUSERPWD] = self::$proxy['proxyAccount'];
		}
		if (!isset($opts[CURLOPT_USERAGENT]))
			$opts[CURLOPT_USERAGENT] = 'User-Agent: Mozilla/5.0 (Web0S; Linux/SmartTV) AppleWebKit/538.2 (KHTML, like Gecko) Large Screen Safari/538.2 LG Browser/7.00.00(LGE; 65LF6300-UA; 04.00.30; 1; DTV_W15M); webOS.TV-2015';
		return HD::http_get_document($url, $opts);
	}
}
?>
