<?
class Kinopoisk_Class {
	static $cName = 'Kinopoisk';
	static $className = 'Kinopoisk_Class';
	static $proxyArr = null;
	static $proxyArrMd5 = null;
	static $proxy = null;
	static $kpAccess = 'noCheck';
	public static function getDomainName(){
		return 'http://www.kinopoisk.ru';
	}
	public static function get_media_url_str($k, $arr=null){
		if ($arr == true)
			return SmartVodCategoryListScreen::get_media_url_str($k, $arr);
		return SmartVodCategoryListScreen::get_media_url_str($k);
	}
	public static function getSearchMediaUrlStr($k, $arr=null){
		return SmartVodListScreen::get_media_url_str($k, $arr);
	}
	public static function getMainMenuInfo(){
		// $arr[] = array (
			// 'name' => self::$cName,
			// 'descr' => '||Kinopoisk|каталог Kinopoisk|Если сайт Kinopoisk не доступен используйте прокси или VPN, без доступа к этому каталогу могут не отображатся некоторые постеры, и будут не доступны некоторые функции плагина.',
			// 'ico' => SmartConfig::getPluginIco(self::$className),
			// 'mUrl' => self::get_media_url_str(self::$className, array('caption' => self::$cName))
		// );
		$arr[] = array (
			'name' => 'Случайные',
			'descr' => '||Случайные фильмы|от Kinopoisk|Если сайт Kinopoisk не доступен используйте прокси или VPN, без доступа к этому каталогу могут не отображатся некоторые постеры, и будут не доступны некоторые функции плагина.',
			'ico' => SmartConfig::getPluginIco('kprandom'),
			'mUrl' => VodRandomScreen::get_media_url_str(self::$className, array('iconId'=> 'kprandom', 'caption' => 'Случайные'))
		);
		return $arr;
	}
	public static function getPopUpMenuItems ($selected_media_url, $parent_media_url){
		$menu_items = array();
		if ($parent_media_url == 'main_menu'){
			$menu_items[] = array(
				'caption' => 'Прокси для ' . self::$cName,
				'params' => array ('action' => 'proxy'),
				'icon_url' => SmartConfig::getPluginIco('s_proxy')
			);
			$menu_items[] = array(
				'caption' => 'API токен',
				'params' => array ('action' => 'apiToken'),
				'icon_url' => SmartConfig::getPluginIco('s_proxy')
			);
			$menu_items[] = 'is_separator';
		}
		$parent_media_url = MediaURL::decode($parent_media_url);
		if ((isset($parent_media_url->screen_id))&&($parent_media_url->screen_id != 'vod_series')){
			$menu_items[] = array(
				'caption' => 'Добавить в Главное меню',
				'params' => array ('action' => 'addToMainMenu'),
				'icon_url' => SmartConfig::getPluginIco('s_home')
			);
		}
		return $menu_items;
	}
	public static function getVodCategories($media_url){
		static $categories = null;
		$category = null;
		if (isset($media_url->categoryId))
			$category = $media_url->categoryId;
		
		$categories['categories'][] = array('id'=> 'search', 'class' => 'SmartSearchScreen', 'caption' => 'Поиск');
		$cf ['Популярные фильмы'] 			= 'kp_item_top_popular_films';
		$cf ['Лучшие фильмы'] 				= 'kp_item_top_best_films';
		$cf ['Самые кассовые'] 				= 'kp_item_most_box_office';
		$cf ['Самые ожидаемые'] 			= 'kp_item_top_await';
		foreach ($cf as $kf => $vf)
			$categories['categories'][] = array('id'=> $vf, 'class' => 'SmartVodCategoryListScreen', 'caption' => $kf);
		$categories['categories'][] = array('id'=> 'soon_films', 'class' => 'SmartVodListScreen', 'caption' => 'Скоро');
		$categories['categories'][] = array('id'=> 'kp_item_top_popular_people', 'class' => 'SmartVodListScreen', 'caption' => 'Самые популярные имена');
		$categories['categories'][] = array('id'=> 'trailers_view', 'class' => 'SmartVodCategoryListScreen', 'caption' => 'Трейлеры');
		$categories['subCategories']['trailers_view'][] = array('id'=> "new", 'class' => 'SmartVodListScreen', 'caption' => 'Новые');
		$categories['subCategories']['trailers_view'][] = array('id'=> "popular", 'class' => 'SmartVodListScreen', 'caption' => 'Популярные');
		$categories['subCategories']['trailers_view'][] = array('id'=> "soon", 'class' => 'SmartVodListScreen', 'caption' => 'Скоро');
		
		if ($category==true){
			if (!isset($categories['subCategories'][$category])){
				$jsd = self::getKPGenresView();
				foreach ($cf as $kf => $vf)
					$categories['subCategories'][$vf][] = array('id'=> $vf . "___", 'class' => 'SmartVodListScreen', 'caption' => 'Все');
				foreach ($jsd->genreData as $v){
					foreach ($cf as $kf => $vf)
						$categories['subCategories'][$vf][] = array('id'=> $vf . "___" . $v->genreID, 'class' => 'SmartVodListScreen', 'caption' => HD::get_upper($v->genreName));
				}
			}
			return $categories['subCategories'][$category];
		}
		return $categories['categories'];
	}
	
	public static function getScreenActionMapArr($media_url){
		$actionsArr = array();
		if(isset($media_url->searchKpId)){
			$actionsArr[0]['create_action'] = 'classAction';
			$actionsArr[0]['params'] = array ('action' => 'searchKpId', 'addId' => false);
			$actionsArr[0]['caption'] = 'Задать kpID';
			$actionsArr[0]['key'] = GUI_EVENT_KEY_C_YELLOW;
			
			$actionsArr[1]['create_action'] = 'classAction';
			$actionsArr[1]['params'] = array ('action' => 'searchKpId', 'searchStr' => false);
			$actionsArr[1]['caption'] = 'Искать kpID';
			$actionsArr[1]['key'] = GUI_EVENT_KEY_B_GREEN;
		}
		return $actionsArr;
	}
	public static function getVodSourceInfo($v){
		return false;
	}
	public function classAction ($defs, $user_input, $select_url = null){
		hd_restore_warnings();
		$post_action = null;
		$caption = 'Error!';
		$msg = 'classAction: action';
		$width = 1050;
		if ($user_input->action == 'reviews'){
			static $commentСounter = null;
			$add_params['control_id']= $user_input->control_id;
			$add_params['action'] = $user_input->action;
			$add_params['indiClass'] = self::$className;
			if (isset($user_input->kpID))
				$add_params['kpID'] = $user_input->kpID;
			
			if (isset($user_input->nextPageToken)){
				$commentСounter[$user_input->kpID] = $nextPageToken = $user_input->nextPageToken;
			}else{
				if (isset($commentСounter[$user_input->kpID])){
					$add_params ['nextPageToken'] = $commentСounter[$user_input->kpID];
					ControlFactory::add_button_close(&$defs, $this, $add_params, $user_input->control_id, '', 'Да', 350);
					$add_params ['nextPageToken'] = 0;
					ControlFactory::add_button_close(&$defs, $this, $add_params, $user_input->control_id, '', 'Нет', 350);
					$commentСounter = null;
					return  ActionFactory::show_dialog('Продолжить просмотр?' ,$defs, true);
				}else{
					$commentСounter = null;
					$nextPageToken = 0;
				}
			}
			if (isset($user_input->kpID)){
				$jsd = Kinopoisk_Class::parse_film_review($user_input->kpID, $nextPageToken);
				if (!isset($jsd->review))
					return ActionFactory::show_title_dialog("Отзывов нет.");
				$caption = $jsd->review->reviewTitle;
				$coment = $jsd->review->reviewDescription;
				$w = 1500;
				if ($jsd->review->reviewType=='kp_review_neutral')
					$reviewType = '<text color="23" dy="-80" size="small">Рецензия: </text><text dy="-80" color="15" size="small">нейтральная</text>';
				if ($jsd->review->reviewType=='kp_review_negative')
					$reviewType = '<text color="23" dy="-80" size="small">Рецензия: </text><text dy="-80" color="4" size="small">негативная</text>';
				if ($jsd->review->reviewType=='kp_review_positive')
					$reviewType = '<text color="23" dy="-80" size="small">Рецензия: </text><text dy="-80" color="10" size="small">позитивная</text>';
					
				$smartLabel0 = '<icon width="95" height="135">'.Kinopoisk_Class::http_get_img("http://st.kp.yandex.net/images/".$jsd->review->reviewAutorImageURL).'</icon>';
				$smartLabel1 = '<gap width="120"/><text color="23" dy="-80">Автор: </text><text color="15" dy="-80">'.$jsd->review->reviewAutor.'</text>';
				$smartLabel2 = '<gap width="120"/>'.$reviewType.'<text dy="-80" color="23" size="small"> Дата: </text><text color="15" dy="-80" size="small">'.$jsd->review->reviewData.' </text><text color="23" dy="-80" size="small">Полезная:</text> <text color="10" dy="-80" size="small"> Да - </text><text color="15" dy="-80" size="small">'.$jsd->review->userPositiveRating.'</text><text color="4" dy="-80" size="small"> Нет - </text><text color="15" dy="-80" size="small">'.$jsd->review->userNegativeRating.'</text>';
				$smartLabel3 = '<gap width="120"/><text dy="-80" color="18" size="small">[</text><text dy="-80" color="10" size="small">'. ($nextPageToken+1) .'</text><text dy="-80" color="18" size="small"> из </text><text dy="-80" color="10" size="small">' .  $jsd->reviewAllCount . '</text><text dy="-80" color="18" size="small">] Рецензии:</text><text dy="-80" color="15" size="small"> [ </text>
					<icon width="35" height="35" dy="-80">'.DuneSystem::$properties['install_dir_path'].'/icons/kp_review_positive.png</icon>
					<text dy="-80" color="18" size="small"> - ' . $jsd->reviewPositiveCount . '</text><text dy="-80" color="15" size="small"> ][ </text>
					<icon width="35" height="35" dy="-80">'.DuneSystem::$properties['install_dir_path'].'/icons/kp_review_negative.png</icon>
					<text dy="-80" color="4" size="small"> - ' . $jsd->reviewNegativeCount. '</text><text dy="-80" color="15" size="small"> ][ </text>
					<icon width="35" height="35" dy="-80">'.DuneSystem::$properties['install_dir_path'].'/icons/kp_review_neutral.png</icon>
					<text dy="-80" color="14" size="small"> - ' . $jsd->reviewNeutralCount . '</text><text dy="-80" color="15" size="small"> ] </text><text dy="-80" color="18" size="small"> Положительных: </text><text dy="-80" color="10" size="small">' . $jsd->reviewAllPositiveRatio . '</text>';
					$reviewAllCount = $jsd->reviewAllCount;
			}
			ControlFactory::add_smart_label($defs,"", $smartLabel0);
			ControlFactory::add_smart_label($defs,"", $smartLabel1);
			ControlFactory::add_vgap($defs, -20);
			ControlFactory::add_smart_label($defs,"", $smartLabel2);
			ControlFactory::add_vgap($defs, -20);
			ControlFactory::add_smart_label($defs,"", $smartLabel3);
			ControlFactory::add_vgap($defs, -80);
			ControlFactory::add_multiline_label($defs, '', $coment, 12);
			$arrowLeft = $arrowRight = '';
			if ($nextPageToken != 0){
				$add_params['nextPageToken']= $nextPageToken - 1;
				$action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $add_params);
				$attrs['actions'][GUI_EVENT_KEY_PREV]	= ActionFactory::close_dialog_and_run($action);
				$attrs['actions'][GUI_EVENT_KEY_REW]	= ActionFactory::close_dialog_and_run($action);
				$attrs['actions'][GUI_EVENT_KEY_LEFT]	= ActionFactory::close_dialog_and_run($action);
				$arrowLeft = '<icon width="24" height="35" >/firmware/skin/special_icons/pane_pointer_left.aai</icon>';
			}
			if ($nextPageToken < $reviewAllCount){
				$add_params['nextPageToken']= $nextPageToken + 1;
				$action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $add_params);
				$attrs['actions'][GUI_EVENT_KEY_NEXT]	= ActionFactory::close_dialog_and_run($action);
				$attrs['actions'][GUI_EVENT_KEY_FWD]	= ActionFactory::close_dialog_and_run($action);
				$attrs['actions'][GUI_EVENT_KEY_RIGHT]	= ActionFactory::close_dialog_and_run($action);
				$arrowRight = '<icon width="24" height="35" >/firmware/skin/special_icons/pane_pointer_right.aai</icon>';
			}
			$attrs['actions'][GUI_EVENT_KEY_STOP]	= ActionFactory::close_dialog();
			ControlFactory::add_smart_label($defs, "", $arrowLeft . '<text color="23" size="tiny"> навигация стрелками вправо и влево </text>' . $arrowRight);
			return  ActionFactory::show_dialog($caption, $defs, true, $w, $attrs);
		}
		if (isset($user_input->selected_media_url))
			$selected_media_url = MediaURL::decode($user_input->selected_media_url);
		else{
			$msg = 'classAction: selected_media_url';
			return ActionFactory::show_title_dialog($caption, $post_action, $msg, 0);
		}
		$class_name = $selected_media_url->class_name;
		$parent_media_url = MediaURL::decode($user_input->parent_media_url);
		
		if ($user_input->action == 'randomGenres'){
			static $jsd = null;
			$add_params['indiClass']= $class_name;
			$add_params['control_id']= $user_input->control_id;
			$add_params['action'] = $user_input->action;
			if (isset($user_input->reset))
				if (HD::saveItemsArr(self::$cName . 'RandomMovies', array()) == false)
					return ActionFactory::show_title_dialog("Сохранение не удалось");
			$randomMovies = (HD::getItemsArr(self::$cName . 'RandomMovies') != array()) ? HD::getItemsArr(self::$cName . 'RandomMovies') : array();
			$random_max_years = isset($randomMovies['max_years']) ? $randomMovies['max_years'] : date('Y');
			$random_min_years = isset($randomMovies['min_years']) ? $randomMovies['min_years'] : '1920';
			$random_genre = isset($randomMovies['random_genre']) ? $randomMovies['random_genre'] : array();
			$random_country = isset($randomMovies['random_country']) ? $randomMovies['random_country'] : array();
			if ($jsd == false)
				$jsd = self::navigatorFilters();
			if ((isset($user_input->selected_control_id))&&(isset($user_input->action_type))){
				$params['indiClass']= $class_name;
				$params['initial_sel_ndx'] = $user_input->initial_sel_ndx;
				$params['action'] = $user_input->action;
				if ($user_input->selected_control_id == 'random_country'){
					$flipRandomCountry = array_flip ($random_country);
					if ($user_input->random_country == ''){
						unset($randomMovies['random_country']);
					}else if ($user_input->random_country == 'all'){
						$random_country = array();
						foreach ($country_jsd as $k => $v)
							$random_country[] = str_replace('f', '', $k);
						$randomMovies['random_country'] = $random_country;
					}else if (isset($flipRandomCountry[$user_input->random_country])){
						unset ($flipRandomCountry[$user_input->random_country]);
						$randomMovies['random_country'] = array_flip ($flipRandomCountry);
					}else{
						$random_country[] = $user_input->random_country;
						$randomMovies['random_country'] = $random_country;
					}
				}
				if ($user_input->selected_control_id == 'random_genre'){
					$flipRandomgenre = array_flip ($random_genre);
					if ($user_input->random_genre == ''){
						unset($randomMovies['random_genre']);
					}else if ($user_input->random_genre == 'all'){
						$random_genre = array();
						foreach ($genre_jsd as $k => $v)
							$random_genre[] = str_replace('f', '', $k);
						$randomMovies['random_genre'] = $random_genre;
					}else if (isset($flipRandomgenre[$user_input->random_genre])){
						unset ($flipRandomgenre[$user_input->random_genre]);
						$randomMovies['random_genre'] = array_flip ($flipRandomgenre);
					}else{
						$random_genre[] = $user_input->random_genre;
						$randomMovies['random_genre'] = $random_genre;
					}
				}
				if ($user_input->selected_control_id == 'random_max_years'){
					$randomMovies['max_years'] = $user_input->random_max_years;
					if ($user_input->random_max_years < $random_min_years)
						$randomMovies['min_years'] = $user_input->random_max_years;
				}
				if ($user_input->selected_control_id == 'random_min_years'){
					$randomMovies['min_years'] = $user_input->random_min_years;
					if ($user_input->random_min_years > $random_max_years)
						$randomMovies['max_years'] = $user_input->random_min_years;
				}
				if (HD::saveItemsArr(self::$cName . 'RandomMovies', $randomMovies) == false)
					return ActionFactory::show_title_dialog("Сохранение не удалось");
				$action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $params);
				return ActionFactory::close_dialog_and_run($action);
			}
			
			
			for ($i = 1920; $i< $random_max_years+1; $i++)
				$min_ops[$i] = $i;
			for ($i = $random_min_years; $i< date('Y')+1; $i++)
				$max_ops[$i] = $i;
			ControlFactory::add_label($defs, "Период:", "$random_min_years - $random_max_years года");
			
			$add_params['initial_sel_ndx'] = 0;
			ControlFactory::add_combobox($defs, $this, $add_params,
			'random_min_years', 'Начало периода:',
			$random_min_years, $min_ops, 100, true, false);
			
			$add_params['initial_sel_ndx'] = $add_params['initial_sel_ndx'] + 1;
			ControlFactory::add_combobox($defs, $this, $add_params,
			'random_max_years', 'Конец периода:',
			$random_max_years, $max_ops, 100, true, false);
			
			$c2 = ''; 
			$arr = array();
			$arr[''] = 'Все жанры';
			$arr['all'] = 'Выбрать все жанры';
			foreach ($jsd->genres as $v){
				if ($v->id != 20)
				$arr['&genre%5B%5D=' . $v->id] = HD::get_upper($v->genre);
			}
			if ($random_genre == array())
				$c = 'Все жанры';
			else{
				$c = '';
				foreach ($random_genre as $v){
					$c .=  $arr[$v] . '; ';
					$arr[$v] = $arr[$v] . '*';
					$c2 = $v;
				}
				
			}
			ControlFactory::add_multiline_label($defs, 'Выбранные жанры:', $c, 3);
			$add_params['initial_sel_ndx'] = $add_params['initial_sel_ndx'] + 1;
			ControlFactory::add_combobox($defs, $this, $add_params,
			'random_genre', 'Жанры:',
			$c2, $arr, 800, true, false);
			
			$c2 = ''; $arr = array();
			$arr[''] = 'Все страны';
			$arr['all'] = 'Выбрать все страны';
			$arr['&country%5B%5D=1'] = "США";
			$arr['&country%5B%5D=11'] = "Великобритания";
			$arr['&country%5B%5D=3'] = "Германия";
			$arr['&country%5B%5D=18'] = "Германия (ФРГ)";
			$arr['&country%5B%5D=8'] = "Франция";
			$arr['&country%5B%5D=38'] = "Ирландия";
			$arr['&country%5B%5D=15'] = "Испания";
			$arr['&country%5B%5D=14'] = "Италия";
			$arr['&country%5B%5D=6'] = "Канада";
			$arr['&country%5B%5D=13'] = "СССР";
			$arr['&country%5B%5D=2'] = "Россия";
			$arr['&country%5B%5D=25'] = "Австралия";
			$arr['&country%5B%5D=41'] = "Бельгия";
			$arr['&country%5B%5D=28'] = "Гонконг";
			$arr['&country%5B%5D=4'] = "Дания";
			$arr['&country%5B%5D=29'] = "Индия";
			$arr['&country%5B%5D=31'] = "Китай";
			$arr['&country%5B%5D=26'] = "Корея Южная";
			$arr['&country%5B%5D=5'] = "Швеция";
			$arr['&country%5B%5D=9'] = "Япония";
			foreach ($jsd->country as $v)
				$arr['&country%5B%5D=' . $v->id] = $v->name;
			if ($random_country == array())
				$c = 'Все страны';
			else{
				$c = '';
				foreach ($random_country as $v){
					$c .=  $arr[$v] . '; ';
					$arr[$v] = $arr[$v] . '*';
					$c2 = $v;
				}
			}
			ControlFactory::add_multiline_label($defs, 'Выбранные страны:', $c, 3);
			$add_params['initial_sel_ndx'] = $add_params['initial_sel_ndx'] + 1;
			ControlFactory::add_combobox($defs, $this, $add_params,
				'random_country', 'Страны:',
				$c2, $arr, 800, true, false
			);
			ControlFactory::add_vgap($defs, (-10));
			ControlFactory::add_smart_label($defs, "", '<text color="23" size="tiny">* повторный выбор категории удаляет ее из списка</text>');
			ControlFactory::add_vgap($defs, (-45));
			ControlFactory::add_smart_label($defs, "", '<icon width="142" height="50">gui_skin://special_icons/controls_button_clear.aai</icon><text color="23"> - сброс сортировок</text>');
			$attrs['initial_sel_ndx'] = isset($user_input->initial_sel_ndx) ? $user_input->initial_sel_ndx : -1;
			$action = UserInputHandlerRegistry::create_action($this, 'invalidate');
			$attrs['actions'][GUI_EVENT_KEY_RETURN]	= ActionFactory::close_dialog_and_run($action);
			$add_params['reset'] = true;
			$action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $add_params);
			$attrs['actions'][GUI_EVENT_KEY_CLEAR]	= ActionFactory::close_dialog_and_run($action);
			return ActionFactory::show_dialog("Выберите жанры, страны и период", $defs,	true, 1200, $attrs);
		}
		return ActionFactory::show_title_dialog($caption, $post_action, $msg, 0);
	}
	public static function getRandomMovies($media_url){
		$items = array();
		$randomMovies = (HD::getItemsArr(self::$cName . 'RandomMovies') != array()) ? HD::getItemsArr(self::$cName . 'RandomMovies') : array();
		$max_years = isset($randomMovies['max_years']) ? $randomMovies['max_years'] : date('Y');
		$min_years = isset($randomMovies['min_years']) ? $randomMovies['min_years'] : '1920';
		$random_genre = isset($randomMovies['random_genre']) ? $randomMovies['random_genre'] : '';
		$random_country = isset($randomMovies['random_country']) ? $randomMovies['random_country'] : '';
		$g = $c = '';
		if ($random_genre == true){
			if (count($random_genre) > 1)
				$g = implode('', $random_genre);
			else
				$g = array_shift($random_genre);
		}
		if ($random_country == true){
			if (count($random_country) > 1)
				$c = implode(''. $random_country);
			else
				$c = array_shift($random_country);
		}
		$jsd = json_decode(self::http_get_document(self::getDomainName() .  "/chance/?item=true&count=10$c$g&max_years=$max_years&min_years=$min_years"));
		foreach ($jsd as $v){
			if (preg_match('|film="(.+?)"|', $v, $match)){
				$id = $match[1];
				if (preg_match('|name="(.+?)"|ms', $v, $match))
					$caption = HD::str_remove_tag ($match[1]);
				$poster_url = self::http_get_img("http://st.kp.yandex.net/images/film_iphone/iphone360_".$id.".jpg");
				$movie = new ShortMovie(
					strval($id),
					strval($caption),
					strval($poster_url)
				);
				$info = '||' . $caption;
				if (preg_match('|<span>(.*?)</span>|ms', $v, $match)){
					if (preg_match("|(.*?)\((\d*?)\)(.*)|", $match[1], $matches)){
						$original_name = HD::str_remove_tag($matches[1]);
						if ($original_name != '')
							$info .= '|' . $original_name;
						else
							$info .= '|' . $caption;
						$info .= '||' . trim ($matches[2]);
						$info .= ' ' . trim ($matches[3]);
					}
				}
				if (preg_match_all('|<div class="gray">(.*?)</div>|ms', $v, $match)){
					$info .= '||' . HD::str_remove_tag ($match[1][0]);
					$info .= '||' . HD::str_remove_tag ($match[1][1]);
				}
				if (preg_match('|class="syn">(.*?)</div>|ms', $v, $match))
					$info .= '||' . HD::str_remove_tag ($match[1]);
				$movie->info = $info;
				
				array_push ($items, $movie);
			}
		}
		return $items;
	}
	public static function getSearchShortMovieRange ($keyword, &$m_feed){
		$items = array();
		if ($m_feed === 'end')
			return $items;
		$searchSettings = (HD::getItemsArr('searchSettings') != array()) ? HD::getItemsArr('searchSettings') : array('useOsk' => 1, 'searchСhoice' => 1, 'kpSearchMetod' => 2);
		$type = 'film';
		if (is_object($keyword)){
			if (isset($keyword->searchType))
				$type = $keyword->searchType;
			$keyword = $keyword->searchStr;
		}
		if ($searchSettings['kpSearchMetod'] == 0)
			$jsd = self::kpSearch($keyword, $m_feed + 1, $type);
		if ($searchSettings['kpSearchMetod'] == 1)
			$jsd = self::siteKpSearch($keyword, $m_feed + 1, $type);
		if ($searchSettings['kpSearchMetod'] == 2)
			$jsd = self::suggestKpSearch($keyword, $type);
		if (($m_feed + 1) == $jsd->pagesCount)
			$m_feed = 'end';
		else ++$m_feed;
		if (isset($jsd->searchFilms)){
			foreach ($jsd->searchFilms as $v){
				$caption = $caption_original = $v->nameRU;
				if ($v->nameEN != ''){
					$caption_original = $v->nameEN;
					if ($v->nameRU == '')
						$caption = $v->nameEN;
				}
				$caption = preg_replace("/\(.*\)/", '', $caption);
				$short_movie = new ShortMovie(
					strval($v->id),
					strval($caption),
					strval(self::http_get_img("http://st.kp.yandex.net/images/film_iphone/iphone360_".$v->id.".jpg"))
				);

				$info = '||' . $caption;
				$info .= '|' . $caption_original;
				if (isset($v->year))
					$info .= '|' . $v->year;
				$rating = '';
				if (isset($v->rating))
					$rating = $v->rating;
				$info .= '||КП рейтинг: ' . $rating;
				if (isset($v->country))
					$info .= '|' . $v->country;
				if (isset($v->genre))
					$info .= '|' . $v->genre;
				if (isset($v->description))
					$info .= '|' . $v->description;
				$short_movie->info = $info;
				array_push ($items, $short_movie);
			}
		}
		if (isset($jsd->searchPeople)){
			foreach ($jsd->searchPeople as $v){
				$short_movie = new ShortMovie(
					strval('KPPeople' . $v->id),
					strval($v->nameRU),
					strval(self::http_get_img("http://st.kp.yandex.net/images/actor_iphone/iphone360_{$v->id}.jpg"))
				);
				$info = '||' . $v->nameRU;
				if ($v->nameEN != '')
					$info .= '|' . $v->nameEN;
				if (isset($v->description))
					$info .= '|' . $v->description;
				$short_movie->info = $info;
				$short_movie->goToScreen = 'SmartVodListScreen';
				array_push ($items, $short_movie);
			}
		}
		return $items;
	}
	public static function getShortMovieRange ($media_url, &$m_feed){
		$items = array();
		if ($m_feed === 'end')
			return $items;
		if (isset($media_url->searchKpId)){
			if (isset($media_url->searchKpId->searchStr))
				$keyword = $media_url->searchKpId->searchStr;
			else
				$keyword = $media_url->searchKpId->caption;
			if ($searchSettings['kpSearchMetod'] == 0)
				$jsd = self::kpSearch($keyword, $m_feed + 1, 'film');
			if ($searchSettings['kpSearchMetod'] == 1)
				$jsd = self::siteKpSearch($keyword, $m_feed + 1, 'film');
			if ($searchSettings['kpSearchMetod'] == 2)
				$jsd = self::suggestKpSearch($keyword, 'film');

			if (($m_feed + 1) == $jsd->pagesCount)
				$m_feed = 'end';
			else ++$m_feed;
			if (isset($jsd->searchFilms)){
				foreach ($jsd->searchFilms as $v){
					$caption = $caption_original = $v->nameRU;
					if ($v->nameEN != ''){
						$caption_original = $v->nameEN;
						if ($v->nameRU == '')
							$caption = $v->nameEN;
					}
					$caption = preg_replace("/\(.*\)/", '', $caption);
					$short_movie = new ShortMovie(
						strval($v->id),
						strval($caption),
						strval(self::http_get_img("http://st.kp.yandex.net/images/film_iphone/iphone360_".$v->id.".jpg"))
					);

					$info = '||' . $caption;
					$info .= '|' . $caption_original;
					if (isset($v->year))
						$info .= '|' . $v->year;
					$rating = '';
					if (isset($v->rating))
						$rating = $v->rating;
					$info .= '||КП рейтинг: ' . $rating;
					if (isset($v->country))
						$info .= '|' . $v->country;
					if (isset($v->genre))
						$info .= '|' . $v->genre;
					if (isset($v->description))
						$info .= '|' . $v->description;
					$short_movie->info = $info;
					array_push ($items, $short_movie);
				}
			}
		}
		if (isset($media_url->kpSimilarSequelsPrequelsRelatedFilms)){
			$jsd = self::getKPFilmsList($media_url->kpID, $media_url->kpSimilarSequelsPrequelsRelatedFilms, $m_feed + 1);
			foreach ($jsd->items as $v){
				$caption = $caption_original = $v->nameRU;
				if ($v->nameEN != ''){
					$caption_original = $v->nameEN;
					if ($v->nameRU == '')
						$caption = $v->nameEN;
				}
				$caption = preg_replace("/\(.*\)/", '', $caption);
				$short_movie = new ShortMovie(
					strval($v->id),
					strval($caption),
					strval(self::http_get_img("http://st.kp.yandex.net/images/film_iphone/iphone360_".$v->id.".jpg"))
				);

				$info = '||' . $caption;
				$info .= '|' . $caption_original;
				if (isset($v->year))
					$info .= '|' . $v->year;
				if (isset($v->rating))
					$info .= '||КП рейтинг: ' . $v->rating;
				if (isset($v->country))
					$info .= '|' . $v->country;
				if (isset($v->genre))
					$info .= '|' . $v->genre;
				$short_movie->info = $info;
				array_push ($items, $short_movie);
			}
			if (!isset($jsd->pagesCount))
				return array();
			if (($m_feed + 1) == $jsd->pagesCount)
				$m_feed = 'end';
			else
				++$m_feed;
		}
		if (isset($media_url->kpActorsAndDirectors)){
			$jsd = self::get_id_staff ($media_url->kpActorsAndDirectors);
			if (isset($jsd->creators)){
				foreach ($jsd->creators as $vel){
					foreach ($vel as $v){
						$caption = $caption_original = $v->nameRU;
						if ($v->nameEN != ''){
							$caption_original = $v->nameEN;
							if ($v->nameRU == '')
								$caption = $v->nameEN;
						}
						$short_movie = new ShortMovie(
							strval('KPPeople' . $v->id),
							strval($caption),
							strval(self::http_get_img("http://st.kp.yandex.net/images/actor_iphone/iphone360_{$v->id}.jpg"))
						);
						$info = '||' . $caption;
						$info .= '|' . $caption_original;
						$info .= '|' . str_replace("ры", "р", $v->professionText);
						if (isset($v->description)){
							if (str_replace("ры", "р", $v->professionText) == 'Актер')
								$info .= '||Роль:';
							$info .= '|' . $v->description;
						}
						$short_movie->info = $info;
						$short_movie->goToScreen = 'SmartVodListScreen';
						array_push ($items, $short_movie);
					}
				}
			}else
				foreach ($jsd as $v){
					$caption = $caption_original = $v->nameRu;
					if ($v->nameEn != ''){
						$caption_original = $v->nameEn;
						if ($v->nameRu == '')
							$caption = $v->nameEn;
					}
					$short_movie = new ShortMovie(
						strval('KPPeople' . $v->staffId),
						strval($caption),
						strval(self::http_get_img("http://st.kp.yandex.net/images/actor_iphone/iphone360_{$v->staffId}.jpg"))
					);
					$info = '||' . $caption;
					$info .= '|' . $caption_original;
					$info .= '|' . str_replace("ры", "р", $v->professionText);
					if (isset($v->description)){
						if (str_replace("ры", "р", $v->professionText) == 'Актер')
							$info .= '||Роль:';
						$info .= '|' . $v->description;
					}
					$short_movie->info = $info;
					$short_movie->goToScreen = 'SmartVodListScreen';
					array_push ($items, $short_movie);
				}
			$m_feed = 'end';
		}
		if (preg_match("|KPPeople(\d+)|", $media_url->categoryId, $m)){
			$jsd = self::getKPPeopleDetailView ($m[1]);
			if (isset($jsd->films))
				foreach ($jsd->films as $vel){
					$arr[$vel->filmId]['caption_original'] = $arr[$vel->filmId]['caption'] = $vel->nameRu;
					if ($vel->nameRu != '')
						$arr[$vel->filmId]['caption_original'] = $vel->nameEn;
					else if ($vel->nameEn != '')
						$arr[$v->filmId]['caption_original'] = $arr[$v->filmId]['caption'] = $v->nameEn;
					$arr[$vel->filmId]['professionKey'] = $vel->professionKey;
					$arr[$vel->filmId]['KPrating'] = $vel->rating;
					if ($vel->description != '')
						$arr[$vel->filmId]['description'] = $vel->description;
					$arr[$vel->filmId]['img'] = "http://st.kp.yandex.net/images/film_iphone/iphone360_".$vel->filmId.".jpg";
				}
			if (isset($jsd->generalFilms))
				foreach ($jsd->generalFilms as $vel){
					$arr[$vel->filmID]['caption_original'] = $arr[$vel->filmID]['caption'] = $vel->nameRU;
					if ($vel->nameRU != '')
						$arr[$vel->filmID]['caption_original'] = $vel->nameEN;
					else
						$arr[$v->filmID]['caption_original'] = $arr[$v->filmID]['caption'] = $v->nameEN;
					$arr[$vel->filmID]['professionText'] = $vel->professionText;
					$arr[$vel->filmID]['img'] = "http://st.kp.yandex.net/images/film_iphone/iphone360_".$vel->filmID.".jpg";
				}
			if (isset($jsd->filmography))
				foreach ($jsd->filmography as $vel){
					foreach ($vel as $v){
						$arr[$v->filmID]['caption_original'] = $arr[$v->filmID]['caption'] = $v->nameRU;
						if ($v->nameRU != '')
							$arr[$v->filmID]['caption_original'] = $v->nameEN;
						else
							$arr[$v->filmID]['caption_original'] = $arr[$v->filmID]['caption'] = $v->nameEN;
						if (isset($arr[$v->filmID]['professionText']))
							$arr[$v->filmID]['professionText'] = $arr[$v->filmID]['professionText'] .', '. $v->professionText;
						else
							$arr[$v->filmID]['professionText'] = $v->professionText;
						$arr[$v->filmID]['KPrating'] = $v->rating;
						$arr[$v->filmID]['year'] = $v->year;
						if ($v->description != '')
							$arr[$v->filmID]['description'] = $v->description;
						$arr[$v->filmID]['img'] = "http://st.kp.yandex.net/images/film_iphone/iphone360_".$v->filmID.".jpg";
					}
				}
			foreach ($arr as $k => $v){
				$caption = preg_replace("/\(.*\)/", '', $v['caption']);
				$short_movie = new ShortMovie(
					strval($k),
					strval($caption),
					strval( self::http_get_img($v['img']))
				);
			
				$info = '||' . $caption;
				$info .= '|' . $v['caption_original'];
				$info .= '|' . $v['year'];
				$info .= '||КП рейтинг: ' . $v['KPrating'];
				$info .= '|' . $v['professionText'];
				if (isset($v['description']))
				$info .= '|' . $v['description'];
				$short_movie->info = $info;
				array_push ($items, $short_movie);
			}
			$m_feed = 'end';
		}
		if (preg_match("|___|",$media_url->categoryId)){
			echo $media_url->categoryId;
			$tmp = explode("___", $media_url->categoryId);
			$jsd = self::getKPTop ($tmp[1], $tmp[0], ($m_feed + 1) );
			foreach ($jsd->items as $v){
				$caption = $caption_original = $v->nameRU;
				if ($v->nameEN != ''){
					$caption_original = $v->nameEN;
					if ($v->nameRU == '')
						$caption = $v->nameEN;
				}
				$caption = preg_replace("/\(.*\)/", '', $caption);
				$short_movie = new ShortMovie(
					strval($v->id),
					strval($caption),
					strval(self::http_get_img("http://st.kp.yandex.net/images/film_iphone/iphone360_".$v->id.".jpg"))
				);
			
				$info = '||' . $caption;
				$info .= '|' . $caption_original;
				$info .= '|' . $v->year;
				$info .= '||КП рейтинг: ' . $v->rating;
				$info .= '|' . $v->country;
				$info .= '|' . $v->genre;
				$short_movie->info = $info;
				array_push ($items, $short_movie);
			}
			if (!isset($jsd->pagesCount))
				return array();
			if (($m_feed + 1) == $jsd->pagesCount)
				$m_feed = 'end';
			else
				++$m_feed;
		}
		if ($media_url->categoryId == "soon_films"){
			$jsd = self::getKPSoonFilms ($m_feed + 1);
			foreach ($jsd->previewFilms[0] as $v){
				$caption = $caption_original = $v->nameRU;
				if ($v->nameEN != ''){
					$caption_original = $v->nameEN;
					if ($v->nameRU == '')
						$caption = $v->nameEN;
				}
				$short_movie = new ShortMovie(
					strval($v->id),
					strval($caption),
					strval(self::http_get_img("http://st.kp.yandex.net/images/film_iphone/iphone360_".$v->id.".jpg"))
				);
				$info = '||' . $caption;
				$info .= '|' . $caption_original;
				$info .= '||Премьера: ' . $v->premiereRU;
				$info .= '|' . $v->year;
				$info .= '|' . $v->genre;
				$info .= '|' . $v->country;
				$short_movie->info = $info;
				array_push ($items, $short_movie);
			}
			if (!isset($jsd->pagesCount))
				return array();
			++$m_feed;
			if (($m_feed+1)==$jsd->pagesCount)
				$m_feed = 'end';
		}
		if (($media_url->categoryId == "new")||
		($media_url->categoryId == "popular")||
		($media_url->categoryId == "soon")){
			$jsd = self::getNewTrailers($media_url->categoryId, $m_feed + 1);
			foreach ($jsd->trailers as $v){
				$caption = $caption_original = $v->nameRU;
				if ($v->nameEN != ''){
					$caption_original = $v->nameEN;
					if ($v->nameRU == '')
						$caption = $v->nameEN;
				}
				$short_movie = new ShortMovie(
					strval($v->filmID),
					strval($caption),
					strval(self::http_get_img("http://st.kp.yandex.net/images/film_iphone/iphone360_".$v->filmID.".jpg"))
				);
				$info = '||' . $caption;
				$info .= '|' . $caption_original;
				$info .= '|' . $v->genre;
				$short_movie->info = $info;
				array_push ($items, $short_movie);
			}
			if (!isset($jsd->pagesCount))
				return array();
			++$m_feed;
			if (($m_feed+1)==$jsd->pagesCount)
				$m_feed = 'end';
		}
		if ($media_url->categoryId == 'kp_item_top_popular_people'){
			$jsd = self::getKPTop ('', $media_url->categoryId, $m_feed + 1);
			foreach ($jsd->items as $v){
				$short_movie = new ShortMovie(
					strval('KPPeople' . $v->id),
					strval($v->nameRU),
					strval(self::http_get_img("http://st.kp.yandex.net/images/actor_iphone/iphone360_{$v->id}.jpg"))
				);
				$info = '||' . $v->nameRU;
				if ($v->nameEN != '')
					$info .= '|' . $v->nameEN;
				$info .= '|' . $v->description;
				$short_movie->info = $info;
				$short_movie->goToScreen = 'SmartVodListScreen';
				array_push ($items, $short_movie);
			}
			if (!isset($jsd->pagesCount))
				return array();
			++$m_feed;
			if (($m_feed+1)==$jsd->pagesCount)
				$m_feed = 'end';
		}
		return $items;
	}
	public static function load_movie($movie_id, $mUrl, $getMovieInfo){
		if (isset($mUrl->caption))
			$arr['caption'] = $arr['class_info']['catalog_info']['caption'] = $mUrl->caption;
		if (isset($mUrl->poster_url))
			$arr['poster_url'] = $arr['class_info']['catalog_info']['poster_url'] = $mUrl->poster_url;
		if (isset($mUrl->caption_original))
			$arr['caption_original'] = $arr['class_info']['catalog_info']['caption_original'] = $mUrl->caption_original;
		if (isset($mUrl->year))
			$arr['year'] = $arr['class_info']['catalog_info']['year'] = $mUrl->year;
		$jsd = self::get_id_info($movie_id);
		if ((isset($jsd->nameRU))&&($jsd->nameRU != ''))
			$arr['caption_original'] = $arr['caption'] = $jsd->nameRU;
		else if ((isset($jsd->nameEN))&&($jsd->nameEN != ''))
			$arr['caption_original'] = $arr['caption'] = $jsd->nameEN;
		if ((isset($jsd->nameEN))&&($jsd->nameEN != ''))
			$arr['caption_original'] = $jsd->nameEN;
		if ((isset($jsd->description))&&($jsd->description != ''))
			$arr['description'] = $jsd->description;
		$arr['poster_url'] = self::http_get_img("http://st.kp.yandex.net/images/film_iphone/iphone360_$movie_id.jpg");
		$arr['country'] = $jsd->country;
		if (preg_match("|-|",$jsd->year))
			$arr['country'] .= ', '.$jsd->year;
		else
			$arr['year'] = $jsd->year;
		if (isset ($jsd->genre))
			$arr['genres'] = $jsd->genre;
		if (isset ($jsd->ratingData->ratingIMDb))
			$arr['rate_imdb'] = $jsd->ratingData->ratingIMDb;
		if (isset ($jsd->ratingData->rating))
			$arr ['rate_kinopoisk'] = $jsd->ratingData->rating;
		if (isset ($jsd->filmLength)){
			$length = $jsd->filmLength;
			if (preg_match("/(\d*):(\d\d)/i", $length, $tmp))
				$length = ($tmp[1]*60+$tmp[2]);
			$arr ['length'] = $length;
		}
		if (isset ($jsd->creators[0])){
			foreach ($jsd->creators[0] as $v){
				if ((isset ($v->nameEN))&&($v->nameEN != ''))
					$name_r[] = $v->nameRU .' ('.$v->nameEN.')';
				else
					$name_r[] = $v->nameRU;
				if (count($name_r) > 1)
					$arr['director'] = implode(', ', $name_r);
				else
					$arr['director'] = $name_r[0];
			}
		}
		if (isset ($jsd->creators[1])){
			$name_r = array();
			foreach ($jsd->creators[1] as $v){
				if ((isset ($v->nameEN))&&($v->nameEN != ''))
					$name_r[] = $v->nameRU .' ('.$v->nameEN.')';
				else
					$name_r[] = $v->nameRU;
				if (count($name_r) > 1)
					$arr['actors'] = implode(', ', $name_r);
				else
					$arr['actors'] = $name_r[0];
			}
		}
		if (isset ($jsd->creators[2])){
			$name_r = array();
			foreach ($jsd->creators[2] as $v){
				if ((isset ($v->nameEN))&&($v->nameEN != ''))
					$name_r[] = $v->nameRU .' ('.$v->nameEN.')';
				else
					$name_r[] = $v->nameRU;
				if (count($name_r) > 1)
					$arr ['details']['Продюсеры:'] = implode(', ', $name_r);
				else
					$arr ['details']['Продюсеры:'] = $name_r[0];
			}
		}
		if (isset ($jsd->gallery)){
			foreach ($jsd->gallery as $key => $vel){
				if ($key=='poster')
					continue;
				foreach ($vel as $v){
					if (!preg_match("|^http|",$v->image))
						$v->image = "http://st.kp.yandex.net/images/". $v->image;
					$arr ['background_urls'][] = self::http_get_img($v->image);
				}
			}
		}
		if (isset ($jsd->slogan))
			$arr ['details']["Слоган:"] = wordwrap($jsd->slogan, 75, "\n");
		
		if (isset ($jsd->budgetData->budget))
			$arr ['budget'] = str_replace(array ('$', ' '),"", $jsd->budgetData->budget);
		if (isset($jsd->videoURL)){
			foreach ($jsd->videoURL as $k => $v){
				$arr['class_info']['trailers'][$v] = array(
					'name' => "Kinopoisk - " . $arr['caption'],
					'url' => $v,
					'hls_v4' => 1
				);
			}
		}
		if ((!isset($arr['description']))||
			(!isset($arr['actors']))){
			foreach (VideoInfo::kpIDInfoRes($movie_id) as $k => $v)
				$arr[$k] = $v;
		}
		if ($getMovieInfo == 'max'){
			if ((isset($jsd->type))&&($jsd->type == 'KPSerial')){
				$arr['is_serial']= 1;
				$jsd = VideoInfo::search_myshows_info($arr['caption_original'], $movie_id);
				if (isset($jsd->id)){
					$arr['class_info']['dbIDs']['myShowsID'] = $jsd->id;
					if ($jsd->rating != '')
						$arr ['rate_details']['MyShows:']=  round($jsd->rating, 1);	
					$arr ['rate_details']['Сезонов:'] = $jsd->totalSeasons;
					if ( $jsd->status != ''){
						if ( $jsd->status == 'TBD/On The Bubble'){
							$arr ['rate_details']['Статус:']= ' ';
							$arr ['rate_details']['   '] = 'Пауза';
						}else if ($jsd->status == 'Returning Series'){
							$arr ['rate_details']['Статус:']= ' ';
							$arr ['rate_details']['   '] = 'Продолжается';
						}else if ($jsd->status == 'Canceled/Ended'){
							$arr ['rate_details']['Статус:'] = ' ';
							$arr ['rate_details']['   '] = 'Завершен';
						}else if ($jsd->status == 'New Series'){
							$arr ['rate_details']['Статус:']= ' ';
							$arr ['rate_details']['   '] = 'Новый!';
						}else{
							$arr ['rate_details']['Статус:']= ' ';
							$arr ['rate_details']['   ']=  $jsd->status;
						}
					}
					if ($jsd->totalSeasons != '')
						$arr ['rate_details']['Сезонов:']=  $jsd->totalSeasons;
					if ($jsd->started != ''){
						$arr ['rate_details']['Started:']=  ' ';
						$arr ['rate_details']['  ']=  $jsd->started;
					}
					if ($jsd->ended != ''){
						$arr ['rate_details']['Ended:']= ' ';
						$arr ['rate_details'][' ']=  $jsd->ended;
					}
					if ($jsd->imdbId != '')
						$arr['class_info']['dbIDs']['imdbID'] = 'tt' . $jsd->imdbId;
					if ($jsd->tvrageId != '')
						$arr['class_info']['dbIDs']['tvrageID'] = 'tt' . $jsd->tvrageId;			
				}
			}
			if (!isset($arr['background_urls'])){
				if ((isset($arr ['year']))&&(preg_match("#^(\d{4})#",$arr ['year'], $mch)))
					$year = $mch[1];
				else if (preg_match("#(\d{4})#",$arr ['country'], $mch))
					$year = $mch[1];
				$themoviedbIdArr = VideoInfo::search_themoviedbId ($arr['caption_original'], $year, true);
				$arr['class_info']['dbIDs']['themoviedbId'] = $themoviedbIdArr['themoviedbId'];
				foreach(TheMovieDatabase_Class::getImagesFromThemoviedb ($arr['class_info']['dbIDs']['themoviedbId'], $themoviedbIdArr['media_type']) as $k => $v)
					if ($k != 'poster_url')
						$arr[$k] = $v;
			}
		}
		if (isset($jsd->seriesInfo)){
			$arr ['rate_details']['Сезонов:'] = $jsd->seriesInfo->totalSeasons;
			$arr ['rate_details']['Эпизодов:'] = $jsd->seriesInfo->totalEpisodes;
		}
		if ((isset($jsd->type))&&($jsd->type == 'KPSerial'))
			$arr['is_serial']= 1;
		$arr['class_info']['dbIDs']['kpID'] = $movie_id;
		if (isset($arr['class_info']['dbIDs']['kpID']))
			$arr ['rate_details']['kpID:'] = $arr['class_info']['dbIDs']['kpID'];
		return $arr;
	}
	public function checkKpAccess(){
		if (self::$kpAccess == 'noCheck'){
			$opts[CURLOPT_HEADER] = true;
			$opts[CURLOPT_NOBODY] = true;
			$doc = self::http_get_document(self::getDomainName(), $opts);
			if (preg_match('|Domain=\.kinopoisk\.ru|', $doc))
				self::$kpAccess = 'true';
			else
				self::$kpAccess = 'false';
		}
		return self::$kpAccess;
	}
	public function meinMenuOpenFolderDialog($user_input){
		if (self::checkKpAccess() == 'false'){
			$alertOff = (HD::getItemStr(self::$cName . 'checkKpAccessAlertOff') != '') ? HD::getItemStr(self::$cName . 'checkKpAccessAlertOff') : false;
			$add_params['action'] = $user_input->action;
			if ((!isset($user_input->closed_dialog))&&($alertOff == false)){
				$add_params['closed_dialog']= true;
				ControlFactory::add_multiline_label($defs, '', "Для полноценного использования плагином необходим доступ к ".self::$cName."!",5);		
				ControlFactory::add_close_dialog_and_apply_button($defs, $this, array ('action' => 'proxy', 'addProxy' => 'socks.zaborona.help:1488', 'addProxyType' => 'SOCKS5'), 'classAction', 'Прокси для ' . self::$cName, 700);
				ControlFactory::add_close_dialog_and_apply_button($defs, $this, $add_params, $user_input->control_id, 'Продолжить без Кинопоиска', 700);
				$add_params['alertOff']= true;
				ControlFactory::add_close_dialog_and_apply_button($defs, $this, $add_params, $user_input->control_id, 'Больше не показывать', 700);
				return  ActionFactory::show_dialog('Внимание!',$defs, true,710,$attrs);
			}
			if (isset($user_input->alertOff))
				if (HD::saveItemStr(self::$cName . 'checkKpAccessAlertOff', 1) == false)
					return ActionFactory::show_title_dialog("Сохранение не удалось");
		}
		return ActionFactory::open_folder();
	}
	public static function parse_film_review($filmID, $item){
		static $arr = false;
		if ($item > 19)
			$i = $item - ((floor($item/20))*20);
		else
			$i = $item;
		if (($item == 0)||($item/20-round($item/20)==0)){
			$arr = false;
			$page = (floor($item/20))+1;
			$jsd = self::getKPReviews ($filmID, "kp_sort_date", $page);
			if (isset($jsd->reviewAllCount))
				$arr['reviewAllCount'] = $jsd->reviewAllCount;
			else
				return false;
			$arr['reviewAllPositiveRatio'] = $jsd->reviewAllPositiveRatio;
			$arr['reviewPositiveCount'] = $jsd->reviewPositiveCount;
			$arr['reviewNegativeCount'] = $jsd->reviewNegativeCount;
			$arr['reviewNeutralCount'] = $jsd->reviewNeutralCount;
			$arr['pagesCount'] = $jsd->pagesCount;
			$arr['page'] = $jsd->page;
				foreach ($jsd->reviews as $k => $v)
					$arr[$k] = $v->reviewID;
		}

		if (isset($arr[$i])){
			$jsd = self::getKPReviewDetail ($arr[$i]);
			$jsd->reviewAllCount = $arr['reviewAllCount'];
			$jsd->reviewAllPositiveRatio = $arr['reviewAllPositiveRatio'];
			$jsd->reviewPositiveCount = $arr['reviewPositiveCount'];
			$jsd->reviewNegativeCount = $arr['reviewNegativeCount'];
			$jsd->reviewNeutralCount = $arr['reviewNeutralCount'];
			$jsd->pagesCount = $arr['pagesCount'];
			$jsd->page = $arr['page'];
			return $jsd;
		}else
			return false;
	}
	public static function http_get_img ($url){
		if (self::$proxy == true){
			$proxySettings = (HD::getItemsArr('proxySettings') != array()) ? HD::getItemsArr('proxySettings') : array();
			if ($proxySettings['kpProxyType'] == 2){
				if (!preg_match("|^http|",$url))
					return DuneSystem::$properties['plugin_cgi_url'] . "do?img=" . self::getDomainName() . $url . "&proxy=" . self::$cName;
				else
					return DuneSystem::$properties['plugin_cgi_url'] . "do?img=" . $url . "&proxy=" . self::$cName;
			}
		}
		if (!preg_match("|^http|",$url))
			$url = self::getDomainName() . $url;
		return DuneSystem::$properties['plugin_cgi_url'] . "do?img=" . $url;
	}
	public static function getKPFilmsListsArr($id, $t){
		if ($id == '')
			return false;
		$arr[3]='kp_similar_films';
		$arr[4]='kp_related_films';
		$arr[5]='kp_sequels_and_prequels_films';
		$type = $arr[$t];
		static $get_poxog = null;
		if ((is_null($get_poxog))||(!isset($get_poxog[$id][$type]))){
			if (count($get_poxog) > 20)
				$get_poxog = null;
			$jsd = self::getKPFilmsList($id, $type);
			if (isset($jsd->items))
				$jsd = $jsd->items;
			else
				$jsd = array();
			$get_poxog[$id][$type] = $jsd;
		}else
			$jsd =  $get_poxog[$id][$type];
		return ($jsd);
	}
	public static function getKPCreatorsListsArr($id){
		if ($id == '')
			return false;
		static $actors_arr = null;
		if ((is_null($actors_arr))||(!isset($actors_arr[$id]))){
			if (count($actors_arr) > 20)
				$actors_arr = null;
			$jsd = self::get_id_staff ($id);
			if (isset($jsd->creators[1]))
				foreach (array_slice($jsd->creators[1], 0, 50) as $v)
					$arr[] = $v;
			if (isset($jsd->creators[0]))
				foreach (array_slice($jsd->creators[0], 0, 50) as $v)
					$arr[] = $v;
			else{
				foreach ($jsd as $v){
					if (isset($v->staffId)){
						$v->id = $v->staffId;
						$v->nameRU = $v->nameRu;
						$v->nameEN = $v->nameEn;
						$arr[] = $v;
					}
				}
			}
			$actors_arr[$id] = $arr;
		}else
			$arr = $actors_arr[$id];
		return $arr;
	}
	public static function http_get_document ($url, $opts=null){
		if (is_null(self::$proxy)){
			self::$proxy = false;
			$sitesProxy = HD::getItemsArr('sitesProxy');
			if (isset($sitesProxy[self::$cName])){
				$proxySettings = (HD::getItemsArr('proxySettings') != array()) ? HD::getItemsArr('proxySettings') : array();
				if (isset($proxySettings['proxy'])){
					self::$proxy['proxy'] = $proxySettings['proxy'];
					if ((isset($proxySettings['proxyType']))&&($proxySettings['proxyType'] == 'SOCKS5'))
						self::$proxy['proxyType'] = $proxySettings['proxyType'];
					if (isset($proxySettings['proxyAccount']))
						self::$proxy['proxyAccount'] = $proxySettings['proxyAccount'];
				}
			}
		}
		if (self::$proxy == true){
			$opts[CURLOPT_PROXY] = self::$proxy['proxy'];
			if (isset(self::$proxy['proxyType']))
				$opts[CURLOPT_PROXYTYPE] = 7;
			if (isset(self::$proxy['proxyAccount']))
				$opts[CURLOPT_PROXYUSERPWD] = self::$proxy['proxyAccount'];
			$opts[CURLOPT_HTTPPROXYTUNNEL] = 1;
		}
		
		return HD::http_get_document($url, $opts);
	}
	public static function getKPinfoUnOff ($action){
		$kpUnOffToken = (HD::getItemStr('kpUnOffToken') != '') ? HD::getItemStr('kpUnOffToken') : '8607157c-60fe-4338-ad9a-fda1906601ed';
		$url = "https://kinopoiskapiunofficial.tech/api" . $action;
		$context = stream_context_create(array(
			'http' => array(
				'method' => 'GET',
				'header' => "X-API-KEY: " . $kpUnOffToken
			)
		));
		$doc = file_get_contents($url ,0,$context);
		return json_decode($doc);
	}
	public static function get_id_info ($id){
		$jsd = self::getKPinfoUnOff ("/v2.1/films/$id");
		if (!isset($jsd->data))
			return false;
		$jsd = $jsd->data;
		
		if (isset($jsd->nameRu))
			$jsd->nameRU = $jsd->nameRu;
		if (isset($jsd->nameEn))
			$jsd->nameEN = $jsd->nameEn;
		if (isset($jsd->countries)){
			$c = array();
			foreach ($jsd->countries as $countries){
				$c[] = $countries->country;
			}
			$jsd->country = implode(', ', $c);
		}
		if (isset($jsd->countries)){
			$c = array();
			foreach ($jsd->genres as $genres){
				$c[] = $genres->genre;
			}
			$jsd->genre = implode(', ', $c);
		}
		if (isset ($jsd->ratingData->ratingIMDb))
			$jsd->ratingData->ratingIMDb;
		if (isset ($jsd->ratingData->rating))
			$jsd->ratingData->rating;
		$doc = self::http_get_document("http://rating.kinopoisk.ru/$id.xml");
		hd_silence_warnings();
		if (preg_match('|<kp_rating.+?>(.+?)</kp_rating>|ms', $doc, $match))
			$jsd->ratingData->rating = $match[1];
		else
			$jsd->ratingData->rating = 0;
		if (preg_match('|<imdb_rating.+?>(.+?)</imdb_rating>|ms', $doc, $match))
			$jsd->ratingData->ratingIMDb = $match[1];
		else
			$jsd->ratingData->ratingIMDb = 0;
		hd_restore_warnings();
		if (
		($jsd->type == 'TV_SHOW')||
		(isset($jsd->seasons))||
		($jsd->type == 'TV_SERIES')
		)
			$jsd->type = 'KPSerial';
		return $jsd;
		// $jsd = self::get_info ('getKPFilmDetailView', array ('filmID'=> $id));
		// if (!isset($jsd->data))
			// return false;
		// $jsd = $jsd->data;
		// $jsds = self::get_info ('getGallery', array ('filmID'=> $id));
		// if (isset ($jsds->data->gallery))
			// $jsd->gallery = $jsds->data->gallery;
		// return $jsd;
		
	}
	public static function navigatorFilters (){
		// $arr["date"] = "0";
		// $jsd = self::get_info ('navigatorFilters', $arr);
		// $jsd = $jsd->data;
		$jsd = self::getKPinfoUnOff ("/v2.1/films/filters");
		return $jsd;
	}
	public static function getBestFilmsList ($listID){//нипанятна
		$arr["listID"] = $listID;
		$jsd = self::get_info ('getBestFilmsList', $arr);
		$jsd = $jsd->data;
		return $jsd;
	}
	public static function getKPTop ($genreID, $type, $page = null){
		$arr['type'] = $type;
		$arr["genreID"] = $genreID;
		$arr['page'] = $page;
		$jsd = self::get_info ('getKPTop', $arr);
		$jsd = $jsd->data;
		return $jsd;
	}
	public static function getKPPeopleDetailView ($id){
		return self::getKPinfoUnOff ("/v1/staff/$id");
		// $arr['peopleID'] = $id;
		// $jsd = self::get_info ('getKPPeopleDetailView', $arr);
		// $jsd = $jsd->data;
		// return $jsd;
	}
	public static function get_id_staff ($id){
		return self::getKPinfoUnOff ("/v1/staff?filmId=$id");
		// $jsd = self::get_info ('getStaffList', array ('filmID'=> $id));
		// $jsd = $jsd->data;
		// return $jsd;
	}
	public static function getKPFilmsList ($id, $type, $page = null){
		$jsd = (object)array();
		if ($type == 'kp_similar_films'){
			$jsd = self::getKPinfoUnOff ("/v2.2/films/$id/similars");
			foreach ($jsd->items as $k => $v){
				$jsd->items[$k]->id = $v->filmId;
				$jsd->items[$k]->nameRU = $v->nameRu;
				if (isset($v->nameEn))
					$jsd->items[$k]->nameEN = $v->nameEn;
			}
			$jsd->pagesCount = 1;
		}
		if ($type == 'kp_sequels_and_prequels_films'){
			$jsds = self::getKPinfoUnOff ("/v2.1/films/$id/sequels_and_prequels");
			foreach ($jsds as $k => $v){
				$jsds[$k]->id = $v->filmId;
				$jsds[$k]->nameRU = $v->nameRu;
				if (isset($v->nameEn))
					$jsds[$k]->nameEN = $v->nameEn;
			}
			$jsd->items = $jsds;
			$jsd->pagesCount = 1;
		}
		// $arr['filmID'] = $id;
		// $arr['type'] = $type;
		// if ($page == true)
			// $arr['page'] = $page;
		// $jsd = self::get_info ('getKPFilmsList', $arr);
		// $jsd = $jsd->data;
		return $jsd;
	}
	public static function getKPReviews ($filmID, $sortType, $page = null){
		$arr["filmID"] = $filmID;
		$arr["sortType"] = $sortType;// "kp_sort_date", "kp_sort_rating", "kp_sort_name";
		$arr['page'] = $page;
		$jsd = self::get_info ('getKPReviews', $arr);
		$jsd = $jsd->data;
		return $jsd;
	}
	public static function getKPReviewDetail ($reviewID){
		$arr["reviewID"] = $reviewID;
		$jsd = self::get_info ('getKPReviewDetail', $arr);
		$jsd = $jsd->data;
		return $jsd;
	}
	public static function getNewTrailers ($type, $page = null){
		$arr["date"] = "0";
		$arr['type'] = $type;
		$arr['page'] = $page;
		$jsd = self::get_info ('getNewTrailers', $arr);
		$jsd = $jsd->data;
		return $jsd;
	}
	public static function getKPSoonFilms ($page = null){
		$arr["date"] = "0";
		$arr['page'] = $page;
		$jsd = self::get_info ('getKPSoonFilms', $arr);
		$jsd = $jsd->data;
		return $jsd;
	}
	public static function getKPGenresView (){
		$arr["date"] = "0";
		$jsd = self::get_info ('getKPGenresView', $arr);
		$jsd = $jsd->data;
		return $jsd;
	}
	public static function get_info ($action, $options){
		$query = http_build_query($options);
		if (!empty($query)) 
			$action.= '?' . $query;
		$url = "https://ext.kinopoisk.ru/ios/5.0.0/" . $action;
		$t = self::req_headers($url);
		$opts [CURLOPT_HTTPHEADER] = array (
				'Image-Scale: 1',
				'countryID: 2',
				'cityID: 1',
				'Content-Lang: ru',
				'Accept: application/json',
				'User-Agent: Android client (4.4 / api22),ru.kinopoisk/4.2.1 (52)',
				'device: android',
				'Android-Api-Version: 22',
				'clientDate: '.  date("H:i d.m.Y"),
				'X-SIGNATURE: ' . $t['X-SIGNATURE'],
				'X-TIMESTAMP: ' . $t['X-TIMESTAMP']
			);
		$jsd = json_decode(self::http_get_document($url, $opts));
		return $jsd;
	}
	public static function req_headers($kpUrl){
		$t['X-TIMESTAMP'] = time();
		$t['X-SIGNATURE'] = md5(str_replace("https://ext.kinopoisk.ru/ios/5.0.0/", "",$kpUrl) . $t['X-TIMESTAMP'] . 'IDATevHDS7');
		return $t;
	}
	public static function simpleKpIdInfo($kpID){
		//$jsd = self::get_info ('getKPFilmDetailView', array ('filmID'=> $kpID));
		$jsd = self::get_id_info ($kpID);
		// if (!isset($jsd->data))
			// return false;
		// $jsd = $jsd->data;
		$arr['caption_original'] = '';
		if ($jsd->nameRU != '')
			$arr['caption_original'] = $arr['caption'] = $jsd->nameRU;
		else if ($jsd->nameEN != '')
			$arr['caption_original'] = $arr['caption'] = $jsd->nameEN;
		if ((isset($jsd->nameEN))&&($jsd->nameEN != ''))
			$arr['caption_original'] = $jsd->nameEN;
		if (isset($jsd->description))
			$arr['description'] = $jsd->description;
		$arr['poster_url'] = self::http_get_img("http://st.kp.yandex.net/images/film_iphone/iphone360_$kpID.jpg");
		$arr['country'] = $jsd->country;
		if (preg_match("|-|",$jsd->year))
			$arr['country'] .= ', '.$jsd->year;
		else
			$arr['year'] = $jsd->year;
		if (isset ($jsd->genre))
			$arr['genres'] = $jsd->genre;
		if (isset ($jsd->ratingData->ratingIMDb))
			$arr['rate_imdb'] = $jsd->ratingData->ratingIMDb;
		if (isset ($jsd->ratingData->rating))
			$arr ['rate_kinopoisk'] = $jsd->ratingData->rating;
		if (isset ($jsd->filmLength)){
			$length = $jsd->filmLength;
			if (preg_match("/(\d*):(\d\d)/i", $length, $tmp))
				$length = ($tmp[1]*60+$tmp[2]);
			$arr ['length'] = $length;
		}
		if (isset ($jsd->creators[0])){
			foreach ($jsd->creators[0] as $v){
				if ((isset ($v->nameEN))&&($v->nameEN != ''))
					$name_r[] = $v->nameRU .' ('.$v->nameEN.')';
				else
					$name_r[] = $v->nameRU;
				if (count($name_r) > 1)
					$arr['director'] = implode(', ', $name_r);
				else
					$arr['director'] = $name_r[0];
			}
		}
		if (isset ($jsd->creators[1])){
			$name_r = array();
			foreach ($jsd->creators[1] as $v){
				if ((isset ($v->nameEN))&&($v->nameEN != ''))
					$name_r[] = $v->nameRU .' ('.$v->nameEN.')';
				else
					$name_r[] = $v->nameRU;
				if (count($name_r) > 1)
					$arr['actors'] = implode(', ', $name_r);
				else
					$arr['actors'] = $name_r[0];
			}
		}
		if (isset ($jsd->creators[2])){
			$name_r = array();
			foreach ($jsd->creators[2] as $v){
				if ((isset ($v->nameEN))&&($v->nameEN != ''))
					$name_r[] = $v->nameRU .' ('.$v->nameEN.')';
				else
					$name_r[] = $v->nameRU;
				if (count($name_r) > 1)
					$arr ['details']['Продюсеры:'] = implode(', ', $name_r);
				else
					$arr ['details']['Продюсеры:'] = $name_r[0];
			}
		}
			
			$arr['poster_url'] =  self::http_get_img("http://st.kp.yandex.net/images/film_iphone/iphone360_$kpID.jpg");
		
		return $arr;
	}
	public static function suggestKpSearch($keyword, $type=null){
		$opts[CURLOPT_HTTPHEADER] = array (
			'x-requested-with: XMLHttpRequest'
		);
		$doc = str_replace("__", "", self::http_get_document(self::getDomainName() . "/api/suggest/v2/?query=" . urlencode($keyword), $opts));
		$jsd = json_decode($doc);
		$obj = (object) array();
		$i=0;
		foreach ($jsd->suggest->top as $k => $v){
			if ($k == 'topResult'){
				foreach ($v as $vel){
					if ((isset($vel->typename))&&
					(($vel->typename == 'Film')||($vel->typename == 'TvSeries'))){
						$i++;
						$obj->searchFilms->searchFilms[$i] = new stdClass();
						$obj->searchFilms->searchFilms[$i]->id = $vel->id;
						$obj->searchFilms->searchFilms[$i]->nameRU = HD::str_remove_tag($vel->title->russian);
						$obj->searchFilms->searchFilms[$i]->nameEN = HD::str_remove_tag($vel->title->original);
						$obj->searchFilms->searchFilms[$i]->year = HD::str_remove_tag($vel->productionYear);
						$obj->searchFilms->searchFilms[$i]->rating = $vel->rating->kinopoisk->value;
					}else if ((isset($vel->typename))&&($vel->typename == 'Person')){
						$i++;
						$obj->searchPeople->searchPeople[$i] = new stdClass();
						$obj->searchPeople->searchPeople[$i]->id = $vel->id;
						$obj->searchPeople->searchPeople[$i]->nameRU = HD::str_remove_tag($vel->name);
						$obj->searchPeople->searchPeople[$i]->nameEN = HD::str_remove_tag($vel->originalName);
						$obj->searchPeople->searchPeople[$i]->year = HD::str_remove_tag($vel->birthDate);
					}
				}
			}
			if (($k == 'persons')||($k == 'movies')){
				foreach ($v as $vel2){
					foreach($vel2 as $vel){
						if ((isset($vel->typename))&&(($vel->typename == 'Film')||($vel->typename == 'TvSeries'))){
							$i++;
							$obj->searchFilms->searchFilms[$i] = new stdClass();
							$obj->searchFilms->searchFilms[$i]->id = $vel->id;
							$obj->searchFilms->searchFilms[$i]->nameRU = HD::str_remove_tag($vel->title->russian);
							$obj->searchFilms->searchFilms[$i]->nameEN = HD::str_remove_tag($vel->title->original);
							if ($obj->searchFilms->searchFilms[$i]->nameRU == '')
								$obj->searchFilms->searchFilms[$i]->nameRU = $obj->searchFilms->searchFilms[$i]->nameEN;
							$obj->searchFilms->searchFilms[$i]->year = HD::str_remove_tag($vel->productionYear);
							$obj->searchFilms->searchFilms[$i]->rating = $vel->rating->kinopoisk->value;
						}else if ((isset($vel->typename))&&($vel->typename == 'Person')){
							$i++;
							$obj->searchPeople->searchPeople[$i] = new stdClass();
							$obj->searchPeople->searchPeople[$i]->id = $vel->id;
							$obj->searchPeople->searchPeople[$i]->nameRU = HD::str_remove_tag($vel->name);
							$obj->searchPeople->searchPeople[$i]->nameEN = HD::str_remove_tag($vel->originalName);
							if ($obj->searchPeople->searchPeople[$i]->nameRU == '')
								$obj->searchPeople->searchPeople[$i]->nameRU = $obj->searchPeople->searchPeople[$i]->nameEN;
							$obj->searchPeople->searchPeople[$i]->year = HD::str_remove_tag($vel->birthDate);
						}
					}
				}
			}
		}
		hd_silence_warnings();
		$obj->searchFilms->pagesCount = $obj->searchPeople->pagesCount = 1;
		hd_restore_warnings();
		if ($type == 'people')
			return $obj->searchPeople;
		else
			return $obj->searchFilms;
	}

	public static function siteKpSearch($keyword, $page, $type){
		if ($type == 'film'){
			$doc =  self::http_get_document(self::getDomainName() . "/s/type/film/list/1/find/".urlencode($keyword)."/order/relevant/page/$page/");
			$doc = html_entity_decode($doc, ENT_QUOTES,'UTF-8');
			$obj = (object) array();
			if (preg_match_all ('|<div class="element.*?data-id="(.*?)".*?alt="(.*?)".*?<div class="clear">|ms', $doc, $match)){
				$i=0;
				foreach ($match[1] as $k => $v){
					$obj->searchFilms[$i] = new stdClass();
					$obj->searchFilms[$i]->id = $v;
					$obj->searchFilms[$i]->nameRU = $match[2][$k];
					$obj->searchFilms[$i]->type = 1;
					if (preg_match('|class="year">(.*?)<|', $match[0][$k], $matches))
						$obj->searchFilms[$i]->year = $matches[1];
					if (preg_match('|<div class="rating.*?">(.*?)<|', $match[0][$k], $matches))
						$obj->searchFilms[$i]->rating = $matches[1];
					if (preg_match('|<br />\((.*?)\)|', $match[0][$k], $matches))
						$obj->searchFilms[$i]->genre = str_replace(array(",","..."),'', $matches[1]);
					if (preg_match('|class="gray">(.*?)<.*?class="gray">(.*?)<.*?class="gray">|ms', $match[0][$k], $matches)){
						$obj->searchFilms[$i]->country = str_replace(array(",","..."),'', $matches[2]);
						if (preg_match('|(.*?),(.*?)мин|ms', $matches[1], $m))
							$obj->searchFilms[$i]->nameEN = $m[1];
						else if (!preg_match('|(.*?)мин|ms', $matches[1], $m))
							$obj->searchFilms[$i]->nameEN = $matches[1];
						else
							$obj->searchFilms[$i]->nameEN = '';
					}
					$i++;
				}
				if (preg_match('|/page/(.*?)/">»»</a></li>|', $doc, $matches))
					$obj->pagesCount = $matches[1];
				else
					$obj->pagesCount = $page;
			}
		}
		if ($type == 'people'){
			$doc = self::http_get_document(self::getDomainName() . "/s/type/people/list/1/find/".urlencode($keyword)."/order/relevant/page/$page/");
			$doc = html_entity_decode($doc, ENT_QUOTES,'UTF-8');
			$obj = (object) array();
			if (preg_match_all ('|<div class="element.*?data-id="(.*?)".*?alt="(.*?)".*?<div class="clear">|ms', $doc, $match)){
				$i=0;
				foreach ($match[1] as $k => $v){
					$obj->searchPeople[$i]= new stdClass();
					$obj->searchPeople[$i]->id = $v;
					$obj->searchPeople[$i]->nameRU = $match[2][$k];
					if (preg_match('|class="year">(.*?)<|', $match[0][$k], $matches))
						$obj->searchPeople[$i]->year = $matches[1];
					if (preg_match('|class="gray">(.*?)<.*?class="gray">(.*?)<|ms', $match[0][$k], $matches)){
						$obj->searchPeople[$i]->nameEN = $matches[1];
						$obj->searchPeople[$i]->description = trim($matches[2]);
					}
					$i++;
				}
				if (preg_match('|/page/(.*?)/">»»</a></li>|', $doc, $matches))
					$obj->pagesCount = $matches[1];
				else
					$obj->pagesCount = $page;
			}
		}
		return $obj;
	}

	public static function kpSearch($keyword, $page, $type=null){
		$keywordUrlEnc = $arr['keyword'] = str_replace('+', '%20', urlencode(str_replace(':', '', $keyword)));
		if ($page == 0)
			$page = 1;
		// if ($page == true)
			// $arr['page'] = $page;
		// $arr['order'] = 'rating';
		// $sfx = 'Films';
		if (($type == true)&&($type == 'people'))
			return self::siteKpSearch($keyword, $page, $type);// $sfx = 'People';
		// $jsd = self::get_info ("getKPSearchIn$sfx" , $arr);
		// $jsd = $jsd->data;
		// return $jsd;
		$jsd = self::getKPinfoUnOff ("/v2.1/films/search-by-keyword?keyword=$keywordUrlEnc&page=$page");
		if (!isset($jsd->films))
			return false;
		$jsd->searchFilms = $jsd->films;
		unset($jsd->films);
		foreach ($jsd->searchFilms as $k => $v){
			$jsd->searchFilms[$k]->id = $v->filmId;
			if (isset($v->nameRu))
				$jsd->searchFilms[$k]->nameRU = $v->nameRu;
			if (isset($v->nameEn))
				$jsd->searchFilms[$k]->nameEN = $v->nameEn;
			if (isset($v->countries)){
				$c = array();
				foreach ($v->countries as $vel)
					$c[] = $vel->country;
				$jsd->searchFilms[$k]->country = implode (', ', $c);
			}
			if (isset($v->genres)){
				$c = array();
				foreach ($v->genres as $vel)
					$c[] = $vel->genre;
				$jsd->searchFilms[$k]->genre = implode (', ', $c);
			}
		}
		return $jsd;
	}

	public static function globalSearch ($keyword, $page = null){
		$arr['keyword'] = urlencode(str_replace(':', '', $keyword));
		if ($page == true)
			$arr['page'] = $page;
		$arr['order'] = 'rating';
		$jsd = self::get_info ('getKPGlobalSearch', $arr);
		$jsd = $jsd->data;
		return $jsd;
	}
	
	public static function searchKpId ($caption, $caption_original, $year, $movie_id=null){
		echo "$caption, $caption_original, $year";
		if ($movie_id == true){
			$kpIDs = HD::getItemsArr('kpIDs');
			if (isset($kpIDs[$movie_id]))
				return $kpIDs[$movie_id];
		}
		if (preg_match('|(.*?)\n|', $caption_original, $m))
			$caption_original = $m[1];
		$searchSettings = (HD::getItemsArr('searchSettings') != array()) ? HD::getItemsArr('searchSettings') : array('useOsk' => 1, 'searchСhoice' => 1, 'kpSearchMetod' => 0);
		$type = 'film';
		if ($searchSettings['kpSearchMetod'] == 0)
			$jsd = self::kpSearch($caption_original, 0, $type);
		else if ($searchSettings['kpSearchMetod'] == 1)
			$jsd = self::siteKpSearch($caption_original, 0, $type);
		else if ($searchSettings['kpSearchMetod'] == 2)
			$jsd = self::suggestKpSearch($caption_original, $type);
		if (isset($jsd->searchFilms)){
			if ($year != '')
				foreach ($jsd->searchFilms as $v)
					if ((isset($v->year))&&(preg_match("|".trim($year)."|",$v->year)))
						return $v->id;
		}
		if (HD::strSanitizing($caption, true) != HD::strSanitizing($caption_original, true)){
			if ($searchSettings['kpSearchMetod'] == 0)
				$jsd = self::kpSearch($caption, 0, $type);
			if ($searchSettings['kpSearchMetod'] == 1)
				$jsd = self::siteKpSearch($caption, 0, $type);
			if ($searchSettings['kpSearchMetod'] == 2)
				$jsd = self::suggestKpSearch($caption, $type);
			if (isset($jsd->searchFilms)){
				if ($year != '')
					foreach ($jsd->searchFilms as $v)
						if ((isset($v->year))&&(preg_match("|".trim($year)."|",$v->year)))
							return $v->id;
				if (isset($jsd->searchFilms[0]->id))
					return $jsd->searchFilms[0]->id;
			}
		}
		if (isset($jsd->searchFilms[0]->id))
			return $jsd->searchFilms[0]->id;
		return false;
	}
}
?>