<?php
if (!class_exists('DuneSystem')){
	if (preg_match('|plugins/(.*?)/lib|', __DIR__, $matches)){
		$tmp_path = '/tmp/plugins/'.$matches[1];
		$plugin_name = $matches[1];
		$install_dir = str_replace('/lib/wox', '',  __DIR__);
		if (file_exists('/persistfs/plugins_data'))
			$data_dir = "/persistfs/plugins_data/$plugin_name";
		else
			$data_dir = "/flashdata/plugins_data/$plugin_name";
        $port = HD::http_local_port();
		$www_url = "http://127.0.0.1:$port/plugins/$plugin_name/";
		$cgi_url = "http://127.0.0.1:$port/cgi-bin/plugins/$plugin_name/";
	}

	function hd_print($str){
		echo $str;
	}
	class DuneSystem{
		public static $properties = array ();
	};
	DuneSystem::$properties['plugin_name']      = $plugin_name;
	DuneSystem::$properties['install_dir_path'] = $install_dir;
	DuneSystem::$properties['tmp_dir_path']     = $tmp_path;
	DuneSystem::$properties['plugin_www_url']   = $www_url;
	DuneSystem::$properties['plugin_cgi_url']   = $cgi_url;
	DuneSystem::$properties['data_dir_path']    = $data_dir;
}
class Kinotochka_Class {
	static $cName = 'Kinotochka';
	static $className = 'Kinotochka_Class';
	static $DomainName = null;
	static $proxyArr = null;
	static $proxyArrMd5 = null;
	static $proxy = null;
	public static function getDomainName(){
		if (null === self::$DomainName)
			self::$DomainName = (HD::getItemStr(self::$cName . 'DomainName') != '') ? HD::getItemStr(self::$cName . 'DomainName') : 'https://kinotochka.co';
		return self::$DomainName;
	}
	public static function getMainMenuInfo(){
		return array (
			'name' => self::$cName,
			'descr' => '||'.self::$cName.'|каталог видео с сайта ' . self::$cName . '||Если сайт не доступен используйте прокси или VPN, а так же официальные зеркала (сайты с похожим дизайном и названием могут не являтся зеркалом)'
		);
	}
	public static function get_media_url_str($k, $arr=null){
		if ($arr == true)
			return SmartVodCategoryListScreen::get_media_url_str($k, $arr);
		return SmartVodCategoryListScreen::get_media_url_str($k);
	}
	public static function getSearchMediaUrlStr($k, $arr=null){
		return SmartVodListScreen::get_media_url_str($k, $arr);
	}
	public static function getScreenActionMapArr($media_url){
		$actionsArr = array();
		return $actionsArr;
	}
	public static function getPopUpMenuItems ($selected_media_url, $parent_media_url){
		$menu_items = array();
		if ($parent_media_url == 'main_menu'){
			$menu_items[] = array(
				'caption' => 'Задать зеркало ' . self::$cName,
				'params' => array ('action' => 'mirror'),
				'icon_url' => SmartConfig::getPluginIco('s_' . self::$className)
			);
			$menu_items[] = array(
				'caption' => 'Прокси для ' . self::$cName,
				'params' => array ('action' => 'proxy'),
				'icon_url' => SmartConfig::getPluginIco('s_proxy')
			);
			$menu_items[] = 'is_separator';
		}
		$parent_media_url = MediaURL::decode($parent_media_url);
		if ((isset($parent_media_url->screen_id))&&($parent_media_url->screen_id != 'vod_series')){
			$menu_items[] = array(
				'caption' => 'Добавить в Главное меню',
				'params' => array ('action' => 'addToMainMenu'),
				'icon_url' => SmartConfig::getPluginIco('s_home')
			);
		}
		return $menu_items;
	}
	public static function getVodCategories($media_url){
		static $categories = null;
		if (is_null($categories)){
			$categories['categories'][] = array('id'=> 'search', 'class' => 'SmartSearchScreen', 'caption' => 'Поиск');
			$doc = self::http_get_document(self::getDomainName());
			$doc = str_replace('Мультфильмы и Аниме','Мультфильмы',$doc);
			if (preg_match_all('|<li><a href="\#">(.+?)</a>(.+?)</ul>|ms', $doc, $matches))
				$c = array_combine($matches[1], $matches[2]);

			if (preg_match_all('|class="fa fa-film">(.+?)</h2>.*?href="(.+?)"|ms', $doc, $match)){
				foreach ($match[1] as $k => $v){
					$v = HD::str_remove_tag($v);
					$match[2][$k] = str_replace(array('/new/','/films/', '/cartoon/'), array('/premier/','/allfilms/', '/cartoons/'), $match[2][$k]);
					if (isset($c[$v])){
						$categories['categories'][] = array('id'=>  $match[2][$k], 'class' => 'SmartVodCategoryListScreen', 'caption' => $v);
						$categories['subCategories'][$match[2][$k]][] = array('id'=>  $match[2][$k], 'class' => 'SmartVodListScreen', 'caption' => $v);
						if (preg_match_all('|href="(.+?)">(.+?)<|ms', $c[$v], $m)){
							foreach ($m[1] as $key => $vel){
								$vel = str_replace(array('/new/','/films/', '/cartoon/'), array('/premier/','/allfilms/', '/cartoons/'), $vel);
								$categories['subCategories'][$match[2][$k]][] = array('id'=> HD::str_remove_tag($vel), 'class' => 'SmartVodListScreen', 'caption' => HD::str_remove_tag($m[2][$key]));
							}
						}
						unset ($c[$v]);
					}else
						$categories['categories'][] = array('id'=> $match[2][$k], 'class' => 'SmartVodListScreen', 'caption' => $v);
				}
			}
			foreach($c as $k => $v){
				$categories['categories'][] = array('id'=>  md5($k), 'class' => 'SmartVodCategoryListScreen', 'caption' => $k);
				if (preg_match_all('|href="(.+?)">(.+?)<|ms', $v, $m)){
					foreach ($m[1] as $key => $vel){
						if (!preg_match('~topreviews\.html|playlist\/top|topusers~', $vel))
							$categories['subCategories'][md5($k)][] = array('id'=> HD::str_remove_tag($vel), 'class' => 'SmartVodListScreen', 'caption' => HD::str_remove_tag($m[2][$key]));
					}
				}
			}
			$categories['categories'][] = array('id'=>  '/podborki_filmov.html', 'class' => 'SmartVodRectangleListScreen', 'caption' => 'Подборки');
			$categories['categories'][] = array('id'=>  '/playlist/', 'class' => 'SmartVodListScreen', 'caption' => 'Подборки пользователей');
		}
		if (isset($media_url->categoryId))
			return $categories['subCategories'][$media_url->categoryId];
		return $categories['categories'];
	}
	public static function getShortMovieRange ($media_url, &$m_feed){
		$items = array();
		if ($m_feed === 'end')
			return $items;
		$url =  self::getDomainName() . $media_url->categoryId;
		if (($m_feed > 0)&&(!preg_match('|\.html|', $media_url->categoryId)))
			$url .= 'page/'. ($m_feed+1) . '/';
		$doc = self::http_get_document($url);
		++$m_feed;
		if ((preg_match('|<span>Дальше</span>|', $doc))||
			(!preg_match('|class="pnext">|', $doc)))
			$m_feed = 'end';
		return self::parseSitePage($doc);
	}
	public static function getSearchShortMovieRange ($keyword, &$m_feed){
		if (is_object($keyword))
			$keyword = $keyword->searchStr;
		if ($m_feed === 'end')
			return array();
		$opts [CURLOPT_POST] = true;
		$opts [CURLOPT_POSTFIELDS] = "query=" . urlencode($keyword);
		$doc = self::http_get_document(self::getDomainName() . '/engine/ajax/search.php', $opts);
		$m_feed = 'end';
		return self::parseSitePage($doc, 'searhc');
	}
	public static function parseSitePage($doc, $arg=null){
		$items = array();
		if (preg_match_all('|class="custom1-item">.*?href="(.+?)".*?src="(.+?)".*?title">(.+?)<.*?</div>\s*?</div>|ms', $doc, $match)){
			foreach ($match[1] as $k => $v){
				$v = str_replace(self::getDomainName(),'', $v);
				$img = $match[2][$k];
				if (!preg_match('|^http|',$match[2][$k]))
					$img = self::getDomainName() . $match[2][$k];
				$name = HD::str_remove_tag($match[3][$k]);
				if (preg_match('|(.*?)\((.*?)\)|', $name, $mm)){
					$name = $mm[1];
					$year =  $mm[2];
				}
				$name = preg_replace('/ \d+? Сезон/', '', $name);
				$info = '||' . $name;
				if ($year == true)
					$info .= '|' . $year;
				if (preg_match('|clearfix">(.+?)</div|ms', $match[0][$k], $matches))
					$info .= '|' . HD::str_remove_tag($matches[1]);
				if (preg_match('|ShortStorySerias">(.+?)</div|ms', $match[0][$k], $matches))
					$info .= '|' . HD::str_remove_tag($matches[1]);
				if (class_exists('ShortMovie')){
					$short_movie = new ShortMovie(
						strval($v),
						strval($name),
						strval(self::http_get_img ($img))
					);
					$short_movie->info = $info;
					array_push ($items, $short_movie);
				}else{
					$items[$v]['url'] = $v;
					$items[$v]['infoArr']['caption'] = $name;
					$items[$v]['infoArr']['poster_url'] = $img;
					$items[$v]['infoArr']['detailed_info'] = $info;
				}
			}
		}else if (preg_match_all('|href="(.+?)">.+?src="(.+?)".+?class="searchheading">(.+?)</.*?class="searchfields">(.+?)</|ms', $doc, $match)){
			foreach ($match[1] as $k => $v){
				$v = str_replace(self::getDomainName(),'', $v);
				$img = $match[2][$k];
				if (!preg_match('|^http|',$match[2][$k]))
					$img = self::getDomainName() . $match[2][$k];
				$name = HD::str_remove_tag($match[3][$k]);
				if (preg_match('|(.*?)\((.*?)\)|', $name, $mm)){
					$name = $mm[1];
					$year =  $mm[2];
				}
				$name = preg_replace('/ \d+? Сезон/', '', $name);
				$info = '||' . $name;
				if ($year == true)
					$info .= '|' . $year;
				$info .= '||' . HD::str_remove_tag($match[4][$k]);
				if (class_exists('ShortMovie')){
					$short_movie = new ShortMovie(
						strval($v),
						strval($name),
						strval(self::http_get_img ($img))
					);
					$short_movie->info = $info;
					array_push ($items, $short_movie);
				}else{
					$items[$v]['url'] = $v;
					$items[$v]['infoArr']['caption'] = $name;
					$items[$v]['infoArr']['poster_url'] = $img;
					$items[$v]['infoArr']['detailed_info'] = $info;
					if ($year == true)
						$items[$v]['infoArr']['year'] = $year;
				}
			}
		}else if ((preg_match_all('|item.*?">.*?href="(.+?)".*?src="(.+?)".*?name">(.+?)</|ms', $doc, $match))&&($arg == true)){
			foreach ($match[1] as $k => $v){
				$img = $match[2][$k];
				if (!preg_match('|^http|',$match[2][$k]))
					$img = self::getDomainName() . $match[2][$k];
				$name = HD::str_remove_tag($match[3][$k]);
				if (preg_match('|(.*?)\((.*?)\)|', $name, $mm)){
					$name = $mm[1];
					$year =  $mm[2];
				}
				$name = preg_replace('/ \d+? Сезон/', '', $name);
				$short_movie = new ShortMovie(
					strval($v),
					strval($name),
					strval(self::http_get_img ($img))
				);
				$info = '||' . $name . '|' . $year;
				$short_movie->info = $info;
				array_push ($items, $short_movie);
			}
		}else if (preg_match_all('|li class="top100.*?href="(.+?)".*?src="(.+?)".*?name">(.+?)</div>|ms', $doc, $match)){
			foreach ($match[1] as $k => $v){
				if (preg_match("|^" . self::getDomainName() . "|",$v))
					$v = str_replace(self::getDomainName(), '', $v);
				if ($v == '/films/')
					continue;
				$year = false;
				$img = $match[2][$k];
				if (!preg_match('|^http|',$match[2][$k]))
					$img = self::getDomainName() . $match[2][$k];
				$name = HD::str_remove_tag($match[3][$k]);
				if (preg_match('|(.*?)\((.*?)\)|', $name, $mm)){
					$name = $mm[1];
					$year =  $mm[2];
				}
				$short_movie = new ShortMovie(
					strval($v),
					strval($name),
					strval(self::http_get_img ($img))
				);
				$info = '||' . $name;
				if ($year == true)
					$info .= '|' . $year;
				$short_movie->info = $info;
				array_push ($items, $short_movie);
			}
		}else if (preg_match_all('|<div style=.*?>.*?href="(.+?)".*?src="(.+?)".*?>(.+?)</div>|ms', $doc, $match)){
			foreach ($match[1] as $k => $v){
				$img = $match[2][$k];
				if (!preg_match('|^http|',$match[2][$k]))
					$img = self::getDomainName() . $match[2][$k];
				$name = HD::str_remove_tag($match[3][$k]);
				$short_movie = new ShortMovie(
					strval($v),
					strval($name),
					strval(self::http_get_img ($img))
				);
				$info = '||' . $name;
				$short_movie->info = $info;
				$short_movie->goToScreen = 'SmartVodListScreen';
				array_push ($items, $short_movie);
			}
		}else if (preg_match_all('|custom1-img">.*?href="(.+?)".*?src="(.+?)".*?title">(.+?)</.*?quantity">(.+?)</.*?date">(.+?)</|ms', $doc, $match)){
			foreach ($match[1] as $k => $v){
				$img = $match[2][$k];
				if (!preg_match('|^http|',$match[2][$k]))
					$img = self::getDomainName() . $match[2][$k];
				$name = HD::str_remove_tag($match[3][$k]);
				$short_movie = new ShortMovie(
					strval($v),
					strval($name),
					strval(self::http_get_img ($img))
				);
				$info = '||' . $name . '|' . $match[4][$k] . '|' . $match[5][$k];
				$short_movie->info = $info;
				$short_movie->goToScreen = 'SmartVodListScreen';
				array_push ($items, $short_movie);
			}
		}else if (preg_match_all('|custom1-img">.+?href="(.+?)".+?src="(.+?)".+?title">(.+?)</a>|ms', $doc, $match)){
			foreach ($match[1] as $k => $v){
				$img = $match[2][$k];
				if (!preg_match('|^http|',$match[2][$k]))
					$img = self::getDomainName() . $match[2][$k];
				$name = HD::str_remove_tag($match[3][$k]);
				if (preg_match('|(.*?)\((.*?)\)|', $name, $mm)){
					$name = $mm[1];
					$year =  $mm[2];
				}
				$info = '||' . $name;
				if ($year == true)
					$info .= '|' . $year;
				$short_movie = new ShortMovie(
					strval($v),
					strval($name),
					strval(self::http_get_img ($img))
				);
				$short_movie->info = $info;
				if (preg_match('|playlist|',$v))
					$short_movie->goToScreen = 'SmartVodListScreen';
				array_push ($items, $short_movie);
			}
		}
		return $items;
	}
	public static function load_movie($movie_id, $mUrl, $getMovieInfo){
		$arr = array();
		$arr['caption'] = $arr['class_info']['catalog_info']['caption'] = $mUrl->caption;
		$arr['poster_url'] = $arr['class_info']['catalog_info']['poster_url'] = $mUrl->poster_url;
		if (isset($mUrl->caption_original))
			$arr['caption_original'] = $arr['class_info']['catalog_info']['caption_original'] = $mUrl->caption_original;
		if (isset($mUrl->year))
			$arr ['year'] = $arr['class_info']['catalog_info']['year'] = $mUrl->year;
		if (!preg_match("|^http|",$movie_id))
			$url = self::getDomainName() . $movie_id;
		else
			$url = preg_replace('#((http.*)://.+?\/)#i', self::getDomainName() . "/", $movie_id);
		$doc = self::http_get_document($url);
		if (preg_match('|<h1.*?>(.+?)</h1>|ms', $doc, $matches)){
			$arr['caption_original'] = $arr['caption'] = HD::str_remove_tag($matches[1]);
			$arr['caption'] = str_replace(array("Фильм","Сериал"), "", $arr['caption']);
			if (preg_match('|(.*)\((.*?)\)|', $arr['caption'], $mm)){
				$arr['caption'] = $mm[1];
				$arr['year'] =  $mm[2];
			}
			$arr['caption'] = preg_replace('/ \d+? .езон/', '', $arr['caption']);
		}
		if (preg_match('|alternativeHeadline">(.+?)</|ms', $doc, $matches))
			$arr['caption_original'] = HD::str_remove_tag($matches[1]);
		if (preg_match('|moviePosterContainer">.*?src="(.+?)"|ms', $doc, $matches)){
			$arr['poster_url'] = self::http_get_img ($matches[1]);
			if (preg_match('|<div.*?>(.+?)</div>|ms', $matches[0], $matches))
				$arr ['rate_details']['Q:'] = HD::str_remove_tag($matches[1]);
		}
		if (preg_match('|class="content">(.*?)</div|ms', $doc, $matches))
			$arr['description'] = HD::str_remove_tag($matches[1]);
		else if (preg_match('|itemprop="description">(.*?)</div|ms', $doc, $matches))
			$arr['description'] = HD::str_remove_tag($matches[1]);
		if (preg_match('|countryOfOrigin">(.+?)</div|ms', $doc, $matches))
			$arr['country'] = HD::str_remove_tag($matches[1]);
		if (preg_match('|itemprop="genre">(.+?)</div|ms', $doc, $matches))
			$arr['genres'] = HD::str_remove_tag($matches[1]);
		if (preg_match('|itemprop="translator">(.+?)</div>|ms', $doc, $match))
			$arr ['details']['Озвучка:'] = HD::str_remove_tag($match[1]);
		if (preg_match('|itemprop="copyrightYear">(.+?)</div|ms', $doc, $matches))
			$arr['year'] = HD::str_remove_tag($matches[1]);
		if (preg_match('|itemprop="director">(.*?)</div|ms', $doc, $matches))
			$arr['director'] = HD::str_remove_tag($matches[1]);
		if (preg_match('|олях:</b>(.*?)</div|ms', $doc, $matches))
			$arr['actors'] = HD::str_remove_tag($matches[1]);
		if (preg_match('|data-id="(.*?)"|ms', $doc, $matches)){
			$opts [CURLOPT_POST] = true;
			$opts [CURLOPT_POSTFIELDS] = "id=" . HD::str_remove_tag($matches[1]);
			$docActors = self::http_get_document(self::getDomainName() . '/engine/ajax/actor/list.php', $opts);
			if (preg_match_all('|class="actor-name">(.+?)</a>|ms', $docActors, $matches))
				$arr['actors'] = implode(', ', $matches[1]);
		}
		if (preg_match('|ratingValue">(.+?)</div|ms', $doc, $matches))
			$arr ['rate_details']['Рейтинг:'] = round(HD::str_remove_tag($matches[1]), 1);
		$arr['class_info']['linksArr'][self::$className] = $movie_id;

		$kpIDs = HD::getItemsArr('kpIDs');
		if (isset($kpIDs[$movie_id]))
			$arr['class_info']['dbIDs']['kpID'] = $kpIDs[$movie_id];
		if ($getMovieInfo != 'min')
			$arr = SmartConfig::getMovieInfoArr($getMovieInfo, $movie_id, $mUrl, $arr);
		return $arr;
	}
	public static function getIframe($params){
		$iframeInfo = array($params);
		if (isset($params['linksArr'][self::$className])){
			if (!preg_match("|^http|",$params['linksArr'][self::$className]))
				$params['linksArr'][self::$className] = self::getDomainName() . $params['linksArr'][self::$className];
			$urls = kinotochka::getKinoTochkaIframe($params['linksArr'][self::$className],'video_id');
		}else{
			if (HD::strSanitizing($params['caption_original']) != HD::strSanitizing($params['caption'])){
				$year = 'null';
				if (isset($params['caption_original'])){
					$keyword = $params['caption_original'];
					$m_feed= 0;
					$arr = self::getSearchShortMovieRange ($keyword, $m_feed);
					foreach ($arr as $k => $v){
						if (HD::strSanitizing($keyword) == HD::strSanitizing($v['infoArr']['caption'])){
							extract ($v);
							$iframeInfo['infoArr'] = $infoArr;
							break;
						}
					}
				}
			}
			if (!isset($url)){
				$keyword = $params['caption'];
				$m_feed= 0;
				$arr = self::getSearchShortMovieRange ($keyword, $m_feed);
				foreach ($arr as $k => $v){
					if (HD::strSanitizing($keyword) == HD::strSanitizing($v['infoArr']['caption'])){
						extract ($v);
						$iframeInfo['infoArr'] = $infoArr;
						break;
					}
				}
				if (!isset($url))
					if (count($arr) > 0){
						$f = array_shift($arr);
						extract ($f);
						$iframeInfo['infoArr'] = $infoArr;
					}
			}
			if (isset($url)){
				if (!preg_match("|^http|",$url))
					$url = self::getDomainName() . $url;
				$urls = kinotochka::getKinoTochkaIframe($url,'video_id');
			}else{
				echo "\n".self::$cName.":search failed";
				return array("status"=>false);
			}
		}
		if ($urls == true){
			foreach ($urls as $k => $v){
				if (($k == 'm')||(preg_match('|^http|', $k)))
					$k = self::$cName;
				if (preg_match("|EpisodId_|", $v))
					$iframeInfo['urls'][$k]['goTo'] = 'VodSeriesListScreen';
				else
					$iframeInfo['urls'][$k]['goTo'] = 'VodSeasonListScreen';
				$iframeInfo['urls'][$k]['link'] = $v;
			}
			return $iframeInfo;
		}else{
			echo "\n".self::$cName.":search failed";
			return array("status"=>false);
		}
		return $iframeInfo;
	}
	public static function getSeasons($media_url){
		$urls = kinotochka::getKinoTochkaIframe ($media_url->link, 'seasons');
		foreach ($urls as $k => $v){
			$uArr[$k]['caption'] = $k;
			$uArr[$k]['link'] = $v;
			$uArr[$k]['detailed_info'] = '||' . $k . $media_url->detailed_info;
			$uArr[$k]['class_name'] = $media_url->class_name;
			$uArr[$k]['poster_url'] = $media_url->poster_url;
			$uArr[$k]['goTo'] = 'VodSeasonListScreen';
			if (preg_match("|SeasonId|",$v)){
				$uArr[$k]['season'] = $k;
				$uArr[$k]['goTo'] = 'VodSeriesListScreen';
			}
		}
		return $uArr;
	}
	public static function get_series_list($media_url, $movie){
		if (preg_match('|EpisodId_|', $media_url->link)){
			$qltyMax = false;
			if (preg_match('|(.+?)\sQ:(\d+)|', $media_url->caption, $m))
				$qltyMax = $m[2];
			$hash_patrs = $media_url->caption;
			if (isset($media_url->hash_patrs)){
				$hash_patrs = implode("", (array)$media_url->hash_patrs);
			}
			$items[$media_url->caption]['id'] = md5 ($hash_patrs);
			$items[$media_url->caption]['title'] = $media_url->caption;
			$items[$media_url->caption]['playback_url'] = $media_url->link;
			$items[$media_url->caption]['is_stream_url'] = false;
			$items[$media_url->caption]['file_info']['poster_url'] = $media_url->poster_url;
			$items[$media_url->caption]['file_info']['details_box_width'] = true;
			$items[$media_url->caption]['file_info']['class_name'] = $media_url->class_name;
			if (isset($media_url->description))
				$items[$media_url->caption]['file_info']['description'] = $media_url->description;
			$items[$media_url->caption]['file_info']['detailed_info'] = $media_url->detailed_info;
			if ($qltyMax == true)
				$items[$media_url->caption]['file_info']['qltyMax'] = $qltyMax;
			return $items;
		}
		$episodes  = kinotochka::getKinoTochkaIframe($media_url->link, 'episodes');
		if ($episodes == true){
			$items = array();
			foreach ($episodes as $key => $vel){
				$qltyMax = false;
				if (preg_match('|(.+?)\sQ:(\d+?)$|', $key, $m)){
					$key = $m[1];
					$qltyMax = $m[2];
				}
				$tvshow_se = VideoInfo::tvshow_se_parse($key);
				if (isset($tvshow_se['S']))
					$media_url->hash_patrs->season = $tvshow_se['S'];
				if (isset($tvshow_se['E']))
					$media_url->hash_patrs->episode = $tvshow_se['E'];
				else
					$media_url->hash_patrs->episode = $key;
				$hash_patrs = implode("", (array)$media_url->hash_patrs);
				$items[$key]['id'] = md5 ($hash_patrs);
				$items[$key]['title'] = $key;
				$items[$key]['playback_url'] = $vel;
				$items[$key]['is_stream_url'] = false;
				$items[$key]['file_info']['poster_url'] = $media_url->poster_url;
				$items[$key]['file_info']['details_box_width'] = true;
				$items[$key]['file_info']['class_name'] = $media_url->class_name;
				$items[$key]['file_info']['detailed_info'] = $media_url->detailed_info;
				if (isset($media_url->description))
					$items[$key]['file_info']['description'] = $media_url->description;
				if ($qltyMax == true)
					$items[$key]['file_info']['qltyMax'] = $qltyMax;
			}
		}
		return $items;
	}
	public static function getVodSourceInfo($v){
		$ico = SmartConfig::getPluginIco($v);
		$arr['caption'] = self::$cName;
		$arr['icon_path'] = $ico;
		$arr['detailed_icon_path'] = $ico;
		$arr['class_name'] = $v;
		$arr['detailed_info'] = '||' . self::$cName . '|видео с сайта '.self::$cName.'. Поиск видео на сайте '.self::$cName.' производится по названию возможны неточности.';
		$arr['type'] = SmartConfig::getPluginIco('onlineSource');
		return $arr;
	}
	public static function http_get_img ($url){
		if (self::$proxy == true){
			$path_parts = parse_url(self::getDomainName());
			if (!preg_match("|^http|",$url))
				return DuneSystem::$properties['plugin_cgi_url'] . "do?img=" . self::getDomainName() . $url . "&proxy=" . self::$cName;
			if (preg_match("|".$path_parts['host']."|",$url))
				return DuneSystem::$properties['plugin_cgi_url'] . "do?img=" . $url . "&proxy=" . self::$cName;
		}
		if (!preg_match("|^http|",$url))
			$url = self::getDomainName() . $url;
		return DuneSystem::$properties['plugin_cgi_url'] . "do?img=" . $url;
	}
	public static function http_get_document ($url, $opts=null){
		
		if (is_null(self::$proxy)){
			self::$proxy = false;
			$sitesProxy = HD::getItemsArr('sitesProxy');
			if (isset($sitesProxy[self::$cName])){
				$proxySettings = (HD::getItemsArr('proxySettings') != array()) ? HD::getItemsArr('proxySettings') : array();
				if (isset($proxySettings['proxy'])){
					self::$proxy['proxy'] = $proxySettings['proxy'];
					if ((isset($proxySettings['proxyType']))&&($proxySettings['proxyType'] == 'SOCKS5'))
						self::$proxy['proxyType'] = $proxySettings['proxyType'];
					if (isset($proxySettings['proxyAccount']))
						self::$proxy['proxyAccount'] = $proxySettings['proxyAccount'];
				}
			}
		}
		if (self::$proxy == true){
			$opts[CURLOPT_PROXY] = self::$proxy['proxy'];
			if (isset(self::$proxy['proxyType']))
				$opts[CURLOPT_PROXYTYPE] = CURLPROXY_SOCKS5;
			if (isset(self::$proxy['proxyAccount']))
				$opts[CURLOPT_PROXYUSERPWD] = self::$proxy['proxyAccount'];
		}
		return HD::http_get_document($url, $opts);
	}
}
?>
