<?php
if (!class_exists('DuneSystem')){
	if (preg_match('|plugins/(.*?)/lib|', __DIR__, $matches)){
		$tmp_path = '/tmp/plugins/'.$matches[1];
		$plugin_name = $matches[1];
		$install_dir = str_replace('/lib/wox', '',  __DIR__);
		if (file_exists('/persistfs/plugins_data'))
			$data_dir = "/persistfs/plugins_data/$plugin_name";
		else
			$data_dir = "/flashdata/plugins_data/$plugin_name";
        $port = HD::http_local_port();
		$www_url = "http://127.0.0.1:$port/plugins/$plugin_name/";
		$cgi_url = "http://127.0.0.1:$port/cgi-bin/plugins/$plugin_name/";
	}

	function hd_print($str){
		echo $str;
	}
	class DuneSystem{
		public static $properties = array ();
	};
	DuneSystem::$properties['plugin_name']      = $plugin_name;
	DuneSystem::$properties['install_dir_path'] = $install_dir;
	DuneSystem::$properties['tmp_dir_path']     = $tmp_path;
	DuneSystem::$properties['plugin_www_url']   = $www_url;
	DuneSystem::$properties['plugin_cgi_url']   = $cgi_url;
	DuneSystem::$properties['data_dir_path']    = $data_dir;
}
class Kodik_Class {
	static $cName = 'Kodik';
	static $className = 'Kodik_Class';
	// static $DomainName = null;
	// static $proxyArr = null;
	// static $proxyArrMd5 = null;
	// static $proxy = null;
	// public static function getDomainName(){
		// if (null === self::$DomainName)
			// self::$DomainName = (HD::getItemStr(self::$cName . 'DomainName') != '') ? HD::getItemStr(self::$cName . 'DomainName') : 'https://kinogo.by';
		// return self::$DomainName;
	// }
	public static function getMainMenuInfo(){
		return array (
			'name' => self::$cName,
			'descr' => '||'.self::$cName.'|каталог видео ' . self::$cName . '||Аниме и дорамы'
		);
	}
	public static function get_media_url_str($k, $arr=null){
		if ($arr == true)
			return SmartVodListScreen::get_media_url_str($k, $arr);
		return SmartVodListScreen::get_media_url_str($k);
	}
	public static function getSearchMediaUrlStr($k, $arr=null){
		return SmartVodListScreen::get_media_url_str($k, $arr);
	}
	public static function getScreenActionMapArr($media_url){
		$actionsArr = array();
		return $actionsArr;
	}
	public static function getPopUpMenuItems ($selected_media_url, $parent_media_url){
		$menu_items = array();
		$parent_media_url = MediaURL::decode($parent_media_url);
		if ((isset($parent_media_url->screen_id))&&($parent_media_url->screen_id != 'vod_series')){
			$menu_items[] = array(
				'caption' => 'Добавить в Главное меню',
				'params' => array ('action' => 'addToMainMenu'),
				'icon_url' => SmartConfig::getPluginIco('s_home')
			);
		}
		return $menu_items;
	}
	public static function getShortMovieRange ($media_url, &$m_feed){
		$items = array();
		if ($m_feed === 'end')
			return $items;
		$jsd = Kodik::kodikCatalogObj($m_feed);
		$m_feed = 'end';
		if ((isset($jsd->next_page))&&($jsd->next_page != ''))
			$m_feed = $jsd->next_page;
		if (isset($jsd->results))
			return self::parseSitePage($jsd->results);
		else
			return array();
	}
	public static function getSearchShortMovieRange ($keyword, &$m_feed){
		$items = array();
		if ($m_feed === 'end')
			return $items;
		if (is_object($keyword))
			$keyword = $keyword->searchStr;
		$jsd = Kodik::kodikSearchObj($keyword);
		$m_feed = 'end';
		if (isset($jsd->results))
			return self::parseSitePage($jsd->results);
		else
			return array();
	}
	public static function parseSitePage($jsd){
		$items = array();
		foreach ($jsd as $v){
			if (isset($v->title))
				$name = $v->title;
			$id = $v->link;
			if (!preg_match('|^http|', $id))
				$id = 'http:' . $id;
			if (isset($v->kinopoisk_id))
				$id = $v->kinopoisk_id;
			$img = 'plugin_file://icons/poster_none.png';
			if (isset($v->kinopoisk_id))
				$img = Kinopoisk_Class::http_get_img("http://st.kp.yandex.net/images/film_iphone/iphone360_$id.jpg");
			$short_movie = new ShortMovie(
				strval($id),
				strval($name),
				strval($img)
			);
			$info = $name;
			if (isset($v->title_orig)){
				$short_movie->caption_original = $v->title_orig;
				$info .= '|' . $v->title_orig;
			}
			if (isset($v->year)){
				$short_movie->year = $v->year;
				$info .= '|' . $v->year;
			}
			if (isset($v->translation->title))
				$info .= '||Перевод:|' . $v->translation->title;
			$quality = false;
			if (isset($v->quality)){
				$quality = '|' . $v->quality;
			}
			if ((isset($v->camrip))&&($v->camrip != ''))
				$quality = ' CamRip';
			if ($quality == true){
				$info .= '|' . $quality;
				$short_movie->right_top_img = $short_movie->left_bottom_img = false;
				$right_top_img = SmartConfig::getQualityIco(str_replace(array('720p', '1080p'),'', $quality));
				$short_movie->right_top_img = $right_top_img;
			}
			if (isset($v->type))
				$info .= '|' . str_replace("-", " ", $v->type);
			if ((isset($v->blocked_countries))&&(count($v->blocked_countries)>0))
				$info .= '|Блокированно: ' . implode(",", $v->blocked_countries);
			if ((isset($v->updated_at))&&($v->updated_at != '')){
				$date = new DateTime($v->updated_at);
				$info .= '|Обновлен: ' . $date->format('d.m.Y H:i');
			}
			if (isset($v->kinopoisk_id))
				$short_movie->newClassName = 'Kinopoisk_Class';
			else
				$short_movie->goToSourceList = true;
			$short_movie->info = $info;
			array_push ($items, $short_movie);
		}
		return $items;
	}
	public static function getVodSourceInfo($v){
		$ico = SmartConfig::getPluginIco($v);
		$arr['caption'] = self::$cName;
		$arr['icon_path'] = $ico;
		$arr['detailed_icon_path'] = $ico;
		$arr['class_name'] = $v;
		$arr['detailed_info'] = '||' . self::$cName . '|видео с '.self::$cName.'. Аниме и дорамы';
		$arr['type'] = SmartConfig::getPluginIco('onlineSource');
		return $arr;
	}
	public static function getIframe($params){
		$iframeInfo = array($params);
		if (isset($params['linksArr'][self::$className]))
			$urls = Kodik::getKodikIframe ($params['linksArr'][self::$className],'video_id');
		else if ((isset($params['kpID']))&&($params['kpID'] != ''))
			$urls = Kodik::getKodikIframe ($params['kpID'],'kp_id');
		if ((isset($urls))&&($urls == true)){
			foreach ($urls as $k => $v){
				if (($k == 'm')||(preg_match('|^http|', $k)))
					$k = self::$cName;
				if (preg_match("|EpisodId_|", $v))
					$iframeInfo['urls'][$k]['goTo'] = 'VodSeriesListScreen';
				else
					$iframeInfo['urls'][$k]['goTo'] = 'VodSeasonListScreen';
				$iframeInfo['urls'][$k]['link'] = $v;
			}
			return $iframeInfo;
		}else{
			echo "\n".self::$cName.":search failed";
			return array("status"=>false);
		}
		return $iframeInfo;
	}
	public static function getSeasons($media_url){
		$urls = Kodik::getKodikIframe ($media_url->link, 'seasons');
		foreach ($urls as $k => $v){
			$uArr[$k]['caption'] = $k;
			$uArr[$k]['link'] = $v;
			$uArr[$k]['detailed_info'] = '||' . $k . $media_url->detailed_info;
			$uArr[$k]['class_name'] = $media_url->class_name;
			$uArr[$k]['poster_url'] = $media_url->poster_url;
			$uArr[$k]['goTo'] = 'VodSeasonListScreen';
			if (preg_match("|SeasonId|",$v)){
				$uArr[$k]['season'] = $k;
				$uArr[$k]['goTo'] = 'VodSeriesListScreen';
			}
		}
		return $uArr;
	}
	public static function get_series_list($media_url, $movie){
		if (preg_match('|EpisodId_|', $media_url->link)){
			$qltyMax = false;
			if (preg_match('|(.+?)\sQ:(\d+)|', $media_url->caption, $m))
				$qltyMax = $m[2];
			$hash_patrs = $media_url->caption;
			if (isset($media_url->hash_patrs)){
				$hash_patrs = implode("", (array)$media_url->hash_patrs);
			}
			$items[$media_url->caption]['id'] = md5 ($hash_patrs);
			$items[$media_url->caption]['title'] = $media_url->caption;
			$items[$media_url->caption]['playback_url'] = $media_url->link;
			$items[$media_url->caption]['is_stream_url'] = false;
			$items[$media_url->caption]['file_info']['poster_url'] = $media_url->poster_url;
			$items[$media_url->caption]['file_info']['details_box_width'] = true;
			$items[$media_url->caption]['file_info']['class_name'] = $media_url->class_name;
			if (isset($media_url->description))
				$items[$media_url->caption]['file_info']['description'] = $media_url->description;
			$items[$media_url->caption]['file_info']['detailed_info'] = $media_url->detailed_info;
			if ($qltyMax == true)
				$items[$media_url->caption]['file_info']['qltyMax'] = $qltyMax;
			return $items;
		}
		$episodes = Kodik::getKodikIframe ($media_url->link, 'episodes');
		if ($episodes == true){
			$items = array();
			foreach ($episodes as $key => $vel){
				$qltyMax = false;
				if (preg_match('|(.+?)\sQ:(\d+?)$|', $key, $m)){
					$key = $m[1];
					$qltyMax = $m[2];
				}
				$tvshow_se = VideoInfo::tvshow_se_parse($key);
				if (isset($tvshow_se['S']))
					$media_url->hash_patrs->season = $tvshow_se['S'];
				if (isset($tvshow_se['E']))
					$media_url->hash_patrs->episode = $tvshow_se['E'];
				else
					$media_url->hash_patrs->episode = $key;
				$hash_patrs = implode("", (array)$media_url->hash_patrs);
				$items[$key]['id'] = md5 ($hash_patrs);
				$items[$key]['title'] = $key;
				$items[$key]['playback_url'] = $vel;
				$items[$key]['is_stream_url'] = false;
				$items[$key]['file_info']['poster_url'] = $media_url->poster_url;
				$items[$key]['file_info']['details_box_width'] = true;
				$items[$key]['file_info']['class_name'] = $media_url->class_name;
				$items[$key]['file_info']['detailed_info'] = $media_url->detailed_info;
				if (isset($media_url->description))
					$items[$key]['file_info']['description'] = $media_url->description;
				if ($qltyMax == true)
					$items[$key]['file_info']['qltyMax'] = $qltyMax;
			}
		}
		return $items;
	}
	public static function load_movie($movie_id, $mUrl, $getMovieInfo){
		$arr = array();
		$arr['caption'] = $arr['class_info']['catalog_info']['caption'] = $mUrl->caption;
		$arr['poster_url'] = $arr['class_info']['catalog_info']['poster_url'] = $mUrl->poster_url;
		if (isset($mUrl->caption_original))
			$arr['caption_original'] = $arr['class_info']['catalog_info']['caption_original'] = $mUrl->caption_original;
		if (isset($mUrl->year))
			$arr ['year'] = $arr['class_info']['catalog_info']['year'] = $mUrl->year;
		$arr['caption'] = $mUrl->caption;
		$arr['caption_original'] = $mUrl->caption_original;
		$arr['description'] = '';
		$arr['poster_url'] = $mUrl->poster_url;
		$arr['id'] = $movie_id;
		$arr['title'] = $mUrl->caption;
		$arr['file_info']['poster_url'] = $mUrl->poster_url;
		$arr['file_info']['class_name'] = HD::str_remove_tag($mUrl->class_name);
		$arr['file_info']['description'] = '';
		$arr['file_info']['detailed_info'] = HD::str_remove_tag($mUrl->description);
		$arr['file_info']['icon_path'] = SmartConfig::getPluginIco('movie');
		$arr['file_info']['parent_media_url'] = 'noupd';
		$arr['class_info']['linksArr'][self::$className] = $movie_id;
		return $arr;
	}
}
?>
