<?
if (!class_exists('DuneSystem')){
	if (preg_match('|plugins/(.*?)/lib|', __DIR__, $matches)){
		$tmp_path = '/tmp/plugins/'.$matches[1];
		$plugin_name = $matches[1];
		$install_dir = str_replace('/lib/wox', '',  __DIR__);
		if (file_exists('/persistfs/plugins_data'))
			$data_dir = "/persistfs/plugins_data/$plugin_name";
		else
			$data_dir = "/flashdata/plugins_data/$plugin_name";
		$www_url = "http://127.0.0.1/plugins/$plugin_name/";
		$cgi_url = "http://127.0.0.1/cgi-bin/plugins/$plugin_name/";
	}

	function hd_print($str){
		echo $str;
	}
	class DuneSystem{
		public static $properties = array ();
	};
	DuneSystem::$properties['plugin_name']      = $plugin_name;
	DuneSystem::$properties['install_dir_path'] = $install_dir;
	DuneSystem::$properties['tmp_dir_path']     = $tmp_path;
	DuneSystem::$properties['plugin_www_url']   = $www_url;
	DuneSystem::$properties['plugin_cgi_url']   = $cgi_url;
	DuneSystem::$properties['data_dir_path']    = $data_dir;
}
class NDR_Class {
	static $cName = 'NDR';
	static $className = 'NDR_Class';
  static $DomainName = null;
  public static function getDomainName(){
		if (null === self::$DomainName)
			self::$DomainName = (HD::getItemStr(self::$cName . 'DomainName') != '') ? HD::getItemStr(self::$cName . 'DomainName') : 'https://ndrsite.neocities.org';
		return self::$DomainName;
	}
	public static function getMainMenuInfo(){
		return array (
			'name' => self::$cName,
			'descr' => '||'.self::$cName.'|НЦР — Новые Цифровые Релизы это каталог, с помощью которого вы сможете просмотреть или скачать новые торренты фильмов, появившиеся за несколько месяцев.'
		);
	}
	public static function get_media_url_str($k, $arr=null){
		if ($arr == true)
			return SmartVodListScreen::get_media_url_str($k, $arr);
		return SmartVodListScreen::get_media_url_str($k);
	}
	public static function getScreenActionMapArr($media_url){
		$actionsArr = array();
		return $actionsArr;
	}
	public static function getPopUpMenuItems ($selected_media_url, $parent_media_url){
		$menu_items = array();
    if ($parent_media_url == 'main_menu'){
     $menu_items[] = array(
				'caption' => 'Задать зеркало ' . self::$cName,
				'params' => array ('action' => 'mirror'),
				'icon_url' => SmartConfig::getPluginIco('' . self::$className)
			);
    }
		$parent_media_url = MediaURL::decode($parent_media_url);
		if ($parent_media_url->screen_id == 'vod_torrentlist'){
			
			$menu_items[] = array(
				'caption' => 'Изменить действие для торрентов',
				'params' => array ('action' => 'torrentActionSetup'),
				'icon_url' => SmartConfig::getPluginIco('s_torrent')
			);
			$menu_items[] = array(
				'caption' => 'Выбрать действие торрента',
				'conID' => 'add_actions',
				'params' => array ('torrentAction' => 1),
				'icon_url' => SmartConfig::getPluginIco('s_list')
			);
			$menu_items[] = 'is_separator';
			$menu_items[] = array(
				'caption' => 'Настройки TorrServer',
				'conID' => 'classSetupTorrServer',
				'params' =>  null,
				'icon_url' => SmartConfig::getPluginIco('s_torrserver')
			);
			$menu_items[] = array(
				'caption' => 'Настройки PeerflixServer',
				'conID' => 'classSetupPeerflixServer',
				'params' =>  null,
				'icon_url' => SmartConfig::getPluginIco('s_peerflixserver')
			);
			$menu_items[] = array(
				'caption' => 'Настройки Transmission',
				'conID' => 'classSetupTransmission',
				'params' =>  null,
				'icon_url' => SmartConfig::getPluginIco('s_transmission')
			);
			$menu_items[] = array(
				'caption' => 'Настройки Transmission UPnP',
				'conID' => 'classSetupTransmissionUPnP',
				'params' =>  null,
				'icon_url' => SmartConfig::getPluginIco('s_transmissionupnp')
			);
			$menu_items[] = 'is_separator';
		}
		if ((isset($parent_media_url->screen_id))&&($parent_media_url->screen_id != 'vod_series')){
			$menu_items[] = array(
				'caption' => 'Добавить в Главное меню',
				'params' => array ('action' => 'addToMainMenu'),
				'icon_url' => SmartConfig::getPluginIco('s_home')
			);
		}
		return $menu_items;
	}
	public static function getShortMovieRange ($media_url, &$m_feed){
		$items = array();
		if ($m_feed === 'end')
			return $items;
		$doc = HD::http_get_document(self::getDomainName() . '/ndr.html');
		$m_feed = 'end';
		if (preg_match_all('|headerFilm">.*?name">(.+?)<.*?description".+?>(.+?)<.*?container">(.+?)</div>|ms', $doc, $match)){
			foreach ($match[0] as $k => $v){
				if ($match[1][$k] == 'Новые Цифровые Релизы')
					continue;
				$caption = $caption_original = $match[1][$k];
				if (preg_match('|alternativeHeadline".*?>(.*?)</|ms', $v, $matches)){
					if ($matches[1] != ''){
						$caption_original = HD::str_remove_tag($matches[1]);
						if ($caption == '')
							$caption = $caption_original;
					}
				}
				if (preg_match('|kinopoisk.ru/film/(\d*)|ms', $v, $matches)){
					$id = $matches[1];
					$poster_url =  Kinopoisk_Class::http_get_img("http://st.kp.yandex.net/images/film_iphone/iphone360_$id.jpg");
				}else{
					$id = md5($caption . $caption_original);
					if (preg_match('|src="(.+?)"|ms', $v, $matches))
						$poster_url =  Kinopoisk_Class::http_get_img($matches[1]);
				}
				$short_movie = new ShortMovie(
					strval($id),
					strval($caption),
					strval($poster_url)
				);
				$info = '||' . $caption;
				$info .= '|' . $caption_original;
				$short_movie->caption_original = $caption_original;
				if (preg_match('|type">страна.*?>(.+?)</tr|ms', $v, $matches))
					$info .= '|| ' .  HD::str_remove_tag($matches[1]);
				else
					$info .= '||';
				if (preg_match('|type">год.*?>(.+?)</div|ms', $v, $matches)){
					$short_movie->year = HD::str_remove_tag($matches[1]);
					$info .= ' ' . $short_movie->year;
				}
				if (preg_match('|type">продолжительность.*?>(.+?)</tr|ms', $v, $matches))
					$info .= ' ' .  HD::str_remove_tag($matches[1]) . ' min.';
				if (preg_match('|type">жанр.*?>(.+?)</tr|ms', $v, $matches))
					$info .= '|| ' . HD::str_remove_tag($matches[1]);
				if (preg_match('|type">акт.*?>(.+?)</tr|ms', $v, $matches))
					$info .= '|| ' .  HD::str_remove_tag($matches[1]);
				
				if (preg_match('|type">рейтинг К.*?>(.+?)</tr|ms', $v, $matches))
					$info .= '||КП рейтинг: ' .  HD::str_remove_tag($matches[1]);
				if (preg_match('|type">рейтинг I.*?>(.+?)</tr|ms', $v, $matches))
					$info .= '||IMDB рейтинг: ' .  HD::str_remove_tag($matches[1]);
				if (preg_match('|class="description".*?>(.+?)</div|ms', $v, $matches)){
					$short_movie->description = HD::str_remove_tag($matches[1]);
					$info .= '||' . $short_movie->description;
				}
				if (preg_match_all("|onclick=\"location.href='(.+?)'.*?>(.+?)</|ms", $v, $matches)){
					$short_movie->links['arr']  = array_combine($matches[1], $matches[2]);
					$short_movie->links['className']  = self::$className;
				}
				$short_movie->info = $info;
				if (preg_match('|kinopoisk.ru/film/(\d*)|ms', $v, $matches))
					$short_movie->newClassName = 'Kinopoisk_Class';
				array_push ($items, $short_movie);
			}
		}
		return $items;
	}
	public static function getVodSourceInfo($v){
		$ico = SmartConfig::getPluginIco(self::$className);
		$sources['caption'] = self::$cName;
		$sources['detailed_info'] = '||'.self::$cName.'|Магниты c '.self::$cName.'. Отображаются только в каталоге ' .self::$cName;
		$sources['icon_path'] = $ico;
		$sources['detailed_icon_path'] = $ico;
		$sources['goTo'] = 'SmartVodTorrentsScreen';
		$sources['class_name'] = $v;
		$sources['variable'] = true;
		$sources['type'] = SmartConfig::getPluginIco('torrentSource');
		return $sources;
	}
	public static function getShortTorrentRange ($movie, $media_url, &$m_feed){
		$items = array();
		if ($m_feed === 'end')
			return $items;
		$m_feed = 'end';
		$icon_path = SmartConfig::getPluginIco('s_magnet');
		foreach ($media_url->links->arr as $k => $v){
			$short_movie = new ShortMovie(
				strval($k),
				strval($v),
				strval($movie->poster_url)
			);
			$short_movie->tType = 'magnet';
			$short_movie->icon_path = $icon_path;
			$info = '||' . $v . '|'. self::$cName;
			$short_movie->info = $info;
			$short_movie->details_box_width = true;
			array_push ($items, $short_movie);
		}
		return $items;
	}
	public static function getTorrentFile($torrent_id, $dloadPath=null){
		$torrentFile["status"] = true;
		$torrentFile["path"] = $torrent_id;
		return $torrentFile;
	}
}
?>