<?
if (!class_exists('DuneSystem')){
	if (preg_match('|plugins/(.*?)/lib|', __DIR__, $matches)){
		$tmp_path = '/tmp/plugins/'.$matches[1];
		$plugin_name = $matches[1];
		$install_dir = str_replace('/lib/wox', '',  __DIR__);
		if (file_exists('/persistfs/plugins_data'))
			$data_dir = "/persistfs/plugins_data/$plugin_name";
		else
			$data_dir = "/flashdata/plugins_data/$plugin_name";
        $port = HD::http_local_port();
		$www_url = "http://127.0.0.1:$port/plugins/$plugin_name/";
		$cgi_url = "http://127.0.0.1:$port/cgi-bin/plugins/$plugin_name/";
	}

	function hd_print($str){
		echo $str;
	}
	class DuneSystem{
		public static $properties = array ();
	};
	DuneSystem::$properties['plugin_name']      = $plugin_name;
	DuneSystem::$properties['install_dir_path'] = $install_dir;
	DuneSystem::$properties['tmp_dir_path']     = $tmp_path;
	DuneSystem::$properties['plugin_www_url']   = $www_url;
	DuneSystem::$properties['plugin_cgi_url']   = $cgi_url;
	DuneSystem::$properties['data_dir_path']    = $data_dir;
}
class Rutracker_Class {
	static $cName = 'Rutracker';
	static $className = 'Rutracker_Class';
	static $DomainName = null;
	static $altDomainName = null;
	static $proxyArr = null;
	static $proxyArrMd5 = null;
	static $proxy = null;
	static $logIn = 'noCheck';
	public static function getDomainName(){
		if (null === self::$DomainName)
			self::$DomainName = (HD::getItemStr(self::$cName . 'DomainName') != '') ? HD::getItemStr(self::$cName . 'DomainName') : 'https://rutracker.org';
		return self::$DomainName;
	}
	public static function getMainMenuInfo(){
		return array (
			'name' => self::$cName,
			'descr' => '||'.self::$cName.'|каталог и источник торрентов с сайта ' . self::$cName . '||Если сайт не доступен используйте прокси или VPN, а так же официальные зеркала (сайты с похожим дизайном и названием могут не являтся зеркалом)||Внимание|После нескильких попыток авторизации с неправильным логином или паролем на сайте появляется капча и плагин не сможет авторизоватся необходимо подождать пару часов пока она не спадет'
		);
	}
	public static function get_media_url_str($k, $arr=null){
		if ($arr == true)
			return SmartVodCategoryListScreen::get_media_url_str($k, $arr);
		return SmartVodCategoryListScreen::get_media_url_str($k);
	}
	public static function getSearchMediaUrlStr($k, $arr = null){
		return SmartVodSimpleListScreen::get_media_url_str($k, $arr);
	}
	public static function getPopUpMenuItems ($selected_media_url, $parent_media_url){
		$menu_items = array();
		if ($parent_media_url == 'main_menu'){
			$menu_items[] = array(
				'caption' => base64_decode('0JDQstGC0L7RgNC40LfQsNGG0LjRjyDQvdCwIA') . self::$cName,
				'params' => array ('action' => 'eneyIn'),
				'icon_url' => SmartConfig::getPluginIco('s_user')
			);
			$menu_items[] = array(
				'caption' => 'Задать зеркало ' . self::$cName,
				'params' => array ('action' => 'mirror'),
				'icon_url' => SmartConfig::getPluginIco('s_' . self::$className)
			);
			$menu_items[] = array(
				'caption' => 'Прокси для ' . self::$cName,
				'params' => array ('action' => 'proxy'),
				'icon_url' => SmartConfig::getPluginIco('s_proxy')
			);
			$menu_items[] = 'is_separator';
		}
		$parent_media_url = MediaURL::decode($parent_media_url);
		if ($parent_media_url->screen_id == 'vod_torrentlist'){
			
			$menu_items[] = array(
				'caption' => 'Изменить действие для торрентов',
				'params' => array ('action' => 'torrentActionSetup'),
				'icon_url' => SmartConfig::getPluginIco('s_torrent')
			);
			$menu_items[] = array(
				'caption' => 'Выбрать действие торрента',
				'conID' => 'add_actions',
				'params' => array ('torrentAction' => 1),
				'icon_url' => SmartConfig::getPluginIco('s_list')
			);
			$menu_items[] = 'is_separator';
			$menu_items[] = array(
				'caption' => 'Настройки TorrServer',
				'conID' => 'classSetupTorrServer',
				'params' =>  null,
				'icon_url' => SmartConfig::getPluginIco('s_torrserver')
			);
			$menu_items[] = array(
				'caption' => 'Настройки PeerflixServer',
				'conID' => 'classSetupPeerflixServer',
				'params' =>  null,
				'icon_url' => SmartConfig::getPluginIco('s_peerflixserver')
			);
			$menu_items[] = array(
				'caption' => 'Настройки Transmission',
				'conID' => 'classSetupTransmission',
				'params' =>  null,
				'icon_url' => SmartConfig::getPluginIco('s_transmission')
			);
			$menu_items[] = array(
				'caption' => 'Настройки Transmission UPnP',
				'conID' => 'classSetupTransmissionUPnP',
				'params' =>  null,
				'icon_url' => SmartConfig::getPluginIco('s_transmissionupnp')
			);
			$menu_items[] = 'is_separator';
		}
		if ((isset($parent_media_url->screen_id))&&($parent_media_url->screen_id != 'vod_series')){
			$menu_items[] = array(
				'caption' => 'Добавить в Главное меню',
				'params' => array ('action' => 'addToMainMenu'),
				'icon_url' => SmartConfig::getPluginIco('s_home')
			);
		}
		return $menu_items;
	}
	public static function getScreenActionMapArr($media_url){
		$actionsArr = array();
		return $actionsArr;
	}
	public function meinMenuOpenFolderDialog($user_input){
		if (self::checkLogIn() == 'false'){
			$alertOff = (HD::getItemStr(self::$cName . 'AlertOff') != '') ? HD::getItemStr(self::$cName . 'AlertOff') : false;
			$add_params['action'] = $user_input->action;
			if ((!isset($user_input->closed_dialog))&&($alertOff == false)){
				$add_params['closed_dialog']= true;
				ControlFactory::add_multiline_label($defs, '', "Для полноценного использования каталога и источника ".self::$cName." необходима авторизация (POPUP MENU на каталоге), без авторизации не доступны торрент файлы, только магнет линки и нет поиска и источника рутрекер в других каталогах!",5);		
				ControlFactory::add_close_dialog_and_apply_button($defs, $this, array ('action' => 'eneyIn'), 'classAction', base64_decode('0JDQstGC0L7RgNC40LfQsNGG0LjRjyDQvdCwIA') . self::$cName, 600);
				ControlFactory::add_close_dialog_and_apply_button($defs, $this, $add_params, $user_input->control_id, 'Продолжить без авторизации', 600);
				$add_params['alertOff']= true;
				ControlFactory::add_close_dialog_and_apply_button($defs, $this, $add_params, $user_input->control_id, 'Больше не показывать', 600);
				return  ActionFactory::show_dialog('Внимание!',$defs, true,900,$attrs);
			}
			if (isset($user_input->alertOff))
				if (HD::saveItemStr(self::$cName . 'AlertOff', 1) == false)
					return ActionFactory::show_title_dialog("Сохранение не удалось");
		}
		return ActionFactory::open_folder();
	}
	public static function getVodCategories($media_url){
		static $categories = null;
		if (is_null($categories)){
			if (self::checkLogIn() == 'true')
				$categories['categories'][] = array('id'=> 'search', 'class' => 'SmartSearchScreen', 'caption' => 'Поиск');
			$doc = self::http_get_document(self::getDomainName() . '/html/ajax/jumpbox_user.html');
			$tmp = explode('<optgroup label="&nbsp;Кино', $doc);
			if(preg_match_all ('|<option.*?value="(.*?)">(.*?)</option>|ms', $tmp[1], $match)){
				$i = 0;
				foreach ($match[1] as $k => $v){
					$arr =  array_flip (array(
					756,214,692,1253,23,707,1194, 1385,321, 2448,
					2460,2451,2450,2449,14,275,1502,1401,1402, 1440,
					1345,1413,1472,1693,1342,19,13,2456,1672,1800,
					1641,320,1406,16,1435,1437,1438,1439,1414,1441, 2243
					
					));
					$arr2 =  array_flip (array(
					4,33,1686,1315,21,919,767,2033,2125,2362,610,1581,1556,
					395,2326,2389,2324,2328,1964,1202,215,409,1125,1849,408,
					1760,416,1215,413,2495,2497,2499,2507,2267,2268,2269,2271,
					1698,1716,1732,722,1781,1821,1807,1808,1809,1810,1811,
					1812,1785,1299,2219,860,899,1012,1376,1013,1014,1052,828,
					1503,957,1933,2235,2238,2236,792
					));
					if ((!isset($arr[$v]))&&(!preg_match('/Ищу|рхив|оговорим|редложения|бсуждение|нструкции|бщения|бщение|подборки ссылок/i', $match[2][$k]))){
						$name = HD::str_remove_tag($match[2][$k]);
						if (!preg_match('/\|-/',$name)){
							$i++;
							$name = trim(str_replace(array('⚽','🏀','🏒'), "", $name));
							$rutracker_categories[$name] = 'rutracker_'.$i;
							$categories['categories'][] = array('id'=> 'r_'.$i, 'class' => 'SmartVodCategoryListScreen', 'caption' => $name);
						}
						if (!isset($arr2[$v]))
							$categories['subCategories']['r_'.$i][] = array('id'=> '/forum/viewforum.php?f='. $v, 'class' => 'SmartVodSimpleListScreen', 'caption' => $name);
					}
				}
			}
		}
		if (isset($media_url->categoryId))
			return $categories['subCategories'][$media_url->categoryId];
		return $categories['categories'];
	}
	public static function load_movie($movie_id, $mUrl, $getMovieInfo){
		$arr = array();
		$arr['caption'] = $arr['class_info']['catalog_info']['caption'] = $mUrl->caption;
		$arr['poster_url'] = $arr['class_info']['catalog_info']['poster_url'] = $mUrl->poster_url;
		if (isset($mUrl->caption_original))
			$arr['caption_original'] = $arr['class_info']['catalog_info']['caption_original'] = $mUrl->caption_original;
		if (isset($mUrl->year))
			$arr ['year'] = $arr['class_info']['catalog_info']['year'] = $mUrl->year;
		if (!preg_match("|^http|",$movie_id))
			$movie_id = self::getDomainName() . $movie_id;
		$doc = iconv('windows-1251', 'UTF-8', self::http_get_document($movie_id));
		if (preg_match('|maintitle">(.*?)</h|ms', $doc, $match))
			$capt = $arr ['caption'] = HD::str_remove_tag($match[1]);
		$tmp = explode('<div class="post_body"', $doc);
		if (preg_match('|title="(.*?)"|ms', $tmp[1], $match))
			$arr['poster_url'] = HD::str_remove_tag($match[1]);
		
		if (preg_match('|>(.*?)<div class="clear"|ms', $tmp[1], $match))
			$arr ['description'] = HD::str_remove_tag(str_replace('<br>', "\n",$match[1]));
		else if (preg_match('|>(.*?)<fieldset class="attach"|ms', $tmp[1], $match))
			$arr ['description'] = HD::str_remove_tag(str_replace('<br>', "\n",$match[1]));
		
		if (preg_match('|kinopoisk.ru/film/(\d*)|ms', $doc, $match))
			$arr['class_info']['dbIDs']['kpID'] = $match[1];
		else if (preg_match('|kinopoisk.ru/rating/(\d*?)\.|ms', $doc, $match))
			$arr['class_info']['dbIDs']['kpID'] = $match[1];
		else{
			$kpIDs = HD::getItemsArr('kpIDs');
			if (isset($kpIDs[$movie_id]))
				$arr['class_info']['dbIDs']['kpID'] = $kpIDs[$movie_id];
		}
		if (preg_match('|imdb.com/title/tt(\d*?)/|ms', $doc, $match))
			$arr['class_info']['dbIDs']['imdbID'] = 'tt' . $match[1];
		if (!isset($arr['class_info']['dbIDs']['kpID'])){
			$arr['class_info']['goToScreen'] = 'SmartVodTorrentsScreen';
			$arr['class_info']['noTrailers'] = true;
		}else
			$arr = SmartConfig::getMovieInfoArr($getMovieInfo, $movie_id, $mUrl, $arr);
		if ($capt == $arr['caption'])
			$arr['class_info']['goToScreen'] = 'SmartVodTorrentsScreen';
		
		if (preg_match('|seed">.*?>(.*?)</|ms', $doc, $match))
			$seed = HD::str_remove_tag($match[1]);
		if (preg_match('|leech">.+?>(.+?)</|ms', $doc, $match))
			$leech = HD::str_remove_tag($match[1]);
		if (preg_match('|азмер:(.*?)</|ms', $doc, $match))
			$size = HD::str_remove_tag($match[1]);
		
		if (preg_match('|href="dl.php\?t=(\d*?)"|', $doc, $match)){
			$torrent_id = '/forum/dl.php?t='.$match[1];
			$arr['class_info']['torrent'][self::$className][$torrent_id]['caption'] = mb_strcut($capt, 0, 70, "UTF-8");
			$arr['class_info']['torrent'][self::$className][$torrent_id]['type'] = 'torrent';
			$arr['class_info']['torrent'][self::$className][$torrent_id]['size'] = $size;
			$arr['class_info']['torrent'][self::$className][$torrent_id] ['S'] = $seed;
			$arr['class_info']['torrent'][self::$className][$torrent_id] ['L'] = $leech;
		}
		if (preg_match('|<a href="magnet:\?xt=(.*?)"|ms', $tmp[1], $match)){
			$torrent_id = 'magnet:?xt='.$match[1];
			$arr['class_info']['torrent'][self::$className][$torrent_id]['caption'] = $capt;
			$arr['class_info']['torrent'][self::$className][$torrent_id]['type'] = 'magnet';
			$arr['class_info']['torrent'][self::$className][$torrent_id]['size'] = $size;
			$arr['class_info']['torrent'][self::$className][$torrent_id] ['S'] = $seed;
			$arr['class_info']['torrent'][self::$className][$torrent_id] ['L'] = $leech;
		}
		return $arr;
	}
	public static function getTorrentFile($torrent_id, $dloadPath=null){
		if ((!preg_match("/dl\.php/",$torrent_id))&&(!preg_match("|magnet:\?xt=|",$torrent_id))){
			if (!preg_match("|^http|",$torrent_id))
				$torrent_id = self::getDomainName() . $torrent_id;
			$doc = iconv('windows-1251', 'UTF-8', self::http_get_document($torrent_id));
			
			if (preg_match('|href="dl.php\?t=(\d*?)"|', $doc, $match))
				$torrent_id = '/forum/dl.php?t='.$match[1];
			else if (preg_match('|<a href="magnet:\?xt=(.*?)"|ms', $tmp[1], $match))
				$torrent_id = 'magnet:?xt='.$match[1];
			else
				return array("status" => false,"descr" => "Этот файл не является торрент файлом. Возможно произошла ошибка при загрузке торрент файла");
		}
		if (preg_match("|magnet:\?xt=|",$torrent_id)){
			$torrentFile["status"] = true;
			$torrentFile["path"] = $torrent_id;
			return $torrentFile;
		}
		if (!preg_match("|^http|",$torrent_id))
			$torrent_id = self::getDomainName()  . $torrent_id;
		$doc = self::http_get_document($torrent_id);
		return SmartConfig::checkTorrent($dloadPath, $doc);
	}
	public static function getVodSourceInfo($v){
		// self::checkLogIn();
		$ico = SmartConfig::getPluginIco(self::$className);
		$sources['caption'] = self::$cName;
		$sources['detailed_info'] = '||'.self::$cName.'|Торрент файлы найденные на '.self::$cName.' по названию. Так как поиск производится по названию возможны неточности.';
		$sources['icon_path'] = $ico;
		$sources['detailed_icon_path'] = $ico;
		$sources['goTo'] = 'SmartVodTorrentsScreen';
		$sources['class_name'] = $v;
		$sources['type'] = SmartConfig::getPluginIco('torrentSource');
		return $sources;
	}
	public static function getShortTorrentRange ($movie, $media_url, &$m_feed){
		$items = array();
		self::checkLogIn();
		if ($m_feed === 'end')
			return $items;
		if (isset($movie->class_info['torrent'][self::$className])){
			foreach ($movie->class_info['torrent'][self::$className] as $k => $v){
				$caption = $v['caption'];
				$short_movie = new ShortMovie(
					strval(trim($k)),
					strval($caption),
					strval($movie->poster_url)
				);
				$short_movie->icon_path = SmartConfig::getPluginIco('s_' . $v['type']);
				$short_movie->tType = $v['type'];
				$info = '||' . $caption . '|'. self::$cName;
				$short_movie->details_box_width = true;
				$info .= '||Размер|' . $v['size'];
				$info .= '||Seed:|' . $v ['S'];
				$info .= '||Leech:|' . $v['L'];
				$short_movie->info = $info;
				$short_movie->extra_item = $v['size'];
				array_push ($items, $short_movie);
			}
			$m_feed = 'end';
			return $items;
		}
		$keyword = $movie->name;
		$itemsObj = self::getSearchShortMovieRange ($keyword, $m_feed);
		$ico = SmartConfig::getPluginIco('s_torrent');
		foreach($itemsObj as $v){
			$v->icon_path = $ico;
			$v->tType = 'torrent';
			$items[] = $v;
		}
		return $items;
	}
	public static function getShortMovieRange ($media_url, &$m_feed){
		if ($m_feed === 'end')
			return $items;
		$url =  self::getDomainName() . $media_url->categoryId;
		if ($m_feed > 0)
			$url .=  '&start=' . ($m_feed * 50);				
		$doc = iconv('windows-1251', 'UTF-8', self::http_get_document($url));
		++$m_feed;
		if (!preg_match('|<a class="pg".*?>След.</a>|', $doc))
			$m_feed = '_end_';
		return self::parseSitePage($doc);
	}
	public static function getSearchShortMovieRange ($keyword, &$m_feed){
		if (is_object($keyword))
			$keyword = $keyword->searchStr;
		if ($m_feed === 'end')
			return array();
		$doc = iconv('windows-1251', 'UTF-8', self::http_get_document(self::getDomainName() . '/forum/tracker.php?nm='  . str_replace(" ", "%20", $keyword). '&start=' . ($m_feed * 50)));
		++$m_feed;
		if (!preg_match('|">След.</a>|', $doc))
			$m_feed = 'end';
		return self::parseSitePage($doc);
	}
	public static function parseSitePage($doc){
		$items = array();
		$doc = str_replace('&#8595;', "", $doc);
		if (preg_match_all('|<span class="tor.*?id="tt-(.*?)".*?text">(.*?)</.*?Seeders">(.*?)</.*?Leechers">(.*?)</.*?stub">(.*?)<|ms', $doc, $matches)){
			foreach ($matches[1] as $k => $v){
				$id = '/forum/viewtopic.php?t='. trim($v);
				$arr[$id]['name']			= HD::str_remove_tag($matches[2][$k]);
				$arr[$id]['size']			= HD::str_remove_tag($matches[5][$k]);
				$arr[$id]['S']			= HD::str_remove_tag($matches[3][$k]);
				$arr[$id]['L']			= HD::str_remove_tag($matches[4][$k]);
			}
		}else if (preg_match_all('|topic_id="(.*?)".*?>(.*?)</.*?stub".*?>(.*?)</.*?row4 nowrap.*?>(.+?)</td.*?leechmed.*?>(.+?)</td|ms', $doc, $matches)){
			foreach ($matches[1] as $k => $v){
				$id = '/forum/viewtopic.php?t='. trim($v);
				$arr[$id]['name']		= HD::str_remove_tag($matches[2][$k]);
				$arr[$id]['size']		= HD::str_remove_tag($matches[3][$k]);
				$arr[$id]['S']			= HD::str_remove_tag($matches[4][$k]);
				if (preg_match('|"med"|',$matches[4][$k]))
					$arr[$id]['S']		= 'Cида не было ' . $arr[$id]['S'];
				$arr[$id]['L']			= HD::str_remove_tag($matches[5][$k]);
			}
		} 
		$poster_url = SmartConfig::getPluginIco(self::$className);
		if (count($arr) > 0)
			foreach ($arr as $k => $v){
				$short_movie = new ShortMovie(
					strval($k),
					strval($v['name']),
					strval($poster_url)
				);
				$info = '||' . $v['name'];
				$info .= '|Размер: ' . $v['size'];
				$info .= '||Seed: ' . $v['S'] . ' Leech: ' . $v['L'];
				$short_movie->extra_item = $v['size'];
				$short_movie->info = $info;
				array_push ($items, $short_movie);
			}
		return $items;
	}
	public static function cookie(){
		return DuneSystem::$properties['tmp_dir_path'] . "/" . self::$cName . "Cookie";
	}
	public static function checkLogIn(){
		if (self::$logIn == 'noCheck'){
			$eney = HD::getItemsArr('eney');
			if (isset($eney[self::$cName])){
				$ul = HD::eney('l', $eney[self::$cName][0]);
				$up = HD::eney('p', $eney[self::$cName][1]);
				if (file_exists(self::cookie())){
					$doc = HD::http_get_document(self::getDomainName());
					if (preg_match('|logged-in-username|', $doc))
						self::$logIn = 'true';
				}
				if (self::$logIn == 'noCheck'){
					$cgr = self::testEneyIn();
					if ($cgr == false)
						self::$logIn = 'false';
					else
						self::$logIn = 'true';
				}
			}else
				self::$logIn = 'false';
		}
		return self::$logIn;
	}
	public static function testEneyIn($ul = null, $up = null){
		if ($ul == false){
			$eney = HD::getItemsArr('eney');
			if (isset($eney[self::$cName])){
				$ul = HD::eney('l', $eney[self::$cName][0]);
				$up = HD::eney('p', $eney[self::$cName][1]);
			}else
				return false;
		}
		if (file_exists(self::cookie()))
			unlink(self::cookie());
		$opts [CURLOPT_COOKIEJAR]	= $opts [CURLOPT_COOKIEFILE]	= self::cookie();
		$opts [CURLOPT_POST] = true;
		$opts [CURLOPT_POSTFIELDS] = "login_username=$ul&login_password=$up&login=%E2%F5%EE%E4";
		$doc = iconv('windows-1251', 'UTF-8', self::http_get_document(self::getDomainName() . "/forum/login.php", $opts));
		if (preg_match("|logged-in-username|",$doc)){
			self::$logIn = 'true';
			return true;
		}else{
			self::$logIn = 'false';
			echo $doc;
			if (file_exists(self::cookie()))
				unlink(self::cookie());
			return false;
		}
	}
	public static function http_get_document ($url, $opts=null){
		if (!isset($opts[CURLOPT_COOKIEJAR])){
			$cgr = true;
			if (!file_exists(self::cookie()))
				$cgr = self::testEneyIn();
			if ($cgr == true)
				$opts[CURLOPT_COOKIEJAR] = $opts[CURLOPT_COOKIEFILE] = self::cookie();
		}
		if (is_null(self::$proxy)){
			self::$proxy = false;
			$sitesProxy = HD::getItemsArr('sitesProxy');
			if (isset($sitesProxy[self::$cName])){
				$proxySettings = (HD::getItemsArr('proxySettings') != array()) ? HD::getItemsArr('proxySettings') : array();
				if (isset($proxySettings['proxy'])){
					self::$proxy['proxy'] = $proxySettings['proxy'];
					if ((isset($proxySettings['proxyType']))&&($proxySettings['proxyType'] == 'SOCKS5'))
						self::$proxy['proxyType'] = $proxySettings['proxyType'];
					if (isset($proxySettings['proxyAccount']))
						self::$proxy['proxyAccount'] = $proxySettings['proxyAccount'];
				}
			}
		}
		if (self::$proxy == true){
			$opts[CURLOPT_PROXY] = self::$proxy['proxy'];
			if (isset(self::$proxy['proxyType']))
				$opts[CURLOPT_PROXYTYPE] = CURLPROXY_SOCKS5;
			if (isset(self::$proxy['proxyAccount']))
				$opts[CURLOPT_PROXYUSERPWD] = self::$proxy['proxyAccount'];
		}
		return HD::http_get_document($url, $opts);
	}
}
?>
