<?
class TheMovieDatabase_Class {
	static $cName = 'The Movie Database';
	static $className = 'TheMovieDatabase_Class';
	public static function get_media_url_str($k, $arr=null){
		if ($arr == true)
			return SmartVodCategoryListScreen::get_media_url_str($k, $arr);
		return SmartVodCategoryListScreen::get_media_url_str($k);
	}
	public static function getSearchMediaUrlStr($k, $arr=null){
		return SmartVodListScreen::get_media_url_str($k, $arr);
	}
	public static function getMainMenuInfo(){
		return array (
			'name' => self::$cName,
			'descr' => '||'.self::$cName.'|каталог фильмов и сериалов с The Movie Database'
		);
	}
	public static function getPopUpMenuItems ($selected_media_url, $parent_media_url){
		$menu_items = array();
		$parent_media_url = MediaURL::decode($parent_media_url);
		if ((isset($parent_media_url->screen_id))&&($parent_media_url->screen_id != 'vod_series')){
			$menu_items[] = array(
				'caption' => 'Добавить в Главное меню',
				'params' => array ('action' => 'addToMainMenu'),
				'icon_url' => SmartConfig::getPluginIco('s_home')
			);
		}
		return $menu_items;
	}
	public static function getVodCategories($media_url){
		static $categories = null;
		$category = null;
		if (isset($media_url->categoryId))
			$category = $media_url->categoryId;
		
		$categories['categories'][] = array('id'=> 'search', 'class' => 'SmartSearchScreen', 'caption' => 'Поиск');

		$main_menu['discover/movie']	= 'Фильмы';
		$main_menu['movie/now_playing']	= 'Фильмы сейчас';
		$main_menu['movie/popular']		= 'Популярные Фильмы';
		$main_menu['movie/top_rated']	= 'Фильмы Топ Рейтинга';
		$main_menu['movie/upcoming']	= 'Фильмы Скоро';
		$main_menu['movie']				= 'Фильмы Жанры';
		$main_menu['discover/tv']		= 'Сериалы';
		$main_menu['tv/airing_today']	= 'Сериалы Сегодня на ТВ';
		$main_menu['tv/on_the_air']		= 'Сериалы на ТВ';
		$main_menu['tv/popular']		= 'Популярные Сериалы';
		$main_menu['tv/top_rated']		= 'Сериалы Топ Рейтинга';
		$main_menu['tv']				= 'Сериалы Жанры';
		foreach ($main_menu as $k => $v){
			if (preg_match('|\/|',$k))
				$categories['categories'][] = array('id'=> $k, 'class' => 'SmartVodListScreen', 'caption' => $v);
			else
				$categories['categories'][] = array('id'=> $k, 'class' => 'SmartVodCategoryListScreen', 'caption' => $v);
		}
		if ($category==true){
			if (!isset($categories['subCategories'][$category])){
				$jsd = VideoInfo::GenresTheMovieDB ($category);
				foreach ($jsd as $k => $v)
					$categories['subCategories'][$category][] = array('id'=> 'discover/' .$category . '/&with_genres=' . $k, 'class' => 'SmartVodListScreen', 'caption' => $v);
			}
			return $categories['subCategories'][$category];
		}
		return $categories['categories'];
	}
	public static function getScreenActionMapArr($media_url){
		$actionsArr = array();
		if (isset($media_url->searchStr))
			return $actionsArr;
		if ((isset($media_url->screen_id))&&($media_url->screen_id == 'vod_list')){
			$actionsArr[0]['create_action'] = 'classAction';
			$actionsArr[0]['params'] = array ('indiClass' => self::$className,'action' => 'sort');
			$actionsArr[0]['caption'] = 'Сортировки';
			$actionsArr[0]['key'] = GUI_EVENT_KEY_C_YELLOW;
		}
		return $actionsArr;
	}
	public function classAction ($defs, $user_input, $select_url = null){
		hd_restore_warnings();
		$post_action = null;
		$caption = 'Error!';
		$msg = 'classAction: action';
		$width = 1050;
		if (isset($user_input->selected_media_url))
			$selected_media_url = MediaURL::decode($user_input->selected_media_url);
		// else{
			// $msg = 'classAction: selected_media_url';
			// return ActionFactory::show_title_dialog($caption, $post_action, $msg, 0);
		// }
		$class_name = $selected_media_url->class_name;
		$parent_media_url = MediaURL::decode($user_input->parent_media_url);
		if ($user_input->action == 'sort'){
			$sorting = (HD::getItemStr(self::$className . '_sorting') != array()) ? HD::getItemStr(self::$className . '_sorting') : 'popularity.desc';
			$add_params['control_id']= $user_input->control_id;
			$add_params['action'] = $user_input->action;
			$add_params['indiClass'] = self::$className;
			if ((isset($user_input->selected_control_id))&&(isset($user_input->action_type))){
				if (isset($user_input->initial_sel_ndx))
					$add_params['initial_sel_ndx'] = $user_input->initial_sel_ndx;
				if ($user_input->selected_control_id == 'sorting'){
					$sorting['other'] = $user_input->sorting;
					if (HD::saveItemStr(self::$className . '_sorting', $user_input->sorting) == false)
						return ActionFactory::show_title_dialog("Сохранение не удалось");
				}
				$action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $add_params);
				$action = ActionFactory::close_dialog_and_run($action);
				return ActionFactory::invalidate_folders(array($user_input->parent_media_url), $action);
			}
			$sorting_ops['popularity.asc']				= 'Популярность +';
			$sorting_ops['popularity.desc']				= 'Популярность -';
			$sorting_ops['release_date.asc']			= 'Дата релиза +';
			$sorting_ops['release_date.desc']			= 'Дата релиза -';
			$sorting_ops['revenue.asc']					= 'Кассовые сборы +';
			$sorting_ops['revenue.desc']				= 'Кассовые сборы -';
			$sorting_ops['primary_release_date.asc']	= 'Основная Дата релиза +';
			$sorting_ops['primary_release_date.desc']	= 'Основная Дата релиза -';
			$sorting_ops['original_title.asc']			= 'Оригинальное название +';
			$sorting_ops['original_title.desc']			= 'Оригинальное название -';
			$sorting_ops['vote_average.asc']			= 'Рейтинг +';
			$sorting_ops['vote_average.desc']			= 'Рейтинг -';
			$sorting_ops['vote_count.asc']				= 'Всего проголосовало +';
			$sorting_ops['vote_count.desc']				= 'Всего проголосовало -';

			ControlFactory::add_combobox($defs, $this, $add_params,
				'sorting', '',
				$sorting, $sorting_ops, 600, true, false
			);
			ControlFactory::add_vgap($defs, (-10));
			ControlFactory::add_smart_label($defs, "", '<text color="23" size="tiny">+ от меньшего к большему</text>');
			ControlFactory::add_vgap($defs, (-40));
			ControlFactory::add_smart_label($defs, "", '<text color="23" size="tiny">- от большего к меньшему</text>');
			$attrs['initial_sel_ndx'] = isset($user_input->initial_sel_ndx) ? $user_input->initial_sel_ndx : -1;
			return ActionFactory::show_dialog("Cортировка:", $defs, true, 0, $attrs);
		}
		return ActionFactory::show_title_dialog($caption, $post_action, $msg, 0);
	}
	
	public static function getSearchShortMovieRange ($keyword, &$m_feed){
		if (is_object($keyword))
			$keyword = $keyword->searchStr;
		if ($m_feed === 'end')
			return array();
		$jsd = VideoInfo::multiSearch_themoviedb ($keyword, $m_feed + 1, 1);
		if (!isset($jsd->results))
			return array();
		++$m_feed;
		if ($jsd->total_pages == $jsd->page)
			$m_feed = 'end';			
		return self::parseTheMovieDBPage($jsd->results);
	}
	public static function parseTheMovieDBPage($jsd){
		$items = array();
		foreach ($jsd as $v){
			$media_type = 'movie';
			if (isset($v->media_type)){
				$media_type = $v->media_type;
				if (($v->media_type != 'tv' )&&($v->media_type != 'movie' ))
					continue;
			}
			if (isset($v->title))
				$caption = $v->title;
			if (isset($v->name))
				$caption = $v->name;
			if (isset($v->original_title))
				$caption_original = $v->original_title;
			if (isset($v->original_name))
				$caption_original = $v->original_name;
			
			if (isset($v->poster_path))
				$img = self::http_get_img('http://image.tmdb.org/t/p/w342' . $v->poster_path);
			else
				$img = 'plugin_file://icons/poster_none.png';
			$short_movie = new ShortMovie(
				strval($v->id),
				strval($caption),
				strval($img)
			);
			$info = $caption;
			$info .= '|' . $caption_original;
			if (isset($v->release_date))
				$date = new DateTime($v->release_date);
			if (isset($v->first_air_date))
				$date = new DateTime($v->first_air_date);
			$info .= '||' . $date->format('d.m.Y');
			if (isset($v->vote_average))
				$info .= '|Рейтинг: ' . $v->vote_average;
			if ((isset($v->genre_ids))&&(count($v->genre_ids) > 0))
				$info .= '||' . VideoInfo::GenresTheMovieDB ($media_type, $v->genre_ids) ;
			if (isset($v->overview))
				$info .= '|' . $v->overview;
			$short_movie->caption = $caption;
			$short_movie->caption_original = $caption_original;
			$short_movie->year = $date->format('Y');
			$short_movie->media_type = $media_type;
			$short_movie->info = $info;

			array_push ($items, $short_movie);
		}
		return $items;
	}
	public static function getShortMovieRange ($media_url, &$m_feed){
		if ($m_feed === 'end')
			return array();
		$sorting = (HD::getItemStr(self::$className . '_sorting') != array()) ? HD::getItemStr(self::$className . '_sorting') : 'popularity.desc';
		if (preg_match('|(.*)\/\&(.*)|',$media_url->categoryId, $matches)){
			$media_type = $matches[1];
			$arg =  '&' . $matches[2];
		}else{
			$media_type = $media_url->categoryId;
			$arg = false;
		}
		$jsd = VideoInfo::discoverTheMovieDB ($media_type, $m_feed + 1, $arg, $sorting);
		if (!isset($jsd->results))
			return array();
		if ($jsd->total_pages == $jsd->page)
			$m_feed = 'end';
		else
			++$m_feed;
		return self::parseTheMovieDBPage($jsd->results);
	}
	public static function load_movie($movie_id, $mUrl, $getMovieInfo){
		$arr['class_info']['catalog_info']['caption'] = $mUrl->caption;
		$arr['class_info']['catalog_info']['poster_url'] = $mUrl->poster_url;
		if (isset($mUrl->caption_original))
			$arr['class_info']['catalog_info']['caption_original'] = $mUrl->caption_original;
		if (isset($mUrl->year))
			$arr['class_info']['catalog_info']['year'] = $mUrl->year;
		$arr['class_info']['dbIDs']['themoviedbId'] = $movie_id;
		$kpIDs = HD::getItemsArr('kpIDs');
		if (isset($kpIDs[$movie_id]))
			$kpID = $kpIDs[$movie_id];
		else
			$kpID = Kinopoisk_Class::searchKpId ($mUrl->caption, $mUrl->caption_original, $mUrl->year);
		if ($kpID == true){
			$arr['class_info']['dbIDs']['kpID'] = $kpID;
			$jsd = Kinopoisk_Class::get_id_info($kpID);
			if ($jsd->nameRU != '')
				$arr['caption_original'] = $arr['caption'] = $jsd->nameRU;
			else if ($jsd->nameEN != '')
				$arr['caption_original'] = $arr['caption'] = $jsd->nameEN;
			if ($jsd->nameEN != '')
				$arr['caption_original'] = $jsd->nameEN;
			$arr['description'] = $jsd->description;
			$arr['poster_url'] = Kinopoisk_Class::http_get_img("http://st.kp.yandex.net/images/film_iphone/iphone360_$kpID.jpg&rPath=". $mUrl->poster_url);
			$arr['country'] = $jsd->country;
			if (preg_match("|-|",$jsd->year))
				$arr['country'] .= ', '.$jsd->year;
			else
				$arr['year'] = $jsd->year;
			if (isset ($jsd->genre))
				$arr['genres'] = $jsd->genre;
			if (isset ($jsd->ratingData->ratingIMDb))
				$arr['rate_imdb'] = $jsd->ratingData->ratingIMDb;
			if (isset ($jsd->ratingData->rating))
				$arr ['rate_kinopoisk'] = $jsd->ratingData->rating;
			if (isset ($jsd->filmLength)){
				$length = $jsd->filmLength;
				if (preg_match("/(\d*):(\d\d)/i", $length, $tmp))
					$length = ($tmp[1]*60+$tmp[2]);
				$arr ['length'] = $length;
			}
			if (isset ($jsd->creators[0])){
				foreach ($jsd->creators[0] as $v){
					if ((isset ($v->nameEN))&&($v->nameEN != ''))
						$name_r[] = $v->nameRU .' ('.$v->nameEN.')';
					else
						$name_r[] = $v->nameRU;
					if (count($name_r) > 1)
						$arr['director'] = implode(', ', $name_r);
					else
						$arr['director'] = $name_r[0];
				}
			}
			if (isset ($jsd->creators[1])){
				$name_r = array();
				foreach ($jsd->creators[1] as $v){
					if ((isset ($v->nameEN))&&($v->nameEN != ''))
						$name_r[] = $v->nameRU .' ('.$v->nameEN.')';
					else
						$name_r[] = $v->nameRU;
					if (count($name_r) > 1)
						$arr['actors'] = implode(', ', $name_r);
					else
						$arr['actors'] = $name_r[0];
				}
			}
			if (isset ($jsd->creators[2])){
				$name_r = array();
				foreach ($jsd->creators[2] as $v){
					if ((isset ($v->nameEN))&&($v->nameEN != ''))
						$name_r[] = $v->nameRU .' ('.$v->nameEN.')';
					else
						$name_r[] = $v->nameRU;
					if (count($name_r) > 1)
						$arr ['details']['Продюсеры:'] = implode(', ', $name_r);
					else
						$arr ['details']['Продюсеры:'] = $name_r[0];
				}
			}
			if (isset ($jsd->gallery)){
				foreach ($jsd->gallery as $key => $vel){
					if ($key=='poster')
						continue;
					foreach ($vel as $v)
						$arr ['background_urls'][] = "http://st.kp.yandex.net/images/". $v->image;
				}
			}
			if (isset ($jsd->slogan))
				$arr ['details']["Слоган:"] = wordwrap($jsd->slogan, 75, "\n");
			
			if (isset ($jsd->budgetData->budget))
				$arr ['budget'] = str_replace(array ('$', ' '),"", $jsd->budgetData->budget);
			if (isset($jsd->videoURL)){
				foreach ($jsd->videoURL as $k => $v){
					$arr['class_info']['trailers'][$v] = array(
						'name' => "Kinopoisk $k",
						'url' => $v
					);
				}
			}
			if ($getMovieInfo == 'max'){
				if ((isset($jsd->type))&&($jsd->type == 'KPSerial')){
					$arr['is_serial']= 1;
					$jsd = VideoInfo::search_myshows_info($arr['caption_original'], $movie_id);
					if (isset($jsd->id)){
						$arr['class_info']['dbIDs']['myShowsID'] = $jsd->id;
						if ($jsd->rating != '')
							$arr ['rate_details']['MyShows:']=  $jsd->rating;	
						$arr ['rate_details']['Сезонов:'] = $jsd->totalSeasons;
						if ( $jsd->status != ''){
							if ( $jsd->status == 'TBD/On The Bubble'){
								$arr ['rate_details']['Статус:']= ' ';
								$arr ['rate_details']['   '] = 'Пауза';
							}else if ($jsd->status == 'Returning Series'){
								$arr ['rate_details']['Статус:']= ' ';
								$arr ['rate_details']['   '] = 'Продолжается';
							}else if ($jsd->status == 'Canceled/Ended'){
								$arr ['rate_details']['Статус:'] = ' ';
								$arr ['rate_details']['   '] = 'Завершен';
							}else if ($jsd->status == 'New Series'){
								$arr ['rate_details']['Статус:']= ' ';
								$arr ['rate_details']['   '] = 'Новый!';
							}else{
								$arr ['rate_details']['Статус:']= ' ';
								$arr ['rate_details']['   ']=  $jsd->status;
							}
						}
						if ($jsd->totalSeasons != '')
							$arr ['rate_details']['Сезонов:']=  $jsd->totalSeasons;
						if ($jsd->started != ''){
							$arr ['rate_details']['Started:']=  ' ';
							$arr ['rate_details']['  ']=  $jsd->started;
						}
						if ($jsd->ended != ''){
							$arr ['rate_details']['Ended:']= ' ';
							$arr ['rate_details'][' ']=  $jsd->ended;
						}
						if ($jsd->imdbId != '')
							$arr['class_info']['dbIDs']['imdbID'] = $jsd->imdbId;
						if ($jsd->tvrageId != '')
							$arr['class_info']['dbIDs']['tvrageID'] = $jsd->tvrageId;			
					}
				}
				$media_type = 'movie';
				if (isset($mUrl->media_type))
					$media_type = $mUrl->media_type;
				if (!isset($arr['background_urls']))
					foreach(self::getImagesFromThemoviedb ($arr['class_info']['dbIDs']['themoviedbId'], $media_type) as $k => $v)
						$arr[$k] = $v;
			}
			if (isset($jsd->seriesInfo)){
				$arr ['rate_details']['Сезонов:'] = $jsd->seriesInfo->totalSeasons;
				$arr ['rate_details']['Эпизодов:'] = $jsd->seriesInfo->totalEpisodes;
			}
			if (isset($arr['class_info']['dbIDs']['kpID']))
				$arr ['rate_details']['KPid:'] = $arr['class_info']['dbIDs']['kpID'];
		}else{
			$arr['caption'] = $mUrl->caption;
			$arr['poster_url'] = $mUrl->poster_url;
			if (isset($mUrl->caption_original))
				$arr['caption_original'] = $mUrl->caption_original;
			if (isset($mUrl->year))
				$arr['year'] = $mUrl->year;
			$media_type = 'movie';
			if (isset($mUrl->media_type))
				$media_type = $mUrl->media_type;
			foreach(TheMovieDatabase_Class::getImagesFromThemoviedb ($arr['class_info']['dbIDs']['themoviedbId'], $media_type) as $k => $v)
				$arr[$k] = $v;
		}
		return $arr;
	}
	public static function getVodSourceInfo($v){
		return false;
	}
	public static function getImagesFromThemoviedb ($themoviedbId, $media_type){
		$arr = array();
		if (($themoviedbId == '')||($themoviedbId == false))
			return $arr;
		$posters['en'] = $posters['ru'] = array();
		$jsd = VideoInfo::getImagesthemoviedbId ($themoviedbId, $media_type);
		if (isset($jsd->backdrops))
			foreach ($jsd->backdrops as $v)
				$arr['background_urls'][] = 'http://image.tmdb.org/t/p/w1280' . $v->file_path;
		if (isset($jsd->posters)){
			foreach ($jsd->posters as $v){
				if ($v->iso_639_1 == 'ru')
					$posters['ru'][] = 'http://image.tmdb.org/t/p/w780' . $v->file_path;
				if ($v->iso_639_1 == 'en')
					$posters['en'][] = 'http://image.tmdb.org/t/p/w780' . $v->file_path;
			}
			if (count($posters['ru'])> 0)
				$arr['poster_url'] = $posters['ru'][array_rand($posters['ru'])];
			else if (count($posters['en'])> 0)
				$arr['poster_url'] = $posters['en'][array_rand($posters['en'])];
			else if (isset($jsd->posters[0]))
				$arr['poster_url'] = 'http://image.tmdb.org/t/p/w780' . $jsd->posters[0]->file_path;
		}
		$jsd = VideoInfo::getVideosthemoviedbId ($themoviedbId, $media_type);
		
		foreach ($jsd as $v){
			if ($v->site =="YouTube"){
				$arr['class_info']['trailers'][$v->key]['url']= 'https://www.youtube.com/watch?v=' . $v->key;
				$arr['class_info']['trailers'][$v->key]['name']= 'Youtube Trailer['.strtoupper($v->iso_639_1).']['.$v->type.'] - '. $v->name;
			}
		}
		return $arr;
	}
	public static function get_themoviedbId_posters($movie_id, $movie){
		static $themoviedbId_posters = null;
		$arr = false;
		if (isset($movie ->class_info['dbIDs']['themoviedbId']))
			$themoviedbId = $movie ->class_info['dbIDs']['themoviedbId'];
		else if (isset($movie ->class_info['dbIDs']['imdbID']))
			$themoviedbId = VideoInfo::imdbId_to_themoviedbId ($movie ->class_info['dbIDs']['imdbID']);
		else if (isset($movie ->class_info['dbIDs']['tvrageID']))
			$themoviedbId =  VideoInfo::tvrageId_to_themoviedbId ($movie ->class_info['dbIDs']['tvrageID']);
		if ((!isset($themoviedbId))||($themoviedbId == '')){
			if (preg_match('|(.*?)\n|',  $movie->name_original, $m))
				$movie->name_original = $m[1];
			if (HD::strSanitizing($movie->name) != $movie->name_original){
				if (($movie->year != -1)&&(preg_match("#^(\d{4})#",$movie->year, $mch)))
					$year = $mch[1];
				else if (preg_match("#(\d{4})#",$movie->country, $mch))
					$year = $mch[1];
				else $year = false;
				$themoviedbId = VideoInfo::search_themoviedbId($movie->name_original, $year, 'tv');
			}else
				$themoviedbId_posters[$movie_id] = array();
		}
		if ((is_null($themoviedbId_posters))||(!isset($themoviedbId_posters[$movie_id]))){
			if ((!isset($themoviedbId))||($themoviedbId == ''))
				$themoviedbId_posters[$movie_id] = array();
			else{
				$jsd = VideoInfo::get_themoviedbId_info($themoviedbId);
				if (isset($jsd->seasons)){
					foreach ($jsd->seasons as $v){
						if (isset($v->poster_path)){
							$arr[$v->season_number]['poster_path'] = 'http://image.tmdb.org/t/p/w500'. $v->poster_path;
							$arr[$v->season_number]['episode_count'] = $v->episode_count;
						}
					}
					$themoviedbId_posters[$movie_id] = $arr;
				}else
					$themoviedbId_posters[$movie_id] = array();
			}
		}
		return $themoviedbId_posters[$movie_id];
	}
	public static function http_get_img ($url){
		return $url;
		// return DuneSystem::$properties['plugin_cgi_url'] . "do?img=" . $url;
	}
}
?>