<?
class myShows_Class {
	static $cName = 'myShows';
	static $className = 'myShows_Class';
	public static function getDomainName(){
		return 'https://myshows.me';
	}
	public static function get_media_url_str($k, $arr=null){
		if ($arr == true)
			return SmartVodCategoryListScreen::get_media_url_str($k, $arr);
		return SmartVodCategoryListScreen::get_media_url_str($k);
	}
	public static function getSearchMediaUrlStr($k, $arr=null){
		return SmartVodRectangleListScreen::get_media_url_str($k, $arr);
	}
	public static function getMainMenuInfo(){
		return array (
			'name' => self::$cName,
			'descr' => '||'.self::$cName.'|каталог сериалов с сайта '.self::$cName.'||Для использования функций скроблига сериалов и просмотра отзывов на эпизоды необходим логин на сайт - кнопка PopUp Menu -> Авторизация на том Избранном которое вы хотите привязать к myShows'
		);
	}
	public static function getPopUpMenuItems ($selected_media_url, $parent_media_url){
		$menu_items = array();
		$parent_media_url = MediaURL::decode($parent_media_url);
		if ((!isset($selected_media_url->mShowsA))&&
		(!isset($parent_media_url->screen_id))&&
		($parent_media_url->screen_id != 'vod_series')){
			$menu_items[] = array(
				'caption' => 'Добавить в Главное меню',
				'params' => array ('action' => 'addToMainMenu'),
				'icon_url' => SmartConfig::getPluginIco('s_home')
			);
		}
		return $menu_items;
	}
	public static function getVodCategories($media_url){
		static $categories = null;
		$category = null;
		if (isset($media_url->categoryId))
			$category = $media_url->categoryId;
		
		if ((!isset($categories['categories']))||(!isset($categories['subCategories']))){
			$categories['categories'][] = array('id'=> 'search', 'class' => 'SmartSearchScreen', 'caption' => 'Поиск');
			$categories['categories'][] = array('id'=> 'all', 'class' => 'SmartVodRectangleListScreen', 'caption' => 'Топ 500');
			$categories['categories'][] = array('id'=> 'm', 'class' => 'SmartVodRectangleListScreen', 'caption' => 'Топ 500 (мужской рейтинг)');
			$categories['categories'][] = array('id'=> 'f', 'class' => 'SmartVodRectangleListScreen', 'caption' => 'Топ 500 (женский рейтинг)');
		}
		if ($category==true)
			return $categories['subCategories'][$category];
		return $categories['categories'];
	}
	public static function getScreenActionMapArr($media_url){
		$actionsArr = array();
		
		if ((isset($media_url->categoryId))&&(!preg_match('/search|myShowsUnwatched|mm/', $media_url->categoryId)))
			return $actionsArr;
		$actionsArr[0]['create_action'] = 'classAction';
		$actionsArr[0]['params'] = array ('indiClass' => self::$className,'action' => 'sort');
		$actionsArr[0]['caption'] = 'Сортировки';
		$actionsArr[0]['key'] = GUI_EVENT_KEY_C_YELLOW;
		
		if(isset($media_url->setMyShowId)){
			$actionsArr[0]['create_action'] = 'classAction';
			$actionsArr[0]['params'] = array ('action' => 'setMyShowId', 'addId' => false);
			$actionsArr[0]['caption'] = 'Задать myShowsID';
			$actionsArr[0]['key'] = GUI_EVENT_KEY_C_YELLOW;
			
			$actionsArr[1]['create_action'] = 'classAction';
			$actionsArr[1]['params'] = array ('action' => 'setMyShowId', 'searchStr' => false);
			$actionsArr[1]['caption'] = 'Искать myShowsID';
			$actionsArr[1]['key'] = GUI_EVENT_KEY_B_GREEN;
		}
		return $actionsArr;
	}
	public static function parse_comments_myShows($showId, $item, $mShowsA){
		static $jsd = false;
		if ($item == 0){
			$jsd = false;
			$jsd = VideoInfo::showsEpisodeComments_myshows ($showId, $mShowsA);
			if ($jsd->count > 0){
				$jsd->comments[$item]->count = $jsd->count;
				return $jsd->comments[$item];
			}else return false;
		}else if (isset($jsd->comments[$item])){
			$jsd->comments[$item]->count = $jsd->count;
			if ($jsd->comments[$item]->comment == '')
				$jsd->comments[$item]->comment = '...';
			return $jsd->comments[$item];
		}else
			return false;
	}
	public static function kpIDtomyShowsId($kpID){
		$myShowsID = false;
		$jsd = Kinopoisk_Class::get_info ('getKPFilmDetailView', array ('filmID'=> $kpID));
		if ($jsd->data->type == 'KPSerial'){
			if (isset($jsd->data->nameEN))
				$myshows = VideoInfo::search_myshows_info($jsd->data->nameEN, $kpID);
			else
				$myshows = VideoInfo::search_myshows_info($jsd->data->nameRU, $kpID);
			if (isset($myshows->id))
				$myShowsID = $myshows->id;
			else
				return false;
		}else
			echo 'noSerial';
		return $myShowsID;
	}
	public function classAction ($defs, $user_input, $select_url = null){
		hd_restore_warnings();
		$post_action = null;
		$caption = 'Error!';
		$msg = 'classAction: action';
		$width = 1050;
		
		if ($user_input->action == 'reviews'){
			if (isset($user_input->user_login)){
				$mUrl = SmartVodRectangleListScreen::get_media_url_str('myShows_Class' ,array('categoryId'=> 'mm', 'favMyShows' => $user_input->favMyShows, 'mShowsA' => $user_input->mShowsA, 'argument' =>$user_input->user_login));
				return ActionFactory::open_folder($mUrl,'Задать бекграунд');
			}
			static $commentСounter = null;
			$add_params['control_id']= $user_input->control_id;
			$add_params['action'] = $user_input->action;
			$add_params['indiClass'] = self::$className;
			if (isset($user_input->myShowsID))
				$add_params['myShowsID'] = $user_input->myShowsID;
			else
				return null;
			if (isset($user_input->myShowsShowID))
				$add_params['myShowsShowID'] = $user_input->myShowsShowID;
			else
				return null;
			if (isset($user_input->mShowsA))
				$add_params['mShowsA'] = $user_input->mShowsA;
			else
				return null;
			if (isset($user_input->series_name))
				$add_params['series_name'] = $user_input->series_name;
			
			if (isset($user_input->nextPageToken))
				$commentСounter[$user_input->myShowsShowID] = $nextPageToken = $user_input->nextPageToken;
			else{
				if (isset($commentСounter[$user_input->myShowsShowID])){
					$add_params ['nextPageToken'] = $commentСounter[$user_input->myShowsShowID];
					ControlFactory::add_button_close(&$defs, $this, $add_params, $user_input->control_id, '', 'Да', 350);
					$add_params ['nextPageToken'] = 0;
					ControlFactory::add_button_close(&$defs, $this, $add_params, $user_input->control_id, '', 'Нет', 350);
					$commentСounter = null;
					return  ActionFactory::show_dialog('Продолжить просмотр?' ,$defs, true);
				}else{
					$commentСounter = null;
					$nextPageToken = 0;
				}
			}
			if (isset($user_input->myShowsShowID)){
				$jsd = self::parse_comments_myShows($user_input->myShowsShowID, $nextPageToken, $user_input->mShowsA);
				if (($jsd == true)&&($jsd->count > 0)){
					ControlFactory::add_smart_label($defs, "", '<text color="23" size="tiny">Внимание Возможны спойлеры!</text>');
					ControlFactory::add_vgap($defs, -20);
					$caption = $user_input->series_name;
					$coment = HD::str_remove_tag($jsd->comment);
					$w = 1500;
					if ($jsd->isBad==true)
						$reviewType = '<text color="4" dy="-80" size="small">' . $jsd->rating. ' </text><icon width="35" height="35" dy="-80">'.DuneSystem::$properties['install_dir_path'].'/icons/kp_review_negative.png</icon>';
					else
						$reviewType = '<text color="18" dy="-80" size="small">+' . $jsd->rating . ' </text><icon width="35" height="35" dy="-80">'.DuneSystem::$properties['install_dir_path'].'/icons/kp_review_positive.png</icon>';
						
					$smartLabel0 = '<icon width="160" height="160">'.self::http_get_img($jsd->user->avatar).'</icon>';
					$smartLabel1 = '<gap width="175"/><text color="23" dy="-80">Автор: </text><text color="15" dy="-80">'.$jsd->user->login.'</text>';
					$smartLabel2 = '<gap width="175"/>'.$reviewType.'<text dy="-80" color="23" size="small">  Дата: </text><text color="15" dy="-80" size="small">'.$jsd->createdAt.' </text>';
					$smartLabel3 = '<gap width="175"/><text dy="-80" color="18" size="small">Отзыв </text><text dy="-80" color="10" size="small">'. ($nextPageToken+1) .'</text><text dy="-80" color="18" size="small"> из </text><text dy="-80" color="10" size="small">' .  $jsd->count . '</text>';
					$reviewAllCount = $jsd->count;					
				}else
					return ActionFactory::show_title_dialog("Отзывов к этому эпизоду нет.");
			}
			ControlFactory::add_smart_label($defs,"", $smartLabel0);
			ControlFactory::add_smart_label($defs,"", $smartLabel1);
			ControlFactory::add_vgap($defs, -20);
			ControlFactory::add_smart_label($defs,"", $smartLabel2);
			ControlFactory::add_vgap($defs, -20);
			ControlFactory::add_smart_label($defs,"", $smartLabel3);
			ControlFactory::add_vgap($defs, -60);
			ControlFactory::add_multiline_label($defs, '', $coment, 12);
			ControlFactory::add_button_close(&$defs, $this, array('control_id'=> $user_input->control_id,
			'action' => $user_input->action, 'indiClass' => self::$className, 'user_login' => $jsd->user->login
			), $user_input->control_id, '', 'Открыть '. $jsd->user->login, 0);
			$arrowLeft = $arrowRight = '';
			if ($nextPageToken != 0){
				$add_params['nextPageToken']= $nextPageToken - 1;
				$action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $add_params);
				$attrs['actions'][GUI_EVENT_KEY_PREV]	= ActionFactory::close_dialog_and_run($action);
				$attrs['actions'][GUI_EVENT_KEY_REW]	= ActionFactory::close_dialog_and_run($action);
				$attrs['actions'][GUI_EVENT_KEY_LEFT]	= ActionFactory::close_dialog_and_run($action);
				$arrowLeft = '<icon width="24" height="35" >/firmware/skin/special_icons/pane_pointer_left.aai</icon>';
			}
			if ($nextPageToken < ($reviewAllCount - 1)){
				$add_params['nextPageToken']= $nextPageToken + 1;
				$action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $add_params);
				$attrs['actions'][GUI_EVENT_KEY_NEXT]	= ActionFactory::close_dialog_and_run($action);
				$attrs['actions'][GUI_EVENT_KEY_FWD]	= ActionFactory::close_dialog_and_run($action);
				$attrs['actions'][GUI_EVENT_KEY_RIGHT]	= ActionFactory::close_dialog_and_run($action);
				$arrowRight = '<icon width="24" height="35" >/firmware/skin/special_icons/pane_pointer_right.aai</icon>';
			}
			$attrs['actions'][GUI_EVENT_KEY_STOP]	= ActionFactory::close_dialog();
			ControlFactory::add_smart_label($defs, "", $arrowLeft . '<text color="23" size="tiny"> навигация стрелками вправо и влево </text>' . $arrowRight);
			return  ActionFactory::show_dialog($caption, $defs, true, $w, $attrs);
		}
		if (isset($user_input->selected_media_url))
			$selected_media_url = MediaURL::decode($user_input->selected_media_url);
		else{
			$msg = 'classAction: selected_media_url';
			return ActionFactory::show_title_dialog($caption, $post_action, $msg, 0);
		}
		$class_name = $selected_media_url->class_name;
		$parent_media_url = MediaURL::decode($user_input->parent_media_url);
		if ($user_input->action == 'watchMyShows'){
			if (isset($select_url[$selected_media_url->movie_id])){
				$watchedMyShows = myShows_Class::getWatchedMyShows($user_input->myShowsID, $user_input->accessToken);
				foreach ($select_url[$selected_media_url->movie_id] as $v){
					$media_url = MediaURL::decode($v);
					if (isset($watchedMyShows[$media_url->file_info->myShowsShowID]))
						VideoInfo::manageUnCheckEpisode_myshows ($media_url->file_info->myShowsShowID, $user_input->accessToken);
					else
						VideoInfo::manageCheckEpisode_myshows($media_url->file_info->myShowsShowID, $user_input->accessToken);
				}
				$action = UserInputHandlerRegistry::create_action($this, 'clearSelectUrls');
			}else{
				if ($user_input->arg == 'add')
					VideoInfo::manageCheckEpisode_myshows($selected_media_url->file_info->myShowsShowID, $user_input->accessToken);
				if ($user_input->arg == 'del')
					VideoInfo::manageUnCheckEpisode_myshows ($selected_media_url->file_info->myShowsShowID, $user_input->accessToken);
				$action = ActionFactory::invalidate_folders(array($user_input->parent_media_url));
			}
			self::getWatchedMyShows('clear');
			return $action;
		}
		if ($user_input->action == 'addToFavFromNotifi'){
			$jsd = json_decode ($user_input->info);
			if ($jsd->show->title != ''){
				$caption = $caption_original = $jsd->show->title;
				if ($jsd->show->titleOriginal != '')
					$caption_original = $jsd->show->titleOriginal;
			}else if ($jsd->show->titleOriginal != '')
				$caption = $caption_original = $jsd->show->titleOriginal;
			$mArr["caption"] = $caption;
			$jsds = VideoInfo::get_info_by_myshows_id ($jsd->show->id);
			if ($jsds->kinopoiskId != '')
				$mArr["poster_url"] = Kinopoisk_Class::http_get_img("http://st.kp.yandex.net/images/film_iphone/iphone360_".$jsds->kinopoiskId.".jpg");
			else
				$mArr["poster_url"] = self::http_get_img($v->show->image);
			$mArr["movie_id"] = $jsd->show->id;
			$mUrl = VodMovieScreen::get_media_url_str(self::$className, $mArr);
			$favorites = HD::getItemsArr($parent_media_url->class_name);
			if (isset($favorites[$mUrl]))
				$captionFav = 'Уже в Избранном';
			else{
				$flipFavorites = array_flip ($favorites);
				array_unshift ($flipFavorites, $mUrl);
				$favorites = array_flip ($flipFavorites);
				$captionFav = 'Добавленно в Избранное';
				if (HD::saveItemsArr($parent_media_url->class_name, $favorites) == false)
					$captionFav = "Добавление в не удалось";
			}
			$post_action = ActionFactory::invalidate_folders(array($user_input->parent_media_url));
			return ActionFactory::show_title_dialog($captionFav, $post_action, $caption, 800);
		}
		if ($user_input->action == 'shwntf'){
			$add_params['action'] = $user_input->action;
			$add_params['indiClass'] = self::$className;
			$add_params['control_id']= $user_input->control_id;
			if ((isset($user_input->selected_control_id))&&(isset($user_input->action_type))){
				if (isset($user_input->notifications)){
					if (HD::saveItemStr('notifications', $user_input->notifications) == false)
						return ActionFactory::show_title_dialog("Сохранение не удалось");
				}
				$action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $add_params);
				return ActionFactory::close_dialog_and_run($action);
			}
			
			$notifications = (HD::getItemStr('notifications') !='') ? HD::getItemStr('notifications') : 1;
			$show_ops[0] = 'Нет';
			$show_ops[1] = 'Да';
			$show_ops[2] = 'Только новые сезоны';
			ControlFactory::add_multiline_label($defs, '', 'Показывать уведомления*:', 8);
			ControlFactory::add_combobox($defs, $this, $add_params,
				'notifications', '',
				$notifications, $show_ops, 750, true, false
			);
			ControlFactory::add_smart_label($defs, "", '<text color="23" size="small">*Отображаются уведомления о завтрашнем выходе</text>');
			ControlFactory::add_vgap($defs, -35);
			ControlFactory::add_smart_label($defs, "", '<text color="23" size="small">серии или первой серии нового сезона.</text>');
			ControlFactory::add_vgap($defs, -35);
			ControlFactory::add_smart_label($defs, "", '<text color="23" size="small">Отображение раз в сутки при входе в избранное,</text>');
			ControlFactory::add_vgap($defs, -35);
			ControlFactory::add_smart_label($defs, "", '<text color="23" size="small">или по кнопке INFO.</text>');
			return  ActionFactory::show_dialog("Уведомления о выходе новой серии", $defs, true, 850);
		}
		if ($user_input->action == 'sort'){
			$sorting = (HD::getItemsArr(self::$className . '_sorting') != array()) ? HD::getItemsArr(self::$className . '_sorting') : array('favMyShows' => 0, 'other' => '', 'ended' => 0);
			$add_params['control_id']= $user_input->control_id;
			$add_params['action'] = $user_input->action;
			$add_params['indiClass'] = self::$className;
			if ((isset($user_input->selected_control_id))&&(isset($user_input->action_type))){
				if (isset($user_input->initial_sel_ndx))
					$add_params['initial_sel_ndx'] = $user_input->initial_sel_ndx;
				if (isset($parent_media_url->favMyShows))
					$sorting['favMyShows'] = $user_input->sorting;
				else
					$sorting['other'] = $user_input->sorting;
				if (isset($user_input->ended))
					$sorting['ended'] = $user_input->ended;
				if (HD::saveItemsArr(self::$className . '_sorting', $sorting) == false)
					return ActionFactory::show_title_dialog("Сохранение не удалось");
				
				$action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $add_params);
				$action = ActionFactory::close_dialog_and_run($action);
				return ActionFactory::invalidate_folders(array($user_input->parent_media_url), $action);
			}
			$add_params['initial_sel_ndx'] = 0;
			if (isset($parent_media_url->favMyShows)){
				$sorting_ops = array(
					0 => 'По умолчанию',
					1 => 'По алфавиту'
				);
				$srt = $sorting['favMyShows'];
				if (!preg_match('/myShowsUnwatched/', $parent_media_url->categoryId)){
					ControlFactory::add_combobox($defs, $this, $add_params,
						'ended', '',
						$sorting['ended'], array('Не показывать завершенные', 'Показывать завершенные'), 800, true, false
					);
					
					$add_params['initial_sel_ndx'] = 1;
				}
			}else{
				$sorting_ops = array(
					'sort=1a' => 'Название +',
					'sort=1d' => 'Название -',
					'sort=2a' => 'Рейтинг +',
					'sort=2d' => 'Рейтинг -',
					'sort=3d' => 'Смотрящих +',
					'sort=3a' => 'Смотрящих -',
					'sort=4d' => 'Аудитория +',
					'sort=4a' => 'Аудитория -',
					'sort=5d' => 'Сезонов +',
					'sort=5a' => 'Сезонов -',
					'sort=6d' => 'Год +',
					'sort=6a' => 'Год -'
				);
				$srt = $sorting['other'];
			}
			ControlFactory::add_combobox($defs, $this, $add_params,
				'sorting', '',
				$srt, $sorting_ops, 800, true, false
			);
			$attrs['initial_sel_ndx'] = isset($user_input->initial_sel_ndx) ? $user_input->initial_sel_ndx : -1;
			return ActionFactory::show_dialog("Cортировка:", $defs, true, 0, $attrs);
		}
		return ActionFactory::show_title_dialog($caption, $post_action, $msg, 0);
	}
	public static function getSearchShortMovieRange ($keyword, &$m_feed){
		if (is_object($keyword))
			$keyword = $keyword->searchStr;
		$items = array();
		if ($m_feed === 'end')
			return $items;
		$jsd = VideoInfo::search_myshows_by_name ($keyword);
		foreach ($jsd as $v){
			if ($v->title != ''){
				$caption = $caption_original = $v->title;
				if ($v->titleOriginal != '')
					$caption_original = $v->titleOriginal;
			}else if ($v->titleOriginal != '')
				$caption = $caption_original = $v->titleOriginal;
			if ($v->titleOriginal != '')
				$caption_original = $v->titleOriginal;
			$short_movie = new ShortMovie(
				strval($v->id),
				strval($caption),
				strval(self::http_get_img($v->image))
			);
			$info = '||' . $caption;
			$info .= '|' . $caption_original;
			if ($v->status != ''){
				if ($v->status == 'TBD/On The Bubble')
					$st = 'Пауза!';
				else if ($v->status == 'TBD')
					$st = 'Пауза!';
				else if ($v->status == 'Returning Series')
					$st = 'Продолжается!';
				else if ($v->status == 'Canceled/Ended')
					$st = 'Завершен!';
				else if ($v->status == 'New Series')
					$st = 'Новый!';
				else
					$st = $v->status;
				$info .= '|Статус: ' . $st;
			}
			if ($v->year != ''){
				$info .= '|Год: ' . $v->year;
				$short_movie->year = $v->year;
			}
			if ($v->totalSeasons != '')
				$info .= '|Сезонов: ' . $v->totalSeasons;
			if ($v->watching != '')
				$info .= '|Смотрящих: ' . $v->watching;
			if ($v->rating != '')
				$info .= '|MyShows: ' . round ($v->rating, 2);
			if (isset($v->unwatched))
				$info .= '||Непросмотренно:|' . $v->unwatched;
			$short_movie->info = $info;
			$short_movie->shape = 'rectangle';
			$short_movie->caption_original = $caption_original;
			array_push ($items, $short_movie);
		}
		$m_feed = 'end';
		return $items;
	}
	public static function getShortMovieRange ($media_url, &$m_feed){
		$items = array();
		if ($m_feed === 'end')
			return $items;
		if (isset($media_url->setMyShowId)){
			if (isset($media_url->setMyShowId->searchStr))
				$keyword = $media_url->setMyShowId->searchStr;
			else
				$keyword = $media_url->setMyShowId->caption;
			$jsd = VideoInfo::search_myshows_by_name ($keyword);
			foreach ($jsd as $v){
				if ($v->title != ''){
					$caption = $caption_original = $v->title;
					if ($v->titleOriginal != '')
						$caption_original = $v->titleOriginal;
				}else if ($v->titleOriginal != '')
					$caption = $caption_original = $v->titleOriginal;
				if ($v->titleOriginal != '')
					$caption_original = $v->titleOriginal;
				$short_movie = new ShortMovie(
					strval($v->id),
					strval($caption),
					strval(self::http_get_img($v->image))
				);
				$info = '||' . $caption;
				$info .= '|' . $caption_original;
				if ($v->status != ''){
					if ($v->status == 'TBD/On The Bubble')
						$st = 'Пауза!';
					else if ($v->status == 'TBD')
						$st = 'Пауза!';
					else if ($v->status == 'Returning Series')
						$st = 'Продолжается!';
					else if ($v->status == 'Canceled/Ended')
						$st = 'Завершен!';
					else if ($v->status == 'New Series')
						$st = 'Новый!';
					else
						$st = $v->status;
					$info .= '|Статус: ' . $st;
				}
				if ($v->year != ''){
					$info .= '|Год: ' . $v->year;
					$short_movie->year = $v->year;
				}
				if ($v->totalSeasons != '')
					$info .= '|Сезонов: ' . $v->totalSeasons;
				if ($v->watching != '')
					$info .= '|Смотрящих: ' . $v->watching;
				if ($v->rating != '')
					$info .= '|MyShows: ' . round ($v->rating, 2);
				if (isset($v->unwatched))
					$info .= '||Непросмотренно:|' . $v->unwatched;
				$short_movie->info = $info;
				$short_movie->shape = 'rectangle';
				$short_movie->caption_original = $caption_original;
				array_push ($items, $short_movie);
			}
			$m_feed = 'end';
		}
		if ($media_url->categoryId == 'myShowsFollowers'){
			if (isset($media_url->argument))
				$jsd = VideoInfo::get_profileFollowers_myshows ($media_url->mShowsA, $media_url->argument);
			else
				$jsd = VideoInfo::get_profileFollowers_myshows ($media_url->mShowsA);
			foreach ($jsd as $v){
				$short_movie = new ShortMovie(
					strval('mm'),
					strval($v->login),
					strval(self::http_get_img($v->avatar))
				);
				$short_movie->info = '||'.$v->login.'|' . str_replace(array ("m", 'f'), array ("male", 'female'), $v->gender);
				$short_movie->goToScreen = 'SmartVodRectangleListScreen';
				$short_movie->shape = 'tetragon';
				$short_movie->mShowsA = $media_url->mShowsA;
				$short_movie->favMyShows = $media_url->favMyShows;
				$short_movie->argument = $v->login;
				array_push ($items, $short_movie);
			}
			$m_feed = 'end';
			return $items;
		}else if ($media_url->categoryId == 'myShowsFriends'){
			if (isset($media_url->argument))
				$jsd = VideoInfo::get_profileFriends_myshows ($media_url->mShowsA, $media_url->argument);
			else
				$jsd = VideoInfo::get_profileFriends_myshows ($media_url->mShowsA);
			foreach ($jsd as $v){
				$short_movie = new ShortMovie(
					strval('mm'),
					strval($v->login),
					strval(self::http_get_img($v->avatar))
				);
				$short_movie->info = '||'.$v->login.'|' . str_replace(array ("m", 'f'), array ("male", 'female'), $v->gender);
				$short_movie->goToScreen = 'SmartVodRectangleListScreen';
				$short_movie->shape = 'tetragon';
				$short_movie->mShowsA = $media_url->mShowsA;
				$short_movie->favMyShows = $media_url->favMyShows;
				$short_movie->argument = $v->login;
				array_push ($items, $short_movie);
			}
			$m_feed = 'end';
			return $items;
		}else if ($media_url->categoryId == 'myShowsUnwatched'){
			$jsd  = VideoInfo::get_listsEpisodes_myshows ('unwatched', $media_url->mShowsA);
			foreach ($jsd as $k => $v){
				unset ($jsd[$k]);
				if ($v->show->title != '')
					$c = $v->show->title;
				else
					$c = $v->show->titleOriginal;
				if (isset($jsd[$c]->unwatched)){
					$jsd[$c]->unwatched = $v->episode->shortName . '; ' . $jsd[$c]->unwatched;
				}else{
					$jsd[$c] = $v->show;
					$jsd[$c]->unwatched = $v->episode->shortName . '; ';
				}
			}
			$sorting = (HD::getItemsArr(self::$className . '_sorting') != array()) ? HD::getItemsArr(self::$className . '_sorting') : array('favMyShows' => 0, 'ended' => 0);
			if ($sorting['favMyShows'] == 1)
				ksort($jsd);
			foreach ($jsd as $v){
				if ($v->title != ''){
					$caption = $caption_original = $v->title;
					if ($v->titleOriginal != '')
						$caption_original = $v->titleOriginal;
				}else if ($v->titleOriginal != '')
					$caption = $caption_original = $v->titleOriginal;
				if ($v->titleOriginal != '')
					$caption_original = $v->titleOriginal;
				$short_movie = new ShortMovie(
					strval($v->id),
					strval($caption),
					strval(self::http_get_img($v->image))
				);
				$info = '||' . $caption;
				$info .= '|' . $caption_original;
				if ($v->status != ''){
					if ($v->status == 'TBD/On The Bubble')
						$st = 'Пауза!';
					else if ($v->status == 'TBD')
						$st = 'Пауза!';
					else if ($v->status == 'Returning Series')
						$st = 'Продолжается!';
					else if ($v->status == 'Canceled/Ended')
						$st = 'Завершен!';
					else if ($v->status == 'New Series')
						$st = 'Новый!';
					else
						$st = $v->status;
					$info .= '|Статус: ' . $st;
				}
				if ($v->year != ''){
					$info .= '|Год: ' . $v->year;
					$short_movie->year = $v->year;
				}
				if ($v->totalSeasons != '')
					$info .= '|Сезонов: ' . $v->totalSeasons;
				if ($v->watching != '')
					$info .= '|Смотрящих: ' . $v->watching;
				if ($v->rating != '')
					$info .= '|MyShows: ' . round ($v->rating, 2);
				if (isset($v->unwatched))
					$info .= '||Непросмотренно:|' . $v->unwatched;
				$short_movie->info = $info;
				$short_movie->shape = 'rectangle';
				$short_movie->caption_original = $caption_original;
				array_push ($items, $short_movie);
			}
		}else if ($media_url->categoryId == 'myShowsNext'){
			$jsd  = VideoInfo::get_listsEpisodes_myshows ('next', $media_url->mShowsA);
			foreach ($jsd as $v){
				if ($v->show->title != ''){
					$caption = $caption_original = $v->show->title;
					if ($v->show->titleOriginal != '')
						$caption_original = $v->show->titleOriginal;
				}else if ($v->show->titleOriginal != '')
					$caption = $caption_original = $v->show->titleOriginal;
				if ($v->show->titleOriginal != '')
					$caption_original = $v->show->titleOriginal;
				if ($v->episode->image != '')
					$img = $v->episode->image;
				else
					$img =  $v->show->image;
				$short_movie = new ShortMovie(
					strval($v->show->id),
					strval($caption),
					strval(self::http_get_img($img))
				);
				$info = '||' . $caption;
				$info .= '|' . $caption_original;
				$date = new DateTime($v->episode->airDate);
				$info .= '||' . $date->format('d.m.Y');
				if ($v->show->status != ''){
					if ($v->show->status == 'TBD/On The Bubble')
						$st = 'Пауза!';
					else if ($v->show->status == 'Returning Series')
						$st = 'Продолжается!';
					else if ($v->show->status == 'Canceled/Ended')
						$st = 'Завершен!';
					else if ($v->show->status == 'New Series')
						$st = 'Новый!';
					else
						$st = $v->show->status;
					$info .= '|Статус: ' . $st;
				}
				if ($v->show->year != ''){
					$info .= '||Год: ' . $v->show->year;
					$short_movie->year = $v->show->year;
				}
				if ($v->show->totalSeasons != '')
					$info .= '||Сезонов: ' . $v->show->totalSeasons;
				if ($v->show->watching != '')
					$info .= '||Смотрящих: ' . $v->show->watching;
				if ($v->show->rating != '')
					$info .= '||MyShows: ' . round ($v->show->rating, 2);
				if ($v->episode->title != '')
					$info .= '||'.$v->episode->title.'|';
				if ($v->episode->shortName != '')
					$info .= $v->episode->shortName;
				$short_movie->info = $info;
				$short_movie->shape = 'rectangle';
				$short_movie->icon_path = SmartConfig::getPluginIco('next');
				$short_movie->extra_item = $date->format('d.m.Y');
				$short_movie->caption_original = $caption_original;
				array_push ($items, $short_movie);
			}
			$m_feed = 'end';
		}else if ($media_url->categoryId == 'myShowsFavorites'){
			$sorting = (HD::getItemsArr(self::$className . '_sorting') != array()) ? HD::getItemsArr(self::$className . '_sorting') : array('favMyShows' => 0, 'ended' => 0);
			$jsd  = VideoInfo::get_listsShows_myshows ('favorites', $media_url->mShowsA);
			if ($sorting['favMyShows'] == 1){
				foreach ($jsd as $k => $v){
					unset ($jsd[$k]);
					if ($v->title != '')
						$c = $v->title;
					else
						$c = $v->titleOriginal;
					$jsd[$c] = $v;
				}
				ksort($jsd);
			}
			foreach ($jsd as $v){
				if ($v->title != ''){
					$caption = $caption_original = $v->title;
					if ($v->titleOriginal != '')
						$caption_original = $v->titleOriginal;
				}else if ($v->titleOriginal != '')
					$caption = $caption_original = $v->titleOriginal;	
				if ($v->titleOriginal != '')
					$caption_original = $v->titleOriginal;	
				$short_movie = new ShortMovie(
					strval($v->id),
					strval($caption),
					strval(self::http_get_img($v->image))
				);
				$info = '||' . $caption;
				$info .= '|' . $caption_original;
				if ($v->status != ''){
					if ($v->status == 'TBD/On The Bubble')
						$st = 'Пауза!';
					else if ($v->status == 'Returning Series')
						$st = 'Продолжается!';
					else if ($v->status == 'Canceled/Ended')
						$st = 'Завершен!';
					else if ($v->status == 'New Series')
						$st = 'Новый!';
					else
						$st = $v->status;
					$info .= '||Статус: ' . $st;
				}
				if ($v->year != ''){
					$info .= '|Год: ' . $v->year;
					$short_movie->year = $v->year;
				}
				if ($v->totalSeasons != '')
					$info .= '||Сезонов: ' . $v->totalSeasons;
				if ($v->watching != '')
					$info .= '||Смотрящих: ' . $v->watching;
				if ($v->rating != '')
					$info .= '||MyShows рейтинг: ' . round ($v->rating, 2);
				$short_movie->info = $info;
				$short_movie->shape = 'rectangle';
				$short_movie->caption_original = $caption_original;
				array_push ($items, $short_movie);
			}
			$m_feed = 'end';
		}else if ($media_url->categoryId == 'mm'){
			$sorting = (HD::getItemsArr(self::$className . '_sorting') != array()) ? HD::getItemsArr(self::$className . '_sorting') : array('favMyShows' => 0, 'ended' => 0);
			if (!isset($media_url->argument)){
				$mySowsArr['myShowsFavorites']['caption'] = 'myShows Избранное';
				$mySowsArr['myShowsFavorites']['info'] = '||myShows Избранное|Избранное myShows';
				$mySowsArr['myShowsFavorites']['goToScreen'] =  'SmartVodRectangleListScreen';
				
				$mySowsArr['myShowsNext']['caption'] = 'myShows Календарь';
				$mySowsArr['myShowsNext']['info'] = '||myShows Next|Календарь myShows';
				$mySowsArr['myShowsNext']['goToScreen'] =  'SmartVodSimpleListScreen';
				
				$mySowsArr['myShowsUnwatched']['caption'] = 'myShows Новые серии';
				$mySowsArr['myShowsUnwatched']['info'] = '||myShows Новые серии|Новые не просмотренные серии';
				$mySowsArr['myShowsUnwatched']['goToScreen'] =  'SmartVodRectangleListScreen';
				
				$jsd  = VideoInfo::get_profile_shows_myshows ($media_url->mShowsA);
			}else
				$jsd  = VideoInfo::get_profile_shows_myshows ($media_url->mShowsA, $media_url->argument);
			
			$mySowsArr['myShowsFriends']['caption'] = 'myShows Друзья';
			$mySowsArr['myShowsFriends']['info'] =  '||myShows Друзья|myShows';
			$mySowsArr['myShowsFriends']['goToScreen'] =  'SmartVodSimpleListScreen';
			
			$mySowsArr['myShowsFollowers']['caption'] = 'myShows Фолловеры';
			$mySowsArr['myShowsFollowers']['info'] =  '||myShows Фолловеры|myShows';
			$mySowsArr['myShowsFollowers']['goToScreen'] =  'SmartVodSimpleListScreen';
			foreach ($mySowsArr as $k => $v){
				$short_movie = new ShortMovie(
					strval($k),
					strval($v['caption']),
					strval(SmartConfig::getPluginIco($k))
				);
				$short_movie->info = $v['info'];
				$short_movie->shape = 'rectangle';
				$short_movie->goToScreen = $v['goToScreen'];
				$short_movie->mShowsA = $media_url->mShowsA;
				$short_movie->favMyShows = $media_url->favMyShows;
				if (isset($media_url->argument))
					$short_movie->argument = $media_url->argument;
				array_push ($items, $short_movie);
			}
						
			if ($sorting['favMyShows'] == 1){
				foreach ($jsd as $k => $v){
					unset ($jsd[$k]);
					if ($v->show->title != '')
						$c = $v->show->title;
					else
						$c = $v->show->titleOriginal;
					$jsd[$c] = $v;
				}
				ksort($jsd);
			}
			foreach ($jsd as $v){
				if (($sorting['ended'] == 0)&&($v->watchStatus != 'watching'))
					continue;
				if ($v->show->title != ''){
					$caption = $caption_original = $v->show->title;
					if ($v->show->titleOriginal != '')
						$caption_original = $v->show->titleOriginal;
				}else if ($v->show->titleOriginal != '')
					$caption = $caption_original = $v->show->titleOriginal;	
				if ($v->show->titleOriginal != '')
					$caption_original = $v->show->titleOriginal;
				$short_movie = new ShortMovie(
					strval($v->show->id),
					strval($caption),
					strval(self::http_get_img($v->show->image))
				);
				$info = '||' . $caption;
				$info .= '|' . $caption_original;
				if (isset($v->watchStatus))
					$info .= '||Статус просмотра:|' . $v->watchStatus;
				if (isset($v->totalEpisodes))
					$info .= '||Всего эпизодов:|' . $v->totalEpisodes;
				if (isset($v->watchedEpisodes))
					$info .= '||Просмотренно эпизодов:|' . $v->watchedEpisodes;
				if ($v->show->status != ''){
					if ($v->show->status == 'TBD/On The Bubble')
						$st = 'Пауза!';
					else if ($v->show->status == 'Returning Series')
						$st = 'Продолжается!';
					else if ($v->show->status == 'Canceled/Ended')
						$st = 'Завершен!';
					else if ($v->show->status == 'New Series')
						$st = 'Новый!';
					else
						$st = $v->show->status;
					$info .= '||Статус: ' . $st;
				}
				if ($v->show->year != ''){
					$info .= '|Год: ' . $v->show->year;
					$short_movie->year = $v->show->year;
				}
				if ($v->show->totalSeasons != '')
					$info .= '||Сезонов: ' . $v->show->totalSeasons;
				if ($v->show->watching != '')
					$info .= '||Смотрящих: ' . $v->show->watching;
				if ($v->show->rating != '')
					$info .= '||MyShows рейтинг: ' . round ($v->show->rating, 2);
				$short_movie->info = $info;
				$short_movie->shape = 'rectangle';
				$short_movie->caption_original = $caption_original;
				array_push ($items, $short_movie);
			}
			$m_feed = 'end';
		} else	if (!preg_match('|search|', $media_url->categoryId)){
			if (($media_url->categoryId == 'f')||($media_url->categoryId == 'm')||($media_url->categoryId == 'all')){
				$jsd = VideoInfo::get_shows_top_by_myshows($media_url->categoryId);
				foreach ($jsd as $v){
					if ($v->show->title != ''){
						$caption = $caption_original = $v->show->title;
						if ($v->show->titleOriginal != '')
							$caption_original = $v->show->titleOriginal;
					}else if ($v->show->titleOriginal != '')
						$caption = $caption_original = $v->show->titleOriginal;
						
					$short_movie = new ShortMovie(
						strval($v->show->id),
						strval($caption),
						strval(self::http_get_img($v->show->image))
					);
					$info = '||' . $caption;
					$info .= '|' . $caption_original;
					
					if ($v->show->status != ''){
						if ($v->show->status == 'TBD/On The Bubble')
							$st = 'Пауза!';
						else if ($v->show->status == 'Returning Series')
							$st = 'Продолжается!';
						else if ($v->show->status == 'Canceled/Ended')
							$st = 'Завершен!';
						else if ($v->show->status == 'New Series')
							$st = 'Новый!';
						else
							$st = $v->show->status;
						$info .= '||Статус: ' . $st;
					}
					if ($v->show->year != ''){
						$info .= '|Год: ' . $v->show->year;
						$short_movie->year = $v->show->year;
					}
					if ($v->show->totalSeasons != '')
						$info .= '||Сезонов: ' . $v->show->totalSeasons;
					if ($v->show->watching != '')
						$info .= '||Смотрящих: ' . $v->show->watching;
					if ($v->show->rating != '')
						$info .= '||MyShows рейтинг: ' . round ($v->show->rating, 2);
					$short_movie->info = $info;
					$short_movie->shape = 'rectangle';
					array_push ($items, $short_movie);
				}
			}
			$m_feed = 'end';
		}else{
			$sorting = (HD::getItemsArr(self::$className . '_sorting') != array()) ? HD::getItemsArr(self::$className . '_sorting') : array('other' => 'sort=3d');
			$sorting = $sorting['other'];
			if (preg_match("|\?|",$media_url->categoryId))
				$sorting = '&' . $sorting;
			else
				$sorting = '?' . $sorting;
			$doc = HD::http_get_document($media_url->categoryId . $sorting . '&page=' . $m_feed);
			if (!preg_match('|<span class="arrowRight">|ms', $doc))
				$m_feed = 'end';
			else if (preg_match('|<li class="_next"><span>|ms', $doc))
				$m_feed = 'end';
			else
				++$m_feed;
			if (preg_match_all('|ShowCol-title">.*?href="/view/(\d+?)/">(.+?)</.*?StatusLabel _(.+?)".*?titleOriginal">(.+?)</.*?all".*?>(.+?)</.*?desktop".*?">(.+?)</div>.*?desktop".*?">(.+?)</div>|ms', $doc, $match)){
				foreach ($matches[1] as $k => $v){
					$caption = trim($matches[2][$k]);
					$short_movie = new ShortMovie(
						strval(trim($v)),
						strval($caption),
						strval(SmartConfig::getPluginIco(self::$className))
					);
					$info = '||' . $caption;
					if ($matches[4][$k] != '')
						$info .= '|' .  trim($matches[4][$k]);
					else
						$info .= '|' . $caption;
					
					$info .= '||Статус|' . str_replace("TBD", "Пауза", $matches[3][$k]);
					$info .= '||Год|' . trim($matches[7][$k]);
					$short_movie->year = trim($matches[7][$k]);
					$info .= '||Сезонов|'. trim($matches[6][$k]);
					$info .= '||Смотрят|'. HD::str_remove_tag($matches[5][$k]);
					$short_movie->info = $info;
					$short_movie->extra_item = str_replace("TBD", "Пауза", $matches[3][$k]);
					array_push ($items, $short_movie);
				}
			}
		}
		return $items;
	}
	public static function load_movie($movie_id, $mUrl, $getMovieInfo){
		$arr = array();
		if (isset($mUrl->caption))
			$arr['class_info']['catalog_info']['caption'] = $mUrl->caption;
		if (isset($mUrl->poster_url))
			$arr['class_info']['catalog_info']['poster_url'] = $mUrl->poster_url;
		if (isset($mUrl->caption_original))
			$arr['class_info']['catalog_info']['caption_original'] = $mUrl->caption_original;
		if (isset($mUrl->year))
			$arr['class_info']['catalog_info']['year'] = $mUrl->year;
		
		$jsd = VideoInfo::get_info_by_myshows_id ($movie_id);
		if ($jsd->title != ''){
				$arr['caption'] = $arr['caption_original'] = $jsd->title;
			if ($jsd->titleOriginal != '')
				$arr['caption_original'] = $jsd->titleOriginal;
		}else if ($jsd->titleOriginal != '')
			$arr['caption'] = $arr['caption_original'] = $jsd->titleOriginal;
		$arr['description'] = HD::str_remove_tag($jsd->description);
		$arr['country'] = $jsd->countryTitle;
		$arr['poster_url'] = self::http_get_img($jsd->image);
		if ($jsd->kinopoiskId != '')
			$arr['poster_url'] = Kinopoisk_Class::http_get_img("https://st.kp.yandex.net/images/film_iphone/iphone360_".$jsd->kinopoiskId.".jpg");
		$arr ['year'] = $jsd->year;
		$arr ['rate_kinopoisk'] = $jsd->kinopoiskRating;
		$arr ['rate_imdb'] = $jsd->imdbRating;
		if ($jsd->rating != '')
			$arr ['rate_details']['MyShows:']=  $jsd->rating;	
		$arr ['rate_details']['Сезонов:'] = $jsd->totalSeasons;
		if ( $jsd->status != ''){
			if ( $jsd->status == 'TBD/On The Bubble'){
				$arr ['rate_details']['Статус:']= ' ';
				$arr ['rate_details']['   '] = 'Пауза';
			}else if ($jsd->status == 'Returning Series'){
				$arr ['rate_details']['Статус:']= ' ';
				$arr ['rate_details']['   '] = 'Продолжается';
			}else if ($jsd->status == 'Canceled/Ended'){
				$arr ['rate_details']['Статус:'] = ' ';
				$arr ['rate_details']['   '] = 'Завершен';
			}else if ($jsd->status == 'New Series'){
				$arr ['rate_details']['Статус:']= ' ';
				$arr ['rate_details']['   '] = 'Новый!';
			}else{
				$arr ['rate_details']['Статус:']= ' ';
				$arr ['rate_details']['   ']=  $jsd->status;
			}
		}
		if ($jsd->totalSeasons != '')
			$arr ['rate_details']['Сезонов:']=  $jsd->totalSeasons;
		if ($jsd->started != ''){
			$arr ['rate_details']['Started:']=  ' ';
			$arr ['rate_details']['  ']=  $jsd->started;
		}
		if ($jsd->ended != ''){
			$arr ['rate_details']['Ended:']= ' ';
			$arr ['rate_details'][' ']=  $jsd->ended;
		}
		if ($jsd->kinopoiskId != '')
			$arr['class_info']['dbIDs']['kpID'] = $jsd->kinopoiskId;
		if ($jsd->imdbUrl != ''){
			if (preg_match('|tt(\d+)\/|', $jsd->imdbUrl, $m))
				$arr['class_info']['dbIDs']['imdbID'] = 'tt' . $m[1];
		}else if ($jsd->imdbId != '')
			$arr['class_info']['dbIDs']['imdbID'] = 'tt' . $jsd->imdbId;
		if ($jsd->tvrageId != '')
			$arr['class_info']['dbIDs']['tvrageID'] = $jsd->tvrageId;
		$arr['class_info']['dbIDs']['myShowsID'] = $movie_id;
		if ($getMovieInfo != 'min')
			$arr = SmartConfig::getMovieInfoArr($getMovieInfo, $movie_id, $mUrl, $arr);
		
		return $arr;
	}
	public static function getVodSourceInfo($v){
		return false;
	}
	public static function getNewES($access_token, $notifications, $class_name){
		static $newES = null;
		$day = strtotime(date('d.m.Y'));
		if ((is_null($newES))||(!isset($newES[$access_token][$day]))){
			$newES[$day] = false;
			
			$jsd = VideoInfo::get_listsEpisodes_myshows ('next', $access_token);
			foreach ($jsd as $v){
				$date = new DateTime($v->episode->airDate);
				if ((strtotime($date->format('d.m.Y')) -86400) == $day){
					if (($notifications == 2)&&($v->episode->episodeNumber != 1))
						continue;
					$newES[$access_token][$day][] = $v;
				}
			}
		}
		if (isset($newES[$access_token][$day]))
			return $newES[$access_token][$day];
		else
			return false;
	}
	public static function http_get_img ($url){
		if (!preg_match("|^http|",$url))
			$url = self::getDomainName() . $url;
		// return $url;
		return DuneSystem::$properties['plugin_cgi_url'] . "do?img=" . $url;
	}
	public static function getSearchMyShowsEpisodes($myShowsID){
		static $myShowsEpisodes = null;
		if ((is_null($myShowsEpisodes))||(!isset($myShowsEpisodes[$myShowsID]))){
			if (count($myShowsEpisodes)> 20)
				$myShowsEpisodes = null;
			$jsd = VideoInfo::get_episodes_by_myshows_id ($myShowsID);
			$myShowsEpisodes[$myShowsID] = $jsd;
		}else
			$jsd =  $myShowsEpisodes[$myShowsID];
		return ($jsd);
	}
	public static function getWatchedMyShows($myShowsID, $accessToken=null){
		static $watchedInfo = array();
		if ($myShowsID == 'clear'){
			$watchedInfo = null;
			return false;
		}
		if (!isset($watchedInfo[$myShowsID][$accessToken])){
			if (count($watchedInfo) > 20)
				$watchedInfo = array();
			$watched = array ();
			$jsd = VideoInfo::profileEpisodes_myshows ($myShowsID, $accessToken);
			foreach ($jsd as $v)
				$watched[$v->id] = $v->watchDate;
			$watchedInfo[$myShowsID][$accessToken] = $watched;
		}
		return $watchedInfo[$myShowsID][$accessToken];
	}
	public function login($user_input){
		hd_restore_warnings();
		$selected_media_url = MediaURL::decode($user_input->selected_media_url);
		$class_name = $selected_media_url->class_name;
		$userFavList = HD::getItemsArr('userFavList');
		$caption = 'Избранное';
		if (isset($userFavList[$class_name]))
			$caption = $userFavList[$class_name];
		$width = 1050;
		$ul = base64_decode('0JLQstC10LTQuNGC0LUg0LvQvtCz0LjQvQ');
		$up = base64_decode('0JLQstC10LTQuNGC0LUg0L/QsNGA0L7Qu9GM');
		$eney = HD::getItemsArr('eney');
		if (isset($user_input->eney)){
			if ($user_input->ul == ''){
				if (isset($eney[$class_name])){
					$mShowsA = HD::getItemsArr('mShowsA');
					unset($mShowsA[$class_name]);
					HD::saveItemsArr('mShowsA', $mShowsA);
					unset($eney[$class_name]);
					HD::saveItemsArr('eney', $eney);
					$caption = base64_decode('0JvQvtCz0LjQvSDQuCDQv9Cw0YDQvtC70Ywg0YPQtNCw0LvQtdC90LXQvdGLIQ');
					$post_action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $add_params);
					return ActionFactory::show_title_dialog($caption, $post_action, '', 0);
				}
			}
			if (($user_input->ul == '')||($user_input->up == '')||($ul == $user_input->ul)||($up == $user_input->up)){
				$caption = base64_decode('0KHQvtGF0YDQsNC90LXQvdC40LUg0L3QtSDRg9C00LDQu9C+0YHRjCE');
				$msg = base64_decode('0KPQutCw0LbQuNGC0LUg0L/RgNCw0LLQuNC70YzQvdC+INC70L7Qs9C40L0g0Lgg0L/QsNGA0L7Qu9GMLg');
				$post_action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $add_params);
				return ActionFactory::show_title_dialog($caption, $post_action, $msg, 0);
			}else if (self::testEneyIn ($user_input->ul, $user_input->up, $class_name) == true){
				$eney[$class_name][0] = HD::eney($user_input->ul);
				$eney[$class_name][1] = HD::eney($user_input->up);
				HD::saveItemsArr('eney', $eney);
				$caption = base64_decode('0JvQvtCz0LjQvSDQuCDQv9Cw0YDQvtC70Ywg0YHQvtGF0YDQsNC90LXQvdGLIQ');
				return ActionFactory::show_title_dialog($caption, null, '', 0);
			}else{
				$caption = base64_decode('0KHQvtGF0YDQsNC90LXQvdC40LUg0L3QtSDRg9C00LDQu9C+0YHRjCE');
				$msg = base64_decode('0J/RgNC+0LLQtdGA0YzRgtC1INC/0YDQsNCy0LjQu9GM0L3QvtGB0YLRjCDQstCy0L7QtNCwINC70L7Qs9C40L3QsCDQuCDQv9Cw0YDQvtC70Y8uINCf0YDQuCDQstGL0LrQu9Cw0LTRi9Cy0LDQvdC40LggbG9nINGE0LDQudC70LAg0L/RgNC+0LLQtdGA0YzRgtC1INC90LXRgiDQu9C4INGC0LDQvCDQstCw0YjQuNGFINC70LjRh9C90YvRhSDQtNCw0L3QvdGL0YUh');
				$add_params['ul'] = $user_input->ul;
				$add_params['up'] = $user_input->up;
				$post_action = UserInputHandlerRegistry::create_action($this, $user_input->control_id, $add_params);
				return ActionFactory::show_title_dialog($caption, $post_action, $msg, $width);
			}
		}
			
		$ps = 0;
		if (isset($eney[$class_name])){
			$ul = HD::eney('l', $eney[$class_name][0]);
			$up = HD::eney('p', $eney[$class_name][1]);
			$ps = 1;
		}else if (isset($user_input->ul)) {
			$ul = $user_input->ul;
			$up = $user_input->up;
		}
		ControlFactory::add_text_field($defs, $this, null,
			'ul',
			'',
			$ul, 0, 0, 0, 1, 950, 0, false
        );
		ControlFactory::add_text_field($defs, $this, null,
			'up',
			'',
			$up, 0, $ps, 0, 1, 950, 0, false
        );
		$add_params['eney']= 'eney';
		ControlFactory::add_close_dialog_and_apply_button($defs, $this, $add_params, $user_input->control_id, 'Применить', 450);
		return ActionFactory::show_dialog(base64_decode("0JvQvtCz0LjQvSDQvdCwIG15U2hvd3MubWUg0LjQt9Cx0YDQsNC90L3QvtCz0L4g") . $caption, $defs, true, $width);
	}

	public static function mShowsAccRefresh($refresh_token, $class_name){
		$opts [CURLOPT_POST] = true;
		$opts [CURLOPT_POSTFIELDS] = "grant_type=refresh_token&client_id=" . base64_decode('bXlzaG93c196aXZpbw') . "&client_secret=cUvxSKgAkxMceEd5Dq5Vt2f6&refresh_token=". $refresh_token;
		$jsd = json_decode(HD::http_get_document('https://myshows.me/oauth/token',$opts));
		if (isset($jsd->access_token)){
			$mShowsA = HD::getItemsArr('mShowsA');
			$mShowsA[$class_name] = $jsd;
			HD::saveItemsArr('mShowsA', $mShowsA);
		}
		return $jsd;
	}
	public static function testEneyIn($ul = null, $up = null, $class_name){
		if ($ul == false){
			$eney = HD::getItemsArr('eney');
			if (isset($eney[self::$cName])){
				$ul = HD::eney('l', $eney[self::$cName][0]);
				$up = HD::eney('p', $eney[self::$cName][1]);
			}else
				return false;
		}
		$opts [CURLOPT_POST] = true;
		$opts [CURLOPT_POSTFIELDS] = "grant_type=password&client_id=" . base64_decode('bXlzaG93c196aXZpbw') . "&client_secret=cUvxSKgAkxMceEd5Dq5Vt2f6&username=$ul&password=$up";
		$jsd = json_decode(HD::http_get_document('https://myshows.me/oauth/token',$opts));
		if (isset($jsd->access_token)){
			$mShowsA = HD::getItemsArr('mShowsA');
			$mShowsA[$class_name] = $jsd;
			HD::saveItemsArr('mShowsA', $mShowsA);
			return true;
		}else{
			echo 'myShows logIn err!';
			return false;
		}
	}
	public static function addToFavAndMyShows($favorites, $selected_media_url, $user_input){
		$mShowsA = HD::getItemsArr('mShowsA');
		if (isset($mShowsA[$favorites])){
			$mShowsA = $mShowsA[$favorites]->access_token;
			if (($selected_media_url->class_name == 'myShows_Class')&&(isset($selected_media_url->movie_id)))
				$myShowsID = $selected_media_url->movie_id;
			else if (isset($user_input->myShowsID))
				$myShowsID = $user_input->myShowsID;
			else if (isset($selected_media_url->myShowsID))
				$myShowsID = $selected_media_url->myShowsID;
			else if ((($selected_media_url->class_name == 'Kinopoisk_Class')&&(isset($selected_media_url->movie_id)))||
			(isset($user_input->kpID))||
			(isset($selected_media_url->kpID))){
				if ($selected_media_url->class_name == 'Kinopoisk_Class')
					$kpID = $selected_media_url->movie_id;
				else if (isset($selected_media_url->kpID))
					$kpID = $selected_media_url->kpID;
				else if (isset($user_input->kpID))
					$kpID = $user_input->kpID;
				else{
					echo 'err $kpID';
				}
				$myShowsID = self::kpIDtomyShowsId($kpID);
			}else{
				$kpIDs = HD::getItemsArr('kpIDs');
				if (isset($kpIDs[$selected_media_url->movie_id]))
					$kpID = $kpIDs[$selected_media_url->movie_id];
				else{
					$caption_original = '';
					if (isset($selected_media_url->caption_original))
						$caption_original = $selected_media_url->caption_original;
					$kpID = Kinopoisk_Class::searchKpId ($selected_media_url->caption, $caption_original, '');
					echo '==>' . $kpID;
				}
				if ($kpID != true)
					return null;
				$jsd = Kinopoisk_Class::get_id_info($kpID);
				if ((isset($jsd->type))&&($jsd->type == 'KPSerial')){
					$myShowsID = self::kpIDtomyShowsId($kpID);
				}else
					return null;
			}
			if ((isset($myShowsID))&&($myShowsID != false)){
				$jsd = VideoInfo::manageSetShowStatus_myshows ($myShowsID, 'watching', $mShowsA);
				if ($jsd == 1)
					echo $myShowsID. ' Статус "watching" задан!';
				else
					echo 'Ошибка myShows';
			}else
				echo 'myShowsID false[2]';
		}else
			echo 'mShowsA err!';
	}
	public static function getMyShowsNamedArr($cfg = null){
		$named['watching']	= 'Смотрю';
        $named['later']		= 'Буду смотреть';
        $named['cancelled']	= 'Перестал';
        $named['remove']	= 'Удалить из myShows';
		if ($cfg === true)
			$named['finished']	= 'Полностью посмотрел';
        return $named;
	}
}
?>